      SUBROUTINE ABSPIN
C          TO READ IN ABSORPTION CORRECTION INPUT DATA
      COMMON/FNAME/NFILE,NAMLEN
      CHARACTER*6 ANS
      CHARACTER*3 IN,out,list
      CHARACTER*4 WORD,METHOD
      character*7 notheta
      CHARACTER*80 CARD
      CHARACTER*16 NFILE
      INTEGER*2 D,P,ID(10),M
      DIMENSION PSI(72)
      logical symm
10    FORMAT(I5)
11    FORMAT(A)
12    FORMAT(F12.0)
31    FORMAT(1X,A)
35    FORMAT('ABSORPTION CORRECTION ',10I2)
      II=NAMLEN+1
      NFILE(II:II+3)='.INF'
      IOP15=0
c      OPEN(NAME=NFILE,UNIT=15,TYPE='OLD',FORM='FORMATTED',ERR=300)
C   FIND WILL OPEN AND CLOSE INF FILE AND SEE IF IT EXISTS AND IS
C             AVAILABLE.. NOT IN USE BY ANOTHER PROGRAM   BJW FEB93
C       iop15=1       ! now means inf file exists
300   TYPE*,' Enter version numbers of MAG files to be used separated',
     1' by commas.  Return for DEFAULT of HIGHEST version only.'
      READ(5,301,ERR=278)ID
301   FORMAT(10I4)
      DO I=1,10
        IF(ID(I).EQ.0)GOTO 302
      ENDDO
302   N=I-1
      N4=22+N*2
      ENCODE(80,35,CARD,ERR=278)(ID(I),I=1,N)
      TYPE 31,CARD(1:N4)
      WRITE(4,11)CARD(1:N4)
      P=0
C
C     ADDED 10/91 KAF, PSI CORRECTION HAS BEEN ADDED TO ABSORPTION
C                      THIS IS TO LET INPUT GIVE THE OPTIONS THAT
C                      ARE AVAILABLE
C
101   TYPE 310
310   FORMAT(' Do you want to calculate absorption correction by:',/,
     1'     1   Conventional gaussian quadrature',/,
     2'    [2]  Semi-empirical psi scan method')
      READ(5,10)K
      METHOD='CON '
      IF(K.ne.1) METHOD='PSI '

      IF (METHOD.EQ.'PSI ') THEN
        TYPE*,'Enter the number of interpolation intervals (Max=72).',
     1'  [36]'
        READ(5,10)NNNN
        IF(NNNN.EQ.0)NNNN=36
        symm=.false.
        if (mod(nnnn,2).eq.0) then
         TYPE*,'Are 0-180 values equal to 180-360 values? [Y]/N'
         accept 11,ans
         if (ans.ne.'N') symm=.true.
        endif
        phioff=0.0
        type*,'Enter phi offset. [0.0]'
        read (5,12) phioff
        notheta='NOTHETA'
        type*,'Use theta dependence? [Y]/N'
        accept 11,ans
        if (ans.ne.'N') notheta='       '
      ELSE
41      TYPE*,'Type in the number of observed ',
     1'crystal faces.'
        READ(5,10)NNNN
C   !Read Linear absorption coefficient from .INF file
C42    IF(IOP15.EQ.1)THEN
42       WORD='U = '
        CALL FIND(CARD,WORD,I,15)
        IF(I.EQ.1)THEN
          DECODE(80,105,CARD,ERR=901)CC
105       FORMAT(4X,F9.0,67X)
          TYPE 106, CC
106       FORMAT(' Linear Absorption Coefficient taken from .INF file: ',
     1F10.6)
          IOP15=1     ! OLD SIGNAL THAT INF EXISTS   BJW FEB93
        ELSE
          TYPE*,'Enter the Linear Absorption Coefficient in cm**-1'
          READ(5,12)CC
        ENDIF
C  input and output identifier must be the same.
      ENDIF
100   TYPE*,'Enter input identifier - [MAG]:  .MAG file,',
     1' HKL:  .HKL file, CRD:  .CRD file or short format',
     2' data cards.'
      ACCEPT 11,IN
      IF(IN.NE.'HKL'.AND.IN.NE.'CRD')IN='MAG'
110   TYPE*,' Enter output identifier - [MAG] HKL, CRD or N ',
     1'(for NONE) -- as above.'
      ACCEPT 11,OUT
      IF(OUT.EQ.'N')THEN
        OUT='   '
        GOTO 250
      ENDIF
      IF(OUT.NE.'HKL'.AND.OUT.NE.'CRD')OUT='MAG'
      IF(IN.EQ.'CRD'.AND.OUT.NE.'CRD')GOTO 240
      IF(IN.EQ.'MAG'.AND.OUT.EQ.'HKL')GOTO 245
      IF(IN.EQ.'HKL'.AND.OUT.EQ.'MAG')GOTO 245
      GOTO 250
240   TYPE*,' Input-Output incompatability.  .CRD input must have',
     +' .CRD output.  Try again.'
      GOTO 100
245   TYPE*,' Input-Output incompatability.  .MAG and .HKL files not',
     +' compatable.  Try again.'
      GOTO 100
250   IFIL=1
      TYPE*,' Do you want to list updated reflections? Y/[N]'
      ACCEPT 11,ANS
      list='   '
      IF(ANS(1:1).EQ.'Y')list='LIS'
c      IF(ANS(1:1).EQ.'Y')N4=30
      if(method.eq.'CON ') then
       n4=30
       ENCODE(N4,303,CARD,ERR=277)METHOD,NNNN,CC,IN,OUT,list
      else
       n4=49
       ENCODE(N4,303,CARD,ERR=277)METHOD,NNNN,CC,IN,OUT,list
     1        ,phioff,notheta
      endif
 303  FORMAT(a4,I4,F10.6,A3,A3,3X,A3,f10.2,2x,a7)
c303   FORMAT(A4,I4,F10.6,A3,A3,2X)
c      READ(1,1001) method,N,VMU,IN,OUT,LIST,phioff,notheta
30    FORMAT(A4,I4,f10.6,A3,A3,I2)
      TYPE 31,CARD(1:N4)
      WRITE(4,11)CARD(1:N4)
      IBEG=1
      IF(METHOD.EQ.'PSI ')GOTO 210
c     this change made effective 6/94-kaf
200   TYPE 5
5     FORMAT(' NOTE CHANGE:  DISTANCE is now to be entered in',
     + ' MM. (Old INPUT files using cm','will still work.)',/,
     + '   Enter your face information now. For each face',/,
     + '   enter CHI,PHI,DISTANCE  (2F8.3,F8.5)',/,
     + '   CHI and PHI in degrees when face is in reflecting position',/,
     + '   DISTANCE, in mm, from center of rotation to crystal face,',/,
     + ' Enter 3 numbers separated by commas followed by [RET].')
      DISCM=0.0
      DO I=IBEG,NNNN
1301    read(5,13,err=21)chi,phi,dismm
        IF(ABS(CHI).GT.360.0.OR.ABS(PHI).GT.360.0)THEN
          TYPE*,'CHI or PHI is greater than 360 degrees. Is this right?'
          ACCEPT 11,ANS
          IF(ANS(1:1).EQ.'N')THEN
            TYPE*,'Reenter CHI, PHI and DISTANCE.'
            GOTO 1301
          ENDIF
        ENDIF
13      FORMAT(3F12.0)
        ENCODE(80,34,CARd)CHI,PHI,discm,dismm
        N4=37
34      FORMAT('FACE',2X,2F8.3,2F8.5)
        TYPE 31,CARD(1:N4)
        WRITE(4,11)CARD(1:N4)
        IF(I.LT.NNNN)TYPE*,'Enter another CHI,PHI,DISTANCE'
      ENDDO
      TYPE*,' Do you want to add to the number of faces? Y/[N]'
      ACCEPT 11,ANS(1:1)
      IF(ANS(1:1).NE.'Y')GOTO 270
      TYPE *,' How many additional face cards do you want?'
      ACCEPT*,M
      IBEG=NNNN+1
      NNNN=NNNN+M
      TYPE 36
36    FORMAT(' Remember to use the editor to change the number',
     +/,' of faces on the CON card. The number on the CON card must',/,
     +' match the number of records beginning with FACE.')
      GO TO 200
210   N=(NNNN+5)/6
      intv=360/nnnn
      if (symm) then
       n=(n+1)/2
       nnnn=nnnn/2
      endif
      is=1
      ie=6
211   TYPE 212,nnnn,intv
212   FORMAT(/' Enter'i3' values of the absorption coefficient ',/,
     +' at intervals of'i3' degrees in PSI, starting at Psi=0.')
      DO I=1,N
213   type 214
214   format(' Enter values (6F6.3), separated by commas, '
     + 'followed by a [RET].') 
37        READ(5,38,ERR=22)(PSI(ii),ii=is,ie)
38      FORMAT(6F6.3)
        is=is+6
        ie=ie+6
        ENDDO
        DO L=1,nnnn
          IF(PSI(L).EQ.0.0) THEN
            TYPE*,'You did not include enough values of Psi.'
            goto 210
          endif
        enddo
        if (ie.lt.nnnn) then
         do l=ie+1,nnnn
          IF(PSI(L).ne.0.0) THEN
            TYPE*,'You included too many values of Psi.'
            goto 210
          endif
         enddo
        endif
        if (symm) then
         do i=nnnn+1,2*nnnn
          psi(i)=psi(i-nnnn)
         enddo
         nnnn=2*nnnn
        endif
        N4=39
        is=1
        ie=6
215     if (ie.gt.nnnn) ie=nnnn
        ENCODE(n4,39,CARD)(PSI(J),J=is,ie)
39      FORMAT(3X,6(F6.3))
        TYPE 31,CARD(1:N4)
        WRITE(4,11)CARD(1:N4)
        is=is+6
        ie=ie+6
        if(is.gt.nnnn)goto 270
        GOTO 215
270   IF(IN.NE.'CRD')THEN
c        inf file is opened and closed in find  bjw feb93
        RETURN
      ENDIF
      TYPE*,' Are you entering SHORT FORMAT data cards? [N]-If input',
     1' is a CRD file)'
      ACCEPT 11,ANS
      IF(ANS(1:1).NE.'Y')THEN
        TYPE*,' Remember to copy CRD file after last FACE card in this',
     1' file.  Blank card must follow last reflection to indicate',
     2' end of card input.'
c        IF(IOP15.EQ.1)CLOSE(UNIT=15,DISP='SAVE')!CLOSE .INF FILE, IF OPEN
        RETURN
      ENDIF
271   TYPE*,' Enter H, K, L, F(OBS), WEIGHT, 2-THETA, PHI, CHI and',
     1' OMEGA separated by commas.  Proper answers are obtained when',
     2' OMEGA is 0.  Return if done.'
      READ(5,272,ERR=275)IH,K,L,F,W,T,PH,C,O
      IF(W.EQ.0.0.AND.F.EQ.0.0)GOTO 276
272   FORMAT(3I6,6F8.0)
      ENCODE(80,273,CARD,ERR=275)IH,K,L,F,W,T,PH,C,O
      N4=70
      TYPE 31,CARD(1:N4)
      WRITE(4,11)CARD(1:N4)
273   FORMAT(4X,3I6,6F8.2)
      GOTO 271
276   TYPE*,' End of card input indicator.'
      CARD(1:N4)='    '
      N4=4
      TYPE 31,CARD(1:N4)
      WRITE(4,11)CARD(1:N4)
c      IF(IOP15.EQ.1)CLOSE(UNIT=15,DISP='SAVE')!CLOSE .INF FILE, IF OPEN
      RETURN
20    TYPE *,' ERROR ON INPUT TRY AGAIN'
      GO TO 100
275   TYPE*,' ERROR ON INPUT.  TRY AGAIN.'
      GOTO 271
278   TYPE *,' ERROR IN VERSION NUMBER - TRY AGAIN.'
      GOTO 300
277   TYPE*,' ERROR ON CON CARD - TRY AGAIN.'
      GOTO 101
21    TYPE *,' ERROR IN FACE INPUT START OVER'
      GO TO 200
22    TYPE*,' ERROR IN PSI SCAN CORRECTION - TRY AGAIN.'
      GOTO 37
901   WRITE(3,902)WORD
902   FORMAT(' Error on ',A4,' card (1st 4 letters) in .INF file.')
      END
