      SUBROUTINE addin(CARD,IUNIT,IFLG)
C  THIS ROUTINE ADDS A CARD TO THE INF FILE. IF THE SAME CARD ALREADY
C  EXISTS, IT REPLACES THE OLD INFORMATION WITH THE NEW.  (I.E. IF
C  LEAST SQUARES IS RUN A SECOND TIME, THE NEW SUMS WILL REPLACE THE
C  OLD SUMS.)
C  CARD IS THE 80 CHARACTER CARD TO BE ADDED.
C  IUNIT IS THE UNIT NUMBER OF THE INF FILE.
c  In this version the inf file will be opened and closed here.
C     IFLG HAS BEEN ADDED TO CALL IFLG=1 IF OPEN SUCCEEDS    
      CHARACTER*80 CARD,JUNK
      CHARACTER*32 NAME
      CHARACTER*16 ANAM
      INCLUDE '($RMSDEF)'
      INTEGER*4 FILESTAT, STATUS
      COMMON/FNAME/ANAM,NAMLEN
      IFLG=0     ! INITIALIZE BEFORE EACH ATTEMPT
      I=NAMLEN+1
      ANAM(I:I+3)='.INF'
      NAME(1:16)=ANAM
      ET=0.0
      NN=O
      BT=SECNDS(0.0)
      OPEN(UNIT=26,TYPE='NEW',FORM='FORMATTED')  ! SCRATCH FILE
1     STATUS= FILESTAT(NAME)
      IF(STATUS.EQ.RMS$_NORMAL)THEN
C         TYPE *,'FILE EXISTS AND IS AVAILABLE'
         GO TO 4
       ELSE IF(STATUS.EQ.RMS$_FLK)THEN
C        IF(NN.EQ.0) TYPE *,' FILE EXISTS BUT IS OPENED BY ANOTHER USER'    
        et=secnds(bt)
        NN=NN+1
        if(et.Gt.7.0)go to 15    ! file has been left open
        GO TO 1
      ELSE IF (STATUS.EQ.RMS$_FNF)THEN
C          TYPE *,' INF FILE DOES NOT EXIST'
      ELSE
C          TYPE 40,STATUS
40        FORMAT(' UNKNOWN STATUS ',Z8.8,' FOR INF FILE')
      ENDIF
      RETURN
4     open(NAME=ANAM,unit=iunit,type='old')
      REWIND IUNIT
      IFLG=1      ! SUCCESSFUL OPEN OF INF FILE
5     READ(IUNIT,10,END=20)JUNK  ! LOOK FOR END
10    FORMAT(A80)
      IF(JUNK(2:5).EQ.CARD(2:5))GOTO 5  ! CARD ALREADY EXISTS - REPLACE
      WRITE(26,10)JUNK
      GOTO 5
15    type*,' inf file is being used by another program.'
      close(unit=26,disp='delete')
      return
20    REWIND 26
      IF(CARD(2:5).EQ.'a = ')THEN 
C       TYPE *,'   ADDIN THINKS THIS IS A CELL CARD'
C  FIRST OF 2 CELL DIMENSION CARDS.  DELETE FIRST TIME.  SAVE 2ND TIME.
        CLOSE(UNIT=IUNIT,DISP='DELETE')
      ELSE
        CLOSE(UNIT=IUNIT,DISP='SAVE')  ! REWRITING INF FILE
      ENDIF
C     WRITE UPDATED INF FILE
      OPEN(NAME=ANAM,UNIT=IUNIT,TYPE='NEW',FORM='FORMATTED')
25    READ(26,10,END=30)JUNK
      WRITE(IUNIT,10)JUNK
      GOTO 25
30    WRITE(IUNIT,10)CARD  ! ADD NEW CARD
      CLOSE(UNIT=26,DISP='DELETE')
      CLOSE(IUNIT,DISP='SAVE')            ! ADD A CLOSE TO LATEST INF FILE
      RETURN
      END
