      SUBROUTINE BEGIN(IFROM)
C  IFROM=0 MEANS FROM MAIN PROGRAM.  THEREFORE, ONLY CREATING AN INF
C  FILE AND MAY DELETE THE SPECIFIED INPUT FILE AT END OF PROGRAM.
C  ALSO SHOULD STOP RATHER THAN RETURN.
C  IFROM=1 MEANS COMING IN FROM TAPEREAD AND SHOULD NOT DO THE ABOVE.
C THIS PROGRAM CREATES A NAME.INF FILE OF DATA COLLECTION
C INFORMATION THAT IS CALLED BY AND ADDED TO BY SOME CRYM PROGRAMS.
C THE USER MAY MODIFY THE NAME.INF FILE AS NECESSARY.
C KMS 6-2-88
C   MODIFIED 2-24-93  TO OPEN AND CLOSE INF FILE IN addin 
      CHARACTER*50 TITLE
      character*80 card
      CHARACTER*4 ANS
      CHARACTER*4 WORD
      CHARACTER*16 ANAM
      CHARACTER*17 SCAN
      CHARACTER*3 FF(12)
c      INTEGER*2 IP,IQ,IS
      integer z
      CHARACTER*1 SGL
      DIMENSION AT(12)
      DIMENSION NA(12)
      COMMON/FNAME/ANAM,NAMLEN
      natom=0
1     FORMAT(A)
2     format(a80)
      TYPE*,'This program creates a NAME.inf file of data collection'
      TYPE*,'information that is added to and called by several CRYM'
      TYPE*,'programs.  You may modify any of the existing information'
      TYPE*,'as needed.'
      TYPE*,' '
      TYPE*,'If at any time, you do not know the needed information,'
      TYPE*,'Return and that card will be skipped.'
      TYPE*,' '
      I=NAMLEN+1
      ANAM(I:I+3)='.INF'
      word='OPEN'
C  CALL FIND TO OPEN INF EITHER OLD OR NEW,IFL=1 FOR NEW IFL=0 FOR OLD
C                                          IFL>1 FOR FAIL TO OPEN  
      call find(card,word,ifl,15)     ! get information and open?
C    IF INF FILE EXISTS DO OPEN AND CLOSE IN addin
CCCC OPEN(NAME=ANAM,UNIT=15,TYPE='old',FORM='FORMATTED',err=5)    
c5      OPEN(NAME=ANAM,UNIT=15,TYPE='new',FORM='FORMATTED')
      INEW=IFL   !  INEW=1 MEANS A NEW INF FILE
      IF(IFL.GT.1)THEN   ! EITHER IN USE OR UNKNOWN OPEN FAILURE
       TYPE*,' INF file cannot be opened.'
       stop
      endif
6     TYPE*,'Would you like to add all cards? [Y]/N '
      ACCEPT 1,ANS
      IFEW=1
      IF(ANS(1:1).NE.'N')THEN
       IFEW=0
      ENDIF
      IF(IFEW.EQ.1)GOTO 600
7     TYPE*,'ENTER A TITLE FOR THE STRUCTURE (UP T0 50 CHARACTERS).'
      TYPE*,'THE TITLE IS USED BY CLIST AND DLIST.'
      TYPE 500
      READ(5,10)TITLE
      IF(TITLE(1:2).NE.'  ')then
        IF(INEW.EQ.0)THEN  ! 15 is open if INEW=0
          WRITE(15,11)TITLE
        ELSE
          encode(80,11,card)title
          call addin(card,15,IFLG)  ! addin will open and close file
        ENDIF
      endif
10    FORMAT(A50)
11    FORMAT(' TITLE: ',A50)
      IF(IFEW.EQ.1)GOTO 600
C              MOLECULAR FORMULA RECORD ADDED 10-26-89 BJW
100   I=1
      TYPE*,'FOR MOLECULAR FORMULA, ENTER ONE FORM FACTOR (A3) FOLLOWED'
      TYPE*,'BY THE NUMBER OF THAT TYPE OF ATOM IN THE MOLECULE.'
      TYPE*,'  (I.E. "C  8")'
1150  IF(I.EQ.1)THEN
        TYPE 500
      ELSE
        TYPE*,'ENTER NEXT FORM FACTOR AND NUMBER. RETURN IF DONE.'
      ENDIF
      READ(5,111,ERR=9120)FF(I),NA(I)
      IF(FF(I).NE.'   '.AND.I.LT.10)THEN
c       if(na(i).eq.0) na(i)=1
       I=I+1
       GO TO 1150
      ENDIF
      IF(FF(1).NE.'   ')THEN
       natom=i-1
        IF(natom.Gt.1)THEN
          IF(INEW.EQ.0)THEN
            WRITE(15,1120,ERR=9120)(FF(J),NA(J),J=1,natom)
          ELSE
            encode(80,1120,card,err=9120)(FF(J),NA(J),J=1,natom)
            call addin(card,15,IFLG)
          ENDIF
1120      FORMAT(' MOLECULE: ',<natom-1>(A3,I3,' '),A3,I3)
C                 12345678901
        ELSE
          IF(INEW.EQ.0)THEN
            WRITE(15,1221,ERR=9120)FF(1),NA(1)
          ELSE
            encode(80,1221,card,err=9120)FF(1),NA(1)
            call addin(card,15,IFLG)
          ENDIF
1221      FORMAT(' MOLECULE: ',A3,I3)
        ENDIF
      ENDIF
      IF(IFEW.EQ.1)GOTO 600
25    TYPE*,'Z: (INTEGER)'
      TYPE 500
      READ(5,26,ERR=903)Z
26    FORMAT(I6)
      IF(z.NE.0)then
        IF(INEW.EQ.0)THEN
          WRITE(15,27,ERR=903)z
        ELSE
          encode(80,27,card,ERR=903)z
          call addin(card,15,IFLG)
        ENDIF
      endif
27    FORMAT(' Z =',I3)
      IF(IFEW.EQ.1)GOTO 600
110   if(ifew.ne.1 .and. natom.ne.0 .and. z.ne.0) then
       do j=1,natom
        na(j)=na(j)*z
       enddo
      else
       I=1
       TYPE*,'FOR CELL CONTENTS  FORMULA, ENTER ONE FORM FACTOR (A3) '
       TYPE*,'FOLLOWED BY THE NUMBER OF THAT TYPE OF ATOM IN THE CELL.'
       TYPE*,'  (I.E. "C  8")'
115    IF(I.EQ.1)THEN
        TYPE 500
       ELSE
        TYPE*,'ENTER NEXT FORM FACTOR AND NUMBER. RETURN IF DONE.'
       ENDIF
       READ(5,111,ERR=912)FF(I),NA(I)
111    FORMAT(A3,I5)
       IF(FF(I).NE.'   '.AND.I.LT.10)THEN
        I=I+1
        GO TO 115
       ENDIF
       natom=i-1
      endif
c
      IF(FF(1).NE.'   ')THEN
        IF(natom.Gt.1)THEN
          IF(INEW.EQ.0)THEN
            WRITE(15,112,ERR=912)(FF(J),NA(J),J=1,natom)
          ELSE
            encode(80,112,card,err=912)(FF(J),NA(J),J=1,natom)
            call addin(card,15,IFLG)
          ENDIF
112       FORMAT(' FORMULA: ',<natom-1>(A3,I3,' '),A3,I3)
        ELSE
          IF(INEW.EQ.0)THEN
            WRITE(15,1121,ERR=912)FF(1),NA(1)
          ELSE
            encode(80,1121,card,err=912)FF(1),NA(1)
            call addin(card,15,IFLG)
          ENDIF
1121      FORMAT(' FORMULA: ',A3,I3)
        ENDIF
      ENDIF
      IF(IFEW.EQ.1)GOTO 600
1122  TYPE*,'CRYSTAL COLOR:'
      TYPE 500
      READ(5,10)TITLE
      IF(TITLE(1:2).NE.'  ')then
        IF(INEW.EQ.0)THEN
          WRITE(15,12)TITLE
        ELSE
          encode(80,12,card)TITLE
          call addin(card,15,IFLG)
        ENDIF
      endif
12    FORMAT(' COLOR: ',A50)
      IF(IFEW.EQ.1)GOTO 600
120   TYPE*,'CRYSTAL HABIT:'
      TYPE 500
      READ(5,10)TITLE
      IF(TITLE(1:2).NE.'  ')then
        IF(INEW.EQ.0)THEN
          WRITE(15,13)TITLE
        ELSE
          encode(80,13,card)TITLE
          call addin(card,15,IFLG)
        ENDIF
      endif
13    FORMAT(' HABIT: ',A50)
      IF(IFEW.EQ.1)GOTO 600
C


21    TYPE*,'Enter cell dimensions a,b,c,alpha,beta and gamma separated'
      TYPE*,'by commas.  This information may be used in ABSORPTION,'
      TYPE*,'PREPARE and RE-PREPARE and CRYSTAL.'
      TYPE 500
      READ(5,14,ERR=901)A,B,C,AA,BB,CC
14    FORMAT(6F11.5)
C
      IF (A.NE.0.0) THEN
       TYPE *,
     1 'Enter sigmas for A,B,C,ALPHA,BETA,GAMMA separated by commas.'
       READ(5,14,ERR=901)SIGA,SIGB,SIGC,SIGAL,SIGBE,SIGGA
       NSA = SIGA * 1000. + 0.5
       NSB = SIGB * 1000. + 0.5
       NSC = SIGC * 1000. + 0.5
       NAL = SIGAL * 100. + 0.5
       NBE = SIGBE * 100. + 0.5
       NGA = SIGGA * 100. + 0.5
C
        IF(INEW.EQ.0)THEN
          WRITE(15,15)A,NSA,B,NSB,C,NSC,AA,NAL,BB,NBE,CC,NGA
        ELSE
          encode(80,15,card,ERR=901)
     1       A,NSA,B,NSB,C,NSC,AA,NAL,BB,NBE,CC,NGA
          call addin(card,15,IFLG)
        ENDIF
15      FORMAT(' CELL',3(F9.3,'(',I2,')'),3(F8.2,'(',I2,')'))
      ENDIF
C
C
C  CALCULATING VOLUME
      IF(A.NE.0.0)THEN
        COSA=COS(AA/57.2958)
        COSB=COS(BB/57.2958)
        COSC=COS(CC/57.2958)
        A=A*B*C*SQRT(1.-COSA**2-COSB**2-COSC**2+2.*COSA*COSB*COSC)
        IF(INEW.EQ.0)THEN
          WRITE(15,24)A
        ELSE
          encode(80,24,card)A
          call addin(card,15,IFLG)
        ENDIF
24      FORMAT(' V = ',F9.1,'(  ) A**3')
        WRITE(5,24)A
      ENDIF
      IF(IFEW.EQ.1)GOTO 600
28    TYPE*,'ENTER TYPE OF MONOCHROMATOR ("NO" FOR NONE).  ENTER "G"'
      TYPE*,'FOR DEFAULT OF GRAPHITE. (USED BY INITIA).'
      TYPE 500
      READ(5,10)TITLE
      IF(TITLE(1:2).NE.'  ')THEN
        IF(TITLE(1:1).EQ.'G')THEN
          TITLE(1:9)='GRAPHITE '
          I=9
        ELSE
          I=0
  32      I=I+1
          IF(TITLE(I:I).NE.' ')GOTO 32
        ENDIF
        IF(INEW.EQ.0)THEN
          WRITE(15,33)TITLE(1:I)
        ELSE
          encode(80,33,card)TITLE(1:I)
          call addin(card,15,IFLG)
        ENDIF
33      FORMAT(1X,A<I>,'MONOCHROMATOR')
      ENDIF
      IF(TITLE(1:2).EQ.'NO')GOTO 30
      TYPE*,'TYPE OF RADIATION: (I.E. "MO" OR "CU")'
      TYPE 500
      II=1
      READ(5,39)SCAN
      IF(SCAN(1:2).NE.'  ')then
        IF(INEW.EQ.0)THEN
          WRITE(15,281)SCAN
        ELSE
          encode(80,281,card)SCAN
          call addin(card,15,IFLG)
        ENDIF
281      FORMAT(' RADIATION: ',A17)
      endif
      IF(SCAN(1:2).EQ.'MO'.OR.SCAN(1:2).EQ.'Mo')THEN
        A=.7107
        B=6.08
        GOTO 29
      ENDIF
      IF(SCAN(1:2).EQ.'AG'.OR.SCAN(1:2).EQ.'Ag')THEN
        A=.5609
        B=4.8
        GOTO 29
      ENDIF
      IF(SCAN(1:2).EQ.'FE'.OR.SCAN(1:2).EQ.'Fe')THEN
        A=1.9373
        B=16.78
        GOTO 29
      ENDIF
      IF(SCAN(1:2).EQ.'CU'.OR.SCAN(1:2).EQ.'Cu')THEN
        A=1.5418
        B=13.28
        GOTO 29
      ENDIF
      IF(SCAN(1:2).EQ.'CO'.OR.SCAN(1:2).EQ.'Co')THEN
        A=1.7903
        B=15.48
        GOTO 29
      ENDIF
      IF(SCAN(1:2).EQ.'CR'.OR.SCAN(1:2).EQ.'Cr')THEN
        A=2.2909
        B=19.97
        GOTO 29
      ENDIF
      II=0
      GOTO 291  ! NOT ONE OF 6 DEFAULTS - MUST ENTER OWN PARAMS
29    TYPE 290,A
290   FORMAT(' LAMBDA SET TO ',F6.4,' A. DO YOU WANT TO CHANGE THIS?')
      ACCEPT 1,ANS
      IF(ANS(1:1).NE.'Y')GOTO 293  ! USE DEFAULT
291   TYPE*,'LAMBDA IN A:  (F7.4)'
      TYPE 500
      READ(5,292,ERR=904)A
292   FORMAT(F10.5)
293   IF(A.NE.0.0)then
        IF(INEW.EQ.0)THEN
          WRITE(15,294,ERR=291)A
        ELSE
          encode(80,294,card,ERR=291)A
          call addin(card,15,IFLG)
        ENDIF
      endif
294   FORMAT(' LAMBDA = ',F7.4,' A')
      IF(II.EQ.1.AND.TITLE(1:1).EQ.'G')THEN ! DEFAULTS FOR GRAPHITE MONO
        TYPE 295,B
295     FORMAT(' THETA FOR THE MONOCHROMATOR SET TO ',F5.2,' DEGREES.')
        TYPE*,'DO YOU WANT TO CHANGE THIS?'
        ACCEPT 1,ANS
        IF(ANS(1:1).NE.'Y')GOTO 297
      ENDIF
296   TYPE*,'THETA FOR MONOCHROMATOR: (F6.2)'
      TYPE 500
      READ(5,292,ERR=913)B
297   IF(B.NE.0.0)then
        IF(INEW.EQ.0)THEN
          WRITE(15,298)B
        ELSE
          encode(80,298,card)B
          call addin(card,15,IFLG)
        ENDIF
      endif
298   FORMAT(' THETA(M) = ',F6.2,' DEGREES.')
      IF(IFEW.EQ.1)GOTO 600
30    TYPE*,'TEMPERATURE OF DATA COLLECTION (DEGREES K) (INTEGER).'
      TYPE*,'(293 IS ROOM TEMP.)'
      TYPE 500
      READ(5,26,ERR=905)I
      IF(I.NE.0)then
        IF(INEW.EQ.0)THEN
          WRITE(15,31,ERR=905)I
        ELSE
          encode(80,31,card,ERR=905)I
          call addin(card,15,IFLG)
        ENDIF
      endif
31    FORMAT(' T =',I4,' DEGREES K')
      IF(IFEW.EQ.1)GOTO 600
34    TYPE*,'ENTER CRYSTAL SIZE BY ENTERING THE 3 DIAMETERS IN MM,'
      TYPE*,'SEPARATED BY COMMAS. (USED TO CALCULATE MU(RMAX)).'
      TYPE 500
      READ(5,35,ERR=906)A,B,C
35    FORMAT(3F9.4)
      IF(A.NE.0.0)then
        IF(INEW.EQ.0)THEN
          WRITE(15,36,ERR=906)A,B,C
        ELSE
          encode(80,36,card,ERR=906)A,B,C
          call addin(card,15,IFLG)
        ENDIF
      endif
36    FORMAT(' CRYSTAL SIZE: ',F6.3,' X ',F6.3,' X ',F6.3,' mm')
      IF(IFEW.EQ.1)GOTO 600
c
c
c   take this out - add plot.typ style to autoread
c
c
37    TYPE*,'TYPE OF DIFFRACTOMETER:'
      TYPE*,'1)CAD4'
      TYPE*,'2)P21'
      TYPE*,'3)P1BAR'
      TYPE*,'ENTER NUMBER (1-3)'
      TYPE 500
      READ(5,26,ERR=907)I
      IF(I.NE.0)THEN
        IF(I.NE.2.AND.I.NE.3)I=1
        TITLE(1:5)='CAD-4'
        J=5
        IF(I.EQ.2)THEN
          TITLE(1:3)='P21'
          J=3
        ENDIF
        IF(I.EQ.3)TITLE(1:5)='P1BAR'
        IF(INEW.EQ.0)THEN
          WRITE(15,38)TITLE(1:J)
        ELSE
          encode(80,38,card)TITLE(1:J)
          call addin(card,15,IFLG)
        ENDIF
38      FORMAT(1X,A<J>,' DIFFRACTOMETER')
41      TYPE*,'TYPE OF SCAN: (MAY BE USED IN TAPEREAD)'
        TYPE*,'1)OMEGA'
        TYPE*,'2)OMEGA-2THETA'
        TYPE*,'ENTER NUMBER (1 OR 2)'
        READ(5,26,ERR=908)I
        IF(I.NE.2)I=1
        SCAN(1:5)='OMEGA'
        J=5
        IF(I.EQ.2)THEN
          SCAN(6:12)='-2THETA'
          J=12
        ENDIF
        IF(INEW.EQ.0)THEN
          WRITE(15,42,ERR=908)SCAN(1:J)
        ELSE
          encode(80,42,card,ERR=908)SCAN(1:J)
          call addin(card,15,IFLG)
        ENDIF
42      FORMAT(1X,A<J>,' SCAN')
      ENDIF
      IF(IFEW.EQ.1)GOTO 600
43    TYPE*,'SCAN SPEED IN DEGREES PER MINUTE (INTEGER).'
      TYPE 500
      READ(5,26,ERR=909)I
      IF(I.NE.0)then
        IF(INEW.EQ.0)THEN
          WRITE(15,44)I
        ELSE
          encode(80,44,card)I
          call addin(card,15,IFLG)
        ENDIF
      endif
44    FORMAT(' SCAN SPEED: ',I3,' DEGREES PER MINUTE')
      IF(IFEW.EQ.1)GOTO 600
45    TYPE*,'ENTER MIN AND MAX 2THETA (FOR 2THETA RANGE) IN DEGREES'
      TYPE*,'SEPARATED BY A COMMA. (INTEGERS)'
      TYPE 500
      READ(5,46,ERR=910)I,J
46    FORMAT(2I5)
      IF(I.NE.0.AND.J.NE.0)then
        IF(INEW.EQ.0)THEN
          WRITE(15,47,ERR=910)I,J
        ELSE
          encode(80,47,card,ERR=910)I,J
          call addin(card,15,IFLG)
        ENDIF
      endif
47    FORMAT(' 2THETA RANGE:',I4,' -',I4,' DEGREES')
      IF(IFEW.EQ.1)GOTO 600
471   TYPE*,'OCTANTS COLLECTED (I.E. +-H,K,+-L)'
      TYPE 500
      READ(5,39)SCAN
39    FORMAT(A17)
      IF(SCAN(1:2).NE.'  ')then
        IF(INEW.EQ.0)THEN
          WRITE(15,48)SCAN
        ELSE
          encode(80,48,card)SCAN
          call addin(card,15,IFLG)
        ENDIF
      endif
48    FORMAT(' OCTANTS COLLECTED: ',A17)
      IF(IFEW.EQ.1)GOTO 600
c
c   bypass this for now 
c
49    continue
c49    TYPE*,'HOW MANY FILES OF REFLECTIONS DO YOU HAVE?'
c      TYPE 500
c      READ(5,26,ERR=911)I
c      IF(I.NE.0)THEN
c
c
c   possible error here, if few card option? i don't think so
c   remove from here altogether
c
  490    continue
  50     continue
c 50        TYPE 51
c51        FORMAT(' Enter ID # of last reflection: [CR=All]',$)
c          READ(5,26,ERR=914)NA(1)
c52      CONTINUE
c        IF(INEW.EQ.0)THEN
c          WRITE(15,53,ERR=915)(NA(J),J=1,I)
c        ELSE
c          encode(80,53,card,ERR=915)(NA(J),J=1,I)
c          call addin(card,15,IFLG)
c        ENDIF
c53      FORMAT(' REFLECTIONS MEASURED: ',<I>(I5,1X))
c      ENDIF
      IF(IFEW.EQ.1)GOTO 600
54    CLOSE(UNIT=15,DISP='SAVE')
      IF(IFROM.EQ.0)THEN
        type*,' '
        TYPE*,'IF YOU ARE ONLY CREATING AN INF FILE (I.E., NOT CREATING'
        TYPE*,'THE INPUT TO ANY OTHER PROGRAMS), YOU SHOULD DELETE THE'
        TYPE*,'INPUT FILE SPECIFIED AT THE BEGINNING AS IT WILL CONTAIN'
        TYPE*,'ONLY AN "END X-RAY" CARD.'
      ENDIF
      TYPE*,' '
      TYPE*,'YOUR NAME.INF FILE IS NOW COMPLETE.  NO CRYM PROGRAM NEED'
      TYPE*,'BE RUN.'
      TYPE*,' '
      RETURN
600   TYPE*,' 1)TITLE                       2)FORMULA'
      TYPE*,' 3)CRYSTAL COLOR               4)HABIT'
      TYPE*,' 5)CELL DIMENSIONS             6)Z'
      TYPE*,' 7)MONOCHROMATOR CARD          8)TEMPERATURE'
      TYPE*,' 9)CRYSTAL SIZE               10)DIFFRACTOMETER AND SCAN'
      TYPE*,'11)SCAN SPEED                 12)2THETA RANGE'
      TYPE*,'13)OCTANTS                    14)# OF REFLECTIONS'
      TYPE*,'15)MOLECULE                   16)NUMBER OF ATOMS'
      TYPE*,' '
      TYPE*,'ENTER NUMBER OF CARD WANTED.'
      TYPE*,'RETURN TO QUIT.'
      READ(5,26,ERR=916)I
      IF(I.LT.0.OR.I.GT.16)GOTO 916
      GOTO(54,7,110,1122,120,21,25,28,30,34,37,43,45,471,49,100,70),I+1
500   FORMAT(' RETURN TO SKIP.')
900   FORMAT(' ERROR ON LAST CARD ENTERED.  TRY AGAIN.')
901   TYPE 900
      GOTO 21
903   TYPE 900
      GOTO 25
904   TYPE 900
      GOTO 291
905   TYPE 900
      GOTO 30
906   TYPE 900
      GOTO 34
907   TYPE 900
      GOTO 37
908   TYPE 900
      GOTO 41
909   TYPE 900
      GOTO 43
910   TYPE 900
      GOTO 45
911   TYPE 900
      GOTO 49
912   TYPE 900
      GOTO 110
9120  TYPE 900
      GO TO 100         ! ADDED 10-27-89 BJW
913   TYPE 900
      GOTO 296
914   TYPE 900
      GOTO 50
915   TYPE 900
      GOTO 490
916   TYPE 900
      GOTO 600
917   TYPE 900
      GO TO 70
70    TYPE*,' FOR NUMBERS OF ATOMS CARD,'
      TYPE*,' ENTER SPACE GROUP NUMBER. NO LETTER YET'
      READ(5,2000,ERR=917)IR
      TYPE*,'ENTER SPACE GROUP LETTER OR RETURN IF BLANK.'
      ACCEPT 1,SGL
      TYPE*,'ENTER THE NUMBER OF EACH',
     1'TYPE OF ATOM IN THE UNIT CELL, UP TO 12, SEPARATED BY',
     2'COMMAS.  THE ORDER MUST BE THE SAME AS THE ORDER IN WHICH',
     3'THE ATOMIC SCATTERING FACTOR LABELS APPEAR ON THE KIND F CARD.'
      READ(5,887,ERR=917)(AT(I),I=1,12)
887   FORMAT(8F4.0,:,F4.0,:3F4.0)
      TYPE*,'ENTER THE CENTERING FACTOR:',
     1' =1 IF CELL IS PRIMITIVE ',
     2' =2 IF CELL IS A-,  C- OR I-CENTERED',
     3' =3 FOR TRIGONAL GROUPS WHICH ARE LISTED WITH BOTH',
     4' HEXAGONAL AND RHOMBOHEDRAL AXES',
     5' =4 IF CELL IS F-CENTERED.'
      TYPE*,'DEFAULT IS CHOSEN ACCORDING TO SPACE GROUP NUMBER.'
      READ(5,2000,ERR=917)IQ
2000  FORMAT(I10,:,I10)
      IF(IR.GT.142)THEN
        IS=0
        GOTO 8841
      ENDIF
      TYPE*,'DO YOU WANT TO ENTER YOUR OWN VALUES OF EPSILON AND',
     1' VARIANCE? Y/N'
	ACCEPT 1,ANS
      IF(ANS(1:1).EQ.'Y')THEN
	IS=1
      ELSE
        IS=0
      ENDIF
8841  ENCODE(80,885,CARD,ERR=917)IR,(AT(I),I=1,12),IP,IQ,IS
885   FORMAT('NUMBERS OF ATOMS',I4,12F4.0,2I2,I2)
      END
