      SUBROUTINE BGROUNDIN
C  INPUT TO BGROUND PROGRAM
      CHARACTER*80 CARD
      CHARACTER*6 ANS
      DIMENSION ID(10)
1     FORMAT(A)
2     FORMAT(1X,A)
20    FORMAT(F14.6,:,F14.6)
30    FORMAT(F6.0)
C  TITLE CARD - INCLUDES VERSION NUMBERS OF MAG FILES TO BE USED
100   TYPE*,' Enter version numbers of MAG files to be used,',
     1' earliest version first, separated by commas.  RETURN for',
     2' DEFAULT of HIGHEST version only.'
      READ(5,101,ERR=902)ID
101   FORMAT(10I4)
      DO 102 I=1,10
      IF(ID(I).EQ.0)GOTO 103
102   CONTINUE
103   N=I-1
      N4=11+2*N
      IF(N.NE.0)THEN
      ENCODE(80,104,CARD,ERR=902)(ID(I),I=1,N)
      ELSE
      ENCODE(80,104,CARD)
      N4=10
      ENDIF
104   FORMAT('BACKGROUND ',10I2)
      TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
      TYPE*,' Do you need a limit card? Y/[N]'
     1' "N" for DEFAULTS of:',
     2' AL(1)=8.0  (include data with INT<=8.0*SIGMA in 1ST dist.)',
     3' AL(2)=3.0  (include data with INT<=3.0*SIGMA in 2ND dist.)',
     4' 2-THETA interval width=1',
     5' No rejection on basis of CHI values'
     6' No rejection on basis of TWO THETA values'
      ACCEPT 1,ANS
      IF(ANS(1:1).NE.'Y')GOTO 108
C  LIMIT CARD (OPTIONAL)
105   TYPE*,' Enter AL(1) and AL(2) separated by a comma such that',
     1' the first distribution includes data with intensity<=AL(1)*',
     2' SIGMA and the second, those with intensity<=AL(1)*SIGMA.',
     3' AL(1) must be >= AL(2).  RETURN for DEFAULTS of AL(1)=8.0',
     4' and AL(2)=3.0. (2F6.2)'
      READ(5,20,ERR=903)A1,A2
      IF(A2.GT.A1)THEN
      TYPE*,' AL(1) must be greater than or equal to AL(2) - try',
     1' again.'
      GOTO 105
      ENDIF
      IF(A1.EQ.0.0)A1=8.0
C  DEFAULT FOR AL(1) IS 8.0 AND AL(2) 3.0
      IF(A2.EQ.0.0)A2=3.0
1050  TYPE*,' Enter the width of the 2THETA interval in degrees - ',
     1' RETURN for DEFAULT of 1 (I6) (negative is interval inverse)'
      READ(5,30,ERR=904)A3
      I3=A3
      IF(I3.EQ.0)I3=1
C DEFAULT FOR INTERVAL LENGTH IS 1
1051  TYPE*,' Enter CHImin and CHImax, the inclusive CHI limits for',
     1' reflections to be accepted, separated by a comma.  RETURN for',
     2' no rejection on the basis of CHI values.  (2F7.2)'
      READ(5,20,ERR=905)A4,A5
1052  TYPE*,' Enter TTHLOW and TTHHI, the exclusive 2theta limits for',
     1' reflections to be accepted, separated by a comma.  RETURN for',
     2' no rejection on the basis of 2THETA values.  (2F7.2)'
      READ(5,20,ERR=905)A6,a7
      ENCODE(80,107,CARD,ERR=903)A1,A2,I3,A4,A5,a6,a7
      N4=52
107   FORMAT('LIMIT ',2F6.2,I6,4F7.2)
      TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
108   TYPE*,' Do you have any reflections to be deleted by ID# ?'
     1' Y/[N]'
      ACCEPT 1,ANS
      KIND=1
      IF(ANS(1:1).EQ.'Y')CALL DELETE(KIND)
      CARD(1:3)='END'
      N4=3
      TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
      RETURN
C  ERROR MESSAGES
902   TYPE 999
      GOTO 100
903   TYPE 999
      GOTO 105
904   TYPE 999
      GOTO 1050
905   TYPE 999
      GOTO 1051
999   FORMAT(' ERROR ON LAST CARD ENTERED - TRY AGAIN.')
      END
