      SUBROUTINE CELLIN
C  INPUT FOR CELL (UNIT CELL LEAST SQUARES)
      CHARACTER*80 CARD
      CHARACTER*79 TITLE
      CHARACTER*6 ANS
1     FORMAT(A)
2     FORMAT(1X,A)
10    FORMAT(I10)
      CARD(1:4)='CELL'
      TYPE 2,CARD(1:4)
      WRITE(4,1)CARD(1:4)
      TYPE*,'Enter a TITLE'
      ACCEPT 1,TITLE
      CARD(1:1)=' '
      CARD(2:80)=TITLE
      TYPE 2,CARD
      WRITE(4,1)CARD
20    TYPE*,'[1]Triclinic               4)Tetragonal'
      TYPE*,' 2)Monoclinic              5)Hexagonal'
      TYPE*,' 3)Orthorhombic            6)Cubic'
      TYPE*,'Enter number'
      READ(5,10,ERR=901)I
      GOTO (21,22,23,24,25,26)I
21    CARD(1:9)='TRICLINIC'
      N4=9
      GOTO 27
22    CARD(1:10)='MONOCLINIC'
      N4=10
      GOTO 27
23    CARD(1:12)='ORTHORHOMBIC'
      N4=12
      GOTO 27
24    CARD(1:10)='TETRAGONAL'
      N4=10
      GOTO 27
25    CARD(1:9)='HEXAGONAL'
      N4=9
      GOTO 27
26    CARD(1:5)='CUBIC'
      N4=5
27    TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
28    TYPE*,'Do you want to add to or change the list of stored ',
     1'wavelengths? Y/[N]'
      ACCEPT 1,ANS
29    IF(ANS(1:1).EQ.'Y')THEN
        TYPE*,'Enter wavelength identifier (number by which you refer',
     1 'to the wavelength) and the corresponding wavelength separated',
     2 ' by commas.'
        READ(5,290,ERR=903)II,A
290     FORMAT(I4,F12.6) 
        ENCODE(23,291,CARD,ERR=903)II,A
291     FORMAT('WAVELENGTH',I3,F10.6)
        TYPE 2,CARD(1:23)
        WRITE(4,1)CARD(1:23)
        GOTO 28
      ENDIF
30    TYPE*,'[1]"2THETA" for diffractometer data with 2THETA values'
      TYPE*,' 2)"COMP LEFT" for comparator film with beam stop on left'
      TYPE*,' 3)"COMP RIGHT" for comparator film with beam ',
     1'stop on right'
      TYPE*,'Enter number'
      READ(5,10,ERR=902)I
      GOTO (310,32,33)I
310   CARD(1:6)='2THETA'
      N4=6
      GOTO 34
32    CARD(1:9)='COMP LEFT'
      N4=9
      GOTO 34
33    CARD(1:10)='COMP RIGHT'
      N4=10
34    TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
      IF(I.GT.1)GOTO 45
C  HERE FOR 2THETA
      TYPE*,'Enter H,K,L,2THETA, wavelength identifier and ',
     1'weight separated by commas. (Wavelength I.D. and weight may be ',
     2'blank for defaults of CuKA wavelength and 1.0 weight.)  RETURN ',
     3'when done.'
38      TYPE*,'H,K,L,2THETA,ID,WEIGHT    (RETURN TO QUIT)'
      READ(5,39,ERR=904)IH,IK,IL,A,I,B
39    FORMAT(3I6,F9.3,I4,F11.5)
      IF(IH.EQ.0.AND.IK.EQ.0.AND.IL.EQ.0.AND.A.EQ.0)GOTO 55 ! QUIT
      N4=60
      IF(B.EQ.0.0)N4=50
      IF(I.EQ.0.AND.B.EQ.0.0)N4=30
      ENCODE(80,40,CARD,ERR=904)IH,IK,IL,A,I,B
40    FORMAT(4X,3I6,F8.3,16X,I4,F10.5)
      TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
      GOTO 38
C HERE FOR COMP LEFT OR COMP RIGHT
45    TYPE*,'Enter H,K,L, left MM, middle MM, right MM, wavelength ',
     1'identifier and weight separated by commas. (Wavelength ID ',
     2'and weight may be blank for defaults of CuKA wavelength and ',
     3'1.0 weight.) RETURN when done.'
46    TYPE*,'H,K,L,LEFT,MIDDLE,RIGHT,ID,WEIGHT  (RETURN TO QUIT)'
      READ(5,47,ERR=905)IH,IK,IL,A,B,C,I,D
      IF(A.EQ.0.0.AND.B.EQ.0.0.AND.C.EQ.0.0)GOTO 55  ! QUIT
      N4=60
      IF(D.EQ.0.0)N4=50
      IF(I.EQ.0.AND.D.EQ.0.0)N4=46
      ENCODE(80,48,CARD,ERR=905)IH,IK,IL,A,B,C,I,D
47    FORMAT(3I6,3F9.3,I4,F11.5)
48    FORMAT(4X,3I6,3F8.2,I4,F10.5)
      TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
      GOTO 46
55    CARD(1:3)='END'
      TYPE 2,CARD(1:3)
      WRITE(4,1)CARD(1:3)
      TYPE*,'Any more data? Y/[N]'
      ACCEPT 1,ANS
      IF(ANS(1:1).EQ.'Y')GOTO 30
      CARD(1:5)='START'
      TYPE 2,CARD(1:5)
      WRITE(4,1)CARD(1:5)
      RETURN
900   FORMAT(' ERROR ON LAST CARD ENTERED - TRY AGAIN.')
901   TYPE 900
      GOTO 20
902   TYPE 900
      GOTO 30
903   TYPE 900
      GOTO 29
904   TYPE 900
      GOTO 38
905   TYPE 900
      GOTO 46
      END
