      SUBROUTINE CONVERTIN
C  INPUT PROGRAM FOR CONVERT
      CHARACTER*80 CARD
      CHARACTER*4 ANS
      CHARACTER*30 BLANK
      BYTE MC
1     FORMAT(A)
2     FORMAT(1X,A)
10    FORMAT(I4)
      IFLAG=0
      MC=0
      BLANK='                              '
      TYPE*,' Will your input be included in a CRD file? [Y]/N'
      ACCEPT 1,ANS
100   IF(ANS(1:1).ne.'N')THEN
        IFLAG=1
        TYPE*,'Enter version number of CRD file to be used.  ',
     1  'RETURN for DEFAULT of HIGHEST version only.'
        READ(5,10,ERR=901)I
        IF(I.EQ.0)THEN
          ENCODE(80,101,CARD)
          CARD(9:11)='CRD'
          N4=11
        ELSE
          ENCODE(80,101,CARD,ERR=901)I
          CARD(9:11)='CRD'
101   FORMAT('CONVERT',4X,I2)
          N4=13
        ENDIF
      ELSE
        ENCODE(80,101,CARD)
        N4=7
      ENDIF
      TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
c
      type*,'Do you want HS atom B',1h','s rescaled? [Y]/N'
        ACCEPT 1,ANS
        IF(ANS(1:1).NE.'N')then
         type*,'Enter scale factor and offset: 2F4.0 [0.1,0.0]'
         read(5,106)hscale,hoffset
  106    format(2f4.0)
         if(hscale.eq.0.0 .and. hoffset.eq.0.0) hscale=0.1
         n4=12
         write(card,107)hscale,hoffset
  107    format('HSIZ',f4.2,f4.1)
         TYPE 2,CARD(1:N4)
         WRITE(4,1)CARD(1:N4)
        endif
c
      IF(IFLAG.EQ.1)THEN
        TYPE*,'Do you want to convert any additional atoms not from ',
     1  'your CRD file? Y/[N]'
        ACCEPT 1,ANS
        IF(ANS(1:1).NE.'Y')GOTO 105
      ENDIF
      CALL COORDIN(2,MC)
      TYPE*,'Any ISOs? Y/[N]'
      ACCEPT 1,ANS
      IF(ANS(1:1).EQ.'Y')CALL COORDIN(3,MC)
      TYPE*,'Any ANISOs? Y/[N]'
      ACCEPT 1,ANS
      IF(ANS(1:1).EQ.'Y')CALL COORDIN(5,MC)
      TYPE*,'Make sure you have the same number of COORD and TEMP'
     1' cards.'
105   TYPE*,'Do you want to enter any SYMMETRY cards?  All converted',
     1'atoms will be transformed according to the specified ',
     2'transformations and included in your name.CVT file after ',
     3'the corresponding, original parameters. [Y]/N'
      ACCEPT 1,ANS
      IF(ANS(1:1).EQ.'N')GOTO 200
      CARD(1:4)='SYM '
201   TYPE*,'Enter symmetry transformation in "FREE FORMAT", i.e. ',
     2'1/2 + X,-Y,-1+Z             '
      TYPE*,'Fractions must be entered with divide signs (i.e. 1/2 ',
     2'not .5) and commas must separate the X, Y, and Z designators. ',
     3'the translation components, if any, must come first.',
     3'RETURN if DONE.'
      ACCEPT 1,CARD(5:34)
      IF(CARD(5:34).EQ.BLANK)GOTO 200
      N4=34
      TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
      GOTO 201
200   TYPE*,'Do you want to convert all atoms?  You may specify ',
     1'atom TYPES *NOT* TO BE converted and/or INDIVIDUAL atoms TO ',
     2'BE converted. Y/[N]'
      ACCEPT 1,ANS
      IF(ANS(1:1).EQ.'Y')GOTO 102
      TYPE*,'Do you want certain atom TYPES (i.e. Hs) *NOT* TO BE ',
     1'converted?  (If you want only a couple of atoms of a certain ',
     2'type to be included, you may omit all atoms of the type and ',
     3'then specify the atoms to be included on an atom card.) Y/[N]'
      ACCEPT 1,ANS
      IOMIT=0
      IF(ANS(1:1).EQ.'Y')IOMIT=1
      IF(IOMIT.EQ.0)GOTO 205
      I=6
      CARD(1:5)='OMIT '
203   TYPE*,'Enter a 3-character form factor label of an atom type ',
     1'to be omitted.  RETURN if DONE.'
      ACCEPT 1,CARD(I:I+3)
      IF(CARD(I:I+3).EQ.'    ')GOTO 204
      I=I+4
      GOTO 203
204   N4=I-1
      TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
205   TYPE*,'Do you want to specify any individual atoms to be ',
     1'converted? '
      IF(IOMIT.EQ.0)THEN
        TYPE*,'Atoms specified here are the only atoms that will be ',
     1  'converted. [Y]/N'
      ELSE
        TYPE*,'All atoms of a type *NOT* specified on your omit card ',
     1  'will be converted.  If you want any atoms of a type specified',
     2  'on your omit card to be converted, enter them here. [Y]/N'
      ENDIF
      ACCEPT 1,ANS
      IF(ANS(1:1).EQ.'N')GOTO 102
      I=6
      CARD(1:5)='ATOM '
206   TYPE*,'Enter a 6-character atom identifier of a single atom ',
     1'to be converted.  RETURN if DONE.'
      ACCEPT 1,CARD(I:I+6)
      IF(CARD(I:I+6).EQ.'     ')GOTO 208
      I=I+7
      IF(I.ge.70)THEN
        TYPE 2,CARD
        WRITE(4,1)CARD
        I=6
      ENDIF
      GOTO 206
208   IF(I.EQ.6)GOTO 102
      N4=I-1
      TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
102   CARD(1:3)='END'
      N4=3
      TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
      RETURN
901   TYPE*,'ERROR IN VERSION NUMBER.  TRY AGAIN.'
      GOTO 100
      END
