      SUBROUTINE CRYSTALIN
C  INPUT FOR CRYSTAL DATA PROGRAM - 6/88
      DIMENSION INF(12),FF(10)
      CHARACTER*80 CARD
      CHARACTER*3 AN(12)
      CHARACTER*6 ANS
      CHARACTER*4 WORD
      CHARACTER*16 ANAM
      COMMON/FNAME/ANAM,NAMLEN
1     FORMAT(A)
2     FORMAT(1X,A)
3     FORMAT(A)
      II=NAMLEN+1
      ANAM(II:II+3)='.INF'
C      IOP15=0
c      OPEN(NAME=ANAM,UNIT=15,TYPE='OLD',FORM='FORMATTED',ERR=101)
C      inquire(FILE=anam,opened=od,exist=ex) 
C      if(ex)then      ! does inf file exist?  feb93bjw
C      IOP15=1
C      endif
C
C
101   CARD(1:12)='CRYSTAL DATA'
      N4=12
      TYPE 2,CARD(1:N4)
      WRITE(4,3)CARD(1:N4)
c
c
C  CELL CARD HERE - FIRST CHECK INF FILE
      IUP=0
        WORD='CELL'
C
        CALL FIND(CARD,WORD,I,15)  ! CELL CARD FROM INF
C
C           IF THERE IS A CELL CARD
C
        IF(I.EQ.1)THEN
          DECODE(80,111,CARD,ERR=901)
     1       A,NSA,B,NSB,C,NSC,AA,NAL,BB,NBE,CC,NGA
111     FORMAT(' CELL',3(F9.3,'(',I2,')'),3(F8.2,'(',I2,')'))
C102     FORMAT(5X,F9.3,4X,F9.3,4X,F9.3,4X,F8.2,4X,F8.2,4X,F8.2)
          TYPE*,'Cell Parameters from INF file:'
          TYPE 111,A,NSA,B,NSB,C,NSC,AA,NAL,BB,NBE,CC,NGA
      SIGA=FLOATJ(NSA)/1000.
      SIGB=FLOATJ(NSB)/1000.
      SIGC=FLOATJ(NSC)/1000.
      SIGAL=FLOATJ(NAL)/100.
      SIGBE=FLOATJ(NBE)/100.
      SIGGA=FLOATJ(NGA)/100.
          TYPE*,'Do you need to change these? Y/[N]'
          ACCEPT 1,ANS
          IF(ANS(1:1).NE.'Y' .AND. NSC.NE.0)GOTO 110
          IF(ANS(1:1).NE.'Y' .AND. NSC.EQ.0)GOTO 115
        ENDIF
C
C
106   TYPE*,'Enter unit cell dimensions A,B,C,ALPHA,BETA and GAMMA'
      TYPE*,'separated by commas.'
      READ(5,107,ERR=902)A,B,C,AA,BB,CC
107   FORMAT(6F10.5)
C
  115 TYPE *,
     1'Enter sigmas for A,B,C,ALPHA,BETA,GAMMA separated by commas.'
      READ(5,107)SIGA,SIGB,SIGC,SIGAL,SIGBE,SIGGA
      NSA = SIGA * 1000. + 0.5
      NSB = SIGB * 1000. + 0.5
      NSC = SIGC * 1000. + 0.5
      NAL = SIGAL * 100. + 0.5
      NBE = SIGBE * 100. + 0.5
      NGA = SIGGA * 100. + 0.5
C
C   ADDING CELL CARD TO INF FILE, SINCE AT LEAST SOMETHING WAS READ IN
          ENCODE(80,111,CARD)
     1       A,NSA,B,NSB,C,NSC,AA,NAL,BB,NBE,CC,NGA
        CALL addin(CARD,15,IFLG)
C
C
C   WRITE CARDS FOR NAME.CRY
C
110   ENCODE(80,104,CARD,ERR=902)A,B,C,AA,BB,CC
104       FORMAT('CELL  ',3F8.5,3F8.4,26(1H ))
      TYPE 2,CARD
      WRITE(4,1)CARD
      ENCODE(80,116,CARD)SIGA,SIGB,SIGC,SIGAL,SIGBE,SIGGA
116   FORMAT('CELSIG',3F8.5,3F8.4,26(1H ))
      TYPE 2,CARD
      WRITE(4,1)CARD
C
c
        INAT=0
        WORD='FORM'
        CALL FIND(CARD,WORD,I,15)  ! IS FORMULA ON INF FILE?
        IF(I.EQ.1)THEN  ! YES, FORMULA THERE
          INAT=1
          DECODE(80,220,CARD,ERR=903)(AN(II),INF(II),II=1,12)
220       FORMAT(10X,12(A3,I3,1X))
          TYPE*,'KIND F from INF file:'
          TYPE 221,(AN(II),II=1,12)
221       FORMAT(' KIND F ',12(A3,' '))
          TYPE*,'Do you want to change this? Y/[N]'
          ACCEPT 1,ANS
          IFF=0
          IF(ANS(1:1).NE.'Y')GOTO 1042 ! USE KIND F FROM INF
2211    ENDIF
        IUP=1
C     ENDIF
      TYPE*,'For KIND F card, enter up to 12 atomic scattering '
      TYPE*,'factor labels. Each  must be exactly three alphanumeric'
      TYPE*,'characters, left justified, spaces permitted, followed by',
     1' a comma.'
      READ(5,125)(AN(I),ASP,I=1,12)
125   FORMAT(12(A3,A1))
1041  TYPE*,'Enter the number of FORM FACTORS that you are entering',
     1' yourself or "0" if blank.'
      ACCEPT *,IFF
1042  IF(IFF.NE.0) THEN
        N4=50
	ENCODE(80,127,CARD,ERR=905)(AN(I),I=1,12),IFF
      ELSE
   	ENCODE(80,127,CARD,ERR=905)(AN(I),I=1,12)
127     FORMAT('KIND F',12A3,:,6X,I2)
        N4=42
      ENDIF
1061  TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
139   IF(IFF.EQ.0)GO TO 155          ! DONT WANT TO ENTER FORM F'S
C
C    FORM FACTORS CARD
C
      TYPE*,'To enter FORM FACTORS, type in 30 F values at increments',
     1' of 0.05 in Sin(THETA)/LAMBDA, beginning at 0.0 in groups',
     2' of 10.  After you have entered three groups of 10, you will',
     3' be asked for your atomic scattering factor label'
      DO ISN=1,3
1389    READ(5,137,ERR=904)(FF(I),I=1,10)
137     FORMAT(10F8.4)
        ENCODE(80,137,CARD,ERR=904)(FF(I),I=1,10)
        N4=80
        TYPE 2,CARD(1:N4)
        WRITE(4,1)CARD(1:N4)
      ENDDO
      TYPE*,'Enter ATOMIC SCATTERING FACTOR LABEL as on your KIND ',
     1'F card.'
      ACCEPT 1,CARD(1:3)
      N4=3
      TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
      IFF=IFF-1
      IF(IFF.GT.0)THEN
     	TYPE*,'For next ATOMIC SCATTERING FACTOR LABEL,'
	GOTO 139
      ENDIF
155   IF(INAT.EQ.1)THEN  ! ALREADY HAVE NUMBERS OF ATOMS FROM INF FILE
C        WORD='Z = '
C        CALL FIND(CARD,WORD,I,15)
C        IF(I.EQ.1)THEN   ! MULTIPLY BY Z
C          DECODE(80,1550,CARD,ERR=157)IZ
C1550      FORMAT(4X,I3)
C          DO II=1,12
C            INF(II)=INF(II)*IZ
C          ENDDO
C        ENDIF
        TYPE*,'Numbers of atoms from INF file:'
        TYPE 156,(INF(II),II=1,12)
156     FORMAT(' NUMBERS OF ATOMS',4X,12I4)
        TYPE*,'Do you want to change this? Y/[N]'
        ACCEPT 1,ANS
        IF(ANS(1:1).NE.'Y')GOTO 170 ! USE PARMAMS FROM INF FILE
        IUP=1
      ENDIF
157   TYPE*,'For numbers of atoms, enter the number of each',
     1'type of atom in the unit cell, up to 12, separated by',
     2'commas.  The order must be the same as the order in which',
     3'the atomic scattering factor labels appear on the KIND F card.'
      READ(5,158,ERR=906)(INF(I),I=1,12)
158   FORMAT(12I6)
170   ENCODE(80,1560,CARD,ERR=906)INF
1560  FORMAT('NUMBERS OF ATOMS',4X,12I4)
      N4=68
      TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
      IF(IUP.EQ.1)THEN  ! UPDATE NUMBER OF ATOMS AND KIND F IN INF FILE
        ENCODE(80,171,CARD)(AN(II),INF(II),II=1,10)
171     FORMAT(' FORMULA: ',10(A3,I3,1X))
        CALL addin(CARD,15,IFLG)
        IF(IFLG.EQ.1)TYPE*,' CELL FORMULA updated on INF file.'
      ENDIF
      RETURN
999   FORMAT(' ERROR ON LAST ENTRY.  TRY AGAIN.')
901   TYPE*,'Error on CELL PARAMS in INF file.  Will replace.'
      IUP=1
      GOTO 106
902   TYPE 999
      GOTO 106
903   TYPE*,'Error on FORMULA CARD in INF file.  Will replace.'
      IUP=1
      GOTO 2211
904   TYPE 999
      GOTO 1389
905   TYPE 999
      GOTO 1041
906   TYPE 999
      GOTO 157
      END
