      SUBROUTINE MAPSIN
C
C  INPUT FOR EXFFT AND SEARCH
C
      CHARACTER*80 CARD
      CHARACTER*6 CHAR6
      CHARACTER*16 NFILE,NAMDES
      COMMON/FNAME/NFILE,NAMLEN
      CHARACTER*4 ANS
      CHARACTER*5 TEMP
      COMMON/CBLANK/CARD,CHAR6,NN
1     FORMAT(A)
2     FORMAT(1X,A)
3     FORMAT(A6)
333   FORMAT(A80)
4     FORMAT(I5)
5     FORMAT(F6.0)
6     FORMAT(I6)
      MAP=0
      DO I=1,80
        CARD(I:I)=' '
      ENDDO
      DO I=1,5
        TEMP(I:I)=' '
      ENDDO
      IF(IPROG.EQ.1)GOTO 300  ! SEARCH, NOT EXFFT
C
C  EXFFT INPUT HERE
C
100   TYPE*,' Do you accept the defaults for EXFFT? [Y]/N '
      READ(5,1)ANS
      TYPE 2,ANS
      IF (ANS(1:1).NE.'N')GOTO 200
110   TYPE*,' Enter the number of E-maps to be examined. '
      TYPE*,' You may also include set-numbers for the maps '
      TYPE*,' leaving a space between numbers.  DEFAULT [1].'
      ACCEPT 1,CARD(5:80)
      IF(CARD(5:5).EQ.'1'.AND.CARD(6:6).EQ.' ')GOTO 115
      CARD(1:4)='MAP '
      WRITE(4,1)CARD
      TYPE 2,CARD
115   TYPE*,' Do you want the E-map printed? [Y]/N '
      READ(5,1)ANS
      IF(ANS(1:1).NE.'N')THEN
        CARD(1:4)='PRI '
        MAP=1
        WRITE(4,1)CARD(1:4)
        TYPE 2,CARD(1:4)
      ENDIF
      IF(MAP.EQ.0)GOTO 150  ! NO MAP PRINTED
120   TYPE*,'Enter N such that reflections greater than n will be'
      TYPE*,'underlined with **** (INT.).   DEFAULT [100].'
      READ(5,1)CARD(5:10) 
      IF(CARD(5:5).NE.' ')THEN
        CARD(1:4)='LEV '
        WRITE(4,1)CARD(1:10)
        TYPE 2,CARD(1:11)
      ENDIF
150   TYPE*,'Enter X such that the grid on which the E-map is printed'
      TYPE*,'is evaluated will have a spacing of X Angstroms (real).'
      TYPE*,' DEFAULT [0.33].'
      READ(5,1)CARD(5:11)
      IF(CARD(5:5).NE.' ')THEN
        CARD(1:4)='GRI '
        WRITE(4,1)CARD(1:11)
        TYPE 2,CARD(1:11)
      ENDIF
      IF(MAP.EQ.0)GOTO 200  ! NO MAP PRINTED
160   TYPE*,'Enter A such that E-map is printed from 0.0 to A along X.'
      TYPE*,'(real).'
      READ(5,1)CARD(5:11)
      IF(CARD(5:5).NE.' ') THEN
        CARD(1:4)='XMA '
        WRITE(4,1)CARD(1:11)
        TYPE 2,CARD(1:11)
      ENDIF
170   TYPE*,'Enter A such that E-map is printed from 0.0 to A along Y.'
      TYPE*,'(real).'
      READ(5,1)CARD(5:11)
      IF(CARD(5:5).NE.' ') THEN
        CARD(1:4)='YMA '
        WRITE(4,1)CARD(1:11)
        TYPE 2,CARD(1:11)
      ENDIF
180   TYPE*,'Enter A such that E-map is printed from 0.0 to A along Z.'
      TYPE*,'(real).'
      READ(5,1)CARD(5:11)
      IF(CARD(5:5).NE.' ') THEN
        CARD(1:4)='ZMA '
        WRITE (4,1) CARD(1:11)
        TYPE 2,CARD(1:11)
      ENDIF
200   TYPE*,'Do you accept SEARCH Defaults? [Y]/N '
      READ(5,3)ANS
      IF(ANS(1:1).NE.'N')GOTO 400
C
C  BEGIN SEARCH INPUT
C
300   TYPE*,'Enter number of peaks to be searched for in the map (INT).'
      TYPE*,'Return for DEFAULT based on number of independent atoms.'
      READ(5,1)CARD(5:10)
      IF(CARD(5:5).NE.' ')THEN
        CARD(1:4)='PEA '
        WRITE(4,1)CARD(1:10)
        TYPE 2,CARD(1:10)
      ENDIF
310   TYPE*,' Do you want peak interpretation? [Y]/N '
      READ(5,1)ANS
      IF(ANS(1:1).EQ.'N')THEN
        CARD(1:4)='NOJ '
        WRITE(4,1)CARD(1:4)
        TYPE 2,CARD(1:4)
      ENDIF
320   TYPE*,'Enter number of orthogonal projections of each cluster'
      TYPE*,'to be plotted (no more than 3) (INT.).'
      TYPE*,'"0" suppresses all plotting.'
      TYPE*,'Return for DEFAULT of plotting least squares projection.'
      READ(5,1)CARD(5:7)
      IF(CARD(5:5).NE.' ')THEN
        CARD(1:4)='PRO '
        WRITE(4,1)CARD(1:7)
        TYPE 2,CARD(1:7)
      ENDIF
330   TYPE*,'Enter X such that interpeaks distances less than X are'
      TYPE*,'tabulated (real). DEFAULT [2.4].'
      READ(5,1)CARD(5:11)
      IF(CARD(5:5).NE.' ')THEN
        CARD(1:4)='DOU '
        WRITE (4,1)CARD(1:11)
        TYPE 2,CARD(1:11)
      ENDIF
340   TYPE*,'Enter minimum allowed bond length in the interpretation.'
      TYPE*,'(real).  DEFAULT [1.1].'
      READ(5,1)CARD(5:11)
      IF(CARD(5:5).NE.' ')THEN
        CARD(1:4)='DMI '
        WRITE(4,1)CARD(1:11)
        TYPE 2,CARD(1:11)
      ENDIF
350   TYPE*,'Enter maximum allowed bond length in the interpretation.'
      TYPE*,'(real). DEFAULT [1.95].'
      READ(5,1)CARD(5:11)
      IF(CARD(5:5).NE.' ')THEN
        CARD(1:4)='DMA '
        WRITE(4,1)CARD(1:11)
        TYPE 2,CARD(1:11)
      ENDIF
360   TYPE*,'Enter minimum allowed bond angle in the interpretation.'
      TYPE*,'(real).  DEFAULT [85] degrees.'
      READ(5,1)CARD(5:11)
      IF(CARD(5:5).NE.' ')THEN
        CARD(1:4)='AMI '
        WRITE(4,1)CARD(1:11)
        TYPE 2,CARD(1:11)
      ENDIF
370   TYPE*,'Enter maximum allowed bond angle in the interpretation.'
      TYPE*,'(real).  DEFAULT [145] degrees.'
      READ(5,1)CARD(5:11)
      IF(CARD(5:5).NE.' ')THEN
        CARD(1:4)='AMA '
        WRITE(4,1)CARD(1:11)
        TYPE 2,CARD(1:11)
      ENDIF
380   TYPE*,'Enter the number of heavy atoms in the asymmtric unit'
      TYPE*,'to eliminate spurious peaks around these atoms (INT).'
      TYPE*,'Return IF this option is NOT WANTED.'
      READ(5,1)CARD(5:7)
      IF(CARD(5:5).NE.' ')THEN
        CARD(1:4)='MET '
        WRITE(4,1)CARD(1:7)
        TYPE 2,CARD(1:7)
      ENDIF
400   CARD(1:4)='END '    
      WRITE(4,1)CARD(1:4)
      TYPE 2,CARD(1:4)
      RETURN
900   FORMAT(' ERROR ON LAST ENTRY.  TRY AGAIN.')
901   TYPE 900
C      GOTO 110
902   TYPE 900
C      GOTO 120
903   TYPE 900
C      GOTO 150
904   TYPE 900
C      GOTO 160
905   TYPE 900
C      GOTO 170
906   TYPE 900
C      GOTO 180
907   TYPE 900
C      GOTO 300
908   TYPE 900
C      GOTO 310
909   TYPE 900
C      GOTO 320
910   TYPE 900
C      GOTO 330
911   TYPE 900
C      GOTO 340
912   TYPE 900
C      GOTO 350
913   TYPE 900
C      GOTO 360
914   TYPE 900
C      GOTO 370
915   TYPE 900
C      GOTO 380
916   TYPE 900
C      GOTO 390
      END
