	SUBROUTINE PATTIN(IPL)
C   PATTERSON, FOURIER AND DIFFERENCE FOURIER AND PEAKLIST PROGRAMS
C   IPL=1 FOR PATTERSON,FOURIER OR DIFFERENCE FOURIER
C   IPL=2 FOR PEAKLIST
C      CHARACTER*1 CH11
C      CHARACTER*1 CH12
C      CHARACTER*6 ABC
C      CHARACTER*15 TRIX
C  FOLLOWING FROM FOOIN.FOR
      CHARACTER*16 NFILE
      CHARACTER*14 ID    
      CHARACTER*5 MPTP
      CHARACTER*80 CARD,PKCARD
C      CHARACTER*1 C(80)
C      EQUIVALENCE (CARD(1),C(1))
      CHARACTER*3 FFF
      CHARACTER*6 ANS    
      CHARACTER*4 SGL,WORD
      CHARACTER*20 BRANCH
      CHARACTER*8 SQU
      CHARACTER*10 END
      CHARACTER*1 XYZ(3)
      BYTE TSC                ! TRUE SCALE MAP SIGNAL
      BYTE GP                ! SIGNAL FOR GENERAL PLANE OPTION
      BYTE ISP   ! SHARPEN PATTERSON
      LOGICAL OD,EX    ! FOR INQUIRE
      INTEGER HMAX,KMAX,LMAX
      REAL NAPL,NGX             ! NEG PEAK MIN HEIGHT, MIN DISTANCE
      DIMENSION CXYZ(3)
      COMMON/PASS/BRANCH
      COMMON/FNAME/NFILE,NAMLEN
      DATA XYZ/'X','Y','Z'/
      DATA MPTP/'REEKE'/           ! REEKE FOURIER
      DATA TSC/1/
      BYTE OP14,GENPK
1     FORMAT(A)
2     FORMAT(1X,A)
2000  FORMAT(I10)    ! FORMAT FOR INTEGERS
3000  FORMAT(F18.10,:,F18.10,:,F18.10,:,3F10.6)   ! FORMAT FOR REALS
4000  FORMAT(F10.4)
5000  FORMAT(1X)
704   FORMAT(A10,A8,1X,I3,A1,1X,A5)       ! 29 COLS
739   FORMAT(F8.4)
740   FORMAT(F8.5)
C      CALL FOOIN(1)         ! ROUTINE PREPARES REEKE INPUT
C   REEKE PATTERSON, FOURIER AND DIFFERENCE FOURIER PROGRAMS
C      SUBROUTINE FOOIN(IPL)
C  IPL = 2 IF JUST WANT TO RUN PEAK LIST, OTHERWISE IPL = 1
      OP14=0          ! UNIT 14 HAS NOT BEEN OPENED YET
C     JMN=0           ! FOR PEAK LIST UNUSED NOW NEED FOR FORMAT
      NGX=0.0          ! INITIALIZE NEG PEAK DIST.
      ISP=0  ! NOT SHARPEN PATTERSON
      IOP15=0
      IUP=0
      NFILE(NAMLEN+1:NAMLEN+4)='.INF'
C       OPEN AND CLOSE OF INF FILE NOW DONE IN FIND AND addin
C      OPEN(NAME=NFILE,UNIT=15,TYPE='OLD',FORM='FORMATTED',ERR=3210)
      IOP15=1
3210  IF(IPL.EQ.2)THEN
        ANS(1:1)='Y'
        GOTO 7597
      ENDIF
      TYPE 5000
      IF(IOP15.EQ.1)THEN  ! CHECK INF FOR SPACE GROUP
        WORD='SPAC'
        CALL FIND(CARD,WORD,I,15)
        IF(I.EQ.1)THEN
          DECODE(80,3211,CARD,ERR=3213)ISG,SGL
3211      FORMAT(14X,I3,A1)
          TYPE 3212,ISG,SGL
3212      FORMAT(' Space Group from .INF: ',I3,A1)
3213      IUP=1
        ELSE
          GOTO 700
        ENDIF
      ELSE
700     TYPE*,'Enter Space Group number.  No letter yet.'
        ASSIGN 700 TO IGO
        READ(5,2000,ERR=301)ISG
        SGL=' '
        TYPE*,'Enter space group LETTER or RETURN if blank.'
        ACCEPT 1,SGL
709     IF(SGL.EQ.'A') GO TO 701
        IF(SGL.EQ.'N') GO TO 701
        IF(SGL.EQ.' ') GO TO 701
        TYPE*,'Error in space group letter.  Must be an "A" or "N". ',
     1're-enter space group letter.'
        ACCEPT 1,SGL
        GO TO 709
      ENDIF
701   IF(BRANCH(1:1).EQ.'P') GO TO 705
      IF(BRANCH(1:1).EQ.'F') GO TO 706
      END='DIFFERENCE'
      SQU=' FOURIER'
703   ENCODE(29,704,CARD,ERR=301)END,SQU,ISG,SGL,MPTP
      TYPE 2,CARD(1:29)
      WRITE(4,1)CARD(1:29)
      GO TO 710
705   END='PATTERSON '
      TYPE*,'Is this a Sharpened Patterson? Y/[N]'
      ACCEPT 1,ANS
      IF(ANS(1:1).EQ.'Y')ISP=1
      SQU='        '
      GO TO 703
706   END='FOURIER   '
      SQU='        '
      GO TO 703
710   TYPE 5000
      IF(IUP.EQ.1)THEN  ! UPDATE SPACE GROUP ON INF FILE
        ENCODE(80,3215,CARD)ISG,SGL
3215    FORMAT(' SPACE GROUP: ',I3,A1)
        CALL addin(CARD,15,IFLG)
        IF(IFLG.EQ.1)TYPE*,'Space group updated on .INF file.'
      ENDIF
      IUP=0
C
C The following question et al. eliminated 8/91 per lmh and wps
C The only cell card option now is from the .HKL file.
C
c      TYPE*,'For CELL CARD, do you want cell parameters taken from ',
c     1'your .HKL file? [Y]/N'
c      ACCEPT 1,ANS
c      IF(ANS(1:1).EQ.'N')THEN
c892     TYPE*,'Enter unit cell dimensions A, B, C, ALPHA, BETA and ',
c     1  'GAMMA separated by commas.'
c        ASSIGN 892 TO IGO
c        READ(5,3000,ERR=301)A,B,C,AL,BE,GA
c        IF(AL.EQ.0)AL=90.0
c        IF(BE.EQ.0)BE=90.0
c        IF(GA.EQ.0)GA=90.0
c        ENCODE(54,561,CARD,ERR=301)A,B,C,AL,BE,GA
c561     FORMAT('CELL  ',6(F7.3,1X))       ! 54 COLS
c        TYPE 2,CARD(1:54)
c        WRITE(4,1)CARD(1:54)
c      ENDIF
      TYPE 5000
7120  TYPE 712
712   FORMAT(' A LIMITS CARD is optional. You may enter any of ',
     1'the following:',/,
     + ' HMAX, KMAX, LMAX, RHOMAX, FMIN, SIGMAX, and  DELETE ZERO ',
     1'WEIGHT.',/,
     + ' Reflections having any value exceeding a maximum will be ',
     +  'omitted from the',/,' calculations.',/,
     + ' DEFAULTS are : ',/,
     + '      RHOMAX is calculated for the copper sphere,',/,
     + '      all other tests are omitted.',/,
     +' Do you want a limits card?  Y/[N]')
          GENPK=0           ! INITIALIZE AND REINITIALIZE
      ACCEPT 1,ANS
      IF (ANS(1:1).EQ.'Y')THEN
        CARD(1:7)='LIMITS '
        IB=8                           ! PLACEMENT OF 1ST PARAMETER
23      TYPE*,'Enter the maximum value of H.  RETURN if not wanted.'
        ASSIGN 23 TO IGO
        READ(5,2000,ERR=301)HMAX
        IF(HMAX.NE.0)THEN
          IE=IB+6
          CARD(IB:IE)='HMAX = '
          IB=IE+1
          IE=IB+2
          ENCODE(3,2001,CARD(IB:IE),ERR=301)HMAX
2001      FORMAT(I3)
          IB=IE+1
        ENDIF
24      TYPE*,'Enter the maximum value of K.  RETURN if not wanted.'
        ASSIGN 24 TO IGO
        READ(5,2000,ERR=301)KMAX
        IF(KMAX.NE.0)THEN
          IF(IB.GT.8)THEN
            CARD(IB:IB)=','
            IB=IB+1
          ENDIF
          IE=IB+6
          CARD(IB:IE)='KMAX = '
          IB=IE+1
          IE=IB+2
          ENCODE(3,2001,CARD(IB:IE),ERR=301)KMAX
          IB=IE+1
        ENDIF
25      TYPE*,'Enter the maximum value of L.  RETURN if not wanted.'
        ASSIGN 25 TO IGO
        READ(5,2000,ERR=301)LMAX
        IF(LMAX.NE.0)THEN
          IF(IB.GT.8)THEN
            CARD(IB:IB)=','
            IB=IB+1
          ENDIF
          IE=IB+6
          CARD(IB:IE)='LMAX = '
          IB=IE+1
          IE=IB+2
          ENCODE(3,2001,CARD(IB:IE),ERR=301)LMAX
          IB=IE+1
        ENDIF
26      TYPE*,'Enter RHOMAX, the maximum value of Sin**2(Theta)/',
     1  'Lambda**2.  RETURN if not wanted.'
        ASSIGN 26 TO IGO
        ACCEPT 1,END
        IF(END(1:2).NE.'  ')THEN
          DECODE(10,4000,END,ERR=301)RHO
          IF(IB.GT.8)THEN
            CARD(IB:IB)=','            ! SEPARATOR
            IB=IB+1
          ENDIF
          IE=IB+8
          CARD(IB:IE)='RHOMAX = '
          IB=IE+1
          IE=IB+7
          ENCODE(8,740,CARD(IB:IE),ERR=301)RHO
          IB=IE+1
        ENDIF
27      TYPE*,'Enter FMIN such that if FOBS is less than FMIN ',
     1  'reflection is omitted.'
        ACCEPT 1,END
        ASSIGN 27 TO IGO
        IF(END(1:2).NE.'  ')THEN
          DECODE(10,4000,END,ERR=301)FMIN
          IF(IB.GT.8)THEN
            CARD(IB:IB)=','
            IB=IB+1
          ENDIF
          IF(IB+15.GT.71)THEN
            WRITE(4,1)CARD(1:IB)
            TYPE 2,CARD(1:IB)
            IB=5
            CARD(1:4)='    '                   ! BLANK FIRST 4 CHAR
          ENDIF
          IE=IB+7  
          CARD(IB:IE)='FMIN = '
          IB=IE+1
          IE=IB+7
          ENCODE(8,739,CARD(IB:IE),ERR=301)FMIN
          IB=IE+1
        ENDIF
28      TYPE*,'Enter the maximum value of Sigma.  RETURN if not ',
     1  'wanted.'
        ASSIGN 28 TO IGO
        ACCEPT 1,END
        IF(END(1:2).NE.'  ')THEN
          DECODE(10,4000,END,ERR=301)SIGMX
          IF(IB.GT.8)THEN
            CARD(IB:IB)=','
            IB=IB+1
          ENDIF
          IF(IB+17.GT.71)THEN
            WRITE(4,1)CARD(1:IB)     ! GET READY FOR CONTINUATION CARD
            TYPE 2,CARD(1:IB)
            IB=5
            CARD(1:4)='    '
          ENDIF
          IE=IB+8
          CARD(IB:IE)='SIGMAX = '
          IB=IE+1
          IE=IB+7
          ENCODE(8,740,CARD(IB:IE),ERR=301)SIGMX
          IB=IE+1
        ENDIF
        TYPE *,'Do you want the delete ZERO WEIGHT option? '
        TYPE *,'Zero weight reflections are always omitted from '
        TYPE *,'Difference Fouriers.  Y/[N]'
        ACCEPT 1,ANS
        IF(ANS(1:1).EQ.'Y')THEN
          IF(IB.GT.8)THEN
            CARD(IB:IB)=','
            IB=IB+1
          ENDIF
          IF(IB+18.GT.71)THEN
            WRITE(4,1)CARD(1:IB)
            TYPE 2,CARD(1:IB)
            IB=5
           CARD(1:4)='    '
          ENDIF
          IE=IB+17
          CARD(IB:IE)='DELETE ZERO WEIGHT'
C     WRITE(4,1)CARD(1:IE)
C     TYPE 2,CARD(1:IE)
        ENDIF
        WRITE(4,1)CARD(1:IE)
        TYPE 2,CARD(1:IE)
      ENDIF
      TYPE 5000
      TYPE *,'Do you want to list rejected reflections? Y/[N]'
      ACCEPT 1,ANS(1:1)
      IF(ANS(1:1).EQ.'Y')THEN
        card(1:12)='LIST REJECTS'
        TYPE 2,CARD(1:12)
        WRITE(4,1)CARD(1:12)
      ENDIF
      TYPE 5000
      TYPE *,'Do you want the asymmetric unit test?  If so,'
      TYPE *,'reflections not in the asymmetric unit will be omitted.'
      TYPE *,'Without the test all reflections are included. Y/[N]'
      ACCEPT 1,ANS(1:1)
      IF(ANS(1:1).NE.'Y')THEN
        CARD(1:25)='OMIT ASYMMETRIC UNIT TEST'
        WRITE(4,1)CARD(1:25)
        TYPE 2,CARD(1:25)
      ENDIF
      TYPE 5000
      TYPE 202
202   FORMAT(' Do you want the PHASE CUTOFF function ?',/,
     + ' Reflections for which Fcalc does not exceed ',/,
     + ' the phase cutoff value will be omitted.',/,
     + ' This option is not permitted with Pattersons. Y/[N]')
      ACCEPT 1,ANS(1:1)
      IF(ANS(1:1).EQ.'Y')THEN
203     TYPE*,'Enter 3 real numbers A, B and C separated by commas ',
     1  'such that FCmin=A + B*Fobs + C*RHO.  Any 2 of A, B and C ',
     3  'may be zero.'
        ASSIGN 203 TO IGO
        READ(5,3000,ERR=301)C1,C2,C3
        ENCODE(67,205,CARD(1:67),ERR=301)C1,C2,C3   
205     FORMAT('PHASE CUTOFF FUNCTION, FCMIN =',F6.3,' +',
     +F6.3,'*FOBS +',F6.3,'*RHO')
        TYPE 2,CARD(1:67)
        WRITE(4,1)CARD(1:67)
      ENDIF
      TYPE 5000
2030  TYPE*,'Enter Point Scale.  Fourier coefficients are ',
     1'multiplied by the reciprocal of this scale.  RETURN for ',
     2'DEFAULT of .01 for FOURIERS and DIFFERENCES, 1.0 ',
     3'for PATTERSONS and .01 for SHARPENED PATTERSONS.'
      ASSIGN 2030 TO IGO
      READ(5,3000,ERR=301)PS
      IF(ISP.EQ.1.AND.PS.EQ.0.0)PS=0.01
      IF(PS.NE.0.0)THEN
        ENCODE(19,207,CARD(1:19),ERR=301)PS
207     FORMAT('POINT SCALE ',F7.4,61X)
        TYPE 2,CARD(1:19)
        WRITE(4,1)CARD(1:19)
      ENDIF
      TYPE 5000
208   TYPE*,'Enter SCALE FACTOR.  RETURN to have scale factor taken ',
     1'from your .HKL file.'
      ASSIGN 208 TO IGO
      READ(5,3000,ERR=301)SC
      IF(SC.NE.0.0)THEN
        ENCODE(23,209,CARD(1:23),ERR=301)SC
209     FORMAT('SCALE FACTOR = ',F8.6)
        TYPE 2,CARD(1:23)
        WRITE(4,1)CARD(1:23)
      ENDIF
      IF(ISP.EQ.1)THEN    !                     
C  ONLY SHARPENED PATTERSONS HERE
        CARD(1:8)='SHARPEN '
        R=0.0                 ! DEFAULT FOR REMOVE
        TYPE *,'Do you want to remove the origin ? Y/[N]'
        ACCEPT 1,ANS(2:2)
        IF(ANS(2:2).EQ.'Y')THEN
          ASSIGN 2008 TO IGO
2008      TYPE 2009
2009      FORMAT(' Enter a number between 0.0 and 1.0 to',/,
     +  ' be subtracted from E for the REMOVE option. ',/,
     +  ' DEFAULT of r=1.0.')
          read(5,3000,ERR=301)R
          IF(R.EQ.0.0)R=1.0
          ENCODE (18,2010,CARD(9:25),ERR=301)R
2010      FORMAT(', REMOVE = ',F6.4)
        ELSE
          CARD(9:26)='                  '
        ENDIF
        TYPE 2,CARD(1:26)
        WRITE(4,1)CARD(1:26)
      ENDIF                        ! END OF SHARPEN OPTION
      GP=0
      TYPE 5000
6     TYPE*,'1) GENERAL PLANE'
      TYPE*,'2) THREE DIMENSIONAL'
      TYPE*,'3) PROJECTION OR'
      TYPE*,'4) SECTION'
      TYPE*,' '
      TYPE*,'ENTER NUMBER.'
      ASSIGN 6 TO IGO
      READ(5,2000,ERR=301)N
      IF(N.LT.1.OR.N.GT.4)GOTO 301
      IF(N.NE.1)THEN
      TYPE*,'Bounds on X,Y and Z for the appropriate asymmetric unit ',
     1'are stored in the program for each space group.  In the CRYM ',
     3'manual beginning on page 11.11 the bounds for Fourier and ',
     4'Difference Fourier are listed.  Do you want ',
     2'to change any of these bounds? Y/[N]'
      ACCEPT 1,ANS(1:1)
      CARD(1:7)='BOUNDS '
      IB=8
      IE=IB+20
      IF(ANS(1:1).EQ.'Y')THEN
31      TYPE 212,XYZ(1)
212     FORMAT(' Enter 2 real numbers separated by a comma to signify ',
     1 'the low and',/,' high bounds for ',A1,'. RETURN if not wanted.')
        ASSIGN 31 TO IGO
        READ(5,3000,ERR=301)XL,XH
        IF(XL.NE.0.0.OR.XH.NE.0.0)THEN
          ENCODE(21,211,CARD(IB:IE),ERR=301)XYZ(1),XL,XH
211       FORMAT(A1,' = (',F7.4,',',F7.4,')')
          IB=IE+1
        ENDIF
32      TYPE 212,XYZ(2)
        ASSIGN 32 TO IGO
        READ(5,3000,ERR=301)YL,YH
        IF(YL.NE.0.0.OR.YH.NE.0.0)THEN
          IF(IB.GT.8)THEN
            IE=IB+1
            CARD(IB:IE)=', '       
            IB=IB+2   
            IE=IB+20
          ENDIF
          ENCODE(21,211,CARD(IB:IE),ERR=301)XYZ(2),YL,YH
          IB=IE+1
        ENDIF
33      TYPE 212,XYZ(3)
        ASSIGN 33 TO IGO
        READ(5,3000,ERR=301)ZL,ZH
        IF(ZL.NE.0.0.OR.ZH.NE.0.0)THEN
          IF(IB.GT.8)THEN
            IE=IB+1
            CARD(IB:IE)=', ' 
            IB=IB+2
            IE=IB+20
          ENDIF
          ENCODE(21,211,CARD(IB:IE),ERR=301)XYZ(3),ZL,ZH
        ENDIF
        IE=IE+1
        TYPE 2,CARD(1:IE)
        WRITE(4,1)CARD(1:IE)
      ENDIF
      ENDIF
      TYPE 5000
      TYPE *,'Do you want the save MAP option? Y/[N]'
      ACCEPT 1,ANS(1:1)
      IF(ANS(1:1).EQ.'Y')THEN
        CARD(1:8)='SAVE MAP'
        TYPE 2,CARD(1:8)
        WRITE(4,1)CARD(1:8)
      ENDIF
C                     MAP STARTING INFORMATION
3     ANS(1:1)=' '       ! BLANK OUT ANS
      IF(N.NE.1)GOTO 8
      GP=9
      TYPE 5000
      I=NAMLEN+1
      NFILE(I:I+3)='.GEN'
      TYPE 5000
      TYPE 7490,NFILE
7490  FORMAT(' Do you want GENERAL PLANE cards taken from your latest ',
     1 A16,/,' file? [Y]/N')
      ACCEPT 1,ANS
      IF(ANS(1:1).NE.'N')THEN
      GENPK=1          ! SIGN THAT .GEN FILE WILL BE OPENED
        TYPE 7600
7600   FORMAT(' Do you want the PEAK LIST option? Y/[N]')
       ACCEPT 1,ANS
       IF(ANS(1:1).EQ.'Y')THEN
      TYPE 7601
7601  FORMAT(' The PEAK LIST record will be inserted after each',/,
     +' GENERAL PLANE record. Use the editor to change the peak',/,
     +' list parameters or to delete peak list if necessary.',/)
7590    TYPE 760
        ASSIGN 7590 TO IGO
        READ(5,3000,ERR=301)APL
        IF(APL.EQ.0.0)APL=150.0          ! DEFAULT HEIGHT
7620     TYPE *,'Enter the MINimum distance between peaks in A.'
         TYPE *,' DEFAULT is 0.5 A.'
        ASSIGN 7620 TO IGO
        READ(5,3000,ERR=301)GX
        IF(GX.EQ.0.0)GX=0.5
        TYPE*,'Do you want to create a name.PKL file of COORDS of ',
     1  'your peaks? Y/[N]'
        ACCEPT 1,ANS
        K=0
        IF(ANS(1:1).EQ.'Y')K=1
        IMIN=0                ! IN GENERAL PLANE 
      TYPE *,' Do you want NEGATIVE peaks? Y/[N]'
      ACCEPT 1,ANS
      IF(ANS(1:1).EQ.'Y')THEN
      TYPE *,' Enter MINimum HEIGHT for negative peaks. ',
     1'DEFAULT is 150.0. '
      READ(5,3000)NAPL           ! REAL NUMBER
      IF(NAPL.EQ.0.0)NAPL=150.0
      TYPE *,' Enter MINimum DISTANCE between peaks'
      TYPE *,' DEFAULT is 0.5.'
      READ(5,3000)NGX
      IF(NGX.EQ.0.0)NGX=0.5
      ENDIF
        ASSIGN 7590 TO IGO
       IF(ANS(1:1).EQ.'Y')THEN
       ENCODE(39,761,PKCARD,ERR=301)APL,GX,K,IMIN,NAPL,NGX
       ELSE
        ENCODE(26,761,PKCARD,ERR=301)APL,GX,K,IMIN
       ENDIF
       GENPK=9         ! SIGNAL FOR PEAK WITH NAM.GEN
        ENDIF
        OPEN(NAME=NFILE,UNIT=14,TYPE='OLD',FORM='FORMATTED',
     1 BLOCKSIZE=32768,ERR=7491)
        OP14=1
7495    READ(14,1,END=7494)CARD
        WRITE(4,1)CARD
        TYPE 2,CARD
       IF(GENPK.EQ.9)THEN
        IE=39
      IF(NGX.EQ.0.0)IE=26
        TYPE 2,PKCARD(1:IE)
        WRITE(4,1)PKCARD(1:IE)
C             INSERT END FOURIER HERE
       ENDIF
        GOTO 7495
7494    GO TO 7610
7491    TYPE 7492,NFILE
7492    FORMAT(' File ',A16,' not found.  You will have',/,' to enter',
     +' GENERAL PLANE information here')
      ENDIF
2014  TYPE*,'Enter SCALE for general plane maps in inches/A.  ',
     1'DEFAULT is 2.0.'
      ASSIGN 2014 TO IGO
      READ(5,3000,ERR=301)RIN
      CARD(1:14)='GENERAL        '                    
      IF(RIN.EQ.0.0)RIN=2.0
      ENCODE(6,221,CARD(9:14),ERR=301)RIN
      H=5.0
      W=5.0                ! DEFAULT HEIGHT AND WIDTH IN ANGSTROMS
      IB=15
218   TYPE 5000
      TYPE*,'Enter the THREE DIRECTION COSINES (angles between ',
     1'real cell axes and the normal to desired plane) separated ',
     2'by commas.'
      ASSIGN 218 TO IGO
      READ(5,3000,ERR=301)CXYZ
      ENCODE(21,2190,CARD(15:35),ERR=301)CXYZ
2190  FORMAT(3F7.4)
219   TYPE*,'Enter the THREE CRYSTALLOGRAPHIC COORDINATES of the ',
     1'center of the map separated by commas.'
      ASSIGN 219 TO IGO
      READ(5,3000,ERR=301)CXYZ
      ENCODE(21,2190,CARD(36:56),ERR=301)CXYZ
220   TYPE*,'Enter the MAP HEIGHT and WIDTH in Angstroms separated ',
     1'by a comma.  DEFAULT is 5.0 ANGSTROMS.'
      ASSIGN 220 TO IGO
      READ(5,3000,ERR=301)H,W
      IF(H.EQ.0.0)H=5.0
      ENCODE(6,221,CARD(57:62),ERR=301)H           ! HEIGHT    
221   FORMAT(F6.3)
      IF(W.EQ.0.0)W=5.0
      ENCODE(6,221,CARD(63:68),ERR=301)W   ! END OF HEIGHT AND WIDTH
      IB=69
      IE=IB+1
      TYPE 222
      READ(5,1)ANS(1:1)
      DO I=1,3
      IF(ANS(1:1).EQ.XYZ(I))GO TO 228
      ENDDO
      I=1
228   ENCODE(2,2002,CARD(69:70),ERR=301)I
2002  FORMAT(I2)
      IB=71
      GO TO 303
8     TYPE 5000
      TYPE *,'Do you want a TRUE SCALE (undistorted) map rather ',
     1'than a fractional scale map? Y/[N]'
      ACCEPT 1,ANS(1:1)
      IF(ANS(1:1).EQ.'Y')THEN
        TSC=9               ! SIGNAL THAT THIS IS TRUE SCALE MAP
214     TYPE*,'Enter the TRUE SCALE in inches/A.  DEFAULT ',
     1  'is 2.0.'
        ASSIGN 214 TO IGO
        READ(5,3000,ERR=301)RIN
        IF(RIN.EQ.0.0)RIN=2.0
        ENCODE(32,204,CARD(1:32),ERR=301)RIN
204     FORMAT('SCALE= ',F5.3,' INCHES PER ANGSTROM')
        TYPE 2,CARD(1:32)
        WRITE(4,1)CARD(1:32)
      ELSE
        TSC=1
216     TYPE*,'FRACTIONAL SCALE MAPS are specified by giving the ',
     1  'intervals between points in each direction in cryst. coords. ',
     2  'Enter 3 real numbers, separated by commas, for intervals in ',
     3  'X, Y, Z.'
        ASSIGN 216 TO IGO
        READ(5,3000,ERR=301)DX,DY,DZ
        ENCODE(43,217,CARD(1:43),ERR=301)DX,DY,DZ
217     FORMAT('SCALE X = ',F7.5,', Y = ',F7.5,', Z = ',F7.5)
        TYPE 2,CARD(1:43)
        WRITE (4,1)CARD(1:43)
      ENDIF
      TYPE 5000
      GOTO(2160,2161,2162),N-1   ! 3-DIM, PROJ OR SECT
2160  GP=0
      CARD(1:18)='THREE-DIMENSIONAL '
      IB=19
      TYPE*,'Enter COORDINATE to be held CONSTANT within each ',
     1'section.  DEFAULT is DOWN Z.'
      ACCEPT 1,ANS(1:1)
      IF(ANS(1:1).NE.' ')THEN
        IE=IB+4
        CARD(IB:IE)='DOWN '
        IB=IE+1
        CARD(IB:IB)=XYZ(3)         ! DEFAULT
        DO I=1,3
          IF(ANS(1:1).EQ.XYZ(I))THEN
            ENCODE(1,1,CARD(IB:IB))XYZ(I)
          ENDIF
        ENDDO
        IB=IB+1
      ENDIF
      GO TO 300            ! END EXCLUSIVELY 3-DIM SECTION
2161  GP=0
      CARD(1:16)='PROJECTION DOWN '
      IB=17
      TYPE *,'Which COORDINATE is the map projected DOWN? ANS X,Y,[Z]'
      ACCEPT 1,ANS(1:1)
      CARD(IB:IB)=XYZ(3)        ! DEFAULT IS Z
      DO I=1,3
        IF(ANS(1:1).EQ.XYZ(I))THEN
          CARD(IB:IB)=XYZ(I)
          IB=IB+1
          GO TO 300
        ENDIF
      ENDDO
      CARD(IB:IB)=XYZ(3)
      IB=IB+1
      GO TO 300
2162  GP=0
      CARD(1:8)='SECTION '
      IB=9
      TYPE 200 
200   FORMAT(' For SECTION you must specify X,Y, or Z = r.rrrrr',/,
     +' first enter X, Y, or Z for the section.')
      ACCEPT 1,ANS(1:1)
2163  TYPE *,'Now enter VALUE of coordinate X,Y, or Z for section.'
      ASSIGN 2163 TO IGO
      READ(5,3000,ERR=2163)SV
      ENCODE(1,1,CARD(IB:IB))ANS(1:1)
      IB=IB+1
      IE=IB+2
      CARD(IB:IE)=' = '
      IB=IE+1
      IE=IB+4
      ENCODE(5,226,CARD(IB:IE),ERR=2163)SV
      IB=IE+1
300   IF(IB.GT.65)THEN
        CARD(IB:IB)=','
        IB=IB+1
        IE=IB
        TYPE 2,CARD(1:IE)
        WRITE(4,1)CARD(1:IE)
        IB=5
        CARD(1:4)='    '
      ELSE
        IF(IB.GT.19.OR.N.GE.3)THEN
          IE=IB+1
          CARD(IB:IE)=', '
          IB=IB+2
        ENDIF
      ENDIF
      IF(GP.NE.9)THEN                 ! DONT DO THIS FOR GENERAL PLANE
        TYPE 222                                                     
222     FORMAT(' Do you want X,Y, or Z held CONSTANT in the HORIZONTAL'
     +  ,/,' direction? ANS [X], Y, OR Z')
        READ(5,1)ANS(1:1)
        ENCODE(1,1,CARD(IB:IB))XYZ(1)          ! X CON.HORIZ IS DEFAULT
        DO I=1,3
          IF(ANS(1:1).EQ.XYZ(I))THEN
            ENCODE(1,1,CARD(IB:IB))XYZ(I)
          ENDIF
        ENDDO
        IB=IB+1
        IE=IB+10
        CARD(IB:IE)=' CON.HORIZ.'
        IB=IE+1
      ENDIF
      IF (TSC.EQ.9.AND.CARD(1:4).EQ.'THRE')THEN
225     TYPE*,'For TRUE SCALE MAPS you may enter an increment ',
     1  'between sections. DEFAULT is a value comparable to the ',
     2  'distance between points within sections. ',
     3  'Enter increment.  Return for DEFAULT.'
        ASSIGN 225 TO IGO
        READ(5,3000,ERR=301)RDEL
        IF(RDEL.NE.0.0)THEN
          IF(IB.GT.20)THEN
            CARD(IB:IB)=','
            IB=IB+1
            IE=IB+11
          ENDIF
          CARD(IB:IE)='INCREMENT = '
          IB=IE+1
          IE=IB+4
          ENCODE(5,226,CARD(IB:IE),ERR=301)RDEL
226       FORMAT(F5.3)
          IB=IE+1
        ENDIF
      ENDIF
303   TYPE 223
223   FORMAT(' Do you want the MINIMUM PRINT option ?',/,
     +' This option specifies the minimum value to be printed.',/,
     +' Smaller densities are printed as blanks. Y/[N]')
      ACCEPT 1,ANS(1:1)
      IF(ANS(1:1).EQ.'Y')THEN
        ASSIGN 20 TO IGO
20      TYPE *,'Enter integer MINimum DENSITY.'
        READ(5,2000,ERR=301)MD
        IF(IB.GT.64)THEN
          CARD(IB:IB)=','
          TYPE 2,CARD(1:IB)
          WRITE(4,1)CARD(1:IB)
          IB=5
          CARD(1:4)='    '
        ELSE
          IF(IB.NE.5)THEN
            CARD(IB:IB)=',' 
            IB=IB+1
          ENDIF
        ENDIF
        IE=IB+9
        CARD(IB:IE)='MINPRINT = '
        IB=IE+1
        IE=IB+3
        ENCODE(4,224,CARD(IB:IE),ERR=301)MD
224     FORMAT(I4)
        IB=IE+1
      ENDIF
      TYPE *,'Do you want to enter a MAP ID?  Y/[N]'
      ACCEPT 1,ANS(1:1)
      IF(ANS(1:1).EQ.'Y')THEN
        IF (IB.GT.60)THEN
          CARD(IB:IB)=','
          TYPE 2,CARD(1:IB)
          WRITE(4,1)CARD(1:IB)
          IB=5
          CARD(1:4)='    '
        ELSE
          IF(IB.NE.5)THEN
            CARD(IB:IB)=','
            IB=IB+1
          ENDIF
        ENDIF
        TYPE *,'Enter ID up to 14 characters.'
        ACCEPT 1,ID
        IE=IB+4
        CARD(IB:IE)=' ID ='
        IB=IE+1
        IE=IB+13
        ENCODE(14,1,CARD(IB:IE))ID
      ENDIF
      TYPE 2,CARD(1:IE)
      WRITE(4,1)CARD(1:IE)
      TYPE 5000
302   type *,'Do you want the PEAK LIST option? Y/[N]'
      ACCEPT 1,ANS
7597  IF(ANS(1:1).EQ.'Y')THEN 
759    TYPE 760
760     FORMAT(' Enter the MINimum HEIGHT in printed units.',/,
     +' enter as a real number, F6.0. DEFAULT is 150.0')
        ASSIGN 759 TO IGO
        READ(5,3000,ERR=301)APL
        IF(APL.EQ.0.0)APL=150.0            ! DEFAULT HEIGHT
762     TYPE *,'Enter the MINimum DISTANCE between peaks in A.'
        TYPE *,' DEFAULT is 0.5'
        ASSIGN 762 TO IGO
        READ(5,3000,ERR=301)GX
        IF(GX.EQ.0.0)GX=0.5         ! DEFAULT DISTANCE
        TYPE*,'Do you want to create a name.PKL file of COORDS of ',
     1  'your peaks? Y/[N]'
        ACCEPT 1,ANS
        K=0
        IF(ANS(1:1).EQ.'Y')K=1
        TYPE *,'Do you want SECTION by SECTION listing? Y/[N]'
        ACCEPT 1,ANS
        IMIN=0
        IF(ANS(1:1).EQ.'Y')IMIN=1
        TYPE *,' Do you want NEGATIVE peaks? Y/[N]'
        ACCEPT 1,ANS
        IF(ANS(1:1).EQ.'Y')THEN
        TYPE *,' Enter MINimum negative PEAK HEIGHT.  DEFAULT is 150.0'
        READ(5,3000)NAPL
      IF(NAPL.EQ.0.0)NAPL=150.0
      TYPE *,' Enter MINimum DISTANCE between peaks'
      TYPE *,' DEFAULT is 0.5'
      READ(5,3000)NGX
      IF(NGX.EQ.0.0)NGX=0.5
      ENDIF
        ASSIGN 759 TO IGO
      IF(ANS(1:1).EQ.'Y')THEN
      ENCODE(39,761,CARD,ERR=301)APL,GX,K,IMIN,NAPL,NGX
      ELSE
        ENCODE(26,761,CARD,ERR=301)APL,GX,K,IMIN
      ENDIF
761     FORMAT('PEAK LIST ',F6.0,F6.3,2I2,:,1X,F6.0,F6.3)
        IE=39
      IF(NGX.EQ.0.0)IE=26
        TYPE 2,CARD(1:IE)
        WRITE(4,1)CARD(1:IE)
      ENDIF                           ! COME HERE FOR NO PEAK LIST
      IF(IPL.EQ.2)RETURN    ! IF PEAK LIST ONLY, THEN QUIT
7610  IF(OP14.NE.0)CLOSE(UNIT=14,DISP='SAVE')       ! .GEN FILE NEEDS TO BE CLOSED
       OP14=0          ! SIGNAL THAT 14 IS CLOSED
      TYPE *,'Do you want another map in this same mode? Y/[N]'
      ACCEPT 1,ANS
      IF(ANS(1:1).EQ.'Y')GO TO 7120   ! CYCLE BACK FOR ANOTHER MAP
      ENCODE(80,763,CARD)
763   FORMAT('END FOURIER')
      TYPE 2,CARD
      WRITE(4,1)CARD
      RETURN
301   TYPE 30
30    FORMAT(' There is an ERROR in your LAST INPUT. Please try again.')
      GO TO IGO
C      END
C      GO TO 762          ! WRITE 'END FOURIER'
	RETURN
	END
