      SUBROUTINE PUBLIN
C  INPUT FOR PUBLICATION LIST
1     FORMAT(A)
2     FORMAT(1X,A)
10    FORMAT(I10)
20    FORMAT(F10.6)
      CHARACTER*80 CARD,CARD1
      CHARACTER*4 ANS,char4
      CHARACTER*16 ANAM
      CHARACTER*1 CHAR1
      CHARACTER*6 ITAB
      CHARACTER*72 TITLE
      COMMON/FNAME/ANAM,NAMLEN
      CARD(1:16)='PUBLICATION LIST'
      TYPE *,' Where will you print your output: '
      TYPE *,'   [H]  HP4M Laser printer '
      TYPE *,'    T   Talaris Laser printer '
      TYPE *,'    P   Line Printer '
      ACCEPT 1,ANS
      IF(ANS(1:1).EQ.'T')THEN
        CARD(17:24)=' TALARIS'
      elseif(ans(1:1).eq.'P')then
        card(17:24)=' PRINTER'
      ELSE
        CARD(17:24)=' HP     '
      ENDIF
      TYPE 2,CARD(1:24)
      WRITE(4,1)CARD(1:24)
c DEFAULTS:
      ITEST=3  !FASTEST MOVING INDEX  1=H,2=J,3=K
      NCI=6    !# COL/INDEX
      NFO=5    !# COL/FOBS
      NOO=4
      ITH=0
c  ith=0, separate heading page?
      NFC=5    !# COL/FCALC
      NAB=0    !# COL ACALC/BCALC
      NPHI=0   !# COL PHASE<
      NSIG=4   !# COL SIGMA FOBS
      NAR=0    !# COL DELTA(F2)/SIGMA_FOB(2)
      NCOL=6   !# COL ON PAGE
      NRFC=78  !# ROWS/PAGE
      SFC=0.0  !
      SCR=10.0 !
      CUT=0.0
       TYPE*,'Do you want a separate table heading page? [Y]/N'
       ACCEPT 1,ANS
       IF(ANS(1:1).EQ.'N')THEN
         ITH=1
         GOTO 101
       ENDIF
c    create .tex heading page file
      ANAM(NAMLEN+1:NAMLEN+4)='.TEX'
      OPEN(NAME=ANAM,UNIT=12,TYPE='NEW',FORM='FORMATTED')
      TYPE 210,ANAM
      TYPE 211,ANAM
210   FORMAT (' Heading page will be output in ',16A)
211   FORMAT (' Type DOTEX ',16A,' -- to print.')
      WRITE(12,21)
c
c  get rid of this; copy a version of pub.tex to CRYM somewhere
21    FORMAT(' \input pub:pub \cret')
c
      WRITE(12,2119)
2119  FORMAT('\hsize=6.5truein\null\vskip 2.0 truein')
      TYPE*,' Enter table number (i.e., "II.").'
      ACCEPT 1,ITAB
      WRITE(12,22)ITAB
22    FORMAT(' {\bf{\centerline {Table ',A6,' ')
c101   if(card(17:20).ne.' HP ') then
101        TYPE*,' What is the name of the compound--72 chars and spaces ma
     1x'
C23456789 123456789 123456789 123456789 123456789 123456789 123456789 123456
        type*,'123456789 123456789 123456789 123456789 123456789 1234567
     189 123456789 12'
        ACCEPT 1,title
        card1(1:72)=title
c      else
c        Type*,' What is the name of the compound--65 chars and spaces ma
c     1x'
c        type*,'123456789 123456789 123456789 123456789 123456789 1234567
c     189 12345'
c        ACCEPT 1,title(1:65)
c        card1(1:65)=title(1:65)
c        card1(66:72)='       '    
c      endif
      IF(ITH.EQ.0)WRITE(12,23)TITLE
23    FORMAT(' Observed and Calculated Structure Factors for }}',/
     1'\vskip 10pt {\centerline {'/a72/'}}}\litpar')
c
c  DATA card here
c
      TYPE*,'For data card, is H, K or L the fastest moving index?  ',
     1'enter "H", "K" OR "[L]".'
      ACCEPT 1,CHAR1
      char4='\ell'
      IF(CHAR1.EQ.'H')THEN
        CHAR4='h   '
        ITEST=1
      endif
      IF(CHAR1.EQ.'K')then
        char4='k   '
        ITEST=2
      endif
      IF(ITH.EQ.0)WRITE(12,24)CHAR4
24    FORMAT(' The columns contain, in order, $',a4,'$\/, ')
      TYPE*,'Do you need any other info on the data card? Y/[N]  ',
     1'DEFAULTS are:'
      TYPE*,'print H,K,L,F(OBS),F(CALC) (UNSIGNED), SIG',
     1'(FOBS)'
      TYPE*,'Number of columns per index is 6                    ',
     4'Number of columns for F(OBS) and F(CALC) is 5                 ',
     5'Number of columns for SIGMA(FOBS) is 4     ',
     6'Number of columns of reflections per page is 6 (maximum on 8',
     7' inches of printout.',
     8'Number of lines per columns is 78                             ',
     9'Scale factor is taken from HKL file                           ',
     1'Printing scale is 10.0                                        ',
     2'No cutoff for SIN(THETA)/LAMBDA**2                       '
      ACCEPT 1,ANS
      IF(ANS(1:1).NE.'Y'.AND.N.EQ.3)GOTO 111
      IF(ANS(1:1).NE.'Y')GOTO 1091
102   TYPE*,'Do you want to print'
      TYPE*,' 1) H,K,L,FOBS,FCALC'
      TYPE*,' 2) H,K,L,FOBS,FCALC,ACALC,BCALC'
      TYPE*,' 3) H,K,L,FOBS,FCALC,PHASE ANGLE'
      TYPE*,' 4) H,K,L,FOBS,FCALC,SIGMA(FOBS)'
      TYPE*,' 5) H,K,L,FOBS,FCALC,DELTA(F**2)/SIGMA(FOBS**2)'
      TYPE*,'Enter number of desired option.'
      READ(5,10,ERR=901)NOO
      IF(NOO.LT.1.OR.NOO.GT.5)THEN
      TYPE*,'No such output option - TRY AGAIN.'
      GOTO 102
      ENDIF
103   TYPE*,'Enter number of columns per index - RETURN for DEFAULT of',
     1' 4.'
      READ(5,10,ERR=902)NCI
      TYPE*,'Enter number of columns for FOBS - RETURN for DEFAULT of',
     1' 5.'
      READ(5,10,ERR=902)NFO
      NFC=5
      IF(NFO.NE.0)NFC=NFO
      TYPE*,'Enter number of columns for FCALC.'
      IF(NOO.NE.2.AND.NOO.NE.3)TYPE*,'Negative for FCALC to be signed.'
      TYPE 104,NFC
104   FORMAT(' Return for DEFAULT of ',I2)
      READ(5,10,ERR=902)NFC
      NAB=0
      NPHI=0
      NRA=0
      GOTO(109,105,106,107,108)NOO
105   TYPE*,'Enter number of columns for ACALC and BCALC.  NO default',
     1' - must be nonzero.'
      READ(5,10,ERR=903)NAB
      GOTO 109
106   TYPE*,'Enter number of columns for phase angle.  NO default - ',
     1'must be nonzero.'
      READ(5,10,ERR=904)NPHI
      GOTO 109
107   TYPE*,'Enter number of columns for SIGMA(FOBS) - RETURN for ',
     1      'DEFAULT of 4'
      NSIG=4
      READ(5,10,ERR=905)NSIG
      GOTO 109
108   TYPE*,'Enter number of columns for DELTA(F**2)/SIGMA(FOBS**2).',
     1'no default - must be nonzero.'
      READ(5,10,ERR=906)NAR
109   TYPE*,'Enter number of columns of reflections per page.  RETURN',
     1'for default of maximum possible on 8 inches of printout.'
      READ(5,10,ERR=907)NCOL
      TYPE*,'Enter number of lines per column.  RETURN for default of ',
     1'78.'
      READ(5,10,ERR=907)NRFC
      TYPE*,'Enter scale factor.  RETURN if you want scale factor ',
     1'taken from HKL file.'
      READ(5,20,ERR=907)SFC
      TYPE*,'Enter printing scale.  RETURN for default of 10.0'
      READ(5,20,ERR=907)SCR
      IF(SCR.EQ.0.0)SCR=10.0
      TYPE*,'Enter SIN(THETA)**2/LAMBDA**2 maximum cutoff.  RETURN if ',
     1'no cutoff.'
      READ(5,20,ERR=907)CUT
1091  ENCODE(80,110,CARD,ERR=901)ITEST,NCI,NFO,NFC,NAB,NPHI,NSIG,NAR,
     1NCOL,NRFC,SFC,SCR,CUT
110   FORMAT('COLUMN',1X,I3,I2,7I3,I4,2F6.2,F8.5)
      TYPE 2,CARD(1:57)
      WRITE(4,1)CARD(1:57)
111   TYPE*,'Do you want to print page numbers? [Y]/N'
      ACCEPT 1,ANS
      IF(ANS(1:1).NE.'N')THEN
        ANS='Page'
      ELSE
        ANS='    '
      ENDIF
      card1(73:76)=ans
      TYPE 2,CARD1(1:76)
      WRITE(4,1)CARD1(1:76)
      if(ith.ne.0)return
      IB=B
      IF(IB.EQ.0)IB=10
      if(noo.eq.1)write(12,25)IB,IB
25    format(I5,'$F_{obs}$ and ',I4,'$F_{calc}$.')
      if(noo.eq.2)write(12,26)IB,IB,IB,IB
26    format(I5,'$F_{obs}$, ',I4,'$F_{calc}$, ',I4,'$A_{calc}$',
     1' and ',I4,'$B_{calc}$.')
      if(noo.eq.3)write(12,27)IB,IB
27    format(I5,'$F_{obs}$, ',I4,'$F_{calc}$ and the phase angle.')
      if(noo.eq.4)write(12,28)IB,IB,IB
28    format(I5,'$F_{obs}$, ',I4,'$F_{calc}$ and ',I4,
     1'$\sigma F_{obs}$.')
      if(noo.eq.5)write(12,29)IB,IB,IB
29    format(I5,'$F_{obs}$, ',I4,'$F_{calc}$ and ',I4,
     1'$\left({{F_{obs}^2-F_{calc}^2}\over{\sigma F_{obs}^2}}\right)$.')
      WRITE(12,30)
30    FORMAT(' A minus sign preceding $F_{obs}$ indicates that',
     1' $F^2_{obs}$ is negative.  \par \vfill \end')
      RETURN
999   FORMAT(' ERROR ON LAST CARD ENTERED - TRY AGAIN.')
901   TYPE 999
      GOTO 102
902   TYPE 999
      GOTO 103
903   TYPE 999
      GOTO 105
904   TYPE 999
      GOTO 106
905   TYPE 999
      GOTO 107
906   TYPE 999
      GOTO 108
907   TYPE 999
      GOTO 109
      END
