c
c    program to generate file for cad-4 for data collection
c    limited options
c     reads a .bad file
c     writes name.HKL file for input as FILHKL in CAD4 system
c     DATHKL must be used to reset counter on CAD4 at sometime  
c     .out is a single listing of reflections redone
c
      integer nh(10000),k(10000),l(10000),nforms(8,3)
      character*132 line
c      call assign (1,'cad4redo.hkl')
      define file 1 (32000,8,u,ipnt)
      call fdbset (1,'NEW')
      open(6,status='new',carriagecontrol='list')
      ipnt=1
      psi=0.0
      WRITE(*,'('' Minimum GOF to repeat? [3.0]'')')      
      read(5,'(f5.0)')gofmin
      if (gofmin .eq. .0) gofmin=3.0
      if (gofmin .lt. .0) gofmin=0.0
      write(6,100) gofmin
  100 format(' gof minimum =',f10.2)
      WRITE(*,'('' Repeat each reflection how many times [1]/n ? '')')      
      read(5,'(i3)')ntimes
      if (ntimes.le.0) ntimes=1
      nforms(1,1)=1
      nforms(1,2)=1
      nforms(1,3)=1
      WRITE(*,'('' Number of forms to redo (exclude identity)? [1]'')')
      WRITE(*,'('' A negative value does only one form, read in'')')
      read(5,'(i3)')nple
      if (nple.eq.0) nple=1
      if (nple.lt.0) nple=0
      nple=nple+1
      if(nple.ne.1) then 
       do i=2,nple
        WRITE(*,'('' 3 sign multipliers for a form (e.g. 1,-1,1)? '')')      
        read(5,*) (nforms(i,j),j=1,3)
       enddo
      else
        WRITE(*,'('' 3 sign multipliers for a form (e.g. 1,-1,1)? '')')      
        read(5,*) (nforms(1,j),j=1,3)
      endif
      open(UNIT=14,STATUS='OLD',carriagecontrol='list')
      nc=0
    3 READ(14,2,end=7) line
    2 FORMAT(a132)
      if (line(22:22).ne.'*' .and. line(22:22).ne.'#'
     1    .and. line(22:22).ne.'1') goto 3
      decode(132,4,line)gof,nhh,kk,ll,f,sig,n
    4 format(1x,f6.0,3i4,3x,f7.2,f5.1,10x,i3)
      if (gof.lt.gofmin .and. gof.ne.0.0) goto 3
      nc=nc+1
      nh(nc)=nhh
      k(nc)=kk
      l(nc)=ll
      go to 3
    7 continue
c
c   add sort
c
      do m=1,nple
      do j=1,nc
       h=nh(j)*nforms(m,1)
       rk=k(j)*nforms(m,2)
       rl=l(j)*nforms(m,3)
        do i=1,ntimes
         write (1'ipnt)h,rk,rl,psi
        enddo
        write(6,5) h,rk,rl,psi
       enddo
      enddo
    5 format(4f5.1)
      call close(1)
      stop
      end                  
