      PROGRAM CIFTAB
      CHARACTER*1 CR,ESC,AMP,OPT,KS
      CHARACTER*7 SYO(512)
      CHARACTER*25 SYM(192)
      CHARACTER*32 CDN(500),CSS(40),COD,CIFDIR,DATB
c******
      CHARACTER*80 IS,IR,IW,CDS(500),CSV(40),more(100)
      INTEGER LDS(500),LSS(40),NCOL(40),MLT(40),moreind(20,2),
c******
     +MSG(40),LSV(40),NS(50),IG(30),IH(800),IK(800),IL(800),
     +IO(800),IC(800),IE(800),IP(4)
      COMMON LDS,LSS,LSV,NCOL,MLT,MSG,NCD,LS,NSS,LB,LC,LO,LU,MC,MX
      COMMON/CBUF/IR,IS,IW,CDS,CDN,CSS,CSV,DATB,CR,ESC,AMP
      COMMON/CSYM/SYM,SYO
      COMMON/ISYM/NSY
      COMMON/CSFT/IG,IH,IK,IL,IO,IC,IE
c******
      common/text/more,moreind
c******
   1  FORMAT(A)
   2  FORMAT(/' CIFTAB - Tables from shelxl CIF files ',
     +'- Structure Code: ',A//' [S] Change structure code'/
     +' [R] Use another CIF file to resolve ? items'/
     +' [C] Set compound code number for tables (currently ',I3,')'/
     +' [N] Set next table number (currently ',I3,')'/
     +' [T] Crystal/atom tables from .cif'/
     +' [F] Structure factor tables from .fcf'/' [Q] Quit')
C
C Possibly system-dependent constants.  CIFDIR is the name of the
C directory to be searched if the format files are not in the current
C directory.  LC, LO and LR are I/O unit numbers.  ESC and AMP are the
C ASCII codes for carriage return, escape and ampersand resp.  CR should
C be set to CHAR(13) to write DOS format files from a UNIX system,
C otherwise to 32.  The structure factor tables are always written in
C local format.  LU is used to convert upper to lower case.
C
C
      CIFDIR='[]'
      LC=1
      LO=2
      LR=3
      ESC=CHAR(27)
      AMP=CHAR(38)
      CR=CHAR(32)
      LU=ICHAR('a')-ICHAR('A')
C
C Main menu - request option
C
      OPT='S'
      COD='? '
      MC=1
      MX=1
      GOTO 6
   3  CLOSE(LR,IOSTAT=I)
      CLOSE(LC,IOSTAT=I)
      CLOSE(LO,IOSTAT=I)
   4  CALL CLS
   5  L=INDEX(COD,' ')-1
      IF(OPT.EQ.'F')OPT='Q'
      IF(OPT.EQ.'T')OPT='F'
      IF(OPT.EQ.'N')OPT='T'
      IF(OPT.EQ.'C')OPT='N'
      IF(OPT.EQ.'R')OPT='C'
      IF(OPT.EQ.'S')OPT='R'
      IF(OPT.EQ.'?')OPT='S'
      WRITE(*,2)COD(1:L),MC,MX
      CALL GETANS('Option',OPT)
      IF(OPT.GE.'a')OPT=CHAR(ICHAR(OPT)-LU)
      IF(OPT.NE.'S')GOTO 7
   6  CALL GETANS('Input new structure code (first part of '//
     +'filename)',COD)
      GOTO 4
   7  IF(OPT.NE.'C')GOTO 8
      WRITE(*,'(/A)')' Input new compound number for tables: '
      READ(*,*,ERR=7)MC
      GOTO 4
   8  IF(OPT.NE.'N')GOTO 9
      WRITE(*,'(/A)')' Input number of next table (for title): '
      READ(*,*,ERR=7)MX
      GOTO 4
C
C Resolve simple '?' items by reference to another .cif file
C
   9  IF(OPT.NE.'R')GOTO 36
      IS=COD(1:L)//'.xcf'
      CALL GETANS('Name of reference file',IS)
      CALL CIFIN(IS,KS)
      IF(KS.EQ.'N')GOTO 13
      IS=COD(1:L)//'.cif'
      CALL GETANS('Name of CIF file to be modified',IS)
      L=INDEX(IS,' ')-1
      IF(L.LE.0)GOTO 12
      OPEN(LR,FILE=IS(1:L),STATUS='OLD',ERR=12)
      OPEN(LO,STATUS='SCRATCH',FORM='UNFORMATTED',ERR=13)
  10  READ(LR,'(A)',END=11,ERR=11)IR
      I=INDEX(IR,CHAR(13))
      IF(I.GT.0)IR(I:I)=' '
      WRITE(LO)IR
      GOTO 10
  11  CLOSE(LR,STATUS='DELETE',IOSTAT=I)
      OPEN(LR,FILE=IS(1:L),STATUS='NEW',ERR=12)
      REWIND LO
      GOTO 15
  12  WRITE(*,'(/A)')' ** cannot open CIF file **'
  13  CLOSE(LC,IOSTAT=I)
      CLOSE(LR,IOSTAT=I)
      CLOSE(LO,IOSTAT=I)
      GOTO 5
C
C Select appropriate data_ set
C
  14  WRITE(*,'(/A)')' ** (Next) data_ not found before eof **'
      GOTO 13
  15  READ(LO,END=14)IS
      LS=0
        DO 16 I=1,80
        IF(IS(I:I).GE.'A'.AND.IS(I:I).LE.'Z')IS(I:I)=
     +  CHAR(ICHAR(IS(I:I))+LU)
        IF(IS(I:I).NE.' ')LS=I
  16    CONTINUE
      WRITE(LR,'(A)')IS(1:LS)//CR
      K=INDEX(IS(1:LS),'data_')
      IF(K.EQ.0)GOTO 15
  17  KS='Y'
      CALL GETANS('Select '//IS(K:LS)//' ? (Y or N)',KS)
      IF(KS.GE.'a')KS=CHAR(ICHAR(KS)-LU)
      IF(KS.EQ.'N')GOTO 15
      IF(KS.NE.'Y')GOTO 17
      IXT=0
      IFL=0
      GOTO 19
C
C Copy back CIF file, identify non-looped '?' items
C
  18  WRITE(LR,'(A)')IS(1:L)//CR
  19  READ(LO,END=3)IS
      IF(IS(1:1).EQ.';')IXT=1-IXT
      LS=0
      K=0
      J=0
      M=0
      N=0
      L=1
        DO 20 I=1,80
        KS=IS(I:I)
        IF(KS.EQ.'''')M=1-M
        IF(KS.EQ.'_'.AND.M.EQ.0.AND.J.EQ.0)J=I
        IF(KS.EQ.'?'.AND.M.EQ.0)N=I
        IR(I:I)=KS
        IF(KS.GE.'A'.AND.KS.LE.'Z')IR(I:I)=CHAR(ICHAR(KS)+LU)
        IF(KS.EQ.' ')GOTO 20
        L=I
        K=K+1
  20    CONTINUE
      IF(IXT.EQ.0)GOTO 21
      IF(K.NE.1)GOTO 18
      GOTO 22
  21  IF(INDEX(IS,'loop_').NE.0)IFL=1
      IF(J.EQ.0)GOTO 22
      IF(IFL.LT.0)IFL=0
      LS=INDEX(IR(J+1:80),' ')
      IW=IR(J:J+LS-1)
      GOTO 23
  22  IFL=-IABS(IFL)
  23  IF(N.EQ.0)GOTO 18
      IF(IFL.NE.0)GOTO 18
C
C Update '?' items if possible
C
        DO 24 I=1,NCD
        IF(IW(1:32).EQ.CDN(I))GOTO 25
  24    CONTINUE
      GOTO 18
  25  IF(LDS(I).EQ.0)GOTO 27
      IW=IS(N+1:80)
      IS(N:80)=CDS(I)(1:IABS(LDS(I)))//IW
      L=0
        DO 26 I=N,80
        IF(IS(I:I).NE.' ')L=I
  26    CONTINUE
      IF(INDEX(IS(N:80),' ').EQ.L-N+2)GOTO 18
      WRITE(LR,'(A)')IS(1:N-1)//''''//IS(N:L)//''''//CR
      GOTO 19
  27  IF(J.NE.0)WRITE(LR,'(A)')IS(1:N-1)//CR
      IF(IXT.EQ.0)WRITE(LR,'(A)')';'//CR
      REWIND LC
  28  CALL NEXT
      IF(IS(1:32).NE.DATB)GOTO 28
  29  CALL NEXT
      IF(IS.NE.IW)GOTO 29
  30  READ(LC,'(A)')IS
      I=INDEX(IS,CHAR(13))
      IF(I.GT.0)IS(I:I)=' '
      IF(IS(1:1).NE.';')GOTO 30
        DO 31 I=2,80
        IF(IS(I:I).NE.' ')GOTO 32
  31    CONTINUE
      GOTO 35
  32  IS(1:1)=' '
  33  L=1
        DO 34 I=1,80
        IF(IS(I:I).NE.' ')L=I
  34    CONTINUE
      WRITE(LR,'(A)')IS(1:L)//CR
  35  READ(LC,'(A)')IS
      I=INDEX(IS,CHAR(13))
      IF(I.GT.0)IS(I:I)=' '
      IF(IS(1:1).NE.';')GOTO 33
      IF(IXT.EQ.0)WRITE(LR,'(A)')';'//CR
      GOTO 19
C
C Prepare tables of crystal data, atoms, bond lengths and angles etc.
C Change 'PRN' below and in subroutine CIFOUT to name by which the
C system printer is known.
C
  36  IF(OPT.NE.'T')GOTO 136
      IS=COD(1:L)//'.cif'
      CALL GETANS('Name of CIF file',IS)
      CALL CIFIN(IS,KS)
      IF(KS.EQ.'N')GOTO 5
      IS=COD(1:L)//'.tex'
      CALL GETANS('Printer (PRN) or filename for tables',IS)
      CALL CIFOUT(LO,IS,KS)
      IF(KS.EQ.'N')GOTO 5
      IS='def'
      WRITE(*,'(/A)')' Format definition file ciftab.def; use '
     +//'other extensions for local versions.'
      WRITE(*,'(/A)')
     +' To create a file for input to Siemens SHELXTL XTEXT answer:'
      WRITE(*,'(A)')
     +' ang (Angstroms), met (metric) or ger (German and metric)'
      CALL GETANS('Filename extension for ciftab.??? format '//
     +'definition file',IS)
      L=INDEX(IS,' ')-1
        DO 37 I=1,L
        KS=IS(I:I)
        IF(KS.LE.'Z'.AND.KS.GE.'A')IS(I:I)=CHAR(ICHAR(KS)+LU)
  37    CONTINUE
      OPEN(LR,FILE='ciftab.'//IS(1:L),STATUS='OLD',ERR=38)
      GOTO 40
  38  K=INDEX(CIFDIR,' ')-1
      OPEN(LR,FILE=CIFDIR(1:K)//'ciftab.'//IS(1:L),STATUS='OLD'
     +,ERR=39)
      GOTO 40
  39  WRITE(*,'(/A)')' ** Cannot open format file ciftab.'//IS(1:L)
     +//' **'
      GOTO 13
C
C Initialize tables
C
  40  IXT=0
      IDT=0
      NSO=0
      IRH=-1
      IBR=1
      IFL=1
C
C Analyse special directives
C
      NBL=0
  41  LOOP=0
      NSS=0
      NT=0
  42  IR=' '
      READ(LR,1,END=3)IR
      I=INDEX(IR,CHAR(13))
      IF(I.GT.0)IR(I:I)=' '
      IF(IR(1:1).NE.'?')GOTO 46
  43  M=2
        DO 44 I=1,80
        IF(IR(I:I).NE.' ')M=I
  44    CONTINUE
      KS='Y'
      CALL GETANS(IR(2:M),KS)
      IF(KS.GE.'a')KS=CHAR(ICHAR(KS)-LU)
      IF(KS.EQ.'Y')GOTO 42
  45  READ(LR,1,END=3)IR
      I=INDEX(IR,CHAR(13))
      IF(I.GT.0)IR(I:I)=' '
      IF(IR(1:1).NE.'?')GOTO 45
      GOTO 43
  46  IF(IR(1:1).NE.'$')GOTO 57
        DO 47 I=2,80
        IF(IR(I:I).GE.'A'.AND.IR(I:I).LE.'Z')IR(I:I)=
     +  CHAR(ICHAR(IR(I:I))+LU)
  47    CONTINUE
      IF(INDEX(IR,'xtext').NE.0)IXT=1
      IF(INDEX(IR,'deutsch').NE.0)IDT=1
      IF(INDEX(IR,'h=none').NE.0)IRH=-1
      IF(INDEX(IR,'h=free').NE.0)IRH=0
      IF(INDEX(IR,'h=all').NE.0)IRH=1
      IF(INDEX(IR,'h=only').NE.0)IRH=2
      IF(INDEX(IR,'brack').NE.0)IBR=1
      IF(INDEX(IR,'nobrack').NE.0)IBR=0
      IF(INDEX(IR,'flag').NE.0)IFL=1
      IF(INDEX(IR,'noflag').NE.0)IFL=0
C
C Output symmetry operators
C
      M=INDEX(IR,'symops')+6
      IF(M.EQ.6)GOTO 42
      CALL RINT(M,NJ)
      M=NJ-1
      IR=' '
        DO 56 I=1,NSO
        READ(SYO(I),'(I3,1X,3I1)')IP
        IF(M.LT.55)GOTO 48
        WRITE(LO,'(A)')IR(1:M)//CR
        IR=' '
        M=NJ-1
  48    M=M+1
        IR(M:M)='#'
        WRITE(IW,'(I4)')I
          DO 49 K=1,4
          IF(IW(K:K).EQ.' ')GOTO 49
          M=M+1
          IR(M:M)=IW(K:K)
  49      CONTINUE
        M=M+1
        IW(1:25)=SYM(IP(1))
        K=2
          DO 55 L=1,25
          IF(L.EQ.25)GOTO 50
          IF(IW(L:L).NE.',')GOTO 54
  50      IF(IR(M-1:M-1).EQ.'/')GOTO 51
          IF(IP(K).EQ.5)GOTO 53
          WRITE(KS,'(I1)')IABS(IP(K)-5)
          IR(M+1:M+1)='+'
          IF(IP(K).LT.5)IR(M+1:M+1)='-'
          M=M+2
          IR(M:M)=KS
          GOTO 53
  51      READ(IR(M-2:M),'(I1,1X,I1)')J,N
          IF(IR(M-3:M-3).EQ.'-')J=-J
          J=J+N*(IP(K)-5)
          IR(M-3:M-3)='+'
          IF(J.LT.0)IR(M-3:M-3)='-'
          J=IABS(J)
          IF(J.LT.10)GOTO 52
          M=M+1
          WRITE(IR(M-3:M),'(I2,A1,I1)')J,'/',N
          GOTO 53
  52      WRITE(IR(M-2:M),'(I1,A1,I1)')J,'/',N
  53      K=K+1
  54      IF(IW(L:L).EQ.' ')GOTO 55
          M=M+1
          IR(M:M)=IW(L:L)
  55      CONTINUE
        M=M+4
  56    CONTINUE
      IF(M.GT.0)WRITE(LO,'(A)')IR(1:M)//CR
      GOTO 42
C
C Construct request list for one text line
C
  57  IF(INDEX(IR,'____').EQ.0)GOTO 59
      M=1
        DO 58 I=1,80
        IF(IR(I:I).NE.' ')M=I
  58    CONTINUE
      WRITE(LO,1)IR(1:M)//CR
      GOTO 42
  59  IF(NBL.EQ.0)GOTO 61
      NBL=0
        DO 60 I=1,80
        IF(IR(I:I).NE.' ')GOTO 61
  60    CONTINUE
      GOTO 42
  61  MT=0
      I=0
      IF(IR(1:5).NE.'loop_')GOTO 62
      LOOP=1
      I=5
  62  I=I+1
      IF(I.GT.80)GOTO 75
      IF(IR(I:I).NE.'_')GOTO 69
  63  IF(I.EQ.80)GOTO 42
      IF(IR(I+1:I+1).EQ.' ')GOTO 42
      NT=NT+1
      NSS=NSS+1
      IF(NSS.GT.40)GOTO 135
      CSS(NSS)=' '
      LSS(NSS)=0
      LSV(NSS)=-1
      NCOL(NSS)=0
      MLT(NSS)=0
      MSG(NSS)=20
      MT=0
      K=0
      M=1
      I=I-1
  64  I=I+1
      IF(I.GT.80)GOTO 135
      IF(IR(I:I).EQ.'>')GOTO 65
      IF(IR(I:I).EQ.'<')GOTO 66
      IF(IR(I:I).EQ.':')GOTO 67
      IF(IR(I:I).EQ.'=')GOTO 68
      IF(IR(I:I).EQ.' ')GOTO 62
      K=K+1
      CSS(NSS)(K:K)=IR(I:I)
      LSS(NSS)=K
      GOTO 64
  65  M=-1
  66  CALL RINT(I,N)
      NCOL(NSS)=M*N
      IF(I.GT.80)GOTO 62
      IF(IR(I:I).EQ.'=')GOTO 68
      IF(IR(I:I).NE.':')GOTO 62
  67  CALL RINT(I,MLT(NSS))
      LSV(NSS)=1
      IF(IR(I:I).EQ.'>')GOTO 65
      IF(IR(I:I).EQ.'<')GOTO 66
      IF(IR(I:I).NE.'=')GOTO 62
  68  CALL RINT(I,MSG(NSS))
      IF(IR(I:I).EQ.'>')GOTO 65
      IF(IR(I:I).EQ.'<')GOTO 66
      IF(IR(I:I).EQ.':')GOTO 67
      GOTO 62
  69  NSS=NSS+1
      IF(NSS.GT.40)GOTO 135
      CSS(NSS)=' '
      LSS(NSS)=-1
      CSV(NSS)=' '
      NCOL(NSS)=0
      MLT(NSS)=0
  70  IF(IR(I:I).NE.CHAR(92))GOTO 71
      CALL RINT(I,N)
      IR(I:I)=CHAR(N)
  71  IF(MT.GE.128)GOTO 72
      MT=MT+1
      CSV(NSS)(MT:MT)=IR(I:I)
      LSV(NSS)=-MT
  72  IF(I.GE.80)GOTO 74
      I=I+1
      IF(IR(I:I).EQ.'_')GOTO 63
      GOTO 70
  73  MT=MT-1
      LSV(NSS)=-MT
  74  IF(CSV(NSS)(MT:MT).NE.' ')GOTO 75
      IF(MT.GT.1)GOTO 73
      NSS=NSS-1
C
C Search list for non-looped CIF data names
C
  75  IF(LOOP.NE.0)GOTO 102
      NBL=0
        DO 101 M=1,NSS
        IF(LSS(M).LT.0)GOTO 101
        IF(CSS(M)(2:6).NE.'tabno')GOTO 77
        WRITE(IS,'(I8)')MX
        J=0
          DO 76 I=1,8
          IF(IS(I:I).EQ.' ')GOTO 76
          J=J+1
          CDS(2)(J:J)=IS(I:I)
  76      CONTINUE
        LDS(2)=J
        MX=MX+1
  77      DO 78 N=1,NCD
          IF(CDN(N).EQ.CSS(M))GOTO 79
  78      CONTINUE
        IF(CSS(M)(12:30).EQ.'abs_structure_flack')GOTO 80
        IF(CSS(M)(8:28).EQ.'absorp_correction_t_m')GOTO 80
        IF(CSS(M)(12:26).EQ.'extinction_coef')GOTO 80
        WRITE(*,'(/A)')' ** '//CSS(M)(1:LSS(M))//' not found **'
        GOTO 13
C
C Deal with special cases
c  somewhere below put in xtext stuff as special case   
C
  79    continue
        if(css(m)(1:23).eq.'_refine_special_details') then
         do i=moreind(1,1),moreind(1,2) 
         write(lo,1012) more(i)
 1012    format(5x,a80)
         enddo
        endif
        if(css(m)(1:21).eq.'_geom_special_details') then
         do i=moreind(2,1),moreind(2,2) 
         write(lo,1012) more(i)
         enddo
        endif
        continue
        IF(CDS(N)(1:4).NE.'?   ')GOTO 81
        IF(CSS(M)(12:26).EQ.'extinction_coef')GOTO 80
        IF(CSS(M)(8:27).NE.'absorpt_correction_t')GOTO 81
  80    NBL=1
        GOTO 41
  81    IW(1:32)=CDN(N)
        IS=CDS(N)
        IR=IS
        LS=LDS(N)
        L=LS
        IF(IXT.EQ.0)GOTO 90
        IF(IW(1:30).NE.'_symmetry_space_group_name_h-m')GOTO 86
        LS=0
        I=0
  82    I=I+1
        IF(I.GT.L)GOTO 100
        IF(IR(I:I).EQ.' ')GOTO 82
        IF(IR(I:I).NE.'-')GOTO 83
        LS=LS+7
        IS(LS-6:LS)=AMP//'^-'//AMP//'0'//AMP//'B'
        GOTO 82
  83    IF(IR(I:I).NE.')')GOTO 84
        LS=LS+2
        IS(LS-1:LS)=AMP//'0'
        GOTO 82
  84    IF(IR(I:I).NE.'(')GOTO 85
        LS=LS+2
        IS(LS-1:LS)=AMP//'v'
        GOTO 82
  85    LS=LS+1
        IS(LS:LS)=IR(I:I)
        GOTO 82
  86    IF(IW(1:21).NE.'_chemical_formula_sum')GOTO 90
        LS=0
        K=0
        I=0
  87    I=I+1
        IF(I.GT.L)GOTO 100
        IF(IR(I:I).NE.' ')GOTO 88
        IF(K.EQ.0)GOTO 87
        LS=LS+2
        IS(LS-1:LS)=AMP//'0'
        K=0
        GOTO 87
  88    IF(K.EQ.1)GOTO 89
        IF(IR(I:I).GT.'9'.OR.IR(I:I).LT.'0')GOTO 89
        LS=LS+2
        IS(LS-1:LS)=AMP//'v'
        K=1
  89    LS=LS+1
        IS(LS:LS)=IR(I:I)
        GOTO 87
  90    IF(IW(8:30).NE.'absorpt_correction_type')GOTO 92
        KS=IS(1:1)
        IF(KS.GE.'a')IS(1:1)=CHAR(ICHAR(KS)-LU)
        IF(IS(1:9).NE.'Empirical')GOTO 91
        IS(1:29)='Semi-empirical from psi-scans'
        LS=29
        IF(IXT.NE.0)IS(21:23)=AMP//'Gu'
        IF(IDT.EQ.0)GOTO 100
        IS(1:19)='Semiempirische aus'
        GOTO 100
  91    IF(IS(1:7).NE.'Refdelf')GOTO 94
        IS(1:18)='Empirical (SHELXA)'
        IF(IDT.NE.0)IS(7:9)='sch'
        LS=18
        GOTO 100
  92    IF(IW(9:22).NE.'ls_matrix_type')GOTO 94
        IF(IS(1:4).NE.'full')GOTO 100
        IF(IS(5:9).NE.'cycle')GOTO 93
        IS='Full-matrix-block'
        LS=17
        IF(IDT.EQ.0)GOTO 100
        IS='Vollmatrix-Block'
        LS=16
        GOTO 100
  93    IF(LS.NE.4)GOTO 100
        IS='Full-matrix'
        LS=11
        IF(IDT.EQ.0)GOTO 100
        IS='Vollmatrix'
        LS=10
        GOTO 100
  94    IF(IW(1:22).NE.'_symmetry_cell_setting')GOTO 99
        KS=IS(1:1)
        IF(KS.GE.'a')IS(1:1)=CHAR(ICHAR(KS)-LU)
        IF(IDT.EQ.0)GOTO 99
        IF(IS(1:4).NE.'Tric')GOTO 95
        IS(4:7)='klin'
        LS=7
        GOTO 100
  95    IF(IS(1:4).NE.'Mono')GOTO 96
        IS(5:8)='klin'
        LS=8
        GOTO 100
  96    IF(IS(1:4).NE.'Orth')GOTO 97
        IS(12:14)='sch'
        LS=14
        GOTO 100
  97    IF(IS(1:4).NE.'Rhom')GOTO 98
        IS(7:13)='edrisch'
        LS=13
        GOTO 100
  98    IF(IS(1:4).NE.'Cubi')GOTO 99
        IS='Kubisch'
        LS=7
  99    IF(IW(1:11).NE.'_cell_angle')GOTO 100
        K=INDEX(IS,'0.00 ')
        IF(K.NE.0)LS=K
 100    LSV(M)=ISIGN(MAX0(1,LS),LSV(M))
        CSV(M)=IS
 101    CONTINUE
      CALL LINOUT
      GOTO 41
C
C Seach name.cif for looped CIF data names
C
 102  REWIND LC
 103  CALL NEXT
      IF(LS.EQ.0)GOTO 103
      IF(IS(1:32).NE.DATB)GOTO 103
 104  CALL NEXT
      IF(LS.LT.0)GOTO 134
      IF(LS.EQ.0)GOTO 104
      IF(IS(1:5).EQ.'data_')GOTO 134
      IF(IS(1:5).NE.'loop_')GOTO 104
        DO 105 I=1,50
        NS(I)=0
 105    CONTINUE
      NHIT=0
      NFLG=0
      NHFL=0
      NRFL=0
      NL=0
        DO 106 I=1,4
        IP(I)=0
 106    CONTINUE
 107  CALL NEXT
      IF(LS.LT.0)GOTO 110
      IF(IS(1:1).NE.'_')GOTO 110
      NL=NL+1
      IF(INDEX(IS(1:LS),'_publ_flag').NE.0)NFLG=NL
      IF(IS(1:LS).EQ.'_atom_site_type_symbol')NHFL=NL
      IF(IS(1:LS).EQ.'_atom_site_refinement_flags')NRFL=NL
      M=INDEX(IS,'_site_symmetry_')
      IF(M.EQ.0)GOTO 108
      READ(IS(M+15:M+15),'(I1)')M
      IF(M.GT.4)GOTO 108
      IP(M)=NL
 108    DO 109 M=1,NSS
        IF(LSS(M).LT.0)GOTO 109
        IF(IS(1:LS).NE.CSS(M)(1:LSS(M)))GOTO 109
        NS(NL)=M
        NHIT=NHIT+1
 109    CONTINUE
      GOTO 107
C
C Extract looped CIF items from name.cif
C
 110  IF(NHIT.EQ.0)GOTO 104
      IF(NHIT.NE.NT)GOTO 134
 111  ISKP=0
      IHSK=0
      IRSK=0
      LSO=NSO
      M=0
 112  M=M+1
      IF(NHFL.NE.M)GOTO 113
      IF(IS(1:LS).EQ.'H')IHSK=1
 113  IF(NRFL.NE.M)GOTO 114
      IF(INDEX(IS(1:LS),'R')+INDEX(IS(1:LS),'G').NE.0)IRSK=1
 114  IF(NFLG.NE.M)GOTO 115
      ISKP=IFL
      IF(IS(1:1).EQ.'y'.OR.IS(1:1).EQ.'Y')ISKP=0
 115    DO 122 I=1,4
        IF(M.NE.IP(I))GOTO 122
        IF(IS(1:1).EQ.'.')GOTO 123
        N=0
        IF(LS.GT.3)GOTO 116
        LS=LS+4
        IS(LS-3:LS)='_555'
 116    N=N+1
        IF(N.GT.NSO)GOTO 117
        IF(IS(1:LS).NE.SYO(N)(8-LS:7))GOTO 116
        GOTO 118
 117    NSO=MIN0(N,512)
        SYO(N)=' '
        SYO(N)(8-LS:7)=IS(1:LS)
 118    WRITE(IS,'(A12,I1)')'_site_label_',I
          DO 119 K=1,NSS
          IF(INDEX(CSS(K),IS(1:13)).NE.0)GOTO 120
 119      CONTINUE
        GOTO 123
 120    J=IABS(LSV(K))
        WRITE(IS,'(A1,I4)')'#',N
          DO 121 N=1,5
          IF(IS(N:N).EQ.' ')GOTO 121
          J=J+1
          CSV(K)(J:J)=IS(N:N)
 121      CONTINUE
        LSV(K)=ISIGN(J,LSV(K))
 122    CONTINUE
 123  N=NS(M)
      IF(N.EQ.0)GOTO 129
C
C Modify atom names
C
      IF(INDEX(CSS(N),'_atom_site_label').NE.0)GOTO 124
      IF(INDEX(CSS(N),'_atom_site_aniso_label').EQ.0)GOTO 128
 124  IF(INDEX(IS(1:LS),'_').EQ.0)GOTO 127
      IR=IS
      IS=' '
      K=LS
      LS=0
      J=0
      I=0
 125  I=I+1
      IF(I.GT.K)GOTO 128
      IF(IR(I:I).NE.'_')GOTO 126
      J=J+1
      IF(J.NE.3)GOTO 125
 126  IF(J.EQ.2)GOTO 125
      LS=LS+1
      IS(LS:LS)=IR(I:I)
      GOTO 125
 127  IF(IBR.EQ.0)GOTO 128
      I=2
      IF(IS(2:2).GE.'a'.AND.IS(2:2).LE.'z')I=3
      IF(IS(I:I).GT.'9'.OR.IS(I:I).LT.'0')GOTO 128
      LS=LS+2
      IR(I:LS)='('//IS(I:LS-2)//')'
      IS(I:LS)=IR(I:LS)
 128  CSV(N)=IS
      LSV(N)=ISIGN(MAX0(1,LS),LSV(N))
 129  IF(M.LT.NL)GOTO 132
      IF(ISKP.NE.0)GOTO 131
      IF(IHSK+1.LT.IRH)GOTO 131
      IF(IRH.EQ.2.OR.IHSK.EQ.0)GOTO 130
      IF(IRSK.GT.IRH)GOTO 131
 130  CALL LINOUT
      GOTO 132
 131  NSO=LSO
 132  CALL NEXT
      IF(LS.LT.0)GOTO 133
      IF(IS(1:1).EQ.'_')GOTO 133
      IF(IS(1:5).EQ.'loop_')GOTO 133
      IF(M.EQ.NL)GOTO 111
      GOTO 112
 133  IF(M.EQ.NL)GOTO 41
C
C Error and normal termination
C
 134  WRITE(*,'(/A)')' ** Loop mismatch or items missing **'
      GOTO 13
 135  WRITE(*,'(/A)')' ** Syntax error in ciftab.* file **'
      GOTO 13
C
C Print structure factor tables
C
 136  IF(OPT.NE.'F')GOTO 139
      IS=COD(1:L)//'.fcf'
      CALL GETANS('Name of CIF structure factor file',IS)
      L=INDEX(IS,' ')-1
      IF(L.LT.1)GOTO 138
      CLOSE(LC,IOSTAT=I)
      OPEN(LC,FILE=IS(1:L),STATUS='OLD',ERR=138)
      L=INDEX(COD,' ')-1
      IS=COD(1:L)//'.sft'
      CALL GETANS('Printer (PRN) or filename for Fo/Fc tables',IS)
      CALL CIFOUT(LO,IS,KS)
      IF(KS.EQ.'N')GOTO 138
      CALL CIFSFT(KS)
 137  CLOSE(LO,IOSTAT=I)
      CLOSE(LC,IOSTAT=I)
      IF(KS.NE.'N')GOTO 4
      GOTO 5
 138  L=INDEX(IS,' ')-1
      WRITE(*,'(/A)')' ** Cannot open file '//IS(1:L)//' **'
      GOTO 137
C
C Finish off
C
 139  IF(OPT.EQ.'Q')GOTO 140
      CALL CLS
      WRITE(*,'(/A)')' ** Unknown option **'
      GOTO 5
 140  STOP
      END
C
C -------------------------------------------------------------------
C
      SUBROUTINE CLS
C
C Clear screen and put cursor in top left hand corner
C
      WRITE(*,'(////////////////////////////////)')
      RETURN
      END
C
C -------------------------------------------------------------------
C
      SUBROUTINE GETANS(PRO,STR)
C
C Read a string from the keyboard with echo and default
C
      CHARACTER*(*)PRO,STR
      CHARACTER*80 IN
C
C Put '$,' before ')' in following FORMAT for VMS and some UNIX systems
C
   1  FORMAT(/' ',A,' [',A,']: ',$)
C
      L=MAX0(INDEX(STR,' '),2)-1
      WRITE(*,1)PRO,STR(1:L)
      IN=' '
      READ(*,'(A)')IN
        DO 2 I=1,80
        IF(IN(I:I).NE.' ')GOTO 3
   2    CONTINUE
      GOTO 4
   3  STR=IN(I:INDEX(IN(I:80),' ')+I-2)
   4  RETURN
      END
C
C -------------------------------------------------------------------
C
      SUBROUTINE CIFIN(FN,OPT)
C
C Scan .cif file and store non-looped items for desired data_ only.
C CDN stores CIF data names and CDS their values as strings (lengths in
C LDS).  NCD is set to the number of items.
C
      CHARACTER*1 CR,ESC,AMP,OPT,KS
      CHARACTER*7 SYO(512)
      CHARACTER*25 SYM(192)
      CHARACTER*32 CDN(500),CSS(40),DATB
      CHARACTER*80 IS,IR,IW,CDS(500),CSV(40),FN,more(100)
      INTEGER LDS(500),LSS(40),NCOL(40),MLT(40),MSG(40),LSV(40)
      integer moreind(20,2)
      COMMON LDS,LSS,LSV,NCOL,MLT,MSG,NCD,LS,NSS,LB,LC,LO,LU,MC,MX
      COMMON/CBUF/IR,IS,IW,CDS,CDN,CSS,CSV,DATB,CR,ESC,AMP
      COMMON/CSYM/SYM,SYO
      COMMON/ISYM/NSY
c******
      common/text/more,moreind
c******
C
      OPT='Y'
      L=INDEX(FN,' ')-1
      IF(L.LT.1)GOTO 10
      CLOSE(LC,IOSTAT=LB)
      OPEN(LC,FILE=FN(1:L),STATUS='OLD',ERR=10)
      LB=0
C
C Select appropriate data_ set
C
   1  CALL NEXT
      IF(LS.GE.0)GOTO 2
      WRITE(*,'(/A)')' ** (next) data_ not found before eof **'
      GOTO 11
   2  IF(IS(1:5).NE.'data_')GOTO 1
   3  KS='Y'
      CALL GETANS('Select '//IS(1:LS)//' ? (Y or N)',KS)
      IF(KS.GE.'a')KS=CHAR(ICHAR(KS)-LU)
      IF(KS.EQ.'N')GOTO 1
      IF(KS.NE.'Y')GOTO 3
      DATB=IS(1:32)
      LOOP=0
      MSY=0
      NSY=0
      NCD=3
      CDN(1)='_data'
      CDS(1)=IS(6:LS)
      LDS(1)=LS-5
      CDN(2)='_tabno'
      CDN(3)='_comno'
      WRITE(IS,'(I8)')MC
      J=0
        DO 4 I=1,8
        IF(IS(I:I).EQ.' ')GOTO 4
        J=J+1
        CDS(3)(J:J)=IS(I:I)
   4    CONTINUE
      LDS(3)=J
   5  CALL NEXT
      IF(LS.LT.0)GOTO 12
      IF(IS(1:5).NE.'loop_')GOTO 6
      LOOP=1
      GOTO 5
   6  IF(LOOP.EQ.0)GOTO 7
      IF(IS(2:19).EQ.'symmetry_equiv_pos')MSY=1
      IF(IS(1:1).EQ.'_')GOTO 5
      LOOP=0
   7  IF(IS(1:1).EQ.'_')GOTO 8
      IF(MSY.NE.1)GOTO 5
      NSY=NSY+1
      SYM(NSY)=IS(1:25)
      GOTO 5
   8  MSY=0
   9  NCD=NCD+1
      CDN(NCD)=IS(1:32)
      CDS(NCD)=' '
      LDS(NCD)=0
      CALL NEXT
      IF(LS.LT.0)GOTO 12
      IF(IS(1:1).EQ.'_')GOTO 9
      CDS(NCD)=IS
      LDS(NCD)=LS
      GOTO 5
  10  WRITE(*,'(/A)')' ** cannot open file '//FN(1:L)//' **'
  11  OPT='N'
c****** was return
  12  continue
      rewind lc
      moreind(1,1)=1
 1000 read(lc,1005,end=1001)is
 1005 format(a)
c
      if(is(1:23).eq.'_refine_special_details') then
 1002  read(lc,1005,end=1001)is
       IF(IS(1:1).EQ.';') then 
         moreind(1,2)=0
 1004    read(lc,1005,end=1001)is
         if(is(1:1).eq.';') goto 1008         
         moreind(1,2)=moreind(1,2)+1
         more(moreind(1,2))=is
         goto 1004
       endif
      endif
      goto 1000
c
 1008 rewind lc
      moreind(2,1)=moreind(1,2)+1
 1009 read(lc,1005,end=1001)is
c
      if(is(1:21).eq.'_geom_special_details') then
      read(lc,1005,end=1001)is
       IF(IS(1:1).EQ.';') then 
         moreind(2,2)=moreind(2,1)-1
 1010    read(lc,1005,end=1001)is
         if(is(1:1).eq.';') goto 1011         
         moreind(2,2)=moreind(2,2)+1
         more(moreind(2,2))=is
         goto 1010
       endif
      endif
c
      goto 1009
 1011 continue
 1001 rewind lc
c******
      RETURN
      END
C
C -------------------------------------------------------------------
C
      SUBROUTINE CIFOUT(LO,FN,OPT)
C
C Open output file on unit LO.
C
      CHARACTER*1 OPT
      CHARACTER*80 FN
C
      OPT='Y'
      L=INDEX(FN,' ')-1
      IF(L.LT.1)GOTO 2
      CLOSE(LO,IOSTAT=I)
      OPEN(LO,FILE=FN(1:L),STATUS='OLD',IOSTAT=I)
C
C Change 'PRN' and 'prn' in next statement to name of system printer
C
      IF(FN(1:L).NE.'PRN'.AND.FN(1:L).NE.'prn')GOTO 1
      IF(I.EQ.0)GOTO 3
   1  CLOSE(LO,STATUS='DELETE',IOSTAT=I)
C
C CARRIAGECONTROL='LIST' should be included in the next statement for
C VAX/VMS and possibly some other systems.
C
      OPEN(LO,FILE=FN(1:L),STATUS='NEW',CARRIAGECONTROL='LIST',ERR=2)
      GOTO 3
   2  WRITE(*,'(/A)')' ** cannot open file '//FN(1:L)//' **'
      OPT='N'
   3  RETURN
      END
C
C -------------------------------------------------------------------
C
      SUBROUTINE NEXT
C
C Return the next item from unit LC (CIF format) in buffer IS.
C LS returns the string length.  Text information produces a
C blank string (with LS=0).  LS=-1 flags end of the file LC.
C All characters are converted to lower case.
C
      CHARACTER*1 CR,ESC,AMP
      CHARACTER*32 CDN(500),CSS(40),DATB
      CHARACTER*80 IS,IR,IW,CDS(500),CSV(40)
      INTEGER LDS(500),LSS(40),NCOL(40),MLT(40),MSG(40),LSV(40)
      COMMON LDS,LSS,LSV,NCOL,MLT,MSG,NCD,LS,NSS,LB,LC,LO,LU,MC,MX
      COMMON/CBUF/IR,IS,IW,CDS,CDN,CSS,CSV,DATB,CR,ESC,AMP
   1  FORMAT(A)
C
      LK=0
      LS=0
      IS=' '
   2  LB=LB+1
      IF(LB.LT.81)GOTO 4
      IF(LS.NE.0)GOTO 9
      LB=0
      IW=' '
      READ(LC,1,END=7)IW
      I=INDEX(IW,CHAR(13))
      IF(I.GT.0)IW(I:I)=' '
      IF(IW(1:1).NE.';')GOTO 2
   3  READ(LC,1,END=7)IW
      I=INDEX(IW,CHAR(13))
      IF(I.GT.0)IW(I:I)=' '
      IF(IW(1:1).NE.';')GOTO 3
      GOTO 9
   4  IF(LK.EQ.0)GOTO 8
      IF(IW(LB:LB).EQ.'''')GOTO 12
   5  LS=LS+1
      IS(LS:LS)=IW(LB:LB)
      GOTO 2
   6  IF(LS.GE.80)GOTO 2
      IF(IW(LB:LB).NE.'''')GOTO 5
      IF(LS.NE.0)GOTO 5
      LK=1
      GOTO 2
   7  LS=-1
      GOTO 12
   8  IF(IW(LB:LB).NE.' ')GOTO  6
      IF(LS.EQ.0)GOTO 2
   9  IF(IS(1:1).EQ.'_')GOTO 10
      IF(IS(1:5).EQ.'Loop_')GOTO 10
      IF(IS(1:5).NE.'LOOP_')GOTO 12
  10    DO 11 I=1,LS
        IF(IS(I:I).GE.'A'.AND.IS(I:I).LE.'Z')IS(I:I)=
     +  CHAR(ICHAR(IS(I:I))+LU)
  11    CONTINUE
  12  RETURN
      END
C
C -------------------------------------------------------------------
C
      SUBROUTINE RINT(I,N)
C
C Set N to the integer which begins at position I in string IR.
C I is incremented to point to the character following this integer.
C
      CHARACTER*1 CR,ESC,AMP
      CHARACTER*32 CDN(500),CSS(40),DATB
      CHARACTER*80 IS,IR,IW,CDS(500),CSV(40)
      COMMON/CBUF/IR,IS,IW,CDS,CDN,CSS,CSV,DATB,CR,ESC,AMP
C
      N=0
      M=1
      IF(IR(I+1:I+1).NE.'-')GOTO 1
      M=-1
      I=I+1
   1  I=I+1
      IF(I.GT.80)GOTO 2
      K=ICHAR(IR(I:I))
      IF(K.LT.48)GOTO 2
      IF(K.GT.57)GOTO 2
      N=N*10+K-48
      GOTO 1
   2  N=N*M
      RETURN
      END
C
C -------------------------------------------------------------------
C
      SUBROUTINE LINOUT
C
C Combine text line in IT with CIF items and output it
C
      CHARACTER*1 CR,ESC,AMP
      CHARACTER*32 CDN(500),CSS(40),DATB
      CHARACTER*80 IS,IR,IW,CDS(500),CSV(40)
      CHARACTER*128 IT
      INTEGER LDS(500),LSS(40),NCOL(40),MLT(40),MSG(40),LSV(40)
      COMMON LDS,LSS,LSV,NCOL,MLT,MSG,NCD,LS,NSS,LB,LC,LO,LU,MC,MX
      COMMON/CBUF/IR,IS,IW,CDS,CDN,CSS,CSV,DATB,CR,ESC,AMP
   1  FORMAT(A)
C
      MT=0
      IT=' '
        DO 11 M=1,NSS
        IR=CSV(M)
        L=IABS(LSV(M))
        IF(LSV(M).LT.0)GOTO 9
C
C Interpret numerical string with esd
C
        K=INDEX(IR(1:L),'(')-1
        IF(K.LE.0)K=L
        J=INDEX(IR(1:L),'.')
        IF(J.GT.0)GOTO 2
        J=K+1
        IR(J:J)='.'
   2    N=K-J
        IF(N.LT.0)N=0
        WRITE(IS,'(A,I2,A,I1,A)')'(F',MAX0(J,K),'.',N,')'
        READ(IR,IS(1:7),ERR=9)X
        Y=-9.E9
        N=MAX0(N-MLT(M),0)
        IF(L.LT.K+2)GOTO 4
        IR(L:L)='.'
        WRITE(IS,'(A,I1,A)')'(F',L-K-1,'.0)'
        READ(IR(K+2:L),IS(1:6),ERR=9)Y
        Y=Y+0.01
          DO 3 I=MSG(M)+1,N
          Y=0.1*Y
   3      CONTINUE
        Y=AMAX1(1.1,Y)
C
C Multiply by power of 10
C
   4    T=10.
        IF(MLT(M).LT.0)T=0.1
        J=IABS(MLT(M))
          DO 5 I=1,J
          X=X*T
   5      CONTINUE
        IF(MSG(M).NE.20)GOTO 7
   6    IF(N.EQ.0)GOTO 7
        IF(Y.LT.15.)GOTO 7
        N=N-1
        Y=Y*0.1
        GOTO 6
   7    WRITE(IR,'(A,I1,A)')'(F20.',MIN0(N,MSG(M)),',A,F12.0,A)'
        IS=' '
        IF(Y.GE.0.)WRITE(IS,IR(1:17))X,' (',Y,' )'
        IR(7:7)=')'
        IF(Y.LT.0.)WRITE(IS,IR(1:7))X
        L=0
        IR=' '
          DO 8 I=1,36
          IF(IS(I:I).EQ.' ')GOTO 8
          IF(IS(I:I+1).EQ.'. ')GOTO 8
          L=L+1
          IR(L:L)=IS(I:I)
   8      CONTINUE
C
C Insert string into text line
C
   9    J=MT+1
        N=MT+L
        IF(NCOL(M).EQ.0)GOTO 10
        J=NCOL(M)
        N=J+L-1
        IF(J.GT.0)GOTO 10
        N=IABS(J)
        J=MAX0(1,N-L+1)
        IF(LSV(M).LE.0)GOTO 10
        K=INDEX(IR(1:L),'.')
        IF(K.EQ.0)K=INDEX(IR(1:L),'(')
        IF(K.EQ.0)GOTO 10
        K=L-K+1
        N=N+K
        J=J+K
  10    N=MIN0(N,128)
        L=MIN0(L,N-J+1)
        IT(J:N)=IR(1:L)
        MT=MIN0(MAX0(N,MT),127)
  11    CONTINUE
      IF(MT.EQ.0)MT=1
      WRITE(LO,1)IT(1:MT)//CR
      RETURN
      END
C
C -------------------------------------------------------------------
C
      SUBROUTINE CIFSFT(KS)
C
C Reads name.fcf (CIF format) and outputs structure factors to .sft in
C compressed format for an HP-Laserjet or compatible printer. The .fcf
C file must have been created using the LIST 4 (or ACTA) instructions
C of SHELXL.  h, k, l, 10Fo, 10Fc and 10sigma(F) are printed in five
C columns per page, unless 10Fo or 10Fc would be too large to print,
C in which case Fo etc. is printed instead.  Fo is set to zero if Fo^2
C is negative, and negative sigma(Fo) flags reflections suppressed for
C refinement purposes.
C
      CHARACTER*1 CR,ESC,AMP,KS
      CHARACTER*32 CDN(500),CSS(40),DATB
      CHARACTER*80 IS,IR,IW,CDS(500),CSV(40)
      INTEGER LDS(500),LSS(40),NCOL(40),MLT(40),MSG(40),LSV(40),
     +IG(30),IH(800),IK(800),IL(800),IO(800),IC(800),IE(800)
      COMMON LDS,LSS,LSV,NCOL,MLT,MSG,NCD,LS,NSS,LB,LC,LO,LU,MC,MX
      COMMON/CBUF/IR,IS,IW,CDS,CDN,CSS,CSV,DATB,CR,ESC,AMP
      COMMON/CSFT/IG,IH,IK,IL,IO,IC,IE
C
   1  FORMAT(A)
   2  FORMAT(21X,F12.2)
   3  FORMAT(27X,F10.3)
   4  FORMAT(3I4,2F12.2,F10.2,1X,A1)
   5  FORMAT(1X,A1)
   6  FORMAT('   Table',I4,'.     Observed and calculated structure ',
     +'factors for',I4,54X,'Page',I3/)
   7  FORMAT(3X,4('h  k  l 10Fo 10Fc 10s',5X),'h  k  l 10Fo 10Fc 10s'/)
   8  FORMAT(3X,4('h  k  l   Fo   Fc   s',5X),'h  k  l   Fo   Fc   s'/)
   9  FORMAT(4(I4,2I3,2I5,I4,2X),I4,2I3,2I5,I4)
  10  FORMAT($,1X,A)
C
      WRITE(LO,1)' '//ESC//AMP//'l0o5c1x'//ESC//'(0u'//
     +ESC//'(s0p16.66h8.5v0s0b0T'
      FMAX=9999.
      FSCA=1.
C
C Check CIF file and set scale factor
C
  11  READ(LC,1,ERR=24,END=24)IR
      I=INDEX(IR,CHAR(13))
      IF(I.GT.0)IR(I:I)=' '
      IF(IR(1:22).NE.'_shelx_refln_list_code')GOTO 11
      IF(IR(23:26).NE.'   4')GOTO 24
      READ(LC,2,ERR=24,END=24)FMAX
      IF(FMAX.LE.0.)GOTO 24
      READ(LC,1,ERR=24,END=24)IR
      READ(LC,3,ERR=24,END=24)FSCA
      IF(FSCA.LE.0.)GOTO 24
  12  READ(LC,1,ERR=24,END=24)IR
      I=INDEX(IR,CHAR(13))
      IF(I.GT.0)IR(I:I)=' '
      IF(INDEX(IR,'loop_').EQ.0)GOTO 12
  13  READ(LC,1,ERR=24,END=24)IR
      I=INDEX(IR,CHAR(13))
      IF(I.GT.0)IR(I:I)=' '
      IF(INDEX(IR,'_').NE.0)GOTO 13
      FSCA=SQRT(FSCA)
      SC=10.
      IF(FMAX.GT.9000.)SC=1.
C
C Set number of lines per page for A or A4 size paper
C
      KS='U'
  14  CALL GETANS('US (U) or European (E) sized paper',KS)
      IF(KS.GE.'a')KS=CHAR(ICHAR(KS)-LU)
      NLINE=90
      IF(KS.EQ.'U')GOTO 15
      IF(KS.NE.'E')GOTO 14
      NLINE=94
C
C Read block of data in fixed format (faster), scale and store
C
  15  NMAX=5*NLINE
      NE=0
      NP=0
  16  NP=NP+1
      M=0
  17  M=M+1
      IF(M.GT.NMAX)GOTO 21
      IF(NP+M.GT.2)GOTO 18
      READ(IR,4,ERR=24,END=20)IH(M),IK(M),IL(M),C,F,S,KS
      GOTO 19
  18  READ(LC,4,ERR=24,END=20)IH(M),IK(M),IL(M),C,F,S,KS
  19  IF(IABS(IH(M))+IABS(IK(M))+IABS(IL(M)).EQ.0)GOTO 20
c*****
c      F=AMAX1(F,0.0001)
c      T=S/F
c      F=SC*SQRT(F)/FSCA
      s=S*sc*sc/(fsca*fsca)
      F=sign((SC*SQRT(abs(F))/FSCA),f)
c*****
      C=SC*SQRT(C)/FSCA
c*****
c      IO(M)=INT(F+0.5)
       if (f.gt.0.0) then
        io(m)=int(f+0.5)
       else
        io(m)=int(f-0.5)
       endif
c*****
      IC(M)=INT(C+0.5)
c*****
c      IE(M)=MAX0(1,INT(F*(1.-SQRT(AMAX1(0.,1.-T)))))
      ie(m)=int(sqrt(f*f+s)-abs(f)+0.5)
c*****
      IF(KS.NE.'o')IE(M)=-IE(M)
      GOTO 17
  20  NE=1
  21  M=M-1
      NB=(M+4)/5
      IF(NB.EQ.0)GOTO 26
      IF(NP.NE.1)WRITE(LO,5)CHAR(12)
      WRITE(LO,6)MX,MC,NP
      IF(SC.GT.5.)WRITE(LO,7)
      IF(SC.LT.5.)WRITE(LO,8)
C
C Output transposed data
C
      J=0
  22  J=J+1
      IF(J.GT.NB)GOTO 25
      K=J+NB*((M-J)/NB)
      L=0
        DO 23 I=J,K,NB
        L=L+6
        IG(L-5)=IH(I)
        IG(L-4)=IK(I)
        IG(L-3)=IL(I)
        IG(L-2)=IO(I)
        IG(L-1)=IC(I)
        IG(L)=IE(I)
  23    CONTINUE
      WRITE(LO,9)(IG(I),I=1,L)
      GOTO 22
  24  WRITE(*,'(/A)')' ** Bad .fcf file **'
      KS='N'
      GOTO 27
  25  IF(NE.EQ.0)GOTO 16
  26  MX=MX+1
      KS='Y'
C
C Reset HP Laserjet
C
  27  WRITE(LO,10)ESC//'E'
      RETURN
      END
