c
c         PROGRAM CRYMSHEL
c
c   to convert CRYM .LSQ file to SHELX .INS file
c   only does some stuff now
c   add no refine option
c   
      parameter na=600,ns=10
      character*1 spgl,dptyp
      character*3 sfac(ns),ffac(ns),ff
      character*6 labelc(na),labeld(na),labelt
      character*72 title
      character*80 card
      double precision cell(6),pi,rad,tpisq,episq,v
      double precision aconv,bconv,cconv,abconv,acconv,bcconv
      real XYZ(na,3),U(na,6),celsig(6),temp(6)
      integer n(na),atno(na),Z,nunit(ns),spcgrp
      pi=3.14159265
      rad=0.01745329
      OPEN(UNIT=4,STATUS='OLD')
      OPEN(UNIT=5,STATUS='OLD')
      OPEN(UNIT=6,STATUS='new',carriagecontrol='list')
      inquire(4,exist=iexist)
      inquire(5,exist=iexist)

c
c open .inf file, get cell parameters and unit cell contents
c
c
   22 read(4,1,end=2) card
    1 format(a80)
      if (card(2:5).eq.'TITL') then
       decode(80,6,card,err=4)title
    6  format(8x,a72)
      elseif (card(2:5).eq.'CELL') then
       decode(80,3,card,err=4) cell
    3  format(6x,f8.3,5x,f8.3,5x,f8.3,5x,f7.2,5x,f7.2,5x,f7.2)
       decode(80,5,card,err=4) celsig
    5  format(15x,f2.2,11x,f2.2,11x,f2.2,10x,f2.2,10x,f2.2,10x,f2.2)
       do i=1,3
        celsig(i)=celsig(i)*.1
       enddo
      elseif (card(2:4).eq.'Z =') then
       decode(80,7,card,err=4) Z
    7  format(4x,i3)
      elseif (card(2:4).eq.'V =') then
       decode(80,8,card,err=4) V
    8  format(4x,f10.1)
      elseif (card(2:5).eq.'FORM') then
       decode(80,9,card,err=4)ffac
    9  format(10x,10(a3,4x))
       decode(80,11,card,err=4)nunit
   11  format(9x,10(4x,i3))
       do i=ns,1,-1
        if(ffac(i).ne.'   ')goto 21
       enddo
   21  nsfac=i
       do i=1,nsfac
        sfac(i)=ffac(i)
       enddo
       call ffsfac(sfac,nsfac)
      elseif (card(2:5).eq.'SPAC') then
       decode(80,12,card,err=4)spcgrp,spgl
   12  format(14x,i3,a1)
      else
       goto 22
      endif
      goto 22
c
c     got info from inf file
c     write header to ins file
c
    2 write(6,13)title
   13 format('TITL ',a72)
      write(6,14)cell
   14 format('CELL 0.71073 ',3f8.3,3f7.2)
      write(6,15)Z,celsig
   15 format('ZERR ',3x,i3,2x,3f8.3,3f7.2)
      write(6,16)
   16 format('LATT ','! *****')
      write(6,17)
   17 format('SYMM ','! *****')
      write(6,18) (sfac(i),i=1,nsfac)
   18 format('SFAC   ',12(a3,1x))
      write(6,19) (nunit(i),i=1,nsfac)
   19 format('UNIT ',12i4)
      write(6,20)
   20 format('L.S. ',' ! *****')
      write(6,34)
   34 format('WGHT 0 0 0 0 0')
c
c
c  read from lsq file now
c
      tpisq=2.*pi*pi
      episq=4.*tpisq
      aconv=tpisq*(cell(2)*cell(3)*dsin(cell(4)*rad)/v)**2
      bconv=tpisq*(cell(1)*cell(3)*dsin(cell(5)*rad)/v)**2
      cconv=tpisq*(cell(1)*cell(2)*dsin(cell(6)*rad)/v)**2
      abconv=2.*tpisq*(cell(2)*cell(3)*dsin(cell(4)*rad)/v)*
     1                (cell(1)*cell(3)*dsin(cell(5)*rad)/v)
      acconv=2.*tpisq*(cell(2)*cell(3)*dsin(cell(4)*rad)/v)*
     1                (cell(1)*cell(2)*dsin(cell(6)*rad)/v)
      bcconv=2.*tpisq*(cell(1)*cell(3)*dsin(cell(5)*rad)/v)*
     1                (cell(1)*cell(2)*dsin(cell(6)*rad)/v)
      nat=0
      ndp=0
      nore=0.
   23 read(5,1,end=24) card
      if (card(1:4).eq.'COOR') then
       nat=nat+1
       decode(80,25,card,err=4)labelc(nat),ff,(xyz(nat,j),j=1,3)
c  ADD mORE STUFF HERE
   25  format(6x,a6,a3,3f9.6)
       do j=1,3
        xyz(nat,j)=xyz(nat,j)+nore
       enddo
       do i=1,nsfac
        if(ff.eq.ffac(i)) then
         atno(nat)=i
         goto 26
        endif
       enddo
   26  continue
      elseif (card(1:4).eq.'ANIS') then
       ndp=ndp+1
       decode(80,27,card,err=4) dptyp,labeld(ndp),(u(ndp,j),j=1,6)
   27  format(5x,a1,a6,6f10.9)
c  ADD MORE STUFF
       if (dptyp.ne.'U') then
        u(ndp,1)=u(ndp,1)/aconv + nore
        u(ndp,2)=u(ndp,2)/bconv + nore
        u(ndp,3)=u(ndp,3)/cconv + nore
        u(ndp,4)=u(ndp,4)/abconv + nore
        u(ndp,5)=u(ndp,5)/acconv + nore
        u(ndp,6)=u(ndp,6)/bcconv + nore
       endif
      elseif (card(1:4).eq.'ISO ') then
       ndp=ndp+1
       decode(80,28,card,err=4) labeld(ndp),u(ndp,1)
   28  format(6x,a6,f12.8)
        u(ndp,1)=u(ndp,1)/episq + nore
c  ADD MORE STUFF
      elseif (card(1:4).eq.'SCAL') then
       decode(80,29,card,err=4) scale
   29  format(6x,f10.7)
      elseif (card(1:4).eq.'SECO') then
       decode(80,30,card,err=4) seco
   30  format(21x,f8.5)
c   ADD THIS ******
      elseif (card(1:4).eq.'POP ') then
      elseif (card(1:4).eq.'NO R') then
      nore=10.
c   THIS ALLOWS ONLY ONE NO REFINEMENT CARD
c
c   ADD THIS ******
      elseif (card(1:4).eq.'END ') then
       goto 24
      endif
      goto 23
c
c
c
   24 if (nat.ne.ndp) then
       write(6,32) nat,ndp
   32  format(i4,' atoms but',i4, 'displacements')
       stop
      endif
      do i=1,nat
       do j=i,ndp
        if (labelc(i).eq.labeld(j)) then
         if(i.ne.j) then
          labelt=labeld(i)
          labeld(i)=labeld(j)
          labeld(j)=labelt
          do k=1,6
           temp(k)=u(i,k)
           u(i,k)=u(j,k)
           u(j,k)=temp(k)
          enddo
         endif
         goto 31
        endif
       enddo
   31 continue
      enddo
      write(6,38)scale/2.
   38 format('FVAR ',f10.7)
      do i=1,nat
       if (labelc(i).ne.labeld(i)) then
        write (6,33) labelc(i),labeld(i)
   33   format(' problem with atom',a6,' or ',a6)
        stop
       endif
       if (u(i,2).ne.0.0) then
        write(6,35)labelc(i),atno(i),(xyz(i,j),j=1,3),(u(i,j),j=1,3),
     1             U(I,6),U(I,5),U(I,4)
C**** CAUTION FUNNY ORDER         U23 U13 U12
   35   format(a6,i4,3f10.5,'  11.00000',2f10.5,' = '/6x,4f10.5)
       else
        write(6,36)labelc(i),atno(i),(xyz(i,j),j=1,3),u(i,1)
   36   format(a6,i4,3f10.5,'  11.00000',f10.5)
       endif
      enddo      
      write(6,37)
   37 format('HKLF 4')
c
c
c
      stop
    4 write(6,10)card
   10 format(' Error decoding this line'/a)
      stop
      end
      SUBROUTINE ffsfac(sfac,nsfac)
      character*3 kindf(216),shelx(216),sfac(nsfac)
c     kindf are form factors
c     shelx is shelx sfac CAUTION should be updated for available atoms
C FORM FACTOR LABELS FROM FFBC.FOR, ****DIFFERENT FORMAT****
      DATA KINDF/
     1 'HS ', 'H  ', 'H1 ', 'HE ', 'LI ', 'LI1', 'BE ', 'BE2', 
     2 'B  ', 'C  ', 'CV ', 'N  ', 'O  ', 'O1 ', 'F  ', 'F1 ', 
     3 'NE ', 'NA ', 'NA1', 'MG ', 'MG2', 'AL ', 'AL3', 'SI ', 
     4 'SI4', 'P  ', 'S  ', 'CL ', 'CL1', 'AR ', 'K  ', 'K1 ', 
     5 'CA ', 'CA2', 'SC ', 'SC3', 'TI ', 'TI2', 'TI3', 'TI4', 
     6 'V  ', 'V2 ', 'V3 ', 'V5 ', 'CR ', 'CR2', 'CR3', 'MN ', 
     7 'MN2', 'MN3', 'MN4', 'FE ', 'FE2', 'FE3', 'CO ', 'CO2', 
     8 'CO3', 'NI ', 'NI2', 'NI3', 'CU ', 'CU1', 'CU2', 'ZN ', 
     9 'ZN2', 'GA ', 'GA3', 'GE ', 'GE4', 'AS ', 'SE ', 'BR ', 
     * 'BR1', 'KR ', 'RB ', 'RB1', 'SR ', 'SR2', 'Y  ', 'Y3 ', 
     1 'ZR ', 'ZR4', 'NB ', 'NB3', 'NB5', 'MO ', 'MO3', 'MO5', 
     2 'MO6', 'TC ', 'RU ', 'RU3', 'RU4', 'RH ', 'RH3', 'RH4', 
     3 'PD ', 'PD2', 'PD4', 'AG ', 'AG1', 'AG2', 'CD ', 'CD2', 
     4 'IN ', 'IN3', 'SN ', 'SN2', 'SN4', 'SB ', 'SB3', 'SB5', 
     5 'TE ', 'I  ', 'I1 ', 'XE ', 'CS ', 'CS1', 'BA ', 'BA2', 
     6 'LA ', 'LA3', 'CE ', 'CE3', 'CE4', 'PR ', 'PR3', 'PR4', 
     7 'ND ', 'ND3', 'PM ', 'PM3', 'SM ', 'SM3', 'EU ', 'EU2', 
     8 'EU3', 'GD ', 'GD3', 'TB ', 'TB3', 'DY ', 'DY3', 'HO ', 
     9 'HO3', 'ER ', 'ER3', 'TM ', 'TM3', 'YB ', 'YB2', 'YB3', 
     * 'LU ', 'LU3', 'HF ', 'HF4', 'TA ', 'TA5', 'W  ', 'W6 ', 
     1 'RE ', 'OS ', 'OS4', 'IR ', 'IR3', 'IR4', 'PT ', 'PT2', 
     2 'PT4', 'AU ', 'AU1', 'AU3', 'HG ', 'HG1', 'HG2', 'TL ', 
     3 'TL1', 'TL3', 'PB ', 'PB2', 'PB4', 'BI ', 'BI3', 'BI5', 
     4 'PO ', 'AT ', 'RN ', 'FR ', 'RA ', 'RA2', 'AC ', 'AC3', 
     5 'TH ', 'TH4', 'PA ', 'U  ', 'U3 ', 'U4 ', 'U6 ', 'NP ', 
     6 'NP3', 'NP4', 'NP6', 'PU ', 'PU3', 'PU4', 'PU6', 'AM ', 
     7 'CM ', 'BK ', 'CF ', 'ES ', 'FM ', 'MD ', 'NO ', 'LR '/ 
      DATA SHELX/
     1 'H  ', 'H  ', 'H  ', 'HE ', 'LI ', 'LI ', 'BE ', 'BE ', 
     2 'B  ', 'C  ', 'C  ', 'N  ', 'O  ', 'O  ', 'F  ', 'F  ', 
     3 'NE ', 'NA ', 'NA ', 'MG ', 'MG ', 'AL ', 'AL ', 'SI ', 
     4 'SI ', 'P  ', 'S  ', 'CL ', 'CL ', 'AR ', 'K  ', 'K  ', 
     5 'CA ', 'CA ', 'SC ', 'SC ', 'TI ', 'TI ', 'TI ', 'TI ', 
     6 'V  ', 'V  ', 'V  ', 'V  ', 'CR ', 'CR ', 'CR ', 'MN ', 
     7 'MN ', 'MN ', 'MN ', 'FE ', 'FE ', 'FE ', 'CO ', 'CO ', 
     8 'CO ', 'NI ', 'NI ', 'NI ', 'CU ', 'CU ', 'CU ', 'ZN ', 
     9 'ZN ', 'GA ', 'GA ', 'GE ', 'GE ', 'AS ', 'SE ', 'BR ', 
     * 'BR ', 'KR ', 'RB ', 'RB ', 'SR ', 'SR ', 'Y  ', 'Y  ', 
     1 'ZR ', 'ZR ', 'NB ', 'NB ', 'NB ', 'MO ', 'MO ', 'MO ', 
     2 'MO ', 'TC ', 'RU ', 'RU ', 'RU ', 'RH ', 'RH ', 'RH ', 
     3 'PD ', 'PD ', 'PD ', 'AG ', 'AG ', 'AG ', 'CD ', 'CD ', 
     4 'IN ', 'IN ', 'SN ', 'SN ', 'SN ', 'SB ', 'SB ', 'SB ', 
     5 'TE ', 'I  ', 'I  ', 'XE ', 'CS ', 'CS ', 'BA ', 'BA ', 
     6 'LA ', 'LA ', 'CE ', 'CE ', 'CE ', 'PR ', 'PR ', 'PR ', 
     7 'ND ', 'ND ', 'PM ', 'PM ', 'SM ', 'SM ', 'EU ', 'EU ', 
     8 'EU ', 'GD ', 'GD ', 'TB ', 'TB ', 'DY ', 'DY ', 'HO ', 
     9 'HO ', 'ER ', 'ER ', 'TM ', 'TM ', 'YB ', 'YB ', 'YB ', 
     * 'LU ', 'LU ', 'HF ', 'HF ', 'TA ', 'TA ', 'W  ', 'W  ', 
     1 'RE ', 'OS ', 'OS ', 'IR ', 'IR ', 'IR ', 'PT ', 'PT ', 
     2 'PT ', 'AU ', 'AU ', 'AU ', 'HG ', 'HG ', 'HG ', 'TL ', 
     3 'TL ', 'TL ', 'PB ', 'PB ', 'PB ', 'BI ', 'BI ', 'BI ', 
     4 'PO ', 'AT ', 'RN ', 'FR ', 'RA ', 'RA ', 'AC ', 'AC ', 
     5 'TH ', 'TH ', 'PA ', 'U  ', 'U  ', 'U  ', 'U  ', 'NP ', 
     6 'NP ', 'NP ', 'NP ', 'PU ', 'PU ', 'PU ', 'PU ', 'AM ', 
     7 'CM ', 'BK ', 'CF ', 'ES ', 'FM ', 'MD ', 'NO ', 'LR '/ 
C
C THIS ARRAY MAPS FORM FACTORS TO ATOMIC NUMBERS
C
c
      do i=1,nsfac
       do ikindf=1,216
        if (sfac(i).eq.kindf(ikindf))then
         sfac(i)=shelx(ikindf)
         goto 1
        endif
       enddo
    1 continue
      enddo       
c
      return
      end
