C PROGRAM FOR CONVERSION OF .OUT DISTAN OUTPUT TO CCDC FILE FOR CCDC
C DEPOSITION OF DISTANCES AND ANGLES
      REAL dist,sigma,angle
      CHARACTER*10 dummy_char,answer,dist_char
      CHARACTER*4 atoma,atomb,atomc
      CHARACTER*129 Line
      LOGICAL file_exists
      INTEGER isigma
C
      WRITE(*,*)
      WRITE(*,*)
      WRITE(*,*)
      WRITE(*,8)
      WRITE(*,9)'                                                    '
      WRITE(*,9)'      CONVERT .TAB FILE TO .CCDC FILE               '
      WRITE(*,9)'                                                    '
      WRITE(*,9)'This program will read your NAME.OUT file from your '
      WRITE(*,9)'distan output and write a new NAME.CCDC file with   '
      WRITE(*,9)'distances and angles for CCDC deposition.           '
      WRITE(*,9)'                                                    '
      WRITE(*,8)
      WRITE(*,*)
      WRITE(*,*)
    9 FORMAT(8x,'*',3x,a52,3x,'*')
    8 FORMAT(8X,'***************************************************',
     1 '*********')
C
      WRITE(*,*)
      write(*,*)'                           RETURN to continue'
      READ(*,90)answer
   90 format(a1)
C Opening .out file
          INQUIRE(unit=5,EXIST=file_exists)
          IF(file_exists) THEN
               OPEN(unit=5,STATUS='OLD',READONLY) ! .OUT file
               REWIND (5)
          ELSE
               WRITE(*,*)'ERROR - INPUT FILE DOES NOT EXIST!'
               GOTO 1000
          ENDIF
C
      WRITE(*,*)
C
C Starting to search .OUT to find distance (or angle) section
  120 READ(5,125,END=500)Line
  125 FORMAT(A80)
      DECODE(80,127,line)dummy_char,dist_char
  127 FORMAT(13x,A10,3x,a10)
      if(dummy_char.ne.'ATOM  ATOM') goto 120
C
      READ(5,125,END=500)Line
C check if actually a section of angle data
      IF(dist_char .NE. 'DISTANCE  ') GOTO 200
      write(7,110)
      write(*,110)
  110 format(1x,'Atom',1x,'Atom',2x,'Distance')
      WRITE(*,*)
C looping through distance section
  130 READ(5,125,END=500)Line
C
C            S     O5      1.4546    0.005 *     8
C
          DECODE(80,137,line)atoma,atomb
  137     FORMAT(13x,a4,2x,a4)
C checking if reached end of distance data section
      if((atoma.eq.'    ').or.(atoma.eq.'T LE')) goto 160
          DECODE(80,138,line)atoma,atomb,dist,sigma
  138     FORMAT(13x,a4,2x,a4,3x,f8.4,3x,f6.3)
      isigma = nint(sigma*1000)
C writing out distance data
      write(*,140)atoma,atomb,dist,isigma
      write(7,140)atoma,atomb,dist,isigma
  140 format(1x,a4,1x,a4,1x,f8.3,'(',I3,')')
      GOTO 130
C
C ANGLES
C
  160 READ(5,125,END=500)Line
      DECODE(80,127,line)dummy_char,dist_char
      if(dummy_char.ne.'ATOM  ATOM') goto 160
C check for distance section
      IF(dist_char .EQ. 'DISTANCE  ') GOTO 130
      READ(5,125,END=500)Line
      write(*,*)
      write(7,*)
  200 write(7,170)
      write(*,170)
  170 format(1x,'Atom',1x,'Atom',1x,'Atom',5x,'Angle')
C
C looping through set of angle data
  210 READ(5,125,END=500)Line
          DECODE(80,220,line)atoma,atomb,atomc
  215 format(13x,a4,2x,a4,2x,a4)
C checking if at end of angle listing
      if((atoma.eq.'    ').or.(atoma.eq.'T LE')) goto 160
C decoding line of angle data 
         DECODE(80,220,line)atoma,atomb,atomc,angle,sigma
  220 format(13x,a4,2x,a4,2x,a4,2x,f7.2,2x,f7.3)
C
C234567 10 234567 20 234567 30 234567 40 234567 50 234567 60 234567 70 2345
C            N2    Re    N3      86.70    0.170       0   0
C
      isigma = nint(sigma*100)
C write out angle data
      write(*,240)atoma,atomb,atomc,angle,isigma
      write(7,240)atoma,atomb,atomc,angle,isigma
  240 format(1x,a4,1x,a4,1x,a4,1x,f7.2,'(',I3,')')
      goto 210
C
  500 WRITE(*,*)' End of .OUT file reached.'
 1000 WRITE(*,*)
      END
