      SUBROUTINE DAVSIG(AV,SIG,NPTS)
C
CHANGED 1/16/79 ON VAX, IN ORDER NOT TO CONTRAVENE THE
C VAX RULE ABOUT MULTIPLE ENTRY SUBROUTINE DUMMY PARAMETERS.
CHANGE CONSISTS ONLY OF CHANGING DUMMY NAME SUMWT
C IN ENTRY WTDAVG TO SUMWGT
C
COMPUTES AND RETURNS AVERAGE AND SIGMA.  INPUT IS AV=SUM(X) AND SIG=SUM(
C  OUTPUT IS AV = AVERAGE, SIG = SIGMA.  BOTH AV AND SIG ARE DOUBLE PREC
C
C  ENTRY WTDAVG COMPUTES WEIGHTED AVERAGE.  INPUT IS AV = SUM(WT*X),
C  SIG = SUM(WT*X*X),  SUMWT = SUM(WT)
C
      REAL*8 AV,SIG,SUMWT
      SUMWT=DFLOAT(NPTS)
3     AV=AV/SUMWT
      SIG=(SIG-AV*AV*SUMWT)*DFLOAT(NPTS)/(SUMWT*DFLOAT(NPTS-1))
      IF(SIG.GE.0.)GO TO 2
      WRITE(6,1)
1     FORMAT('0*****     SIGMA**2<0 IN SUBROUTINE DAVSIG     *******')
      SIG=-SIG
2     SIG=DSQRT(SIG)
      RETURN
C
      ENTRY WTDAVG(AV,SIG,SUMWGT,NPTS)
      SUMWT=SUMWGT
      GO TO 3
      END
