C						J. KRISTIAN
	LOGICAL*1 AUTO, WTODSK, DOAVGE
	CHARACTER CMD*50, CMDLIS*63, OUTYPE*1
	DATA CMDLIS/' SKREC  SKFILE  CHANGE_OUTPUT  STATUS
     *  REWIND  UNLOAD  QUIT'/
	DATA WTODSK/.FALSE./, OUTYPE/'D'/
C
	CALL INTRO(CMDLIS)
C
	CALL OPENMTIN(ID,1)
C
	NFILE = 1
	NREC = 0
C
	CALL GTOUTFORM(NA,NB,OUTYPE,AUTO,WTODSK,DOAVGE,N1AV,N2AV)
C
3	TYPE *,' '
	CALL GETCMD(' WHAT NEXT? ',CMDLIS,CMD,NWD)
	IF(NWD.EQ.0) CALL READTAPE(ID,NFILE,NREC,NA,NB,OUTYPE,AUTO,
     *  WTODSK,DOAVGE,N1AV,N2AV)
	IF(NWD.EQ.1) CALL SKIPREC(ID,NFILE,NREC)
	IF(NWD.EQ.2) CALL SKIPFILE(ID,NFILE,NREC)
	IF(NWD.EQ.3) CALL GTOUTFORM(NA,NB,OUTYPE,AUTO,WTODSK,
     *  DOAVGE,N1AV,N2AV)
	IF(NWD.EQ.4) CALL STATUS(ID)
	IF(NWD.EQ.5) CALL REWIND(ID,NFILE,NREC)
	IF(NWD.EQ.6) CALL UNLOAD(ID)
	IF(NWD.EQ.7) STOP
C
	GO TO 3
C
	END

	SUBROUTINE INTRO(CMDLIS)
C						J. KRISTIAN
	CHARACTER CMDLIS*(*)
C
	TYPE 1, CMDLIS
1	FORMAT(/' TO READ FROM THE TAPE AT ANY TIME, JUST TYPE A',
     *  ' CARRIAGE RETURN.'//
     *  ' THE FOLLOWING COMMANDS ARE AVAILABLE:'/A/
     *  ' TO SEE THE COMMAND LIST AT ANY TIME, TYPE IN "?"')
C
	TYPE 2
2	FORMAT(/' FOR INSTRUCTIONS, COMMENTS AND DOCUMENTATION,',
     *  ' SEE DOC:MTCHECK.DOC'/
     *  ' IF YOU NEED FURTHER HELP, SEE KRISTIAN.'/)
	RETURN
C
	END

	SUBROUTINE GTOUTFORM(NA,NB,OUTYPE,AUTO,WTODSK,DOAVGE,N1AV,N2AV)
C GETS PARAMETERS DEFINING OUTPUT FORMAT FROM USER.
C
	CHARACTER REPLY*1, OUTYPE*1
	LOGICAL*1 AUTO, WTODSK, DSKFOPEN, DOAVGE
	DATA DSKFOPEN/.FALSE./
C
	TYPE 1
1	FORMAT(/' I WILL PRINT BYTES A-B, INCLUSIVE, OF EACH RECORD.')
7	CALL NEW2I4(' TYPE IN VALUES FOR A AND B:  ',NA,NB)
	IF(NB.LT.0) NB = -NB   !ASSUMES USER INTENDED NA THROUGH NB.
	IF(NB.LT.NA) THEN
	  TYPE *,'INPUT ERROR: B CANNOT BE SMALLER THAN A.'
	  GO TO 7
	  END IF
	IF(NA.GT.0) THEN 
5	  TYPE 2
2	  FORMAT(' HOW DO YOU WANT THESE INTERPRETED?'
     *    ' (ASCII?  EBCDIC?  HEX?  DECIMAL?)  ',$)
	  ACCEPT 4 , REPLY
4	  FORMAT(A)
	  IF(REPLY.NE.'A'.AND.REPLY.NE.'E'.AND.REPLY.NE.'H'.
     *    AND.REPLY.NE.'D'.AND.REPLY.NE.' ') GO TO 5
	  IF(REPLY.NE.' ') OUTYPE = REPLY   !ELSE NO CHANGE
	  END IF
C
	DOAVGE = .FALSE.
	CALL TISTRG(' DO YOU WANT THE DECIMAL AVERAGE FOR PART '//
     *  'OF EACH RECORD?  ',REPLY)
	IF(REPLY.EQ.'Y') THEN
	  DOAVGE = .TRUE.
	  CALL NEW2I4(' FIRST AND LAST BYTES FOR AVERAGE? ',N1AV,N2AV)
	  IF(N2AV.LT.0) N2AV = -N2AV
	  IF(N1AV.LE.0.OR.N2AV.LT.N1AV) DOAVGE = .FALSE.
	  END IF
C
	CALL TISTRG(' SHALL I WRITE INFORMATION TO A PRINTABLE'//
     *  ' DISK FILE AS WELL AS THE TERMINAL? ',REPLY)
	IF(REPLY.EQ.'Y') THEN
	  WTODSK = .TRUE.
	  IF(DSKFOPEN) TYPE *,'DATA WILL BE ADDED TO FILE MTCHECK.LIS'
	  IF(.NOT.DSKFOPEN) THEN
	    OPEN (UNIT=7,NAME='MTCHECK.LIS',TYPE='NEW',DISP='KEEP')
	    DSKFOPEN = .TRUE.
	    TYPE 6
6	    FORMAT(' DATA WILL BE WRITTEN TO A NEW FILE MTCHECK.LIS')
	    END IF
	 ELSE
	  WTODSK = .FALSE.
	  END IF
C
	TYPE 3
3	FORMAT(' DO YOU WANT TO RUN THROUGH EACH FILE'
     *  ' AUTOMATICALLY?  ',$)
	ACCEPT 4, REPLY
	AUTO = .FALSE.
	IF(REPLY.EQ.'Y') AUTO = .TRUE.
	RETURN
	END

	SUBROUTINE READTAPE(ID,NFILE,NREC,NA,NB,OUTYPE,AUTO,WTODSK,
     *  DOAVGE,N1AV,N2AV)
	PARAMETER MAXBUF=65535
C 		THE MAXIMUM BUFFER LENGTH IS 65535 = 64*1024 - 1
C IF THE TAPE RECORD HAS MORE THAN 64K - 1
C BYTES, IT APPEARS THAT NOTHING IS TRANSFERRED TO THE
C BUFFER - IT JUST SPINS THROUGH TO THE NEXT RECORD OR EOR
C (FOUND BY TRYING TO READ A TYPE 0 TAPE)
	LOGICAL*1 BUFFER(MAXBUF),AUTO,WTODSK,DOAVGE
	INTEGER*2 DECOUT(MAXBUF)
	CHARACTER OUTYPE*1
C
	IF(NB.GT.MAXBUF) NB=MAXBUF
C		TO PREVENT SYSTEM CRASH.  CHANGE OF INPUT PARAMETER.
C
4	CONTINUE
	IF(NA.GT.0) THEN
	DO 11 I=NA,NB
11	BUFFER(I) = 0
	END IF
1	CALL MTREAD(ID,MAXBUF,BUFFER,LENGTH,IRET)
	CALL MTERRMESS('MTREAD',IRET,6)
	IF(WTODSK) CALL MTERRMESS('MTREAD',IRET,7)
	IF(IRET.EQ.2) RETURN
	NREC = NREC + 1
	IF(IRET.LT.2)
     *  CALL OUTPUT(LENGTH,OUTYPE,NA,NB,BUFFER,DECOUT,
     *  NFILE,NREC,AUTO,WTODSK,DOAVGE,N1AV,N2AV)
	IF(IRET.EQ.3) NFILE = NFILE + 1
	IF(IRET.EQ.3) NREC = 0
	IF(IRET.GT.1) RETURN
	IF(AUTO) GO TO 4
	RETURN
	END

	SUBROUTINE UNLOAD(ID)
	CALL MTUNLD(ID,IRET)
	CALL MTERRMESS('MTUNLD',IRET,6)
	IF(IRET.EQ.0) TYPE *, ' TAPE WILL BE REWOUND AND TAKEN OFFLINE'
	STOP
	END

	SUBROUTINE REWIND(ID,NFILE,NREC)
	TYPE 15
15	FORMAT(' REWINDING TAPE: HANG LOOSE')
	CALL MTREWI(ID,IRET)
	CALL MTERRMESS('MTREWI',IRET,6)
	IF(IRET.EQ.0) TYPE 17
17	FORMAT(' TAPE IS REWOUND.')
	NFILE = 1
	NREC = 0
	RETURN
	END

	SUBROUTINE STATUS(ID)
C
C READS THE MAG TAPE STATUS WORD, DECODES IT, AND TYPES MESSAGES
C DESCRIBING THE STATUS OF THE TAPE TO THE TERMINAL.
C
C ID (INPUT) IS THE IDENTIFYING NUMBER OF THE TAPE DRIVE USED BY MTCHECK
C
	LOGICAL*1 STWORD(4),TAPELOST,WRENABLE,EOT,EOF,BOT,EPARITY
C
	CALL STATUSWORD(ID,STWORD,IDENS,TAPELOST,WRENABLE,EOT,EOF,BOT,
     *  EPARITY,IRET)
C
	IF(IDENS.EQ.800) TYPE 800 
	IF(IDENS.EQ.1600) TYPE 1600
800	FORMAT(/' TAPE DENSITY = 800 BPI.')
1600	FORMAT(/' TAPE DENSITY = 1600 BPI.')
	IF(IDENS.NE.800.AND.IDENS.NE.1600) TYPE 4, STWORD(2)
4	FORMAT(' TAPE IS OF UNKNOWN DENSITY. MTSENS RETURNS',
     *  ' STATUS BYTE =',Z3,' (HEX).')
C
	IF(TAPELOST) THEN
	TYPE 5, STWORD(3)
5	FORMAT(' TAPE POSITION IS LOST. STATUS WORD (3) =',Z3,' (HEX)')
	RETURN
	ENDIF
C
	IF(BOT) TYPE 9
9	FORMAT(' TAPE IS POSITIONED AT ITS BEGINNING.')
	IF(EOF) TYPE 10
10	FORMAT(' HAVE JUST READ AN END OF FILE MARK.')
	IF(EOT) TYPE 11
11	FORMAT(' HAVE REACHED THE END OF THE TAPE.')
C
	IF(.NOT.WRENABLE) TYPE 6
6	FORMAT(' THERE IS NO WRITE RING ON THIS TAPE.')
	IF(WRENABLE) TYPE 8
8	FORMAT(' THERE IS A WRITE RING ON THIS TAPE.')
C
	TYPE 7, STWORD
7	FORMAT (' STATUS WORD (HEX) =',4Z3)
C
	RETURN
	END



	SUBROUTINE OUTPUT(LENGTH,OUTYPE,NA,NB,BUFFER,DECOUT,
     *  NFILE,NREC,AUTO,WTODSK,DOAVGE,N1AV,N2AV)
C NA THROUGH NB ARE THE CHARACTERS DESIRED IN THE OUTPUT.
C N1 THROUGH N2 ARE THE CHARACTERS ACTUALLY WRITTEN.
C THE FILE NUMBER, RECORD NUMBER AND BYTE COUNT ARE ALWAYS WRITTEN.
C
	LOGICAL*1 BUFFER(1), AUTO, WTODSK, DOAVGE,INTGR1
	INTEGER*2 DECOUT(1), INTGR2
	CHARACTER OUTYPE*1
	REAL*8 AVGE,SIGMA,X
	EQUIVALENCE (INTGR2,INTGR1)
C
	N1=NA
	N2 = JMIN0(NB,LENGTH)
C
	IF(DOAVGE) THEN
	  AVGE = 0.D0
	  SIGMA = 0.D0
	  I1 = N1AV
	  I2 = JMIN0(N2AV,LENGTH)
	  DO 8 I=I1,I2
	  INTGR1 = BUFFER(I)
	  X = INTGR2
	  AVGE = AVGE + X
8	  SIGMA = SIGMA + X*X
	  CALL DAVSIG(AVGE,SIGMA,I2-I1+1)
	  END IF
C
	IF(AUTO) THEN
	  IF(NREC.EQ.1) THEN
	    TYPE 1
	    IF(WTODSK) WRITE(7,1)
1	    FORMAT(/2X,'FILE',1X,'RECORD',1X,'BYTES',4X,'DATA'/)
	    END IF
	  IF(NA.EQ.0) THEN
	    TYPE 3, NFILE,NREC,LENGTH
	    IF(WTODSK) WRITE(7,3) NFILE,NREC,LENGTH
3	    FORMAT(1X,I4,I6,I7)
	    END IF
	 ELSE
	  TYPE 2, NFILE, NREC, LENGTH 
	  IF(WTODSK) WRITE(7,2) NFILE, NREC, LENGTH 
2	  FORMAT(/' FILE',I4,' RECORD',I4,' CONTAINS',I7,' BYTES.')
	  END IF
C
	IF(NA.EQ.0) THEN
	  IF(DOAVGE) THEN
	    TYPE 9, AVGE,SIGMA,I1,I2
9	    FORMAT(23X,' AVERAGE =',F7.2,' +/-',F7.2,', BYTES',I6,
     *      ' -',I6)
	    IF(WTODSK) WRITE(7,9) AVGE,SIGMA,I1,I2
	    END IF
	  RETURN
	  END IF
C
	IF(OUTYPE.EQ.'E') CALL ETOAST(N2,BUFFER)
C
	IF(OUTYPE.EQ.'D') THEN
	DO 13 I=N1,N2
	DECOUT(I)=BUFFER(I)
13	IF(DECOUT(I).LT.0) DECOUT(I) = DECOUT(I) + 256
	END IF
C
	IF(.NOT.AUTO) THEN
	IF(OUTYPE.EQ.'E'.OR.OUTYPE.EQ.'A') THEN
	  TYPE 7, (BUFFER(I),I=N1,N2)
	  IF(WTODSK) WRITE(7,7) (BUFFER(I),I=N1,N2)
7	  FORMAT(1X,80A1)
	  END IF
	IF(OUTYPE.EQ.'H') TYPE 10, (BUFFER(I),I=N1,N2)
	IF(OUTYPE.EQ.'H'.AND.WTODSK) WRITE(7,10) (BUFFER(I),I=N1,N2)
10	FORMAT(1X,26Z3)
	IF(OUTYPE.EQ.'I') TYPE 14, (BUFFER(I),I=N1,N2)
	IF(OUTYPE.EQ.'I'.AND.WTODSK) WRITE(7,14) (BUFFER(I),I=N1,N2)
	IF(OUTYPE.EQ.'D') TYPE 14, (DECOUT(I),I=N1,N2)
	IF(OUTYPE.EQ.'D'.AND.WTODSK) WRITE(7,14) (DECOUT(I),I=N1,N2)
14	FORMAT(1X,20I4)
	END IF
C
	IF(AUTO) THEN
	IF(OUTYPE.EQ.'E'.OR.OUTYPE.EQ.'A') THEN
	  TYPE 4, NFILE,NREC,LENGTH,(BUFFER(I),I=N1,N2)
	  IF(WTODSK) WRITE(7,4) NFILE,NREC,LENGTH,(BUFFER(I),I=N1,N2)
4	  FORMAT(1X,I4,I6,I7,2X,60A1/(20X,60A1))
	  END IF
	IF(OUTYPE.EQ.'H') THEN
	  TYPE 5, NFILE,NREC,LENGTH,(BUFFER(I),I=N1,N2)
	  IF(WTODSK) WRITE(7,5) NFILE,NREC,LENGTH,(BUFFER(I),I=N1,N2)
5	  FORMAT(1X,I4,I6,I7,2X,20Z3/(20X,20Z3))
	  END IF
	IF(OUTYPE.EQ.'I') THEN
	  TYPE 6, NFILE,NREC,LENGTH,(BUFFER(I),I=N1,N2)
	  IF(WTODSK) WRITE(7,6) NFILE,NREC,LENGTH,(BUFFER(I),I=N1,N2)
	  END IF
	IF(OUTYPE.EQ.'D') THEN
	  TYPE 6, NFILE,NREC,LENGTH,(DECOUT(I),I=N1,N2)
	  IF(WTODSK) WRITE(7,6) NFILE,NREC,LENGTH,(DECOUT(I),I=N1,N2)
6	  FORMAT(1X,I4,I6,I7,2X,15I4/(20X,15I4))
	  END IF
	END IF
C
	IF(DOAVGE) THEN
	  TYPE 9, AVGE,SIGMA,I1,I2
	  IF(WTODSK) WRITE(7,9) AVGE,SIGMA,I1,I2
	  END IF
C
	RETURN
	END
