      SUBROUTINE COSINE
C        THIS PROGRAM PREPARES THE INPUT CARDS FOR GENERAL PLANE FOURIER.
C        THE CALCULATED PLANE IS PERPENDICULAR TO THE AXIS OF TWO ATOMS
C        WITH A DISTANCE OF 'DNH1' TO ATOM 1.  IF A SET OF PARALLEL PLANES
C        ARE NEEDED ONE CAN ENTER AN INCREMENT (DIF) AND A UP LIMIT (DNH2)
C
C 1       FIRST INPUT CARD IS CELL CONSTANTS CARD (CRYM FORMAT).
C
C 2       SECOND CARD CONTAINS SCALE,DH,DV,IO,DNH1,DIF,DNH2 (3F10.5,I5,3F10.5)
C          SCALE = INCHES/ANGSTROM
C          DH  =  MAP HORIZONTAL DISTANCE IN A
C          DV  =   "  VERTICAL     "       "
C          IO  =  CODE FOR AXIS TO BE CONSTANT HORIZONTAL
C                 1 = X
C                 2 = Y
C                 3 = Z
      COMMON IS1
      CHARACTER*4 CARD(20)
      CHARACTER*17 NFILE
      CHARACTER*10 NAMDES
      INTEGER*4 SYS$TRNLOG
      IS1=0
      DATA IBLNK/'   '/
      DEG = 57.2958
      ICD=SYS$TRNLOG('NAM',NAMLEN,NAMDES,,,)
      IF(.NOT.ICD)THEN
        WRITE(3,999)
999     FORMAT(' ERROR ON RETURN FROM TRNLOG')
        RETURN
      ENDIF
      NFILE(1:NAMLEN)=NAMDES
      NFILE(NAMLEN+1:NAMLEN+4)='.GEN'
      OPEN(NAME=NFILE,UNIT=14,TYPE='NEW',FORM='FORMATTED',
     1 BLOCKSIZE=32768)
      WRITE (3,200)
      READ (1,100) A,B,C,AL,BE,GA
      IF (AL.EQ.0.) AL=90.
      IF (BE.EQ.0.) BE=90.
      IF (GA.EQ.0.) GA=90.
      WRITE(3,205) A,B,C,AL,BE,GA
      READ(1,103)CARD
C  IS IT COORD OR CONSTANTS CARD?
103   FORMAT(20A4)
      IF(CARD(1).EQ.'COOR')THEN
      SCALE=2.0
      DH=5.0
      DV=5.0
      IO=0
      DNH1=0.3
      DNH2=0.3
      DIF=0.1
      DECODE(80,102,CARD)N1,XA,YA,ZA
      GOTO 12
      ENDIF
      DECODE(80,101,CARD)SCALE,DH,DV,IO,DNH1,DIF,DNH2
      IF (DIF.EQ.0.AND.DNH2.NE.0.) GO TO 15
      IF(SCALE.EQ.0.0)SCALE=2.0
      IF(DH.EQ.0.0)DH=5.0
      IF(DV.EQ.0.0)DV=5.0
      IF (DNH1.EQ.0.) DNH1=0.3
      IF (DNH2.EQ.0.) DNH2=DNH1
      IF (DIF.EQ.0.) DIF=0.1
      WRITE(3,206) SCALE,DH,DV,IO,DNH1,DIF,DNH2
   10 READ (1,102) N1,XA,YA,ZA
12    IF (N1.EQ.IBLNK)GOTO 400
      READ (1,102) N2,XB,YB,ZB
      WRITE (3,102) N1,XA,YA,ZA
      WRITE (3,102) N2,XB,YB,ZB
      DNH =DNH1
      DX = XA-XB
      DY = YA-YB
      DZ = ZA-ZB
      DXX = DX*A
      DYY = DY*B
      DZZ = DZ*C
      CA = COS(AL/DEG)
      CB = COS(BE/DEG)
      CG = COS(GA/DEG)
      DIST = SQRT(DXX**2+DYY**2+DZZ**2+2.*DXX*DYY*CG+2.*DXX*DZZ*CB +
     1 2.*DYY*DZZ*CA )
      COA = (DXX+DYY*CG+DZZ*CB)/DIST
      COB = (DYY+DXX*CG+DZZ*CA)/DIST
      COC = (DZZ+DXX*CB+DYY*CA)/DIST
   11 XC =-(DX/DIST)*DNH + XB
      YC =-(DY/DIST)*DNH + YB
      ZC =-(DZ/DIST)*DNH + ZB
      WRITE (3,201) SCALE,COA,COB,COC,XC,YC,ZC,DH,DV,IO,N1,N2,DNH
      WRITE(14,204)  SCALE,COA,COB,COC,XC,YC,ZC,DH,DV,IO,N1,N2
      DNH = DNH + DIF
      IF (DNH.GT.DNH2) GO TO 10
      GO TO 11
   15 WRITE ( 3,203 )
      WRITE (  3,202 )
      WRITE ( 3,203 )
  100 FORMAT(6X,3F8.5,3F8.4)
  101 FORMAT  ( 3F10.5,I5,3F10.5 )
 102  FORMAT ( 6X,A4,5X,3F9.6)
C001  FORMAT(6X,A4,2X,A3,3F9.6,2X,F4.0,F6.2,6A2,1X,A3,2X,F7.5)
C 102 FORMAT ( 7X,A3,5X,3F9.6 )
  200 FORMAT ( 1H1 )
  201 FORMAT ( 10X,7HGENERAL,F5.1,2X,6F6.3,F4.1,F6.1,3X,I1,4X,A4,
     11H-,A4,F5.2,1HA/ )
  202 FORMAT(' DELTA, THE INCREMENT FOR CALCULATING A SERIES OF PLANES',
     +/,' IS BLANK OR 0 AND D2, THE LAST DISTANCE FOR MORE THAN ONE',
     +' PLANE',/,' IS NOT BLANK. THIS IS AN ERROR.')
  203 FORMAT (1H  '   ????????????????????????'/ )
204	FORMAT('GENERAL',1X,F6.4,6F7.4,2F6.3,I2,A4,1H-,A4,1X)
C 756	FORMAT('GENERAL ',F6.4,6F7.4,2F6.3,1X,I1,A10)
  205 FORMAT ( 1H0,9X,5HCELL ,3F9.5,1X,3F9.4 )
  206 FORMAT ( 1H0,9X,3F10.2,I5,3F10.2,// )
  208 FORMAT('GENERAL PLANE CENTER = (' ,F7.4,',',F7.4,',',F7.4,'),',
     122X,'*')
  209 FORMAT(4X,'COSINES = (',F6.3,',', F6.3,',', F6.3,'),',
     1' HEIGHT =',F4.1, ', WIDTH =',F4.1)
400   CLOSE(UNIT=14,DISP='SAVE')
      RETURN
      END
