C          MULTIPLE ENTRY GENERATING ROUTINES WITH 4 RETURNS
      SUBROUTINE GEN3(*,*,*,*)
C    RETURN 1 = GENOUT  RETURN 2 = GENDUP  RETURN 3 = ROTATE
C                RETURN 4 = PICKX  SKIP GEN HKL                     
      COMMON /GENN/GENH,OLDH,RNH,RNK,RNL,SPG,IPAR,GENSAP,NGEN,SCR,NGNS
C     COMMON /GENN/GENH,OLDH,RNH,RNK,RNL,SPGG,IPAR,GENSAP,NGN,SCRW
      INTEGER GENH(3),OLDH(4),RNH,RNK,RNL
      BYTE IPAR,GENSAP,NGEN,SCR,NGNS
      INTEGER*2 SPG
      BYTE RSV,PSV,FST
      DATA FST/0/
C     WRITE(3,10)GENH
C10    FORMAT('   IN GEN GENH=',3I5)
      RNH=-GENH(2)        ! HP=-K
      RNK=GENH(1)        ! KP=H
      RNL=GENH(3)        ! LP=L
      ngen=ngen-1        ! COUNT OF NUMBER OF POSSIBLE GENERATED REF.
      RETURN 1           ! GO TO GENOUT
      ENTRY GEN4(*,*,*)    ! TETRAGONAL 4/MMM
      RNH=GENH(2)        ! HP=K
      RNK=GENH(1)        ! KP=H
      RNL=GENH(3)        ! KL=L
      ngen=ngen-1        ! COUNT OF NUMBER OF POSSIBLE GENERATED REF.
      RETURN 1
      ENTRY GEN5(*,*,*)     ! CUBIC 23
      RNH=GENH(2)           ! HP=K
      RNK=GENH(3)           ! KP=L
      RNL=GENH(1)           ! LP=H
      NGEN=NGEN-1
      RETURN 2              ! GO TO GENDUP
      ENTRY GEN6(*,*,*)     ! CUBIC  432
      IF(FST.EQ.0)GENSAP=IPAR           ! SAVE PARITY
      FST=1
      RNH=GENH(2)            ! HP=K
      RNK=GENH(3)            ! KP=L
      RNL=GENH(1)            ! LP=H
      NGEN=NGEN-1             ! COUNT OF NUMBER OF GEN. REFLEC.
      IF(NGEN.EQ.0)FST=0
      IF(NGEN.EQ.2)THEN    ! 3RD TIME HERE TIME HERE
      IF(RNH.EQ.RNL)RETURN 4
      IF(RNK.EQ.RNL)RETURN 4        ! SKIP THIS REFLECTION
      RSV=RNH
      RNH=RNK
      RNK=RSV
      IPAR=GENSAP 
      RETURN 1       ! GO TO GENOUT
      ELSE
      RETURN 2       ! GO TO GENDUP
      ENDIF
      ENTRY GEN7(*,*,*,*)
      IF(FST.EQ.0)GENSAP=IPAR        ! SAVE ORIGINAL PARITY
      FST=1
C     WRITE(3,90)NGEN
90     FORMAT('  IN GEN7 NGEN=',I4)
      NGEN=NGEN-1
      IF(NGEN.EQ.0)FST=0   ! RESET PARITY SAVE SWITCH
      RNH=GENH(2)
      RNK=-GENH(2)-GENH(1)    ! I= -H-K
      RNL=GENH(3)
C     WRITE(3,91)GENH,FST,SCR,RNH,RNK,RNL
91     FORMAT(' IN GEN7 GENH=',3I6,'  FST=',I2,' SCR=',I2,' NEW=',3I4)
      IF(SCR.EQ.0)RETURN 2    ! NO SCREW AXIS
      IPAR=GENSAP
      RETURN 3                 ! ROTATE
      ENTRY GEN8(*,*,*,*)
      IF(FST.EQ.0)GENSAP=IPAR
      FST=1
      NGEN=NGEN-1
      IF(NGEN.EQ.0)FST=0
      RNH=GENH(2)
      RNK=-GENH(1)-GENH(2)
      RNL=GENH(3)
      IF(NGEN.EQ.2)THEN         ! FOR 3RD TIME HERE
      RSV=RNH
C     WRITE(3,80)NGEN,RSV,RNH
C80    FORMAT('  IN GEN8 NGEN=',I4,'  RSV=',I4,'  RNH=',I4)
      IF(RNH.EQ.0)THEN    ! SKIP IT
      NGEN=0
      RETURN 4
      ENDIF
      RNH=RNK
C     WRITE(3,81)NGEN,RNH,RNK
C81    FORMAT('  IN GEN8 NGEN=',I4,'  RNH=',I4,'  RNK=',I4)
      IF(RNK.EQ.0)THEN    ! SKIP IT
      NGEN=0
      RETURN 4
      ENDIF
      RNK=RSV
      RNL=-RNL
      IPAR=GENSAP
C     WRITE(3,82)RNH,RNK,RNL,IPAR
C82    FORMAT('  IN GEN8 RNH,RNK,RNL,IPAR=',4I4)
      IF(IPAR.EQ.0)RETURN 1     ! GENOUT
      PSV=-IPAR
      PSV=PSV+3     ! REVERSE PARITY
      GENSAP=PSV
      IF(SCR.EQ.1)IPAR=0
      RETURN 1
      ENDIF
      IF(SCR.NE.1)RETURN 2    ! GENDUP
      IPAR=GENSAP           ! 3 FOLD SCREW HERE
      RETURN 3             ! ROTATE
      ENTRY GEN9(*,*,*,*)
      IF(FST.EQ.0)GENSAP=IPAR
      FST=1
      NGEN=NGEN-1
      IF(NGEN.EQ.0)FST=0        !NEXT TIME GET NEW REFLECTION PARITY 
      RNK=GENH(1)+GENH(2)     ! KP=-I
      RNH=-GENH(2)                 ! HP=-K
      RNL=GENH(3)
      IPAR=GENSAP
      RETURN 3           ! ROTATE
      ENTRY GEN10(*,*,*,*)
      IF(FST.EQ.0)GENSAP=IPAR
      FST=1
      NGEN=NGEN-1
      IF(NGEN.EQ.0)FST=0
      IF(NGEN.EQ.2)THEN       ! FOR 3RD TIME HERE
      if(oldh(1).eq.oldh(2))THEN
      NGEN=NGNS
      RETURN 4
      ENDIF
      RNH=OLDH(1)
      RNK=OLDH(2)
      RNL=OLDH(3)        ! MIRROR PARALLEL TO 6
      IF(RNH.EQ.0)THEN      ! SKIP 0KL
      NGEN=NGNS            ! RESTORE NUMBER TO BE GENERATED
      RETURN 4            ! SKIP IT
      ENDIF
      RSV=RNH
      RNH=RNK
      IF(RNH.EQ.0)THEN      ! SKIP H0L
      NGEN=NGNS
      RETURN 4
      ENDIF
      RNK=RSV                ! SWAP H AND K
      IPAR=GENSAP            ! RESTORE PARITY
      RETURN 1             ! GENOUT
      ENDIF
      RNK=GENH(2)
      RNH=-RNK           ! HP=-K
      RNK=GENH(1)+GENH(2)    ! KP=-I
      RNL=GENH(3)
      IPAR=GENSAP
      RETURN 3         ! ROTATE
      ENTRY GEN11(*,*,*,*)
      IF(FST.EQ.0)GENSAP=IPAR
      FST=1
      NGEN=NGEN-1
      IF(NGEN.EQ.0)FST=0
      RNH=GENH(2)                ! HP=K
      RNK=-GENH(1)-GENH(2)       ! KP=I
      RNL=GENH(3)
      IF(NGEN.LT.3)THEN       ! FOR 3RD TIME HERE
      RSV=RNK                  ! MIRROR PARALLEL TO 3
      IF(RNK.EQ.0.AND.RNL.EQ.0)THEN     ! SKIP H00
      NGEN=NGNS
      RETURN 4
      ENDIF
      RNK=RNH
      IF(RNH.EQ.0.AND.RNL.EQ.0)THEN      ! SKIP 0K0
       NGEN=NGNS
      RETURN 4
      ENDIF
      IPAR=GENSAP
      IF(SCR.EQ.1)IPAR=0          
      RETURN 1         ! GENOUT
      ELSE
      ENDIF
      IF(SCR.NE.1)RETURN 2      ! GENDUP
      IPAR=GENSAP
      RETURN 3            ! ROTATE
      END
