       SUBROUTINE GETCOM
       BYTE FIRST,IGO,T(27)
      INTEGER DOIT,TEV
       COMMON /TRIG/TR1(8),TR2(8),TR3(8),TR4(8),TR5(8),TR6(8),
     1 ISPG,FIRST,IGO
      COMMON /COMB/ TCOM(24),FSC(20)                                    
      DATA T/3,1,1,3,3,1,1,3,1,2,0,0,2,2,0,2,2,0,0,0,0,0,0,2,2,0,0/
      COMMON /STORIT/TEV,HALF1,HALF2,NN
C               COMBINES TRIPLE PRODUCTS AND SCATTERING FACTORS
C        GETCOM CALCULATES COMBINATIONS OF TRIPLE PRODUCTS AND
C        SCATTERING FACTORS USING THE SPACE GROUP NUMBER TO DECIDE
C        WHICH ARE NECESSARY. DATA IS PASSED IN LABELED COMMON 'COMB'.
C        CALCULATIONS ARE OF THE EXPRESSIONS 1,3,5,...24 OF TABLE 7 AND
C         EXPRESSIONS 1,2,3,4,5,6,.......24 OF TABLE 10 ON PAGES 175
C        AND 179 OF THESIS
C        SPACE GROUP NO. IS PASSED IN NEXT TO LAST WORD OF COMMON 
C        'TRIG' AND IF NEGATIVE INDICATES LEAST SQUARES CALCULATION.
C         ON FIRST ENTRY TO PROGRAM A SWITCH IGO IS SET, DEPENDING
C        ON SPACE GROUP, TO CALCULATED EXPRESSIONS NEEDED.
       NSPG=ISPG
       IF(NSPG.LT.0)NSPG=-NSPG
       IF(NSPG.GT.167)GO TO 100    !  TO 100 FOR HEXAGONAL
       CALL PMMM(TR1,1,FSC(1),TCOM(1))
       IF(ISPG.NE.147.AND.ISPG.NE.148) THEN
       CALL MPPP(TR1,5,FSC(1),TCOM(3))   ! FOR LEAST SQUARES 147 
C    CALCULATE f*(-K+M+O+Q)
       ELSE                              ! 148 ISPG=-147,-148
       ENDIF                             ! AND TCOM(3),(7),(11)
       CALL PMMM(TR6,1,FSC(3),TCOM(5))
       IF(ISPG.NE.147.AND.ISPG.NE.148) THEN
       CALL MPPP(TR6,5,FSC(3),TCOM(7))
       ELSE
       ENDIF
       CALL PMMM(TR4,1,FSC(5),TCOM(9))
       IF(ISPG.NE.147.AND.ISPG.NE.148) THEN
       CALL MPPP(TR4,5,FSC(5),TCOM(11))
       ELSE
       ENDIF
      IF(ISPG.LT.0)THEN
      FIRST=15
      IGO=13
      GO TO 13
       ELSE
       ENDIF
       IF(NSPG.LT.148)GO TO 6
       IF(FIRST.EQ.0) THEN    ! DO THIS ON FIRST TIME ONLY
       NSPG=NSPG-148   ! 1,2,...19  FOR 149 TO 167
       GO TO(1,2,1,2,1,2,2,2,1,2,1,2,2,3,3,4,4,4,4),NSPG
1      FIRST=15
       IGO=13
       GO TO 5
2      FIRST=16
       IGO=14
       GO TO 5
3       FIRST=13
       IGO=13
       GO TO 5
4       FIRST=14
       IGO=14
       GO TO 5
       ELSE
       ENDIF
5      IF(IGO.EQ.13)GO TO 13
       GO TO 14
6      IF(ISPG.LT.0)THEN
       DO 60 I=1,20
       FSC(I)=0.0       ! CLEAR ARRAY FOR DERIVATIVE CALC.
60      CONTINUE
       ELSE
       ENDIF
       RETURN
13     CALL PMMM(TR2,1,FSC(7),TCOM(13))
C        f*(D-F-H-J)
       IF(FIRST.EQ.15)THEN
       CALL MPPP(TR2,5,FSC(7),TCOM(15))
       ELSE
       ENDIF
       CALL PMMM(TR5,1,FSC(9),TCOM(17))
       IF(FIRST.EQ.15)THEN
       CALL MPPP(TR5,5,FSC(9),TCOM(19))
       ELSE
       ENDIF
       CALL PMMM(TR3,1,FSC(11),TCOM(21))
       IF(FIRST.EQ.15)THEN
       CALL MPPP(TR3,5,FSC(11),TCOM(23))
       ELSE
       ENDIF
       IF(ISPG.LT.0)THEN
       FIRST=16
       GO TO 14
       ELSE
        ENDIF
       GO TO 6
14     CALL PMPP(TR2,1,FSC(8),TCOM(14))
       TCOM(14)=-TCOM(14)   ! -f(D-F+H+J)
       IF(FIRST.EQ.16)THEN
       CALL MMMP(TR2,5,FSC(8),TCOM(16))
       TCOM(16)=-TCOM(16)   !f(L+N+P-R)=-f(-L-N-P+R)
       ELSE
       ENDIF
       CALL PMPP(TR5,1,FSC(10),TCOM(18))
       TCOM(18)=-TCOM(18)    ! -f(C-E+G+I)
       IF(FIRST.EQ.16)THEN
       CALL MMMP(TR5,5,FSC(10),TCOM(20))
       TCOM(20)=-TCOM(20)
       ELSE
       ENDIF
       CALL PMPP(TR3,1,FSC(12),TCOM(22))
       TCOM(22)=-TCOM(22)    ! AS IN EXPR. 16
       IF(FIRST.EQ.16)THEN
       CALL MMMP(TR3,5,FSC(12),TCOM(24))
       TCOM(24)=-TCOM(24)
       ELSE
       ENDIF
       GO TO 6
100    NSPG=(NSPG-167)   ! INDEX FROM 1 TO 27
       IF(ISPG.LT.0)THEN
       TEV=0          ! CALCULATE ALL 24 EXPRESSIONS
       IF(NSPG.LT.10)TEV=1 ! UNLESS WE ONLY NEED 12
       ELSE
       TEV=T(NSPG)   ! T IS 0,1,2, OR 3
C  0 FOR CALCULATE 24, 1 FOR 12, 2 FOR ONLY ODD, 3 FOR ONLY ODD 1-11
       ENDIF
       CALL PMMM(TR1,1,FSC(1),HALF1)
       CALL PMPP(TR1,1,FSC(2),HALF2)
       NN=1
       CALL STORE       ! STORE 1 AND 2 (IF EVEN IS NEEDED)
       CALL MPPP(TR1,5,FSC(1),HALF1)
       CALL MMMP(TR1,5,FSC(2),HALF2)
       NN=3
       CALL STORE    ! STORE 3 AND 4 (IF EEVEN NEEDED)
       CALL PMMM(TR6,1,FSC(3),HALF1)
       CALL PMPP(TR6,1,FSC(4),HALF2)
       NN=5
       CALL STORE   ! STORE 5 AND 6  (IF)
       CALL MPPP(TR6,5,FSC(3),HALF1)
       CALL MMMP(TR6,5,FSC(4),HALF2)
       NN=7
       CALL STORE   ! 7 AND 8  (IF)
       CALL PMMM(TR4,1,FSC(5),HALF1)
       CALL PMPP(TR4,1,FSC(6),HALF2)
       NN=9
       CALL STORE
       CALL MPPP(TR4,5,FSC(5),HALF1)
       CALL MMMP(TR4,5,FSC(6),HALF2)
       NN=11
       CALL STORE           ! STORE 11 AND 12
       IF(TEV.EQ.3.OR.TEV.EQ.1)THEN
       GO TO 6
       ELSE
       CALL PMMM(TR2,1,FSC(7),HALF1)
       CALL PMPP(TR2,1,FSC(8),HALF2)
       NN=13
       CALL STORE
       CALL MPPP(TR2,5,FSC(7),HALF1)
       CALL MMMP(TR2,5,FSC(8),HALF2)
       NN=15
       CALL STORE
       CALL PMMM(TR5,1,FSC(9),HALF1)
       CALL PMPP(TR5,1,FSC(10),HALF2)
       NN=17
       CALL STORE
       CALL MPPP(TR5,5,FSC(9),HALF1)
       CALL MMMP(TR5,5,FSC(10),HALF2)
       NN=19
       CALL STORE
       CALL PMMM(TR3,1,FSC(11),HALF1)
       CALL PMPP(TR3,1,FSC(12),HALF2)
       NN=21
       CALL STORE
       CALL MPPP(TR3,5,FSC(11),HALF1)
       CALL MMMP(TR3,5,FSC(12),HALF2)
       NN=23
       CALL STORE
       GO TO 6
       ENDIF
       END
       SUBROUTINE STORE
       INTEGER TEV
       COMMON/STORIT/TEV,HALF1,HALF2,NN
      COMMON /COMB/ TCOM(24),FSC(20)                                          13
       TCOM(NN)=HALF1+HALF2
       IF(TEV.LT.2)THEN
       NN=NN+1     ! FOR EVEN NUMBERED EXPRESSIONS
       TCOM(NN)=HALF1-HALF2
       ELSE
       ENDIF
       RETURN
       END
       SUBROUTINE PMMM(TR,I,F,T)
       DIMENSION TR(8)
      T=(TR(I)-TR(I+1)-TR(I+2)-TR(I+3))*F
      RETURN
       END
       SUBROUTINE MPPP(TR,I,F,T)
       DIMENSION TR(8)
      T=(-TR(I)+TR(I+1)+TR(I+2)+TR(I+3))*F
       RETURN
       END
       SUBROUTINE PMPP(TR,I,F,T)
       DIMENSION TR(8)
      T=(TR(I)-TR(I+1)+TR(I+2)+TR(I+3))*F
       RETURN
       END
       SUBROUTINE MMMP(TR,I,F,T)
       DIMENSION TR(8)
      T=(-TR(I)-TR(I+1)-TR(I+2)+TR(I+3))*F
       RETURN
       END
