      SUBROUTINE HPOS
      CHARACTER*3 KF
      DIMENSION CATOM(3),AT(4),NT(4),CDUM(20)
      EQUIVALENCE (AT(1),A1),(AT(2),A2),(AT(3),A3),(AT(4),A4),
     1(NT(1),N1),(NT(2),N2),(NT(3),N3),(NT(4),N4)
      COMMON/HP/X(202),Y(202),Z(202),ATOM(200),AA,BB,CC,AB,AC,BC,TXT(12)
      DATA RAD/0.01745329/
      DATA TEMP/'ISO '/,BLANK/'    '/,COORD/'COOR'/,STOP/'END '/
    1 FORMAT (6X,3F8.5,3F8.4)
C    NEW TYPE FORMAT
2     FORMAT(A2,I2,4A4,2F10.5,6X,3A4,1X,A3)
3     FORMAT(' COORD ',I4,2X,A3,3F9.6)
    4 FORMAT(14X,3F10.5)
C    NEW COORD FORMAT
6     FORMAT(A2,4X,A4,5X,3F9.6)
   10 FORMAT (20A4)
   11 FORMAT ( 1H1,10X,20A4 )
83    FORMAT(' COORD ',A4,2X,A3,3F9.6)
12    FORMAT('0HYDROGEN AT ',A4,4X,'X',8X,'Y',8X,'Z',/)
913   FORMAT ( 5HCOORD,1X,I4,2X,A3,3F9.6 )
13    FORMAT('COORD',1X,A4,2X,A3,3F9.6)
   14 FORMAT (1H0,19X,3HISO,3X,I4,5X,F7.3 )
   15 FORMAT (     3HISO,3X,I4,5X,F7.3 )
61    FORMAT(' INPUT CELL CARD')
60    FORMAT(' INPUT COORDS',9X,'X',8X,'Y',8X,'Z',/)
63    FORMAT(1X,3F9.5,3F9.4)
      COMMON IS1
      IS1=0
      NCK=2
  101 READ(1,10)TXT
      WRITE(3,11)TXT
      READ(1,1) A,B,C,ALFA,BETA,GAMMA
      IF (ALFA.EQ.0.) ALFA=90.
      IF (BETA.EQ.0.) BETA=90.0
      IF (GAMMA.EQ.0.) GAMMA=90.0
      WRITE(3,61)
      WRITE(3,63)A,B,C,ALFA,BETA,GAMMA
      NHS=1
      NH = NHS - 1
C     CREATING ORTHONORMAL COORDINATE SYSTEM
      AA=A*A
      BB=B*B
      CC=C*C
      AB=A*B*COS(RAD*GAMMA)
      AC=A*C*COS(RAD*BETA)
      BC=B*C*COS(RAD*ALFA)
      ABSIN=A*B*SIN(RAD*GAMMA)
      ACSIN=A*C*SIN(RAD*BETA)
      BCSIN=B*C*SIN(RAD*ALFA)
C    CALCULATING CROSS PRODUCTS
      DET=AA*BB-AB*AB
      AXB1=(AB*BC-BB*AC)/DET
      AXB2=(AB*AC-AA*BC)/DET
      AXB3=ABSIN/DIST(AXB1,AXB2,1.0)
      AXB1=AXB1*AXB3
      AXB2=AXB2*AXB3
      DET=AC*AC-AA*CC
      AXC1=(AC*BC-AB*CC)/DET
      AXC3=(AB*AC-AA*BC)/DET
      AXC2=ACSIN/DIST(AXC1,-1.,AXC3)
      AXC1=AXC1*AXC2
      AXC3=AXC3*AXC2
      AXC2=-AXC2
      DET=BB*CC-BC*BC
      BXC2=(AC*BC-AB*CC)/DET
      BXC3=(AB*BC-AC*BB)/DET
      BXC1=BCSIN/DIST(1.0,BXC2,BXC3)
      BXC2=BXC2*BXC1
      BXC3=BXC3*BXC1
      X(202)=0.0
      Y(202)=0.0
      Z(202)=0.0
C    COORD CARD READ IN
      I=1
      WRITE(3,60)
102   READ(1,10)CDUM
66    FORMAT(A2)
      IF (CDUM(1).NE.COORD) GO TO 9100
	DECODE(80,6,CDUM)CARD,ATOM(I),X(I),Y(I),Z(I)
      WRITE(3,96)ATOM(I),X(I),Y(I),Z(I)
96    FORMAT(' COORD',3X,A4,5X,3F9.5)
      I=I+1
      GO TO 102
9100  NATOM=I-1
      GO TO 9101
100   READ(1,10)CDUM
9101  IF(CDUM(1).EQ.TEMP)GO TO 200
      IF(CDUM(1).EQ.STOP)GO TO 900
C    READ TYPE CARD
	DECODE(80,2,CDUM)CARD,NTYP,A1,A2,A3,A4,DH,VH,CATOM,KF
      NCK=2
      IF(DH.EQ.0.0)DH=0.95  ! DEFAULT
      IF(NTYP.EQ.2.AND.VH.EQ.0.0)VH=120.  ! DEFAULT
      IF(NTYP.GT.3.AND.VH.EQ.0.0)VH=(ACOS(-1./3.))/RAD  !DEFAULT
      IF(KF.EQ.'   ')KF='HS '  ! DEFAULT
      WRITE(3,92)NTYP ,A1,A2,A3,A4,DH,VH,CATOM,KF
92    FORMAT('0TYPE=',I3,' ATOMS ',4A4,' DH=',F10.5,' VH=',F10.5,
     1' LABEL=',3A4,' KF=',A3,/)
C    NEED TO SET N1,N2,N3,N4 TO PROPER INDEX
      DO 995 J=1,4
      DO 95 I=1,NATOM
      IF(AT(J).EQ.ATOM(I)) GO TO 94
      GO TO 95
94    NT(J)=I
      GO TO 995
95    CONTINUE
      GO TO 93
995   CONTINUE
      IF (NTYP.LT.1) GO TO 999
      IF(NTYP.GT.4.AND.VH.GT.120.)THEN
      WRITE(3,991)
991   FORMAT(' ILLEGAL ANGLE SPECIFIED. CARD SKIPPED.')
C   MAXIMUM ANGLE FOR NTYPS 5 AND 6 IS 120.
      GOTO 100
      ENDIF
      IF(NTYP.GT.6) GO TO 999
      GO TO (30,31,30,31,31,31), NTYP
   30 DH1=DH
      DH2=0.0
   31 CALL NORM(S1,S2,S3,N2,N1)
      CALL NORM(T1,T2,T3,N3,N1)
      GO TO (36,33,32,33,33,33), NTYP
   32 CALL NORM(V1,V2,V3,N4,N1)
      T1=T1+V1
      T2=T2+V2
      T3=T3+V3
      GO TO 36
33    IF(NTYP.GT.4)THEN
      VH=ACOS(SQRT(ABS(2./3.*(.5+COS(VH*RAD)))))
C   CALUCULATING "HALF" ANGLE
      ELSE
      VH=VH*RAD/2.0
      ENDIF
      DH1=DH*COS(VH)
      DH2=DH*SIN(VH)
C   FOR NTYPS 5 AND 6 -    X                Y                Z
C       ATOM 1          COS(VH)          SIN(VH)             0
C       ATOM 2          COS(VH)      -1/2*SIN(VH)    SQRT(3)/2*SIN(VH)
C       ATOM 3          COS(VH)      -1/2*SIN(VH)   -SQRT(3)/2*SIN(VH)
C   FOR NTYP 6, Y DIRECTION IS REVERSED
      GO TO (900,39,900,34,34,34),NTYP
   34 COF1=S1*T2-S2*T1
C   CALCULATING PLANE NORMAL  ("Z" DIRECTION FOR NTYPS 5 AND 6)
      COF2=S1*T3-S3*T1
      COF3=S2*T3-S3*T2
      X(201)=COF1*AXB1+COF2*AXC1+COF3*BXC1
      Y(201)=COF1*AXB2+COF2*AXC2+COF3*BXC2
      Z(201)=COF1*AXB3+COF2*AXC3+COF3*BXC3
   35 CALL NORM(SXT1,SXT2,SXT3,201,202)
      GO TO (900,37,900,36,41,41), NTYP
41    COF11=S1*SXT2-S2*SXT1
C   NTYPS 5 AND 6 - CALCULATING "Y" PLANE BY CROSSING PLANE NORMAL
C   WITH NORM OF N1 AND N2
      COF22=S1*SXT3-S3*SXT1
      COF33=S2*SXT3-S3*SXT2
      X(201)=COF11*AXB1+COF22*AXC1+COF33*BXC1
      Y(201)=COF11*AXB2+COF22*AXC2+COF33*BXC2
      Z(201)=COF11*AXB3+COF22*AXC3+COF33*BXC3
      CALL NORM(SYT1,SYT2,SYT3,201,202)
C   FOR NTYPS 5 AND 6 "X" PLANE IS NORM OF N1 AND N2
      SPT1=S1
      SPT2=S2
      SPT3=S3
      GOTO 37
   36 X(201)=S1+T1
      Y(201)=S2+T2
      Z(201)=S3+T3
      CALL NORM(SPT1,SPT2,SPT3,201,202)
37    IF(NTYP.GT.4)THEN
      ICK=1
      IF(NTYP.EQ.6)ICK=-1
C   "Y" DIRECTION IS REVERSED FOR STAGGERED AND ECLIPSED
      XH=X(N1)-SPT1*DH1+ICK*(SYT1*DH2)
C   FIRST ATOM FOR NTYPS 5 AND 6 IS IN PLANE - NO "Z" DIRECTION
      YH=Y(N1)-SPT2*DH1+ICK*(SYT2*DH2)
      ZH=Z(N1)-SPT3*DH1+ICK*(SYT3*DH2)
      ELSE
      XH=X(N1)-SPT1*DH1+SXT1*DH2
      YH=Y(N1)-SPT2*DH1+SXT2*DH2
      ZH=Z(N1)-SPT3*DH1+SXT3*DH2
      ENDIF
      NH = NH + 1
      WRITE(3,12)ATOM(N1)
      IF(CATOM(1).EQ.BLANK)GO TO 90
      WRITE(3,83)CATOM(1),KF,XH,YH,ZH
      WRITE(2,13)CATOM(1) ,KF,XH,YH,ZH
901   GO TO (100,38,100,38,42,42),NTYP
90    WRITE(3,3)NH,KF,XH,YH,ZH
      WRITE(2,913)NH,KF,XH,YH,ZH
      NHS=NH
      GO TO 901
  38  XH=XH-2.0*SXT1*DH2
      YH=YH-2.0*SXT2*DH2
      ZH=ZH-2.0*SXT3*DH2
43    NH = NH + 1
      IF(CATOM(NCK).EQ.BLANK)GO TO 902
      WRITE(3,83)         CATOM(NCK),KF,XH,YH,ZH
      WRITE(2,13)CATOM(NCK),KF,XH,YH,ZH
      IF(NCK.EQ.2)NCK=3
      IF(NTYP.GT.4)GOTO 45
      GO TO 100
902   WRITE(3,3)         NH,KF,XH,YH,ZH
      WRITE(2,913)NH,KF,XH,YH,ZH
      IF(NCK.EQ.2)NCK=3
      IF(NTYP.GT.4)GOTO 45
      GO TO 100
   39 SS=1.0/(S1*T1*AA+S2*T2*BB+S3*T3*CC+(S1*T2+S2*T1)*AB+(S1*T3+S3*T1)*
     1AC+(S2*T3+S3*T2)*BC)
      SPT1= S1
      SPT2= S2
      SPT3= S3
      X(201)=S1-SS*T1
      Y(201)=S2-SS*T2
      Z(201)=S3-SS*T3
      GO TO 35
42    DH2=-.5*DH*SIN(VH)
      DH3=SQRT(3.)/2.*DH*SIN(VH)
44    XH=X(N1)-SPT1*DH1+ICK*(SYT1*DH2)+SXT1*DH3
      YH=Y(N1)-SPT2*DH1+ICK*(SYT2*DH2)+SXT2*DH3
      ZH=Z(N1)-SPT3*DH1+ICK*(SYT3*DH2)+SXT3*DH3
      GOTO 43
45    DH3=-SQRT(3.)/2.*DH*SIN(VH)
      NTYP=1
      GOTO 44
C    ISO CARDS HERE
200	DECODE(80,7,CDUM)TEMPN
7     FORMAT(12X,F10.5)
      IF(CATOM(1).EQ.BLANK)GO TO 210
400   WRITE(3,414)CATOM(1),TEMPN
      WRITE(2,415) CATOM(1),TEMPN
414   FORMAT(1X,'ISO',3X,A4,2X,F10.5)
415   FORMAT('ISO',3X,A4,2X,F10.5)
      IF(CATOM(2).EQ.BLANK) GO TO 100
      WRITE(3,414)CATOM(2),TEMPN
      WRITE(2,415)CATOM(2),TEMPN
      IF(CATOM(3).EQ.BLANK)GO TO 100
      WRITE(3,414)CATOM(3),TEMPN
      WRITE(2,415)CATOM(3),TEMPN
      GO TO 100
210   DO 201 II=NHS,NH
      WRITE(3,14)II,TEMPN
      WRITE(2,15) II,TEMPN
201   CONTINUE
      GO TO 100
93    IF(AT(J).EQ.BLANK)GO TO 9993
      WRITE(3,993)AT(J)
993   FORMAT(' CANT FIND MATCHING COORD ATOM NUMBER FOR ',A4,
     1' FROM TYPE CARD. BOTH SHOULD BE A4.')
      GO TO 100
9993  NT(J)=0
      GO TO 995
900   RETURN
999   WRITE(3,88)
88    FORMAT('     ERROR ON INPUT')
      STOP 90
      END
      FUNCTION DIST(P,Q,R)
      COMMON/HP/X(202),Y(202),Z(202),ATOM(200),AA,BB,CC,AB,AC,BC,TXT(12)
      DIST=SQRT(P*P*AA+Q*Q*BB+R*R*CC+2.0*(P*Q*AB+P*R*AC+Q*R*BC))
      RETURN
      END
      SUBROUTINE NORM(P,Q,R,I,J)
      COMMON/HP/X(202),Y(202),Z(202),ATOM(200),AA,BB,CC,AB,AC,BC,TXT(12)
      P=X(I)-X(J)
      Q=Y(I)-Y(J)
      R=Z(I)-Z(J)
      ADST=DIST(P,Q,R)
      P=P/ADST
      Q=Q/ADST
      R=R/ADST
      RETURN
      END
