C     LSINV                                                             01     1
C     LEAST SQUARES MATRIX INVERSION ROUTINE                            01     2
      SUBROUTINE LSINV(ARY,BRY)                                         01     3
C     DIMENSION ARY(1),MLST(2,300),X(900),Y(900),Z(900),NUM(900),       01     4
C     DIMENSION     ARY(1),MLST(2,300),X(150),Y(150),Z(150),NUM(150),   01     5
C    1BVEC(2200),PA(2200),PB(2200),CARD(20)                             01     6
C     DIMENSION     ARY(1),MLST(2,310),X(150),Y(150),Z(150),NUM(150),   01     7
C     DOUBLE PRECISION BRY(1),A(311),B(311)                             01     8
      DOUBLE PRECISION BRY(1),A(1501),B(1501)                         
C     5/11/83 CHANGED DIMENSION OF A,B TO 1500 +1 FOR NUMBER OF
C               PARAMETERS ALLOWED IN ONE MATRIX PLUS ONE
      DIMENSION ARY(1),MLST(2,300),X(300),Y(300),Z(300),NUM(300),
     1BVEC(1500),PA(1500),PB(1500),CARD(20)                             01    11
      COMMON IS1,IS2,IS3,IS4,IS5,IS6,SCF,B2,CARD,JPAGE,IT1,IT2,X,Y,Z,   01    12
     1NUM,BVEC,MLST,JSI                                                 01    13
      EQUIVALENCE (GOF,B2),(NMAT,IS5)                                   01    14
	PARAMETER JT=5,KT=6
      REWIND KT                                                         01    17
      LM=1                                                              01    18
      KM=0                                                              01    19
      DO 20 I=1,NMAT                                                    01    20
      IP=MLST(1,I)-1                                                    01    21
      IN=MLST(2,I)                                                      01    22
      IF (IP) 10,12,12                                                  01    23
   10 KM=KM+IN                                                          01    24
      GO TO 13                                                          01    25
   12 KM=KM+(IN*(IN+1))/2                                               01    26
   13 WRITE (KT)(ARY(M),M=LM,KM)                                        01    27
   20 LM=KM+1                                                           01    28
      REWIND KT                                                         01    29
C     CYCLE OVER MATRICES                                               01    31
C     CALCULATING SHIFTS AND STD. DEVS.                                 01    33
C     DO 817 I=1,NMAT                                                   01    35
      DO 8817 I=1,NMAT                                                  01    36
      IP=MLST(1,I)-1                                                    01    37
      IN=MLST(2,I)                                                      01    38
      IAR=1                                                             01    39
      IF (IP) 50,53,53                                                  01    40
   50 KM=IN                                                             01    41
      GO TO 54                                                          01    42
   53 KM=(IN*(IN+1))/2                                                  01    43
   54 READ (KT) (ARY(M),M=1,KM)                                         01    44
      IF(IP) 600,599,599                                                01    45
  599 IF(JSI) 620,620,918                                               01    46
C     HERE FOR DIAGONAL MATRICES                                        01    48
  600 IP=-IP-2                                                          01    50
      DO 610 L=1,IN                                                     01    51
      IPUF = L+IP                                                       01    52
      IF(ARY(IAR))605,605,606                                           01    53
  605 ANV=0.0                                                           01    54
      GO TO 607                                                         01    55
  606 ANV=1.0/ARY(IAR)                                                  01    56
  607 PA(IPUF)=ANV*BVEC(IPUF)                                           01    57
      PB(IPUF)=SQRT(ANV*GOF)                                            01    58
  610 IAR=IAR+1                                                         01    59
      GO TO 817                                                         01    60
C     INVERT THE MATRIX ERROR                                           01    62
  615 WRITE(3,614)                                                      01    64
      DO 616 L=1,KM                                                     01    65
  616 ARY(L)=0.0                                                        01    66
      DO 617 L=1,IN                                                     01    67
      IPUF=L+IP                                                         01    68
      PA(IPUF)=0.0                                                      01    69
  617 PB(IPUF)=0.0                                                      01    70
      GO TO 817                                                         01    71
  614 FORMAT('O MATRIX IS SINGULAR')                                    01    72
C     HERE FOR OTHER MATRICES                                           01    74
  620 IF(IN-1) 622,622,630                                              01    76
  622 IF (ARY(IAR)) 624,918,624                                         01    77
  624 ARY(IAR)=1.0/ARY(IAR)                                             01    78
      GO TO 918                                                         01    79
  630 KM1=KM+1                                                          01    80
      DO 634 L=1,KM                                                     01    81
      M=KM1-L                                                           01    82
  634 BRY(M)=ARY(M)*1.D0                                                01    83
      CALL CIVT(BRY,IN,A,B,IERR)                                        01    84
      IF (IERR) 615,640,615                                             01    85
  640 DO 643 L=1,KM                                                     01    86
  643 ARY(L)=BRY(L)                                                     01    87
  918 CONTINUE                                                          01    88
C     WRITE(2,998)(ARY(L),L=1,KM)                                       01    89
C     WRITE(3,999)(ARY(L),L=1,KM)                                       01    90
C 999 FORMAT(10E13.5)                                                   01    91
C 998  FORMAT(6E13.5)                                                   01    92
C       WRITE AND PUNCH INVERSE MATRIX********************************* 01    93
C                                                                       01    94
C     NOW HAVE INVERSE MATRIX                                           01    95
C                                                                       01    96
C     IN PLACE OF OLD MATRIX                                            01    97
C                                                                       01    98
C     GET SHIFTS AND STD. DEVIATIONS                                    01    99
C                                                                       01   100
      IAS=IAR                                                           01   101
      DO 816 J=1,IN                                                     01   102
      IPUF=IP+J                                                         01   103
      LJ=J-1                                                            01   104
      IF (ARY(IAR)) 810,810,811                                         01   105
  810 PB(IPUF)=0.0                                                      01   106
      PA(IPUF)=0.0                                                      01   107
      GO TO 816                                                         01   108
  811 PB(IPUF)=SQRT(ARY(IAR)*GOF)                                       01   109
      PA(IPUF)=0.0                                                      01   110
      IAM=IAS+LJ                                                        01   111
      IF(LJ)812,814,812                                                 01   112
  812 DO 813 L=1,LJ                                                     01   113
      IDP=IP+L                                                          01   114
      PA(IPUF)=PA(IPUF)+BVEC(IDP)*ARY(IAM)                              01   115
  813 IAM=IAM+IN-L                                                      01   116
  814 DO 815 L=J,IN                                                     01   117
      IDP=IP+L                                                          01   118
      PA(IPUF)=PA(IPUF)+BVEC(IDP)*ARY(IAM)                              01   119
  815 IAM=IAM+1                                                         01   120
  816 IAR=IAR+IN-LJ                                                     01   121
  817 WRITE (JT)(ARY(M),M=1,KM)                                         01   122
C     WRITE(2,8002)(ARY(M),M=1,KM)                                      01   123
8817  CONTINUE                                                          01   124
8002  FORMAT(5E16.10)                                                   01   125
8003  FORMAT(1X,8E16.10)                                                01   126
  819 CONTINUE                                                          01   127
      LM=1                                                              01   128
      KM=0                                                              01   129
       REWIND JT                                                        01   130
       READ(JT)                                                         01   131
       READ(JT)                                                         01   132
      DO 835 I=1,NMAT                                                   01   133
      IP=MLST(1,I)-1                                                    01   134
      IN=MLST(2,I)                                                      01   135
      IF (IP) 830,833,833                                               01   136
  830 KM=KM+IN                                                          01   137
      GO TO 834                                                         01   138
  833 KM=KM+(IN*(IN+1))/2                                               01   139
  834 READ (JT) (ARY(M),M=LM,KM)                                        01   140
  835 LM=KM+1                                                           01   141
      WRITE (JT)PA,PB                                                   01   142
      RETURN                                                            01   143
      END                                                               01   144
      SUBROUTINE CIVT (ARY,IN,PB,PA,IERR)                               01    12
      DOUBLE PRECISION ARY(1),TEMP,BARY,PA(1),PB(1),PFA,ZROD            01    13
      COMMON /TLRN/ZROD                                                 01    14
      DIMENSION LE(1501)    ! CHANGED 5/11/83 FOR NUMBER OF PARAMS.   
C                              IN ONE MATRIX.
      NOZ=0
      JX=(IN*(IN+1))/2                                                  01    17
      IAR=1                                                             01    18
      IERR=0                                                            01    19
      IN1=IN+1                                                          01    20
      DO 910 J=1,IN                                                     01    21
      LJ=J-1                                                            01    22
      IAM=J                                                             01    23
 1901 FORMAT(5X,'ARY(',I9,')=',E12.6)                                   01    24
1902  FORMAT(' THE FOLLOWING DIAGONAL ELEMENTS ARE BELOW THE',
     1' TOLERANCE:')
       IF(ARY(IAR).LE.ZROD) GO TO 909                                   01    25
C    DEFAULT IS ZROD=1.D-1, ANOTHER VALUE FOR ZROD MAY BE               01    26
C    ENTERED ON THE GARBAGE CARD.                                       01    27
  901 PFA=DSQRT(ARY(IAR))                                               01    28
      PB(J)=PFA                                                         01    29
      IF(LJ) 903,905,903                                                01    30
  903 DO 904 L=1,LJ                                                     01    31
      ARY(IAM)=ARY(IAM)/PFA                                             01    32
  904 IAM=IAM+IN-L                                                      01    33
  905 DO 906 L=J,IN                                                     01    34
      ARY(IAM)=ARY(IAM)/PFA                                             01    35
  906 IAM=IAM+1                                                         01    36
      ARY(IAR) = 1.0                                                    01    37
      GO TO 910                                                         01    38
909   IF(NOZ.EQ.0)THEN
      NOZ=1
      WRITE(3,1902)
      ENDIF
      WRITE(3,1901)IAR,ARY(IAR)                                         01    39
      ARY(IAR)=1.0                                                      01    40
      PB(J)=0.0                                                         01    41
  910 IAR=IAR+IN-LJ                                                     01    42
C                                                                       01    43
C     2. DIAGONALIZE                                                    01    44
C                                                                       01    45
C     AT THIS POINT ALL DIAGONAL                                        01    46
C                                                                       01    47
C     A(I,I)ELEMENTS =1.                                                01    48
C                                                                       01    49
C     FIRST ROW IS DIFFERENT STORAGE                                    01    50
C                                                                       01    51
      DO 911 J=2,IN                                                     01    52
  911 PA(J)=-ARY(J)                                                     01    53
      IAD=IN1                                                           01    54
      DO 913 J=2,IN                                                     01    55
      DO 912 K=J,IN                                                     01    56
      ARY(IAD)=ARY(IAD)+PA(K)*ARY(J)                                    01    57
  912 IAD=IAD+1                                                         01    58
  913 CONTINUE                                                          01    59
C                                                                       01    60
C     OTHER ROWS                                                        01    61
C                                                                       01    62
      IAR=IN1                                                           01    63
      DO 928 I=2,IN                                                     01    64
      BARY=0.0                                                          01    65
      IAD=IAR                                                           01    66
      IH=I+1                                                            01    67
      DO 915 J=I,IN                                                     01    68
      TEMP=DABS(ARY(IAD))                                               01    69
      IF(TEMP-BARY)915,915,914                                          01    70
  914 BARY=TEMP                                                         01    71
      L=J                                                               01    72
  915 IAD=IAD+IN1-J                                                     01    73
      LE(I)=L                                                           01    74
      IF (L-I) 917,921,917                                              01    75
C                                                                       01    76
C     INTERCHANGE                                                       01    77
C                                                                       01    78
  917 IAD=IAR                                                           01    79
      IAM=IAR+L-I                                                       01    80
      IAS=IAM                                                           01    81
      DO 920 J=I,IN                                                     01    82
      TEMP=ARY(IAD)                                                     01    83
      ARY(IAD)=ARY(IAM)                                                 01    84
      ARY(IAM)=TEMP                                                     01    85
      IAD=IAD+1                                                         01    86
      IF(J-L) 918,919,919                                               01    87
  918 IAM=IAM+IN-J                                                      01    88
      GO TO 920                                                         01    89
  919 IAM=IAM+1                                                         01    90
  920 CONTINUE                                                          01    91
      TEMP=ARY(IAR)                                                     01    92
      ARY(IAR)=ARY(IAS)                                                 01    93
      ARY(IAS)=TEMP                                                     01    94
  921 IF(ARY(IAR)) 922,615,922                                          01    95
  615 IERR=1                                                            01    96
      RETURN                                                            01    97
C                                                                       01    98
C     DO TRANSFORMATION AND INVERSION                                   01    99
C                                                                       01   100
  922 TEMP=1.0/ARY(IAR)                                                 01   101
      ARY(IAR)=TEMP                                                     01   102
      IF(I-IN) 923,956,923                                              01   103
  923 IPUF=IAR-IN1+I                                                    01   104
      IAM=IAR+1                                                         01   105
      IAS=IAM+IN-IH                                                     01   106
      ISV=IPUF                                                          01   107
      DO 924 J=IAM,IAS                                                  01   108
      ARY(IPUF)=-TEMP*ARY(J)                                            01   109
  924 IPUF=IPUF+1                                                       01   110
      IAD=IAS+1                                                         01   111
      IPUF=IPUF-1                                                       01   112
      DO 927 J=IAM,IAS                                                  01   113
      TEMP=ARY(J)                                                       01   114
      DO 926 K=ISV,IPUF                                                 01   115
      ARY(IAD)=ARY(IAD)+ARY(K)*TEMP                                     01   116
  926 IAD=IAD+1                                                         01   117
  927 ISV=ISV+1                                                         01   118
  928 IAR=IAR+IN1-I                                                     01   119
C                                                                       01   120
C  3. RESTORATION BEGINS                                                01   121
C                                                                       01   122
  930 I=I-1                                                             01   123
      IAS=IAR-1                                                         01   124
      IAR=IAR-IN1+I                                                     01   125
      IAM=IAR+1                                                         01   126
      DO 932 J=IAM,IAS                                                  01   127
  932 ARY(J)=0.0                                                        01   128
      IAD=IAR+IN1-I                                                     01   129
      IPAF=IAR-IN1+I                                                    01   130
      DO 947 J=IAM,IAS                                                  01   131
      IPUF=IPAF                                                         01   132
      DO 945 K=J,IAS                                                    01   133
      ARY(K)=ARY(K)+ARY(IPAF)*ARY(IAD)                                  01   134
      IF(J-K) 943,944,943                                               01   135
  943 ARY(J)=ARY(J)+ARY(IPUF)*ARY(IAD)                                  01   136
  944 IPUF=IPUF+1                                                       01   137
  945 IAD=IAD+1                                                         01   138
      ARY(IAR)=ARY(IAR)+ARY(IPAF)*ARY(J)                                01   139
  947 IPAF=IPAF+1                                                       01   140
C                                                                       01   141
C     INTERCHANGE                                                       01   142
C                                                                       01   143
      IF(LE(I)-I) 950,956,950                                           01   144
  950 L=LE(I)                                                           01   145
      IAD=IAR                                                           01   146
      IAM=IAR+L-I                                                       01   147
      IAS=IAM                                                           01   148
      DO 955 J=I,IN                                                     01   149
      TEMP=ARY(IAD)                                                     01   150
      ARY(IAD)=ARY(IAM)                                                 01   151
      ARY(IAM)=TEMP                                                     01   152
      IAD=IAD+1                                                         01   153
      IF(J-L) 952,953,953                                               01   154
  952 IAM=IAM+IN-J                                                      01   155
      GO TO 955                                                         01   156
  953 IAM=IAM+1                                                         01   157
  955 CONTINUE                                                          01   158
      TEMP=ARY(IAR)                                                     01   159
      ARY(IAR)=ARY(IAS)                                                 01   160
      ARY(IAS)=TEMP                                                     01   161
  956 IF(I-2) 930,960,930                                               01   162
C                                                                       01   163
C     RESTORE FIRST ROW                                                 01   164
C                                                                       01   165
  960 IAR=1                                                             01   166
      DO 962 J=2,IN                                                     01   167
  962 ARY(J)=0.0                                                        01   168
      IAD=IN1                                                           01   169
      DO 967 J=2,IN                                                     01   170
      DO 964 K=J,IN                                                     01   171
      ARY(K)=ARY(K)+PA(J)*ARY(IAD)                                      01   172
      IF(J-K) 963,964,963                                               01   173
  963 ARY(J)=ARY(J)+PA(K)*ARY(IAD)                                      01   174
  964 IAD=IAD+1                                                         01   175
  967 ARY(IAR)=ARY(IAR)+PA(J)*ARY(J)                                    01   176
C                                                                       01   177
C  4. UNNORMALIZE                                                       01   178
C                                                                       01   179
      DO 990 J=1,IN                                                     01   180
      LJ=J-1                                                            01   181
      PFA=PB(J)                                                         01   182
      IF(PFA  ) 982,981,982                                             01   183
  981 ARY(IAR)=0.0                                                      01   184
      GO TO 990                                                         01   185
  982 IAM= J                                                            01   186
      IF(LJ) 983,985,983                                                01   187
  983 DO 984 L=1,LJ                                                     01   188
      ARY(IAM)=ARY(IAM)/PFA                                             01   189
  984 IAM=IAM+IN-L                                                      01   190
  985 DO 986 L=J,IN                                                     01   191
      ARY(IAM)=ARY(IAM)/PFA                                             01   192
  986 IAM=IAM+1                                                         01   193
      ARY(IAR)=ARY(IAR)/PFA                                             01   194
  990 IAR=IAR+IN-LJ                                                     01   195
      RETURN                                                            01   196
      END                                                               01   197
