      SUBROUTINE LSTHX (ARY)                                                   
C     TRIGONAL-HEXAGONAL VERSION                                               2
C               COMPILED SUNDAY AFTERNOON MARCH 1 1981
C               WILL NOT PUT ANOMALOUS CORRECTION INTO DERIVATIVES
C               I AM WORKING ON THE DERIVATIVE ROUTINES
	CHARACTER*20 DIN
        CHARACTER*80 INFC
        CHARACTER*1 CHAR1
        BYTE IFOP,IONCE,INSEC
	INTEGER*4 SYS$ASCTIM,PNFCP,PNRLS
        DIMENSION X(300),Y(300),Z(300),B(300),KIND(300),KREF(300),
     1 NUM(300),IPC(300),IPB(300),POP(300),SHFTC(300),SHFTB(300),
     2 NPAT(300),BAC(300),AAC(300),IICODE(300),BAN(1800),
     3 ARY(1),WGT(6),F(12),PI(9),LE(100),SP(8),CARD(20),
     4 POPIF(2,10),NPOPI(4,10),MLST(2,300),PA(1500),PB(1500),BVEC(1500)
      COMMON IS1,IS2,IS3,IS4,IS5,IS6,SCF,B2,CARD,JPAGE,IT1,IT2,X,Y,Z,          8
     1NUM,BVEC,MLST,JSI                                                        9
      COMMON /SAVE/IUSA,NSV,PTST,IQ
      COMMON/INFFILE/IFOP,IONCE,INSEC   ! INF FILE,NEG. SEC. EXT.
C  IFOP = 1 MEANS INF FILE IS OPENED SO INFO MAY BE ADDED TO IT
C  IONCE = 0 FIRST TIME THRU, = 1 FOR ALL OTHERS.
C  SOME PARAMS ARE ONLY WRITTEN FIRST TIME THROUGH.
      REAL*8 SFOS,SFCS,SFOFC,SWDEL,SFOBS,SFCAL,SDELF                          10
      REAL*8 SPFOS,SPFCS,PFOFC,SPWDEL,SPFOBS,SPFCAL,SPDELF
      REAL*4 IAK(300)
      BYTE FIRST,IGO,IDER(4,40),CODE(2,40)
      COMMON /TRIG/ TR1(8),TR2(8),TR3(8),TR4(8),TR5(8),TR6(8),M6,      
     1 FIRST,IGO
C
      COMMON /COMB/ TCOM(24),FSC(20)                                          13
      COMMON /CDCOM/CODE,IDER,NUMB,M5,M1,M2,IH,IK,IL,PIH,PIK,
     1PIL,PII,H11,H22,H33,H12,H13,H23,S,T,U,V                                 15
C    NUMB = NUMBER OF CHARACTERS IN CODE                                      16
C     M1= PARITY CODE NUMBER, M2= DIVISOR FOR PARITY TEST, M4= ISPG-142.    
            INTEGER*2 MPOP(2,10)                                        
        DIMENSION IA1(3),IA2(3),IA3(3),IA4(3),IA5(3),IA6(3)
      EQUIVALENCE (IA1(1),TR1(1)),(IA2(1),TR2(1)),(IA3(1),TR3(1)),            21
     1(IA4(1),TR4(1)),(IA5(1),TR5(1)),(IA6(1),TR6(1))                         22
      EQUIVALENCE (FSC(1),F1),(FSC(2),F2),(FSC(3),F3),(FSC(4),F4),            23
     1(FSC(5),F5),(FSC(6),F6),(FSC(7),F7),(FSC(8),F8),(FSC(9),F9),            24
     2(FSC(10),F10),(FSC(11),F11),(FSC(12),F12)                               25
      DIMENSION FPOPI(10)                                                     26
      JT=5                                                                    27
      REWIND JT                                                               28
      READ(JT)B,KIND,KREF,WGT,BAN,IPC,IPB,POP,MLST,IAK,POPIF,NPOPI,NPAT       29
     1,SHFTC,SHFTB                                                            30
      READ(JT)MSTO,M1,M2,M3,KWG,NA,NPAR,NMAT,FMIN,NACC,NOPR,SMIN,             31
     1SMAX,SSHFT,ISC,M4,M5,M6,WWD,ICEN,NRPOP,GF,IGF,FLAMS,SECSS,MPOP,         32
     2ISPG,IICODE                                                             33
  230 NPR=0                                                                   34
      NRLS=0                                                                  35
      FP=.25*FMIN                                                             36
      FL=1.0/(FP*FMIN)                                                        37
      FLR=SQRT(FL)                                                            38
      NLTH=0                                                                  39
      NREF=0                                                                  40
      SFOBS=0.0                                                               41
      SFCAL=0.0                                                               42
      SDELF=0.0                                                               43
      SFOS=0.0                                                                44
      SFCS=0.0                                                                45
      SWDEL=0.0                                                               46
      LTLS=0                                                                  47
      SFOFC=0.0                                                               48
      SPFOS=0.0
      SPFCS=0.0
      PFOFC=0.0
      SPWDEL=0.0
      SPFOBS=0.0
      SPFCAL=0.0
      SPDELF=0.0
      PNFCP=0
      PNRLS=0
      ISPG=M5
      IPAR=M1
      IMOD=M2
C   SUM ABS(WFOB)*WFCL                                                        49
      NFCP=0                                                                  50
C    SUM W.NE.0 AND FSQ.NLT.0                                                 51
C    DONT REFILL COS TABLE FOR RECYCLE                                        52
      IF(JPAGE.NE.0)GO TO 9231                                                53
C    SET UP COS TAB                                                           54
C    TPI=2.*3.1415926                                                        55
C      DO 9230 J=1,2049                                                        56
C9230   QUAD1(J)=COS(FLOAT(J-1)*TPI/8192.)                                     57
C      NEGATIVE ISPG IS USED BY GET COM TO INDICATE LEAST SQUARES             58
9231  M5=ISPG                                                                 59
      IF(IS1.NE.0) M5=-M5                                                     60
      M6=M5                                                                   61
      DO 193 I=2,24                                                           62
193   TCOM(I)=0.0                                                             63
      DO 194 I=1,3                                                            64
      IA1(I)=0                                                                65
      IA2(I)=0                                                                66
      IA3(I)=0                                                                67
      IA4(I)=0                                                                68
      IA5(I)=0                                                                69
194   IA6(I)=0                                                                70
      DO 96 I=1,6                                                             71
96    FSC(I)=0.0                                                              72
      IF (IS1) 5,11,5                                                         73
    5 DO 10 I=1,NPAR                                                          74
       PB(I)=0.0
   10 BVEC(I)=0.0                                                             75
      IF (JSI) 8,8,11                                                         76
    8 DO 9 I=1,MSTO                                                           77
    9 ARY(I)=0.0                                                              78
   11 CONTINUE                                                                79
   91 FORMAT(' ',3I6,7F8.2)
   92 FORMAT( '0    H     K     L   FOBS    FCAL     DF      WDEL    AC      81
     1AL    BCAL      SSQLS',10X,A/)
C93    FORMAT('0',3(2X,F10.2),F9.3,2I6/' ',4E12.4,F9.5,I6)                     83
93    FORMAT('0Sum|Fo|=',F10.2,'   Sum|Fc|=',F10.2,'   Sum|DF|=',F10.2,
     1'   R=',F10.4,'   N(R)=',I6,'   N(TOTAL)=',I6,/,'0Sum wFo**4=',
     2E10.4,'  Sum wFc**4=',E10.4,'  Sum wFo**2*Fc**2=',E10.4,'  Sum ',
     3'w(DF**2)**2=',E10.4,'  RWF**2=',F6.4,'  N(W)=',I5)
   94 FORMAT('0  ',I4,' LESS THANS, ',I4,' IN LS,',/,' GOF = ',E10.3,
     1' FOR ',I6,' REFLECTIONS AND ',I5,' PARAMETERS.')
      IF (NOPR) 16,16,17                                                      86
16	IER=SYS$ASCTIM(,DIN,,)
      WRITE(3,92)DIN                                                          88
   17 CONTINUE                                                                89
      KIN=0                                                                   90
C                                                                             91
C     READ A REFLECTION.                                                      92
C                                                                             93
   18 READ(IT1)K1,K2,K3,FABS,W,PIH,PIK,PIL,SSQLS,(F(M),M=1,12),(SP(M),        94
     1M=1,8),ACAL,BCAL                                                        95
C     TEST FOR END                                                            96
      IF(K1-999999)19,250,250                                                 97
C                                                                             98
C     PROCESS REFLECTION                                                      99
C                                                                            100
   19 H1=K1                                                                  101
      FOBS=ABS(FABS)                                                         102
      H2=K2                                                                  103
      H3=K3                                                                  104
C    FIX UP INPUT TO TRIP                                                    105
C      TK1=K1*16384.*2.                                                       106
C      TK2=K2*16384.*2.                                                       107
C      TK3=K3*16384.*2.                                                       108
C       TI=(-K1-K2)*16384.*2.                                                 109
      NSK=0                                                                  110
      IF(SSQLS-SMIN) 150,702,702                                             111
  702 IF(SSQLS-SMAX) 703,703,150                                             112
  703 CONTINUE                                                               113
      NSK=1                                                                  114
C   PTST AND IQ ARE IN COMMON /SAVE/.  IF PTST =0.0, NO TEST
      IF(PTST.EQ.0.0) GO TO 9703
      IF(W.EQ.0.0) GO TO 9701
      PSIG=(1.0/W)*PTST
      PSIG=ABS(PSIG)
      GO TO 9702
9701  PSIG=0.0
9702  FBSQ=FABS*FABS
      IF(FABS.LT.0.0)FBSQ=-FBSQ   ! SIGN OF FABS TO FBSQ
      IF(IQ.NE.0) GO TO 9703
C   IF IQ.NE.0 INCLUDE ALL BUT KEEP SEPARATE SUMS FOR FBSQ.LT.PSIG
C   IF IQ=0 OMIT FBSQ.LT.PSIG
      IF(W.LT.0.0) GO TO 150
      IF(PTST)9705,9703,9704
9704  IF(FABS.LT.0) GO TO 150
      IF(FBSQ.LE.PSIG) GO TO 150
      GO TO 9703
9705  IF(FBSQ.GE.PSIG) GO TO 150
C     OMIT FROM CALCULATION
9703  CONTINUE
      H11=H1*H1                                                              115
      H22=H2*H2                                                              116
      H33=H3*H3                                                              117
      H23=H2*H3                                                              118
      H13=H1*H3                                                              119
      H12=H1*H2                                                              120
      H22H12=H22+H12                                                         121
      H11H12=H11+H12                                                         122
      H13H23=H13+H23                                                         123
C     K**2+HK, H**2+HK, HL+KL                                                124
      S=H11+H22+2*H12                                                        125
      PII=-PIH-PIK                                                           126
      T=-H22H12                                                              127
      U=-H11H12                                                              128
      V=-H13H23                                                              129
      IF(NACC) 21,20,21                                                      130
   20 ACAL=0.0                                                               131
      BCAL=0.0                                                               132
   21 CONTINUE                                                               133
C                                                                            134
C     WEIGHTING ROUTINE                                                      135
C                                                                            136
      GO TO (700,710,720,740,730),KWG                                        137
C                                                                            138
C     EXTERNAL WEIGHT                                                        139
C                                                                            140
  700 RTW=ABS(W)                                                             141
      GO TO 33                                                               142
C                                                                            143
C     UNIT WEIGHT                                                            144
C                                                                            145
  710 RTW=1.0                                                                146
      GO TO 33                                                               147
C                                                                            148
C     POLYNOMIAL WEIGHT                                                      149
C                                                                            150
  720 RTW=(WGT(1)+WGT(2)*SSQLS)/(WGT(3)+(WGT(4)+(WGT(5)+ WGT(6)*FOBS)        151
     1*FOBS)*FOBS)                                                           152
      GO TO 33                                                               153
C                                                                            154
C     1.0/FOBS**2                                                            155
C                                                                            156
730   IF(FOBS.EQ.0.0)THEN
        RTW=0.0
        GOTO 33
      ENDIF
      IF(FMIN-FOBS)731,731,725                                               157
  725 IF (FP-FOBS) 3725,3725,3723                                            158
 3723 RTW=FL                                                                 159
      GO TO 33                                                               160
 3725 RTW=1.0/(FOBS*FMIN)                                                    161
      GO TO 33                                                               162
  731 RTW=1.0/(FOBS*FOBS)                                                    163
      GO TO 33                                                               164
C                                                                            165
C     1/FOBS                                                                 166
C                                                                            167
740   IF(FOBS.EQ.0.0)THEN
        RTW=0.0
        GOTO 33
      ENDIF
      IF(FMIN-FOBS)30,30,25                                                  168
   25 IF (FP-FOBS) 3025,3025,3023                                            169
 3023 RTW=FLR                                                                170
      GO TO 33                                                               171
 3025 RTW = SQRT (1.0/(FOBS*FMIN))                                           172
      GO TO 33                                                               173
   30 RTW=1.0/FOBS                                                           174
   33 CONTINUE                                                               175
      RTW=RTW/SCF**2
   36 NAN=1                                                                  176
C     TRIX CALLED BY LSINIT SUPPLIES APPROPRIATE PARITY TEST INFORMATION     177
C     LATER USED BY CDHEX. PASSED TO CDHEX BY COMMON /CDCOM/.                178
C    CDHEX DOES PARITY TEST AND PUTS APPROPRIATE CODE FOR CALCULATING        179
C    A AND B INTO COMMON/CDCOM/ ARRAY CODE. IF THERE IS NO PARITY TEST       180
C    SKIP CDHEX AFTER 1ST TIME. M1 HAS PARITY TEST NUMBER. NO TEST IS 0      181
C    FIRST TIME AND IS .GT.3 ARTER FIRST TIME...                             182
      IF(M1.GT.3)GO TO 900                                                   183
      IH=K1                                                                  184
       IK=K2                                                                 185
      IL=K3                                                                  186
      CALL CDHEX                                                             187
      IF(M1.EQ.0)M1=9                                                        190
      IF (ICEN.EQ.1)NUMB=-NUMB                                               191
C         IH=99 IS SIGNAL OF PARITY ERROR                                    192
      IF(IH.EQ.99)GO TO 180                                                  193
900   CONTINUE                                                               194
C                                                                            195
C     CYCLE OVER ATOMS.                                                      196
C                                                                            197
      DO 125 I=1,NA                                                          198
      M=IABS(KIND(I))                                                        199
C                                                                            200
C     TRIGONAL AND HEXAGONAL S.F. ROUTINE                                    201
C                                                                            202
      DO 2 MN=1,10                                                           203
      IF(MPOP(1,MN)-I)2,1,2                                                  204
C     MPOP(1,10)  ATOM NO. FOR ATOMS WITH 2 F'S                              205
C     MPOP(2,10) POINTS TO KIND F OFF POP CARD                               206
    1 MP=MPOP(2,MN)                                                          207
      P=1.0-POPIF(1,MN)                                                      208
      IF(NRPOP.EQ.0)GO TO 1111                                               209
      FPOPI(MN)=P*F(MP)+POPIF(1,MN)*F(M)                                     210
C     SAVE FPOPI FOR DERIVATIVE                                              211
      FPOPI(MN)=(F(M)-F(MP))/FPOPI(MN)                                       212
 1111 CONTINUE                                                               213
      P=P*POP(I)/POPIF(1,MN)                                                 214
      P=P*F(MP)+F(M)*POP(I)                                                  215
      GO TO 3                                                                216
    2 CONTINUE                                                               217
      P=F(M)*POP(I)                                                          218
    3 CONTINUE                                                               219
2702  CONTINUE                                                               220
C       WRITE(13,6000)P,F(M),POP(I)
C6000   FORMAT(2X,'P=',E15.8,'F(M)=',E15.8,' POP(I)=',E15.8)
C      GET TRIGONOMETRIC TRIPLE PRODUCTS                                     221
C   IA1 ETC USED AS AN INDEX TO COS TABLE                                    222
C     IA1(1)=TK1*X(I)+2.                                                     223
      TR1(1)=PIH*X(I)
C     IA1(2)=TK2*Y(I)+2.                                                     224
      TR1(2)=PIK*Y(I)
C     IA1(3)=TK3*Z(I)+2.                                                     225
      TR1(3)=PIL*Z(I)
C     IA4(1)=TK1*Y(I)+2.                                                     226
      TR4(1)=PIH*Y(I)
C     IA4(2)=TI*X(I)+2.                                                      227
      TR4(2)=PII*X(I)
C     IA4(3)=TK3*Z(I)+2.                                                     228
      TR4(3)=PIL*Z(I)
C     IA6(1)=TI *Y(I)+2.                                                     229
      TR6(1)=PII*Y(I)
C     IA6(2)=TK2*X(I)+2.                                                     230
      TR6(2)=PIK*X(I)
C     IA6(3)=TK3*Z(I)+2.                                                     231
      TR6(3)=PIL*Z(I)
      IF(ISPG.LT.147)GO TO 1722                                              232
C     IA2(1)=TK1*Y(I)+2.                                                     233
      TR2(1)=PIH*Y(I)
C     IA2(2)=TK2*X(I)+2.                                                     234
      TR2(2)=PIK*X(I)
CC     IA2(3)=TK3*Z(I)+2.                                                     235
      TR2(3)=PIL*Z(I)
C     IA3(1)=TK1*X(I)+2.                                                     236
      TR3(1)=PIH*X(I)
C     IA3(2)= TI*Y(I)+2.                                                     237
      TR3(2)=PII*Y(I)
C     IA3(3)=TK3*Z(I)+2.                                                     238
      TR3(3)=PIL*Z(I)
C     IA5(1)= TI*X(I)+2.                                                     239
      TR5(1)=PII*X(I)
C     IA5(2)=TK2*Y(I)+2.                                                     240
      TR5(2)=PIK*Y(I)
C     IA5(3)=TK3*Z(I)+2.                                                     241
      TR5(3)=PIL*Z(I)
1722  CONTINUE                                                               242
      CALL TRIP                                                              243
C                                                                            244
C     PUT IN TEMPERATURE PART                                                245
C                                                                            246
C     BRANCH ACCORDING TO TYPE                                               247
C                                                                            248
      IF (KIND(I))1700,1720,1720                                             249
C                                                                            250
C     HERE FOR ANISOTROPIC                                                   251
C                                                                            252
C     F'S CORRESPOND TO SMALL F'S OF THESIS                                  253
1700  CONTINUE                                                               254
      F9=BAN(NAN)*H11+BAN(NAN+1)*H22+BAN(NAN+2)*H33+BAN(NAN+3)*H12           255
      TEM=BAN(NAN+4)*H13+BAN(NAN+5)*H23                                      256
      F1=F9+TEM                                                              257
      F2=F9-TEM                                                              258
      TEM=BAN(NAN)*H22+BAN(NAN+1)*S+BAN(NAN+2)*H33-BAN(NAN+3)*H22H12         259
      F8=BAN(NAN+4)*H23-BAN(NAN+5)*H13H23                                    260
      F3=TEM+F8                                                              261
      F4=TEM-F8                                                              262
      TEM=BAN(NAN)*S+BAN(NAN+1)*H11+BAN(NAN+2)*H33-BAN(NAN+3)*H11H12         263
      F8=-BAN(NAN+4)*H13H23+BAN(NAN+5)*H13                                   264
      F5=TEM+F8                                                              265
      F6=TEM-F8                                                              266
      TEM=BAN(NAN)*H22+BAN(NAN+1)*H11+BAN(NAN+2)*H33+BAN(NAN+3)*H12          267
      F8=BAN(NAN+4)*H23+BAN(NAN+5)*H13                                       268
      F7=TEM+F8                                                              269
      F8=TEM-F8                                                              270
      TEM=BAN(NAN)*S+BAN(NAN+1)*H22+BAN(NAN+2)*H33-BAN(NAN+3)*H22H12         271
      F12=-BAN(NAN+4)*H13H23+BAN(NAN+5)*H23                                  272
      F9=TEM+F12                                                             273
      F10=TEM-F12                                                            274
      TEM=BAN(NAN)*H11+BAN(NAN+1)*S+BAN(NAN+2)*H33-BAN(NAN+3)*H11H12         275
      F12=BAN(NAN+4)*H13-BAN(NAN+5)*H13H23                                   276
      F11=TEM+F12                                                            277
      F12=TEM-F12                                                            278
      NAN=NAN+6                                                              279
C     F'S CALCULATED FIND EXP(-F)                                            280
C                                                                            281
      F1=P*EXP(-F1)                                                         282
      F3=P*EXP(-F3)                                                         283
      F5=P*EXP(-F5)                                                         284
      F7=P*EXP(-F7)                                                         285
      F8=P*EXP(-F8)                                                         286
      F9=P*EXP(-F9)                                                         287
      F10=P*EXP(-F10)                                                       288
      F11=P*EXP(-F11)                                                       289
      F12=P*EXP(-F12)                                                       290
C6001   FORMAT('   F1 THRU F12='4E15.8,/,11X,4E15.8)
      IF(ISPG.LT.168)GO TO 1721                                              291
      F2=P*EXP(-F2)                                                         292
      F4=P*EXP(-F4)                                                         293
      F6=P*EXP(-F6)                                                         294
      GO TO 1721                                                             295
C                                                                            296
C     HERE FOR ISOTROPIC                                                     297
C                                                                            298
 1720 TEMP=EXP(-B(I)*SSQLS)                                                  299
      F1=P*TEMP                                                              300
      DO 1712 II=2,12                                                        301
1712  FSC(II)=FSC(1)                                                         302
C        WRITE(13,6001)F1,F3,F5,F7,F8,F9,F10,F11,F12
1721  CONTINUE                                                               303
      CALL GETCOM                                                            304
       CALL GETAB(IPC(I),IPB(I),KIND(I),IAK(I))
      AATM=FSC(1)                                                            306
      BATM=FSC(2)                                                            307
      IF (ICEN.NE.0) BATM=0.0                                                308
      DBC=AATM                                                               309
C    DBC  RESET IN ANOMALOUS CASE ONLY                                       310
      IF(IAK(I).EQ.0.0)GOTO 2727
      P=IAK(I)/F(M)
      TEMP=AATM                                                              314
      IF(ICEN.EQ.0)GO TO 9720                                                315
C      CENTRIC CASE COMES HERE                                               316
      CAB=P*TEMP                                                             317
C    FOR CENTRIC ANOMALOUS ATOM                                              318
      BCAL=BCAL+CAB                                                          319
      DBC=-P*BATM                                                            320
C      -F''SIN(  )                                                           321
      GO TO 2727                                                             322
9720  AATM=AATM-P*BATM                                                       323
      BATM=BATM+P*TEMP                                                       324
      DBC=AATM                                                               325
 2727 IF (ABS(AATM)-0.00001) 1726,1727,1727                                  326
 1726 AATM=0.0                                                               327
 1727 IF (ABS(BATM)-0.00001) 1725,1728,1728                                  328
 1725 BATM=0.0                                                               329
C                                                                            330
C     ACCUMULATE STRUCTURE FACTORS.                                          331
C                                                                            332
 1728 ACAL=ACAL+AATM                                                         333
      IF(ICEN)3121,3120,3121                                                 334
 3120 BCAL=BCAL+BATM                                                         335
 3121 IF (IS1) 120,125,120                                                   336
  120 AAC(I)=AATM                                                            337
      BAC(I)=BATM                                                            338
C    THIS IS TEMPORARY NEED NEW DERIVATIVE ROUTINE                           339
      IF(IAK(I).NE.0.0.AND.ICEN.NE.0)BAC(I)=CAB                                340
C                                                                            341
C    GETAB CALCULATES DERIVATIVES AND RETURNS THEM IN FSC(3) TO FSC(20)      342
C                                                                            343
C     GET REFINABLE PARAMETER NO OF COORD.                                   344
C                                                                            345
      IP=IPC(I)                                                              346
      IF(IP.EQ.0)GO TO 1740         
1730  IR=KREF(I)-(KREF(I)/10)*10     ! WHAT IS THE REFINE SIGNAL 
      IRR=KREF(I)/10                ! WHAT IS THE SHIFT SIGNAL
      GO TO (1731,733,1731,1731,735,733,1731),IR                             349
1731  PA(IP)=FSC(3)                                                          350
      PB(IP)=FSC(12)                                                         351
      IF(IR.EQ.3.AND.IRR.EQ.1)THEN
      PA(IP)=PA(IP)*2.0
      PB(IP)=PB(IP)*2.0
      ELSE
      IF(IR.EQ.7.AND.IRR.EQ.4)THEN
      PA(IP)=PA(IP)*2.0
      PB(IP)=PB(IP)*2.0
      ELSE
      IF(IR.EQ.3.AND.IRR.EQ.50)THEN
      PA(IP)=PA(IP)*2.0
      PB(IP)=PB(IP)*2.0
      ENDIF
      ENDIF
      ENDIF
      IP=IP+1                                                                352
      GO TO (733,733,735,733,735,733,1740),IR                                353
733   PA(IP)=FSC(4)                                                          354
      PB(IP)=FSC(13)                                                         355
      IP=IP+1                                                                356
      GO TO (735,735,735,1740,735,1740,1740),IR                              357
735   PA(IP)=FSC(5)                                                          358
      PB(IP)=FSC(14)                                                         359
C                                                                            360
C     GET REFINABLE PARAMETER NO OF TEMP.                                    361
C                                                                            362
 1740 IP=IPB(I)                                                              363
      IF(IP)741,125,741                                                      364
741   IF(IAK(I).NE.0.0.AND.ICEN.NE.0)BATM=CAB                                  365
      IF(KIND(I))742,745,745                                                 366
C                                                                            367
C     ANISOTROPIC.                                                           368
C                                                                            369
742   IF(IICODE(I).NE.0)GO TO 9742                                           370
7420    PA(IP)=-FSC(6)
      PA(IP+1)=-FSC(7)                                                       372
      PA(IP+2)=-FSC(8)                                                       373
      PA(IP+3)=-FSC(9)                                                       374
      PA(IP+4)=-FSC(10)                                                      375
      PA(IP+5)=-FSC(11)                                                      376
      IF(ICEN)925,743,925                                                    377
925     IF(IICODE(I).NE.0)GO TO 9751
C      IF(IAK(I))743,125,743
C      USE ANOMOLOUS PART FOR CENTRIC CASE TOO                               379
743   PB(IP)=-FSC(15)                                                        380
      PB(IP+1)=-FSC(16)                                                      381
      PB(IP+2)=-FSC(17)                                                      382
      PB(IP+3)=-FSC(18)                                                      383
      PB(IP+4)=-FSC(19)                                                      384
      PB(IP+5)=-FSC(20)                                                      385
        IF(IICODE(I).NE.0)GO TO 9751
      GO TO 125                                                              386
9742  IW=(IICODE(I)/1000)                                                    387
      I1=(IICODE(I)-IW*1000)/100                                             388
      I2=(IICODE(I)-IW*1000-I1*100)/10                                       389
        I3=(IICODE(I)-IW*1000-I1*100-I2*10)
C    B33                                                                     391
      PA(IP+2)=-FSC(8)                                                       392
      IF(ICEN.EQ.0)PB(IP+2)=-FSC(17)                                         393
        IF(IW.EQ.0)GO TO 7420
        GO TO (7420,9744,9745,9747,9750),IW
C       W=2 MEANS B11=B22 AND B23=B13 OR B23=-B13
9744    PA(IP)=-2.*FSC(6)
        PA(IP+1)=0.0
C       B12
        PA(IP+3)=-FSC(9)
C       B13 AND B23
        PA(IP+4)=-2.*FSC(10)
        PA(IP+5)=0.0
        IF(ICEN.NE.0)GO TO 9751
        PB(IP)=-2.*FSC(15)
        PB(IP+1)=0.0
        PB(IP+3)=-FSC(18)
        PB(IP+4)=-2.*FSC(19)
        PB(IP+5)=0.0
        GO TO 9751
C    B11=B22=B12 AND B13=B23=0                                               405
9745  PA(IP)=-1.5*FSC(6)                                                      406
      PA(IP+1)=0.0                                                           407
      PA(IP+3)=0.0                                                           408
      PA(IP+4)=0.0                                                           409
      PA(IP+5)=0.0                                                           410
        IF(ICEN.NE.0)GO TO 125
      PB(IP)=-1.5*FSC(15)                                                     412
      PB(IP+1)=0.0                                                           413
      PB(IP+3)=0.0                                                           414
      PB(IP+4)=0.0                                                           415
      PB(IP+5)=0.0                                                           416
      GO TO 125                                                              417
C    B12, B13, B23                                                           418
9751    IF(I1.EQ.1)PA(IP+3)=0.0
        IF(I2.EQ.1)PA(IP+4)=0.0
        IF(I3.EQ.1)PA(IP+5)=0.0
C       IF(ICEN.NE.0.OR.IAK(I).EQ.0.0)GO TO 125
        IF(ICEN.NE.0)GO TO 125
        IF(I1.EQ.1)PB(IP+3)=0.0
        IF(I2.EQ.1)PB(IP+4)=0.0
        IF(I3.EQ.1)PB(IP+5)=0.0
      GO TO 125                                                              432
C       W=4 MEANS B12=B22
9747    PA(IP)=-FSC(6)
        PA(IP+1)=-1.*FSC(7)
        PA(IP+3)=0.0
        IF(ICEN.NE.0)GO TO 9752
        PB(IP)=-FSC(15)
        PB(IP+1)=-1.*FSC(16)
        PB(IP+3)=0.0
9752    IF(I2.LT.2) GO TO 9753
C       Y=5 MEANS B23=0.5*B13
C       Y=2 MEANS B13=0.5*B23
C     WRITE(13,8000)FSC(10),FSC(11)
C8000  FORMAT('  IN HEXLS B13 B23 DERIVATIVE IS FSC(10)=',F12.6,
C     +' AND FSC(11)=',F12.6)
      IF(I2.EQ.2)THEN
      PA(IP+4)=0.0                ! B13
      PA(IP+5)=-1.0*FSC(11)    ! B23
      ELSE
        IF(I2.EQ.5)PA(IP+4)=-1.0*FSC(10)
        IF(I2.EQ.5)PA(IP+5)=0.0
      ENDIF
        IF(ICEN.NE.0)GO TO 9751
C     WRITE(13,8001)FSC(19),FSC(20)
C8001  FORMAT('  AND FOR B DERIV.IS IN FSC(19)=',F12.6,' AND FSC(20)=', 
C    +F12.6)
      IF(I2.EQ.2)THEN
      PB(IP+4)=0.0
      PB(IP+5)=-1.0*FSC(20)
      ENDIF
        IF(I2.EQ.5)PB(IP+4)=-1.0*FSC(19)
        IF(I2.EQ.5) PB(IP+5)=0.0
        GO TO 9751
C       W=5 MEANS B12=B11
9750    PA(IP)=-1.*FSC(6)
        PA(IP+1)=-FSC(7)
        PA(IP+2)=-FSC(8)
        PA(IP+3)=0.0
        IF(ICEN.NE.0)GO TO 9752
        PB(IP+1)=-FSC(17)
        PB(IP)=-1.*FSC(15)
        PB(IP+3)=0.0
        GO TO 9752
C COME HERE IF W=4 OR 5 AND Y DOES NOT =2 OR 5
C SET SHIFTS TO USUAL B13 B23 ALTHOUGH THEY MAY BECOME 0 IF Y AND OR Z
C ARE = 1
9753    PA(IP+4)=-FSC(10)
        PA(IP+5)=-FSC(11)
        IF(ICEN.NE.0)GO TO 9751
        PB(IP+4)=-FSC(19)
        PB(IP+5)=-FSC(20)
        GO TO 9751
  745 PA(IP)=-SSQLS*AATM                                                     433
      PB(IP)=-SSQLS*BATM                                                     434
  125 CONTINUE                                                               435
C                                                                            436
C     SCALE FACTOR DERIV.                                                    437
C                                                                            438
      IF (IS1) 8582,2118,8582                                                439
 8582 IF(ISC)126,127,126                                                     440
  126 PA(ISC)=ACAL                                                           441
      PB(ISC)=BCAL                                                           442
  127 CONTINUE                                                               443
C                                                                            444
C     POPULATION FACTOR DERIVATIVES                                          445
C                                                                            446
      IF (NRPOP) 2118,2118,2001                                              447
 2001 DO 2010 I=1,NRPOP                                                      448
      NX=NPOPI(2,I)                                                          449
      KAT=NPOPI(1,I)                                                         450
      PA(NX)=0.0                                                             451
      PB(NX)=0.0                                                             452
      IP=NPAT(KAT)                                                           453
      IF(MPOP(1,I)-IP)6,4,6                                                  454
    4 PA(NX)=PA(NX)+AAC(IP)*FPOPI(I)                                         455
      PB(NX)=PB(NX)+BAC(IP)*FPOPI(I)                                         456
      KAT=KAT+1                                                              457
      GO TO 2010                                                             458
    6 CONTINUE                                                               459
      RES=POPIF(1,I)                                                         460
      LX=NPOPI(3,I)                                                          461
      DO 2005 J=1,LX                                                         462
      IP=NPAT(KAT)                                                           463
      PA(NX)=PA(NX)+AAC(IP)/RES                                              464
      PB(NX)=PB(NX)+BAC(IP)/RES                                              465
 2005 KAT=KAT+1                                                              466
      LX=NPOPI(4,I)                                                          467
      IF (LX) 2010,2010,2006                                                 468
 2006 RES=1.0-RES                                                            469
      DO 2008 J=1,LX                                                         470
      IP=NPAT(KAT)                                                           471
      PA(NX)=PA(NX)-AAC(IP)/RES                                              472
      PB(NX)=PB(NX)-BAC(IP)/RES                                              473
 2008 KAT=KAT+1                                                              474
 2010 CONTINUE                                                               475
C                                                                            476
C        SECONDARY EXTINCTION                                                477
C                                                                            478
 2118 CORR=1.0                                                               479
      FCALS=ACAL*ACAL+BCAL*BCAL                                              480
      IF(SSQLS.EQ.0.0)GO TO 9000                                             481
      IF(INSEC.EQ.1)GOTO 3202  ! ALLOW NEG. SEC. EXT.
      IF (GF) 3300,3202,3202    ! NOW ALLOWS STARTING VALUE OF 0.0  
 3202 TEMP=SSQLS*FLAMS                                                       483
      C2T=1.0-2.0*TEMP                                                       484
      S2T=2.0*SQRT(TEMP-TEMP*TEMP)                                           485
      TEMP=C2T*C2T                                                           486
      TEMP=(1+TEMP*TEMP)/(S2T*TEMP+S2T)                                      487
 3208 COR=1.0/(1.0+TEMP*GF*FCALS)                                            488
      FCALS=FCALS*COR                                                        489
      CORR=SQRT(COR)                                                         490
 9000 ACAL=ACAL*CORR                                                         491
      BCAL=BCAL*CORR                                                         492
      IF (IGF) 3300,3300,3220                                                493
 3220 TEMP=TEMP*FCALS*0.5/CORR                                               494
      PA(IGF)=-TEMP*ACAL                                                     495
      PB(IGF)=-TEMP*BCAL                                                     496
C                                                                            497
C     CALCULATE FOBS AND FCALC, ETC.                                         498
C                                                                            499
 3300 FOBS=SCF*FOBS                                                          500
      FCAL=SQRT (FCALS)                                                      501
      DELF=FOBS-FCAL                                                         502
      IF (FABS) 2119,2121,2121                                               503
 2119 DELF=0.0                                                               504
 2121 NREF=NREF+1                                                            505
C                                                                            506
C     BRANCH ACCORDING TO WEIGHT.                                            507
C                                                                            508
      IF (W) 130,135,140                                                     509
  130 NLTH=NLTH+1                                                            510
      IF(DELF)136,135,135                                                    511
  135 RTW = 0.0                                                              512
      WDEL=0.0                                                               513
      GO TO 141                                                              514
  136 CONTINUE                                                               515
  139 LTLS=LTLS+1                                                            516
C                                                                            517
C     ADD TO WEIGHTED SUMS                                                   518
C                                                                            519
  140 WFOB=RTW*FOBS*FOBS                                                     520
      IF (FABS) 2131,2130,2130                                               521
 2131 WFOB=-WFOB                                                             522
      IF(PTST)9934,2132,9933
C                                                                            524
C     ACCUMULATE SUMMATIONS                                                  525
C                                                                            526
2130  IF(PTST.EQ.0.0) GO TO 9930
      IF(IQ.EQ.0) GO TO 9930
      IF(W.LT.0.0) GO TO 9131
      IF(PTST.GT.0.0) GO TO 9933
9934  IF(FABS.LT.0) GO TO 9930
      IF(FBSQ.LT.PSIG) GO TO 9930
C   SEPARATE SUMS FOR F**2.GE.PSIG
      GO TO 9131
9933  IF(FBSQ.GT.PSIG) GO TO 9930
C    SEPARATE SUMS FOR F**2.LT.OR.EQ.PSIG
9131  IF(FABS.LT.0.0) GO TO 9132
      SPFOBS=SPFOBS+FOBS
      SPFCAL=SPFCAL+ABS(FCAL)
      SPDELF=SPDELF+ABS(DELF)
      PNFCP=PNFCP+1
9132  PWFCL=RTW*FCALS
      PWDEL=WFOB-PWFCL
      SPFOS=SPFOS+WFOB*WFOB
      SPFCS=SPFCS+PWFCL*PWFCL
      PFOFC=PFOFC+WFOB*PWFCL
      SPWDEL=SPWDEL+PWDEL*PWDEL
      PNRLS=PNRLS+1
C   SUM UP BUT DO NOT PRINT UNTIL LAST PAGE
9930  IF(FABS.LT.0.0) GO TO 2132
      SFOBS=SFOBS+FOBS
      SFCAL=SFCAL+ABS(FCAL)                                             01   581
      SDELF=SDELF+ABS(DELF)                                                  529
      NFCP=NFCP+1                                                            530
2132  WFCL=RTW*FCALS                                                         531
      WDEL=WFOB-WFCL                                                         532
      SFOS=SFOS+WFOB*WFOB                                                    533
      SFCS=SFCS+WFCL*WFCL                                                    534
      SFOFC=SFOFC+ABS(WFOB)*WFCL                                             535
      SWDEL=SWDEL+WDEL*WDEL                                                  536
      NRLS=NRLS+1                                                            537
  141 CONTINUE                                                               538
C                                                                            539
C     PRINT A LINE                                                           540
C                                                                            541
      IF (NOPR) 145,147,150                                                  542
  145 IF (WWD-ABS(WDEL)) 147,147,150                                         543
  147 WRITE(3,91)K1,K2,K3,FOBS,FCAL,DELF,WDEL,ACAL,BCAL,SSQLS
      NPR=NPR+1                                                              545
      IF (80-NPR)142,142,150                                                 546
  142 NPR=0                                                                  547
  	IER=SYS$ASCTIM(,DIN,,)
      RF=SDELF/SFOBS                                                         549
      WRF=SWDEL/SFOS                                                         550
      WRITE(3,93)SFOBS,SFCAL,SDELF,RF,NFCP,NREF,SFOS,SFCS,SFOFC,SWDEL,       551
     1WRF,NRLS                                                               552
      IF(IFOP.EQ.1.AND.IONCE.EQ.0)THEN 
C  FOR INF FILE.  NO. OF REFLECTIONS ONLY GET WRITTEN ONCE (IONCE=1)
C  R INDEX MUST BE REWRITTEN EACH TIME THRU.
        ENCODE(80,1421,INFC)NREF
1421    FORMAT(' INDEPENDENT REFLECTIONS: ',I6)
        CALL ADDON(INFC,27,IFLG)  ! ADD NO. OF INDEPENDENT REFLECTS. TO INF.
        if(iflg.ne.1)write(3,1420)
1420    format('    Unable to write to >INF file.')
        ENCODE(80,1422,INFC)NFCP
1422    FORMAT(' NUMBER WITH F(OBS)^2 > 0 :',I6)
        CALL ADDON(INFC,27,IFLG)
        if(iflg.ne.1)write(3,1420)
      ENDIF
      IF(IFOP.EQ.1)THEN   ! R INDEX TO INF FILE
        ENCODE(80,1423,INFC)RF
1423    FORMAT(' R-INDEX: ',F10.4)
        CALL ADDON(INFC,27,IFLG)  ! ADD TO INF FILE
        if(iflg.ne.1)write(3,1420)
        ENCODE(80,1424,INFC)sqrt(wRF)
1424   FORMAT(' wR(F**2): ',F10.4)
        CALL ADDON(INFC,27,IFLG)  ! ADD TO INF FILE
        if(iflg.eq.0)write(3,1420)
      ENDIF
      IF (KIN)252,144,252                                                    553
  144 WRITE(3,92)DIN                                                         554
  150 CONTINUE                                                               555
      WRITE(IT2)K1,K2,K3,FABS,W,PIH,PIK,PIL,SSQLS,(F(M),M=1,12),(SP(M),      556
     1M=1,8),ACAL,BCAL                                                       557
C                                                                            558
C     CONTINUE IF MATRICES.                                                  559
C                                                                            560
      IF(NSK) 151,18,151                                                     561
  151 IF(RTW)152,18,152                                                      562
  152 IF(IS1)153,18,153                                                      563
  153 CONTINUE                                                               564
C                                                                            565
C     GENERAL FOR ALL REFINEMENTS                                            566
C                                                                            567
C     CYCLE OVER PARAMETERS                                                  568
C                                                                            569
C     FORM PARTIALS AND BVECTOR                                              570
C                                                                            571
      ACAW=ACAL*RTW*2.0*CORR                                                 572
      BCAW=BCAL*RTW*2.0*CORR                                                 573
      DO 210 J=1,NPAR                                                        574
      PA(J)=ACAW*PA(J)+BCAW*PB(J)                                            575
  210 BVEC(J)=BVEC(J)+PA(J)*WDEL                                             576
C                                                                            577
C     ACCUMULATE MATRICES                                                    578
C                                                                            579
      IF (JSI) 211,211,18                                                    580
C                                                                            581
C    THE FOLLOWING CODE HAS BEEN REPLACED BY THE ASSEMBLER ROUTINE 'MAC'     582
C                                                                            583
C 211 IAR=1                                                                  584
C     DO 220 K=1,NMAT                                                        585
C     IP=MLST(1,K)-1                                                         586
C     IN=MLST(2,K)                                                           587
C     IF(IP) 225,215,215                                                     588
C 215 DO 220 L=1,IN                                                          589
C     IDP=IP+L                                                               590
C     PTEM=PA(IDP)                                                           591
C     DO 220 J=L,IN                                                          592
C     IXP=IP+J                                                               593
C     ARY(IAR)=ARY(IAR)+PTEM*PA(IXP)                                         594
C 220 IAR=IAR+1                                                              595
C     GO TO 18                                                               596
C                                                                            597
C     HERE FOR DIAGONAL MATRICES                                             598
C                                                                            599
C 225 IP=-IP-2                                                               600
C     DO 227 L=1,IN                                                          601
C     IDP=IP+L                                                               602
C     ARY(IAR)=ARY(IAR)+PA(IDP)*PA(IDP)                                      603
C 227 IAR=IAR+1                                                              604
C                                                                            605
C                                                                            606
  211 CALL MAC(MLST,NMAT,ARY,PA)                                             607
      GO TO 18                                                               608
180   WRITE(3,99)K1,K2,K3                                                    609
99     FORMAT(5X,'REFLECTION,',3I4,' ,WILL NOT BE USED FOR THIS SPACE GR     610
     1OUP.')                                                                 611
      GO TO 18                                                               612
C                                                                            613
C     HERE AFTER ALL REFLECTIONS IN.                                         614
C                                                                            615
  250 KIN=1                                                                  616
      GO TO 142                                                              617
  252 GOF=NRLS-NPAR                                                          618
      GOF=SWDEL/GOF                                                          619
      RGOF=SQRT(GOF)
      WRITE(3,94) NLTH,LTLS,RGOF,NRLS,NPAR
      IF(IFOP.EQ.1)THEN   ! ADD GOF TO INF FILE IF IT IS OPENED
        ENCODE(80,2521,INFC)RGOF,NRLS,NPAR
2521    FORMAT(' FINAL GOF: ',E10.3,' FOR ',I6,' REFS. AND ',I5,
     1  ' PARAMS.')
        CALL ADDON(INFC,27,IFLG)  ! ADD GOF TO INF FILE (UNIT 27)
        if(iflg.ne.1)write(3,1420)
      ENDIF
C  WRITE SPECIAL SUMS FOR F**2.LT.OR.EQ.PSIG IF NECESSARY
      IF(PTST.EQ.0.0) GO TO 9252
      IF(IQ.EQ.0) GO TO 9252
C  WRITE HEADING FOR SPECIAL SUMS
      IF(PTST.GT.0.0) WRITE(3,9494)PTST
9494  FORMAT(/,5X,'  SUMS FOR F**2 .LT. ',F6.3,'SIGMA',/)
      PST=ABS(PTST)
      IF(PTST.LT.0)WRITE(3,9495)PST
9495  FORMAT(//5X,' SUMS FOR F**2 .GT. ',F6.3,' SIGMA',/)
      IF(SPFOBS.LT.0.0000001) GO TO 9253
      PRF=SPDELF/SPFOBS
      IF(SPFOS.LT.0.000001) GO TO 9253
      PWRF=SPWDEL/SPFOS
      GO TO 254
9253   PRF=0.0
      PWRF=0.0
 254  WRITE(3,93) SPFOBS,SPFCAL,SPDELF,PRF,PNFCP,NREF,SPFOS,SPFCS,
     1PFOFC,SPWDEL,PWRF,PNRLS
      CHAR1='<'
      IF(PTST.LT.0.0)CHAR1='>'
      IF(IONCE.EQ.0.AND.IFOP.EQ.1)THEN
C   FOR INF FILE - # OF REFLECTIONS ADDED ONLY ONCE (IONCE=0)
        ENCODE(80,2541,INFC)CHAR1,PST,PNFCP
2541    FORMAT(' NO. WITH F(OBS)^2 ',A1,F6.3,' SIGMA: ',I6)
        CALL ADDON(INFC,27,IFLG)  ! ADD TO INF FILE
        if(iflg.ne.1)write(3,1420)
      ENDIF
      IF(IFOP.EQ.1)THEN  !  R SUM UPDATED EACH TIME
        ENCODE(80,2542,INFC)CHAR1,PST,PRF
2542    FORMAT(' R FOR F(OBS)^2 ',A1,F6.3,' SIGMA: ',F10.4)
        CALL ADDON(INFC,27,IFLG)  ! ADD TO INF FILE
        if(iflg.ne.1)write(3,1420)
      ENDIF
9252  CONTINUE
      IONCE=1
      KIN=999999                                                             622
      WRITE(IT2)KIN,F,F,WGT                                                  623
      WRITE(IT2)KIN,F,F,WGT                                                  624
      KIN=IT1                                                                625
      IT1=IT2                                                                626
      IT2=KIN                                                                627
  253 REWIND IT1                                                             628
      REWIND IT2                                                             629
C                                                                            630
C     EXIT                                                                   631
C                                                                            632
  256 B2=GOF                                                                 633
      IS5=NMAT                                                               634
      RETURN                                                                 635
      END                                                                    636
