      SUBROUTINE P21READ
C         THIS READS A DISK FILE TAKEN FORM A NEW P21 DIF. TAPE 12NOV86
C     MAG FILE CONTAINS ID,H,K,L,TTH,PHI,CHI,RANGE,SPEED,
C   B1,SCAN,B2,EXPTM,TBTS, INT, SIG, AND A BLANK FOR ABSCOEF.
C     (BLANK FIELDS INCLUDED SO THAT MAG FILE WILL
C   ALWAYS BE THE SAME LENGTH AND NOT INCREASE IN SIZE, WITH THE DANGER
C   OF OVERFLOWING DISK SPACE, WHEN THE LATER PROGRAMS ARE RUN.)
      INTEGER*2 IDHKL(4),ISTEP(96),ID,H,K,L,IH(10),IK(10),IL(10),IDCNT
      INTEGER*2 STD,IHAB(6,50),IKAB(6,50),ILAB(6,50)
      REAL*4 INT,INTCOR,IIAB(6,50)
      CHARACTER*2 LA
      CHARACTER*7 NPROF
      CHARACTER*1 ISTAR,TP
      CHARACTER*4 CARD(20)
      CHARACTER*1 DASH(11)
      CHARACTER*16 NAMFI,NAMFI2
      CHARACTER*128 RECORD
      CHARACTER*24 NAM
      DATA IBLANK/'    '/
      DIMENSION REAL(13),ISAB(6)
      EQUIVALENCE (ID,IDHKL(1)),(H,IDHKL(2)),(K,IDHKL(3)),(L,IDHKL(4)),
     1  (TTH,REAL(1)),(PHI,REAL(2)),
     1(CHI,REAL(3)),(RANGE,REAL(4)),(SPEED,REAL(5)),(BG1,REAL(6)),
     1(SCAN,REAL(7)),(BG2,REAL(8)),(EXPTM,REAL(9)),(TBTS,REAL(10)),
     1(INT,REAL(11)),(SIG,REAL(12)),(ABSCOEF,REAL(13))
	INTEGER*2 IDD(100,2),ID1(200),IDEL(500),NDR(12)
	INTEGER FILE,READRC,RECFM
      COMMON/FNAME/NAMFI,NAMLEN
      IN=12              ! INPUT UNIT FOR TAPE
      OUT=7
      BL1=0.0   ! BLANK FIELDS
      BL2=0.0
      BL3=0.0
      abscoef=0.0
      SCAN=1.0
      TBTS=1.0
      IPROF=0
      IRD=0
      ND=0
      ND1=0
      NTOT=0
      DO I=1,6
        ISAB(I)=0
      ENDDO
      NAMFI(NAMLEN+1:NAMLEN+4)='.MAG'
C   OPENING MAG FILE
25    OPEN(NAME=NAMFI,UNIT=OUT,TYPE='NEW',FORM='UNFORMATTED',
     1BLOCKSIZE=32768,BUFFERCOUNT=2)
C       OPEN DATA FILE  FOR P21 DIFF.
C     OPEN(NAME='[BJW]REM.TAP',UNIT=IN,TYPE='OLD',FORM='FORMATTED')
      NOCHEK=0   ! NUMBER OF CHECKS
      TSTBL=0.
C
C  FILE CARD 
C2345678901234567890
C####NN LIST
C LENGTH IS LAST ID TO BE READ FROM THIS FILE
C IFILE IS FILE NUMBER - DEFAULT IS 1
C NLIST NONBLANK REQUESTS THAT PRINTED OUTPUT BE SUPPRESSED
C
      READ(1,10)LENGTH,IFILE,NLIST,NPROF
10    FORMAT(I5,I2,1X,A4,1X,A7)
      IF(NLIST.EQ.IBLANK)THEN
      ILIST=1
      WRITE(3,15)
15    FORMAT(' AS REQUESTED, YOU WILL HAVE PRINTED OUTPUT OF TAPE',
     1' CONTENTS.')
      ELSE
      ILIST=0
      WRITE(3,16)
16    FORMAT(' NO PRINTED OUTPUT OF TAPE CONTENTS.')
      ENDIF
      IF(IFILE.EQ.0)IFILE=1
      WRITE(3,7)IFILE,LENGTH
      IF(LENGTH.EQ.0)GOTO 901
7     FORMAT(' LAST ID TO BE READ FROM FILE ',I2,' IS: ',I5)
      READ(1,18)CARD
18    FORMAT(20A4)
      IF(CARD(1).NE.'SCAN')THEN
C  DEFAULT IF NO SCAN CARD FOUND IS SCAN 2THETA
      IOMEG=1
      IRD=1
      GOTO 19
      ENDIF
C   OMEGA OR 2THETA SCAN
      WRITE(3,180)CARD
180   FORMAT(1X,20A4)
      IF(CARD(2).EQ.' 2TH')THEN
C  SCAN 2THETA
      IOMEG=1
      ELSE
C  SCAN OMEGA
      IF(CARD(2).NE.' OME')GOTO 923
      IOMEG=2
      ENDIF
181   READ(1,18)CARD
19    CONTINUE
      IF(CARD(1).NE.'DELE')GOTO 253
C DELETE CARDS HERE - DELETED REFLECTIONS NOT STORED ON MAG FILE!
      DECODE(80,21,CARD)(NDR(I),DASH(I),I=1,11),NDR(12)
21    FORMAT(7X,11(I5,A1),I5)
      WRITE(3,22)(NDR(I),DASH(I),I=1,11),NDR(12)
22    FORMAT(1X,'DELETE ',11(I5,A1),I5)
      I=1
23    IF(NDR(I).EQ.0)GOTO 181
      IF(DASH(I).EQ.'-')THEN
C  DASH MEANS RANGE OF IDS TO BE DELETED
      ND=ND+1
C  ND KEEPS TRACK OF RANGES OF DELETIONS
      IF(ND.GT.100)THEN
C  PREVENT ARRAY OVERFLOW - 100 DELETION RANGES ALLOWED
      ND=100
      WRITE(3,24)NDR(I)
24    FORMAT(' DELETION ARRAY OVERFLOW - REFLECTION # ',I6,
     1' NOT DELETED.')
      ENDIF
      IDD(ND,1)=NDR(I)
      IDD(ND,2)=NDR(I+1)
      I=I+2
      ELSE ! SINGLE DELETION
      ND1=ND1+1
C  ND1 KEEPS TRACK OF NUMBER OF SINGLY DELETED REFLECTIONS
      IF(ND1.GT.200)THEN
C  PREVENT ARRAY OVERFLOW - 200 SINGLE DELETIONS ALLOWED
      ND1=200
      WRITE(3,24)NDR(I)
      ENDIF
      ID1(ND1)=NDR(I)
      I=I+1
      ENDIF
      IF(I.LE.12)GOTO 23
      GOTO 181
253   CONTINUE
      IF(ILIST.EQ.1)WRITE(3,3001)
C    READ IN DATA TAPE HERE                                                  184
C300   READ(IN,100,END=301)ID,H,K,L,TTH,OM,CHI,PHI,Q1,Q2,BG2,SCAN,BG1,INTI.
C     +,SIG,EXPTM
      IF(IFILE.EQ.0)IFILE=1
17    FORMAT(I1)
      OPEN(UNIT=12,STATUS='OLD')
      INQUIRE(UNIT=12,NAME=NAM)
      J=INDEX(NAM(1:),';')
      IF(J.NE.0)THEN
      J=J+1
      ENCODE(1,17,NAM(J:J+1))IFILE
      ENDIF
      J=INDEX(NAM(1:),'.')    ! IS THIS P21 OR NONIUS
      J=J+1
c     TP=NAM(J:J)            ! EITHER D FOR NONIUS OR P FOR P21
      OPEN(NAME=NAM,UNIT=12,STATUS='OLD')
      WRITE(3,70)NAM   
70    FORMAT(' FILE ',A,' IS OPENED')
      WRITE(3,7)IFILE,LENGTH
300   READ(12,71)RECORD
C     WRITE(3,7100)RECORD(7:128) 
C     WRITE(3,7100)RECORD(53:76)
7100  FORMAT(1X,A)
71     FORMAT(A)
C    THIS VERSION OF P21READ IS FOR TAKING THE DIFFRACTOMETER DATA
C    FROM A DISK FILE WRITTEN BY MTCOPY
C    TO READ FROM A TAPE USE RECORD WITHOUT THE (7:128) AND A SLIGHTLY
C DIFFERENT FORMAT FOR THE DECODE (1X,I5,ETC     )
C     DECODE(120,100,RECORD,END=301)ID,H,K,L,TTH,OM,CHI,PHI,
C    +RANGE,SPEED,BG1,SCAN,BG2,INT,SIG,EXPTM
      DECODE(128,100,RECORD,END=301)ID,H,K,L,TTH,OM,CHI,PHI,
     +RANGE,SPEED,BG1,SCAN,BG2,INT,TB,EXPTM,TS
C             SPEED HERE IS DEGREES PER MINUTE
C             TB IS BACKGROUND TIME AND TS IS SCAN TIME
C     FOR THE OMEGA SCAN TSTB IS SET TO 1.0
C     THIS MAY BE CHANGED IN OUR PERMANENT VERSION OF THIS PROGRAM
C100    FORMAT(I6,3I3,7F8.3,F11.3,F8.3,3F10.3)
100    FORMAT(1X,I5,3I3,7F8.3,F11.3,F8.3,4F10.3)
900    FORMAT(I6,3I3,7F8.3,F10.3,F8.3,4F10.3)   ! 128 BYTES
        IDCNT=ID
C     WRITE(3,8989)TB,TS
C8989  FORMAT('  TB=',F10.3,'  TS=',F10.3)
      IF(IDCNT.GT.0)GOTO 210
      IDCNT=-IDCNT            ! THIS IS A CHECK REFL.
      IF(NOCHEK.EQ.0)GOTO 206
      DO 205 I=1,NOCHEK
      IF(H.EQ.IH(I).AND.K.EQ.IK(I).AND.L.EQ.IL(I))THEN
      ICK=I
      GOTO 210
      ENDIF
205   CONTINUE
206   NOCHEK=NOCHEK+1
      ICK=NOCHEK
      IH(ICK)=H
      IK(ICK)=K
      IL(ICK)=L
210   IF(ND.EQ.0)GOTO 211
      DO 211 I=1,ND
C  IS REFLECTION IN ONE OF THE DELETION RANGES
      IF(IDCNT.GE.IDD(I,1).AND.IDCNT.LE.IDD(I,2))THEN
      NTOT=NTOT+1
      IF(NTOT.GT.500)NTOT=500  ! PREVENT ARRAY OVERFLOW
C  NTOT KEEPS TRACK OF TOTAL NUMBER OF DELETED REFLECTIONS
      IDEL(NTOT)=ID
      GOTO 300
      ENDIF
211   CONTINUE
      IF(ND1.EQ.0)GOTO 212
C  SEEING IF REFLECTION IS ONE OF THE SINGLE DELETIONS
      DO 212 I=1,ND1
      IF(IDCNT.EQ.ID1(I))THEN
      NTOT=NTOT+1
      IF(NTOT.GT. 500)NTOT=500  !PREVENT ARRAY OVERFLOW
      IDEL(NTOT)=ID
      GOTO 300
      ENDIF
212   CONTINUE
      IF(LENGTH.NE.0)THEN
       IF(IDCNT.GT.LENGTH)GO TO 301  ! IS ID > LAST ID TO BE READ IN
      ENDIF
      IF(SPEED.EQ.0.0.OR.SCAN-INT/SPEED.EQ.0.0)THEN
        TBTS=0.0
        TSTB=0.0
      ELSE
      SP=SPEED*.0166666666              ! DEGREES PER SECOND
C     TBTS=(BG1+BG2)/(SCAN-(INT/SP))
       TBTS=TB/TS                  ! WRITTEN ON THE TAPE
      TSTB=1./TBTS
      ENDIF
      IF(TSTBL.EQ.0.)TSTBL=TSTB
C   TSTBL IS LAST TSTB - IF THERE IS MORE THAN 20% DIFFERENCE BETWEEN 
C  THE TWO, A STAR WILL BE PRINTED ON OUTPUT TO INDICATE THIS.
      IF(TSTB.EQ.0.0)THEN
        ISTAR=' '
      ELSE
      IF(ABS(TSTB-TSTBL)/TSTB.GT.0.2)THEN
      ISTAR='*'  ! STAR IN OUTPUT IF CHANGE IN TS/TB> 20%
      ELSE
      ISTAR=' '
      ENDIF
      ENDIF
      TSTBL=TSTB
      IF(IOMEG.EQ.2)THEN
C  IF SCAN OMEGA, SCAN CANNOT BE CALCULATED FROM PROFILE AS IT IS NOT
C  STORED ON THE DIFFRACTOMETER TAPE.  THEREFORE, SCAN, SIGMA AND
C  INTENSITY ARE TAKEN FROM THE TAPE RATHER THAN CALCULATED FROM THE
C  PROFILES.
      INTCOR=INT
C     SIGCOR=SIG
      RATIO=1.0
      ELSE
C     WRITE(35,9000)RANGE,SPEED,BG1,SCAN,BG2,INT,SIG
C9000  FORMAT(' RANGE=',F10.4,' SPEED=',F10.4,' BG1=',F10.4,
C    +/,' SCAN=',F10.4,' BG2=',F10.4,' INT=',F12.4,' SIG=',F10.4)
      INTCOR=(SCAN-(BG1+BG2)*TSTB)*SP     ! SP=SPEED/60.
C     SP=SPEED/60   DEGREES PER SECOND
      SIGCOR=SQRT(SP**2*(SCAN+(BG1+BG2)*TSTB**2))
C     WRITE(35,9001)SIG,SIGCOR
C001  FORMAT('  SIG=',F10.6,'  SIGCOR=',F10.6)
C     INTCOR=INT
      IF(INT.EQ.0.)THEN
      RATIO=0.0
      ELSE
      RATIO=INTCOR/INT
      ENDIF
      ENDIF
c     TMAG=EXPTM/60.           ! CONVERT EXPOSURE TIME TO HOURS
      tmag=exptm                ! dont do this yet. kms says
c                              other diffractometers have it in minutes
      WRITE(OUT)IDHKL,TTH,PHI,CHI,RANGE,SP,BG1,SCAN,BG2,TMAG,TBTS,
     1 BL1,BL2,BL3
C  FOR SPACE GROUP ABSENCES
C  H 0 0
      IF(K.EQ.0.AND.L.EQ.0)THEN
        ISAB(1)=ISAB(1)+1
        I=ISAB(1)
        IF(I.GT.50)GOTO 2121
        IHAB(1,I)=H
        IKAB(1,I)=K
        ILAB(1,I)=L
        IIAB(1,I)=INTCOR
2121  ENDIF
C  0 K 0
      IF(H.EQ.0.AND.L.EQ.0)THEN
        ISAB(2)=ISAB(2)+1
        I=ISAB(2)
        IF(I.GT.50)GOTO 2122
        IHAB(2,I)=H
        IKAB(2,I)=K
        ILAB(2,I)=L
        IIAB(2,I)=INTCOR
2122  ENDIF
C  0 0 L
      IF(H.EQ.0.AND.K.EQ.0)THEN
        ISAB(3)=ISAB(3)+1
        I=ISAB(3)
        IF(I.GT.50)GOTO 2123
        IHAB(3,I)=H
        IKAB(3,I)=K
        ILAB(3,I)=L
        IIAB(3,I)=INTCOR
2123  ENDIF
C  H K 0  (ONLY FOR -5 <= H,K <= 5)
      IF(L.EQ.0.AND.IABS(H).LT.6.AND.IABS(K).LT.6)THEN
        ISAB(4)=ISAB(4)+1
        I=ISAB(4)
        IF(I.GT.50)GOTO 2124
        IHAB(4,I)=H
        IKAB(4,I)=K
        ILAB(4,I)=L
        IIAB(4,I)=INTCOR
2124  ENDIF
C  H 0 L  (ONLY FOR -5 <= H,L <= 5)
      IF(K.EQ.0.AND.IABS(H).LT.6.AND.IABS(L).LT.6)THEN
        ISAB(5)=ISAB(5)+1
        I=ISAB(5)
        IF(I.GT.50)GOTO 2125
        IHAB(5,I)=H
        IKAB(5,I)=K
        ILAB(5,I)=L
        IIAB(5,I)=INTCOR
2125  ENDIF
C  0 K L  (ONLY FOR -5 <= K,L <= 5)
      IF(H.EQ.0.AND.IABS(K).LT.6.AND.IABS(L).LT.6)THEN
        ISAB(6)=ISAB(6)+1
        I=ISAB(6)
        IF(I.GT.50)GOTO 2126
        IHAB(6,I)=H
        IKAB(6,I)=K
        ILAB(6,I)=L
        IIAB(6,I)=INTCOR
2126  ENDIF
      IF(ILIST.EQ.1)THEN
      IF(NOL.EQ.78)THEN
      WRITE(3,3001)
      NOL=1
3001  FORMAT(1H1,'   ID     H     K     L    CK    B1     SCAN  ',
     1'   B2     INT      SIG   RATIO   2TH     PHI     CHI    TIME  ',
     2' SPEED  TB/TS',/,/)
      ENDIF
      NOL=NOL+1  ! KEEPS TRACK OF NUMBER OF LINES
      IBG1=BG1
      IBG2=BG2
      ISCAN=SCAN
      IF(ID.GT.0)THEN
      IF(ABS(1.0-RATIO).GT.0.0005)THEN
C  1.00 - RATIO > .0005 AND NOT A CHECK
      WRITE(3,3000)IDHKL,IBG1,ISCAN,IBG2,INTCOR,SIGCOR,RATIO,TTH,PHI,
     1CHI,EXPTM,SP,TBTS,ISTAR
3000  FORMAT(1X,4I6,5X,I7,I9,I7,F9.2,F8.2,F7.3,F7.2,3F8.2,F7.2,
     1F6.2,2X,A1)
      ELSE  ! 1-RATIO < .0005 AND NOT A CHECK
      WRITE(3,3003)IDHKL,IBG1,ISCAN,IBG2,INTCOR,SIGCOR,TTH,PHI,CHI,
     1EXPTM,SP,TBTS,ISTAR
3003  FORMAT(1X,4I6,5X,I7,I9,I7,F9.2,F8.2,7X,F7.2,3F8.2,F7.2,
     1F6.2,2X,A1)
      ENDIF
      ELSE  ! CHECK
      IF(1.0-RATIO.GT.0.0005)THEN
C   1.0 - RATIO > .0005 AND IS A CHECK
      WRITE(3,3002)IDHKL,ICK,IBG1,ISCAN,IBG2,INTCOR,SIGCOR,RATIO,TTH,
     1PHI,CHI,EXPTM,SP,TBTS,ISTAR
3002  FORMAT(1X,4I6,1X,1H(,I2,1H),I7,I9,I7,F9.2,F8.2,F7.3,F7.2,3F8.2,
     1F7.2,F6.2,2X,A1)
      ELSE  ! 1.0 - RATIO < .0005 AND IS A CHECK
      WRITE(3,3004)IDHKL,ICK,IBG1,ISCAN,IBG2,INTCOR,SIGCOR,TTH,PHI,
     1CHI,EXPTM,SP,TBTS,ISTAR
3004  FORMAT(1X,4I6,1X,1H(,I2,1H),I7,I9,I7,F9.2,F8.2,7X,F7.2,3F8.2,
     1F7.2,F6.2,2X,A1)
      ENDIF
      ENDIF
      ENDIF
3005  IF(IDCNT.EQ.LENGTH)GOTO 301
      GOTO 300 ! READ NEXT REFLECTION
301   ID=0  ! LAST REFLECTION MARKED WITH ID=0
c     TMAG=EXPTM/60.     ! CONVERT EXPOSURE TIME TO HOURS
       tmag=exptm
      WRITE(OUT)IDHKL,TTH,PHI,CHI,RANGE,SP,BG1,SCAN,BG2,TMAG,TBTS,
     1 BL1,BL2,BL3
      CLOSE(UNIT=OUT,DISP='SAVE')
      IF(CARD(1).NE.'END ')GOTO 25 ! READ NEXT FILE FROM SAME TAPE
      IF(NTOT.NE.0)THEN
C  LISTING DELETED REFLECTIONS
      WRITE(3,304)
304   FORMAT(//,' THESE REFLECTIONS HAVE BEEN DELETED AND ARE NOT',
     1' INCLUDED ON THE MAG FILE: ',/)
      IF(NTOT.GE.500)WRITE(3,305)
305   FORMAT(' NOTE - ONLY THE FIRST 500 REFLECTIONS ARE LISTED HERE')
      I=0
302   I=I+1
      I1=15*I-14
      I2=15*I
      IF(NTOT.LT.I2)I2=NTOT
      WRITE(3,303)(IDEL(II),II=I1,I2)
303   FORMAT(1X,15(I6,1X))
      IF(I2.LT.NTOT)GOTO 302
      ENDIF
C  WRITING OUT LIST FOR SPACE GROUP ABSENCES
      WRITE(3,3032)ISAB(1)
3032  FORMAT(//' REFLECTIONS OF TYPE H 0 0:  TOTAL NO: ',I5)
      IF(ISAB(1).GT.50)THEN
        WRITE(3,3033)
        ISAB(1)=50
      ENDIF
3033  FORMAT(' ONLY FIRST 50 ARE LISTED')
      WRITE(3,3034)
3034  FORMAT('     H     K     L       INT                H     K   ',
     1'  L       INT')
      WRITE(3,3035)(IHAB(1,I),IKAB(1,I),ILAB(1,I),IIAB(1,I),I=1,ISAB(1))
3035  FORMAT(I7,I6,I6,F11.2,10X,I6,I6,I6,F11.2)
      WRITE(3,3036)ISAB(2)
3036  FORMAT(/' REFLECTIONS OF TYPE O K O:  TOTAL NO: ',I5)
      IF(ISAB(2).GT.50)THEN
        WRITE(3,3033)
        ISAB(2)=50
      ENDIF
      WRITE(3,3034)
      WRITE(3,3035)(IHAB(2,I),IKAB(2,I),ILAB(2,I),IIAB(2,I),I=1,ISAB(2))
      WRITE(3,3037)ISAB(3)
3037  FORMAT(/' REFLECTIONS OF TYPE O O L:  TOTAL NO: ',I5)
      IF(ISAB(3).GT.50)THEN
        WRITE(3,3033)
        ISAB(3)=50
      ENDIF
      WRITE(3,3034)
      WRITE(3,3035)(IHAB(3,I),IKAB(3,I),ILAB(3,I),IIAB(3,I),I=1,ISAB(3))
      WRITE(3,3038)ISAB(4)
3038  FORMAT(/' REFLECTIONS OF TYPE H K 0 FOR |H,K|<=5:  TOTAL NO: ',I5)
      IF(ISAB(4).GT.50)THEN
        WRITE(3,3033)
        ISAB(4)=50
      ENDIF
      WRITE(3,3034)
      WRITE(3,3035)(IHAB(4,I),IKAB(4,I),ILAB(4,I),IIAB(4,I),I=1,ISAB(4))
      WRITE(3,3039)ISAB(5)
3039  FORMAT(/' REFLECTIONS OF TYPE H 0 L FOR |H,L|<=5:  TOTAL NO: ',I5)
      IF(ISAB(5).GT.50)THEN
        WRITE(3,3033)
        ISAB(5)=50
      ENDIF
      WRITE(3,3034)
      WRITE(3,3035)(IHAB(5,I),IKAB(5,I),ILAB(5,I),IIAB(5,I),I=1,ISAB(5))
      WRITE(3,3040)ISAB(6)
3040  FORMAT(/' REFLECTIONS OF TYPE 0 K L FOR |K,L|<=5:  TOTAL NO: ',I5)
      IF(ISAB(6).GT.50)THEN
        WRITE(3,3033)
        ISAB(6)=50
      ENDIF
      WRITE(3,3034)
      WRITE(3,3035)(IHAB(6,I),IKAB(6,I),ILAB(6,I),IIAB(6,I),I=1,ISAB(6))
      RETURN
923   WRITE(3,101)
101   FORMAT(' ERROR ON SCAN OMEGA OR SCAN 2THETA CARD')
      GOTO 924
901   WRITE(3,102)
102   FORMAT(' NEED TO SPECIFY LAST ID NUMBER TO BE READ IN.')
924   STOP
      END
