      SUBROUTINE PREPT
C     PREPARE DATA TAPE PROGRAM.                                        
C     EDIT DATA TAPE PROGRAM.                                           
C     LIST DATA TAPE PROGRAM.                                           
C    OPTIONS ARE :
C        LIST DATA TAPE AND CARD
C        EDIT DATA TAPE
C        EDIT DATA TAPE AND CARD
C        EDIT DATA TAPE AND LIST
C        PREPARE DATA TAPE
C        PREPARE DATA TAPE FROM SCRATCH DISK
C        MAKE PHASED TAPE  (ALIAS MAKE SPECIAL TAPE)
C        LIST PHASED TAPE   (GIVES LISTING OF A AND B)
C        RE-PREPARE DATA TAPE
C        THE WORD CARD IN COL'S 20-24 IN ANY MODE CAUSES CARD
C        IMAGES TO BE WRITTEN IN A 'name'.CRD FILE IN THE 
C        SHORT FORMAT DATA 'CARD' FORMAT.
      DIMENSION CARD(20),Q(12),QT(12,30),KNF(12),QFT(12,30),MK(12),     00000090
     1SPACE(11),IH(1000),IK(1000),IL(1000),DCOR(1000),W(1000),  
     2FLAT(31),LEN(9),CKNF(12),ICARD(20),SW(9),ADF(12),IKNF(12)
      DIMENSION AO(4),BO(4),AA(12,4),BB(12,4),CC(12),INL(12),DFP(7),
     2KD(7),CD(12),dumA(4),dumB(4)
      COMMON IS1,IS2,IS3,IS4,IS5,IS6,SCF,B2,CARD,JPAGE,IT1,IT2          
      EQUIVALENCE (CKNF(1),KNF(1))                                      
      EQUIVALENCE (CD(1),KD(1))
      EQUIVALENCE (ACLC,SPACE(9)),(BCLC,SPACE(10))
      CHARACTER*2 target
      CHARACTER*8 IBLK(1000)
      CHARACTER*80 ICRD
      INTEGER*2 ABTP
      DATA PHASE/' PHA'/
      DATA IKND/'KIND'/
      DATA APUN/4HCARD/
      DATA ISW/'SWIT'/
      DATA ASCRT/4H    /
      DATA ALST/4HIST /
  100 FORMAT(6HCELL  3F8.5,3F8.4)                                       00000170
  110 FORMAT('0    EDIT DECK '//)                                       00000180
  115 FORMAT(A4,3I6,F8.2,F8.4)                                          00000190
C840	FORMAT(4X,3I6,F8.3,F8.5,:,F8.5)
  116 FORMAT('0',A4/)                                                   00000200
  117 FORMAT(' ',4X,3I6,F8.2,F8.4)                                      00000210
  131 FORMAT (10F8.3/10F8.3/10F8.3/A3)                                  00000220
120   FORMAT(10X,7(A3,F7.3))
121   FORMAT(' ANOMALOUS 'a2' fp ',7(A3,F9.4,3x))
  122 FORMAT (' ERROR ON ANOMALOUS DISPERSION CARD.')
  132 FORMAT(' ',10F8.3/' ',10F8.3/' ',10F8.3/1X,A3)
  148 FORMAT('0  CELL PARAMETERS '/'0',3F9.5,3F9.4/'0  SINE SQUARED     00000230
     1THETA/LAMBDA SQUARED COEF.'/'0',6F9.6)                            00000240
  149 FORMAT ('0       H   K   L   FOBS     W    SSQ/LS ',12(3X,A3)/)   00000250
150   FORMAT(' ',A4,3I4,F8.2,2F8.4,12F6.2)
  159 FORMAT('0  CELL PARAMETERS '/'0',3F9.5,3F9.4)
  175 FORMAT(6HKIND F,12A3,4x,I2,30x,a2)
  176 FORMAT('0KIND F',10X,12(2X,A3),1x,I2,1x,a2)
  180 FORMAT(6HKIND F12A3,6x,I2)                                        00000270
  177 FORMAT('0    EDIT ERROR CHECK')                                   00000280
  178 FORMAT('0ERROR ON KIND CARD  (ARE ALL ATOM TYPES IN TABLE?)')
  179 FORMAT(' ',3I4,F8.2,F8.4,'  WAS NOT FOUND')                       00000300
  579 FORMAT ('0   NO EDIT ERRORS')                                     00000310
949   FORMAT('0',7X,'H',3X,'K',3X,'L',5X,'F',5X,'W',4X,'SSQ/LS',4X,'A',
     18X,'B',3X,12(3X,A3)/)
432   FORMAT(9F5.2)
950   FORMAT(' ',A4,3I4,F8.2,2F8.4,2F8.2,12F6.2)
1201  FORMAT(20A4)
4124  FORMAT(' ERROR ON ANOMALOUS DISPERSION CARD - NO MATCH')
C     DECIDE OPTION WANTED                                              
      ABTP=0
      IPRNT=1
      IF(IS1.EQ.3.OR.IS1.EQ.5)IPRNT=0  ! FOR LIMITED OUTPUT PREP,RE-PREP
      NREF=0
      NREF1=0
      IKIND=1
      SCAL=1.0
      IEDIT=0
      NRED=0
      ISWITCH=0
      ITEST=0
      IPRT=0
      IPUN=0
      IF(CARD(2).EQ.PHASE) ABTP=1
      IF(CARD(6).EQ.'CARD')IPUN=1
      IF (CARD(3).NE.'CRD ')IKIND=2
      IF(CARD(4).EQ.'PRIN'.OR.IKIND.EQ.1)IPRNT=1
C  LIMITED OUTPUT (1ST AND LAST 5 REFLECTIONS) FOR PREP,LIST IF NOT CRD
      REWIND IT1                                                        
      IF(IS1.EQ.4) ABTP=1
      NPXZ=0                                                            
      IF(IS1.EQ.2)IPRT=1
      GO TO (280,280,5,5,5),IS1
C    LIST, EDIT, PREPARE, MAKE PHASED, RE-PREPARE
C     THE FOLLOWING STATEMENTS READ IN THE CELL                         00000400
C     PARAMETERS AND COMPUTE THE COEFFICIENTS FOR CALCULATING           
C     SINE(SQ)THETA/LAMBDA**2.                                          00000440
    5 READ (1,100)A,B,C,ALPHA,BETA,GAMMA                                00000460
      WRITE(3,159)A,B,C,ALPHA,BETA,GAMMA
      COSA=COS(ALPHA/57.2958)                                           00000470
      COSB=COS(BETA/57.2958)                                            00000480
      COSC=COS(GAMMA/57.2958)                                           00000490
      DETA=4.0*(1.0-COSA**2-COSB**2-COSC**2+2.0*COSA*COSB*COSC)         00000500
      SHH=(1.0-COSA**2)/(DETA*A**2)                                     00000510
      SKK=(1.0-COSB**2)/(DETA*B**2)                                     00000520
      SLL=(1.0-COSC**2)/(DETA*C**2)                                     00000530
      SKL=(COSB*COSC-COSA)*2.0/(B*C*DETA)                               00000540
      SHK=(COSA*COSB-COSC)*2.0/(A*B*DETA)                               00000550
      SHL=(COSA*COSC-COSB)*2.0/(A*C*DETA)                               00000560
      DO I=1,11
        SPACE(I)=0.0
      ENDDO
C   SWITCH CARDS HERE IF RE-PREPARE
      IF(IS1.NE.5)GOTO 440
      READ(1,1201)ICARD
      IF(ICARD(1).NE.ISW)GOTO 441
      ISWITCH=1
      READ(1,432)(SW(II),II=1,9)    ! LOOK FOR 1/3 AND 2/3
      DO JJJ=1,9           ! CHECK ALL NUMBERS
      GTS=0.0               ! CAN BE FROM 0.0 TO 9.0
      SWT=ABS(SW(JJJ))
      DO III=1,9   ! COULD BE 1.33 OR UP TO 9.33
      IF(SWT.GT.1.0)THEN         ! ONLY WANT DECIMAL PART
      SWT=SWT-1.0
      GTS=GTS+1.0
      ENDIF
      ENDDO
      IF(SWT.GT.0.299.AND.SWT.LT.0.4)SWT=(1.0/3.0) ! FIX FRACTION 
      IF(SWT.GT.0.599 .AND. SWT.LT.0.7)SWT=(2.0/3.0)  ! ADD INTEGER
      SWT=SWT+GTS            ! PUT BACK DIGITS 
C     WRITE(3,9003)SWT,SW(JJJ)
C9003  FORMAT('  SWT=',F9.6,'   SW(JJJ)=',F9.6)
      IF(SW(JJJ).LT.0.0)SW(JJJ)=-SWT
      IF(SW(JJJ).GT.0.0)SW(JJJ)=SWT
      ENDDO
      WRITE(3,9003)SW
9003  FORMAT(' SWITCH ',9F9.6)
440   READ(1,1201)ICARD
441   REWIND IT2
      CALL NAMTB(CARD)                                                  00000600
C                                                                       00000610
C     SET UP FORM FACTORS.                                              00000620
      IF(IS1.EQ.2)THEN
        IF(ICARD(1).NE.IKND)GOTO 1112
C  READING IN OF KIND F
          DECODE(80,175,ICARD)IKNF,NRED,target
          if (target .ne. 'CU') target='MO'
          WRITE(3,176)KNF,NRED,target
        ELSE
          DECODE(80,175,ICARD)KNF,NRED,target
          if (target .ne. 'CU') target='MO'
          WRITE(3,176)KNF,NRED
      ENDIF
      DO II=1,12
        CC(II)=0.0
        INL(II)=1
      ENDDO
C                                                                       00000610
      DO NQ=1,12
        IF (CARD(5).EQ.CKNF(NQ))GOTO 1111
      ENDDO
 1111 NQ=NQ-1
 1112 IF(NRED.NE.0)THEN
        DO K=1,NRED
          READ(1,131)(QFT(K,L),L=1,30),MK(K)
          WRITE(3,132)(QFT(K,L),L=1,30),MK(K)
        ENDDO
      ENDIF
C     INITIALIZE FORM FACTORS                                           00000750
      DO 340 I=1,NQ                                                     00000770
        IF(NRED.NE.0)THEN
          DO K=1,NRED
            IF(MK(K).EQ.KNF(I))GOTO 219
          ENDDO
        ENDIF
C     FORM FACTOR NOT READ IN, CHECK INTERNAL TABLE                     00000830
  211 CALL FFBC('FF',KNF(I),AO,BO,C1,ERG)                                 
      INL(I)=0
      IF (ERG.EQ.0.0)GOTO 215
  212 WRITE (3,178)                                                     00000870
      IF(IS1.EQ.2)WRITE(3,2121)
2121  FORMAT(' YOU NEED TO ENTER A KIND F CARD WHEN YOU ARE HAND-',
     1'ENTERING ANY FORM FACTORS.')
      IS1=-1                                                            00000880
      RETURN                                                            00000890
  215 DO K=1,4
        AA(I,K)=AO(K)
        BB(I,K)=BO(K)
      ENDDO
      CC(I)=C1
      GO TO 340                                                         00000920
  219 DO L=1,30
        QT(I,L)=QFT(K,L)
      ENDDO
  340 CONTINUE                                                          00000950
      IF(IS1.EQ.2)THEN
        IF(ICARD(1).EQ.IKND)READ(1,1201)ICARD
        DO I=1,12
          CC(I)=CC(I)+ADF(I)
        ENDDO
        GOTO 18
      ENDIF
      DO I=1,12
        Q(I)=0.0
      ENDDO
c
C READ IN OF ANOMALOUS DISPERSION FACTORS.  
      DO II=1,7
        DFP(II)=0.0
      ENDDO
c
      READ(1,120)(KD(II),DFP(II),II=1,7)
c
  34  DO II=1,7
        IF(KD(II).EQ.'   ')GOTO 36
      ENDDO
C TOTAL NUMBER OF DISPERSION FACTORS
  36  ND=II-1
      DO 38 II=1,ND
      DO 37 JJ=1,NQ
  37  IF(CD(II).EQ.CKNF(JJ))GOTO 3801
C  HERE IF NO MATCH
      WRITE(3,122)
      IS1=-1
      RETURN
3801  IF(DFP(II).EQ.0.)
     1  CALL FFBC(target,KD(II),dumA,DUMB,DUMC,ERG)
      dfp(ii)=dumA(1)
C CALL FFBC FOR ATOMIC MASS, abs stuff FOR MOLY,copper ONLY
      IF(ERG.NE.0.0)WRITE(3,4124)
      CC(JJ)=CC(JJ)+DFP(II)
      ADF(JJ)=DFP(II)
38    CONTINUE
      WRITE(3,121) target,(KD(II),DFP(II),II=1,nd)
C     SWITCH TAPES IF PREPARE.                                          00000990
      GO TO (280,18,17,17,17),IS1
C  BRANCH TO LIST,EDIT,PREPARE,MAKE PHASED TAPE, OR RE-PREPARE
   17 IAR=IT1                                                           00001020
      IT1=IT2                                                           00001030
      IT2=IAR                                                           00001040
C     START TAPE FOR PREPARE.                                           00001060
      IF(IS1.NE.5) GO TO 9317
C  POSITION ALREADY PREPARED A DATA TAPE TO REFLECTION RECORD
      READ(4)FLAT
      READ(4)FLAT
      READ(4)FLAT
      IKIND=2
9317  IF(ABTP.EQ.1) WRITE(3,949) KNF
      IF(ABTP.EQ.0) WRITE(3,149) KNF
      IF(IKIND.EQ.1.OR.IS1.EQ.4)GOTO 9319
      READ(1,115)ADE  ! READING END CARD
      IF(ADE-CARD(1))9318,9319,9318
9318  WRITE(3,9320)ADE
      IS1=-1
9320  FORMAT(' UNIDENTIFIABLE CARD. FIRST 4 COLUMNS ARE: ',A4)
      RETURN
9319  WRITE(IT2)SCAL,(ADF(I),I=1,10),A,B,C,ALPHA,BETA,GAMMA,COSA,
     1 COSB,COSC,ADF(11),ADF(12),(SPACE(I),I=1,9)
C  WRITING FIRST RECORD OF HKL FILE.  SCALE FACTOR SET TO 1.0.
      WRITE (IT2) KNF,SHH,SKK,SLL,SKL,SHK,SHL,SPACE,MGO,MGO             00001100
      WRITE(IT2)SPACE,SPACE,(SPACE(I),I=1,9)
      J=1                                                               00001120
      MAM=7                                                             00001130
      IF(IKIND.EQ.1.OR.IPRNT.EQ.1)GOTO 9321
C  IF LIMITED OUTPUT FOR PREPARE, RE-PREP, READ THROUGH TAPE ONCE TO SEE
C  TOTAL NUMBER OF REFLECTIONS.  FIRST 5 AND LAST 5 REFLECTIONS
C  PRINTED.
9322  READ(4)IH1
      IF(IH1.LE.-100.OR.IH1.EQ.999999)THEN
        REWIND 4
        IF(IS1.EQ.5)THEN  ! REPREPARE - SET UP TAPE
          READ(4)FLAT
          READ(4)FLAT
          READ(4)FLAT
        ENDIF
        GOTO 9321
      ENDIF
      NREF=NREF+1
      GOTO 9322
9321  IF(IS1.EQ.4) GO TO 9300
C     CARD READ IN PREPARE MODE                                         00001150
  300 CONTINUE
      GO TO (400,401),IKIND
  400 READ (1,115)ADE,IH(J),IK(J),IL(J),DCOR(J),W(J)                    00001170
      GO TO 403
  401 READ(4)IH(J),IK(J),IL(J),DCOR(J),W(J)
      NREF1=NREF1+1
      IF(IS1.EQ.5) GO TO 9420
      IF (IH(J).GT.-100) GO TO 20
      GO TO 305
9420  IF(IH(J).EQ.999999) GO TO 305
      IF(ISWITCH.EQ.0)GOTO 433
      B1=IH(J)
      B2=IK(J)
      B3=IL(J)
      C1=B1*SW(1)+B2*SW(2)+B3*SW(3)
      C2=B1*SW(4)+B2*SW(5)+B3*SW(6)
      C3=B1*SW(7)+B2*SW(8)+B3*SW(9)
      IF(C1.GT.0.0)THEN
      C1=C1+.0001
      ELSE
      C1=C1-.0001
      ENDIF
      IF(C2.GT.0.0)THEN
      C2=C2+.0001
      ELSE
      C2=C2-.0001
      ENDIF
      IF(C3.GT.0.0)THEN
      C3=C3+.0001
      ELSE
      C3=C3-.0001
      ENDIF
C     WRITE(3,9001)C1,C2,C3
C9001   FORMAT('  C1,C2,C3=',3F10.4)
      JC1=C1
      JC2=C2
      JC3=C3
      IF(ABS(C1-FLOAT(JC1)).GT.0.01)GOTO 435
      IF(ABS(C2-FLOAT(JC2)).GT.0.01)GOTO 435
      IF(ABS(C3-FLOAT(JC3)).GT.0.01)GOTO 435
      IH(J)=C1
      IK(J)=C2
      IL(J)=C3
433   GOTO 20
435   WRITE(3,436)IH(J),IK(J),IL(K)
436   FORMAT(' TRANSFORMATION MATRIX TIMES ',3I5,' NON-INTEGER INDEX.')
      ITEST=ITEST+1
      IF(ITEST.GE.5)GOTO 437
      GOTO 20
437   IS1=-1
      RETURN
  403 CONTINUE
      IF (ADE-CARD(5)) 302,20,302                                       
  302 IF (ADE-CARD(1)) 3020,305,3020
3020  IF(ADE.EQ.'EDIT')THEN
      IEDIT=1
      GOTO 305
      ENDIF
      GOTO 224
C    CARD READ FOR MAKE PHASED TAPE
9300  READ(1,9115) ADE,IH(J),IK(J),IL(J),ACLC,BCLC,P,W(J)
9115  FORMAT(A4,3I6,2F8.2,2F8.5)
      GO TO 403
C     START TAPE FOR EDIT                                               00001210
   18 LA=0                                                              00001230
      LD=0                                                              00001240
      LS=0                                                              00001250
      IEN=0                                                             00001260
      REWIND IT1
      DO I=1,3
        READ (IT1) FLAT
        WRITE (IT2) FLAT
      ENDDO
      IF (FLAT(1).NE.0.)THEN
  220   READ (IT1) FLAT 
        WRITE (IT2) FLAT
      ENDIF
      IF (FLAT(1).NE.0.)GOTO 220
C     READ IN EDIT DATA CARDS.                                          00001370
      NUF=1                                                             00001390
      WRITE(3,110)                                                      00001400
      IBLK(1)='        '
      DECODE(80,115,ICARD) ADE,IH(NUF),IK(NUF),IL(NUF),DCOR(NUF),W(NUF)
      GOTO 2223
222   READ(1,2222)ICRD
2222  FORMAT(A80)
      IBLK(NUF)=ICRD(23:30)
C  IBLK USED TO SEE IF F IS BLANK - IF SO, DONT COMPARE F IN DELS OR
C  SUBS.
      DECODE(80,115,ICRD) ADE,IH(NUF),IK(NUF),IL(NUF),DCOR(NUF),W(NUF)
2223  DO J=1,5
        IF (ADE.EQ.CARD(J))GOTO 227
      ENDDO
224   WRITE (3,140)
      IS1=-1                                                            00001460
      RETURN                                                            00001470
  140 FORMAT ('0 ERROR ON INPUT CARD')                                  00001480
  227 GO TO (239,239,239,239,229),J                                     00001490
C     HERE FOR DATA CARD.                                               00001510
  229 WRITE(3,117)IH(NUF),IK(NUF),IL(NUF),DCOR(NUF),W(NUF)              00001530
      NUF=NUF+1                                                         00001540
      GO TO 222                                                         00001550
C     HERE FOR ADDITIONS.                                               00001570
  230 ISK=1                                                             00001590
      LAB=NUF                                                           00001600
      GO TO 222                                                         00001610
C     HERE FOR DELETIONS.                                               00001630
  231 ISK=2                                                             00001650
      LDB=NUF                                                           00001660
      GO TO 222                                                         00001670
C     HERE FOR SUBSTITUTUONS.                                           00001690
  232 ISK=3                                                             00001710
      LSB=NUF                                                           00001720
      GO TO 222                                                         00001730
C     TERMINATE PREVIOUS.                                               00001750
  239 WRITE(3,116)ADE                                                   00001770
      IF(NUF-1) 241,240,241                                             00001780
  240 GO TO (246,230,231,232,229),J                                     00001790
  241 GO TO (242,243,244),ISK                                           00001800
  242 LA=NUF-LAB                                                        00001810
      LAH=NUF-1                                                         00001820
      GO TO 240                                                         00001830
  243 LD=NUF-LDB                                                        00001840
      LDH=NUF-1                                                         00001850
      GO TO 240                                                         00001860
  244 LS=NUF-LSB                                                        00001870
      LSH=NUF-1                                                         00001880
      GO TO 240                                                         00001890
C     HERE FOR END OF INPUT.                                            00001910
  246 NR=NUF+2                                                          00001930
C     EDIT MODE TAPE READ.                                              00001960
  250 IF(IEN) 271,247,271                                               00001980
  247 READ(IT1,END=901) IH(NR),IK(NR),IL(NR),DCOR(NR),W(NR),PIH,PIK,PIL,
     1SSQLS,
     2(Q(I),I=1,12),(SPACE(I),I=1,10)
      GO TO 900
  901 WRITE(3,902)IT1
  902 FORMAT('0*** THE END OF TAPE ON UNIT',I4,' HAS BEEN REACHED'/
     1'0THE LAST OF THE TAPE HAS BEEN WIPED OUT')
      IH(NR)=999999
C     CHECK FOR END.                                                    00002020
  900 IF (IH(NR)-999999) 249,269,249                                    00002040
C     CHECK FOR DELETIONS.                                              00002060
  249 IF(LD) 248,1254,248                                               00002080
  248 DO 254 J=LDB,LDH                                                  00002090
      IF (IH(NR)-IH(J)) 254,251,254                                     00002100
  251 IF(IK(NR)-IK(J)) 254,252,254                                      00002110
  252 IF (IL(NR)-IL(J)) 254,253,254                                     00002120
253   IF(IBLK(J).EQ.'        ')GOTO 265
C  IF F BLANK, COMPARE ONLY H,K,L AND DELETE ALL MATCHES
      DC=ABS(DCOR(NR)-DCOR(J))
      IF (DC-0.10) 265,254,254                                          00002140
  254 CONTINUE                                                          00002150
C     CHECK FOR SUBSTITUTIONS.                                          00002170
 1254 IF (LS) 255,262,255                                               00002190
  255 DO 260 J=LSB,LSH,2                                                00002200
      IF(IH(NR)-IH(J)) 260,257,260                                      00002210
  257 IF(IK(NR)-IK(J)) 260,258,260                                      00002220
  258 IF(IL(NR)-IL(J)) 260,259,260                                      00002230
259   IF(IBLK(J).EQ.'        ')GOTO 267
C  IF F BLANK, COMPARE ONLY H,K,L FOR SUBS
      DC=ABS(DCOR(NR)-DCOR(J))
      IF(DC-0.10) 267,260,260                                           00002250
  260 CONTINUE                                                          00002260
C     COPY REFLECTION                                                   00002280
  262 MAM=7                                                             00002300
      J=NR                                                              00002310
      GO TO 66                                                          00002320
C     HERE TO DELETE REFLECTION.                                        00002340
265   WRITE(3,117)IH(NR),IK(NR),IL(NR),DCOR(NR),W(NR)
      WRITE(3,2650)
2650  FORMAT('+',40X,'DELETION')
      WRITE(3,2675)
      IH(J)=999
      GO TO 247
C     HERE TO SUBSTITUTE REFLECTION.                                    00002390
267   WRITE(3,117)IH(NR),IK(NR),IL(NR),DCOR(NR),W(NR)
      WRITE(3,2670)
2670  FORMAT('+',40X,'SUBSTITUTION')
      WRITE(3,117)IH(J+1),IK(J+1),IL(J+1),DCOR(J+1),W(J+1)
      WRITE(3,2675)
2675  FORMAT(1X)
      IH(J)=999
      MAM=4                                                             00002420
      J=J+1                                                             00002430
      GO TO 20                                                          00002440
C     HERE FOR END OF DATA, DO ADDITIONS.                               00002460
  269 IF (LA) 270,572,270                                               00002480
  270 MAM=2                                                             00002490
      IEN=1                                                             00002500
      DO 271 J=LAB,LAH                                                  00002510
      GO TO 20                                                          00002520
  271 CONTINUE                                                          00002530
  572 IXR=0                                                             00002540
      WRITE (3,177)                                                     00002550
      IF (LD) 272,374,272                                               00002560
  272 DO 273 J=LDB,LDH                                                  00002570
      IF (IH(J)-999) 274,273,274                                        00002580
  274 WRITE (3,179) IH(J),IK(J),IL(J),DCOR(J),W(J)                      00002590
      IXR=IXR+1                                                         00002600
  273 CONTINUE                                                          00002610
  374 IF (LS) 275,505,275                                               00002620
  275 DO 277 J=LSB,LSH,2                                                00002630
      IF (IH(J)-999) 276,277,276                                        00002640
  276 WRITE (3,179) IH(J),IK(J),IL(J),DCOR(J),W(J)                      00002650
      IXR=IXR+1                                                         00002660
  277 CONTINUE                                                          00002670
  505 IF (IXR) 305,508,305                                              00002680
  508 WRITE (3,579)                                                     00002690
      GO TO 305                                                         00002700
C     LISTING INITIALIZATION.                                           00002720
  280 READ (IT1) SPACE(1),(ADF(I),I=1,10),A,B,C,ALPHA,BETA,GAMMA,COSA,
     1 COSB,COSC,ADF(11),ADF(12),(SPACE(I),I=1,9)
      IF(IPUN.EQ.1)WRITE(2,9000)A,B,C,ALPHA,BETA,GAMMA
9000  FORMAT('CELL ',3(F9.5,1X),3(F9.4,1X))
      READ (IT1) KNF,SHH,SKK,SLL,SKL,SHK,SHL,SPACE                      00002750
      WRITE (3,148) A,B,C,ALPHA,BETA,GAMMA,SHH,SKK,SLL,SKL,SHK,SHL      00002760
      IF(ABTP.EQ.0) WRITE(3,149)KNF
      IF(ABTP.EQ.1) WRITE(3,949)KNF
      DO 1275 NQ=1,12                                                   00002780
      IF (CARD(5)-CKNF(NQ)) 1275,1276,1275                              00002790
 1275 CONTINUE                                                          00002800
      GO TO 1277                                                        00002810
 1276 NQ=NQ-1                                                           00002820
 1277 READ (IT1)FLAT                                                    00002830
      IF(FLAT(1)) 282,285,282                                           00002840
  282 READ (IT1) FLAT                                                   00002850
      IF (FLAT(1)-CARD(1)) 282,285,282                                  00002860
C     READ IN FOR LISTING.                                              00002880
285   IF(IS1.EQ.2)GOTO 440
      J=1
      MAM=7                                                             00002910
  286 READ(IT1,END=905) IH(J),IK(J),IL(J),DCOR(J),W(J),PIH,PIK,PIL,SSQLS
     1,(Q(I),
     2I=1,12),(SPACE(I),I=1,10)
      GO TO 906
  905 WRITE(3,902)IT1
      IH(J)=999999
  906 IF(IH(J)-999999) 70,307,70                                        00002940
C     PUT REFLECTION ON TAPE.                                           00002960
   20 H1=IH(J)                                                          00002980
      H2=IK(J)                                                          00002990
      H3=IL(J)                                                          00003000
      PIH=6.28319*H1                                                    00003010
      PIK=6.28319*H2                                                    00003020
      PIL=6.28319*H3                                                    00003030
C     COMPUTE SINE SQUARRED THETA.                                      00003050
      SSQLS=H1**2*SHH+H2**2*SKK+H3**2*SLL+H1*H2*SHK+H1*H3*SHL+H2*H3*SKL 00003070
      STL=SQRT (SSQLS)                                                  00003080
C     FORM FACTORS CALCULATION                                          00003100
      DO 53 II=1,12
  53  Q(II)=0.0
      PV=STL*20.0+1.0                                                   00003120
      MO=PV                                                             00003130
      PO=MO                                                             00003140
      RAT=PV-PO                                                         00003150
      TEMP=RAT**2-RAT                                                   00003160
      DO 65 K=1,NQ                                                      00003170
      IF(INL(K))64,54,64
   54 DO 56 I=1,4
   56 Q(K)=Q(K)+AA(K,I)*EXP((-1)*BB(K,I)*SSQLS)
      Q(K)=Q(K)+CC(K)
      GOTO 65
   64 Q(K)=(1.0-RAT+TEMP*0.5)*QT(K,MO)-(TEMP-RAT)*QT(K,MO+1)+TEMP*0.5*  00003180
     1QT(K,MO+2)                                                        00003190
      Q(K)=Q(K)+CC(K)  ! ADD ANOMOLOUS
   65 CONTINUE                                                          00003200
      IF(IS1.NE.4) GO TO 66
C    DO SPECIAL PHASED TAPE
      IF(P.EQ.0.0) GO TO 9301
      BCLC=ACLC*SIN(P)
      ACLC=ACLC*COS(P)
9301  DCOR(J)=SQRT(ACLC*ACLC+BCLC*BCLC)
      GO TO 66
   66 WRITE (IT2)IH(J),IK(J),IL(J),DCOR(J),W(J),PIH,PIK,PIL,SSQLS,(Q(I),00003210
     1I=1,12),(SPACE(I),I=1,10)                                         00003220
      IF (IPRT.EQ.1) GO TO 71
70    IF(ABTP.EQ.1) GO TO 970
      IF(IPRNT.EQ.0)THEN
        IF(NREF1.EQ.6)WRITE(3,9302)
        IF(NREF1.GT.5.AND.NREF-NREF1.GT.5)GOTO 71
        IF(NREF1.LE.0)GOTO 71
9302    FORMAT(1X)
      ENDIF
      WRITE (3,150) CARD(MAM),IH(J),IK(J),IL(J),DCOR(J),W(J),SSQLS,(Q(I)00003230
     1,I=1,NQ)
      NPXZ=NPXZ+1                                                       00003250
      GO TO 71
970   IF(IPRNT.EQ.0)THEN
        IF(NREF1.EQ.6)WRITE(3,9302)
        IF(NREF1.GT.5.AND.NREF-NREF1.GT.5)GOTO 71
      ENDIF
      WRITE(3,950) CARD(MAM),IH(J),IK(J),IL(J),DCOR(J),W(J),SSQLS,ACLC,
     1BCLC,(Q(I),I=1,NQ)
      NPXZ=NPXZ+1
71    IF(IPUN.EQ.1)WRITE(2,800)IH(J),IK(J),IL(J),DCOR(J),W(J)
800   FORMAT(4X,3I6,F8.2,F8.4)
      IF(NPXZ-50)78,73,78                                               00003260
73    IF(ABTP.EQ.0) WRITE(3,149) KNF
      IF(ABTP.EQ.1) WRITE(3,949) KNF
      NPXZ=0                                                            00003280
   78 CONTINUE                                                          00003290
      GO TO (286,250,300,9300,401),IS1
C     TERMINATE FOR PREPARE AND EDIT                                    00003320
  305 LEN(1)=999999                                                     00003340
      DO 306 I=1,3                                                      00003350
      WRITE (IT2) LEN,SPACE,SPACE                                       00003360
  306 CONTINUE                                                          00003370
C     SWITCH TAPES                                                      00003390
      IAR=IT1                                                           00003410
      IT1=IT2                                                           00003420
      IT2=IAR                                                           00003430
      REWIND IT2                                                        00003440
  307 REWIND IT1                                                        00003450
      IF(IS1.EQ.1)THEN
      READ(1,308)ECK
      WRITE(3,308)ECK
308   FORMAT(A4)
      IF(ECK.EQ.'EDIT')IEDIT=1
      ENDIF
      IF(IEDIT.EQ.1)THEN
      IS1=2
      IEDIT=0
      IPRT=1
      READ(1,1201)ICARD
      GOTO 18
C  EDIT AFTER PREPARE - GOTO EDIT
      ENDIF
      IS1=0                                                             00003460
      RETURN                                                            00003470
      END                                                               00003480
	SUBROUTINE NAMTB(CARD)
	DIMENSION CNAI(5),CARD(20)
	DATA CNAI/'END ','ADD ','DEL ','SUB ','    '/
	DO 1 I=1,5
	CARD(I)=CNAI(I)
1	CONTINUE
	RETURN
	END
