      SUBROUTINE RCHECK
C  READS THE HKL FILE AND CALCULATES R, ETC. FOR DIFFERENT GROUPS OF 
C  DATA.
      DIMENSION F(12),SP(8),SFOBS(354),SFCALC(354),SDELF(354),NFAP(354),
     1 SFOS(354),SFCS(354),SFOFC(354),SWDEL(354),NTOT(354),MAX(3),
     2 ISIG(8)
      COMMON IS1,IS2,IS3,IS4,IS5,IS6,SCF,B2,CARD,JPAGE,IT1,IT2
      EQUIVALENCE(MAX(1),K1MAX),(MAX(2),K2MAX),(MAX(3),K3MAX)
      INTEGER*4 SYS$TRNLOG
      CHARACTER*5 CHAR(14)
      CHARACTER*4 CARD(20)
      CHARACTER*10 NAMDES
      CHARACTER*14 NFILE
      CHARACTER*15 CHARB(3)
      LOGICAL*1 OD            ! TEST FOR IT1 OPEN
      ICD=SYS$TRNLOG('NAM',NAMLEN,NAMDES,,,)
C  RETRIEVING FILE NAME FROM SYSTEM
      IF(.NOT.ICD)THEN
      WRITE(3,9001)
9001  FORMAT(' ERROR ON RETURN FROM TRNLOG')
      STOP 
      ENDIF
      NFILE(1:NAMLEN)=NAMDES
      N=NAMLEN+1
      NFILE(N:N+3)='.HKL'
      NF=IT1  ! HKL UNIT NUMBER
       INQUIRE (UNIT=IT1,OPENED=OD)
       IF(OD)THEN
        OP8=9
C        WRITE(3,1000)IT1       !kaf4/15/93 per wps
C1000    FORMAT('   UNIT ',I1,' IS ALREADY OPEN')
      ELSE
      OPEN(NAME=NFILE,UNIT=NF,TYPE='OLD',FORM='UNFORMATTED',
     1 BLOCKSIZE=32768)
      ENDIF
      DO 99 I=1,354  ! INITIALIZE ARRAYS
      SFOBS(I)=0.0
      SFCALC(I)=0.0
      SDELF(I)=0.0
      NFAP(I)=0
      SFOS(I)=0.0
      SFCS(I)=0.0
      SFOFC(I)=0.0
      SWDEL(I)=0.0
      NTOT(I)=0
99    CONTINUE
      K1MAX=0
      K2MAX=0
      K3MAX=0
      SSQLSMAX=0
      ISIG(1)=100
      ISIG(2)=50
      ISIG(3)=20
      ISIG(4)=10
      ISIG(5)=5
      ISIG(6)=3
      ISIG(7)=1
      ISIG(8)=0
      READ(1,100)CARD
100   FORMAT(20A4)
      IF(CARD(1).EQ.'END ')THEN
C  NO SCALE FACTOR ENTERED - GET IF FROM HKL FILE
      READ(NF)SCF
      ELSE
C  READ SCALE FACTOR FROM INPUT
      DECODE(80,101,CARD)SCF
101   FORMAT(F10.6)
      READ(NF)  !READ FIRST RECORD FROM HKL FILE - DONT NEED INFO
      READ(1,100)CARD
      ENDIF
      WRITE(3,102)SCF
102   FORMAT(' SCALE FACTOR=',F11.6)
      IF(SCF.EQ.0.0)THEN
      WRITE(3,9002)
9002  FORMAT(' SCALE FACTOR INTERPRETTED AS 0.0 - ERROR')
      STOP
      ENDIF
      READ(NF)
      READ(NF)
C  READING 2ND AND 3RD RECORDS FROM HKL FILE - NOT NEEDED
      ICK=1
105   READ(NF)K1,K2,K3,FABS,WEIGHT,PIH,PIK,PIL,SSQLS,F,SP,ACAL,BCAL
C  READ A RECORD
      IF(K1.EQ.999999)GOTO 350 !LAST RECORD ENCOUNTERED
C     IF(ICK.EQ.1.AND.ACAL.EQ.0.0.AND.BCAL.EQ.0.0)THEN
C     WRITE(3,9003)
C003  FORMAT(' INSUFFICIENT DATA ON HKL FILE')
C     STOP
C     ENDIF
      ICK=0
      IF(WEIGHT.EQ.0.0)GOTO 105
      W=WEIGHT/(SCF**2)
      IE1=0
      IE2=0
      IE3=0
      FOBS=ABS(FABS)*SCF
      FCALS=ACAL*ACAL+BCAL*BCAL
      FCAL=SQRT(FCALS)
      DELF=FOBS-FCAL
      WFOB=ABS(W)*FOBS*FOBS
      wfob=sign (wfob,fabs)
      WFCL=ABS(W)*FCALS
      WDEL=WFOB-WFCL
      IF(IABS(K1).GT.K1MAX)K1MAX=IABS(K1)
      I=IABS(K1)+1
      IF(I.GT.100)I=100 ! MAX H VALUE IS 100
C  I KEEPS TRACK OF "GROUP OF DATA" AND IS USED AS ARRAY IDENTIFIER
C  FIRST 100 BLOCKS IN THE ARRAYS ARE FOR ABS(H)=N FOR N=1 TO MAX
      ASSIGN 110 TO IGO
      GOTO 500 ! ADD TO APPROPRIATE ARRAYS
110   IF(IABS(K2).GT.K2MAX)K2MAX=IABS(K2)
      I=IABS(K2)+101
C  ARRAY BLOCKS 101-200 ARE FOR ABS(K)=N FOR N=1,MAX
      IF(I.GT.200)I=200  ! MAX K VALUE IS 100
      ASSIGN 201 TO IGO
      GOTO 500
201   IF(IABS(K3).GT.K3MAX)K3MAX=IABS(K3)
      I=IABS(K3)+201
C  ARRAY BLOCKS 201-300 ARE FOR ABS(L)=N WHERE N=1,MAX
      IF(I.GT.300)I=300  !MAX VALUE FOR L IS 100
      ASSIGN 301 TO IGO
      GOTO 500
301   IF(K1*K2.GT.0)THEN
      I=301
      ASSIGN 303 TO IGO
      GOTO 500
      ENDIF
      IF(K1*K2.LT.0)THEN
      I=302
      ASSIGN 303 TO IGO
      GOTO 500
      ENDIF
303   IF(K1*K3.GT.0)THEN
      I=303
      ASSIGN 305 TO IGO
      GOTO 500
      ENDIF
      IF(K1*K3.LT.0)THEN
      I=304
      ASSIGN 305 TO IGO
      GOTO 500
      ENDIF
305   IF(K2*K3.GT.0)THEN
      I=305
      ASSIGN 307 TO IGO
      GOTO 500
      ENDIF
      IF(K2*K3.LT.0)THEN
      I=306
      ASSIGN 307 TO IGO
      GOTO 500
      ENDIF
307   EK1=K1/2.
      IK1=K1/2
      EK2=K2/2.
      IK2=K2/2
      EK3=K3/2.
      IK3=K3/2
      IF(EK1.EQ.IK1)IE1=1
      IF(EK2.EQ.IK2)IE2=2
      IF(EK3.EQ.IK3)IE3=3
      ASSIGN 315 TO IGO
      GOTO (314,310,312,308,309,311,3070)IE1+IE2+IE3+1
3070  I=307 ! E E E
      GOTO 500
308   IF(IE1.EQ.0)THEN
      I=313 ! O E E
      ELSE
      I=308 ! E E O
      ENDIF
      GOTO 500
309   I=309 ! E O E
      GOTO 500
310   I=310 ! E O O
      GOTO 500
311   I=311 ! O E E
      GOTO 500
312   I=312 ! O E O
      GOTO 500
314   I=314 ! O O O
      GOTO 500
315   IF(SSQLS.GT.SSQLSMAX)SSQLSMAX=SSQLS
      ISSQLS=SSQLS*20.
C  315-345 ARE INTERVALS OF SSQLS BY .05
      IF(ISSQLS.GT.30)ISSQLS=30 ! MAX FOR SSQLS IS 1.5
      I=315+ISSQLS
      ASSIGN 346 TO IGO
      GOTO 500
346   SIGF=1./WEIGHT
      FABSS=FABS*FABS
      IF(FABS.LT.0.0)FABSS=-FABSS
      ASSIGN 348 TO IGO
      DO 348 J=1,8
      IF(FABSS.GT.ISIG(J)*SIGF)THEN
      I=345+J
      GOTO 500
      ENDIF
348   CONTINUE
      I=354
      ASSIGN 105 TO IGO
      GOTO 500
350   NOL=6
      WRITE(3,351)
351   FORMAT(' ',19X,' SUM|Fo|  SUM|Fc|  SUM|DF|    R    N(R)  SUMw
     1Fo**4  SUMwFc**4 SUMw(FoFc)**2 SUMw(DF**2)**2 RMS RWF**2  N(w)')
      CHAR(1)='|H|='
      CHAR(2)='|K|='
      CHAR(3)='|L|='
      DO 356 J=1,3
        write(3,3531)
        DO 354 I=1,99
C  PRINTING OUT RESULTS FOR GROUPS OF I (ABS(I)=N FOR N=1,MAX AND I
C = H,K AND L
        L=(J-1)*100+I
        IF(I-1.GT.MAX(J))GOTO 356
        WRITE(3,352)CHAR(J),I-1
352     FORMAT(1X,A5,I2)
353     FORMAT('+',18X,3F9.2,F7.4,I6,1X,E10.4,1X,E10.4,2X,E10.4,4X,
     1  E10.4,1X,F7.2,F7.4,I6)
3530    FORMAT(1X)
3531    format(' ')  !5/93--to add line between sets of H's,K's, and L's
        IF(SFOBS(L).EQ.0.0)THEN
          A=0.0
        ELSE
          A=SDELF(L)/SFOBS(L)
        ENDIF
        IF(SFOS(L).EQ.0.0)THEN
          B=0.0
        ELSE
          B=SWDEL(L)/SFOS(L)
        ENDIF
        IF(NTOT(L).EQ.0)THEN
          C=0.0
        ELSE
          C=SQRT(SWDEL(L)/NTOT(L))
        ENDIF
        WRITE(3,353)SFOBS(L),SFCALC(L),SDELF(L),A,
     1  NFAP(L),SFOS(L),SFCS(L),SFOFC(L),SWDEL(L),C,B,
     2  NTOT(L)
c      NOL=NOL+1         !kaf 4/15/93 per wps
c      IF(NOL.GE.82)THEN
c      WRITE(3,351)
c      NOL=2
c      ENDIF
354     CONTINUE
        WRITE(3,355)CHAR(J),MAX(J)
355     FORMAT(1X,A6,'99-',I3)
        L=J*100
        IF(SFOBS(L).EQ.0.0)THEN
          A=0.0
        ELSE
          A=SDELF(L)/SFOBS(L)
        ENDIF
        IF(SFOS(L).EQ.0.0)THEN
          B=0.0
        ELSE
          B=SWDEL(L)/SFOS(L)
        ENDIF
        IF(NTOT(L).EQ.0)THEN
          C=0.0
        ELSE
          C=SQRT(SWDEL(L)/NTOT(L))
        ENDIF
        WRITE(3,353)SFOBS(L),SFCALC(L),SDELF(L),A,NFAP(L),
     1  SFOS(L),SFCS(L),SFOFC(L),SWDEL(L),C,B,NTOT(L)
c3560  WRITE(3,3530)    !kaf 4/15/93 per wps
356   CONTINUE    !KAF 4/93 PER WPS TO ELIMINATE PAGE 
      WRITE (3,3531)
C     NOL=NOL+1   !BREAKS
      CHAR(1)='H*K>0'
      CHAR(2)='H*K<0'
      CHAR(3)='H*L>0'
      CHAR(4)='H*L<0'
      CHAR(5)='K*L>0'
      CHAR(6)='K*L<0'
      CHAR(7)='E E E'
      CHAR(8)='E E O'
      CHAR(9)='E O E'
      CHAR(10)='E O O'
      CHAR(11)='O E E'
      CHAR(12)='O E O'
      CHAR(13)='O O E'
      CHAR(14)='O O O'
      DO 358 I=1,14
        WRITE(3,357)CHAR(I)
357     FORMAT(1X,A5)
        L=300+I
        IF(SFOBS(L).EQ.0.0)THEN
          A=0.0
        ELSE
          A=SDELF(L)/SFOBS(L)
        ENDIF
        IF(SFOS(L).EQ.0.0)THEN
          B=0.0
        ELSE
          B=SWDEL(L)/SFOS(L)
        ENDIF
        IF(NTOT(L).EQ.0)THEN
          C=0.0
        ELSE
          C=SQRT(SWDEL(L)/NTOT(L))
        ENDIF
        WRITE(3,353)SFOBS(L),SFCALC(L),SDELF(L),A,NFAP(L),
     1  SFOS(L),SFCS(L),SFOFC(L),SWDEL(L),C,B,NTOT(L)
        IF(I.EQ.6)WRITE (3,3531)
        IF(I.EQ.14)WRITE (3,3531)
c        NOL=NOL+1
c        IF(NOL.GE.82)THEN
c          WRITE(3,351)
c          NOL=2
c        ENDIF
c      IF(I.EQ.6)THEN     !kaf 4/15/93 per wps
c      WRITE(3,3530)
c      NOL=NOL+1
c      ENDIF
358   CONTINUE
c      WRITE(3,3530)      !kaf 4/15/ per wps
C      NOL=NOL+1
      DO 361 I=1,30
        A=(I-1)*.05
        B=I*.05
        IF(SSQLSMAX.LT.A)GOTO 362
        WRITE(3,360)A,B
360     FORMAT(1X,F4.2,'<SSQLS<=',F4.2)
        L=314+I
        IF(SFOBS(L).EQ.0.0)THEN
          A=0.0
        ELSE
          A=SDELF(L)/SFOBS(L)
        ENDIF
        IF(SFOS(L).EQ.0.0)THEN
          B=0.0
        ELSE
          B=SWDEL(L)/SFOS(L)
        ENDIF
        IF(NTOT(L).EQ.0)THEN
          C=0.0
        ELSE
          C=SQRT(SWDEL(L)/NTOT(L))
        ENDIF
        WRITE(3,353)SFOBS(L),SFCALC(L),SDELF(L),A,NFAP(L),
     1  SFOS(L),SFCS(L),SFOFC(L),SWDEL(L),C,B,NTOT(L)
C      NOL=NOL+1         !KAF 4/93 PER WPS
C      IF(NOL.GE.82)THEN !TO ELMINIATE
C      WRITE(3,351)      !PAGE BREAKS
C      NOL=2             !
C      ENDIF             !KAF
361   CONTINUE
      WRITE(3,360)B,SSQLSMAX
      L=345
      IF(SFOBS(L).EQ.0.0)THEN
      A=0.0
      ELSE
      A=SDELF(L)/SFOBS(L)
      ENDIF
      IF(SFOS(L).EQ.0.0)THEN
      B=0.0
      ELSE
      B=SWDEL(L)/SFOS(L)
      ENDIF
      IF(NTOT(L).EQ.0)THEN
      C=0.0
      ELSE
      C=SQRT(SWDEL(L)/NTOT(L))
      ENDIF
      WRITE(3,353)SFOBS(L),SFCALC(L),SDELF(L),A,NFAP(L),
     1 SFOS(L),SFCS(L),SFOFC(L),SWDEL(L),C,B,NTOT(L)
c362   WRITE(3,3530)     !kaf 4/15/93 per wps
c      NOL=NOL+1
362   WRITE(3,3531)
      CHARB(1)='F**2>SIG(F**2)'
      CHARB(2)='F**2>0'
      CHARB(3)='ALL REFLECTIONS'
      DO 364 I=1,9
        IF(I.GT.6)THEN
          WRITE(3,363)CHARB(I-6)
        ELSE
          WRITE(3,3630)ISIG(I)
3630      FORMAT(1X,'F**2>',I3,'*SIG(F**2)')
        ENDIF
363     FORMAT(1X,A15)
        L=345+I
        IF(SFOBS(L).EQ.0.0)THEN
          A=0.0
        ELSE
          A=SDELF(L)/SFOBS(L)
        ENDIF
        IF(SFOS(L).EQ.0.0)THEN
          B=0.0
        ELSE
          B=SWDEL(L)/SFOS(L)
        ENDIF
        IF(NTOT(L).EQ.0)THEN
          C=0.0
        ELSE
          C=SQRT(SWDEL(L)/NTOT(L))
        ENDIF
        WRITE(3,353)SFOBS(L),SFCALC(L),SDELF(L),A,NFAP(L),
     1  SFOS(L),SFCS(L),SFOFC(L),SWDEL(L),C,B,NTOT(L)
C      NOL=NOL+1          !KAF 4/93
C      IF(NOL.GE.82)THEN  !PER WPS
C      WRITE(3,351)       !TO
C      NOL=2              !ELIMINATE
C      ENDIF              !PAGE BREAKS
       IF(I.EQ.8)WRITE(3,3530)
C      NOL=NOL+1
364   CONTINUE
      REWIND NF
      CLOSE(UNIT=NF,DISP='SAVE')
      WRITE(3,3530)
      RETURN
500   IF(FABS.LT.0.0)GOTO 501
      SFOBS(I)=SFOBS(I)+FOBS
      SFCALC(I)=SFCALC(I)+ABS(FCAL)
      SDELF(I)=SDELF(I)+ABS(DELF)
      NFAP(I)=NFAP(I)+1
501   SFOS(I)=SFOS(I)+WFOB*WFOB
      SFCS(I)=SFCS(I)+WFCL*WFCL
      SFOFC(I)=SFOFC(I)+WFOB*WFCL
      SWDEL(I)=SWDEL(I)+WDEL*WDEL
      NTOT(I)=NTOT(I)+1
      GOTO IGO
      END
