       SUBROUTINE SETCAL
C    READ IN ALL OF HKL DISK, DO LIMITS TESTS, AND OTHER TESTS THAT
C    ELIMINATE REFLECTION DATA. FIND MAX H,K,L AND I IF NECESSARY.
C    WRITE ACCEPTED DATA ON A SCRATCH DISK THAT WILL BE DELETED WHEN
CC   PROGRAM ENDS. 
C    USING MAX. INDICES ALLOCATE NECESSARY STORAGE FOR TRIG TABLES
C    AND BLOCKS. DO OTHER INITIALIZATION TASKS AND CALL FOO.
C    FOO CALCULATES AND PRINTS THE MAP.
      INTEGER AD1,AD5,AD6,AD7,AD9,AD11,BLKL,HKL(3),MAX(4),
     + TRGSZ,RSIZ,GETSIZ,TBL,ARADD,ARAD3,LIB$GET,LIB$FREE,HMAX(3),
     + SECNUM,AD2,AD3,AD4,AD8,AD10,AD12,SZE,ADP
       CHARACTER*4 FTB(10),NEXT
       CHARACTER*1 SDH(3),SDV(3)
      COMMON /INIT/ACODE,BCODE,SPG,SPGL,MGO,SYMGO,PAR,GPAR,CEN,LAUE,ACN,
     + FZ,VSCALE,CUT,GD,GEN,NGEN,NOAS,SGA,SGR,GP,PRJ,SCT,TRD,TSC,TS,MNP,
     + HR2,HR1,RX1,RX2,RX3,INCHES,PV,PH,INCHOR,INCHV,HM(6),LB,LR,LS,TWT,
     + LRJCT,SCRD,DHORIZ,DVERTI,CELLIN,NAMEX,OP12,OP8,OPSCR,SCR,lf
c                    lf signal for fmin added 19-oat-1989
C  INIT
      BYTE MGO,SYMGO,CEN,ACN,FZ,CUT,GD,GEN,NGEN,NOAS,SGA(4),SGR(4),GP,
     + PRJ,SCT,TRD,TSC,TS,MNP,LB(3),LR,LS,TWT,LRJCT,SCRD,SQG,CELLIN,
     + OP12,OP8,OPSCR,FTS,lf              ! lf added 19-oct-1989
      INTEGER*2 ACODE(8,8),BCODE(8,8),SPG,PAR,GPAR,LAUE,HR2,HR1,RX1,
     + RX2,RX3,RRX1,RRX2,RRX3,SPG2
      INTEGER*2 H,K,L
      CHARACTER*1 SPGL,SPGL2
      CHARACTER*12 NAMEX,NMEX    
      COMMON/STOR/AD1,AD5,AD6,AD7,AD9,AD11,
     + BLKL,TRGSZ,NDUM1,NDUM2,ADC,GETSIZ,TBL
      CHARACTER*9 NAMDES
      CHARACTER*16 NFILE
	COMMON IS1,IS2,IS3,IS4,IS5,IS6,SCF,B2,CARD,JPAGE,IT1,IT2
       CHARACTER*80 CARD,CRDSAV
      INTEGER SCR,CENA,CENB,CENC,CENI,CENF,CENR
      COMMON /MAP/VAL1,FST2,VAL2,FST3,VAL3,DEL1V,DEL2V,DEL3V,DEL2H,
     +DEL3H,NUMCOL,NUMROW,NUMSEC,ADFJC,NMCP,NMRP
      DIMENSION SS(6),KIND(12),NKND(12)
      COMMON /STCAL/CELL,COSALF,VSTAR,ASUB,NOMAPS 
       COMMON /NUMBER/IB,IER,IL,IE,ND,BL,PT,CM,RNUM
      BYTE IER,ND
      INTEGER*2 IB,IE,IL
      CHARACTER*1 BL,PT,CM
      COMMON/CALC/SHRPB,SHPR,SHPA,SHPE,SHPC,SHPD,TWOB,CUTA,CUTB,CUTC,
     +FSCALE,PSCALE,PRTOP,XFRACT,DL1V,LOWX,HIGHX,CENX,DIRX,ORIENT,CUTOFF 
     +,SS,SB1,SB2,SB3,SB4,FPK,FPLT,MSC,SGSV
C CALC
      REAL LOWX(3),HIGHX(3),LOWX1,LOWX2,LOWX3,LX(3),HX(3)
      DIMENSION XFRACT(3),CENX(3),DIRX(3)
      INTEGER PRTOP
      INTEGER*2 ORIENT(2),SGSV
      BYTE SHRPB,CUTOFF,SB1,SB2,SB3,SB4,fpk,fplt,MSC
      COMMON /INDX/ H,K,L
      COMMON /PLTCOM/RAB,RAD,RAE,
     +NMEX,CLL,SPG2,SPGL2,ITYP,RRX1,RRX2,RRX3,LX,HX,D1V,
     +DL2V,DL3V,DL1H,DL2H,DL3H,NSEC,NR,NC,NUMROB,NUMCOB,
     +OSDV,OSDH,SP,MXPEAK,SMHPK,DMPK,LPKST,LSTO,SCLP
      COMMON/FNAME/NFILE,NAMLEN
      integer ADDAR,SIZ,SIZ2,SIZ3,ADPH,ADPV
      DIMENSION DELH(3),DELV(3),VAL(3),DH(3),DV(3)
      PARAMETER (SMALL=.0001)     ! USED FOR GEN PLANE
      PARAMETER (MAXCLS=156)       ! PROGRAM ONLY CALCULATES 156
       PARAMETER (RADS=0.0174533)      ! DEGREES TO RADS
       DIMENSION Q(12)
      DIMENSION CELL(6),SPACE(11),KNF(12),COSALF(5),CLL(6)
      BYTE ASUB
      LOGICAL OD            ! SIGNAL THAT IT1 IS OPEN OR NOT
      EQUIVALENCE (MAX1,MAX(1)),(MAX2,MAX(2)),
     + (MAX3,MAX(3))
       EQUIVALENCE (HMAX(1),HM(1)),(RHOMAX,HM(5)),
     + (FMIN,HM(4)),(SIGMAX,HM(6))
          INTEGER*2 PLSET
       REAL*8 PSA,QSA,DV1,DV2,VI,V2,V3,S1,S2,S3,DEL,DARG
       REAL*4 INCHOR,INCHV,INCHES
      REAL*4 NMHPK,NDPK         ! NEG. PEAK HEIGHT AND DISTANCE
        CHARACTER*1 XYZT(3)
       CHARACTER*1 ABCT(3)
        CHARACTER*5 HOLHKO(3)
      DATA HOLHKO/'O K L','H O L','H K O'/
      DATA XYZT/'X','Y','Z'/
       DATA ABCT/'A','B','C'/
       DATA FTB/'FOUR','PATT','DIFF','END ','PEAK','CONT',
     + 'GENE','PROJ','SECT','THRE'/
       CHARACTER*10 MPS(2)
       DATA MPS/'   MAP HAS',' MAPS HAVE'/
       DIMENSION SP(3)
      COMMON /Q/ARG,VALU,R1024,COR
      COMMON /CSSN/SC,C
      DIMENSION SC(1024),C(1024),
     +          SCTB(2050)
       EQUIVALENCE (SC(1),SCTB(1)),
     +             (C(1),SCTB(1025))
      INTEGER ARG,ADC,ADS
       ASSIGN 47 TO PLSET
C     WRITE(3,909)OP12
C909    FORMAT('  IN SETCAL OP12=',I3)
      CALL TBFIL          ! FILL TABLES FOR COS AND SIN
      DO I=1,4
      MAX(I)=0
      ENDDO              ! INITIALIZE MAX INDICES
C PH,PV ARE POINTS PER INCH HORIZONTAL AND VERTICAL
C INCHES IS INCHES PER ANGSTROM
      INCHOR=PH*INCHES    ! HORIZONTAL SCALE PH POINTS / INCH
      INCHV=PV*INCHES    ! VERTICAL SCALE PV POINTS / INCH
C     WRITE(50,9830)GP,PRJ,SCT,TRD,TSC
C9830  FORMAT('  GP=',I2,' PRJ=',I2,'SCT=',I2,'TRD=',I2,' TSC=',I2)
      IF(GP.EQ.0)THEN
C     WRITE(3,9000)ORIENT
C9000  FORMAT('  ORIENT(1)=',I2,'  ORIENT(2)=',I2,/, 
C     +'   RX1=ORIENT(1) AND RX2=ORIENT(2)')
      RX1=ORIENT(1)
      RX2=ORIENT(2)
      IF(RX1.EQ.RX2)THEN
       WRITE(3,1)         ! ERROR IN ORIENTATION INPUT
1      FORMAT(' INPUT ERROR FOR ORIENTATION. THE FIRST AND',
     +' SECOND DIMENSION ARE THE SAME.')
       IER=99            ! FATAL ERROR ON INPUT
       RETURN
      ELSE
        IF(RX1+RX2.EQ.4)RX3=2
        IF(RX1+RX2.EQ.5)RX3=1
        IF(RX1+RX2.EQ.3)RX3=3
      ENDIF
      ELSE IF(GP.EQ.9)THEN
      ITYP=1                 ! FOR FPEAK
          RX1=ORIENT(2)        ! X,Y OR Z CON HORIZ. 1ST DIM HAS DELH=0
       RX2=RX1+1        !                            
       IF(RX2.GT.3)RX2=1   
       if(rx2+rx1.eq.5)rx3=1
      IF(RX1+RX2.EQ.4)RX3=2
      IF(RX1+RX2.EQ.3)RX3=3
      ENDIF
C     WRITE(3,900)RX1,RX2,RX3
C900   FORMAT('  IN SETCAL RX1=',I3,'  RX2=',I3,'  RX3=',I3)
      CALL RKFINT             ! CODES SET IN SUBROUTINE PASSED IN COMMON
C       COME HERE AFTER READING MAPSTARTING RECORD AND      
C           READ IN IST 3 RECORDS OF HKL DATA DISK
C       UP TO BUT NOT INCLUDING THE HKL DATA
       INQUIRE (UNIT=IT1,OPENED=OD)
       IF(OD)THEN
        OP8=9
        WRITE(3,1000)IT1
1000    FORMAT('   UNIT ',I1,' IS ALREADY OPEN')
      ENDIF
      IF(OP8.EQ.0)OPEN (UNIT=IT1,TYPE='OLD',BUFFERCOUNT=2,
     1BLOCKSIZE=32768,FORM='UNFORMATTED')
       OP8=9
      IF(OPSCR.EQ.0)THEN
      N=NAMLEN+1
      NFILE(N:N+3)='.SCR'
       OPEN (UNIT=SCR,NAME=NFILE,TYPE='SCRATCH',BUFFERCOUNT=2,
     1BLOCKSIZE=3600,RECL=36,FORM='UNFORMATTED')
       OPSCR=9
      ENDIF
      IF(CELLIN.EQ.0)THEN
      READ(IT1)SPACE,CELL
        DO I=1,3
        J=I+3                 ! ANGLES
        COSALF(I)=COS(CELL(J)*RADS)
      ENDDO
        COSALF(4)=COSALF(1)    ! COSA,COSB,COSG,COSA,COSB
        COSALF(5)=COSALF(2)
       CELLIN=9
      WRITE(3,903)CELL
903    FORMAT('0 CELL PARAMETERS FROM HKL DISK ',6F10.5)
      ELSE
      READ(IT1)SPACE     ! READ PAST FIRST RECORD BUT DONT USE CELL
      ENDIF
      IF(FSCALE.EQ.0.0)THEN    ! DEFAULT FOR FOBS SCALE 
      FSCALE=SPACE(1)
      WRITE(3,2)FSCALE
2      FORMAT('0 SCALE FOR FOBS HAS BEEN READ FROM THE HKL FILE',/,
     + '           SCALE IS  ',F11.6)
      ENDIF
      IF(CELLIN.EQ.1)THEN          ! CELL READ FROM INPUT NOT DISK
      READ(IT1)KNF                 ! AND SS HAS BEEN CALC FROM CELL
      ELSE
      READ(IT1)KNF,SS        ! SS(1) CORRESPONDS TP SPACE (13) IN CRYM
      SV=SS(5)
      SS(5)=SS(6)
      SS(6)=SV         ! ORDER IS SKL,SHK,SHL FOR REEKE
      ENDIF
C              CALCULATE V*
      SIN2ALF=1.0-COSALF(1)*COSALF(1)    ! FOR COSINE ALPHA
      TMP=SQRT(SS(1)/SIN2ALF)
      VSTAR=(TMP+TMP)/(CELL(2)*CELL(3))
      FVSCALE=(VSTAR*VSCALE)/PSCALE
C     WRITE(3,90)FVSCALE,VSCALE,VSTAR,PSCALE
C90    FORMAT('  FVSCALE=',F10.5,' VSCALE=',F10.5,' VSTAR=',F12.6,
C    +'  PSCALE=',F12.6)
        VSCALE=FVSCALE
      READ(IT1)   ! POSITION HKL DATA DISK TO FIRST REFLECTION RECORD
3      READ(IT1)HKL,F,W,PIH,PIK,PIL,SSQLS,(Q(I),I=1,12),ASP,BSP,
     + SP1,SP2,SP3,SP4,E,SHARP,ACAL,BCAL
       RHO=SSQLS                ! PROGRAM USES BOTH NAMES
      IF(HKL(1).EQ.999999)THEN   ! REFLECTIONS ALL READ IN
      WRITE(SCR)HKL,K1,K2,K3,AOBS,BOBS,IPAR          ! END MARK
      REWIND SCR                ! POSITION FOR READ IN FOO
      REWIND IT1                 ! POSITION FOR A SECOND MAP
      GO TO 30
      ENDIF
      IF(LR.NE.0)THEN
      IF(RHO.GT.RHOMAX)THEN     ! SKIP IT
C     WRITE(3,1400)HKL,F,W
1400    FORMAT(' REFLECTION ',3I4,F8.3,F8.5,' HAS BEEN REJECTED')
      GO TO 3
      ENDIF
      ENDIF
      IF(LF.NE.0)THEN
      IF(F.LT.FMIN)THEN
      WRITE(3,1400)HKL,F,W
      GO TO 3
      ENDIF
         ENDIF
      IF(LS.NE.0)THEN
      SIG=1.0/(W*2.*F)
      IF(SIG.GT.SIGMAX)THEN
      WRITE(3,1400)HKL,F,W
      GO TO 3
      ENDIF
      ENDIF
      H=HKL(1)
      K=HKL(2)
      L=HKL(3)
      AC=ACAL
      BC=BCAL
       TFOBS=FSCALE*F    ! DEFAULT FOR FSCALE IS 1.0
C                     PHASING COMES HERE
      IF(IS1.EQ.1)THEN           ! PATTERSON HERE
      IF(TF0BS.LT.0)TFOBS=TFOBS*0.5    ! LESS THANS
      IF(SHRPB.EQ.9)THEN           ! SHARPENED PATTERSON
C     WRITE(3,91)SHARP
C91    FORMAT('  IN SETCAL SHARP FROM TAPE =',F10.6)
       AOBS=SHARP-SHPR        ! SHPR=REMOVE, NUMBER BETWEEN 0.0 AND 1.0
       ELSE
      AOBS=TFOBS*TFOBS
      ENDIF
      BOBS=0.0
      ENDIF                        ! END PATTERSOM
      IF(IS1.EQ.0)THEN       ! THIS IS A FOURIER
      IF(W.LT.0)THEN     ! SKIP REFLECTION
      WRITE(3,1400)HKL,F,W
      GO TO 3
      ENDIF
      FCAL=SQRT(AC*AC+BC*BC)
      IF(FCAL.LT.0.01)THEN
      WRITE(3,1400)HKL,F,W
      GO TO 3
      ENDIF
      IF(CUTOFF.EQ.9)THEN      ! USE CUTOFF FUNCTION
       TEM=CUTA+CUTB*TFOBS+CUTC*RHO    !    BE SURE TO SET RHO
      IF(FCAL.LT.TEM)THEN        ! SKIP IT
       WRITE(3,1400)HKL,F,W
      GO TO 3
      ENDIF
      ENDIF
      TEM=TFOBS/FCAL
      AOBS=AC*TEM          !  PHASED A
C     WRITE(3,900)HKL,AC,TFOBS,FCAL,TEM,AOBS
C900    FORMAT('  FOR HKL=',3I4,' ACAL=',F12.6,' TEM=',F12.6,'/',F12.6,
C    +'=',F12.6,' AOBS=',F12.6)
      IF(ACN.EQ.0)THEN
      BOBS=BC*TEM
      ELSE
      BOBS=0.0
      ENDIF
      ENDIF                         ! END FOURIER
      IF(IS1.EQ.2)THEN          ! DIFFERENCE FOURIER
      IF(W.LT.0)THEN            ! SKIP IT
      WRITE(3,1400)HKL,F,W
      GO TO 3
      ENDIF
      FCAL=SQRT(AC*AC+BC*BC)
      IF(W.LT.0)THEN
      IF(FCAL.LT.TFOBS)THEN      ! SKIP IT
      WRITE(3,1400)HKL,F,W
      GO TO 3
      ENDIF
      ENDIF
      IF(TFOBS.LT.0.0)TFOBS=0.0
C                 TFOBS=FSCALE*F
      IF(FCAL.LT.0.01)THEN
      WRITE(3,1400)HKL,F,W
      GO TO 3
      ENDIF
      TEM=TFOBS/FCAL
      IF(ASUB.NE.0)THEN
      AP=AC-ASP
      BP=BC-BSP
      ELSE
      AP=AC
      BP=BC
       ENDIF
      AOBS=AC*TEM-AP
      IF(ACN.EQ.0)THEN
      BOBS=BC*TEM-BP
      ELSE
      BOBS=0.0
      ENDIF
      IF(CUTOFF.EQ.9)THEN      ! USE CUTOFF FUNCTION
       TEM=CUTA+CUTB*TFOBS+CUTC*RHO    !    BE SURE TO SET RHO
      IF(FCAL.LT.TEM)THEN        ! SKIP IT
       WRITE(3,1400)HKL,F,W                     
      GO TO 3
      ENDIF
      ENDIF
      ENDIF                     ! END DIFFERENCE
C      OR=1,2,3,4,5,6   FOR  HKL,HLK,KLH,LHK,LKH
C
C202    FORMAT('   MGO=',I3)
       IF(MGO.EQ.1)THEN
       VSC=P1(H,K,L,VSCALE)
      ELSE IF(MGO.EQ.2)THEN
       VSC=P2M(H,K,L,VSCALE)
      ELSE IF(MGO.EQ.3)THEN
       VSC=P3M(H,K,L,VSCALE)
      ELSE IF(MGO.EQ.4)THEN
       VSC=P4M(H,K,L,VSCALE)
      ENDIF
      K1=IABS(HKL(RX1))+1       ! HERE FOR ALL REFLECTIONS ACCEPTED
      K2=IABS(HKL(RX2))+1   ! K1,K2,K3 ARE 1ST, 2ND 3RD DIM. INDICES
      K3=IABS(HKL(RX3))+1   ! RX1,2,3= 1,2,OR 3 DEPENDING ON ORIENTATION
C     WRITE(3,92)HKL,AOBS,VSC
C92    FORMAT('  HKL=',3I4,'  AOBS=',F12.3,'  VSC=',F8.3)
      AOBS=AOBS*VSC
      BOBS=BOBS*VSC
      IPAR=0           ! INITIALIZE PARITY TO 0
      IF(PAR.EQ.0)GO TO 100    ! SKIP ALL THIS 
       IF (PAR.EQ.1)THEN
      IPAR=PAR1(H)
      ELSE IF(PAR.EQ.2)THEN
      IPAR= PAR2(K)
      ELSE IF(PAR.EQ.3)THEN
      IPAR= PAR3(L)
      ELSE IF(PAR.EQ.4)THEN
      IPAR= PAR4(H,K)
      ELSE IF(PAR.EQ.5)THEN
      IPAR= PAR5(K,L)
      ELSE IF(PAR.EQ.6)THEN
      IPAR= PAR6(H,L)
      ELSE IF(PAR.EQ.7)THEN
      IPAR= PAR7(H,K,L)
      ELSE IF(PAR.EQ.8)THEN
      IPAR= PAR8(H,K,L)
      ELSE IF(PAR.EQ.9)THEN
      IPAR= PAR9(H,K,L)
      ELSE IF(PAR.EQ.10)THEN
      IPAR= PAR10(H,K)
      ELSE IF (PAR.EQ.11)THEN
      IPAR= PAR11(H,L)
      ELSE IF (PAR.EQ.12)THEN
      IPAR= PAR12(K,L)
      ELSE IF (PAR.EQ.13)THEN
      IPAR= PAR13(H,K,L)
      ELSE IF(PAR.EQ.14)THEN
      IPAR= PAR14(H,K,L)
      ELSE IF (PAR.EQ.15)THEN
      IPAR= PAR15(H,K,L)
      ELSE IF (PAR.EQ.16)THEN
      IPAR= PAR16(H,K,L)
      ELSE IF (PAR.EQ.17)THEN
      IPAR= PAR17(H,K,L)
      ELSE IF (PAR.EQ.18)THEN
      IPAR= PAR18(H,K,L)
      ELSE IF (PAR.EQ.19)THEN
      IPAR= PAR19(H,K,L)
      ELSE IF (PAR.EQ.20)THEN
      IPAR= PAR20(K,L)
      ELSE IF (PAR.EQ.21)THEN
      IPAR= PAR21(H,L)
      ELSE IF (PAR.EQ.22)THEN
      IPAR= PAR22(L)
      ELSE IF (PAR.EQ.23)THEN
      IPAR= PAR23(H,K,L)
      ELSE IF (PAR.EQ.24)THEN
      IPAR= PAR24(L)
      ELSE IF(PAR.EQ.25)THEN
      IPAR=PAR25(L)
      ENDIF
C      OR=1,2,3,4,5,6   FOR  HKL,HLK,KLH,LHK,LKH
C     WRITE(3,200)NOAS,SYMGO,CEN
C200    FORMAT('   NOAS=',I3,'   SYMGO=',I4,'   CEN=',I4)
100    IF (NOAS.EQ.0)THEN
      if(symgo.eq.0)go to 14    ! no test
      GO TO (4,5,6,7,8,9,10,11,12),SYMGO
4      CALL SYMA(*13,*14)        ! RETURN 1 TO OMIT
5      CALL SYMB(*13,*14)        ! RETURN 2 TO KEEP
6      CALL SYMC(*13,*14)
7      CALL SYMD(*13,*14)
8      CALL SYME(*13,*14)
9      CALL SYMF(*13,*14)
10      CALL SYMG(*13,*14)
11      CALL SYMH(*13,*14)
12      CALL SYMI(*13,*14)
      ENDIF
14     IF(CEN.EQ.0)GO TO 15
       IF(CEN.EQ.1)THEN
       ICN=CENA(H,K,L)
      ELSE IF(CEN.EQ.2)THEN
       ICN=CENB(H,K,L)
      ELSE IF(CEN.EQ.3)THEN
       ICN=CENC(H,K,L)
      ELSE IF(CEN.EQ.4)THEN
       ICN=CENI(H,K,L)
      ELSE IF(CEN.EQ.5)THEN
       ICN=CENF(H,K,L)
      ELSE IF(CEN.EQ.6)THEN
       ICN=CENR(H,K,L)
      ENDIF
      IF(ICN.EQ.0)GO TO 15
13    IF(LRJCT.NE.0)WRITE(3,140)H,K,L  !HERE FOR ALL REFL. REJECTED
140     FORMAT(' REFLECTION ',3I4,' HAS BEEN REJECTED BY SYMMETRY'
     + ' OR CENTERING TEST')
        GO TO 3        ! SKIP THIS AND READ ANOTHER
15    DO I=1,3
      IND=IABS(HKL(I))     ! GET ABS VALUE FOR COMPARISON
      IF(HMAX(I).GT.-99)THEN  ! INDEX MAX ENTERED ON LIMITS INPUT
      IF(IND.GT.HMAX(I))THEN      ! OMIT THIS REFLECTION
      IF(LRJCT.NE.0)WRITE(3,1400)HKL,F,W
      GO TO 3
      ENDIF
      ENDIF
      IF(IND.GT.MAX(I))MAX(I)=IND    ! GET MAXIMUM INDICES
      ENDDO
      IF(LAUE.GT.7)THEN
      IK=IABS(HKL(1)+HKL(2))
      IF(IK.GT.MAX(4))MAX(4)=IK
      ENDIF
      WRITE(SCR)HKL,K1,K2,K3,AOBS,BOBS,IPAR    ! WRITE ACCEPTED REF.
C     WRITE(3,201)HKL,AOBS,BOBS
201    FORMAT('  ACCEPTED REFL. ',3I6,2X,F9.4,2X,F9.4)
      GO TO 3             ! GO READ IN ANOTHER REFLECTION
30     IF(MODEL.NE.1)THEN       ! IS THIS MODEL OPTION
       IF(PATTER.NE.0)GO TO 31   ! OMIT REFERENCES TO PHASES FOR PATTERSON
C      TEST IF PHASE SET IS ON DATA TAPE
C      COMPARE NPHAS WITH NCALC
C        TEST IF DIFFERENCE MAP
       ENDIF
31        IF(CELLIN.EQ.0)THEN
       WRITE(3,32)
32      FORMAT('0 CELL INFORMATION IS MISSING')
       IER=9
       RETURN
       ENDIF
       DO I=1,3
       IF(HMAX(I).EQ.-99)HMAX(I)=MAX(I)
       ENDDO
      IF (LAUE.GT.7)THEN        ! USE IK AS WELL
      DO I=1,2
      IF (MAX(4).GT.HMAX(I))HMAX(I)=MAX(4)
      ENDDO
      ENDIF
C33    FORMAT('0 STORAGE IS PROVIDED FOR INDICES UP TO ',3I6)
C          OBTAIN STORAGE FOR SUMMATION ARRAYS
      IF(HMAX(1).GT.HMAX(2))THEN     ! PUT LARGEST OF
      HR2=HMAX(1)                    ! HMAX IN HR2 AND
      HR1=HMAX(2)                    ! NEXT LARGEST IN HR1
      ELSE
      HR2=HMAX(2)
      HR1=HMAX(1)
      ENDIF
      IF(HMAX(3).GT.HR2)THEN
      HR1=HR2
      HR2=HMAX(3)
      ELSE IF(HMAX(3).GT.HR1)THEN
      HR1=HMAX(3)
      ENDIF
      HR2=HR2+1          ! ALLOW FOR ZERO INDEX
      HR1=HR1+1
      IF(SPG.GT.74)THEN
      MAX1=HR2+1
      MAX2=MAX1
      MAX3=MAX1     ! INDICES CYCLE NEED THIS FOR SAFETY
      ELSE
      MAX1=HMAX(RX1)+1    ! ALLOW FOR ZERO INDEX
      MAX2=HMAX(RX2)+1
      MAX3=HMAX(RX3)+1
      ENDIF
C      WRITE(3,33)MAX1,MAX2,MAX3
      BLKL=MAX2*MAX3*4  ! BLKN(MAX2,MAX3)  IN BYTES
      TRGSZ=HR2*4          ! SIZE OF TRIG TABLE LARGEST POSSIBLE
      RSIZ=(MAX3)*4       ! SIZE OF 3RD DIM ROW
      GETSIZ=4*BLKL       ! NEED 4 ARRAYS
      TSIZ=TRGSZ*2*3    ! MAX INDEX FOR COS AND SIN IN BYTES FOR 3TBLS
      TSIZ=TSIZ+RSIZ*2  ! STORAGE FOR ROW3 COS AND SIN
      GETSIZ=GETSIZ+TSIZ
      IRET=LIB$GET_VM(GETSIZ,ARADD)
      IF(IRET.NE.1)THEN
      WRITE(3,34)
34     FORMAT('0 NOT ENOUGH VIRTUAL MEMORY FOR BLOCK ARRAYS')
      IER=9
      RETURN
      ENDIF
      AD1=ARADD      ! GET ADDRESS
      AD2=AD1+BLKL       ! BLK1   BLK2
      AD3=AD2+BLKL       ! BLK3
      AD4=AD3+BLKL        ! BLK4
      AD5=AD4+BLKL        ! ROW3C  FOR COS TERMS
      AD6=AD5+RSIZ     ! ROW3S  FOR SIN TERMS
      AD7=AD6+RSIZ       ! COST1
      AD8=AD7+TRGSZ       ! SINT1
      AD9=AD8+TRGSZ       ! COST2
      AD10=AD9+TRGSZ       ! SINT2
      AD11=AD10+TRGSZ      !COST3
      AD12=AD11+TRGSZ    ! SINT3
C       LATER CALL FOURIER(AD1,AD2,AD3,AD4,..           AD12)
C       ADDRESSES OF BLK1,BLK2,BLK3,BLK4,ETC
      ADFJC=1.0      ! 1.0 WILL BE REPLACED BY PROJECTION SCALE
      IF(GP.NE.0)GO TO PLSET   ! GENERAL PLANE
      IF(TSC.EQ.9)DEL1V=DL1V        ! THIS IS TRUE SCALE
      SINA1=SQRT(1-COSALF(RX1)*COSALF(RX1))
      IF(TSC.EQ.0)THEN   ! FRACTIONAL SCALE HERE
      DEL1V=XFRACT(RX1)         ! SECTION INCREMENT
      DEL2V=XFRACT(RX2)         ! VERTICAL INCREMENT
      DEL3H=XFRACT(RX3)         ! HORIZONTAL INCREMENT
      DEL3V=0
      ELSE                 ! TRUE SCALE HERE
       DEL3H=(1.0/(INCHOR*CELL(RX3)))   ! HORIZ. INCREMENT
       DEL2V=SINA1*CELL(RX2)
C     write(50,9824)del2v,sina1,cell(rx2)
C9824  format('  del2v=sina1*cell(rx2)=',f8.5,'=',f8.5,'*',f8.5)
       DEL2V=(1.0/(INCHV*DEL2V))    ! ADJUST VERT. SCALE FOR SLANT
C  INCHV=INCHES/ANGSTROM*POINTS VERTICAL PER INCH
       DEL3V=-COSALF(RX1)/(SINA1*CELL(RX3)*inchv)  ! ROW OFFSETsep 89
        ENDIF
         CNT=0   ! FOR PROJECTION ONE SET OF HIGH BOUNDS MAY EQUAL
          DO I=1,3                 ! LOW BOUNDS
          IF(LOWX(I).EQ.HIGHX(I))THEN
          IF(PRJ.EQ.9.OR.SCT.EQ.9)THEN
           CNT=CNT+1
        ELSE
          WRITE(3,35)
35      FORMAT(' ERROR ON INPUT FOR THE BOUNDS')
            IER=99
           RETURN
          ENDIF
          ENDIF
          ENDDO
          IF(CNT.GT.1)THEN
          WRITE(3,35)
           IER=99
            RETURN
            ENDIF
C      CALCULATE NUMBER OF ROWS AND COLUMNS
      LOWX2=LOWX(RX2)
      LOWX(RX2)=LOWX(RX2)-DEL2V
      HIX2=HIGHX(RX2)     
      HIGHX(RX2)=HIGHX(RX2)+DEL2V
      LOWX3=LOWX(RX3)
      LOWX(RX3)=LOWX(RX3)-DEL3H
      HIX3=HIGHX(RX3)
      HIGHX(RX3)=HIGHX(RX3)+DEL3H
        NUMROB=(-LOWX(RX2)/DEL2V)+0.5
        NUMROA=( HIGHX(RX2)/DEL2V)+0.5
        NUMROW=NUMROB+NUMROA+1
        NUMCOB=-LOWX(RX3)/DEL3H+0.5
        NUMCOA=HIGHX(RX3)/DEL3H+0.5
C        TEST FOR ROW ADDITIONAL OFFSET
        IF(DEL3V.NE.0)THEN   ! ADDITIONAL ROW OFFSET
         V3=DEL3V
      IF(V3.LT.0)V3=-V3
      OB=NUMROB*V3/DEL3H
      OA=NUMROA*V3/DEL3H
C     WRITE(50,9833)OB,OA
C9833  FORMAT('  OFFSETS OB=',F12.6,'  OA=',F12.6)
      IF(DEL3V.GT.0)THEN
      NUMCOB=NUMCOB+OA
      NUMCOA=NUMCOA+OB
      ELSE
      NUMCOB=NUMCOB+OB
      NUMCOA=NUMCOA+OA
      ENDIF
      ENDIF
      NUMCOL=NUMCOB+NUMCOA+1     ! TOTAL NUMBER OF COLUMNS
      IF(NUMROB.LT.0)NUMROW=NUMROW-1
      IF(NUMCOB.LT.0)NUMCOL=NUMCOL-1  ! NO 0 COL IN MAP
      IF(NUMROB.LT.0)NUMROB=NUMROB-1
      IF(NUMCOB.LT.0)NUMCOB=NUMCOB-1
      FST2=-NUMROB*DEL2V
      FST3=-NUMROB*DEL3V-NUMCOB*DEL3H
C   PRINT SECTION OR PROJECTION INFORMATION
       WRITE(3,36)XYZT(RX2),XYZT(RX3),DEL3H
       WRITE(3,37)XYZT(RX2),DEL2V,XYZT(RX3),DEL3V
       WRITE(3,38)XYZT(RX2),XYZT(RX3),NUMCOB,NUMROB
36      FORMAT('0',A1,' IS CONSTANT,  ',A1,' INCREASES BY ',F7.4,
     + ' BETWEEN POINTS IN THE HORIZONTAL DIRECTION.')
37     FORMAT('0',A1,' INCREASES BY ',F7.4,1X,A1,' INCREASES BY',
     + F7.4,' BETWEEN POINTS IN THE VERTICAL DIRECTION.')
38     FORMAT('0',A1,' = 0 AND ',A1,' = 0 FOR POINT',
     + I4,' ON ROW ',I4)
C       DETERMINE WHETHER 3RD DIM TRIG TABLES CAN BE STORED
            IF(DEL3V.EQ.0)THEN      ! NO ROW OFFSET
           TBL=MAX3*NUMCOL*4      ! LENGTH OF TABLE IN BYTES
           ADS=TBL               ! OFFSET FOR SIN TABLE
           TBL=TBL*2            ! BOTH COS AND SIN
       IRET=LIB$GET_VM(TBL,ARAD3)
C         GET STORAGE FOR TABLE
      IF(IRET.NE.1)THEN
      WRITE(3,39)
39    FORMAT('0 NOT ENOUGH VIRTUAL MEMORY FOR BLOCK ARRAYS')
40    FORMAT('1 ERROR IN FREEING ALLOCATED VIRTUAL MEMORY')
41     IER=9
      RETURN
      ENDIF
      ADC=ARAD3
      ADS=ADC+ADS
      ENDIF
C
C  IF THIS IS SECTION OR PROJECTION THEN:
C     WRITE(50,9831)TRD
C9831  FORMAT('  TRD=',I2)
       IF(TRD.EQ.0)THEN      ! THIS IS NOT 3-DIM
      NUMSEC=3           ! ADD FOR FPEAK CALCULATIONS
      SECNUM=1
       WRITE(3,42)XYZT(RX2),LOWX2,HIX2,XYZT(RX3),
     + LOWX3,HIX3
42    FORMAT('0MAP GIVES THE PART OF THE CELL FROM 'A1,
     +' = ',F6.3,' TO ',F6.3,' , ', A1,' = ',F6.3,' TO ',F6.3)
C  IF THIS IS PROJECTION THEN:
      IF(PRJ.EQ.9)THEN
      ITYP=2            ! FPEAK WANTS THIS
        ADFJC=1.0/(VSTAR*SINA1*CELL(RX2)*CELL(RX3)) ! PROJECTION SCALE
C       ADFJC=ADFJC/(2**22)
        WRITE(3,990)ADFJC
990     FORMAT('0 SCALE FOR PROJECTION IS ',F12.6)
        write(3,43)HOLHKO(RX1),NAMEX
43     FORMAT('1',13X,'PROJECTION 'A5,13X,A)
      NUMSEC=1
      ENDIF
      IF(SCT.EQ.9)THEN     ! SECTION HERE
      ITYP=3            ! FPEAK WANTS THIS
      VAL1=LOWX(RX1)
      WRITE(3,44)SECNUM,XYZT(RX1),VAL1,NAMEX  ! DO THIS HERE FOR SECTION
44     FORMAT('1     SECTION  ',I3,8X,A1,' = ',F6.4,8X,A)
      SECNUM=0          ! JUST AS IN 3-DIM
        ENDIF
      IF(DEL1V.EQ.0)THEN
      DEL1V=(1.0/INCHOR*CELL(RX1))+0.5      ! round up
C     WRITE(3,9898)DEL1V
      ENDIF
      LOWX1=LOWX(RX1)              ! SAVE IT
      LOWX(RX1)=LOWX(RX1)-DEL1V
      VAL1=LOWX(RX1)
C       NEED TO SET HIGHX(RX1) AND MAKE SURE OF A REASONABLE DEL1V
       HIX1=HIGHX(RX1)          ! SAVE IT
      HIGHX(RX1)=HIGHX(RX1)+DEL1V
      go to 50
      ENDIF
      IF (TRD.NE.0)THEN     ! THIS IS 3-DIM
      ITYP=3          ! FPEAK WANTS THIS
      IF(DEL1V.EQ.0)THEN
      DEL1V=(1.0/INCHOR*CELL(RX1))+0.5      ! round up
C     WRITE(3,9898)DEL1V
9898  FORMAT('  IN SETCAL DEL1V CALCULATED AS',F8.5)
      ENDIF
      LOWX1=LOWX(RX1)
      LOWX(RX1)=LOWX(RX1)-DEL1V

      IF(TSC.EQ.9)THEN           ! THIS IS TRUE SCALE
      INCHV=DEL1V*CELL(RX1)*INCHES
      OSDH=COSALF(RX2)*INCHV    ! HORIZONTAL OFFSET = COS*INCHES VERT.
      OSDV=INCHV*COSALF(RX3)-COSALF(RX1)*COSALF(RX2) /SINA1
      WRITE(3,45)ABCT(RX1),OSDV,OSDH
      ENDIF
      VAL1=LOWX(RX1)
      HIX1=HIGHX(RX1)       ! SAVE INPUT VALUE
      HIGHX(RX1)=HIGHX(RX1)+DEL1V
      NUMSEC=((HIGHX(RX1)-LOWX(RX1))/DEL1V)+1.01    ! never trust reals
c     WRITE(3,401)HIGHX(RX1),LOWX(RX1),DEL1V,NUMSEC
c401    FORMAT(' HIGHX=',F6.4,' LOWX=',F6.4,' DEL1V=',F6.4,
cc     +' NUMSEC=',I4)
      NSCM=NUMSEC-2
      NRM=NUMROW-2
      NCM=NUMCOL-2
      WRITE(3,400)NSCM,NCM,NRM
400   FORMAT('  NUMBER OF SECTIONS TO BE CALCULATED =',I4,/,
     +'  NUMBER OF COLUMNS IS ',I3,'  NUMBER OF ROWS IS ',I3)
45    FORMAT('0THE ',A1,' AXIS IS DISPLACED ',F5.1,
     +' INCHES HORIZONTALLY, AND ',
     +F5.1,' INCHES VERTICALLY FOR EACH SUCCESSIVE SECTION.')
      WRITE(3,46)xyzt(rx1),LOWX1,HIX1,xyzt(rx2),LOWX2,HIX2,xyzt(rx3),
     +lowx3,hix3
46    FORMAT('0MAP GIVES THE PART OF THE CELL FROM  ',A1,'= ',F6.3,
     +' TO ',F6.3,' , ',A1,'= ',F6.3,' TO ',F6.3,' , ',A1,'= ',F6.3,
     +' TO ',F6.3)
      ENDIF
C     WRITE(3,44)SECNUM,XYZT(RX1),VAL1      ! DO THIS IN FOO FOR 3-DIM
               GO TO 50
C   PLSET IS HERE
47    DV1=COSALF(RX3)*DIRX(RX3)
      DV2=COSALF(RX2)*DIRX(RX2)
      V1=DV1-DV2
      V2=DIRX(RX3)-COSALF(RX1)*dirx(rx2)
      V3=DIRX(RX3)*COSALF(RX1)-DIRX(RX2)
      S1=DIRX(RX2)*V3-DIRX(RX3)*V2
      S2=DIRX(RX3)*V1-DIRX(RX1)*V3
      S3=DIRX(RX1)*V2-DIRX(RX2)*V1
C             CALCUATE PSA
      PSA=(DIRX(RX2)*DIRX(RX3)*COSALF(RX1))*2.0
      PSA=(DIRX(RX2)*DIRX(RX2)+DIRX(RX3)*DIRX(RX3))-PSA
      IF(PSA.GE.SMALL)THEN
      DARG=PSA
      PSA=DSQRT(DARG)
C               CALCULATE QSA
      QSA=2*(COSALF(RX1)*S3*S2+COSALF(RX2)*S1*S3+COSALF(RX3)*S1*S2)
      QSA=DSQRT(QSA+S1*S1+S2*S2+S3*S3)
      DEL=1.0/(INCHOR*PSA)     ! ORDER IS LEFT TO RIGHT
      DEL3H=(DEL*DIRX(RX2))/CELL(RX3)
      DEL2H=-(DIRX(RX3)*DEL)/CELL(RX2)
      DEL=1.0/(INCHV*QSA)
      DEL1V=(S1*DEL)/CELL(RX1)
      DEL2V=(S2*DEL)/CELL(RX2)
      DEL3V=(S3*DEL)/CELL(RX3)
C     write(3,9900)V1,V2,V3,S1,S2,S3,PSA,QSA,INCHOR,INCHV,RX1,RX2,
C    + RX3,CELL,DIRX
C9900   format(' V1=',F12.6,' V2=',F12.6,' V3=',F12.6,' S1=',F12.6,
C    +' S2=',F12.6,' S3=',F12.6,/,'  PSA=',F14.7,' QSA=',F14.7,
C    +'  INCHOR=',F6.3,' INCHV=',F6.3,' LC1,LC2,LC3=',3I3,              
C    +/,'  CELL=',6(1X,F9.6),' DIRX=',3(1X,F9.6))
       ELSE
      DEL1V=0.0        ! UNDEFINED CASE  DEL1V=0.0
      DEL3H=0.0        ! NORMAL PARALLEL TO 1ST DIMENSION AXIS
      SINA1=SQRT(1.0-(COSALF(RX1)*COSALF(RX1)))
      DEL2H=1.0/INCHOR*CELL(RX2)
      DEL=1.0/SINA1*INCHV
      DEL2V=-(COSALF(RX1)*DEL)/CELL(RX2)
      DEL3V=DEL/CELL(RX3)
      ENDIF
C            CALCULATE NUMBERS OF ROWS AND COLUMNS TO DO
         NUMSEC=1
         SECNUM=1
         R1=DHORIZ*INCHOR
         IR1=R1
         NUMCOL=IOR(IR1,SECNUM)     ! MAKE NUMCOL ODD  IF IT ISNT
         R1=-NUMCOL/2
         R3=R1
         R14=(R1*DEL2H)+CENX(RX2)
         R15=(R3*DEL3H)+CENX(RX3)
      R1=DVERTI*INCHV
      IR1=R1
         NUMROW=IOR(IR1,SECNUM)  ! MAKE NUMROW ODD
         R1=-NUMROW/2     !
         R3=R1
       VAL1=(R1*DEL1V)+CENX(RX1)    ! CORRECT 1ST DIM STARTING VALUE
       FST2=(R3*DEL2V)+R14          ! CORRECT 2ND DIM START FOR (0,0)
       VAL2=FST2
       FST3=(R3*DEL3V)+R15          ! CORRECT 3RD DIM STARTING VALUE
       VAL3=FST3                    ! SAVE FOR LATER PRINT
       DEL1H=0
      DELH(RX1)=DEL1H
      DELH(RX2)=DEL2H
      DELH(RX3)=DEL3H
      DELV(RX1)=DEL1V
      DELV(RX2)=DEL2V
      DELV(RX3)=DEL3V
      VAL(RX1)=VAL1
      VAL(RX2)=VAL2
      VAL(RX3)=VAL3
      DO II=1,3
      IF(DELH(II).GE.0.0)THEN
      DH(II)=DELH(II)
      SDH(II)='+'
      ELSE
      SDH(II)='-'
      DH(II)=ABS(DELH(II))
      ENDIF
      IF(DELV(II).GE.0.0)THEN
      DV(II)=DELV(II)
      SDV(II)='+'
      ELSE
      DV(II)=ABS(delv(ii))
      SDV(II)='-'
      ENDIF
      ENDDO
      WRITE(3,400)NUMSEC,NUMCOL,NUMROW
C            WRITE COORDINATE FILE FOR WPS HOPT PROGRAM
      N=NAMLEN+1
      NFILE(N:N+3)='.HOP'
      OPEN(NAME=NFILE,UNIT=48,TYPE='NEW',FORM='FORMATTED',BLOCKSIZE=800)
      nomaps=nomaps+1 !kms 10/26/87 for hop file
      WRITE(48,3000)nomaps,(VAL(II),II=1,3),DELH(1),DELV(1),DELH(2),
     +delv(2),DELH(3),DELV(3),inches,(numcol-1.0)/2.0,(numrow-1.0)/2.0
3000  FORMAT(1x,i2,1X,9f8.5,/,5X,3(1X,F4.1)) !NEW Hop file 10/26/87
      WRITE(3,48)(VAL(II),II=1,3),(DELH(II),II=1,3),(DELV(II),II=1,3),
     +(VAL(JJ),SDH(JJ),DH(JJ),SDV(JJ),DV(JJ),JJ=1,3)
48    FORMAT('0  COORDINATES OF STARTING POINT    X = ',F8.5,
     + '  Y = ',F8.5,'  Z = ',F8.5,//,
     +' HORIZONTAL INCREMENTS   DELTA X = ',F8.5,'  DELTA Y= ',
     + F8.5,'  DELTA Z = ' F8.5,//,
     +' VERTICAL INCREMENTS     DELTA X =',F8.5,'   DELTA Y =',
     + F8.5,'  DELTA Z =  ',F8.5,//,
     + '   TO FIND THE COORDINATES OF A POINT ON COLUMN c AND',
     + ' ROW r (ROWS AND COLUMNS BEING NUMBERED FROM ZERO)',
     + ' USE:',//,'  X(r,c) = ',f8.5,1X,A,f8.5,' *c ',1X,A,f8.5,' *r '/,
     +            '  Y(r,c) = ',f8.5,1X,A,f8.5,' *c ',1X,A,f8.5,' *r '/,
     +            '  Z(r,c) = ',f8.5,1X,A,f8.5,' *c ',1X,A,f8.5,' *r')
C     WRITE(3,48)XYZT(RX1),VAL1,XYZT(RX2),VAL2,XYZT(RX3),VAL3,XYZT(RX1),
C    +DEL1H,XYZT(RX2),DEL2H,XYZT(RX3),DEL3H,XYZT(RX1),DEL1V,XYZT(RX2),
C    +DEL2V,XYZT(RX3),DEL3V
C48    FORMAT('0  COORDINATES OF STARTING POINT    ',A1,'= ',F8.5,
C    + '  ',A1,'= ',F8.5,'  ',A1,'= ',F8.5,//,
C    +' HORIZONTAL INCREMENTS   DELTA ',A1,' = ',F8.5,'  DELTA ',A1,'= ',
C    + F8.5,'  DELTA ',A1,' = ' F8.5,//,
C    +' VERTICAL INCREMENTS    DELTA ',A1,' =',F8.5,'   DELTA ',A1,' =',
C    + F8.5,'  DELTA ',A1,' =  ',F8.5,//,
C    + '  TO FIND THE X COORDINATE OF A POINT ON THE M ROW AND',
C    + ' THE N COLUMN (ROWS AND COLUMNS BEING NUMBERED FROM ZERO)',
C    + ' USE:',//,'  X(M,N) = X(STARTING POINT) + M*DELTA X(VERTICAL)',
C    + '  + N*DELTA X(HORIZONTAL)')
      WRITE(3,49)NAMEX
49     FORMAT('1',5X,'GENERAL PLANE',5X,A)
50      IF(NUMCOL-2.GT.MAXCLS)THEN
      WRITE(3,51)MAXCLS
51     FORMAT(' MORE THAN ',I3,' COLUMNS REQUESTED; YOU GET FIRST ,I3 ')
       NUMCOL=MAXCLS+2          ! SET NUMBER OF COLUMNS TO 156
        ENDIF
       FSTCOL=(NUMCOL-2)*5            ! NUMBER OF BYTES PER LINE
      IF(FSTCOL.GT.130)THEN    ! NUMBER OF BYTES ON ONE PAGE
      IF(TS.EQ.7)THEN      ! SIGNAL TO SAVE MAP
      TS=8                 ! SIGNAL FOR EXTRA PRINT AND SAVE MAP
      ELSE
      TS=9                 ! SIGNAL FOR EXTRA PRINT
      ENDIF
      FSTCOL=130
      ENDIF
      SZE=(NUMCOL*2)+(NUMROW*2)        ! FOR ROW AND COL MARKS
      IRET=LIB$GET_VM(SZE,ADP)
      IF(IRET.NE.1)THEN
      WRITE(3,54)
54     FORMAT('  UNABLE TO ALLOCATE VIRTUAL MEMORY FOR ROW MARKS')
      IER=9
      RETURN
      ENDIF
      IPH=ADP
      IPV=ADP+(NUMCOL*2)
      MSC=0         ! SIGNAL FOR FIRST MAP SARTING CARD
57     READ(1,52)CARD
C           ! PASS THIS INFORMATION ON RETURN TO CRYVAX
C           ! SO THAT NEXT RECORD TO BE EXAMINED WILL BE IN CARD.
C      write(3,58)card
C58     format('  in setcal input card :',A)
      DO I=5,6
      IF(CARD(1:4).EQ.FTB(I))FTS=I  ! 5=FPEAK, 6=CONTOUR MAP
      ENDDO
c     WRITE(3,200)TS,OP12,FTS
c200   FORMAT('  IN SETCAL TS=',I3,' OP12=',I2,' FTS=',I3)
      IF(TS.NE.0.OR.FTS.NE.0)THEN          ! MAKE SURE 12 IS OPEN
      IF(OP12.EQ.0)THEN
      N=NAMLEN+1
      NFILE(N:N+3)='.MAP'
C
      OPEN(NAME=NFILE,UNIT=12,TYPE='NEW',FORM='UNFORMATTED',
     + BLOCKSIZE=32768)
      OP12=9          ! SIGNAL THAT 12 IS OPEN
c902    FORMAT('   UNIT 12 HAS BEEN OPENED. TS=',I4)
c      WRITE(3,902)TS
       NV2=NPV/2
       NH2=NPH/2
C     SP(1)=CENX(1)-(DEL1V*NV2)
C      SP(2)=CENX(2)-(DEL2H*NH2)-(DEL2V*NV2)
C      SP(3)=CENX(3)-(DEL3H*NH2)-(DEL3V*NV2)
       SP(1)=VAL1
       SP(2)=VAL2
       SP(3)=VAL3
      ENDIF
      IF(CARD(1:4).EQ.FTB(5))THEN
      DECODE(80,55,CARD)SMHPK,DMPK,ICRD,LPKST,NMHPK,NDPK    
  55  FORMAT (10X,F6.0,F6.3,2I2,1X,F6.0,F6.3)
      fpk=5            ! signal that this IS FPEAK
      IF(TS.EQ.0)TS=FPK
C     WRITE(3,904)SMHPK,DMPK
C 904    FORMAT('  SMHPK=',F6.0,'   DMPK=',F6.3)
      MXPEAK=1
      GO TO 57    ! IF FPEAK, READ ANOTHER RECORD
      ELSE IF(CARD(1:4).EQ.FTB(6))THEN
      DECODE(35,56,CARD)RAB,RAD,RAE     ! pass ab,ad,ae in common
56    format(12x,3F7.0)
       FPLT=6        ! SIGNAL THAT CONTOUR RECORD HAS BEEN READ
      IF(TS.EQ.0)TS=FPLT
C               DONT READ NEXT RECORD UNTIL YOU ARE IN FPLOT
      ENDIF
      ENDIF
      LX(RX1)=VAL1
      LX(RX2)=FST2
      LX(RX3)=FST3
C     WRITE(3,2000)RX1,LX(RX1),RX2,LX(RX2),RX3,LX(RX3)
C2000  FORMAT('  LX(',I1,')=',F7.4,' LX(',I1,')=',F7.4,' LX(',I1,')=',
C     +F7.4)
C     WRITE(50,9832)NUMSEC,SECNUM,ITYP,SCT
C9832  FORMAT(' NUMSEC=',I3,' SECNUM=',I3,' ITYP=',I2,'  SCT=',I2)
C     if(numsec.eq.0)numsec=3
      WRITE(12)NAMEX,CELL,SGSV,SPGL,ITYP,RX1,RX2,RX3,LX,HIGHX,DEL1V,
     +DEL2V,DEL3V,DEL1H,DEL2H,DEL3H,NUMSEC,NUMROW,NUMCOL,NUMROB,NUMCOB,
     +OSDV,OSDH,SP,MXPEAK,SMHPK,DMPK,LPKST,NMHPK,NDPK,INCHES,ICRD,SPG
c     WRITE(3,901)NUMSEC,NUMROW,NUMCOL,INCHES
c901    FORMAT('  IN SETCAL NUMSEC=',I3,' NUMROW=',I3,' NUMCOL=',I3,/,
c    +'  INCHES=',F5.2)
      CALL FOO(%VAL(AD1),%VAL(AD5),%VAL(AD6),%VAL(AD7),%VAL(AD9),    
     +%VAL(AD11),%VAL(ADC),%VAL(ADS),MAX1,MAX2,MAX3,%VAL(IPH),     
     +%VAL(IPV))
52      FORMAT(A)
      SPG=SGSV
       MPD=MPD+1
        I=1
C      WRITE(3,901)CARD,FPK,FPLT
C901    FORMAT(' IN SETCAL , AFTER CALL TO FOO CARD IS  ',/,5X,A,/,
C    +'  FPK=',I2,'FPLT=',I2)
      IF(FPK.EQ.5)THEN  
      IS3=MPD
      REWIND 12
      CALL FPEAK3    ! REEKE VERSION
C     WRITE(3,60)
60     FORMAT('    FPEAK HAS BEEN CALLED')
        FPK=0
      ELSE IF(FPLT.EQ.6)THEN
      IS3=MPD
      REWIND 12
      READ(12)NMEX,CLL,SPG2,SPGL2,ITYP,RRX1,RRX2,RRX3,LX,hx,D1V,              
     +DL2V,DL3V,DL1H,DL2H,DL3H,NSEC,NROW,NCOL,NUMROB,NUMCOB,
     +OSDV,OSDH,SP,MXPEAK,SMHPK,DMPK,LPKST,NMHPK,NDPK,INCHES,ICRD,SPG
      SIZ=NCOL*NROW*4          ! SIZE IN BYTES
      SIZ2=(NCOL+NROW)*2       ! SIZE OF PHR,PVR IN BYTES
      SIZ3=SIZ+SIZ2
      IRET=LIB$GET_VM(SIZ3,ADDAR)
      IF(IRET.NE.1)THEN
      WRITE(3,204)
204   FORMAT('0  NOT ENOUGH VIRTUAL MEMORY FOR PLOT ARRAY')
      RETURN
      ENDIF
      ADPH=ADDAR+SIZ
      ADPV=ADPH+(NCOL*2)
       NR=NROW
       NC=NCOL
      IS3=MPD
       CALL FPLOT(%VAL(ADDAR),NCOL,NROW,%VAL(ADPH),%VAL(ADPV))
      FPLT=0
      READ(1,52)CARD
      ENDIF
       IF(CARD(1:4).EQ.FTB(4))THEN    ! END FOURIER
        IF(MPD.GT.1)I=2
       WRITE(3,53)MPD,MPS(I)
53     FORMAT('0',5X,I3,A,' BEEN CALCULATED.',//)    !  DOUBLE SPACE
        ELSE
       IF(CARD(1:4).EQ.FTB(1))IS1=0
       IF(CARD(1:4).EQ.FTB(2))IS1=1
       IF(CARD(1:4).EQ.FTB(3))IS1=2
       DO I=7,10
       IF(CARD(1:4).EQ.FTB(I))MSC=I     ! ANOTHER MAP STARTING RECORD
      ENDDO
      ENDIF
      IRET=LIB$FREE_VM(GETSIZ,AD1)   ! FREE BLOCK AND TRIG MEMORY
        IF(TBL.NE.0)THEN      ! FREE STORAGE ALLOCATED FOR PREVIOUS MAP
       IRET=LIB$FREE_VM(TBL,ADC)
       IF(IRET.NE.1)THEN
      WRITE(3,40)
      ENDIF
      ENDIF
C     WRITE(3,4000)
4000  FORMAT('1')
      RETURN
      END
