C     SUBROUTINE SYMM                                                   00000020
C     GENERATES ALL SYMMETRY ELEMENTS THAT PRODUCE ATOMS WITHIN A GIVEN 00000040
C     DISTANCE OF BLOCK CONTAINING THE ATOMS.                           00000050
      SUBROUTINE SYMM(X,Y,Z,NA,ADMX,NSYM,AM,AR,MSYM,ASP)
c     below 1000 = msym as set in two other programs, guk common in 4
c      DIMENSION A(9999),B(9999),C(9999),D(9999),E(9999),F(9999),
c     1G(9999),H(9999),P(9999),Q(9999),RR(9999),SS(9999),AX(9999,12),
      DIMENSION A(9999),B(9999),C(9999),D(9999),E(9999),F(9999),
     1G(9999),H(9999),P(9999),Q(9999),RR(9999),SS(9999),AX(9999,12),
     1X(1),Y(1),Z(1),XC(8),AGL(12,192),
     2YC(8),ZC(8),XM(2),YM(2),ZM(2),AM(3,3),AR(3,3)
      CHARACTER*1 ASP
      COMMON IS1,IS2,IS3,IS4
      COMMON /GUK/A,B,C,D,E,F,G,H,P,Q,RR,SS
      COMMON /CONSYM/IYES
      EQUIVALENCE (XMN,XM(1)),(XMX,XM(2)),(YMN,YM(1)),(YMX,YM(2)),      00000130
     1(ZMN,ZM(1)),(ZMX,ZM(2)),(AX(1,1),A(1)),(AX(1,2),B(1)),(AX(1,3),   00000140
     2C(1)),(AX(1,4),D(1)),(AX(1,5),E(1)),(AX(1,6),F(1)),(AX(1,7),G(1)),00000150
     3(AX(1,8),H(1)),(AX(1,9),P(1)),(AX(1,10),Q(1)),(AX(1,11),RR(1)),
     4(AX(1,12),SS(1))
  200 FORMAT ('0',10X,'SPACE GROUP GENERATION'/)                        00000160
  201 FORMAT (' ',5X,12F6.2)
  202 FORMAT ('0',10X,'FINAL SYMMETRY LIST'/)                           00000180
  203 FORMAT ('0   SYMMETRY LIST OVERFLOWED'/)                          00000190
204   FORMAT('0',9X,'A',5X,'B',5X,'C',5X,'D',5X,'E',5X,'F',5X,'G',5X,
     1'H',5X,'P',5X,'Q',5X,'R',5X,'S')
C                                                                       00000200
C   NC= # OF CENTERING OPERATIONS FOR CUBIC SPACE GROUPS
      NC=0
C     FIND EXTENTS OF ASYMMETRIC UNIT                                   00000210
C                                                                       00000220
      IYES=1   ! FOR CONNECT - NEED TO RUN SYM FIRST
      XMN=X(1)                                                          00000230
      XMX=X(1)                                                          00000240
      YMN=Y(1)                                                          00000250
      YMX=Y(1)                                                          00000260
      ZMN=Z(1)                                                          00000270
      ZMX=Z(1)                                                          00000280
      IF(NA.EQ.1) GO TO 15
      DO 15 I=2,NA                                                      00000290
      IF (XMN-X(I)) 3,3,2                                               00000300
    2 XMN=X(I)                                                          00000310
    3 IF (XMX-X(I)) 4,5,5                                               00000320
    4 XMX=X(I)                                                          00000330
    5 IF (YMN-Y(I)) 7,7,6                                               00000340
    6 YMN=Y(I)                                                          00000350
    7 IF (YMX-Y(I)) 8,9,9                                               00000360
    8 YMX=Y(I)                                                          00000370
    9 IF (ZMX-Z(I)) 10,11,11                                            00000380
   10 ZMX=Z(I)                                                          00000390
   11 IF (ZMN-Z(I)) 15,15,12                                            00000400
   12 ZMN=Z(I)                                                          00000410
   15 CONTINUE                                                          00000420
C     DEFINE CORNERS OF ATOM CONTAINING UNIT                            00000440
      L=1                                                               00000460
      DO 20 I=1,2                                                       00000470
      DO 20 J=1,2                                                       00000480
      DO 20 K=1,2                                                       00000490
      XC(L)=XM(I)                                                       00000500
      YC(L)=YM(J)                                                       00000510
      ZC(L)=ZM(K)                                                       00000520
   20 L=L+1                                                             00000530
C     DEFINE EXTENTS OF PARALLELOPIPED OF INFLUENCE                     00000550
      TXE=ADMX*SQRT(AR(1,1))                                            00000570
      XMX=XMX+TXE                                                       00000580
      XMN=XMN-TXE                                                       00000590
      TXE=ADMX*SQRT(AR(2,2))                                            00000600
      YMX=YMX+TXE                                                       00000610
      YMN=YMN-TXE                                                       00000620
      TXE=ADMX*SQRT(AR(3,3))                                            00000630
      ZMX=ZMX+TXE                                                       00000640
      ZMN=ZMN-TXE                                                       00000650
CWRITE(3,1000)XMN,XMX,YMN,YMX,ZMN,ZMX
C1000	FORMAT(' XMN,XMX,YMN,YMX,ZMN,ZMX=',6F12.6)
C     GET SPACE GROUP GENERATORS                                        00000670
      CALL SPACE(AGL,N,ASP,NC)
c      write(3,5200)n
c5200  format('0after call space N = ',i3)
      IF (N) 69,69,52                                                   00000700
   52 WRITE (3,200)  !KAF 4/15/93 PER WPS -temp cancel per rem                             00000710
c      IF(IS4.GT.194)N=N+2
c      write(3,2010)n
2010  format('0N = ',i3)
      DO 55 I=1,N                                                       00000720
      WRITE(16,201)(AGL(J,I),J=1,12)  ! FOR CONNECT
   55 WRITE (3,201) (AGL(J,I),J=1,12)  !KAF 4/15/93 PER WPS-temp cancel5/93
c   55 CONTINUE
      IF(IS4.GT.194) GO TO 960
      IF(IS4.GT.142) GO TO 860
      IF (N-1) 69,69,60                                                 00000750
C   HERE FOR TRIGONAL AND HEXAGONAL SPACE GROUPS
C		IN TRIGONAL AND HEX. NEVER CALCULATE 1X2
860   CONTINUE
      IF(N.EQ.2) GO TO 69
      M=N+1
      DO 861 I=1,2
      CALL COMBI (AGL,I,3,M)
      M=M+1
C   N+1=1X3  N+2=2X3
861   CONTINUE
      IF(N.EQ.3) GO TO 870
      DO 862 I=1,2
      CALL COMBI(AGL,I,4,M)
      M=M+1
C   N+3=1X4, N+4=2X4
862   CONTINUE
      IF(IS4.EQ.146) GO TO 870
C   HERE FOR N=4, 5, OR 6
      DO 863 I=1,2
      L=N+I
C    N+5=1X3X4   N+6=2X3X4
      CALL COMBI(AGL,L,4,M)
      M=M+1
863   CONTINUE
      IF(N.NE.5) GO TO 850
      DO 864 I=1,2
      CALL COMBI(AGL,I,5,M)
      M=M+1
C   N+7=1X5  N+8=2X5
864   CONTINUE
C   HERE ONLY IF N=5
      DO 865 I=1,2
      L=N+I
      CALL COMBI(AGL,L,5,M)
      M=M+1
C   N+9=1X3X5  N+10=2X3X5 
865   CONTINUE
	IF(IS4.GT.161)GO TO 8865   ! STAY FOR 146,148,155,160,161
	DO 8866 I=4,5
	CALL COMBI(AGL,3,I,M)
	M=M+1     !  N+11= 3X4 , N+12=   3X5
8866	CONTINUE
	GO TO 870
8865  	DO 8658 I=4,5
	L=N+I
	CALL COMBI(AGL,L,5,M)
	M=M+1	!  N+11=1X4X5  N+12=2X4X5
8658	CONTINUE
      IF(IS4.LT.191) GO TO 870
C   191, 192, 193 COMBINE 3X4X5  24 REFLECTIONS
      DO 866 I=1,2
      L=N+10+I
      CALL COMBI(AGL,L,3,M)
      M=M+1
C   N+13=3X1X4X5  N+14=3X2X4X5
866   CONTINUE
      DO 867 I=4,5
      CALL COMBI(AGL,I,3,M)
      M=M+1
C   N+15=3X4  N+16=3X5
867   CONTINUE
      CALL COMBI(AGL,4,5,M)
      L=M
      M=M+1
      CALL COMBI(AGL,L,3,M)
C    N+17=4X5  N+18=3X4X5
      GO TO 68
C
850   CONTINUE
C  HERE FOR N=4, N=6
C N+1=1X3 N+2=2X3 N+3=1X4 N+4=2X4 N+5=1X3X4 N+6=2X3X4
C   HAVE 10 REFLECTIONS
      CALL COMBI(AGL,3,4,M)
      M=M+1
      IF(N.EQ.4) GO TO 870
C  N=6  N+7=3X4  WANT 36 REFLECTIONS
      IEND=N+7
      DO 868 J=5,6
      DO 868 I=1,IEND
      IF(I.EQ.5) GO TO 868
      IF(I.EQ.6) GO TO 868
      CALL COMBI(AGL,I,J,M)
      M=M+1
868   CONTINUE
C    ALL DONE
870   M=M-1
      GO TO 68
C   HERE FOR CUBIC SPACE GROUPS
960   CONTINUE
C   N=4, 5, 6, 7, 8, OR 9     NP=4, 5, OR 6   NC=0, 1, OR 3
      M=N+1
      NP=N-NC
C    NP=  4  5  OR  6    NC =  0  1  OR  3
      DO 961 I=1,2
      DO 961 J=3,NP
      CALL COMBI (AGL,I,J,M)
961   M=M+1
      IM=M-1
C    IMO IS THE FIRST COMBINATION WITH NO OP 1 OR OP 2
      IMO=M
C   COMBINE 3X4  3X5  ...3X6,4X5,4X6,5X6
      NPE=NP-1
      DO 962 I=3,NPE
      DO 962 J=4,NP
      IF(J.LE.I) GO TO 962
      CALL COMBI(AGL,I,J,M)
      M=M+1
962   CONTINUE
      IME=M-1
C   IME=LAST OF NPEXNP
      IMA=IME
      IF(NP.EQ.4) GO TO 964
C   HERE FOR NP= 5  6
      IF(NP.EQ.5) II=1
      IF(NP.EQ.6) II=3
      J=IME-II
      DO 963 I=1,II
      J=J+1
      CALL COMBI(AGL,3,J,M)
      M=M+1
963   CONTINUE
      IF(NP.EQ.5) GO TO 964
      CALL COMBI(AGL,4,IME,M)
      M=M+1
C      4 X 5 X 6
      CALL COMBI(AGL,IMO,IME,M)
      M=M+1
C      3X4 X 5X6
964   IMA=M-1
C   IMO IS THE INDEX OF 3 X 4
C   APPLY 1 AND 2 TO EVERYTHING FROM 3 X 4 ON.
      DO 965 I=1,2
      DO 965 J=IMO,IMA
      CALL COMBI(AGL,I,J,M)
      M=M+1
965   CONTINUE
C   READY FOR CENTERING OPS
      IME=M-1
      IF(NC.EQ.0) GO TO 870
      IB=NP+1
      DO 966 I=IB,N
      DO 966 J=1,NP
      CALL COMBI(AGL,I,J,M)
      M=M+1
C    I IS INDEX OF CENTERING OPS
966   CONTINUE
      NB=N+1
      DO 967 I=IB,N
      DO 967 J=NB,IME
      CALL COMBI(AGL,I,J,M)
      M=M+1
967   CONTINUE
      GO TO 870
   60 M=N                                                               00000760
      L=N-1                                                             00000770
      DO 61 I=2,N                                                       00000780
      M=M+1                                                             00000790
c     WRITE(3,123)I,M,N
c123   FORMAT('  1X',I1,'=',I1,'   N=',I1)
61    CALL COMBI(AGL,1,I,M)
      IF(IS4.GE.74.AND.is4.LT.143)THEN
      do jj=4,12,4
      if(agl(jj,m).eq.-0.5)agl(jj,m)=0.5     ! -0.5 + 1.0
      enddo
      endif
      IF (N-2)68,68,62                                                  00000810
   62 DO 63 I=3,N                                                       00000820
      M=M+1                                                             00000830
c     WRITE(3,234)I,M,N
c234   FORMAT('   2X',I1,'=',I1,'   N=',I1)
63    CALL COMBI(AGL,2,I,M)
      if(is4.ge.74.and.is4.lt.143)then
      do jj=4,12,4
      if(agl(jj,m).eq.-0.5)agl(jj,m)=0.5     ! -0.5 + 1.0
      enddo
      endif
	IF(N.EQ.5)GO TO 630
      M=M+1                                                             00000850
c     WRITE(3,345)M,N
c345   FORMAT('  3X4=',I1,'   N=',I1)
      IF(IS4.EQ.114.or.is4.eq.96)THEN
      CALL COMBI(AGL,4,3,M)
      ELSE
      CALL COMBI(AGL,3,4,M)
      ENDIF
      if(is4.ge.74.and.is4.lt.143)then
      do jj=4,12,4
      if(agl(jj,m).eq.-0.5)agl(jj,m)=0.5     ! -0.5 + 1.0
      enddo
      endif
      IF (N-3) 68,68,65                                                 00000870
   65 M=M+1                                                             00000880
      CALL COMBI(AGL,2,10,M)
655	IB=2*N
	IE=M  
	DO 67 I=IB,IE
      M=M+1                                                             00000910
67    CALL COMBI(AGL,1,I,M)
	GO TO 68
630	DO 631 I=4,5
	M=M+1
	CALL COMBI(AGL,3,I,M)		! 3X4  3X5
631	CONTINUE
	M=M+1
	CALL COMBI(AGL,4,5,M)
	I=M
	M=M+1
	CALL COMBI(AGL,3,I,M)		!3X4X5
	DO 632 I=13,16
	M=M+1
	CALL COMBI(AGL,2,I,M)
632	CONTINUE
	GO TO 655
68	DO 668 I=N+1,M
        WRITE(16,201)(AGL(J,I),J=1,12)  ! FOR CONNECT
668     WRITE(3,201)(AGL(J,I),J=1,12)
	N=M
C     CALCULATE TRANSLATION LIMITS.                                     00000950
   69 L=XMN-2.5                                                         00000970
      XDL=L                                                             00000980
C 	WRITE(3,4001)XMN,L,XDL
C4001	FORMAT(' XMN, L, XDL=',F9.3,I4,F9.3)
      NXT=XMX+1.5                                                       00000990
      NXT=NXT-L                                                         00001000
      L=YMN-2.5                                                         00001010
      YDL=L                                                             00001020
      NYT=YMX+1.5                                                       00001030
      NYT=NYT-L                                                         00001040
      L=ZMN-2.5                                                         00001050
      ZDL=L                                                             00001060
      NZT=ZMX+1.5                                                       00001070
      NZT=NZT-L                                                         00001080
C 	WRITE(3,1002)NXT,NYT,NZT
C1002	FORMAT(' NXT,NYT,NZT NUMBER OF TRANSLATIONS',/,
C     1 3I4)
C     SET UP SYMMETRY RELATIONS                                         00001100
      NX=NSYM+1                                                         00001120
      DO 766 I=2,12
766   AX(NX,I)=0.0
      DO 76 I=1,11,5
76    AX(NX,I)=1.0
      INUL=1                                                            00001160
 78   D(NX)=D(NX)+XDL
      H(NX)=H(NX)+YDL
      SS(NX)=SS(NX)+ZDL
C     APPLY TRANSLATIONS                                                00001210
      XST=D(NX)
      YST=H(NX)
      DO 125 K=1,NZT                                                    00001250
      SS(NX)=SS(NX)+1.0
      H(NX)=YST
      DO 125 L=1,NYT                                                    00001280
      H(NX)=H(NX)+1.0
      D(NX)=XST
      DO 125 M=1,NXT                                                    00001310
      D(NX)=D(NX)+1.0
C	WRITE(3,4000)D(NX),K,L,M
C4000	FORMAT(' D(NX),K,L,M',F12.3,3I4)
C     TEST IF ANY CORNER IS WITHIN THE PARALLELOPIPED OF INFLUENCE.     00001340
C     NOTE - THIS CRITERIA MAY NEED TO BE MODIFIED BY INCLUDING A       00001360
C        'STRADDLE' TEST FOR HIGHER THAN ORTHORHOMBIC SYMMETRY          00001370
      DO 88 I=1,8                                                       00001390
      CALL TRANS(XC(I),YC(I),ZC(I),XCN,YCN,ZCN,NX)
      IF (XCN-XMN) 88,80,80                                             00001410
   80 IF (XCN-XMX) 81,81,88                                             00001420
   81 IF (YCN-YMN) 88,82,82                                             00001430
   82 IF (YCN-YMX)83,83,88                                              00001440
   83 IF (ZCN-ZMN) 88,84,84                                             00001450
   84 IF (ZCN-ZMX) 91,91,88                                             00001460
   88 CONTINUE                                                          00001470
C 	WRITE(3,1001)XCN,YCN,ZCN
1001	FORMAT(' XCN,YCN,ZCN=',3F12.6)
      GO TO 125                                                         00001480
C     ACCEPT TRIAL SYMMETRY RELATION                                    00001500
   91 IF (INUL) 93,100,93                                               00001520
93    DO 94 I=1,11,5
 	RDIFF=ABS(AX(NX,I)-1.0)
	IF(RDIFF.GT.0.000001)GO TO 100
94    CONTINUE
      DO 95 I=2,5
	RDIFF=ABS(AX(NX,I))
	IF(RDIFF.GT.0.000001)GO TO 100
95    CONTINUE
      DO 96 I=7,10
	RDIFF=ABS(AX(NX,I))
	IF(RDIFF.GT.0.000001)GO TO 100
96    CONTINUE
	RDIFF=ABS(AX(NX,12))
	IF(RDIFF.GT.0.000001)GO TO 100
97    CONTINUE
      INUL=0                                                            00001570
      GO TO 125                                                         00001580
  100 IF (NSYM) 109,109,101                                             00001590
  101 DO 108 I=1,NSYM                                                   00001600
      DO 106 J=1,12
	RDIFF=ABS(AX(I,J)-AX(NX,J))
	IF(RDIFF.GT.0.000001)GO TO 108
  106 CONTINUE                                                          00001630
      GO TO 125                                                         00001640
  108 CONTINUE                                                          00001650
  109 J=NX                                                              00001660
      NX=NX+1                                                           00001670
      IF (NX-MSYM) 111,111,138                                          00001680
111   DO 110 I=1,12
  110 AX(NX,I)=AX(J,I)                                                  00001700
  125 CONTINUE                                                          00001710
      IF (N) 140,140,128                                                00001720
C     TRY NEXT SPACE GROUP OPERATION.                                   00001740
128   DO 130 I=1,12
  130 AX(NX,I)=AGL(I,N)                                                 00001770
      N=N-1                                                             00001780
      GO TO 78                                                          00001790
C     TERMINATE                                                         00001810
  138 WRITE (3,203)                                                     00001830
  140 NSYM=NX-1                                                         00001840
142    IF (NSYM.NE.0)THEN             
       WRITE(3,202)
       WRITE(3,204)
      ENDIF
       RETURN
      END                                                               00001860
      SUBROUTINE MOLEC
      WRITE(3,100)
      RETURN
100   FORMAT(1X,'  MOLEC IS NOT WORKING. ')
      END
