C         TETRAGONAL INITIALIZATION ROUTINE
      SUBROUTINE TETRN(ISPG,MXMUL,M,JOE)
    	INTEGER*2 TCODE(8,68),MULT(68),PCODE(68),PAR(12,14),
     1 TGCOD(8,56)
      DIMENSION M(12),JOE(8,8)
C234567
CC   GET PARITY CODE NUMBER  HALF WORD LENGTH
C
       ISPG=ISPG-74	! BEGIN AT 1
      IP=PCODE(ISPG)	! GET PARITY CODE INDEX
C   C       GET AND SAVE PARITY CODES  HALF WORD LENGTH
    	IP=IP+1		! BEGIN AT 1 INSTEAD OF 0
    	DO 1 I=1,12
       M(I)=PAR(I,IP)
1      CONTINUE
C23456
    	MXMUL=MULT(ISPG)
C         TCODE(8,68)  IS INDEX OF TRIG CODE
       DO 2 I=1,8
    	IT=TCODE(I,ISPG)-1	! START WITH 1 INSTEAD IF 2
    	IF(IT.LT.1)GO TO 4
      DO 3 J=1,8
    	JOE(J,I)=TGCOD(J,IT)	!  I IS JOE INDEX IT IS TGCOD INDEX
3      CONTINUE
C23456
    	GO TO 2
4      DO 5 J=1,8
    	JOE(J,I)=0.0
5      CONTINUE
2      CONTINUE
    	ISPG=ISPG+74	! RESTORE ISPG
    	RETURN
C   C     TRIG CODE NUMBER (BY SPACE GROUP) FOR TETRAGONAL
          DATA TCODE /28,0,0,0,0,0,0,0,
     1 28,33,29,34,0,0,0,0,            ! SPACE GROUP  76
     1 28,29,0,0,0,0,0,0,              ! SPACE GROUP  77
     1 28,34,29,33,0,0,0,0,            ! SPACE GROUP  78
     1 28,0,0,0,0,0,0,0,               ! SPACE GROUP  79
C23456789
     1 28,31,29,32,0,0,0,0,            ! SPACE GROUP  80
     1 30,0,0,0,0,0,0,0,               ! SPACE GROUP  81
     1 30,0,0,0,0,0,0,0,               ! SPACE GROUP  82
     1 2,0,0,0,0,0,0,0,                ! SPACE GROUP  83
     1 2,3,0,0,0,0,0,0,                ! SPACE GROUP  84
     1 2,8,9,3,0,0,0,0,                ! SPACE GROUP  85
     1 2,3,8,9,0,0,0,0,                ! SPACE GROUP  86
     1 2,0,0,0,0,0,0,0,                ! SPACE GROUP  87
     1 2,6,5,9,3,7,4,8,              ! SPACE GROUP  88
     1 35,0,0,0,0,0,0,0,               ! SPACE GROUP  89
     1 35,36,0,0,0,0,0,0,              ! SPACE GROUP  90
     1 35,54,37,55,0,0,0,0,            ! SPACE GROUP  91
     1 35,56,36,57,0,0,0,0,            ! SPACE GROUP  92
     1 35,37,0,0,0,0,0,0,              ! SPACE GROUP  93
     1 35,36,0,0,0,0,0,0,              ! SPACE GROUP  94
     1 35,55,37,54,0,0,0,0,            ! SPACE GROUP  95
     1 35,57,36,56,0,0,0,0,            ! SPACE GROUP  96
     1 35,0,0,0,0,0,0,0,               ! SPACE GROUP  97
     1 35,52,36,53,0,0,0,0,            ! SPACE GROUP  98
     1 38,0,0,0,0,0,0,0,               ! SPACE GROUP  99
     1 38,39,0,0,0,0,0,0,              ! SPACE GROUP 100
     1 38,40,0,0,0,0,0,0,              ! SPACE GROUP 101
     1 38,40,0,0,0,0,0,0,              ! SPACE GROUP 102
     1 38,39,0,0,0,0,0,0,              ! SPACE GROUP 103
     1 38,39,0,0,0,0,0,0,              ! SPACE GROUP 104
     1 38,41,0,0,0,0,0,0,              ! SPACE GROUP 105
     1 38,41,39,40,0,0,0,0,            ! SPACE GROUP 106
     1 38,0,0,0,0,0,0,0,               ! SPACE GROUP 107
     1 38,39,0,0,0,0,0,0,              ! SPACE GROUP 108
     1 38,48,41,49,0,0,0,0,            ! SPACE GROUP 109
     1 38,50,41,51,0,0,0,0,            ! SPACE GROUP 110
     1 42,0,0,0,0,0,0,0,               ! SPACE GROUP 111
     1 42,43,0,0,0,0,0,0,              ! SPACE GROUP 112
     1 42,43,0,0,0,0,0,0,              ! SPACE GROUP 113
     1 42,43,0,0,0,0,0,0,              ! SPACE GROUP 114
     1 44,0,0,0,0,0,0,0,               ! SPACE GROUP 115
     1 44,45,0,0,0,0,0,0,              ! SPACE GROUP 116
     1 44,45,0,0,0,0,0,0,              ! SPACE GROUP 117
     1 44,45,0,0,0,0,0,0,              ! SPACE GROUP 118
     1 44,0,0,0,0,0,0,0,               ! SPACE GROUP 119
     1 44,45,0,0,0,0,0,0,              ! SPACE GROUP 120
     1 42,0,0,0,0,0,0,0,               ! SPACE GROUP 121
     1 42,46,43,47,0,0,0,0,            ! SPACE GROUP 122
     1 10,12,0,0,0,0,0,0,              ! SPACE GROUP 123
     1 10,0,0,0,0,0,0,0,               ! SPACE GROUP 124
     1 10,27,22,11,0,0,0,0,            ! SPACE GROUP 125
     1 10,11,22,27,13,12,23,24,       ! SPACE GROUP 126
     1 10,12,0,0,0,0,0,0,              ! SPACE GROUP 127
     1 10,12,0,0,0,0,0,0,              ! SPACE GROUP 128
     1 10,23,24,11,0,0,0,0,            ! SPACE GROUP 129
     1 10,11,24,23,13,12,27,22,       ! SPACE GROUP  130
     1 10,13,0,0,0,0,0,0,              ! SPACE GROUP 131
     1 10,11,0,0,0,0,0,0,              ! SPACE GROUP 132
     1 10,27,22,11,13,24,23,12,       ! SPACE GROUP 133
     1 10,11,22,27,0,0,0,0,            ! SPACE GROUP 134
     1 10,13,12,11,0,0,0,0,            ! SPACE GROUP 135
     1 10,11,0,0,0,0,0,0,              ! SPACE GROUP 136
     1 10,23,24,11,13,22,27,12,       ! SPACE GROUP 137
     1 10,23,24,11,0,0,0,0,            ! SPACE GROUP 138
     1 10,0,0,0,0,0,0,0,               ! SPACE GROUP 139
     1 10,12,0,0,0,0,0,0,              ! SPACE GROUP 140
     1 10,19,14,25,13,18,15,26,       ! SPACE GROUP 141
     1 10,20,16,25,13,21,17,26/         ! SPACE GROUP 142
C        PARITY CODE (BY SPACE GROUP #)  TETRAGONAL
      DATA PCODE /0,1,2,1,0,4,0,0,0,2,5,       ! SPACE GROUPS 75,-85
     1 6,0,7,0,8,1,9,2,3,             ! SPACE GROUPS 86-94
     1 1,9,0,4,0,8,2,3,2,3,2,         ! SPACE GROUPS 95-105
     1 10,0,2,4,4,0,2,8,3,0,2,8,     ! SPACE GROUPS 106-117
     1 3,0,2,0,4,0,2,5,11,8,         ! SPACE GROUPS 118-127
     1 3,5,11,2,2,12,13,             ! SPACE GROUPS 128-134
     1 10,3,12,13,0,2,12,12/          ! SPACE GROUPS 135-142
C         MULTIPLICITIES (BY  SPACE GROUP #) FOR TETRAGONAL
      DATA MULT /1,1,1,1,2,2,1,2,2,2,2,
     1 2,4,4,1,1,1,1,1,1,
     1 1,1,2,2,1,1,1,1,1,1,1,
     1 1,2,2,2,2,1,1,1,1,1,1,1,
     1 1,2,2,2,2,2,2,2,2,2,
     1 2,2,2,2,2,2,2,
     1 2,2,2,2,4,4,4,4/
C     TRIG CODES (USED TO FILL JOE) FOR TETRAGONAL
      DATA TGCOD/1,5,0,0,0,0,0,0,
     1 1,-5,0,0,0,0,0,0,
     1 1,6,0,0,0,0,0,0,
     1 1,-6,0,0,0,0,0,0,
     1 -2,5,0,0,0,0,0,0,
     1 -2,-5,0,0,0,0,0,0,
     1 -2,6,0,0,0,0,0,0,
     1 -2,-6,0,0,0,0,0,0,
     1 1,5,9,13,0,0,0,0,
     1 1,-5,-9,13,0,0,0,0,
     1 1,5,-9,-13,0,0,0,0,
     1 1,-5,9,-13,0,0,0,0,
     1 1,6,9,14,0,0,0,0,
     1 1,-6,9,-14,0,0,0,0,
     1 1,6,-9,-14,0,0,0,0,
     1 1,-6,-9,14,0,0,0,0,
     1 -2,5,10,13,0,0,0,0,
     1 -2,-5,10,-13,0,0,0,0,
     1 -2,-5,-10,13,0,0,0,0,
     1 -2,5,-10,-13,0,0,0,0,
     1 -2,-6,10,14,0,0,0,0,
     1 -2,6,10,-14,0,0,0,0,
     1 -2,-6,-10,-14,0,0,0,0,
     1 -2,-6,10,-14,0,0,0,0,
     1 -2,6,10,14,0,0,0,0,
     1 -2,6,-10,14,0,0,0,0,
     1 1,5,0,0,3,7,0,0,
     1 1,-5,0,0,3,-7,0,0,
     1 1,5,0,0,3,-7,0,0,
     1 1,-7,0,0,3,5,0,0,
     1 1,7,0,0,3,-5,0,0,
     1 -2,8,0,0,4,6,0,0,
     1 -2,-8,0,0,4,-6,0,0,
     1 1,5,9,13,3,7,-11,-15,
     1 1,-5,-9,13,3,-7,11,-15,
     1 1,-5,9,-13,3,-7,-11,15,
     1 1,5,9,13,3,7,11,15,
     1 1,5,-9,-13,3,7,-11,-15,
     1 1,-5,-9,13,3,-7,-11,15,
     1 1,-5,9,-13,3,-7,11,-15,
     1 1,5,9,13,3,-7,-11,15,
     1 1,5,-9,-13,3,-7,11,-15,
     1 1,5,9,13,3,-7,11,-15,
     1 1,5,-9,-13,3,-7,-11,15,
     1 1,5,11,-15,3,-7,9,13,
     1 1,5,-11,15,3,-7,-9,-13,
     1 1,-7,9,-15,3,5,11,13,
     1 1,7,9,15,3,-5,11,-13,
     1 1,-7,-9,15,3,5,-11,-13,
     1 1,7,-9,-15,3,-5,-11,13,
     1 1,-7,11,13,3,5,9,-15,
     1 1,7,-11,13,3,-5,-9,-15,
     1 -2,8,-10,16,4,6,-12,-14,
     1 -2,-8,-10,-16,4,-6,-12,14,
     1 -2,8,12,14,4,6,-10,16,
     1 -2,-8,-12,14,4,-6,10,16/
C      PARITY CODES (M1 TO M12) FOR TETRAGONAL
      DATA PAR/0,0,0,0,0,0,0,0,0,0,0,0,   !   0=NO PARITY
     1 0,0,1,4,0,0,0,0,0,0,0,0,   !     1 L=4N
     1 0,0,1,2,0,0,0,0,0,0,0,0,   !     2 L=2N
     1 1,1,1,2,0,0,0,0,0,0,0,0,   !     3 H+K+L=2N
     1 0,2,1,4,0,0,0,0,0,0,0,0,   !     4 2K+L=4N
     1 0,1,0,2,1,0,0,2,0,0,0,0,   !     5 K=2N, H=2N
     1 0,1,1,2,1,1,0,2,0,0,0,0,   !     6 K+6=2N, H+K=2N
     1 0,1,0,2,1,0,0,2,1,1,1,4,      !  7 K=2N,H=2N,H+K+L=4N
     1 1,1,0,2,0,0,0,0,0,0,0,0,   !     8 H+K=2N
     1 2,2,1,4,0,0,0,0,0,0,0,0,   !     9 2H+2K+L=4N
     1 0,0,1,2,1,1,0,2,0,0,0,0,   !     10 L=2N, H+K=2N
     1 0,1,1,2,1,1,0,2,0,0,1,2,      !   11 K+L=2N,H+K=2N,L=2N
     1 0,1,0,2,1,0,0,2,0,0,1,2,      !   12,K=2N, H=2N, L=2N
     1 0,1,1,2,1,0,1,2,0,0,0,0/   !     13 K+L=2N, H+L=2N
         END
