       SUBROUTINE TRIX(ISPG,MXMUL,IPAR,IMOD,ICEN,M4)
C      THIS VERSION BEING USED FOR HEXAGONAL ADDITIONS
C      GETCOM IS SEPARATE
C        TRIX SETS PARITY AND MULTIPLICITY CODES
C        CALL TRIX(ISPG,MXMUL,IPAR,IMOD,ICEN,M4)
C        MXMUL IS EQUIVALENCED IN LSINIT TO TWO HALFWORDS,
C        MULT1 AND MULT2. MULTIPLICITY IS CALCULATED BY MULT1/MULT2.
       INTEGER*2 MXMUL(2),INDEX
       BYTE PARTAB(2,52),MULT1(52),MULT2(52),CENT(52),PAR(104)
      DATA PAR/0,0,1,3,1,3,2,3,8*0,1,3,1,3,1,3,1,3,2,3,4*0, !143-157
C234567
     1 1,2,1,2,2,3,3,2,0,0,1,2,0,0,1,2,0,0,3,2,0,0,1,6,1,6, !158-170
     1 1,3,1,3,1,2,4*0,1,2,0,0,1,6,1,6,1,3,1,3,1,2,0,0,1,2, !171-184
     1 1,2,1,2,0,0,1,2,0,0,1,2,0,0,1,2,1,2,1,2/   ! 185-194
       DATA CENT/4*0,2*1,13*0,6*1,7*0,2*1,14*0,4*1/
       DATA MULT1/3*3,9,6,18,6*6,18,4*6,18,18,4*12,2*36,7*6,16*12,4*24/
       DATA MULT2/6*3,28*6,18*12/
       EQUIVALENCE(PAR(1),PARTAB(1,1))
        INDEX=ISPG-142     ! INDEX BEGINS AT 1
         M4=INDEX          ! SAVE INDEX FOR CALLER
         IPAR=PARTAB(1,INDEX)        ! PARITY CODE
       IMOD=PARTAB(2,INDEX)      ! MOD NUMBER FOR PARITY TEST
C        PARITY IN PARTAB(INDEX,1) MOD NUMBER IN PARTAB(INDEX,2)
C        1=0,1,2,3. 0=NO TEST, 1=TEST L, 2=-H+K+L, 3=1 AND 2.
C        2=1,2,3,4 DIVIDE BY 3,2,6, BOTH 3 AND 2.
       MXMUL(1)=MULT1(INDEX)
        MXMUL(2)=MULT2(INDEX)
        ICEN= CENT(INDEX)
C      WRITE(13,10)IPAR,IMOD
C10      FORMAT('  IPAR=',I3,'   IMOD=',I3)
       RETURN
         END
C
C        GETAB CALCULATES A AND B ( IF ACENTRIC)
C      USING EXPRESSIONS 1-24 FROM COMMON COMB AND CODE WORD FROM
C        COMMON CDCOM. A AND B ARE RETURNED IN FSC(1) AND FSC(2)
C        OF COMB.
C      CALL GETAB(IPC,IPB,KIND)
C    IPC=0 MEANS NO COORD DERIVATIVES. =1 MEANS CALCULATE DX,DY,DZ.
C    DECIDE IN LSHEX WHICH IF NOT ALL ARE NEEDED.
C    IPB=0 MEANS NO TEMP DERIVATIVE. =1 MEANS NEED TEMP. DERIV
C    KIND.LT.0 MEANS CALCULATE ANISO TEMP DERIVATIVE.
C     DERIVATIVE ARE PASSED TO LSHEX IN COMMON /COMB/ ON RETURN
C    A IS IN FSC(1), B IN FSC(2) AND DERIVATIVES DX,DY,DZ,DB11,DB22,
C    DB33,...,DB23 ARE IN FSC(3) TO FSC(11) THE B TERM DERIVATIVES
C    FOLLOW IN FSC(12), TO FSC(20).
C
       SUBROUTINE GETAB(IPC,IPB,KIND)
      BYTE CODE(2,40),IDER(4,40),HKLTB(7,6),SET1(7),SET2(7),
     1 SET3(7),SET4(7),SET5(7),SET6(7)
       EQUIVALENCE (HKLTB(1,1),SET1(1)),(HKLTB(1,2),SET2(1)),
     1(HKLTB(1,3),SET3(1)),(HKLTB(1,4),SET4(1)),(HKLTB(1,5),
     1 SET5(1)),(HKLTB(1,6),SET6(1))
       COMMON /COMB/TCOM(24),A,B,DXA,DYA,DZA,DB11,DB22,DB33,DB12,
     1 DB13,DB23,DXB,DYB,DZB,DB11B,DB22B,DB33B,DB12B,DB13B,DB23B
      COMMON /CDCOM/CODE,IDER,NUM,ISPG,DUM(5),PIH,PIK,PIL,PII,H11,
     1H22,H33,H12,H13,H23,S,T,U,V
      CHARACTER*3 DR13,DR23
      DATA DR13/'B13'/
       DATA DR23/'B23'/
      DIMENSION HKL(14),RMULT(6)
      DATA RMULT/1.0,0.5,0.866666,-1.0,-0.5,-0.866666/
      EQUIVALENCE (HKL(1),PIH)
       DATA SET1/1,2,5,6,8,9,10/   ! INDEX TO 2PIH,2PIK,ETC
       DATA SET2/2,4,6,11,12,10,14/
       DATA SET3/4,1,11,5,13,14,9/
       DATA SET4/2,1,6,5,8,10,9/
       DATA SET5/4,2,11,6,12,14,10/
       DATA SET6/1,4,5,11,13,9,14/
       A=0
       B=0    ! INITIALIZE TO ZERO
       IF(NUM.LT.0) THEN
       NUMB=-NUM    ! CENTRIC
      ELSE
      NUMB=NUM/2    ! ACENTRIC
       ENDIF   !  IABS(NUM)= NUMBER OF EXPRESSIONS NEEDED
C                TO CALCULATE A (CENTRIC) OR A AND B (ACENTRIC)
C    ONLY PROGRAMMED FOR TRIGONAL FOR NOW AUG 19 1981
C    NOV. 4 BELIEVE IS OKAYT FOR HEX TOO
      DO 1 I=1,NUMB
      IM = CODE(1,I)    ! INDEX FOR MULTIPLIER
      IE = CODE(2,I)    ! EXPRESSION NUMBER 
      SVA = TCOM(IE)*RMULT(IM)
C      WRITE(13,10)IM,RMULT(IM),IE,TCOM(IE)
C10     FORMAT(' FOR A  RMULT(',I1,')=',F9.6,'  TCOM(',I2,')=',
C     1 E12.6)
      A=SVA+A    ! SUM UP ALL A EXPRESSIONS
      IF(ISPG.GT.0)GO TO 1   !  STRUCTURE FACTOR ONLY
       J=IDER(4,I)+1  ! J POINTS TO SET1,SET2,...SET6
       IF(IPC.GT.0) THEN    ! COORD DERIVATIVES
       ID=IDER(1,I)
       IF(ID.LT.0)ID=-ID
       DX=TCOM(ID)*RMULT(IM)
       IF(IDER(1,I).LT.0)DX=-DX
CWRITE(13,101)J
C 101	FORMAT('  J POINTS TO SET1,SET2,...SET6, J IS',I2)
       DXA=DX*HKL(HKLTB(1,J))+DXA
C	DT=DX*HKL(HKLTB(1,J))
C     WRITE(13,100)DT
       DYA=DX*HKL(HKLTB(2,J))+DYA
C	DT=DX*HKL(HKLTB(2,J))
C	WRITE(13,100)DT
100     FORMAT('  DERIVATIVE CALC FOR',A3,E12.6)
       ID=IDER(2,I)   ! GET Z DERIV. EXP. NUMBER
       IF(ID.LT.0)ID=-ID
       DZ=TCOM(ID)*RMULT(IM)
       IF(IDER(2,I).LT.0)DZ=-DZ
       DZA=DZ*PIL+DZA
C       DT=DZ*PIL
C	WRITE(13,100)DT
       ELSE         ! SKIP ALL THIS IF NO REFINEMENT OF COORDS
       ENDIF
       IF(IPB.GT.0) THEN   ! TEMP. DERIV.
       IF(KIND.GT.0) GO TO 1   ! ISO TO 1
       DB11=SVA* HKL(HKLTB(3,J))+DB11
C	DT=SVA*HKL(HKLTB(3,J))
C	WRITE(13,100)DT
       DB22=SVA*HKL(HKLTB(4,J))+DB22
C       DT=SVA*HKL(HKLTB(4,J))
C	WRITE(13,100)DT
       DB33=SVA*H33+DB33
C	DT=SVA*H33
C	WRITE(13,100)DT
       DB12=SVA*HKL(HKLTB(5,J))+DB12
C       DT=SVA*HKL(HKLTB(5,J))
C	WRITE(13,100)DT
       ID= IDER(3,I)   !  CODE FOR B13 DERIVATIVE
C     J POINT TO SET1 SET2 SET3 ETC
       IF (ID.LT.0)ID=-ID
       B13=TCOM(ID)*RMULT(IM)
       IF(IDER(3,I).LT.0)B13=-B13
       DB13= B13 * HKL(HKLTB(6,J)) + DB13
          DT=B13 * HKL(HKLTB(6,J))
CC 	WRITE(13,100)DR13,DT
       DB23= B13 * HKL(HKLTB(7,J)) + DB23
          DT= B13 * HKL(HKLTB(7,J))
CC 	WRITE(13,100)DR23,DT
       ELSE     !  HERE  IF TEMP FACTOR NOT REFINED
       ENDIF    
1       CONTINUE  ! ISO COMES HERE
      IF(NUM.LT.0)GO TO 3
       NUMB=NUMB+1     ! GET NEXT EXPRESSION AFTER LAST A
       DO 2 I=NUMB,NUM  ! NUM=TOTAL NUMBER PF EXPRESSIONS IS
       IM=CODE(1,I)     ! A AND B
       IE=CODE(2,I)
       SVB=TCOM(IE)*RMULT(IM)
C	WRITE(13,11)IM,RMULT(IM),IE,TCOM(IE)
 11     FORMAT(' FOR B  RMULT(',I1,')=',F9.6,'  TCOM(',I2,')=',
     1 E12.6)
C234567
       B=SVB+B
C     ARE THERE ANY DERIVATIVES
       IF(ISPG.GT.0)GO TO 2    ! S.F.ONLY GOES TO 2
       J=IDER(4,I)+1
       IF(IPC.GT.0)THEN
       ID=IDER(1,I)     ! COORD DERIV. HERE
       IF(ID.LT.0)ID=-ID
       DX=TCOM(ID)*RMULT(IM)
       IF(IDER(1,I).LT.0)DX=-DX
       DXB=DX*HKL(HKLTB(1,J))+DXB
C	DT=DX*HKL(HKLTB(1,J))
C	WRITE(13,100)DT
       DYB=DX*HKL(HKLTB(2,J))+DYB
C	DT=DX*HKL(HKLTB(2,J))
C	WRITE(13,100)DT
       ID=IDER(2,I)
       IF(ID.LT.0)ID=-ID
       DZ=TCOM(ID)*RMULT(IM)
       IF(IDER(2,I).LT.0)DZ=-DZ
       DZB=(DZ*PIL)+DZB
      ELSE     !   HERE IF NO COORDINATE DERIV.
      ENDIF
      IF(IPB.GT.0)THEN    !  TEMP DERIVATIVES OR NOT
      IF(KIND.GT.0)GO TO 2   ! SKIP TO 2 FOR ISO
      DB11B=SVB*HKL(HKLTB(3,J))+DB11B
C	DT=SVB*HKL(HKLTB(3,J))
C	WRITE(13,100)DT
      DB22B=SVB*HKL(HKLTB(4,J))+DB22B
C       DT=SVB*HKL(HKLTB(4,J))
C	WRITE(13,100)DT
      DB33B=SVB* H33 +DB33B
C	DT=SVB*H33
C	WRITE(13,100)DT
      DB12B=SVB*HKL(HKLTB(5,J))+DB12B
C       DT=SVB*HKL(HKLTB(5,J))
C	WRITE(13,100)DT
C   TRIGONAL B13, B23 ONLY   CHANG FOR HEXAGONAL
      ID=IDER(3,I)    ! CODE FOR B13
      IF(IDER(3,I).LT.0)ID=-ID
      B13=TCOM(ID)*RMULT(IM)
      IF(IDER(3,I).LT.0)B13=-B13
      DB13B=B13*HKL(HKLTB(6,J))+DB13B
          DT=B13 * HKL(HKLTB(6,J))
C	WRITE(13,100)DR13,DT
      DB23B=B13*HKL(HKLTB(7,J))+DB23B
          DT= B13 * HKL(HKLTB(7,J))
C	WRITE(13,100)DR23,DT
      ELSE
      ENDIF
2      CONTINUE
3     RETURN    ! ALL DONE
      END
       SUBROUTINE TRIP
C        THERE ARE 6 8WORD ARRAYS TR1,TR2,...TRL IN A COMMON AREA, TRIG
C        FOR THE TRIPLE PRODUCTS TO BE RETURNED TO CALLER.
C        ON ENTRY THE ARG. FOR COS AND SIN FOR EACH OF TR1,TR2,...
C        ARE IN THE 1ST 3 WORDS OF THESE ARRAYS IN INTEGER FORM.
C        THES ARGUMENTS ARE REPLACED BY THE TRIPLE PRODUCTS.
C        TR1 : HX,KY,LZ    TR2 : HY,KX,LZ
C        TR3 : HX,IY,LZ           TR4 : HY,IX,LZ
C        TR5 : IX,KY,LZ           TR6 : IY, KX, LZ
C        ISPG FOLLOWS TR6 AND CONTAINS THE SPACE GROUP NUMBER
      COMMON /TRIG/ TR1(8),TR2(8),TR3(8),TR4(8),TR5(8),TR6(8),ISPG              12
         COMMON /CS/CA(3),SA(3)
         DO 10 I=1,3
         CA(I)=COS(TR1(I))
         SA(I)=SIN(TR1(I))
10     CONTINUE
C      WRITE(13,11)(CA(I),I=1,3),(SA(I),I=1,3)
C1     FORMAT('  TR1 COS=',3E12.6 ,'      SIN=',3E12.6)
       CALL TRIPC(TR1)
         DO 40 I=1,3
       CA(I)=COS(TR4(I))
        SA(I)=SIN(TR4(I))
40     CONTINUE
C      WRITE(13,41)(CA(I),I=1,3),(SA(I),I=1,3)
C1     FORMAT('  TR4 COS=',3E12.6,'      SIN=',3E12.6)
        CALL TRIPC(TR4)
          DO 60 I=1,3
       CA(I)=COS(TR6(I))
       SA(I)=SIN(TR6(I))
60     CONTINUE
C      WRITE(13,61)(CA(I),I=1,3),(SA(I),I=1,3)
C1     FORMAT('  TR6 COS=',3E12.6,'      SIN=',3E12.6)
       CALL TRIPC(TR6)
        NSPG=ISPG
        IF(NSPG.LT.0)NSPG=-NSPG
        IF (NSPG.GT.148)THEN
C      CALCULATE TR2,TR3, AND TR5
       DO 20 I=1,3
       CA(I)=COS(TR2(I))
       SA(I)=SIN(TR2(I))
20       CONTINUE
C      WRITE(13,21)(CA(I),I=1,3),(SA(I),I=1,3)
C1     FORMAT('  TR2 COS=',3E12.6,'      SIN=',3E12.6)
       CALL TRIPC(TR2)
       DO 30 I=1,3
       CA(I)=COS(TR3(I))
       SA(I)=SIN(TR3(I))
30     CONTINUE
C      WRITE(13,31)(CA(I),I=1,3),(SA(I),I=1,3)
C31     FORMAT('  TR3 COS=',3E12.6,'      SIN=',3E12.6)
       CALL TRIPC(TR3)
       DO 50 I=1,3
       CA(I)=COS(TR5(I))
       SA(I)=SIN(TR5(I))
50     CONTINUE
C      WRITE(13,51)(CA(I),I=1,3),(SA(I),I=1,3)
C51     FORMAT('  TR5 COS=',3E12.6,'      SIN=',3E12.6)
       CALL TRIPC(TR5)
       ELSE
       ENDIF
       RETURN
       END
       SUBROUTINE TRIPC (TR)
       COMMON /CS/CA(3),SA(3)
       DIMENSION TR(8)
       TR(8)=CA(1)*CA(2)
       TR(1)=TR(8)*CA(3)     !  COS COS COS
       TR(8)=SA(3)*TR(8)     !  COS COS SIN
       TR(5)=SA(1)*SA(2)
       TR(2)=TR(5)*CA(3)     !  SIN SIN COS
       TR(5)=TR(5)*SA(3)     !  SIN SIN SIN
       TR(7)=CA(1)*SA(2)
       TR(3)=TR(7)*SA(3)    ! COSXSINYSINZ
       TR(7)=TR(7)*CA(3)    ! COS SIN COS
       TR(6)=SA(1)*CA(2)
       TR(4)=TR(6)*SA(3)    ! SIN COS SIN
       TR(6)=TR(6)*CA(3)    ! SIN COS COS
       RETURN
       END
