      SUBROUTINE UPDATE
C  THIS PROGRAM LISTS THE CONTENTS OF MAG FILES AND DELETES AND
C  RESTORES REFLECTIONS FROM IT.
      CHARACTER*16 NFILE
      CHARACTER*2 NT(10)
      INTEGER*2 IDHKL(4),ID,IDD(100,2),ID1(200),IDEL(500),NDR(12),
     1 IRES(100,2),IRES1(200)
      CHARACTER*1 DASH(12),DSH
      DIMENSION REAL(13),CARD(20)
	COMMON IS1,IS2,IS3,IS4,IS5,IS6,SCF,B2,CARD,JPAGE,IT1,IT2
      COMMON/FNAME/NFILE,NAMLEN
      EQUIVALENCE(IDHKL(1),ID),(REAL(5),SPEED)
      ND=0
      DATA DSH/'-'/
      ND1=0
      NTOT=0
      LIST=0
      NOF=1
      NOL=80
      IUND=0
      ITYPE=0
      NRES=0
      NRES1=0
      NMAG=13  ! MAG FILE UNIT NUMBER
      NSCR=20  ! SCRATCH FILE UNIT NUMBER
      DECODE(80,101,CARD)NT
C   READING IN TITLE CARD - NT HOLDS VERSION NUMBERS OF MAG FILE.
C   DEFAULT IF NT IS BLANK IS HIGHEST VERSION MAG FILE ONLY.
C   NMT IS TOTAL NUMBER OF MAG FILES
101   FORMAT(7X,10A2)
      DO 102 I=1,10
      IF(NT(I).EQ.'  ')GOTO 103
102   CONTINUE
103   NMT=I-1
C  NMT IS TOTAL NUMBER OF MAG FILES ENTERED.
1030  READ(1,104)CARD
104   FORMAT(20A4)
      IF(CARD(1).EQ.'DELE')GOTO 110  !DELETE
      IF(CARD(1).EQ.'LIST')GOTO 120   ! REQUEST LISTING OF MAG FILE
      IF(CARD(1).EQ.'REST')GOTO 122  ! RESTORE
      IF(CARD(1).NE.'END ')GOTO 901
      GOTO 125
110   DECODE(80,111,CARD)(NDR(I),DASH(I),I=1,12)
C   READING IN DELETE CARD - ND IS TOTAL NUMBER OF RANGES OF DELETES,
C   ND1 IS TOTAL NUMBER OF SINGLE DELETES.
111   FORMAT(7X,12(I5,A1))
      WRITE(3,112)(NDR(I),DASH(I),I=1,11),NDR(12)
112   FORMAT(1X,'DELETE',1X,11(I5,A1),I5)
      I=1
113   IF(NDR(I).EQ.0)GOTO 1030
      IF(DASH(I).EQ.DSH)THEN
C   DASH SYMBOLIZES RANGE OF IDS TO BE DELETED
      ND=ND+1
      IF(ND.GT.100)THEN
      ND=100   ! PREVENT ARRAY OVERFLOW
      WRITE(3,114)NDR(I)
114   FORMAT(' DELETION ARRAY OVERFLOW - REFLECTION NO. ',I5,' NOT',
     1' DELETED.')
      ENDIF
      IDD(ND,1)=NDR(I)
      IDD(ND,2)=NDR(I+1)
      I=I+2
      ELSE
C   SINGLE ID TO BE DELETED
      ND1=ND1+1
      IF(ND1.GT.200)THEN
      ND1=200  ! PREVENT ARRAY OVERFLOW
      WRITE(3,114)NDR(I)
      ENDIF
      ID1(ND1)=NDR(I)
      I=I+1
      ENDIF
      IF(I.LE.12)GOTO 113
      GOTO 1030
120   LIST=1
C   LIST=1 MEANS LISTING OF MAG FILE DESIRED
      GOTO 1030
122   IF(CARD(3).EQ.'ALL ')THEN
      IUND=1
      WRITE(3,1220)
1220  FORMAT(' ALL REFLECTIONS RESTORED.')
C  IUND=1 MEANS RESTORE ALL PREVIOUSLY DELETED REFLECTIONS
      GOTO 1030
      ENDIF
      DECODE(80,111,CARD)(NDR(I),DASH(I),I=1,11),NDR(12)
C  RESTORING GROUP OF REFLECTIONS OR SINGLE REFLECTIONS - NOT ALL
      WRITE(3,123)(NDR(I),DASH(I),I=1,11),NDR(12)
123   FORMAT('RESTORE',11(I5,A1),I5)
      I=1
124   IF(NDR(I).EQ.0)GOTO 1030
      IF(DASH(I).EQ.DSH)THEN
C  RESTORING GROUP OF REFLECTIONS
C  DASH SIGNIFIES A GROUP
      NRES=NRES+1
      IF(NRES.GT.100)THEN
C  PREVENT ARRAY OVERFLOW
      NRES=100
      WRITE(3,1240)NDR(I)
1240  FORMAT(' RESTORATION ARRAY OVERFLOW - REFLECTION # ',I5,' NOT',
     1' RESTORED.')
      ENDIF
      IRES(NRES,1)=NDR(I)
      IRES(NRES,2)=NDR(I+1)
      I=I+2
      ELSE
C  SINGLE REFLECTION TO BE RESTORED
      NRES1=NRES1+1
      IF(NRES1.GT.200)THEN
C  PREVENT ARRAY OVERFLOW
      NRES1=200
      WRITE(3,1240)NDR(I)
      ENDIF
      IRES1(NRES1)=NDR(I)
      I=I+1
      ENDIF
      IF(I.LE.12)GOTO 124
      GOTO 1030
125   N=NAMLEN+1
      NFILE(N:N+4)='.MAG;'
      N=N+5
      IF(NMT.NE.0)NFILE(N:N+1)=NT(NOF)
      NOF=NOF+1
      OPEN(NAME=NFILE,UNIT=NMAG,TYPE='OLD',FORM='UNFORMATTED',
     1 BLOCKSIZE=32768)
C  OPENING MAG FILE
      OPEN(UNIT=NSCR,TYPE='NEW',FORM='UNFORMATTED',BLOCKSIZE=32768)
C  OPENING SCRATCH FILE
C  REFLECTIONS ARE READ IN FROM THE MAG FILE.  IF NECESSARY, CHANGES
C  ARE MADE (DELETE OR RESTORE).  THEN THE REFLECTIONS ARE COPIED
C  ONTO THE SCRATCH DISK.  AFTER ALL REFLECTIONS HAVE BEEN READ IN
C  AND ALL CHANGES HAVE BEEN MADE, THE ORIGINAL MAG FILE IS DELETED
C  AND THE SCRATCH FILE IS COPIED BACK AS THE NEW MAG FILE.
127   READ(NMAG,END=1450)IDHKL,REAL
      IF(ID.EQ.0)GOTO 145  !ID=0 MEANS LAST REFLECTION
      IF(SPEED.LT.0)THEN
C  SPEED < 0 MEANS REFLECTIONS WAS PREVIOUSLY DELETED - CHECK IF IT
C  HAS BEEN RESTORED, OTHERWISE DELETE
      IF(IUND.EQ.1)GOTO 129
C  IUND=1 MEANS ALL REFLECTIONS RESTORED
      IF(NRES.EQ.0)GOTO 128
      DO 128 I=1,NRES
C  SEEING IF IN ONE OF THE GROUPS OF IDS TO BE RESTORED
      IF(IABS(ID).GE.IRES(I,1).AND.IABS(ID).LE.IRES(I,2))GOTO 129
128   CONTINUE
      IF(NRES1.EQ.0)GOTO 1280
      DO 1280 I=1,NRES1
C  SEEING IF ONE OF THE SINGLE REFLECTIONS TO BE RESTORED
      IF(IABS(ID).EQ.IRES1(I))GOTO 129
1280  CONTINUE
C  HERE IF NOT RESTORED - INCLUDE IN LIST OF DELETED REFLECTIONS
C  AND DO KEEP NEGATIVE SCAN SPEED
      NTOT=NTOT+1
      IF(NTOT.GT.500)NTOT=500  ! PREVENT ARRAY OVERFLOW
      IDEL(NTOT)=ID
      GOTO 135
129   SPEED=-SPEED
C   HERE IF RESTORED - DO NOT DELETE AND CHANGE SCAN SPEED TO POSITIVE
      ENDIF
      IF(ND.EQ.0)GOTO 130
C  ND IS NUMBER OF RANGES OF DELETED REFLECTIONS
      DO 130 I=1,ND
C   CHECKING IF ID IS IN ONE OF THE RANGES OF IDS TO BE DELETED
      IF(IABS(ID).LT.IDD(I,1))GOTO 130
      IF(IABS(ID).GT.IDD(I,2))GOTO 130   ! IDD(I,1) CHANGED TO IDD(I,2)
      NTOT=NTOT+1                        ! AUG-6-1985  BJW
C  TOTAL NUMBER OF DELETED REFLECTIONS
      IF(NTOT.GT.500)NTOT=500   ! PREVENT ARRAY OVERFLOW
      IDEL(NTOT)=ID
      SPEED=-SPEED
C   DELETED IDS MARKED WITH NEGATIVE SCAN SPEED
      GOTO 135
130   CONTINUE
      IF(ND1.EQ.0)GOTO 135
C  ND1 IS NUMBER OF SINGLE DELETED IDS
      DO 133 I=1,ND1
C   CHECKING IF ID IS ONE OF SINGLE IDS TO BE DELTED
      IF(IABS(ID).NE.ID1(I))GOTO 133
      NTOT=NTOT+1
C  NTOT IS TOTAL NUMBER OF DELETED REFLECTIONS
      IF(NTOT.GT.500)NTOT=500  ! PREVENT ARRAY OVERFLOW
      IDEL(NTOT)=ID
      SPEED=-SPEED
C  DELETED REFLECTIONS MARKED ON MAG FILE WITH NEGATIVE SCAN SPEED
      GOTO 135
133   CONTINUE
135   IF(LIST.EQ.0)GOTO 143
C  LIST =1 IF REQUESTED LISTING OF TAPE CONTENTS
      NOL=NOL+1
C  NUMBER OF LINES
      IF(NOL.LT.80)GOTO 139
      IF(ITYPE.NE.0)GOTO 1350
      ITYPE=10
      IF(REAL(12).NE.0.0)ITYPE=12
C  ITYPE=10 FOR NO INTCOR, SIGCOR OR ABSCOEF ON MAG FILE YET.
C   ITYPE=12 IF INTCOR AND SIGCOR ARE ON MAG FILE (BGROUND2 HAS BEEN
C  RUN).  ITYPE=13 IF ABSCOEF IS ON MAG FILE (ABSORPTION HAS BEEN RUN.)
      IF(REAL(13).NE.0.0)ITYPE=13
1350  IF(ITYPE.EQ.10)WRITE(3,136)
      IF(ITYPE.EQ.12)WRITE(3,137)
      IF(ITYPE.EQ.13)WRITE(3,138)
136   FORMAT(1H1,'    ID     H     K     L    2TH    PHI     CHI  ',
     1'  RANGE  SPEED     B1      SCAN      B2    EXPTM  TB/TS',/)
137   FORMAT(1H1,'    ID     H     K     L    2TH    PHI     CHI  ',
     1'  RANGE  SPEED     B1      SCAN      B2    EXPTM  TB/TS',
     2'   INTCOR   SIGCOR ',/)
138   FORMAT(1H1,'    ID     H     K     L    2TH    PHI     CHI  ',
     1'  RANGE  SPEED     B1      SCAN      B2    EXPTM  TB/TS',
     2'   INTCOR   SIGCOR ABSCOEF',/)
      NOL=0
139   WRITE(3,140)IDHKL,(REAL(I),I=1,ITYPE)
140   FORMAT(1X,4I6,F7.2,3F8.2,F7.2,F8.0,F10.0,F8.0,F8.2,F6.2,F11.2,
     1 F8.2,F7.2)
143   WRITE(NSCR)IDHKL,REAL
C  WRITING REFLECTION ON SCRATCH DISK
      GOTO 127
1450  IDHKL(1)=0
145   WRITE(NSCR)IDHKL,REAL
C  WRITING LAST REFLECTION (DUMMY REFLECTION WITH ID=0) ON SCRATCH DISK
      NCHANGE=ND+ND1+NRES+NRES1+IUND
C  IF NO CHANGES TO MAG FILE, NO NEED TO RECOPY IT FROM SCRATCH DISK
      IF(NCHANGE.EQ.0)THEN
      CLOSE(UNIT=NMAG,DISP='SAVE')
      CLOSE(UNIT=NSCR,DISP='DELETE')
      ELSE
C  CHANGES ON MAG FILE - RECOPY FROM SCRATCH
      CLOSE(UNIT=NMAG,DISP='DELETE')
C  DELETING ORIGINAL MAG FILE
      REWIND NSCR
C  REWINDING SCRATCH DISK TO BEGIN COPYING SCRATCH DISK TO NEW MAG FILE
      OPEN(NAME=NFILE,UNIT=NMAG,TYPE='NEW',FORM='UNFORMATTED',
     1 BLOCKSIZE=32768)
C  OPENING NEW MAG FILE
146   READ(NSCR)IDHKL,REAL
      WRITE(NMAG)IDHKL,REAL
      IF(ID.NE.0)GOTO 146
      CLOSE(UNIT=NMAG,DISP='SAVE')
      CLOSE(UNIT=NSCR,DISP='DELETE')
      ENDIF
C  SCRATCH NOW COPIED TO MAG FILE - DELETE SCRATCH
      IF(NOF.LE.NMT)GOTO 125
C  ANY MORE MAG FILES REQUESTED?
      IF(NTOT.EQ.0)GOTO 150
C  LISTING ALL REFLECTIONS NOW MARKED AS DELETED ON MAG FILE
      WRITE(3,147)
147   FORMAT(//,' THESE REFLECTIONS ARE MARKED AS DELETED ON THE MAG',
     1' FILE: ',/)
      IF(NTOT.EQ.500)WRITE(3,1470)
1470  FORMAT(' NOTE - ONLY THE FIRST 500 REFLECTIONS ARE LISTED.')
      I=0
148   I=I+1
      I1=15*I-14
      I2=15*I
      IF(I2.GT.NTOT)I2=NTOT
      WRITE(3,149)(IDEL(II),II=I1,I2)
149   FORMAT(1X,15I5)
      IF(I2.LT.NTOT)GOTO 148
150   RETURN
901   WRITE(3,902)
902   FORMAT(' UNRECOGNIZED COMMAND')
      WRITE(3,903)CARD
903   FORMAT(1X,20A4)
      STOP
      END
