      SUBROUTINE WILSO                                                  WI     1
C            WILSON STATISTICS AND STATISTICAL REFS PROGRAM             WI     3
C    EMPLOYING THE LEAST-SQUARES METHOD OF LEVY,H., ET AL,(CHEM. DIV.   WI     5
C    ANNUAL PROG. REPORT, OAK RIDGE NAT'L LAB., SEPT.,1970, P.135FF)    WI     6
C    WITH CYCLED WEIGHTS, AND INCLUDING A MODIFICATION OF THE PREVIOUS  WI     7
C    SUBROUTINE WILSO WRITTEN BY D. J. DUCHAMP..........H. M. EINSPAHR  WI     8
      REAL*4   NSUM,KAYO,MODE,ISO                                       WI    10
      DIMENSION  A(12),FF(12),CARD(20),SPACE(31),CARDF(31),CHK(10)      WI    11
      DIMENSION  NZUM(11),WZUM(11),FZUM(11),SZSUM(11),X(10),Y(10)       WI    12
      DIMENSION  EPS(14),SSNV(14),ICF(230)
      DIMENSION AB(7),CAO(7),HO(7,7),PACE(13),SIG(7),DAO(7)             WI    14
      COMMON IS1,IS2,IS3,IS4,IS5,IS6,SCF,B2,CARD,JPAGE,IT1,IT2          WI    15
      DATA PLOT/4HPLOT/
      DATA ANISO/4HANIS/                                                WI    18
      DATA ISO/4HISO /                                                  WI    19
      DATA ONLY/4HONLY/                                                 WI    20
      DATA BLANK/4H    /                                                WI    21
      DATA ICF/1,1,1,1,2,1,1,2,2,1,1,2,1,1,2,1,1,1,1,2,
     1 2,4,2,2,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,
     2 2,4,4,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
     3 1,1,2,2,2,2,2,2,4,4,2,2,2,2,1,1,1,1,2,2,
     4 1,2,1,1,1,1,2,2,1,1,1,1,1,1,1,1,2,2,1,1,
     5 1,1,1,1,1,1,2,2,2,2,1,1,1,1,1,1,1,1,2,2,
     6 2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,
     7 2,2,1,1,1,3,1,3,1,1,1,1,1,1,3,1,1,1,1,3,
     8 3,1,1,1,1,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,
     9 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,4,2,1,2,1,
     1 1,4,4,2,1,2,1,1,4,4,2,1,1,2,1,4,2,1,4,2,
     2 1,1,1,1,4,4,4,4,2,2/
C    FORMAT LIBRARY.                                                    WI    23
  177 FORMAT(3I6,F8.2,F8.2,3F8.4,2F8.2)                                 WI    25
  178 FORMAT(3I5,F10.5)                                                 WI    26
180   FORMAT('NUMBERS OF ATOMS',I4,12F4.0,I2,F2.0,I2)
  181 FORMAT(   75H1     H     K     L   SHARP     F       E     E**2   WI    28
     1  U    (E2-1)2 (E2-1)3 /)                                         WI    29
C 182 FORMAT(40X,F8.4)                                                        30
182   FORMAT(7X,A4,2X,A4,F8.4,1X,2F10.2)
  183 FORMAT (20A4)                                                     WI    31
  185 FORMAT(/,20X,'CENTRIC       OBS  ACENTRIC'/,12X,'<|E|>     0.798',WI    32
     1F10.3,'     0.886'/,13X,'<E2>     1.000',F10.3,'     1.000'/,     WI    33
     29X,'<|E2-1|>     0.968',F10.3,'     0.736'/,10X,'|E|>1,%      32.0WI    34
     3',F10.1,'      36.8'/,10X,'|E|>2,%       5.0',F10.1,'       1.8'/,WI    35
     410X,'|E|>3,%       0.3',F10.1,'      0.01'//,20X,'NO=',I6,/)      WI    36
186    FORMAT(' NUMBERS OF ATOMS ',I4,12F5.0,5X,I2,F5.0,I5,/)
  187 FORMAT(//14X,'ZERO MOMENT OF HOWELLS, PHILLIPS, AND ROGERS'//     WI    38
     141X,'Z'/                                                          WI    39
     212X,'0.1    0.2    0.3    0.4    0.5    0.6    0.7    0.8    0.9  WI    40
     3  1.0    1.2    1.4    1.6    2.0    2.4    2.8'/                       41
     4' CENTRIC    0.248  0.345  0.419  0.474  0.520  0.561  0.597  0.6201    42
     59  0.657  0.683  0.727  0.763  0.794  0.843  0.879  0.906'/       01    43
     6' OBSERVED ',16F7.3,/                                                   44
     7' ACENTRIC   0.095  0.181  0.259  0.330  0.394  0.451  0.503  0.55WI    45
     81  0.593  0.632  0.699  0.753  0.798  0.865  0.909  0.939',/)           46
  305 FORMAT(9H0   2B = F6.2,5X,9H S(2B) = F6.2//9H     K = F8.4,3X,9H SWI    47
     1(K)  = F8.4)                                                      WI    48
  306 FORMAT(36H0 SCALE FACTOR, K, IS FOR F(OBS)     ////)              WI    49
  307 FORMAT('0    N   SSQLS      OBS      CAL'/)                       WI    50
  308 FORMAT('0',I6,F9.5,F9.3,F9.3)                                     WI    51
C 500 FORMAT(4X,3I6,F8.2,F8.5)                                          WI    52
  511 FORMAT(1X,'WHAT KIND OF SPACE GROUP HAS NO.',I4,'?  YOU BOMBED.') WI    53
  512 FORMAT('CUBICS HAVE ISOTROPIC OVER-ALL TEMP FACTOR.  STOP.',/)    WI    54
  513 FORMAT(1X,'PARAMETERS USED FOR STATISTICS ARE EITHER THOSE FROM WIWI    55
     1LSON PLOT OR THOSE INPUT AS INITIAL VALUES.')                     WI    56
  514 FORMAT(1X,'PARAMETERS USED FOR STATISTICS ARE EITHER THOSE FROM ISWI    57
     1OTROPIC REFINEMENT OR THOSE INPUT AS INITIAL VALUES.')            WI    58
  640 FORMAT(22X,'HKL',2X,'HKO',2X,'HOL',2X,'OKL',2X,'HOO',2X,'OKO',2X, WI    59
     1'OOL',/,10X,'EPSILON',3X,7F5.1)                                   WI    60
  641 FORMAT(10X,'VARIANCE',2X,7F5.1,/,9X,'(THE VARIANCE OF THE F**2 DISWI    61
     1TRIBUTION IS 2 IF CENTRIC, 1 IF ACENTRIC.)',/)                    WI    62
  643 FORMAT(22X,'HKL',2X,'HKO',2X,'HOL',2X,'OKL',2X,'HOO',2X,'OKO',2X, WI    63
     1'OOL',2X,'HHL',2X,'HHO',/,10X,'EPSILON',3X,9F5.1)                 WI    64
  644 FORMAT(10X,'VARIANCE',2X,9F5.1,/,9X,'(THE VARIANCE OF THE F**2 DISWI    65
     1TRIBUTION IS 2 IF CENTRIC, 1 IF ACENTRIC.)',/)                    WI    66
  648 FORMAT(22X,'HKL',2X,'HKO',2X,'HOL',2X,'OKL',2X,'HOO',2X,'OKO',2X, WI    67
     1'OOL',2X,'HHL',2X,'HHO',2X,'HKH',2X,'HOH',2X,'HKK',2X,'OKK',2X,'HHWI    68
     2H',/,10X,'EPSILON',3X,14F5.1)                                     WI    69
  649 FORMAT(10X,'VARIANCE',2X,14F5.1,/,9X,'(THE VARIANCE OF THE F**2 DIWI    70
     1STRIBUTION IS 2 IF CENTRIC, 1 IF ACENTRIC.)',/)                   WI    71
  698 FORMAT(18F4.0)                                                    WI    72
  705 FORMAT(24X,'HKO',7X,'HOL',7X,'OKL',/,12X,'<|E|>',3F10.3/,13X,'<E2>WI    73
     1',3F10.3/,9X,'<|E2-1|>',3F10.3/,6X,'<(E2-1)**2>',3F10.3/,6X,      WI    74
     2'<(E2-1)**3>',3F10.3/,6X,'NO. OF DATA',3(5X,F5.0),/)              WI    75
  708 FORMAT(1X,'FOR THE HHL ZONE, <|E|>',F10.3/,20X,'<E2>',F10.3/,16X,'WI    76
     1<|E2-1|>',F10.3/,13X,'<(E2-1)**2>',F10.3/,13X,'<(E2-1)**3>',F10.3/WI    77
     2,13X,'NO. OF DATA',5X,F5.0,/)                                     WI    78
  710 FORMAT(///,1X,'THE END',/,1H1)                                    WI    79
  711 FORMAT(10X,'<(E2-1)**2>=',F10.3,' ,<(E2-1)**3>=',F10.3,/,10X,'FOR WI    80
     1THEORETICAL VALUES OF THE ABOVE, SEE HAUPTMAN,H.,ET AL.(1969). ACTWI    81
     2A CRYST. B25,811.',//)                                            WI    82
  712 FORMAT(1X,'ZONAL STATISTICS',/)                                   WI    83
  720 FORMAT(1X,'FOR 3-D DATA ONLY,<|E|>',F10.3/,20X,'<E2>',F10.3/,16X,'WI    84
     1<|E2-1|>',F10.3/,13X,'<(E2-1)**2>',F10.3/,13X,'<(E2-1)**3>',F10.3/WI    85
     2,13X,'NO. OF DATA',5X,F5.0,/)                                     WI    86
  723 FORMAT(24X,'HHL',7X,'HKH',7X,'HKK',/,12X,'<|E|>',3F10.3/,13X,'<E2>WI    87
     1',3F10.3/,9X,'<|E2-1|>',3F10.3/,6X,'<(E2-1)**2>',3F10.3/,6X,      WI    88
     2'<(E2-1)**3>',3F10.3/,6X,'NO. OF DATA',3(5X,F5.0),/)              WI    89
  750 FORMAT(2X,'INPUT PARAMETERS ARE K=',F8.4,'   , AND 2B=',F8.4,/)   WI    90
  751 FORMAT(1X,'STARTING VALUES FOR LEAST SQUARES ARE 1/K2=',F10.4,3X, WI    91
     1'AND 2B=',F10.4,/)                                                WI    92
C 752 FORMAT(A4,16X,2F10.2,6X,A4,6X,A4,I2)                              WI    93
752   FORMAT(A4,1X,2F10.2,1X,A4)
  753 FORMAT(1H1,'ISOTROPIC REFINEMENT',/)                              WI    94
  754 FORMAT(1H1,'ANISOTROPIC REFINEMENT',/)                            WI    95
  755 FORMAT(1X,'STARTING VALUES ARE',6X,'1/K2',6X,'B11',7X,'B22',7X,'B3WI    96
     13',7X,'B12',7X,'B13',7X,'B23',/,21X,7F10.5,/)                     WI    97
  756 FORMAT(1X,'START',5X,' K ',8X,'2B',5X,'MODE',/,
     11X,A4,1X,2F10.4,3X,A4)
  757 FORMAT(1X,'START',3X,'MAX2THETA',4X,'LAMBDA',3X,'MODE',/,
     11X,A4,3X,F10.2,F10.4,3X,A4)
  800 FORMAT(/,1X,'END OF DATA',/,1H1,'TABULATION OF E-STATISTICS',//)  WI   102
  801 FORMAT(//,1X,'MAY I HAVE THE ENVELOPE PLEASE?  THE WINNERS ARE',/)WI   103
  900 FORMAT(/,23X,'1/K2',6X,'B11',7X,'B22',7X,'B33',7X,'B12',7X,'B13',7WI   104
     1X,'B23')                                                          WI   105
  901 FORMAT(12X,'SHIFTS',7F10.5)                                       WI   106
  902 FORMAT(8X,'NEW VALUES',7F10.5)                                    WI   107
  903 FORMAT(12X,'SIGMAS',7F10.5,//)                                    WI   108
  904 FORMAT(1X,'REFINEMENT NOT CONVERGING TOWARD AN ELLIPSOID.  STOP.')WI   109
  905 FORMAT(6X,'FINAL VALUES',7F10.5)                                  WI   110
  906 FORMAT(/,23X,'  K ',6X,'B11',7X,'B22',7X,'B33',7X,'B12',7X,'B13',7WI   111
     1X,'B23')                                                          WI   112
C 907 FORMAT(//,1X,'* * NONPOSITIVE DEFINITE.  CHECK ANISO CARD. * *')  WI   113
C 951 FORMAT('ANISO',7X,6F10.7)                                         WI   114
C 953 FORMAT(12X,6F10.7)                                                WI   115
C 961 FORMAT(1X,'INPUT PARAMETERS ARE',6X,' K ',6X,'B11',7X,'B22',7X,'B3WI   116
C    13',7X,'B12',7X,'B13',7X,'B23',/,21X,7F10.5,/)                     WI   117
 2753 FORMAT(1H1,'WILSON PLOT',/)                                       WI   118
 3000 FORMAT(14X,'SHIFTS',2F10.4)                                       WI   119
 3001 FORMAT(10X,'NEW VALUES',2F10.4)                                   WI   120
 3002 FORMAT(1X,'FOR CYCLE',I2,',THE VALUE OF THE FUNCTION MINIMIZED IS'WI   121
     1,F15.2)                                                           WI   122
 3003 FORMAT(14X,'SIGMAS',2F10.4,//)                                    WI   123
 3004 FORMAT(1X,'NO. OF DATA =',F8.0,' ; NO. OF PARAMETERS =',I2,/)     WI   124
 3504 FORMAT(1X,'* * * * * *DIVERGENCE.  TAPE NOT UPDATED.* * * * * *') WI   125
 3555 FORMAT(/,25X,'1/K2',5X,'  2B')                                    WI   126
 3901 FORMAT(1X,'CONVERGENCE NOT ACHIEVED.  RESUBMIT W/ NEW VALUES FOR PWI   127
     1ARAMETERS OR GIVE UP. TAPE NOT UPDATED. SORRY.')                  WI   128
C                                                                       WI   129
C    PRIMARY INITIALIZATION.                                            WI   130
C                                                                       WI   131
      NDISK=0                                                           WI   132
      IPNCH=0                                                           WI   133
      IPRNT=0
      NREF=0
      INREF=-1
      NCNV=0              ! SIGNAL FOR CONVERGENCE IS ANISO CALC.
      NHU=0                                                             WI   134
      MINH=0                                                            WI   135
      NGO=1                                                             WI   136
      KY=0                                                              WI   137
      MDE=IS1-6  ! MDE=1 FOR WILSON.  WILL BE SET TO 0 IF NO UPDATE
C   MDE=0 IS OLD STATISTICAL REFLECTIONS
      ESUM=0.0                                                          WI   139
      EQSUM=0.0                                                         WI   140
      EQMS=0.0                                                          WI   141
      EOKL=0.0                                                          WI   142
      EQOKL=0.0                                                         WI   143
      EMOKL=0.0                                                         WI   144
      E2OKL=0.0                                                         WI   145
      E3OKL=0.0                                                         WI   146
      EHOL=0.0                                                          WI   147
      EQHOL=0.0                                                         WI   148
      EMHOL=0.0                                                         WI   149
      E2HOL=0.0                                                         WI   150
      E3HOL=0.0                                                         WI   151
      EHKO=0.0                                                          WI   152
      EQHKO=0.0                                                         WI   153
      EMHKO=0.0                                                         WI   154
      E2HKO=0.0                                                         WI   155
      E3HKO=0.0                                                         WI   156
      THKO=0.0                                                          WI   157
      THOL=0.0                                                          WI   158
      TOKL=0.0                                                          WI   159
      EHKL=0.0                                                          WI   160
      EQHKL=0.0                                                         WI   161
      EMHKL=0.0                                                         WI   162
      E2HJL=0.0                                                         WI   163
      E3HJL=0.0                                                         WI   164
      THKL=0.0                                                          WI   165
      E1=0.0                                                            WI   166
      E2=0.0                                                            WI   167
      E3=0.0                                                            WI   168
      E2HKL=0.0                                                         WI   169
      E3HKL=0.0                                                         WI   170
      IHPR1=0                                                           WI   171
      IHPR2=0                                                           WI   172
      IHPR3=0                                                           WI   173
      IHPR4=0                                                           WI   174
      IHPR5=0                                                           WI   175
      IHPR6=0                                                           WI   176
      IHPR7=0                                                           WI   177
      IHPR8=0                                                           WI   178
      IHPR9=0                                                           WI   179
      IHPR0=0                                                           WI   180
      IHPR12=0                                                               181
      IHPR14=0                                                               182
      IHPR16=0                                                               183
      IHPR20=0                                                               184
      IHPR24=0                                                               185
      IHPR28=0                                                               186
      GO TO 30                                                          WI   187
  504 EHHL=0.0                                                          WI   188
      EQHHL=0.0                                                         WI   189
      EMHHL=0.0                                                         WI   190
      E2HHL=0.0                                                         WI   191
      E3HHL=0.0                                                         WI   192
      THHL=0.0                                                          WI   193
      IF(NLAUE.LE.16) GO TO 505                                         WI   194
      IF(NGP.LE.194) GO TO 630                                          WI   195
      EHKH=0.0                                                          WI   196
      EQHKH=0.0                                                         WI   197
      EMHKH=0.0                                                         WI   198
      E2HKH=0.0                                                         WI   199
      E3HKH=0.0                                                         WI   200
      THKH=0.0                                                          WI   201
      EHKK=0.0                                                          WI   202
      EQHKK=0.0                                                         WI   203
      EMHKK=0.0                                                         WI   204
      E2HKK=0.0                                                         WI   205
      E3HKK=0.0                                                         WI   206
      THKK=0.0                                                          WI   207
      GO TO 630                                                         WI   208
C    READ IS FROM ARRAY 'CARD'.                                         WI   210
C   30 CALL INCORE(CARD,80)                                              WI   212
C 30	DECODE(80,182,CARD)EMIN
30    DECODE(80,182,CARD)APRNT,AOUT,EMIN,Q,QQ
C      READ(5,182) EMIN                                                  WI   213
C     CALL INCORE                                                       WI   214
C     IF(EMIN.EQ.0.0)EMIN=100.                                          WI   215
C    READ AND STORE NUMBERS OF ATOMS,OUTPUT CODE,C,I,OR F CENTERING     WI   217
C    FACTOR, AND SPACE GROUP NUMBER.                                    WI   218
C     IF(CARD(7).NE.BLANK) IPNCH=1                                      WI   220
      IF(AOUT.NE.BLANK)IPNCH=1
      IF(APRNT.NE.BLANK)IPRNT=1
      IF(IPNCH.EQ.1.AND.EMIN.EQ.0.0)EMIN=1.2
      IF(Q.NE.0.0.OR.QQ.NE.0.0)THEN
      QQ=QQ*2.
C  OLD "STATISTICAL REFLECTIONS".  SCALE AND TEMP FACTORS ARE KNOWN.
      IS1=0
      MDE=IS1
      ENDIF
   70 READ(1,180)NGP,(A(K),K=1,12),IT,CIF,NRE 
      WRITE(3,186)NGP,(A(K),K=1,12),IT,CIF,NRE 
      IF(CIF.EQ.0.0)CIF=ICF(NGP)
C    SET UP EPSILON AND VARIANCE ARRAYS ACCORDING TO SPACE GROUP NUMBER.WI   225
C    ARRAYS PREPARED AUTOMATICALLY FOR SPACE GROUP NOS. 1 THROUGH 142.  WI   226
C    ORTHORHOMBIC AND TETRAGONAL GROUPS MUST HAVE STANDARD SETTINGS.    WI   227
C    B AXIS MUST BE UNIQUE FOR MONOCLINIC GROUPS.  ARRAYS MUST BE INPUT WI   228
C    (USING FORMAT NO. 698) FOR TRIGONAL, HEXAGONAL AND CUBIC GROUPS.   WI   229
C    TRIGONAL GROUPS MUST USE HEXAGONAL AXES (AND, WHERE NECESSARY,     WI   230
C    CIF=3.0).                                                          WI   231
      IF(NGP.LE.0.OR.NGP.GT.230) GO TO 510                              WI   233
      IF(NGP.GT.142) GO TO 699                                          WI   234
      IF(NRE.NE.0) GO TO 699                                            WI   235
      NCBC=7                                                            WI   236
      NLAUE=1                                                           WI   237
      IF(NGP.GT.122) NLAUE=NLAUE+1                                      WI   238
      IF(NGP.LE.110) GO TO 501                                          WI   239
      NGP=NGP-110                                                       WI   240
      IF(NGP.GT.12) GO TO 502                                           WI   241
      GO TO (502,502,502,502,503,503,503,503,503,503,502,502), NGP      WI   242
  503 NLAUE=NLAUE+2                                                     WI   243
  502 NLAUE=NLAUE+1                                                     WI   244
      NGP=NGP+110                                                       WI   245
  501 IF(NGP.GT.98) NLAUE=NLAUE+1                                       WI   246
      IF(NGP.GT.88) NLAUE=NLAUE+1                                       WI   247
      IF(NGP.GT.82) NLAUE=NLAUE+1                                       WI   248
      IF(NGP.GT.80) NLAUE=NLAUE+1                                       WI   249
      IF(NGP.GT.74) NLAUE=NLAUE+1                                       WI   250
      IF(NGP.GT.74) NCBC=9                                              WI   251
      IF(NGP.GT.46) NLAUE=NLAUE+1                                       WI   252
      IF(NGP.GT.24) NLAUE=NLAUE+1                                       WI   253
      IF(NGP.GT.15) NLAUE=NLAUE+1                                       WI   254
      IF(NGP.GT.9) NLAUE=NLAUE+1                                        WI   255
      IF(NGP.GT.5) NLAUE=NLAUE+1                                        WI   256
      IF(NGP.GT.2) NLAUE=NLAUE+1                                        WI   257
      IF(NGP.GT.1) NLAUE=NLAUE+1                                        WI   258
      IF(NLAUE.GT.8) GO TO 504                                          WI   259
  505 GO TO (601,602,601,601,602,602,601,602,601,602,602,602,601,602,602WI   260
     1,602), NLAUE                                                      WI   261
  601 DO 603 I=1,9                                                      WI   262
  603 SSNV(I)=1.0                                                       WI   263
      GO TO 610                                                         WI   264
  602 DO 604 I=1,9                                                      WI   265
  604 SSNV(I)=2.0                                                       WI   266
  610 GO TO (611,611,611,611,612,612,612,612,611,611,611,611,612,612,612WI   267
     1,612), NLAUE                                                      WI   268
  611 DO 613 I=2,9                                                      WI   269
  613 EPS(I)=1.0                                                        WI   270
      GO TO 620                                                         WI   271
  612 DO 614 I=2,9                                                      WI   272
  614 EPS(I)=2.0                                                        WI   273
  620 EPS(1)=CIF                                                        WI   274
      GO TO (630,630,633,634,635,636,637,638,621,622,623,624,625,626,627WI   275
     1,628), NLAUE                                                      WI   276
  633 SSNV(3)=2.0                                                       WI   277
      SSNV(5)=2.0                                                       WI   278
      SSNV(7)=2.0                                                       WI   279
      EPS(6)=2.0                                                        WI   280
      GO TO 630                                                         WI   281
  634 SSNV(6)=2.0                                                       WI   282
      EPS(3)=2.0                                                        WI   283
      EPS(5)=2.0                                                        WI   284
      EPS(7)=2.0                                                        WI   285
      GO TO 630                                                         WI   286
  635 EPS(2)=1.0                                                        WI   287
      EPS(4)=1.0                                                        WI   288
      GO TO 630                                                         WI   289
  636 SSNV(1)=1.0                                                       WI   290
      EPS(2)=1.0                                                        WI   291
      EPS(3)=1.0                                                        WI   292
      EPS(4)=1.0                                                        WI   293
      GO TO 630                                                         WI   294
  637 SSNV(2)=2.0                                                       WI   295
      SSNV(5)=2.0                                                       WI   296
      SSNV(6)=2.0                                                       WI   297
      EPS(2)=1.0                                                        WI   298
      EPS(7)=4.0                                                        WI   299
      GO TO 630                                                         WI   300
  638 EPS(5)=4.0                                                        WI   301
      EPS(6)=4.0                                                        WI   302
      EPS(7)=4.0                                                        WI   303
      GO TO 630                                                         WI   304
  621 SSNV(2)=2.0                                                       WI   305
      SSNV(5)=2.0                                                       WI   306
      SSNV(6)=2.0                                                       WI   307
      SSNV(9)=2.0                                                       WI   308
      EPS(7)=4.0                                                        WI   309
      GO TO 630                                                         WI   310
  622 SSNV(1)=1.0                                                       WI   311
      SSNV(3)=1.0                                                       WI   312
      SSNV(4)=1.0                                                       WI   313
      SSNV(8)=1.0                                                       WI   314
      EPS(7)=2.0                                                        WI   315
      GO TO 630                                                         WI   316
  623 EPS(2)=2.0                                                        WI   317
      EPS(5)=2.0                                                        WI   318
      EPS(6)=2.0                                                        WI   319
      EPS(7)=4.0                                                        WI   320
      EPS(9)=2.0                                                        WI   321
      GO TO 630                                                         WI   322
  624 SSNV(1)=1.0                                                       WI   323
      EPS(5)=2.0                                                        WI   324
      EPS(6)=2.0                                                        WI   325
      EPS(7)=4.0                                                        WI   326
      EPS(9)=2.0                                                        WI   327
      GO TO 630                                                         WI   328
  625 SSNV(2)=2.0                                                       WI   329
      SSNV(5)=2.0                                                       WI   330
      SSNV(6)=2.0                                                       WI   331
      SSNV(9)=2.0                                                       WI   332
      EPS(2)=1.0                                                        WI   333
      EPS(7)=8.0                                                        WI   334
      GO TO 630                                                         WI   335
  626 SSNV(1)=1.0                                                       WI   336
      SSNV(8)=1.0                                                       WI   337
      EPS(2)=1.0                                                        WI   338
      EPS(3)=1.0                                                        WI   339
      EPS(4)=1.0                                                        WI   340
      EPS(7)=4.0                                                        WI   341
      GO TO 630                                                         WI   342
  627 EPS(5)=4.0                                                        WI   343
      EPS(6)=4.0                                                        WI   344
      EPS(7)=8.0                                                        WI   345
      EPS(9)=4.0                                                        WI   346
      GO TO 630                                                         WI   347
  628 SSNV(1)=1.0                                                       WI   348
      SSNV(3)=1.0                                                       WI   349
      SSNV(4)=1.0                                                       WI   350
      EPS(2)=1.0                                                        WI   351
      EPS(7)=4.0                                                        WI   352
      EPS(8)=1.0                                                        WI   353
      GO TO 630                                                         WI   354
  510 WRITE(3,511) NGP                                                  WI   355
      GO TO 351                                                         WI   356
  630 DO 642 I=2,NCBC                                                   WI   357
  642 EPS(I)=EPS(I)*EPS(1)                                              WI   358
      GO TO 645                                                         WI   359
  699 NCBC=7                                                            WI   360
      EPS(1)=CIF                                                        WI   361
      IF(NGP.GT.74) NCBC=9                                              WI   362
      IF(NGP.GT.194) NCBC=14                                            WI   363
      READ(1,698)(EPS(I),I=2,NCBC)                                      WI   364
      READ(1,698)(SSNV(I),I=1,NCBC)                                     WI   365
      DO 515 I=1,NCBC                                                   WI   366
      IF(EPS(I).EQ.0.0) EPS(I)=1.0                                      WI   367
  515 IF(SSNV(I).EQ.0.0) SSNV(I)=1.0                                    WI   368
      IF(NCBC.LE.7) GO TO 630                                           WI   369
      NLAUE=17                                                          WI   370
      GO TO 504                                                         WI   371
  645 IF(NCBC.GT.9) GO TO 680                                           WI   372
      IF(NCBC.GT.7) GO TO 646                                           WI   373
      WRITE(3,640)(EPS(I),I=1,7)                                        WI   374
      WRITE(3,641)(SSNV(I),I=1,7)                                       WI   375
      GO TO 647                                                         WI   376
  646 WRITE(3,643)(EPS(J),J=1,9)                                        WI   377
      WRITE(3,644)(SSNV(J),J=1,9)                                       WI   378
      GO TO 647                                                         WI   379
  680 WRITE(3,648)(EPS(J),J=1,NCBC)                                     WI   380
      WRITE(3,649)(SSNV(J),J=1,NCBC)                                    WI   381
C647	CALL NAMTB(CARD)
647	CONTINUE
      IT3=6                                                             WI   383
      NNNN=1                                                            WI   384
      NSHIFT=0                                                          WI   385
      IF(MDE.EQ.0)GOTO 953
C   TEMP AND SCALE FACTORS ALREADY KNOWN FROM TITLE CARD - NO NEXT
C CARD NEEDED.
C
C    IF START=INIT, READ INITIAL VALUES FOR ISOTROPIC REFINEMENT.       WI   387
C    IF START=USE, READ MAX TWOTHETA AND LAMBDA FOR WILSON PLOT.        WI   388
C    MODE=ONLY GIVES WILSON PLOT ALONE.                                 WI   389
C    29JAN86 I AM TRYING TO RESTOR THE MODE=ONLY OPTION WITH OR
C                                      WITHOUT UPGRADE.    BJW
C    MODE=ISO OR BLANK CALLS FOR ISOTROPIC REFINEMENT.                  WI   390
C    MODE=ANISO CALLS FOR ANISO REFINEMENT OF ISO RESULTS, OR, IF HUE = WI   391
C    ONLY, FOR ANISO REFINEMENT OF ISO VALUES INPUT USING START=INIT.   WI   392
C     READ(1,752) START,Q,QQ,MODE,HUE,MARK                              WI   394
      READ(1,752)START,Q,QQ,MODE
C     IF(START.EQ.USE) GO TO 2000                                       WI   395
      IF(START.EQ.PLOT)GOTO 2000
C953   IF(MODE.NE.ANISO) MODE=ISO                                        WI   396
953    IF(MODE.NE.ANISO)THEN
       IF(MODE.NE.ONLY)MODE=ISO
       ENDIF
      WRITE(3,756) START,Q,QQ
      SCF=Q                                                             WI   398
C     IF(MODE.EQ.ANISO.AND.HUE.EQ.ONLY.AND.MARK.NE.0) GO TO 950         WI   399
      B2=QQ                                                             WI   400
      WRITE(3,750) SCF,B2                                               WI   401
      KAYO=1.0/(SCF*SCF)                                                WI   402
      SFQSR=KAYO                                                        WI   403
      TOBE=B2                                                           WI   404
      IF(MDE.EQ.0) GO TO 6013                                           WI   405
C     IF(MODE.EQ.ANISO.AND.HUE.EQ.ONLY) NHU=-1                          WI   406
      IF(NHU.EQ.-1) GO TO 136                                           WI   407
 2001 WRITE(3,753)                                                      WI   408
      WRITE(3,751) KAYO,TOBE                                            WI   409
      GO TO 136                                                         WI   410
C 950 READ(1,953)(AB(J),J=2,7)                                          WI   411
C     CALL FLIP(AB)                                                     WI   412
C     CALL THERMO(AB,KY)                                                WI   413
C     IF(KY.NE.0) WRITE(3,907)                                          WI   414
C     IF(KY.NE.0) GO TO 351                                             WI   415
C     CALL FLIP(AB)                                                     WI   416
C     IF(MDE.EQ.0) GO TO 960                                            WI   417
C     NHU=1                                                             WI   418
C     AB(1)=1.0/(SCF*SCF)                                               WI   419
C     GO TO 136                                                         WI   420
C 960 MINH=1                                                            WI   421
C     WRITE(3,961) SCF,(AB(J),J=2,7)                                    WI   422
C     GO TO 6013                                                        WI   423
C    SELECT PROPER STORAGE DEVICES (IT1,IT2,IT3) FOR READING AND WRITINGWI   425
C    OF DATA.                                                           WI   426
   36 IF(NHU.EQ.1) GO TO 6020                                           WI   428
  136 IF(MDE.EQ.1.AND.NDISK.EQ.1) GO TO 6020                            WI   429
      IF(MDE) 6010,6013,6010                                            WI   430
 6013 J=0                                                               WI   431
      IF(IT.EQ.0) GO TO 6011                                            WI   432
      IF(NDISK.EQ.0) IT3=IT1                                            WI   433
      GO TO 6020                                                        WI   434
 6011 IQQ=IT2                                                           WI   435
      IF(NDISK.EQ.0) GO TO 6012                                         WI   436
      IQ=IT3                                                            WI   437
      GO TO 6019                                                        WI   438
 6010 IQQ=IT3                                                           WI   439
 6012 IQ=IT1                                                            WI   440
      GO TO 6019                                                        WI   441
C    FIND FIRST REFLECTION ON STORAGE DEVICE.  GET ELEMENTS OF INVERSE  WI   443
C    METRIC IF ANISO.                                                   WI   444
 6019 REWIND IQ                                                         WI   446
      REWIND IQQ                                                        WI   447
      READ(IQ) SPACE                                                    WI   448
      WRITE(IQQ) SPACE                                                  WI   449
      IF(NHU.EQ.-1) GO TO 6021                                          WI   450
      READ(IQ) SPACE                                                    WI   451
      WRITE(IQQ) SPACE                                                  WI   452
   19 READ(IQ) SPACE                                                    WI   453
      WRITE(IQQ) SPACE                                                  WI   454
      IF(SPACE(1)) 19,21,19                                             WI   455
   21 DO 22 K=1,6                                                       WI   456
   22 SPACE(K)=0.0                                                      WI   457
      IF(MDE.EQ.0) GO TO 6030                                           WI   458
      IF(NHU.NE.0) GO TO 100                                            WI   459
      GO TO 6030                                                        WI   460
 6021 READ(IQ) FF,SHH,SKK,SLL,SKL,SHK,SHL,PACE                          WI   461
      WRITE(IQQ) FF,SHH,SKK,SLL,SKL,SHK,SHL,PACE                        WI   462
      NHU=1                                                             WI   463
      GO TO 19                                                          WI   464
 6020 REWIND IT3                                                        WI   465
      READ(IT3) SPACE                                                   WI   466
      IF(NHU.EQ.1.AND.NGO.EQ.1) GO TO 6121                              WI   467
      READ(IT3) SPACE                                                   WI   468
 6219 READ(IT3) SPACE                                                   WI   469
      IF(SPACE(1)) 6219,6221,6219                                       WI   470
 6221 DO 6222 K=1,6                                                     WI   471
 6222 SPACE(K)=0.0                                                      WI   472
      IF(MDE.EQ.0) GO TO 6030                                           WI   473
      IF(NHU.EQ.1) GO TO 100                                            WI   474
      GO TO 6030                                                        WI   475
 6121 READ(IT3) FF,SHH,SKK,SLL,SKL,SHK,SHL,PACE                         WI   476
      GO TO 6219                                                        WI   477
C    GO TO PROPER ZEROING ROUTINE OR TO TAPEREAD FOR STAT. REFLECTIONS. WI   479
 6030 IF(MDE) 2048,38,48                                                WI   481
   38 CONTINUE                                                          WI   482
   39 WRITE(3,181)                                                      WI   483
      NPTR=0                                                            WI   484
C    READ DATA ON EITHER INPUT TAPE OR DISK(IT3).                       WI   486
   40 IF(NDISK.EQ.0) GO TO 6000                                         WI   488
      READ(IT3)IH,IK,IL,DCOR,W,PIH,PIK,PIL,BCON,FF,CHK,DMUM,UMUM,SNV,NNNWI   489
      IF(INREF.LT.0)THEN
        NREF=NREF+1 
C  NREF IS THE TOTAL NUMBER OF REFLECTIONS.  FIRST PASS THROUGH,
C  INCREMENT NREF SO AT END OF FIRST PASS, NREF IS TOTAL.  THEN, WHEN
C  MAKE 2ND PASS, INREF KEEPS A COUNT OF THE CURRENT REFLECTION.
C  THIS IS SO THAT FOR LIMITED OUTPUT (IPRNT=0), ONLY THE FIRST
C  AND LAST 5 REFLECTIONS WITH THEIR WILSON AVERAGING WILL BE PRINTED.
      ELSE
        INREF=INREF+1
      ENDIF
      IF(IH-999999) 6001,53,6001                                        WI   490
 6000 READ(IT1)IH,IK,IL,DCOR,W,PIH,PIK,PIL,BCON,FF,CHK                  WI   491
      IF(INREF.LT.0)THEN
        NREF=NREF+1
      ELSE
        INREF=INREF+1
      ENDIF
      IF(IH-999999) 45,6350,45                                          WI   492
C    COMPUTE SUMMATION FI**2.                                           WI   494
   45 DMUM=0                                                            WI   496
      UMUM=0                                                            WI   497
      DO 330 K=1,12                                                     WI   498
      DMUM=DMUM+FF(K)*FF(K)*A(K)                                        WI   499
  330 UMUM=UMUM+FF(K)*A(K)                                              WI   500
      IF(IH)650,651,650                                                 WI   501
  651 IF(IK)652,653,652                                                 WI   502
  653 IF(IL.EQ.0) GO TO 671                                             WI   503
      NNN=7                                                             WI   504
      GO TO 659                                                         WI   505
  652 IF(IL)654,655,654                                                 WI   506
  655 NNN=6                                                             WI   507
      GO TO 659                                                         WI   508
  654 NNN=4                                                             WI   509
      IF(IL.EQ.IK.AND.NGP.GT.194) NNN=13                                WI   510
      GO TO 659                                                         WI   511
  650 IF(IK)656,657,656                                                 WI   512
  657 IF(IL)658,660,658                                                 WI   513
  660 NNN=5                                                             WI   514
      GO TO 659                                                         WI   515
  658 NNN=3                                                             WI   516
      IF(IL.EQ.IH.AND.NGP.GT.194) NNN=11                                WI   517
      GO TO 659                                                         WI   518
  656 IF(NCBC.GT.7) GO TO 663                                           WI   519
  664 IF(IL) 661,662,661                                                WI   520
  662 NNN=2                                                             WI   521
      GO TO 659                                                         WI   522
  661 NNN=1                                                             WI   523
      IF(IL.EQ.IH.AND.NGP.GT.194) NNN=10                                WI   524
      IF(IL.EQ.IK.AND.NGP.GT.194) NNN=12                                WI   525
      GO TO 659                                                         WI   526
  663 IF(IH.NE.IK) GO TO 664                                            WI   527
      IF(IL) 665,666,665                                                WI   528
  671 NNN=0                                                             WI   529
      SNV=SSNV(7)                                                       WI   530
      SEPS=EPS(7)*SNV                                                   WI   531
      IF(NGP.GT.194) SEPS=SEPS*3.0                                      WI   532
      GO TO 672                                                         WI   533
  665 NNN=8                                                             WI   534
      IF(IL.EQ.IH.AND.NGP.GT.194) NNN=14                                WI   535
      GO TO 659                                                         WI   536
  666 NNN=9                                                             WI   537
  659 SEPS=EPS(NNN)                                                     WI   538
      SNV=SSNV(NNN)                                                     WI   539
  672 DMUM=DMUM*SEPS                                                    WI   540
C    STORE DATA ON DISK(IT3).                                           WI   542
C    GO TO PROPER SUMMATION ROUTINE OR TO SHARPENING ROUTINE.           WI   543
      IF(MDE.EQ.0) GO TO 37                                             WI   545
      WRITE(IT3)IH,IK,IL,DCOR,W,PIH,PIK,PIL,BCON,FF,CHK,DMUM,UMUM,SNV,  WI   546
     1NNN                                                               WI   547
 6001 IF(MDE) 2200,37,6002                                              WI   548
 6002 IF(NHU) 106,200,106                                               WI   549
   37 CONTINUE                                                          WI   550
C    SCALE AND CALCULATE SHARPENED INTENSITY.                           WI   552
      FCOR=DCOR                                                         WI   554
      IF(DCOR.LT.0.0) FCOR=0.0                                          WI   555
      FCOR=SCF*FCOR                                                     WI   556
      DCOR=SCF*DCOR                                                     WI   557
      W=SFQSR*W                                                         WI   558
      IF(MINH.EQ.1) GO TO 1300                                          WI   559
      TEMP=EXP(BCON*B2)                                                 WI   560
      GO TO 1301                                                        WI   561
 1300 AH=IH                                                             WI   562
      AK=IK                                                             WI   563
      AL=IL                                                             WI   564
      TEMP=EXP(2.0*(AH*AH*AB(2)+AK*AK*AB(3)+AL*AL*AB(4)+AH*AK*AB(5)+AH*AWI   565
     1L*AB(6)+AK*AL*AB(7)))                                             WI   566
 1301 ESQ=FCOR*FCOR*TEMP/DMUM                                           WI   567
      IF (W) 1280,1283,1283                                             WI   568
 1280 ESQ=ESQ*0.50                                                      WI   569
 1283 EF=SQRT (ESQ)                                                     WI   570
      UF=(FCOR*SQRT(TEMP))/UMUM                                         WI   571
      ESQM=ESQ-1.0                                                      WI   572
      SHARP=ESQM*10000.*BCON**2*EXP(-19.36*BCON)                        WI   573
      E21S=ESQM*ESQM                                                    WI   574
      E21C=ESQM*ESQM*ESQM                                               WI   575
      EF=EF*EF                                                          WI   576
      IF(NNN.EQ.0) GO TO 673                                            WI   577
C    COUNTING FOR N(Z) TEST.                                            WI   579
      IF(EF.LE.0.1)IHPR1=IHPR1+1                                        WI   581
      IF(EF.LE.0.2)IHPR2=IHPR2+1                                        WI   582
      IF(EF.LE.0.3)IHPR3=IHPR3+1                                        WI   583
      IF(EF.LE.0.4)IHPR4=IHPR4+1                                        WI   584
      IF(EF.LE.0.5)IHPR5=IHPR5+1                                        WI   585
      IF(EF.LE.0.6)IHPR6=IHPR6+1                                        WI   586
      IF(EF.LE.0.7)IHPR7=IHPR7+1                                        WI   587
      IF(EF.LE.0.8)IHPR8=IHPR8+1                                        WI   588
      IF(EF.LE.0.9)IHPR9=IHPR9+1                                        WI   589
      IF(EF.LE.1.0)IHPR0=IHPR0+1                                        WI   590
      IF(EF.LE.1.2)IHPR12=IHPR12+1                                           591
      IF(EF.LE.1.4)IHPR14=IHPR14+1                                           592
      IF(EF.LE.1.6)IHPR16=IHPR16+1                                           593
      IF(EF.LE.2.0)IHPR20=IHPR20+1                                           594
      IF(EF.LE.2.4)IHPR24=IHPR24+1                                           595
      IF(EF.LE.2.8)IHPR28=IHPR28+1                                           596
  673 EF=SQRT(EF)                                                       WI   597
C    PRINTOUT SCALED AND SHARPENED INTENSITIES.                         WI   599
      IF(IPRNT.EQ.1.OR.INREF.LE.5.OR.NREF-INREF.LE.5)THEN
C  PRINT REFLECTION IF NO LIMITED OUTPUT (IPRNT=1) OR IF ONE OF FIRST
C  OR LAST 5 REFLECTIONS.
      WRITE(3,177)IH,IK,IL,SHARP,DCOR,EF,ESQ,UF,E21S,E21C 
      ENDIF
      IF(INREF.EQ.6.AND.IPRNT.NE.1)WRITE(3,1771)
1771  FORMAT(1X)  ! BLANK LINE TO SEPARATE FIRST AND LAST 5 REFLECTIONS
      IF(IT.EQ.0) GO TO 42                                              WI   602
      IF(IT.EQ.1) GO TO 44                                              WI   603
      GO TO 41                                                          WI   604
C    MAKE UPDATED DATA TAPE.                                            WI   606
   42 WRITE(IT2)IH,IK,IL,DCOR,W,PIH,PIK,PIL,BCON,FF,(CHK(I),I=1,6),     WI   608
     1EF,SHARP,CHK(9),CHK(10)                                           WI   609
C  44 IF(EF.GE.EMIN)WRITE(2,178)IH,IK,IL,EF                             WI   610
C     IF(IPNCH.GT.0)WRITE(2,500)IH,IK,IL,DCOR,W                         WI   611
44    IF(EF.GE.EMIN.AND.IPNCH.GT.0)WRITE(2,178)IH,IK,IL,EF
   41 CONTINUE                                                          WI   612
      IF(NNN.EQ.0) GO TO 709                                            WI   613
      J=J+1                                                             WI   614
      IF(EF.GT.1.0) E1=E1+1.0                                           WI   615
      IF(EF.GT.2.0) E2=E2+1.0                                           WI   616
      IF(EF.GT.3.0) E3=E3+1.0                                           WI   617
C    MAXWELL'S DEMON FOR ZONAL STATISTICS.                              WI   619
      GO TO (706,703,702,701,702,701,701,707,703,721,702,722,701,707), NWI   621
     1NN                                                                WI   622
  701 EOKL=EOKL+EF                                                      WI   623
      EQOKL=EQOKL+ESQ                                                   WI   624
      EMOKL=EMOKL+ABS(ESQM)                                             WI   625
      E2OKL=E2OKL+ESQM*ESQM                                             WI   626
      E3OKL=E3OKL+ESQM*ESQM*ESQM                                        WI   627
      TOKL=TOKL+1.0                                                     WI   628
      IF(NNN.EQ.6) GO TO 703                                            WI   629
      IF(NNN.EQ.7) GO TO 702                                            WI   630
      IF(NNN.EQ.13) GO TO 722                                           WI   631
      GO TO 704                                                         WI   632
  702 EHOL=EHOL+EF                                                      WI   633
      EQHOL=EQHOL+ESQ                                                   WI   634
      EMHOL=EMHOL+ABS(ESQM)                                             WI   635
      E2HOL=E2HOL+ESQM*ESQM                                             WI   636
      E3HOL=E3HOL+ESQM*ESQM*ESQM                                        WI   637
      THOL=THOL+1.0                                                     WI   638
      IF(NNN.EQ.5) GO TO 703                                            WI   639
      IF(NNN.EQ.11) GO TO 721                                           WI   640
      IF(NNN.EQ.7.AND.NCBC.GT.7) GO TO 707                              WI   641
      GO TO 704                                                         WI   642
  703 EHKO=EHKO+EF                                                      WI   643
      EQHKO=EQHKO+ESQ                                                   WI   644
      EMHKO=EMHKO+ABS(ESQM)                                             WI   645
      E2HKO=E2HKO+ESQM*ESQM                                             WI   646
      E3HKO=E3HKO+ESQM*ESQM*ESQM                                        WI   647
      THKO=THKO+1.0                                                     WI   648
      IF(NNN.EQ.5.AND.NGP.GT.194) GO TO 722                             WI   649
      IF(NNN.EQ.6.AND.NGP.GT.194) GO TO 721                             WI   650
      IF(NNN.EQ.9) GO TO 707                                            WI   651
      GO TO 704                                                         WI   652
  707 EHHL=EHHL+EF                                                      WI   653
      EQHHL=EQHHL+ESQ                                                   WI   654
      EMHHL=EMHHL+ABS(ESQM)                                             WI   655
      E2HHL=E2HHL+ESQM*ESQM                                             WI   656
      E3HHL=E3HHL+ESQM*ESQM*ESQM                                        WI   657
      THHL=THHL+1.0                                                     WI   658
      IF(NNN.EQ.14) GO TO 721                                           WI   659
      GO TO 704                                                         WI   660
  721 EHKH=EHKH+EF                                                      WI   661
      EQHKH=EQHKH+ESQ                                                   WI   662
      EMHKH=EMHKH+ABS(ESQM)                                             WI   663
      E2HKH=E2HKH+ESQM*ESQM                                             WI   664
      E3HKH=E3HKH+ESQM*ESQM*ESQM                                        WI   665
      THKH=THKH+1.0                                                     WI   666
      IF(NNN.EQ.14) GO TO 722                                           WI   667
      GO TO 704                                                         WI   668
  722 EHKK=EHKK+EF                                                      WI   669
      EQHKK=EQHKK+ESQ                                                   WI   670
      EMHKK=EMHKK+ABS(ESQM)                                             WI   671
      E2HKK=E2HKK+ESQM*ESQM                                             WI   672
      E3HKK=E3HKK+ESQM*ESQM*ESQM                                        WI   673
      THKK=THKK+1.0                                                     WI   674
      GO TO 704                                                         WI   675
  706 EHKL=EHKL+EF                                                      WI   676
      EQHKL=EQHKL+ESQ                                                   WI   677
      EMHKL=EMHKL+ABS(ESQM)                                             WI   678
      E2HJL=E2HJL+ESQM*ESQM                                             WI   679
      E3HJL=E3HJL+ESQM*ESQM*ESQM                                        WI   680
      THKL=THKL+1.0                                                     WI   681
  704 CONTINUE                                                          WI   682
      ESUM=ESUM+EF                                                      WI   683
      EQSUM=EQSUM+ESQ                                                   WI   684
      EQMS=EQMS+ABS(ESQM)                                               WI   685
      E2HKL=E2HKL+ESQM*ESQM                                             WI   686
      E3HKL=E3HKL+ESQM*ESQM*ESQM                                        WI   687
  709 NPTR=NPTR+1                                                       WI   688
      IF(NPTR.GE.78.AND.IPRNT.EQ.1)GOTO 39
      GOTO 40
C    CALCULATE <AVG.>'S AND %'S FOR E-STATISTICS.                       WI   691
   43 DJ=J                                                              WI   693
      ESUM=ESUM/DJ                                                      WI   694
      EQSUM=EQSUM/DJ                                                    WI   695
      EQMS=EQMS/DJ                                                      WI   696
      E2HKL=E2HKL/DJ                                                    WI   697
      E3HKL=E3HKL/DJ                                                    WI   698
      EPER1=100.0*E1/DJ                                                 WI   699
      EPER2=100.0*E2/DJ                                                 WI   700
      EPER3=100.0*E3/DJ                                                 WI   701
      IF(TOKL.EQ.0.0)THEN
        EOKL=0.0
        EQOKL=0.0
        EMOKL=0.0
        E2OKL=0.0
        E3OKL=0.0
      ELSE
      EOKL=EOKL/TOKL                                                    WI   702
      EQOKL=EQOKL/TOKL                                                  WI   703
      EMOKL=EMOKL/TOKL                                                  WI   704
      E2OKL=E2OKL/TOKL                                                  WI   705
      E3OKL=E3OKL/TOKL                                                  WI   706
      ENDIF
      IF(THOL.EQ.0.0)THEN
        EHOL=0.0
        EQHOL=0.0
        EMHOL=0.0
        E2HOL=0.0
        E3HOL=0.0
      ELSE
      EHOL=EHOL/THOL                                                    WI   707
      EQHOL=EQHOL/THOL                                                  WI   708
      EMHOL=EMHOL/THOL                                                  WI   709
      E2HOL=E2HOL/THOL                                                  WI   710
      E3HOL=E3HOL/THOL                                                  WI   711
      ENDIF
      IF(THKO.EQ.0.0)THEN
        EHKO=0.0
        EQHKO=0.0
        EMHKO=0.0
        E2HKO=0.0
        E3HKO=0.0
      ELSE
      EHKO=EHKO/THKO                                                    WI   712
      EQHKO=EQHKO/THKO                                                  WI   713
      EMHKO=EMHKO/THKO                                                  WI   714
      E2HKO=E2HKO/THKO                                                  WI   715
      E3HKO=E3HKO/THKO                                                  WI   716
      ENDIF
      IF(THKL.EQ.0.0)THEN
        EHKL=0.0
        EQHKL=0.0
        EMHKL=0.0
        E2HKL=0.0
        E3HKL=0.0
      ELSE
      EHKL=EHKL/THKL                                                    WI   717
      EQHKL=EQHKL/THKL                                                  WI   718
      EMHKL=EMHKL/THKL                                                  WI   719
      E2HJL=E2HJL/THKL                                                  WI   720
      E3HJL=E3HJL/THKL                                                  WI   721
      ENDIF
      HPR1=IHPR1/DJ                                                     WI   722
      HPR2=IHPR2/DJ                                                     WI   723
      HPR3=IHPR3/DJ                                                     WI   724
      HPR4=IHPR4/DJ                                                     WI   725
      HPR5=IHPR5/DJ                                                     WI   726
      HPR6=IHPR6/DJ                                                     WI   727
      HPR7=IHPR7/DJ                                                     WI   728
      HPR8=IHPR8/DJ                                                     WI   729
      HPR9=IHPR9/DJ                                                     WI   730
      HPR0=IHPR0/DJ                                                     WI   731
      HPR12=IHPR12/DJ                                                        732
      HPR14=IHPR14/DJ                                                        733
      HPR16=IHPR16/DJ                                                        734
      HPR20=IHPR20/DJ                                                        735
      HPR24=IHPR24/DJ                                                        736
      HPR28=IHPR28/DJ                                                        737
      IF(NCBC.LE.7) GO TO 888                                           WI   738
      IF(THHL.EQ.0.0)THEN
        EHHL=0.0
        EQHHL=0.0
        EMHHL=0.0
        E2HHL=0.0
        E3HHL=0.0
      ELSE
      EHHL=EHHL/THHL                                                    WI   739
      EQHHL=EQHHL/THHL                                                  WI   740
      EMHHL=EMHHL/THHL                                                  WI   741
      E2HHL=E2HHL/THHL                                                  WI   742
      E3HHL=E3HHL/THHL                                                  WI   743
      ENDIF
      IF(NGP.LE.194) GO TO 888                                          WI   744
      IF(THKH.EQ.0.0)THEN
        EHKH=0.0
        EQHKH=0.0
        EMHKH=0.0
        E2HKH=0.0
        E3HKH=0.0
      ELSE
      EHKH=EHKH/THKH                                                    WI   745
      EQHKH=EQHKH/THKH                                                  WI   746
      EMHKH=EMHKH/THKH                                                  WI   747
      E2HKH=E2HKH/THKH                                                  WI   748
      E3HKH=E3HKH/THKH                                                  WI   749
      ENDIF
      IF(THKK.EQ.0.0)THEN
        EHKK=0.0
        EQHKK=0.0
        EMHKK=0.0
        E2HKK=0.0
        E3HKK=0.0
      ELSE
      EHKK=EHKK/THKK                                                    WI   750
      EQHKK=EQHKK/THKK                                                  WI   751
      EMHKK=EMHKK/THKK                                                  WI   752
      E2HKK=E2HKK/THKK                                                  WI   753
      E3HKK=E3HKK/THKK                                                  WI   754
      ENDIF
C    PRINT E-STATISTICS.                                                WI   756
  888 WRITE(3,800)                                                      WI   758
      WRITE(3,185) ESUM,EQSUM,EQMS,EPER1,EPER2,EPER3,J                  WI   759
      WRITE(3,711) E2HKL,E3HKL                                          WI   760
      WRITE(3,720) EHKL,EQHKL,EMHKL,E2HJL,E3HJL,THKL                    WI   761
      WRITE(3,712)                                                      WI   762
      WRITE(3,705) EHKO,EHOL,EOKL,EQHKO,EQHOL,EQOKL,EMHKO,EMHOL,EMOKL,  WI   763
     1E2HKO,E2HOL,E2OKL,E3HKO,E3HOL,E3OKL,THKO,THOL,TOKL                WI   764
      IF(NCBC.LE.7) GO TO 889                                           WI   765
      IF(NGP.GT.194) GO TO 887                                          WI   766
      WRITE(3,708) EHHL,EQHHL,EMHHL,E2HHL,E3HHL,THHL                    WI   767
      GO TO 889                                                         WI   768
  887 WRITE(3,723) EHHL,EHKH,EHKK,EQHHL,EQHKH,EQHKK,EMHHL,EMHKH,EMHKK,  WI   769
     1E2HHL,E2HKH,E2HKK,E3HHL,E3HKH,E3HKK,THHL,THKH,THKK                WI   770
  889 WRITE(3,187)HPR1,HPR2,HPR3,HPR4,HPR5,HPR6,HPR7,HPR8,HPR9,HPR0     WI   771
     1,HPR12,HPR14,HPR16,HPR20,HPR24,HPR28                                   772
      IF(NNNN.EQ.7) WRITE(3,3901)                                       WI   773
 1996 IF(NGO.GE.10.AND.KY.GT.1) WRITE(3,904)                            WI   774
      IF(NGO.GE.10.AND.NAM.GE.1) WRITE(3,3504)                          WI   775
      IF(NGO.GE.10) WRITE(3,514)                                        WI   776
      IF(NNNN.GE.10) WRITE(3,3504)                                      WI   777
      IF(NNNN.GE.10) WRITE(3,513)                                       WI   778
      WRITE(3,710)                                                      WI   779
C    END TAPE AND RETURN.                                               WI   781
      IF(IT.GE.1) GO TO 351                                             WI   783
  350 KRK=999999                                                        WI   784
      DO 355 I=1,3                                                      WI   785
  355 WRITE(IT2)KRK,SPACE                                               WI   786
      KRK=IT2                                                           WI   787
      IT2=IT1                                                           WI   788
      IT1=KRK                                                           WI   789
  351 REWIND IT1                                                        WI   790
      REWIND IT2                                                        WI   791
      IS1 = 0                                                           WI   792
      IF(NGP.LE.0.OR.NGP.GT.230) IS1=3                                  WI   793
      IF(NNNN.GE.10.OR.NGO.GE.10) IS1=3                                 WI   794
      IF(KY.NE.0) IS1=3                                                 WI   795
      CALL IMP2                                                         WI   796
      RETURN                                                            WI   797
C    END DISK(IT3).                                                     WI   799
6350  INREF=0
      IF(MDE.EQ.0) GO TO 53
      KRK=999999                                                        WI   802
      DO 6355 I=1,3                                                     WI   803
 6355 WRITE(IT3) KRK,SPACE,KRK,KRK,KRK                                  WI   804
      NDISK=1                                                           WI   805
      GO TO 53                                                          WI   806
C    CALC. CONSTANT USED TO PARTITION SIN(THETA)/LAMBDA FOR WILSON PLOT.WI   808
 2000 IF(Q.EQ.0.0) Q=60.0
      IF(QQ.EQ.0.0) QQ=0.71
      IF(MODE.NE.ANISO.AND.MODE.NE.ONLY) MODE=ISO  ! CHANGED 28JAN86 BJW
C     IF(MODE.NE.ANISO)MODE=ISO
      WRITE(3,757) START,Q,QQ,MODE
      SINT=SIN(0.5*Q/57.29578)                                          WI   814
      PING=10.0*QQ*QQ/(SINT*SINT)                                       WI   815
      MDE=-1                                                            WI   816
      WRITE(3,2753)                                                     WI   817
      GO TO 36                                                          WI   818
C    CONSTRUCT SIN(THETA)/LAMBDA INTERVALS AND ACCUMULATE WILSON SUMS.  WI   820
 2200 IF(NNN.EQ.0) GO TO 40                                             WI   822
      MI=BCON*PING                                                      WI   823
      M=MI+1                                                            WI   824
      IF(M.GT.11) GO TO 40                                              WI   825
      IF(DCOR.LT.0.0) DCOR=0.0                                          WI   826
      IF (W) 210,211,211                                                WI   827
  210 WZUM(M) = WZUM(M)+DCOR*DCOR*0.5                                   WI   828
      GO TO 216                                                         WI   829
  211 WZUM(M) = WZUM(M)+DCOR*DCOR                                       WI   830
  216 NZUM(M) = NZUM(M) +1                                              WI   831
      FZUM(M) = FZUM(M)+DMUM                                            WI   832
      SZSUM(M) = SZSUM(M)+BCON                                          WI   833
      GO TO 40                                                          WI   834
C    ACCUMULATE SUMS FOR ISOTROPIC REFINEMENT.  THIS PROCEDURE PRODUCES WI   836
C    A NON-LINEAR L.S. REGRESSION WITH CYCLED WEIGHTS.                  WI   837
  200 IF(NNN.EQ.0) GO TO 40                                             WI   839
      IF(DCOR.LT.0.0) DCOR=0.0                                          WI   840
      DDCOR=DCOR*DCOR                                                   WI   841
      XPON=EXP(-1.0*BCON*TOBE)                                          WI   842
      DTOBE=-1.0*KAYO*BCON*XPON                                         WI   843
      DLOBS=(DDCOR/DMUM)-(KAYO*XPON)                                    WI   844
      RVARF=W*W*DMUM*DMUM                                               WI   845
      IF(RVARF.EQ.0.0)THEN
        WAIT=0.0
        RWAIT=0.0
      ELSE
      RWAIT=(1.0/RVARF)+XPON*XPON*KAYO*KAYO*SNV                         WI   846
      WAIT=1.0/RWAIT                                                    WI   847
      ENDIF
      NSUM=NSUM+1.0                                                     WI   848
      WSUM=WSUM+XPON*XPON*WAIT                                          WI   849
      SSSUM=SSSUM+DTOBE*XPON*WAIT                                       WI   850
      TSSUM=TSSUM+DTOBE*DTOBE*WAIT                                      WI   851
      OSUM=OSUM+DLOBS*XPON*WAIT                                         WI   852
      OTSUM=OTSUM+DLOBS*DTOBE*WAIT                                      WI   853
      FLOTS=FLOTS+WAIT*DLOBS*DLOBS                                      WI   854
      GO TO 40                                                          WI   855
C    ACCUMULATE SUMS FOR ANISO REFINEMENT.                              WI   857
  106 IF(NNN.EQ.0) GO TO 40                                             WI   859
      IF(DCOR.LT.0.0) DCOR=0.0                                          WI   860
      DDCOR=DCOR*DCOR                                                   WI   861
      AH=IH                                                             WI   862
      AK=IK                                                             WI   863
      AL=IL                                                             WI   864
      KAYO=AB(1)                                                        WI   865
      XUONG=-2.0*(AH*AH*AB(2)+AK*AK*AB(4)+AL*AL*AB(3)+AH*AK*AB(6)+AH*AL*WI   866
     1AB(5)+AK*AL*AB(7))                                                WI   867
      XPON=EXP(XUONG)                                                   WI   868
      DLOBS=(DDCOR/DMUM)-(KAYO*XPON)                                    WI   869
      RVARF=W*W*DMUM*DMUM                                               WI   870
      IF(RVARF.EQ.0.0)THEN
        WAIT=0.0
        RWAIT=0.0
      ELSE
        RWAIT=(1.0/RVARF)+XPON*XPON*KAYO*KAYO*SNV
        WAIT=1.0/RWAIT
      ENDIF
      CHI=-2.0*XPON*XPON*KAYO*WAIT                                      WI   873
      THIEU=-2.0*KAYO*CHI                                               WI   874
      GIAP=-2.0*DLOBS*XPON*KAYO*WAIT                                    WI   875
      NSUM=NSUM+1.0                                                     WI   876
      FLOTS=FLOTS+WAIT*DLOBS*DLOBS                                      WI   877
      HO(1,1)=HO(1,1)+XPON*XPON*WAIT                                    WI   878
      HO(1,2)=HO(1,2)+AH*AH*CHI                                         WI   879
      HO(1,3)=HO(1,3)+AL*AL*CHI                                         WI   880
      HO(2,2)=HO(2,2)+AH*AH*AH*AH*THIEU                                 WI   881
      HO(2,3)=HO(2,3)+AH*AH*AL*AL*THIEU                                 WI   882
      HO(3,3)=HO(3,3)+AL*AL*AL*AL*THIEU                                 WI   883
      CAO(1)=CAO(1)+DLOBS*XPON*WAIT                                     WI   884
      CAO(2)=CAO(2)+AH*AH*GIAP                                          WI   885
      CAO(3)=CAO(3)+AL*AL*GIAP                                          WI   886
      IF(NGP.GT.74) GO TO 107                                           WI   887
      HO(1,4)=HO(1,4)+AK*AK*CHI                                         WI   888
      HO(2,4)=HO(2,4)+AH*AH*AK*AK*THIEU                                 WI   889
      HO(3,4)=HO(3,4)+AL*AL*AK*AK*THIEU                                 WI   890
      HO(4,4)=HO(4,4)+AK*AK*AK*AK*THIEU                                 WI   891
      CAO(4)=CAO(4)+AK*AK*GIAP                                          WI   892
      IF(NGP.GT.15) GO TO 107                                           WI   893
      HO(1,5)=HO(1,5)+AH*AL*CHI                                         WI   894
      HO(2,5)=HO(2,5)+AH*AH*AH*AL*THIEU                                 WI   895
      HO(3,5)=HO(3,5)+AL*AL*AL*AH*THIEU                                 WI   896
      HO(4,5)=HO(4,5)+AK*AK*AH*AL*THIEU                                 WI   897
      HO(5,5)=HO(5,5)+AH*AH*AL*AL*THIEU                                 WI   898
      CAO(5)=CAO(5)+AH*AL*GIAP                                          WI   899
      IF(NGP.GT.2) GO TO 107                                            WI   900
      HO(1,6)=HO(1,6)+AH*AK*CHI                                         WI   901
      HO(1,7)=HO(1,7)+AK*AL*CHI                                         WI   902
      HO(2,6)=HO(2,6)+AH*AH*AH*AK*THIEU                                 WI   903
      HO(2,7)=HO(2,7)+AH*AH*AK*AL*THIEU                                 WI   904
      HO(3,6)=HO(3,6)+AL*AL*AH*AK*THIEU                                 WI   905
      HO(3,7)=HO(3,7)+AL*AL*AL*AK*THIEU                                 WI   906
      HO(4,6)=HO(4,6)+AK*AK*AK*AH*THIEU                                 WI   907
      HO(4,7)=HO(4,7)+AK*AK*AK*AL*THIEU                                 WI   908
      HO(5,6)=HO(5,6)+AH*AH*AK*AL*THIEU                                 WI   909
      HO(5,7)=HO(5,7)+AH*AK*AL*AL*THIEU                                 WI   910
      HO(6,6)=HO(6,6)+AH*AH*AK*AK*THIEU                                 WI   911
      HO(6,7)=HO(6,7)+AH*AL*AK*AK*THIEU                                 WI   912
      HO(7,7)=HO(7,7)+AK*AK*AL*AL*THIEU                                 WI   913
      CAO(6)=CAO(6)+AH*AK*GIAP                                          WI   914
      CAO(7)=CAO(7)+AK*AL*GIAP                                          WI   915
  107 GO TO 40                                                          WI   916
C    DO WILSON INITIALIZATION.                                          WI   918
 2048 DO 55 M=1,11                                                      WI   920
      WZUM(M) = 0.0                                                     WI   921
      NZUM(M) = 0                                                       WI   922
      FZUM(M) = 0.0                                                     WI   923
   55 SZSUM(M) = 0.0                                                    WI   924
      GO TO 40                                                          WI   925
C    DO INITIALIZATION FOR ISOTROPIC REFINEMENT.                        WI   927
   48 NSUM=0.0                                                          WI   929
      WSUM=0.0                                                          WI   930
      SSSUM=0.0                                                         WI   931
      TSSUM=0.0                                                         WI   932
      OSUM=0.0                                                          WI   933
      OTSUM =0.0                                                        WI   934
      FLOTS=0.0                                                         WI   935
      NGUYEN=2                                                          WI   936
      GO TO 40                                                          WI   937
C    PREPARE INITIAL VALUES AND ZERO FOR ANISO REFINEMENT.              WI   939
  100 IF(NGP-194) 102,102,103                                           WI   941
  103 WRITE(3,512)                                                      WI   942
      MDE=0                                                             WI   943
      NHU=0                                                             WI   944
      GOTO 6013
C     IF(HUE.NE.ONLY) GO TO 6013                                        WI   945
C     NGP=NGP+100                                                       WI   946
C     GO TO 351                                                         WI   947
  102 IF(NGO.GT.1) GO TO 101                                            WI   948
      NGUYEN=3                                                          WI   949
      IF(NGP.LE.74) NGUYEN=NGUYEN+1                                     WI   950
      IF(NGP.LE.15) NGUYEN=NGUYEN+1                                     WI   951
      IF(NGP.LE.2) NGUYEN=NGUYEN+2                                      WI   952
      IF(MARK.NE.0) GO TO 150                                           WI   953
      AB(1)=KAYO                                                        WI   954
      AB(2)=0.5*TOBE*SHH                                                WI   955
      AB(3)=0.5*TOBE*SKK                                                WI   956
      AB(4)=0.5*TOBE*SLL                                                WI   957
      AB(5)=0.5*TOBE*SHK                                                WI   958
      AB(6)=0.5*TOBE*SHL                                                WI   959
      AB(7)=0.5*TOBE*SKL                                                WI   960
c     WRITE(3,300)TOBE,AB
c300    FORMAT(' TOBE='F12.7,' AB= ',7F12.7)
      DO 150 J=5,7                                                      WI   961
  150 CONTINUE                                                          WI   963
      WRITE(3,754)                                                      WI   964
      WRITE(3,755)(AB(J),J=1,7)                                         WI   965
  101 DO 104 J=1,7                                                      WI   966
      SIG(J)=0.0                                                        WI   967
  104 CAO(J)=0.0                                                        WI   968
      DO 105 K=1,NGUYEN                                                 WI   969
      DO 105 L=1,NGUYEN                                                 WI   970
  105 HO(K,L)=0.0                                                       WI   971
      NSUM=0.0                                                          WI   972
      FLOTS=0.0                                                         WI   973
      CALL FLIP(AB)                                                     WI   974
      GO TO 40                                                          WI   975
C    GO TO PROPER REGRESSION OR TO E-STATISTICS CALCULATION.            WI   977
53    INREF=0
      IF(MDE.NE.0.AND.NHU.NE.0) GO TO 108
      IF(MDE) 2059,43,59                                                WI   980
C    WILSON CALCULATIONS.  STANDARD LINEAR L.S. REGRESSION FOLLOWS.     WI   982
C    X(I) AND Y(I) ARE POINTS; NN IS THE NUMBER OF POINTS.              WI   983
 2059 NN = 0                                                            WI   985
      DO 65 L=1,10                                                      WI   986
      IF (WZUM(L)) 61,65,61                                             WI   987
   61 NN = NN+1                                                         WI   988
      Y(NN) =ALOG (WZUM(L)/FZUM(L))                                     WI   989
      DN = NZUM(L)                                                      WI   990
      X(NN) = SZSUM(L)/DN                                               WI   991
   65 CONTINUE                                                          WI   992
      SMX = 0.0                                                         WI   993
      SMY = 0.0                                                         WI   994
      SMXS = 0.0                                                        WI   995
      SMYS = 0.0                                                        WI   996
      SMXY = 0.0                                                        WI   997
      DO 400 L=2,NN                                                     WI   998
      SMX = SMX+X(L)                                                    WI   999
      SMY = SMY+Y(L)                                                    WI  1000
      SMXS = SMXS+X(L)*X(L)                                             WI  1001
      SMYS = SMYS+Y(L)*Y(L)                                             WI  1002
      SMXY = SMXY+X(L)*Y(L)                                             WI  1003
  400 CONTINUE                                                          WI  1004
      WNN = NN-1                                                        WI  1005
      XM = SMXS-(SMX*SMX/WNN)                                           WI  1006
      BPR = (SMXY-(SMX*SMY/WNN))/XM                                     WI  1007
      APR = (SMY-BPR*SMX)/WNN                                           WI  1008
      SEP =(BPR*BPR*SMXS+SMYS-2.0*(APR*SMY+BPR*SMXY-APR*BPR*SMX)+WNN*   WI  1009
     1APR*APR)/(WNN-2.0)                                                WI  1010
      SIGA=SQRT(SEP/WNN+((SMX*SMX*SEP)/(WNN*WNN*XM)))                   WI  1011
      SIGB = SQRT(SEP/XM)                                               WI  1012
C    REGRESSION ENDS HERE.  PRINT RESULTS AND GO EITHER TO              WI  1014
C    ISOTROPIC REFINEMENT OR quit for mode=omly   30jan86  bjw
      B2 = -BPR                                                         WI  1017
      SCF = EXP (-APR)                                                  WI  1018
      SIGS = SCF*SIGA                                                   WI  1019
      KAYO=1.00/SCF                                                     WI  1020
      TOBE=B2                                                           WI  1021
      SFQSR=KAYO                                                        WI  1022
      SCF = SQRT(SCF)                                                   WI  1023
      SIGS = SIGS/(2.0*SCF)                                             WI  1024
      WRITE (3,307)                                                     WI  1025
      DO 310 L=1,NN                                                     WI  1026
      CAL=BPR*X(L)+APR                                                  WI  1027
  310 WRITE(3,308)NZUM(L),X(L),Y(L),CAL                                 WI  1028
      WRITE(3,801)                                                      WI  1029
      WRITE(3,305)B2,SIGB,SCF,SIGS                                      WI  1030
      WRITE (3,306)                                                     WI  1031
      MDE=1                                                             WI  1032
C     IF(MODE.EQ.ANISO.AND.HUE.EQ.ONLY) NHU=1                           WI  1033
      IF(MODE.EQ.ONLY) MDE=0    ! put back mode =only option
      IF(NHU.EQ.1) GO TO 6020                                           WI  1035
      IF(MDE) 2001,136,2001                                             WI  1036
C    CALCULATIONS FOR ISOTROPIC REFINEMENT.                             WI  1038
   59 QUOT=WSUM*TSSUM-SSSUM*SSSUM                                       WI  1040
      APR=(OSUM*TSSUM-OTSUM*SSSUM)/QUOT                                 WI  1041
      BPR=(WSUM*OTSUM-OSUM*SSSUM)/QUOT                                  WI  1042
      SEP=FLOTS/(NSUM-2.0)                                              WI  1043
      SIGA=SQRT((SEP*TSSUM)/QUOT)                                       WI  1044
      SIGB=SQRT((SEP*WSUM)/QUOT)                                        WI  1045
      IF(NNNN.EQ.1) WRITE(3,3004) NSUM,NGUYEN                           WI  1046
      WRITE(3,3002) NNNN,FLOTS                                          WI  1047
      IF(NNNN.EQ.1) GO TO 3501                                          WI  1048
C    TEST FOR DIVERGENCE BY COMPARING WITH SHIFTS FROM PREVIOUS CYCLE.  WI  1050
      IF(ABS(APR).GE.PAPR.AND.ABS(BPR).GE.PBPR) GO TO 3502              WI  1052
      GO TO 3505                                                        WI  1053
 3502 IF(NSHIFT.GE.1) GO TO 3503                                        WI  1054
      NSHIFT=NSHIFT+1                                                   WI  1055
      GO TO 3501                                                        WI  1056
 3503 IT=2                                                              WI  1057
      MDE=0                                                             WI  1058
      NHU=0                                                             WI  1059
      NNNN=10                                                           WI  1060
      WRITE(3,3504)                                                     WI  1061
      GO TO 3500                                                        WI  1062
 3505 NSHIFT=0                                                          WI  1063
 3501 PAPR=ABS(APR)                                                     WI  1064
      PBPR=ABS(BPR)                                                     WI  1065
 3500 WRITE(3,3555)                                                     WI  1066
      WRITE(3,3000) APR,BPR                                             WI  1067
      AAPR=APR+KAYO                                                     WI  1068
      BBPR=BPR+TOBE                                                     WI  1069
      WRITE(3,3001) AAPR,BBPR                                           WI  1070
      WRITE(3,3003) SIGA,SIGB                                           WI  1071
      IF(NNNN.GE.10) GO TO 36                                           WI  1072
      RTB=ABS(BPR/SIGB)                                                 WI  1073
      RK=ABS(APR/SIGA)                                                  WI  1074
C    TEST FOR CONVERGENCE USING RATIOS OF SHIFTS TO E.S.D.'S.           WI  1076
      IF(RTB.LT.0.3.AND.RK.LT.0.3) GO TO 4000                           WI  1078
      KAYO=AAPR                                                         WI  1079
      TOBE=BBPR                                                         WI  1080
      NNNN=NNNN+1                                                       WI  1081
C    HAS MAX NO. OF CYCLES BEEN EXCEEDED?                               WI  1083
      IF(NNNN.EQ.7) GO TO 3900                                          WI  1085
      GO TO 36                                                          WI  1086
 3900 IT=2                                                              WI  1087
      WRITE(3,3901)                                                     WI  1088
C    TERMINATE IF CONVERGED OR SIXTH CYCLE COMPLETED.  PRINT RESULTS.   WI  1090
 4000 B2=BBPR                                                           WI  1092
      SCF=SQRT(1.0/AAPR)                                                WI  1093
      SFQSR=AAPR                                                        WI  1094
      SIGS=0.5*SIGA*SCF*SCF*SCF                                         WI  1095
      IF(NNNN.GE.7) GO TO 1999                                          WI  1096
      WRITE(3,801)                                                      WI  1097
 1999 WRITE(3,305)B2,SIGB,SCF,SIGS                                      WI  1098
      WRITE (3,306)                                                     WI  1099
      IF(MODE.EQ.ANISO) GO TO 1998                                      WI  1100
 1995 MDE=0                                                             WI  1101
      NHU=0                                                             WI  1102
      GO TO 36                                                          WI  1103
 1998 IF(NNNN.GE.7) GO TO 1995                                          WI  1104
      MDE=1                                                             WI  1105
      NHU=1                                                             WI  1106
      GO TO 36                                                          WI  1107
C    CALCULATIONS FOR ANISO REFINEMENT.                                 WI  1109
  108 LMN=NGUYEN-1                                                      WI  1111
      DO 109 I=1,LMN                                                    WI  1112
      K=I+1                                                             WI  1113
      DO 109 J=K,NGUYEN                                                 WI  1114
  109 HO(J,I)=HO(I,J)                                                   WI  1115
      CALL MATINS(HO,NGUYEN,CAO,1,DIEM)                                 WI  1116
      TET=FLOAT(NGUYEN)                                                 WI  1117
      DO 110 I=1,NGUYEN                                                 WI  1118
  110 SIG(I)=SQRT(HO(I,I)*FLOTS/(NSUM-TET))                             WI  1119
      IF(NGO.EQ.1) WRITE(3,3004) NSUM,NGUYEN                            WI  1120
      WRITE(3,3002) NGO,FLOTS                                           WI  1121
C    TEST FOR DIVERGENCE.                                               WI  1123
      VAN=ABS(CAO(1))+ABS(CAO(2))+ABS(CAO(3))                           WI  1125
      IF(NGP.LE.74) VAN=VAN+ABS(CAO(4))                                 WI  1126
      IF(NGO.EQ.1) GO TO 115                                            WI  1127
      IF(VAN.LT.VIET) GO TO 115                                         WI  1128
      IF(NAM.GE.1) GO TO 117                                            WI  1129
      NAM=NAM+1                                                         WI  1130
      GO TO 121                                                         WI  1131
  117 WRITE(3,3504)                                                     WI  1132
  113 IT=2                                                              WI  1133
      MDE=0                                                             WI  1134
      NHU=0                                                             WI  1135
      NGO=10                                                            WI  1136
      IF(KY.GT.1) GO TO 134                                             WI  1137
      GO TO 118                                                         WI  1138
  115 NAM=0                                                             WI  1139
  121 VIET=VAN                                                          WI  1140
  118 IF(NGP.GT.74) CAO(4)=CAO(2)                                       WI  1141
      IF(NGP.GT.142) CAO(6)=CAO(2)                                      WI  1142
      DO 120 J=1,7                                                      WI  1143
  120 AB(J)=AB(J)+CAO(J)                                                WI  1144
      IF(NGO.GE.10) GO TO 134                                           WI  1145
C    TEST FOR POSITIVE DEFINITE MATRIX.                                 WI  1147
      IF(NGP.LE.15) GO TO 122                                           WI  1149
      KY=KY+1                                                           WI  1150
      IF(AB(1).GT.0.0.AND.AB(2).GT.0.0.AND.AB(3).GT.0.0.AND.AB(4).GT.0.0WI  1151
     1) KY=0                                                            WI  1152
      GO TO 123                                                         WI  1153
  122 CALL THERMO(AB,KY)                                                WI  1154
  123 IF(KY.LE.1) GO TO 134                                             WI  1155
      WRITE(3,904)                                                      WI  1156
      GO TO 113                                                         WI  1157
  134 WRITE(3,900)                                                      WI  1158
C    TEST FOR CONVERGENCE.                                              WI  1167
      DO 127 I=1,NGUYEN                                                 WI  1169
      DAO(I)=ABS(CAO(I)/SIG(I))                                         WI  1170
	IF(DAO(I).LT.0.5)GO TO 127    ! CHANGED FROM 0.3 TO 0.5 4/22/83
	NCNV=99   ! NCNV.NE.0 MEANS DAO FAILED TEST
	GO TO 1270
  127 CONTINUE                                                          WI  1172
1270      CALL FLIP(CAO)                                                
      CALL FLIP(AB)                                                     WI  1160
      CALL FLIP(SIG)                                                    WI  1161
      WRITE(3,901)(CAO(J),J=1,7)                                        WI  1162
      WRITE(3,902)(AB(J),J=1,7)                                         WI  1163
      WRITE(3,903)(SIG(J),J=1,7)                                        WI  1164
      IF(NGO.GE.10) GO TO 36                                            WI  1165
	IF(NCNV.NE.0)GO TO 128
      GO TO 129                                                         WI  1173
C    HAS MAX NO. OF CYCLES BEEN EXCEEDED?                               WI  1175
  128 NGO=NGO+1                                                         WI  1177
      NCNV=0           ! RESET CONVERGENCE SIGNAL
      IF(NGO.LT.7) GO TO 36                                             WI  1178
  132 IT=2                                                              WI  1179
      WRITE(3,3901)                                                     WI  1180
C    TERMINATE IF CONVERGED OR SIXTH CYCLE COMPLETED.  PRINT RESULTS.   WI  1182
  129 SCF=SQRT(1.0/AB(1))                                               WI  1184
      SFQSR=AB(1)                                                       WI  1185
      SIGS=0.5*SIG(1)*SCF*SCF*SCF                                       WI  1186
      IF(NGO.GE.7) GO TO 1997                                           WI  1187
      WRITE(3,801)                                                      WI  1188
 1997 WRITE(3,906)                                                      WI  1189
      WRITE(3,905) SCF,(AB(J),J=2,7)                                    WI  1190
      WRITE(3,903) SIGS,(SIG(J),J=2,7)                                  WI  1191
      WRITE(3,306)                                                      WI  1192
C     DO 952 I=1,5                                                      WI  1193
C 952 WRITE(2,951)(AB(J),J=2,7)                                         WI  1194
      MDE=0                                                             WI  1195
      NHU=0                                                             WI  1196
      MINH=1                                                            WI  1197
      GO TO 36                                                          WI  1198
      END                                                               WI  1199
