      SUBROUTINE BACK2IN
C  INPUT FOR BACKGROUND2
      CHARACTER*80 CARD
      CHARACTER*6 ANS
      DIMENSION ID(10)
      CHARACTER*4 ANS1
1     FORMAT(A)
2     FORMAT(1X,A)
20    FORMAT(F14.6,:,F14.6)
C  TITLE CARD - INCLUDES VERSION NUMBERS OF MAG FILES
100   TYPE*,' Enter version numbers of MAG files to be used,',
     1' earliest version first, separated by commas.  RETURN for ',
     2' DEFAULT of HIGHEST version only.'
      READ(5,101,ERR=902)ID
101   FORMAT(10I4)
      DO 102 I=1,10
      IF(ID(I).EQ.0)GOTO 103
102   CONTINUE
103   N=I-1  ! NUMBER OF MAG FILES ENTERED
      IF(N.NE.0)THEN
      ENCODE(80,104,CARD,ERR=902)(ID(I),I=1,N)
      N4=12+N*2
      ELSE
      ENCODE(80,104,CARD)
      N4=11
      ENDIF
104   FORMAT('2BACKGROUND ',10I2)
      TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
106   TYPE*,' For reflection card, enter the starting point for the',
     1' three-point calculation. Above this point, an average',
     2' background is determined by a linear least squares fit',
     3' through each 3 adjacent 2-theta intervals - below the point,',
     4' there will be 1 quadratic fit through all 2-theta intervals.',
     5' Be sure that your point is as least as large as the minimum',
     6' value printed on background output.'
      READ(5,1060,ERR=903)A
1060   FORMAT(F5.0)
      TYPE*,' Are you using the first distribution from',
     1' BACKGROUND? Y/[N]'
      ACCEPT 1,ANS
      NN=2
      IF(ANS(1:1).EQ.'Y')NN=1
      TYPE*,' Do you want to enter CHI limits? ("N" for no rejection',
     1' on basis of CHI values.) Y/[N]'
      ACCEPT 1,ANS1
      N4=7
      IF(ANS1(1:1).EQ.'Y')THEN
      N4=20
1061  TYPE*,' EnteR CHImin and CHImax to define the inclusive CHI',
     1' limits, separated by a comma. CHI limits should be the same',
     2' as those entered in BACKGROUND. (2F7.2)'
      READ(5,20,ERR=903)B,C
      ENDIF
      TYPE*,' Do you want a listing of the corrected reflections?'
     1' Y/[N]'
      ACCEPT 1,ANS
      IF(ANS1(1:1).EQ.'Y')THEN
        ENCODE(20,108,CARD,ERR=903)A,NN,B,C
      ELSE
        CARD(23:28)='NOLIST'
        N4=26
        ENCODE(20,108,CARD,ERR=903)A,NN
      ENDIF
108   FORMAT(F5.0,I2,:,1X,2F7.2)
      TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
      TYPE*,' Do you want to restore any reflections deleted in',
     1' BACKGROUND? Y/[N]'
      ACCEPT 1,ANS
      IF(ANS(1:1).EQ.'Y')THEN
        TYPE*,' Restore all reflections? Y/[N]'
        ACCEPT 1,ANS
        IF(ANS(1:1).EQ.'Y')THEN
          CARD(1:11)='RESTORE ALL'
          N4=11
          TYPE 2,CARD(1:N4)
          WRITE(4,1)CARD(1:N4)
        ELSE
          KIND=2
          CALL DELETE(KIND)
        ENDIF
      ENDIF
      TYPE*,' Do you have any reflections to be deleted by ID#?'
     1' Y/[N]'
      ACCEPT 1,ANS
      KIND=1
      IF(ANS(1:1).EQ.'Y')CALL DELETE(KIND)
      CARD(1:3)='END'
      N4=3
      TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
      RETURN
902   TYPE 999
      GOTO 100
903   TYPE 999
      GOTO 106
904   TYPE 999
      GOTO 1061
999   FORMAT(' ERROR ON LAST CARD ENTERED - TRY AGAIN.')
      END
