      SUBROUTINE COORDIN(NFI,MC)
C  THIS PROGRAM DOES THE INPUT FOR COORD, ISO, ISO-AN AND ANISO CARDS.
C  NF=1 FOR COORDS FOR SFLS (REQUIRES ATOM FORM FACTOR).
C  NF=2 FOR OTHER COORDS (DISTAN, HPOS, COSINE, PARAMETER SWITCH,
C     CONVERT).
C  NF=3 FOR ISO (SFLS, CONVERT).
C  NF=4 FOR ISO-AN (SFLS).
C  NF=5 FOR ANISO (SFLS, DISTAN, CONVERT, PARAMETER SWITCH).
      COMMON/FNAME/ANAM,NAMLEN
      CHARACTER*16 ANAM
      CHARACTER*4 ANS,C4,C42,SWI
      CHARACTER*3 C3
      CHARACTER*80 CARD
      CHARACTER*6 C6,C62,C63
      CHARACTER*1 C1,CK,C12,CT
      BYTE MC,II           ! SIGNAL TO TAKE COORDS FROM NAM.SFC FILE
      DIMENSION U(6)
      DIMENSION J(6)
      DIMENSION SFC(3)     ! FOR COORD FROM NAM.SFC FILE
      EQUIVALENCE(X,SFC(1)),(Y,SFC(2)),(Z,SFC(3))
      NF=NFI
1     FORMAT(A)
2     FORMAT(1X,A)
10    FORMAT(I10)
20    FORMAT(F10.6)
      DO 201 I=1,80
201   CARD(I:I)=' '
      IF(NF.EQ.3)GOTO 120
      IF(NF.EQ.4)GOTO 120
      IF(NF.EQ.5)GOTO 130
      IF(MC.EQ.1)GO TO 140         ! COORDS FROM MULTAN NAM.SFC FILE
      IF(NF.NE.1)THEN
      TYPE*,'Do you want to enter FORM FACTOR labels on COORD ',
     1'cards?  They are not required by this program but are necessary',
     2'if these coord cards will be used as input to a future SFLS ',
     3'program. Y/[N]'
      ACCEPT 1,ANS
      IF(ANS(1:1).EQ.'Y')NF=1
      ENDIF
      SF=1.0
      TYPE*,'Do you want to enter X, Y and Z as integers? Y/[N]'
      ACCEPT 1,SWI
1000  IF(SWI(1:1).EQ.'Y')THEN
      TYPE*,'Enter SCALE FACTOR.'
      READ(6,20,ERR=9010)SF
      ENDIF
      IF(NF.EQ.1)THEN
        TYPE*,'For coord cards, enter atom IDENTIFIER (6 ',
     1  'alphanumeric characters), atom form factor LABEL (3 ',
     2  'alphanumeric characters, X,Y and Z ',
     4  '(which will be multiplied by scale ',
     3  'factor if requested) separated by commas.'
      ELSE
        TYPE*,'For coord cards, enter atom IDENTIFIER (6 ',
     1  'alphanumeric characters), X, Y and Z ',
     3  '(which will be multiplied by scale ',
     2  'factor if requested) separated by commas.'
      ENDIF
      TYPE*,'If you need to enter more information, type "M" after Z ',
     1'(before carriage return). Type "DONE" to QUIT.'
101   N4=42
      IF(NF.EQ.1)THEN
      TYPE*,'IIIIII,FFF,  X  ,  Y  ,  Z  (,"M" - More) ("DONE" to QUIT)'
         IF(SWI(1:1).EQ.'Y')THEN
            READ(6,1020,ERR=901)C63,C1,C3,C1,IX,IY,IZ,CK
            X=IX*SF
            Y=IY*SF
            Z=IZ*SF
         ELSE
            READ(6,102,ERR=901)C63,C1,C3,C1,X,Y,Z,CK
         ENDIF
      ELSE
      TYPE*,'IIIIII,  X  ,  Y  ,  Z  (,"M")   ("DONE" to QUIT)'
         IF(SWI(1:1).EQ.'Y')THEN
            READ(6,1030,ERR=901)C63,C1,IX,IY,IZ,CK
            X=IX*SF
            Y=IY*SF
            Z=IZ*SF
         ELSE
            READ(6,103,ERR=901)C63,C1,X,Y,Z,CK
      ENDIF
      C3='   '
      ENDIF
102   FORMAT(A6,A1,A3,A1,3F11.6,A1)
1020  FORMAT(A6,A1,A3,A1,3I11,A1)
103   FORMAT(A6,A1,3F11.6,A1)
1030  FORMAT(A6,A1,3I11,A1)
      IF(C63.EQ.'DONE  ')RETURN
104   IF(CK.NE.'M')GOTO 115
      N4=80
105   TYPE*,'Enter MULTIPLICITY - RETURN if not needed.'
      READ(6,106,ERR=902)A
106   FORMAT(F6.0)
107   TYPE*,'Enter PARTIAL SHIFT factor - RETURN if not needed.'
      READ(6,20,ERR=903)B
      TYPE*,'Enter SHIFT CONSTRAINTS under heading - RETURN if not ',
     1'needed.'
      TYPE*,'NXNYNZ                                            '
      ACCEPT 1,C6
      IF(C6(1:1).EQ.'+'.OR.C6(3:3).EQ.'+'.OR.C6(5:5).EQ.'+')THEN
        TYPE*,' Do not enter "+X".  " X" is needed.'
        IF(C6(1:1).EQ.'+')C6(1:1)=' '
        IF(C6(3:3).EQ.'+')C6(3:3)=' '
        IF(C6(5:5).EQ.'+')C6(5:5)=' '
      ENDIF
      TYPE*,'Enter REFINEMENT CONSTRAINTS under heading - RETURN if ',
     1'not needed.'
      TYPE*,'NXNYNZ'
      ACCEPT 1,C62
      IF(C62(1:1).EQ.'+'.OR.C62(3:3).EQ.'+'.OR.C62(5:5).EQ.'+')THEN
        TYPE*,' Do not enter "+X".  " X" is needed.'
        IF(C62(1:1).EQ.'+')C62(1:1)=' '
        IF(C62(3:3).EQ.'+')C62(3:3)=' '
        IF(C62(5:5).EQ.'+')C62(5:5)=' '
      ENDIF
108   TYPE*,'Enter IMAGINARY part of ANOMALOUS DISPERSION - RETURN ',
     1'if not needed.'
      READ(6,20,ERR=904)CC
109   TYPE*,'Enter STANDARD DEVIATION - RETURN if not needed.'
      READ(6,20,ERR=905)D
      IF(A.NE.0.0)ENCODE(4,110,CARD(45:48),ERR=902)A
      IF(B.NE.0.0)ENCODE(6,111,CARD(49:54),ERR=903)B
110   FORMAT(F4.0)
111   FORMAT(F6.2)
      ENCODE(6,112,CARD(55:60))C6
112   FORMAT(A6)
      ENCODE(6,112,CARD(61:66))C62
      IF(CC.NE.0.0)ENCODE(6,111,CARD(67:72),ERR=904)CC
      IF(D.NE.0.0)ENCODE(7,113,CARD(73:79),ERR=905)D
113   FORMAT(F7.5)
115   ENCODE(44,116,CARD(1:44),ERR=901)C63,C3,X,Y,Z
116   FORMAT('COORD',1X,A6,A3,3F9.6,2X)
      TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
      DO 117 I=1,80
117   CARD(I:I)=' '
      IF(MC.EQ.1)GO TO 143 
      GOTO 101
120   C3='   '
      IF(NF.EQ.4)C3='-AN'
      TYPE*,'For ISO cards, enter the atom IDENTIFIER (6 alphanumeric ',
     1'characters) and the ISOTROPIC AMPLITUDE (B), separated by ',
     2'commas.  If you need to enter more information, type "M" after ',
     3'B (before carriage return).  Type "DONE" to QUIT.'
121   TYPE*,'IIIIII,  B    (,"M")    ("DONE" to QUIT)'
      N4=24
      READ(6,122,ERR=9050)C63,C1,A,CK
122   FORMAT(A6,A1,F13.9,A1)
      IF(C63.EQ.'DONE  ')RETURN
      IF(CK.NE.'M')GOTO 126
123   TYPE*,'Enter PARTIAL SHIFT factor - RETURN if not needed.'
      N4=80
      READ(6,20,ERR=906)B
      TYPE*,'Enter W, X, Y and Z for CONSTRAINTS under heading ',
     1'(include 0''s to make a 4-digit number) - RETURN if not ',
     2'needed.'
      TYPE*,'WXYZ'
      ACCEPT 1,C42
      IF(B.NE.0.0)ENCODE(4,124,CARD(73:76),ERR=906)B
      ENCODE(4,125,CARD(77:80))C42
124   FORMAT(F4.2)
125   FORMAT(A4)
      IF(NF.EQ.5)GOTO 135
126   ENCODE(72,127,CARD(1:72),ERR=9050)C3,C63,A
127   FORMAT('ISO',A3,A6,F10.6,'00',47X)
      TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
      DO 128 I=1,80
128   CARD(I:I)=' '
      IF(MC.EQ.1)GO TO 143
      GOTO 121
130   TYPE*,'Will you be entering U(i,j) values on ANISO cards ',
     1'rather than B(i,j) values? Y/[N]'
      ACCEPT 1,ANS
      C12=' '
      IF(ANS(1:1).EQ.'Y')C12='U'
      CT=C12
      IF(CT.EQ.' ')CT='B'
      TYPE *,'Do you want to enter TEMPERATURE PARAMETERS as ',
     1'integers? Y/[N]'
      ACCEPT 1,SWI
      SF=1.0
1300  IF(SWI(1:1).EQ.'Y')THEN
      TYPE*,'Enter SCALE FACTOR'
      READ(6,20,ERR=9070)SF
      ENDIF
      TYPE 131,CT,CT,CT,CT
131   FORMAT(' Enter atom IDENTIFIER (6 alphanumeric characters)',/,
     1' and the 6 TEMPERATURE factors (',A1,'11, ',A1,'22,...,',A1,
     2'23)',/,' which will be multiplied by the scale factor if ',
     3'requested,',/,' separated by commas.  If you need to enter ',
     4'more information,',/,' type "M" after ',A1,'23 (before ',
     5'carraige return).  Type "DONE" to QUIT.')
132   TYPE 133,CT,CT,CT,CT,CT,CT
      N4=72
133   FORMAT(' IIIIII, ',A1,'11 , ',A1,'22 , ',A1,'33 , ',A1,'12 , ',
     1 A1,'13 , ',A1,'23  (,"M")  ("DONE" to QUIT)')
      IF(SWI(1:1).EQ.'Y')THEN
      READ(6,1340,ERR=907)C63,C1,J,CK
      DO 1341 JJ=1,6
      U(JJ)=J(JJ)*SF
1341  CONTINUE
      ELSE
      READ(6,134,ERR=907)C63,C1,U,CK
      ENDIF
134   FORMAT(A6,A1,6F12.9,A1)
1340  FORMAT(A6,A1,6I12,A1)
      IF(C63.EQ.'DONE  ')RETURN
      IF(CK.EQ.'M')GOTO 123
135   ENCODE(72,136,CARD(1:72),ERR=907)C12,C63,U
136   FORMAT('ANISO',A1,A6,6(F8.5,'00'))
      TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
      DO 137 I=1,80
137   CARD(I:I)=' '
      GOTO 132
140   ANAM(NAMLEN+1:NAMLEN+4)='.SFC'
      OPEN(NAME=ANAM,UNIT=14,TYPE='OLD',FORM='FORMATTED')
1390  FORMAT(' Enter number of COORD you want from ',A16)
1400  TYPE 1390,ANAM
       READ(6,10,ERR=908)NUM
1401  READ(14,1700,END=144)SFC,NSFC     ! LOOK AT COORD FROM NAM.SFC FILE
      N4=42
 1700 FORMAT (2X,3F10.5,I5)                
C     TYPE 1111,SFC,NSFC,NUM
C1111   FORMAT('  COORD',3F9.6,2X,I5,'  NUM=',I5)
      IF(NUM.EQ.NSFC)THEN           ! WANT THIS COORD
      IRW=0                ! RESET REWIND SEARCH COUNTER
      TYPE 141,SFC
141   FORMAT('  For COORD ',3F10.5,/,
     *' enter atom IDENTIFIER(6 alphanumeric characters)',/,
     *'       atom FORM FACTOR label (3 alphanumeric characters)',/,
     *'       separated by commas.')
      TYPE*,' If you need to enter more information type "M"',
     *' after the form factor label (before carraige return).'
      CK=' '
1420  TYPE*,'IIIIII,FFF(,"M"-MORE)'
      READ(6,142,ERR=909)C63,C1,C3,C1,CK
142   FORMAT(A6,A1,A3,A1,A1)
C     TYPE 2222,C4,C3,CK
C2222  FORMAT(' C4=',A4,' C3=',A3,' CK=',A1)
      GO TO 104             ! WRITE THE RECORD
      ENDIF
      GO TO 1401     ! NO MATCH LOOK AGAIN
143   TYPE 1430,ANAM,ANAM
1430  FORMAT(' Enter 1, 2, 3, or 4',/,
     *' 1) Another atom from ' ,A16,/,
     *' 2) ISO',/,
     *' 3) ISO-AN',/,
     *' 4) Done with ',A16,' file',/,
     *' Enter number')
      READ(6,10,ERR=910)NF
      IF(NF.GT.4)GO TO 910
      NUM=0                       ! CLEAR OUT ALREADY DONE NUM
      IF(NF.EQ.1)GO TO 1400    ! ANOTHER SFC COORD
      IF(NF.EQ.2)THEN   !ISO
      NF=3
      GO TO 120
      ENDIF
      IF(NF.EQ.3)THEN    ! ISO-AN
      NF=4
      GO TO 120
      ENDIF
      IF(NF.EQ.4)GO TO 145     ! DONE WITH .SFC FILE
144    REWIND(14)             ! READ THROUGH FILE AGAIN
       IF(IRW.NE.0)THEN
      TYPE 1444,NUM,ANAM
1444  FORMAT(' Can''t find atom ',I5,' in ',A16,/,
     *' Want to try another atom number ? Y/[N]')
C     *' ANSWER Y FOR TRY AGAIN.')
      ACCEPT 1,ANS
      IF(ANS(1:1).NE.'Y')GO TO 145 
      ENDIF
       IRW=IRW+1              ! COUNT OF REWINDS
      IF(IRW.EQ.1)GO TO 1401
C     TYPE 1450,IRW
C1450   FORMAT('  Have come to rewind ',I3,' times')
      GO TO 1400
145    MC=0                  ! ALL DONE WITH NAM.SFC COORDS
      CLOSE(UNIT=14)
       RETURN              ! BACK TO CALLING PROGRAM
900   FORMAT(' ERROR ON LAST CARD ENTERED - TRY AGAIN.')
901   TYPE 900
      GOTO 101
9010  TYPE 900
      GOTO 1000
902   TYPE 900
      GOTO 105
903   TYPE 900
      GOTO 107
904   TYPE 900
      GOTO 108
905   TYPE 900
      GOTO 109
9050  TYPE 900
      GOTO 121
906   TYPE 900
      GOTO 123
907   TYPE 900
      GOTO 132
9070  TYPE 900
      GOTO 1300
908   TYPE 900
      GO TO 1400
909    TYPE 900
      GO TO 1420
910    TYPE 900
      GO TO 143
      END
