      SUBROUTINE COSININ
C  INPUT TO COSINE
      CHARACTER*80 CARD
      CHARACTER*4 ATOM,ATOM2,WORD
      CHARACTER*1 ALPHA
      BYTE MC
      DIMENSION STUFF(11)
      CHARACTER*6 ANS
      CHARACTER*16 ANAM
      logical ex,od
      COMMON/FNAME/ANAM,NAMLEN
1     FORMAT(A)
2     FORMAT(1X,A)
2000  FORMAT(F14.6,:,F14.6)
      MC=0
      CARD(1:6)='COSINE'
      TYPE 2,CARD(1:6)
      WRITE(4,1)CARD(1:6)
      I=NAMLEN+1
      ANAM(I:I+3)='.INF'       ! FIRST LOOK FOR CELL ON INF BJW 93
      ILEN=I+1
C          FIRST TRY INF FILE
      TYPE 100,ANAM
100   FORMAT(' Do you want CELL PARAMETERS taken from your latest ',
     1 1X,A16,' file? [Y]/N')
      ACCEPT 1,ANS
      IF(ANS.NE.'N')THEN
      WORD='CELL '
      CALL FIND(CARD,WORD,II,15)
      IF(II.EQ.1)THEN
      DECODE(80,1006,CARD,ERR=9020)A,B,C,AA,BB,CC
1006  FORMAT(5X,F9.3,4X,F9.3,4X,F9.3,4X,F8.2,4X,F8.2,4X,F8.2)
      TYPE*,' Cell parameters from INF file: '
      type 1007,a,b,c,aa,bb,cc
1007  format(' Cell ',3f8.5,3f8.4)
      type*,' Do you want to change these? Y/[N]'
      accept 1,ans
      if(ans.EQ.'Y')go to 101 ! AND CHANGE BY HAND
      GO TO 1025       !               AND DONT CHANGE
      ENDIF
      ELSE        ! DONT WANT INF, HOW ABOUT HKL?
      I=NAMLEN+1
      ANAM(I:I+3)='.HKL'    
      TYPE 100,ANAM
      ACCEPT 1,ANS
102   IF(ANS(1:1).EQ.'N')GO TO 101
          OPEN(NAME=ANAM,UNIT=12,TYPE='OLD',FORM='UNFORMATTED',
     1    BLOCKSIZE=32768,ERR=902)
          READ(12)STUFF,A,B,C,AA,BB,CC
          CLOSE(UNIT=12,DISP='SAVE')
          TYPE *,'  Cell parameters from .HKL file: '
          TYPE 1007,A,B,C,AA,BB,CC
          type *,'  Do you want to change these? [Y]/N'          
          ACCEPT 1,ANS
          if(ans.EQ.'N')GO TO 1025
      ENDIF
101   TYPE*,'Enter A,B,C,ALPHA,BETA and GAMMA separated by commas.'
      READ(5,103,ERR=901)A,B,C,AA,BB,CC
1025  ENCODE(80,104,CARD,ERR=901)A,B,C,AA,BB,CC
103   FORMAT(6F9.0)
104   FORMAT('CELL',2X,6F8.4)
      TYPE 2,CARD(1:54)
1040  WRITE(4,1)CARD(1:54)
      TYPE*,'Do you need a CONSTANTS card? [Y]/N'
      TYPE*,'"N" means all default values will be used.'
      TYPE*,'DEFAULTS are:'
      TYPE*,'Fourier map scale = 2.0'
      TYPE*,'Horizontal and vertical map sizes = 5.0 A.'
      TYPE*,'One plane calculated at a distance of .3 A. from target ',
     1'atom.'
      ACCEPT 1,ANS
      IF(ANS(1:1).EQ.'N')GOTO 110
105   TYPE*,'Enter the desired FOURIER MAP scale in In/Ang. ',  
     1 'RETURN for DEFAULT of 2.0'
      READ(5,2000,ERR=904)A
      IF(A.EQ.0.0)A=2.0
106   TYPE*,'Enter the horizontal and vertical map sizes in A. ',
     1'separated by a comma.  RETURN for DEFAULT of 5.0 X 5.0'
      READ(5,2000,ERR=905)B,C
      IF(B.EQ.0.0)B=5.
      IF(C.EQ.0.0)C=5.
      TYPE*,'Enter "X", "Y" or "Z" to indicate which is to be ',
     1'constant horizontal.'
      ACCEPT 1,ALPHA
      I=0
      IF(ALPHA.EQ.'Y')I=2
      IF(ALPHA.EQ.'Z')I=3
107   TYPE*,'Enter the distance from the target atom to the first ',
     1'plane in A.  RETURN for DEFAULT of 0.3 A.'
      READ(5,2000,ERR=906)AA
      IF(AA.EQ.0.0)AA=.3
108   TYPE*,'Enter the increment for calculating a series of',
     1'planes at different distances - RETURN for one plane.'
      READ(5,2000,ERR=907)BB
1080  TYPE*,'Enter the last distance to calculate the plane if ',
     1'more than one plane is to be calculated. DEFAULT if blank ',
     2'sets distance to first distance.'
      READ(5,2000,ERR=912)CC
      ENCODE(80,109,CARD,ERR=904)A,B,C,I,AA,BB,CC
109   FORMAT(3F10.5,I5,3F10.5)
      N4=65
      TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
110   ANAM(ILEN:ILEN+2)='CRD'
      TYPE 1100,ANAM
1100  FORMAT(' Do you want COORDS taken from your ',A16,' file? [Y]/N')
      ACCEPT 1,ANS
111   IF(ANS(1:1).EQ.'N')GOTO 1132
      OPEN(NAME=ANAM,UNIT=12,TYPE='OLD',FORM='FORMATTED',
     1 BLOCKSIZE=32768,ERR=908)
      TYPE*,'Coord cards should be arranged in pairs with the first ',
     1'being the atom farther from the plane.'
1121  TYPE*,'Enter one atom IDENTIFIER of coord to be used.  RETURN ',
     1'if DONE.'
      ACCEPT 1,ATOM
      IF(ATOM.EQ.'    ')GOTO 1131
      REWIND 12
112   READ(12,1,END=113)CARD
      ATOM2=CARD(7:11)
      IF(CARD(1:3).EQ.'END')GOTO 113
      IF(CARD(1:4).NE.'COOR')GOTO 112
      IF(ATOM2.NE.ATOM)GOTO 112
      WRITE(4,1)CARD
      TYPE 2,CARD
      GOTO 1121
113   TYPE 1130,ATOM
1130  FORMAT(' Atom ',A4,' not found in CRD file.')
      GOTO 1121
1131  CLOSE(UNIT=12,DISP='SAVE')
      GOTO 1133
1132  TYPE*,'Enter coord cards in pairs.'
      TYPE*,'The first of the pair is the atom farther from ',
     1'the plane.'
      CALL COORDIN(2,MC)
1133  CARD(1:3)='END'
      N4=3
      TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
      RETURN
901   TYPE 999
      GOTO 101
902   TYPE 903,ANAM
903   FORMAT(' FILE ',A16,' NOT FOUND. ')
9030  format ( ' You will have to enter cell parameters by hand.')
9020  type 9030      
      GOTO 101
904   TYPE 999
      GOTO 105
905   TYPE 999
      GOTO 106
906   TYPE 999
      GOTO 107
907   TYPE 999
      GOTO 108
908   TYPE 909,ANAM
909   FORMAT(' FILE ',A16,' NOT FOUND.  YOU WILL HAVE TO ENTER COORDS ',
     1/,' BY HAND.')
      ANS(1:1)='N'
      GOTO 111
912   TYPE 999
      GOTO 1080
999   FORMAT(' ERROR ON LAST CARD ENTERED.  TRY AGAIN.')
      END
