      SUBROUTINE DECAY2IN
C   INPUT PROGRAM FOR DECAY
      INTEGER*2 ND
      CHARACTER*80 CARD,SCALECD
      CHARACTER*6 ANS
      CHARACTER*1 HKL
      INTEGER*2 IIK
      DIMENSION ID(12)
1     FORMAT(A)
2     FORMAT(1X,A)
100   FORMAT(I10)   ! FORMAT FOR INTEGERS
101   FORMAT(F18.10)   ! FORMAT FOR REALS
3000  FORMAT(F18.10)      ! FORMAT FOR REALS
8141  FORMAT(F8.2,2F10.6,F8.2)
815   FORMAT('SCALE',4X,A1,12X,F8.5,:,2F10.5,F8.5)
8153  FORMAT(F8.2,2F10.6,I8)
8152  FORMAT('SCALE',4X,'N',12X,F8.0,2F10.0,I8)
110   TYPE*,'Enter the version numbers of MAG files to be used',
     1' separated by commas (up to 10).  RETURN for DEFAULT of',
     2' HIGHEST version only.'
      READ(5,1170,ERR=901)(ID(I),I=1,10)
1170  FORMAT(10I5)
      I=1
1172  IF(ID(I).EQ.0)THEN
      I=I-1
      N4=6+2*I
      GOTO 1171
      ENDIF
      I=I+1
      GOTO 1172
1171  ENCODE(80,111,CARD,ERR=901)(ID(J),J=1,I)
111   FORMAT('2DECAY',10I2)
      TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
112   TYPE *,' Enter starting X-ray TIME - <CR> if 0'
      READ(5,101,ERR=902)BEXPT
113   TYPE *,' Enter DELMAX such that reflections with',
     1' (F(obs)-F(calc))/SIG(F(obs)) > DELMAX will be deleted.',
     2' RETURN for DEFAULT of 10.0'
      READ(5,101,ERR=903)DELMAX
      IF(DELMAX.EQ.0.0)THEN
      ENCODE(80,114,CARD,ERR=902)BEXPT
      N4=13
      ELSE
      ENCODE(80,114,CARD,ERR=902)BEXPT,DELMAX
      N4=19
      ENDIF
114   FORMAT('TIME=',F8.2,:,F6.2)
      TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
      TYPE*,'Any deletes? Y/[N]'
      ACCEPT 1,ANS
      KIND=1
      IF(ANS(1:1).EQ.'Y')CALL DELETE(KIND)
      SCALECD(1:12)='SCALE=  1.00'
      TYPE*,' Do you need the SCALE option? [Y]/N'
      TYPE*,' Present scale values:'
      TYPE 2,SCALECD
      ACCEPT 1,ANS
      IF(ANS(1:1).EQ.'N') GO TO 120
C 
C  ** SCALE CARD **
C
      TYPE*,'Scale on TIME? [Y]/N'
      ACCEPT 1,ANS
      IF(ANS(1:1).NE.'N')HKL='T'
      IF(HKL.EQ.'T')THEN
8149    TYPE*,'Enter K, A (A*10**3), B (B*10**6), and T separated by ',
     1  'commas such that F(new)=F(obs)*K/(1+A(T-T0)+B(T-T0)**2).'
        type*,'A and B may be taken from DECAY output. T is starting ',
     1  'X-ray time - normally 0.0. K is SCALE factor.'
	READ(5,8141,ERR=8155)SK,SA,SB,SNT
	ENCODE(80,815,SCALECD,ERR=8155)HKL,SK,SA,SB,SNT
        N4=58
      ELSE
        IF (HKL.EQ.'N')THEN
8150      TYPE*,'Enter K, A (A*10**3), B (B*10**6) and N (an integer) ',
     1    'separated by commas.'
          READ(5,8153,ERR=8154)SK,SA,SB,IIR
          ENCODE(80,8152,SCALECD,ERR=8154)SK,SA,SB,IIR
          N4=58
c this else is left from before making T default--i don't 
C  see how it will ever occur
c  and i'm not sure it did before kaf 7/91
        ELSE
          TYPE*,'ENTER THE SCALE FACTOR, K.'
          READ(5,3000,ERR=8155)SK
          ENCODE(80,815,SCALECD,ERR=8155)HKL,SK
          N4=30
        ENDIF
      ENDIF
      TYPE 2,SCALECD(1:N4)
      WRITE(4,1)SCALECD(1:N4)
      GOTO 120
901   TYPE 999
      GOTO 110
902   TYPE 999
      GOTO 112
903   TYPE 999
      GOTO 113
8154  type 999
      goto 8150
8155  type 999
      goto 8149
999   FORMAT(' ERROR ON LAST CARD.  TRY AGAIN.')
120   CARD(1:3)='END'
      N4=3
      TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
      RETURN
      END
