      SUBROUTINE DISTANIN
C  INPUT PROGRAM FOR DISTANCES, ANGLES AND PLANES
      CHARACTER*1 CHAR1,CH1
      CHARACTER*4 C1,C2,C3,C4,CHAR(100),WORD
      CHARACTER*80 CARD
      CHARACTER*16 ANAM
      CHARACTER*2 CHAR2
      CHARACTER*2 CHAR3
      CHARACTER*4 ANS
      CHARACTER*6 WEIGHT
      CHARACTER*5 PLANE
      CHARACTER*10 GNAME
      BYTE MC
      COMMON/FNAME/ANAM,NAMLEN
      DIMENSION ISYM(100),STUFF(11)
      DIMENSION W(10)
1     FORMAT(A)
2     FORMAT(1X,A)
1000  FORMAT(I10)
2000  FORMAT(2F11.0)
      MC=0
      ITW=0
      ICYES=0
      IUP=0
      IOP15=0
      ANAM(NAMLEN+1:NAMLEN+4)='.INF'
C      OPEN(NAME=ANAM,UNIT=15,TYPE='OLD',FORM='FORMATTED',ERR=100,IOS=IOSTAT)
C      IOP15=1  ! HAVE AN INF FILE
      WORD='SPAC'  ! IS SPACE GROUP ON INF?
      CALL FIND(CARD,WORD,II,15)
C      TYPE 5002,II
C5002  FORMAT('  IN DISTANIN AFTER FIND II=',I4)
      IF(II.EQ.1)THEN
        DECODE(80,1001,CARD,ERR=1004)I,CHAR1
1001    FORMAT(14X,I3,A1)
        TYPE 1002,I,CHAR1
1002    FORMAT(' Space group from INF: ',I3,A1)
C        TYPE*,'DO YOU NEED TO CHANGE THIS?'
C        ACCEPT 1,ANS
C        IF(ANS(1:1).NE.'Y')GOTO 1003
         GOTO 1003
      ENDIF
1004  IUP=1   ! NEED TO UPDATE SPACE GROUP IN INF
C      endif          ! skip above if inf doesnt exist 
100   TYPE*,'Enter your space group number'
      READ(5,1000,ERR=901)I
      CHAR1=' '
      IF(I.EQ.14)THEN
        TYPE*,'Do you want 14N rather than 14C? Y/[N]'
        ACCEPT 1,ANS
        IF(ANS(1:1).EQ.'Y')CHAR1='N'
      ENDIF
1003  ENCODE(80,101,CARD,ERR=901)I,CHAR1
      N4=34
101   FORMAT('DISTANCES, ANGLES, AND PLANES',1X,I3,A1)
      TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
      IF(IUP.EQ.1)THEN
        ENCODE(80,1005,CARD)I,CHAR1   ! UPDATING SPACE GROUP ON INF
1005    FORMAT(' SPACE GROUP: ',I3,A1)
        CALL addin(CARD,15,IFLG)    ! IFLG=1 IF OPEN SUCCEEDS
      ENDIF
C  CELL CARD HERE - FIRST CHECK INF FILE
      IUP=0
C        IF(IOP15.EQ.1)THEN
        WORD='CELL'
        CALL FIND(CARD,WORD,II,15)  ! CELL CARD FROM INF
        IF(II.EQ.1)DECODE(80,1006,CARD,ERR=1009)A,B,C,AA,BB,CC
1006    FORMAT(5X,F9.3,4X,F9.3,4X,F9.3,4X,F8.2,4X,F8.2,4X,F8.2)
        IF(II.EQ.1)THEN
          TYPE*,'Cell parameters from INF file:'
          TYPE 1007,A,B,C,AA,BB,CC
1007      FORMAT('CELL  ',3F8.5,3F8.4)
          I=2
          TYPE*,'DO YOU NEED TO CHANGE THESE?'
          ACCEPT 1,ANS
          IF(ANS(1:1).NE.'Y')GOTO 1008
          i=3
          go to 1011        ! enter by hand to change
        ENDIF
        IUP=1
1009  ANAM(NAMLEN+1:NAMLEN+4)='.HKL'
1015  TYPE 1010,ANAM
1010  FORMAT(' For cell card, do you want CELL PARAMETERS',/,
     1'  1) from SFLS (only if distan follows SFLS in SAME job)',/,
     2'  2) from your latest ',A16,' file',/,
     3' [3] entered by hand.',/,
     4' ENTER NUMBER.')
      READ(5,1000,ERR=919)I
      IF(I.EQ.0)I=3
1011  IF(I.EQ.3)THEN
102     TYPE*,'Enter unit cell dimensions A, B, C, Alpha, Beta and ',
     1  'Gamma separated by commas.'
        READ(5,104,ERR=902)A,B,C,AA,BB,CC
104     FORMAT(6F10.5)
      ELSE
        IF(I.EQ.2)THEN     !! read from hkl file
          OPEN(NAME=ANAM,UNIT=12,TYPE='OLD',FORM='UNFORMATTED',
     1    BLOCKSIZE=32768,ERR=920)
          READ(12)STUFF,A,B,C,AA,BB,CC
          CLOSE(UNIT=12,DISP='SAVE')
        ENDIF
      ENDIF
1008  IF(I.NE.1)THEN
        ENCODE(80,105,CARD,ERR=902)A,B,C,AA,BB,CC
        N4=54
105     FORMAT('CELL',2X,3F8.5,3F8.4)
      ELSE
        CARD(1:15)='CELL IN STORAGE'
        N4=15
      ENDIF
      TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
      IF(IUP.EQ.1)THEN  ! UPDATE CELL ON INF
        ENCODE(80,1100,CARD)A,B,C,AA,BB,CC
1100    FORMAT(' CELL',3(F9.3,'(',2X,')'),3(F8.3,'(',2X,')'))
        CALL addin(CARD,15,IFLG)
      ENDIF
      TYPE*,' From now on, you will be asked whether or not you want',
     1'to use the remaining options.  Whenever you are done entering',
     2'your data, you may type "END" in answer to "Do you want this',
     3' option.'
      TYPE*,'    '
      TYPE*,'Do you want to enter COORDINATE DATA? NOTE: This card',
     1'is necessary for most other calculations. ("END" to end) [Y]/N'
      ACCEPT 1,ANS
      IF(ANS(1:3).EQ.'END')GOTO 800
      IF(ANS(1:1).EQ.'N')GOTO 115
      ANAM(NAMLEN+2:NAMLEN+4)='CRD'
1051  TYPE 1050,ANAM
1050  FORMAT(' For coord cards, do you want coordinates',/,
     1'  1) Taken from SFLS (only if DISTAN follows SFLS in same job',/,
     2' [2] Taken from your latest ',A16,' file',/,
     3'  3) Entered by hand',/,
     4' ENTER NUMBER.')
      READ(5,1000,ERR=922)I
      IF(I.EQ.0)I=2
1052  IF(I.EQ.1)THEN
        CARD(1:16)='COORD IN STORAGE'
        N4=16
        TYPE 2,CARD(1:N4)
        WRITE(4,1)CARD(1:N4)
      ELSE
        IF(I.EQ.2)THEN
          TYPE*,'Do you want hydrogens (if any) included? Y/[N]'
          ACCEPT 1,ANS
          OPEN(NAME=ANAM,UNIT=12,TYPE='OLD',FORM='FORMATTED',
     1    BLOCKSIZE=32768,ERR=923)
1053      READ(12,1,END=1054)CARD
          IF(CARD(1:3).EQ.'END')GOTO 1054
          IF(CARD(1:4).NE.'COOR')GOTO 1053
          IF(ANS(1:1).NE.'Y'.AND.CARD(13:15).EQ.'HS ')GOTO 1053
          WRITE(4,1)CARD
          TYPE 2,CARD
          GOTO 1053
1054      CLOSE(UNIT=12,DISP='SAVE')
        ENDIF
      ENDIF
      IF(I.NE.3)THEN
        TYPE*,'Do you want to enter any additional coordinates? Y/[N]'
        ACCEPT 1,ANS
        IF(ANS(1:1).NE.'Y')GOTO 115
      ENDIF
      CALL COORDIN(2,MC)
115   TYPE*,'Do you want to calculate any torsional angles? "END" ',
     1'to end. Y/[N]'
      ACCEPT 1,ANS
      IF(ANS(1:3).EQ.'END')GOTO 800
      IF(ANS(1:1).NE.'Y')GOTO 118
      TYPE*,'Enter your four atom identifiers (4 alphanumeric ',
     1'characters each) separated by commas, to calculate torsional ',
     2'angle about the line joining the 2nd and 3rd atoms.  Type ',
     3'"DONE" when done.'
116   TYPE*,'1111,2222,3333,4444     (DONE to quit.)'
      READ(5,1160)C1,CHAR1,C2,CHAR1,C3,CHAR1,C4
1160  FORMAT(3(A4,A1),A4)
      IF(C1.EQ.'DONE')GOTO 118
      ENCODE(80,117,CARD)C1,C2,C3,C4
      N4=27
117   FORMAT('TORSION',1X,A4,1X,A4,1X,A4,1X,A4)
      TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
      GOTO 116
118   TYPE*,'Do you want to enter anisotropic parameters? ',
     1'"END" to end. Y/[N]'
      ACCEPT 1,ANS
      IF(ANS(1:3).EQ.'END')GOTO 800
      IF(ANS(1:1).NE.'Y')GOTO 125
      ANAM(NAMLEN+2:NAMLEN+4)='CRD'
1181  TYPE 1180,ANAM
1180  FORMAT(' Do you want ANISO data',/,
     1'  1) Taken from SFLS (only if DISTAN follows SFLS in same job',/,
     2'  2) Taken from your latest ',A16,' file',/,
     3' [3] Entered by hand',/,
     4' ENTER NUMBER.')
      READ(5,1000,ERR=925)I
      IF(I.EQ.0)I=3
1182  IF(I.EQ.1)THEN
        CARD(1:16)='ANISO IN STORAGE'
        N4=16
        TYPE 2,CARD(1:N4)
        WRITE(4,1)CARD(1:N4)
      ELSE
        IF(I.EQ.2)THEN
          OPEN(NAME=ANAM,UNIT=12,TYPE='OLD',FORM='FORMATTED',
     1    BLOCKSIZE=32768,ERR=926)
1183      READ(12,1,END=1184)CARD
          IF(CARD(1:3).EQ.'END')GOTO 1184
          IF(CARD(1:4).NE.'ANIS')GOTO 1183
          WRITE(4,1)CARD
          TYPE 2,CARD
          GOTO 1183
1184      CLOSE(UNIT=12,DISP='SAVE')
        ENDIF
      ENDIF
      IF(I.NE.3)THEN
        TYPE*,'Do you want to enter any additional ANISO''s? Y/[N]'
        ACCEPT 1,ANS
        IF(ANS(1:1).NE.'Y')GOTO 125
      ENDIF
      CALL COORDIN(5,MC)
125   TYPE*,'Do you want to request the calculation of any SYMMETRY ',
     1'TRANSFORMATIONS?  ("END" to end) Y/[N]'
      ACCEPT 1,ANS
      IF(ANS(1:3).EQ.'END')GOTO 800
      IF(ANS(1:1).NE.'Y')GOTO 132
      TYPE*,'Do you want to calculate all transformations up to a ',
     2'given cutoff? [Y]/N'
      ACCEPT 1,ANS
      IF(ANS(1:1).EQ.'N')THEN
C123456789 123456789 123456789 123456789 123456789 123456789 123456789 
126     TYPE*,'Enter A, B, C and D from Ax+By+Cz+D separated by commas.'
        READ(5,127,ERR=907)A,B,C,D
        TYPE*,'Enter E, F, G and H from Ex+Fy+Gz+H separated by commas.'
        READ(5,127,ERR=907)E,F,G,H
        TYPE*,'Enter P, Q, R and S from Px+Qy+Rz+S separated by commas.'
        READ(5,127,ERR=907)AA,BB,CC,DD
127     FORMAT(4F8.3)
        ENCODE(80,128,CARD,ERR=907)A,B,C,D,E,F,G,H,AA,BB,CC,DD
        N4=78
128     FORMAT('SYM',3X,12F6.3)
        TYPE 2,CARD(1:N4)
        WRITE(4,1)CARD(1:N4)
        TYPE*,'Any more transformations to be entered? Y/[N]'
        ACCEPT 1,ANS
        IF(ANS(1:1).EQ.'Y')GOTO 126
      ELSE
        ICYES=1
130     TYPE*,'Enter distance to generate all transformations which ',
     1  'will place one or more of the atoms within this distance ',
     2  'from the asymmetric unit.'
        READ(5,2000,ERR=908)A
        TYPE*,'Do you want to create a CRD file of SYM cards? Y/[N]'
        ACCEPT 1,ANS
        CHAR1=' '
        IF(ANS(1:1).EQ.'Y')CHAR1='1'
        TYPE*,'Do you want more than 50 transformations to be ',
     1  'printed? Y/[N]'
        ACCEPT 1,ANS
        IF(ANS(1:1).EQ.'Y')THEN
C23456789 123456789 123456789 123456789 123456789 123456789 123456789 
          TYPE*,'Enter number of transformations to be generated ',
     1    '(<=500).'
          READ(5,1000,ERR=908)IB
          ENCODE(80,131,CARD,ERR=908)A,CHAR1,IB
          N4=24
131       FORMAT('SYM ALL',1X,F10.2,1X,A1,1X,I3)
        ELSE
          ENCODE(80,131,CARD,ERR=908)A,CHAR1
          N4=20
        ENDIF
        TYPE 2,CARD(1:N4)
        WRITE(4,1)CARD(1:N4)
      ENDIF
      type*,'Do you want the ORTHOG OPTION to request the printing of',
     1'the fractional and orthogonalized coordinates of symmetry ',
     2'transformed atoms? "END" to end. Y/[N]'
      ACCEPT 1,ANS
      IF(ANS(1:3).EQ.'END')GOTO 800
      IF(ANS(1:1).NE.'Y')GOTO 132
      N4=6
      CARD(1:N4)='ORTHOG'
      TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
132   IF(ICYES.EQ.0)GOTO 1327
      TYPE*,'Do you want the connect option? "END" to end. Y/[N]'
      ACCEPT 1,ANS
      IF(ANS(1:3).EQ.'END')GOTO 800
      IF(ANS(1:1).NE.'Y')GOTO 1327
1322  TYPE*,'Enter minimum and maximum BOND LENGTHS, in Angstroms,'
      TYPE*,'separated by a comma. (2F5.2)'
      READ(5,1323,ERR=930)A,B
1323  FORMAT(2F5.2)
      CARD(1:8)='CONNECT '
      ENCODE(10,1323,CARD(9:18),ERR=930)A,B
      N4=18
      TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
1327  TYPE*,'Do you want any interatomic distances calculated? "END" ',
     1'to end. [Y]/N'
      ACCEPT 1,ANS
      IF(ANS(1:3).EQ.'END')GOTO 800
      IF(ANS(1:1).EQ.'N')GOTO 140
      TYPE*,' Do you want all distances less than a given maximum to ',
     1'be calculated? [Y]/N'
      ACCEPT 1,ANS
      IF(ANS(1:1).NE.'N')THEN
134     TYPE*,'Enter one or two numbers - all interatomic distances ',
     1  'below these will be generated.'
        type*,'Second number applies to distances involving HS atoms.',
     1  ' [1.6,=first]'
        READ(5,2000,ERR=909)A,AA
        if(a.eq.0.0)a=1.6
        if(aa.eq.0.0)aa=a
        TYPE*,'Enter minimum distance - all distances between this ',
     1  'minimum and the maximum will be generated. [0.0] '
        READ(5,2000,ERR=909)B
        IF(A.LT.B)THEN
          TYPE*,'Max less than min.  No distances calculated. ',
     1    'Try again.'
          GOTO 134
        ENDIF
        ENCODE(80,135,CARD,ERR=909)A,B,aa
        N4=39
135     FORMAT('DIST ALL',1X,3F10.2)
        TYPE 2,CARD(1:N4)
        WRITE(4,1)CARD(1:N4)
        TYPE*,'Do you want to request the calculation of ',
     1  'any additional distances? Y/[N]'
        ACCEPT 1,ANS
        IF(ANS(1:1).NE.'Y')GOTO 140
      ENDIF
      TYPE*,'Enter 2 atom identifiers (4 alphanumeric characters ',
     1'each) separated by commas, to request the distance between ',
     2'them.  If you want to apply symmetry to the 1st atom, enter ',
     3'the transformation number separated by a comma.  Type "DONE" ',
     4'when done.'
136   TYPE*,'1111,2222(,sym)    (DONE to quit)'
      READ(5,137,ERR=910)C1,CHAR1,C2,CHAR1,I
      IF(C1.EQ.'DONE')GOTO 140
      IF(I.NE.0)THEN
      ENCODE(80,138,CARD,ERR=910)C1,C2,I
      N4=21
      ELSE
      ENCODE(80,138,CARD,ERR=910)C1,C2
      N4=14
      ENDIF
      TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
137   FORMAT(A4,A1,A4,A1,I5)
138   FORMAT('DIST',2X,2A4,:,3X,I4)
      GOTO 136
140   TYPE*,'Do you want to request any angle calculations? "END" to ',
     1'end. [Y]/N'
      ACCEPT 1,ANS
      IF(ANS(1:3).EQ.'END')GOTO 800
      IF(ANS(1:1).EQ.'N')GOTO 148
      TYPE*,'Do you want to request all angles less than a given ',
     1'maximum? [Y]/N'
      ACCEPT 1,ANS
      IF(ANS(1:1).NE.'N')THEN
141   TYPE*,'Do you need to change the distance default of 1.6? This ',
     1'default will calculate all angles abc whose lengths AB and BC ',
     2'are less than 1.6. Y/[N]'
      ACCEPT 1,ANS
      IF(ANS(1:1).NE.'Y')THEN
        A=1.6
      ELSE
        TYPE*,'Enter distance.'
        READ(5,2000,ERR=911)A
      ENDIF
      ENCODE(80,142,CARD,ERR=911)A
      N4=16
142   FORMAT('ANGLE ALL',1X,F6.2)
      TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
      TYPE*,'Do you want to request any additional angle calculations?',
     1' Y/[N]'
      ACCEPT 1,ANS
      IF(ANS(1:1).NE.'Y')GOTO 148
      ENDIF
      TYPE*,'Enter 3 atom identifiers (4 alphanumeric characters ',
     1'each) separated by commas to request calculation of the angle ',
     2'between the three atoms with the 2nd being the apex atom.  If ',
     3'you want to apply symmetry to atoms 1 and/or 3, type the ',
     4'transformation number(s) separated by commas (1st ',
     5'transformation applied to atom 1).  Type "DONE" when done.'
143   TYPE*,'1111,2222,3333(,sym-1)(,sym-3)     (DONE to quit)'
      READ(5,144,ERR=912)C1,CHAR1,C2,CHAR1,C3,CHAR1,I,J
144   FORMAT(3(A4,A1),2I5)
      IF(C1.EQ.'DONE')GOTO 148
      IF(I.NE.0.OR.J.NE.0)THEN
      ENCODE(80,145,CARD,ERR=912)C1,C2,C3,I,J
      N4=28
      ELSE
      ENCODE(80,145,CARD,ERR=912)C1,C2,C3
      N4=19
      ENDIF
145   FORMAT('ANGLE',2X,3A4,:,1X,2I4)
      TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
      GOTO 143
148   TYPE*,'Do you want to request the calculation of any "best" ',
     1'planes?  ("END" to end) Y/[N]'
      ACCEPT 1,ANS
      IF(ANS(1:1).NE.'Y')GOTO 800
149   TYPE*,'Do you want to request the calculations for two planes ',
     1'calculating the dihedral angle between them as well? Y/[N]'
      ACCEPT 1,ANS
      PLANE='PLANE'
      IF(ANS(1:1).EQ.'Y')PLANE='TWOPL'
      TYPE*,'Do you want full plane output? Y/[N]'
      ACCEPT 1,ANS
      CHAR1=' '
      IF(ANS(1:1).EQ.'Y')CHAR1='F'
      I=1
      II=1
      K=1
      DO 1501 LL=1,100
      CHAR(LL)='    '
1501  ISYM(LL)=0
      IF(PLANE(1:1).EQ.'T')TYPE*,'For first plane, '
150   TYPE*,'Enter 1 atom identifier (4 alphanumeric characters) of ',
     1'atom in plane.  If you want to apply symmetry to the atom, ',
     2'enter the transformation number, separated by a comma. Type ',
     3'"DONE" when done.'
151   TYPE*,'IIII(,sym)   (DONE if done)'
      READ(5,152,ERR=915)CHAR(I),CH1,ISYM(I)
152   FORMAT(A4,A1,I4)
      IF(CHAR(I).EQ.'DONE')THEN
        CHAR(I)='    '
        I=I-1
        GOTO 153
      ENDIF
      I=I+1
      GOTO 151
153   JJ=10
      N4=80
      TYPE*,'Enter PLANE IDENTIFIER - RETURN if none.'
      ACCEPT 1,CHAR2
      ENCODE(80,154,CARD,ERR=915)PLANE,CHAR1,(CHAR(J),ISYM(J),J=1,9),
     1 CHAR2
      TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
1530  IF(JJ.GT.I)GOTO 157
      ENCODE(80,155,CARD,ERR=915)(CHAR(J),ISYM(J),J=JJ,JJ+8),CHAR2
154   FORMAT(A5,A1,9(A4,I4),A2)
155   FORMAT(6X,9(A4,I4),A2)
      TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
      JJ=JJ+9
      GOTO 1530
157   IF(PLANE(1:1).EQ.'T'.AND.II.EQ.1)THEN
      ITW=1
      GOTO 1600
1571  ITW=0
      TYPE*,'For second plane, '
      II=0
      I=1
      DO 156 JJ=1,100
      ISYM(JJ)=0
156   CHAR(JJ)='    '
      GOTO 150
      ENDIF
      IF(PLANE(1:1).EQ.'T')THEN
158   TYPE*,'Enter number of atoms common to both planes - RETURN if ',
     1'none.'
      READ(5,1000,ERR=916)I
      IF(I.NE.0)THEN
      ENCODE(80,159,CARD,ERR=916),I
159   FORMAT('NUMBER COMMON ATOMS',1X,I2)
      N4=22
      TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
      ENDIF
      ENDIF
      TYPE*,'Do you want to create a general card for this ',
     1'calculation?  If "Y" the card will be found in name.GEN upon ',
     2'completion. Y/[N]'
      ACCEPT 1,ANS
      IF(ANS(1:1).NE.'Y')GOTO 1600
1601  TYPE*,'Enter the map scale in inches/A.  RETURN for default of 1.'
      READ(5,2000,ERR=928)A
      IF(A.EQ.0.0)A=1.0
1602  TYPE*,'Enter the vertical and horizontal map widths in A., ',
     1'separated by a comma.  RETURN for default 10. X 10.'
      READ(5,1603,ERR=929)B,C
1603  FORMAT(2F7.3)
      IF(B.EQ.0.0)B=10.
      IF(C.EQ.0.0)C=10.
      TYPE*,' Enter X, Y or Z to specify which direction should be ',
     1'constant horizontal.  RETURN for X.'
      ACCEPT 1,CHAR1
      I=1
      IF(CHAR1.EQ.'Y')I=2
      IF(CHAR1.EQ.'Z')I=3
      TYPE*,'Enter map identifier up to 10 characters.  RETURN if none.'
      ACCEPT 1,GNAME
      ENCODE(80,1604,CARD,ERR=928)A,B,C,I,GNAME
1604  FORMAT('GEN ',3F6.3,I2,A10)
      N4=34
      TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
1600  TYPE*,'Do you want to change the weights of any of the atoms ',
     1'involved in the plane calculation from 1.0? ("END" to end) Y/[N]'
      ACCEPT 1,ANS
      IF(ANS(1:3).EQ.'END')GOTO 800
      IF(ANS(1:1).NE.'Y')GOTO 180
      TYPE*,'Do you want to assign weights of 1/Sigma or 1/Sigma**2 ',
     1'to all atoms?  "Y" only if Sigmas have been previously ',
     2'assigned to all atoms involved. [Y]/N'
      ACCEPT 1,ANS
      IF(ANS(1:1).NE.'N')THEN
160   TYPE*,'[1]1/Sigma or                                 ',
     1' 2)1/Sigma**2     (ENTER "1" or "2")'
      READ(5,1000,ERR=917)I
      IF(I.EQ.2)THEN
        CARD(1:22)='WEIGHT=1/SIGMA SQUARED'
        N4=22
      ELSE
        CARD(1:14)='WEIGHT=1/SIGMA'
        N4=14
      ENDIF
      TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
      TYPE*,'Do you want to make any additional weight changes? Y/[N]'
      ACCEPT 1,ANS
      IF(ANS(1:1).NE.'Y')GOTO 180
      ENDIF
      WEIGHT='WEIGHT'
      I=1
      J=1
      K=1
      TYPE*,'Enter 1 atom identifier (4 alphanumeric characters) and ',
     1'the weight of that atom, separated by a comma.  "DONE" when ',
     2'done.'
163   TYPE 1630,WEIGHT
1630  FORMAT(1X,'IIII,',A6,'   DONE to quit.')
      READ(5,164,ERR=918)CHAR(I),CHAR1,W(I)
      IF(CHAR(I).EQ.'DONE')GOTO 165
164   FORMAT(A4,A1,F5.2)
      I=I+1
      IF(I.GT.9)GOTO 165
      GOTO 163
165   IF(I.EQ.1)GOTO 170
      N4=6+8*(I-1)
      IF(J.EQ.1)THEN
      ENCODE(80,166,CARD,ERR=918)WEIGHT,(CHAR(II),W(II),II=1,I-1)
      J=O
166   FORMAT(A6,9(A4,F4.1))
      ELSE
      ENCODE(80,167,CARD,ERR=918)(CHAR(II),W(II),II=1,I-1)
      ENDIF
167   FORMAT(6X,9(A4,F4.1))
      TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
      IF(I.GT.9)THEN
      I=1
      GOTO 163
      ENDIF
170   IF(K.NE.1)GOTO 800
180   K=0
      I=1
      J=1
      WEIGHT='SIGMA '
      TYPE*,'Do you want to change the Sigmas of any of the atoms ',
     1'involved in the plane calculation from .1?  ("END" to end) ',
     2'Y/[N]'
      ACCEPT 1,ANS
      IF(ANS(1:3).EQ.'END')GOTO 800
      IF(ANS(1:1).NE.'Y')THEN
      IF(ITW.EQ.1)GOTO 1571
      TYPE*,'Any more plane calculations? Y/[N]'
      ACCEPT 1,ANS
      IF(ANS(1:1).NE.'Y')GOTO 800
      GOTO 149
      ENDIF
      TYPE*,'Do you want to use the previously assigned values of ',
     1'Sigma?  "Y" only if Sigmas have been assigned to all atoms ',
     2'involved. [Y]/N'
      ACCEPT 1,ANS
      IF(ANS(1:1).NE.'N')THEN
      CARD(1:16)='SIGMA IN STORAGE'
      N4=16
      TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
      TYPE*,'Do you want to make any additional Sigma changes? Y/[N]'
      ACCEPT 1,ANS
      IF(ANS(1:1).NE.'Y')GOTO 800
      ENDIF
      TYPE*,'Enter 1 atom identifier (4 alphanumeric characters) and ',
     1'the desired sigma for that atom, separated by a comma.  Type ',
     2'"DONE" when done.'
      GOTO 163
800   IF(ITW.EQ.1)GOTO 1571
      CARD(1:10)='END DISTAN'
      N4=10
      TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
      RETURN
999   FORMAT(' ERROR ON LAST CARD ENTERED - TRY AGAIN.')
901   TYPE 999
      GOTO 100
902   TYPE 999
      GOTO 102
908   TYPE 999
      GOTO 130
907   TYPE 999
      GOTO 126
909   TYPE 999
      GOTO 134
910   TYPE 999
      GOTO 136
911   TYPE 999
      GOTO 141
912   TYPE 999
      GOTO 143
915   TYPE 999
      GOTO 151
916   TYPE 999
      GOTO 158
917   TYPE 999
      GOTO 160
918   TYPE 999
      GOTO 163
919   TYPE 999
      GOTO 1015
920   TYPE 921,ANAM
921   FORMAT(' FILE ',A16,' NOT FOUND.  YOU WILL HAVE TO ENTER',/,
     1' CELL PARAMETERS BY HAND.')
      I=3
      GOTO 1011
922   TYPE 999
      GOTO 1051
923   TYPE 924,ANAM
924   FORMAT(' FILE ',A16,' NOT FOUND.  YOU WILL HAVE TO ENTER',/,
     1' COORDS BY HAND.')
      I=3
      GOTO 1052
925   TYPE 999
      GOTO 1181
926   TYPE 927,ANAM
927   FORMAT(' FILE ',A16,' NOT FOUND.  YOU WILL HAVE TO ENTER',/,
     1' ANISOS BY HAND.')
      I=3
      GOTO 1182
928   TYPE 999
      GOTO 1601
929   TYPE 999
      GOTO 1602
930   TYPE 999
      GOTO 1322
      END
