      INTEGER*4 FUNCTION FILESTAT(NAME)
C      attempt to open a file for exclusive access. return the status.
c      we are interested in the status for the inf file.
      CHARACTER*(*) NAME
      INTEGER*4 SYS$OPEN, STAT
      INCLUDE '($FABDEF)'
      INCLUDE '($RMSDEF)'
      RECORD /FABDEF/ FAB
C   Set up the RMS File Access Block
C   Identify it as a FAB
      FAB.FAB$B_BID=FAB$C_BID
C   Specify the length of the block
      FAB.FAB$B_BLN = FAB$C_BLN
C   Put the address of the filename in the FAB
      FAB.FAB$L_FNA = %LOC(NAME)
C   Compute the length of the filename and store that in the FAB
      J = LEN(NAME)
      FAB.FAB$B_FNS = 0
      DO 10 I=1, J
      IF (NAME(I:I) .EQ. ' ') GOTO 20
10    FAB.FAB$B_FNS = I
C   Set filesharing option to NIL, requiring exclusive access
20    FAB.FAB$B_SHR = 1 
      DO 30 I = 1, FAB$V_NIL
30    FAB.FAB$B_SHR = 2 * FAB.FAB$B_SHR
C   Set file access option to GET (i.e., readonly)
      FAB.FAB$B_FAC = 1
      DO 40 I = 1, FAB$V_GET
40    FAB.FAB$B_FAC = 2 * FAB.FAB$B_FAC
C   Attempt to open the file 
      STAT = SYS$OPEN(FAB)
C   Close the file if necessary
      IF (STAT .EQ. RMS$_NORMAL) THEN
           CALL SYS$CLOSE(FAB)
      ENDIF
C   Return status of attempt to open the file
      FILESTAT = STAT
      RETURN
      END
      
