      SUBROUTINE PREORTEP
      CHARACTER*80 CARD,CARD1
      CHARACTER*1 CHAR1
      CHARACTER*16 ANAM
      CHARACTER*6 ANS
      CHARACTER*4 CHSYM
      DIMENSION CELL(6),T1(4),T2(4),T3(4),AII(4),AJJ(8),AA(9),STUFF(11),
     1 II(4)
      COMMON/FNAME/ANAM,NAMLEN
10    FORMAT(A)
11    FORMAT(I1,F14.3,3F3.0,F15.3,3F3.0,F15.3,3F3.0)
12    FORMAT(3F9.4,:,3F9.4)
101   FORMAT(1X,A)
25    FORMAT(F9.3,:,F9.3)
250   FORMAT(F9.0,:,F9.0)
30    FORMAT(F14.8)
8     FORMAT(A6,3X,2F9.6,:,F9.6,I9)
88    FORMAT(2X,A4,21X,3F9.6,I9)
9      FORMAT(1X,F8.5,5F9.5,I9)
28     FORMAT(F7.3,3F4.0)
29    FORMAT(F4.0,:,2F4.0)
51    FORMAT(2F9.6,:,F9.6)
1013  FORMAT(I3,I6,4F9.0,F9.4,:,2F9.4)
1021  FORMAT(I3,6X,4I3,3X,2F6.2)
1031  FORMAT(I3,I6,:,F9.4,:,3F9.4)
3021  FORMAT(I3,I6,F9.0,:,F9.0,:,5F9.0)
4012  FORMAT(I3,I6,:,7F9.0)
4031  FORMAT(3X,I6,4F9.0,3F9.4)
5013  FORMAT(3X,I6,5F9.0,9X,F9.0)
5022  FORMAT(F9.2)
8039  FORMAT(I3,6X,5I3,7F6.2,F6.0)
9168  FORMAT(I3,I6,F9.0,F9.2,5F9.4)
9170  FORMAT(9X,F9.0,:,F9.0)
      NATOMS=0
      NSYM=1
      IFLAG=0
c      TYPE *,'The purpose of this program is to help you prepare'
c      type *,'input to ORTEP.'
58    TYPE*,' '
      TYPE*,'Enter number for version or more information - '
      TYPE*,'1)  The "NO BRAINER"'
      TYPE*,'[2])The "BASIC" and'
      TYPE*,'3)  The "DETAILED"'
      TYPE*,'4)  Detailed description of the above options"'
      ACCEPT 10,ANS
      if(ans(1:1).ne.'1' .and. ans(1:1).ne.'3' .and. ans(1:1).ne.'4')
    1    ans(1:)='2'
      IF(ANS(1:1).EQ.'4')THEN
        TYPE*,' '
        TYPE*,'1)THE "NO BRAINER"'
        TYPE*,'THIS WILL CREATE A PRE-DESIGNED ORTEP INPUT FILE WHICH ',
     1  'WILL PROVIDE FOR A VERY BASIC ORTEP VIEW OF A SINGLE ',
     2  'MOLECULE TO BE VIEWED ON A TERMINAL.  PROVISIONS ARE AS ',
     3  'FOLLOWS:'
        TYPE*,'  A)NO ADDITIONAL SYMMETRY-RELATED ATOMS ARE GENERATED ',
     1  '(MOST SUCH SYMMETRIES CAN BE GENERATED WHEN PREPARING THE ',
     2  'NAME.CVT FILE);'
        TYPE*,'  B)THE VIEW DIRECTION IS PERPENDICULAR TO THE LEAST-',
     1  'SQUARES PLANE OF ALL THE ATOMS;'
        TYPE*,'  C)ALL ATOMS ARE PLOTTED IN OUTLINE ONLY - EITHER ',
     1  'ELLIPSES OR CIRCLES ("50 PERCENT PROBABILITY");'
        TYPE*,'  D)ALL BONDS BETWEEN 0.5 AND 2.1 ANGSTROMS IN LENGTH ',
     1  'ARE DRAWN - TWO LINES 0.08 ANGSTROMS APART (THUS, HYDROGEN ',
     2  'ATOMS SHOULD PROBABLY BE DELETED WHEN PREPARING THE NAME.CVT ',
     3  'FILE);'
        TYPE*,'  E)OVERLAP IS REMOVED;'
        TYPE*,'  F)A SINGLE VIEW IS MADE, FROM A VIEWING DISTANCE OF ',
     1  '30 INCHES.'
        TYPE*,'  G)NO LABELLING IS PROVIDED.'
        TYPE*,'THIS DATA FILE CAN, OF COURSE BE EDITED TO PROVIDE ',
     1  'SOMEWHAT MORE SOPHISTICATED DRAWINGS.  FOR A FINAL, ',
     2  'PUBLISHABLE DRAWING, HOWEVER, IT IS PROBABLY BETTER TO ',
     3  'ASSEMBLE THE DATA FILE FROM EITHER THE "BASIC" OR THE ',
     4  '"DETAILED" INPUT ROUTINE.'
        TYPE*,' '
        TYPE*,'RETURN TO CONTINUE.'
        ACCEPT 10,ANS
        GOTO 58
      ENDIF
      IKIND=3
      IF(ANS(1:1).EQ.'2')IKIND=2
      IF(ANS(1:1).EQ.'1')IKIND=1
      IF(IKIND.EQ.1)THEN
        CARD(1:1)=' '
        WRITE(4,10)CARD(1:1)
       ELSE
        TYPE *,'Enter a job title, up to 72 characters (a comment to ',
     1'describe the plot).'
        ACCEPT 10,CARD(1:72)
        WRITE(4,10)CARD(1:72)
        TYPE 101,CARD(1:72)
      ENDIF
      I=NAMLEN+1
      ANAM(I:I+3)='.HKL'
      ILEN=I+1
      TYPE 54,ANAM
54    FORMAT(' Do you want your cell parameters taken from your',/,
     1' latest ',a16,' file?')
c add option for .inf file
      ACCEPT 10,ANS
      IF(ANS(1:1).NE.'Y')THEN
4       TYPE *,' ENTER 6 CELL PARAMETERS, SEPARATED BY COMMAS'
        TYPE *,' A,B,C,ALPHA,BETA,GAMMA'
        READ(5,12,ERR=9901)CELL
      ELSE
        OPEN(NAME=ANAM,UNIT=12,TYPE='OLD',FORM='UNFORMATTED',
     1  BLOCKSIZE=32768,ERR=9964)
        READ(12)STUFF,CELL
        CLOSE(UNIT=12,DISP='SAVE')
      ENDIF
      ENCODE (80,12,CARD,ERR=9901)CELL
      N4=54
      WRITE(4,10)CARD(1:N4)
      TYPE 101,CARD
      IF(IKIND.EQ.1)THEN
        TYPE*,' '
        TYPE*,'IDENTITY SYMMETRY TRANSFORMATION INCLUDED.'
        ANS(1:1)='N'
        GOTO 53
      ENDIF
      TYPE*,'Do you need to generate any symmetry operations?  The ',
     1'identity operation is automatically included.  (pp. 30-31)'
      ACCEPT 10,ANS
53    N=0
      IF(ANS(1:1).NE.'Y')N=1
      DO 50 I=1,4
        T1(I)=0.
        T2(I)=0.
        T3(I)=0.
50    CONTINUE
      T1(2)=1.
      T2(3)=1.
      T3(4)=1.
      ENCODE(80,11,CARD)N,T1,T2,T3
      N4=72
      TYPE 101,CARD(1:N4)
      WRITE(4,10)CARD(1:N4)
      IF(N.EQ.1)GOTO 108
1       TYPE*,'ENTER T1,S11,S12 AND S13 SEPARATED BY COMMAS WHERE'
        TYPE*,'X1=T1+S11X+S12Y+S13Z'
        TYPE*,'T1 IS REAL.'
        READ(5,28,ERR=9902)T1
        TYPE*,'ENTER T2,S21,S22 AND S23 SEPARATED BY COMMAS WHERE'
        TYPE*,'Y1=T2+S21X+S22Y+S23Z'
        TYPE*,'T2 IS REAL.'
        READ(5,28,ERR=9902)T2
        TYPE*,'ENTER T3,S31,S32 AND S33 SEPARATED BY COMMAS WHERE'
        TYPE*,'Z1=T3+S31X+S32Y+S33Z'
        TYPE*,'T3 IS REAL.'
        READ(5,28,ERR=9902)T3
      TYPE*,'ANY MORE SYMMETRY OPERATIONS TO BE ENTERED?'
      ACCEPT 10,ANS
      N=0
      IF(ANS(1:1).EQ.'N')N=1
      ENCODE(80,11,CARD,ERR=9902)N,T1,T2,T3
      NSYM=NSYM+1
      N4=72
      TYPE 101,CARD
      WRITE(4,10)CARD(1:N4)
      IF(N.EQ.0)GOTO 1
108   I=ILEN
      ANAM(I:I+2)='CVT'
      TYPE 1081,ANAM
1081  FORMAT(' ARE YOUR COORDINATES AND TEMPERATURE FACTORS',/,
     1' COMING FROM YOUR LATEST ',A16,' FILE?')
      ACCEPT 10,ANS
      IF(ANS(1:1).NE.'N')THEN
        N4=72
        OPEN(NAME=ANAM,UNIT=12,TYPE='OLD',FORM='FORMATTED',
     1  BLOCKSIZE=32768,ERR=9966)
1082    IF(NATOMS.NE.0)THEN
          TYPE 101,CARD(1:N4)
          WRITE(4,10)CARD(1:N4)
        ENDIF
        NATOMS=NATOMS+1
        READ(12,10)CARD
        TYPE 101,CARD(1:N4)
        WRITE(4,10)CARD(1:N4)
        READ(12,10)CARD
        IF(CARD(1:1).NE.'1')GOTO 1082
        CLOSE(UNIT=12,DISP='SAVE')
        TYPE*,'DO YOU WISH TO ADD ANY ADDITIONAL ATOMS (LIKE RING ',
     1  'CENTROIDS) NOT INCLUDED IN YOUR CVT FILE?'
        ACCEPT 10,ANS
        IF(ANS(1:1).EQ.'Y')CARD(1:1)=' '
        TYPE 101,CARD(1:N4)
        WRITE(4,10)CARD(1:N4)
        IF(ANS(1:1).NE.'Y')GOTO 3
      ENDIF
1083  TYPE *,'ENTER ATOM IDENTIFIER'
      TYPE*,'RETURN IF DONE.'
       ACCEPT 10,CHSYM
      IF(CHSYM.EQ.'    ')GOTO 260
      IF(IFLAG.NE.0)THEN
        TYPE 101,CARD(1:N4)
        WRITE(4,10)CARD(1:N4)
      ENDIF
      IFLAG=1
5     TYPE *,' ENTER X,Y,Z, SEPARATED BY COMMAS.'
      READ(5,51,ERR=9903)A,B,C
      ITTT=0
      ENCODE (80,88,CARD,ERR=9903)CHSYM,A,B,C,ITTT
      N4=63
      WRITE (4,10)CARD(1:N4)
      TYPE 101,CARD
26    TYPE*,'1)ANISOTROPIC B''S'
      TYPE*,'2)ANISOTROPIC U''S  OR'
      TYPE*,'3)ISOTROPIC B'
      TYPE*,'4)R (RADIUS)?'
      TYPE*,'ENTER NUMBER OF DESIRED TYPE OF TEMPERATURE FACTOR.'
      READ(5,250,ERR=9904)A
      N=A
      IF(N.EQ.1)THEN
        TYPE*,'ENTER B11,B22,B33,B12,B13 AND B23 SEPARATED BY COMMAS'
        TYPE*,'ACCORDING TO TYPE 0 (PAGE 33).'
        READ(5,12,ERR=9904)CELL
        NN=0
      ELSE
        IF(N.EQ.2)THEN
          TYPE*,'ENTER U11,U22,U33,U12,U13 AND U23 SEPARATED BY COMMAS'
          TYPE*,'ACCORDING TO TYPE 8 (PAGE 33).'
          READ(5,12,ERR=9904)CELL
          NN=8
        ELSE
          IF(N.EQ.4)THEN
            TYPE*,'ENTER THE RADIUS IN ANGSTROMS.'
            READ(5,12,ERR=9904)CELL
            NN=7
        ELSE
          TYPE*,'ENTER B'
          READ(5,12,ERR=9904)CELL
          NN=6
      ENDIF
      ENDIF
      ENDIF
      ENCODE(80,9,CARD,ERR=9904)CELL,NN
      NATOMS=NATOMS+1
      N4=63
      GOTO 1083
260   CARD(1:1)='1'
      TYPE 101,CARD(1:N4)
      WRITE(4,10)CARD(1:N4)
3     TYPE*,' '
      TYPE*,' '
       TYPE *,'        INSTRUCTION INPUT'
      INO=0
      IF(IKIND.EQ.2)GOTO 2000
      GOTO 49
491   WRITE(4,10)CARD(1:N4)
      TYPE 101,CARD(1:N4)
49    IL=0
      IF(IKIND.EQ.1)GOTO 1000
      IF(IKIND.EQ.2)GOTO 2003
      TYPE*,'ENTER NEXT INSTRUCTION NUMBER WANTED - FOR EXAMPLE 201.'
      TYPE*,' 100 SERIES:  STRUCTURE ANALYSIS INSTRUCTIONS (PP. 35-37)'
      TYPE*,' 200 SERIES:  PLOTTER CONTROL INSTRUCTIONS (P. 37)'
      TYPE*,' 300 SERIES:  PLOT BOUNDARY INSTRUCTIONS (PP. 37-38)'
      TYPE*,' 400 SERIES:  ATOMS LIST INSTRUCTIONS (PP. 39-40)'
      TYPE*,' 500 SERIES:  ORIENTING INSTRUCTIONS (PP. 40-42)'
      TYPE*,' 600 SERIES:  POSITIONING AND SCALING INSTRUCTIONS ',
     1'(PP. 42-44)'
      TYPE*,' 700 SERIES:  ATOM PLOTTING INSTRUCTIONS (PP. 44-47)'
      TYPE*,' 800 SERIES:  BOND PLOTTING INSTRUCTIONS (PP. 47-49)'
      TYPE*,' 900 SERIES:  LABEL PLOTTING INSTRUCTIONS (PP. 49-51)'
      TYPE*,'1100 SERIES:  SAVED SEQUENCE INSTRUCTIONS (P. 51)'
      TYPE*,'RETURN TO QUIT.'
      READ(5,250,ERR=9905)A
      INS=A
      IF(INS.LE.0)GOTO 99
      ISER=INS/100
      IM=MOD(INS,100)
      IF(ISER.LE.9.OR.ISER.EQ.11)GOTO 493
492   TYPE*,'INCORRECT INSTRUCTION NUMBER. TRY AGAIN.'
      GOTO 49
493   GOTO(100,200,300,400,500,600,700,800,900,492,1100),ISER
100   IF(IM.GT.6.OR.IM.LT.1)GOTO 492
      GOTO(1019,1019,103,492,1019,1019),IM
C  HERE FOR 101,102,104,105
1019  TYPE*,'THIS INSTRUCTION WILL FIND ALL TARGET ATOMS WITHIN A ',
     1'SPHERE OF ENCLOSURE ABOUT A PARTICULAR ORIGIN ATOM.  SEE PAGES ',
     2'35-36 FOR FURTHER DESCRIPTION.'
1010  TYPE*,'ENTER TWO ATOM NUMBERS (I.E. 1,4) SEPARATED BY A COMMA ',
     1'TO SPECIFY THE ATOM NUMBER RUN OF ORIGIN ATOMS.'
      READ(5,250,ERR=9906)AII(1),AII(2)
      II(1)=AII(1)
      II(2)=AII(2)
1011  TYPE*,'ENTER TWO ATOM NUMBERS (I.E. 1,4) SEPARATED BY A COMMA ',
     1'TO SPECIFY THE ATOM NUMBER RUN OF TARGET ATOMS.'
      READ(5,250,ERR=9907)AII(3),AII(4)
      II(3)=AII(3)
      II(4)=AII(4)
      IF(INS.EQ.403.OR.INS.EQ.413)GOTO 4030
      IF(IL.EQ.2.OR.INS.EQ.812)THEN
1014    TYPE*,'ENTER A DISTANCE DMIN (A) TO SPECIFY THE MINIMUM BOND ',
     1'DISTANCE.  RETURN FOR DEFAULT OF .5 A.'
        READ(5,30,ERR=9909)B
        IF(B.EQ.0.0)B=0.5
      ENDIF
1012  TYPE*,'ENTER A DISTANCE DMAX (A) TO SPECIFY THE MAXIMUM BOND ',
     1'DISTANCE.  RETURN FOR DEFAULT OF 1.6 A.'
      READ(5,30,ERR=9908)A
      IF(A.EQ.0.0)A=1.6
      IF(INS.EQ.802.OR.INS.EQ.812)GOTO 8032
      IF(IL.EQ.2)GOTO 1020
      IF(IM.LE.2.OR.INS.EQ.412)THEN
        TYPE*,'VECTOR SEARCH CODES ALLOW FOR FURTHER SELECTION OF THE ',
     1'INTERATOMIC VECTORS FROM A PARTICULAR ORIGIN ATOM TO THE TARGET',
     2'ATOMS WHICH FALL WITHIN THE LIMITING SPHERE.'
        TYPE*,'DO YOU WANT TO ENTER ANY VECTOR SEARCH CODES?'
        ACCEPT 10,ANS
        IF(ANS(1:1).EQ.'Y')IL=2
      ENDIF
      ENCODE(80,1013,CARD,ERR=9906)IL,INS,(AII(I),I=1,4),A
      N4=54
      TYPE 101,CARD
      WRITE(4,10)CARD(1:N4)
      IF(IL.EQ.0)GOTO 49
      GOTO 1010
1020  TYPE*,'ANY MORE VECTOR SEARCH CODES?'
      ACCEPT 10,ANS
      IF(ANS(1:1).NE.'Y')IL=0
      ENCODE(80,1021,CARD,ERR=9906)IL,(II(I),I=1,4),B,A
      N4=36
      TYPE 101,CARD
      WRITE(4,10)CARD(1:N4)
      IF(IL.EQ.0)GOTO 49
      GOTO 1010
103   TYPE*,'THIS INSTRUCTION REQUESTS THE CALCULATION OF PRINCIPAL ',
     1'AXES OF THERMAL MOTION FOR ALL ATOMS IN THE INPUT LIST.'
1032  ENCODE(80,4031,CARD)INS
      N4=9
      GOTO 491
200   IF(IM.GT.6.OR.IM.LT.1)GOTO 492
      GOTO(201,202,492,492,492,206),IM
201   TYPE*,'THIS INSTRUCTION CALLS FOR PLOT INITIALIZATION.'
      GOTO 1032
202   TYPE*,'THIS INSTRUCTION PERFORMS PLOT TERMINATION AND PAPER ',
     1'POSITION FOR THE NEXT PLOT.'
      TYPE*,'ENTER THE PLOTTER MOVEMENT ALONG THE X EDGE OF PAPER IN ',
     1'INCHES  (APPROX. 1/2 THE WIDTH OF THE PAPER - I.E. 3.5).'
      READ(5,30,ERR=9911)A
      ENCODE(80,1031,CARD,ERR=9911)IL,INS,A
      N4=18
      GOTO 491
206   TYPE*,'THIS INSTRUCTION TERMINATES THE PLOT.'
      GOTO 1032
300   IF(IM.GT.3.OR.IM.LT.1)GOTO 492
      GOTO(301,302,303),IM
301   TYPE*,'THIS INSTRUCTION DEFINES THE LIMITING X AND Y DIMENSIONS ',
     1'OF THE PLOT BOUNDARY AND THE BORDER INDENTATIONS.  SEE PAGES ',
     2'37-38 FOR FURTHER DESCRIPTION.'
3010  TYPE*,'ENTER THE PLOT X AND Y LIMITS IN INCHES SEPARATED BY A ',
     1'COMMA.  RETURN FOR DEFAULTS OF 11. AND 8. INCHES (SUITABLE FOR ',
     2'PRINTER OUTPUT) RESPECTIVELY.'
      READ(5,51,ERR=9912)A,B
      IF(A.EQ.0.0)A=11.
      IF(B.EQ.0.0)B=8.
3011  TYPE*,'ENTER THE PERSPECTIVE VIEWING DISTANCE, IN INCHES, FROM ',
     1'THE PLANE OF THE DRAWING.  RETURN FOR INFINITE VIEW DISTANCE ',
     2'(PARALLEL PROJECTION).'
      READ(5,30,ERR=9913)C
3012  TYPE*,'ENTER THE BORDER INDENTATION IN INCHES.  RETURN FOR ',
     1'DEFAULT OF 0.5 INCHES.'
      READ(5,30,ERR=9914)D
      IF(D.EQ.0.0)D=0.5
3013  ENCODE(80,1031,CARD,ERR=9915)IL,INS,A,B,C,D
      N4=45
      IF(IKIND.EQ.2)GOTO 2002
      GOTO 491
302   TYPE*,'THIS INSTRUCTION SPECIFIES TITLE ROTATION.  SEE PAGE 38 ',
     1'FOR FURTHER DESCRIPTION.'
3020  TYPE*,'THE LETTERING BASE LINE FOR ALL LETTERING WILL BE ROTATED',
     1'COUNTERCLOCKWISE BY THETA FROM THE X AXIS OF THE PLOTTER.  ',
     2'ENTER THETA IN DEGREES.'
      READ(5,29,ERR=9916)A
      ENCODE(80,3021,CARD,ERR=9917)IL,INS,A
      N4=18
      GOTO 491
303   TYPE*,'THIS INSTRUCTION SPECIFIES RETRACE DISPLACEMENT.  SEE ',
     1'PAGE 38 FOR FURTHER DESCRIPTION.'
3030  TYPE*,'ENTER THE PEN DISPLACEMENT FROM THE ORIGINAL PATH IN ',
     1'INCHES.  RETURN FOR DEFAULT OF .005 INCHES.'
      READ(5,30,ERR=9918)A
      IF(A.EQ.0.0)A=.005
      ENCODE(80,1031,CARD,ERR=9919)IL,INS,A
      N4=18
      GOTO 491
400   IM2=IM
      IF(IM2.GE.10)IM2=IM2-10
      IF(IM2.LT.0.OR.IM2.GT.3)GOTO 492
      GOTO(410,401,402,403),IM2+1
401   IF(INS.EQ.401)THEN
        TYPE*,'THIS INSTRUCTION WILL ADD ATOMS TO THE ATOM LIST.'
      ELSE
        TYPE*,'THIS INSTRUCTION WILL DELETE ATOMS FROM THE ATOM LIST.'
      ENDIF
      TYPE*,'SEE PAGE 39 FOR FURTHER DESCRIPTION.'
4010  TYPE*,'DO YOU HAVE ANY SINGLE ATOMS TO BE ENTERED?  (ATOM RUNS ',
     1'ARE ENTERED SEPARATELY.)'
      ACCEPT 10,ANS
      NN=0
      IF(ANS(1:1).EQ.'N')GOTO 4013
4011  TYPE*,'ENTER THE ATOM DESIGNATOR CODE (I.E. 155501) FOR ONE ',
     1'SINGLE ATOM TO BE '
      IF(INS.EQ.401)THEN
        TYPE*,'ADDED.'
      ELSE
        TYPE*,'DELETED.'
      ENDIF
      TYPE*,'RETURN IF DONE.'
      READ(5,250,ERR=9920)AI
      IF(AI.NE.0.0)THEN
        NN=NN+1
        AJJ(NN)=AI
        IF(NN.EQ.8)THEN
          IL=1
          ENCODE(80,4012,CARD,ERR=9920)IL,INS,(AJJ(I),I=1,7)
          N4=72
          TYPE 101,CARD
          WRITE(4,10)CARD(1:N4)
          NN=1
          AJJ(1)=AJJ(8)
        ENDIF
        GOTO 4011
      ENDIF
4013  TYPE*,'DO YOU HAVE ANY ATOM RUNS TO BE ENTERED?'
      ACCEPT 10,ANS
      IL=1
      IF(ANS(1:1).EQ.'N')IL=0
      IF(NN.NE.0)THEN
        ENCODE(80,4012,CARD,ERR=9920)IL,INS,(AJJ(I),I=1,NN)
        N4=(NN+1)*9
        TYPE 101,CARD(1:N4)
        WRITE(4,10)CARD(1:N4)
      ENDIF
      IF(IL.EQ.0)GOTO 49
      NN=0
4014  TYPE*,'ENTER TWO ATOM DESIGNATOR CODES (I.E. 155501,2055501), ',
     1'SEPARATED BY A COMMA, '
      IF(INS.EQ.401)TYPE*,'TO SPECIFY THE ATOM RUN TO BE ADDED.'
      IF(INS.EQ.411)TYPE*,'TO SPECIFY THE ATOM RUN TO BE DELETED.'
      TYPE*,'RETURN IF DONE.'
      READ(5,250,ERR=9921)AI,AJ
      IF(AI.NE.0.0)THEN
        NN=NN+2
        AJJ(NN-1)=AI
        IF(ISER.NE.8)THEN
          AJJ(NN)=-(ABS(AJ))
        ELSE
          AJJ(NN)=AJ
        ENDIF
        IF(NN.EQ.8)THEN
          IL=1
          ENCODE(80,4012,CARD,ERR=9921)IL,INS,(AJJ(I),I=1,6)
          N4=72
          TYPE 101,CARD
          WRITE(4,10)CARD(1:N4)
          NN=2
          AJJ(1)=AJJ(7)
          AJJ(2)=AJJ(8)
        ENDIF
        GOTO 4014
      ENDIF
      IF(ISER.EQ.8)THEN
        IL=2
        ENCODE(80,4012,CARD,ERR=9921)IL,INS,(AJJ(I),I=1,6)
        N4=(NN+1)*9
        GOTO 8031
      ENDIF
      IF(NN.EQ.0)GOTO 49
      IL=0
      ENCODE(80,4012,CARD,ERR=9921)IL,INS,(AJJ(I),I=1,NN)
      N4=(NN+1)*9
      GOTO 491
402   IF(INS.EQ.402)THEN
        TYPE*,'THIS INSTRUCTION IS USED TO ADD A SPHERE OF ENCLOSURE.'
      ELSE
        TYPE*,'THIS INSTRUCTION IS USED TO DELETE A SPHERE OF ',
     1'ENCLOSURE.'
      ENDIF
      TYPE*,'SEE PAGES 39-40 FOR FURTHER DESCRIPTION.'
      GOTO 1010
403   IF(INS.EQ.403)THEN
        TYPE*,'THIS INSTRUCTION IS USED TO ADD A BOX OF ENCLOSURE.'
      ELSE
        TYPE*,'THIS INSTRUCTION IS USED TO DELETE A BOX OF ENCLOSURE.'
      ENDIF
      TYPE*,'SEE PAGE 40 FOR FURTHER DESCRIPTION.'
      GOTO 1010
4030  TYPE*,'ENTER A/2, B/2 AND C/2, THE THREE SEMI-DIMENSIONS OF THE ',
     1'BOX OF ENCLOSURE IN ANGSTROMS, SEPARATED BY COMMAS.'
      READ(5,12,ERR=9922)A,B,C
      ENCODE(80,4031,CARD,ERR=9906)INS,AII,A,B,C
      N4=72
      GOTO 491
410   TYPE*,'THIS INSTRUCTION CLEARS YOUR ATOMS LIST.'
      GOTO 1032
500   IF(IM.EQ.11)GOTO 511
      IF(IM.GT.6.OR.IM.LT.1)GOTO 492
      GOTO(501,502,503,492,492,506),IM
501   TYPE*,'THIS INSTRUCTION IS USED TO DEFINE A REFERENCE CARTESIAN ',
     1'SYSTEM.  SEE PAGE 41 FOR FURTHER DESCRIPTION.'
5010  TYPE*,'ENTER AN ATOM DESIGNATOR CODE (I.E. 155501) TO SPECIFY ',
     1'THE ORIGIN POINT OF THE SYSTEM.'
      READ(5,250,ERR=9923)AI
      I=AI
      TYPE*,'THE 3 ORTHONORMAL BASE VECTORS OF THE CARTESIAN SYSTEM ',
     1'CAN BE DESCRIBED BY TWO NO-COLINEAR VECTORS.  ORTEP PROVIDES ',
     2'TWO TECHNIQUES FOR PERFORMING THIS OPERATION, USING VECTOR ',
     3'CROSS PRODUCTS OF THE TWO VECTORS u AND v.:'
      TYPE*,'                             TYPE A           TYPE B'
      TYPE*,'BASE VECTOR 1 (X-AXIS)         u                u'
      TYPE*,'BASE VECTOR 2 (Y-AXIS)       u x v         (u x v) x u'
      TYPE*,'BASE VECTOR 3 (Z-AXIS)     u x (u x v)        u x v'
      TYPE*,'WILL YOU BE ENTERING YOUR VECTORS ACCORDING TO TYPE B ',
     1'RATHER THAN TYPE A (AS DESCRIBED ABOVE)?'
      ACCEPT 10,ANS
      AJ=0.0
      IF(ANS(1:1).EQ.'Y')AJ=1.0
      J=AJ
5011  TYPE*,'ENTER TWO ATOM DESIGNATOR CODES (I.E. 155501,255501), ',
     1'SEPARATED BY A COMMA, TO SPECIFY THE VECTOR DESIGNATOR CODE ',
     2'(V.D.C.''S EXPLAINED ON PAGE 28) OF VECTOR u.'
      READ(5,250,ERR=9924)AII(1),AII(2)
      II(1)=AII(1)
      II(2)=AII(2)
5012  TYPE*,'ENTER TWO ATOM DESIGNATOR CODES (I.E. 155501,355501), ',
     1'SEPARATED BY A COMMA, TO SPECIFY THE VECTOR DESIGNATOR CODE OF ',
     2'VECTOR v.'
      READ(5,250,ERR=9925)AII(3),AII(4)
      II(3)=AII(3)
      II(4)=AII(4)
      IF(IKIND.EQ.2)GOTO 2200
      ENCODE(80,5013,CARD,ERR=9926)INS,AI,AII,AJ
      N4=72
      GOTO 491
502   TYPE*,'THIS INSTRUCTION DEFINES REFERENCE CARTESIAN SYSTEM ',
     1'ROTATION.  SEE PAGES 41-42 FOR FURTHER DESCRIPTION.'
      NN=0
      TYPE*,'EACH ROTATION OPERATION REQUIRES TWO ENTRIES; THE FIRST ',
     1'INDICATES THE TYPE OF ROTATION AND THE SECOND THE ROTATION ',
     2'ANGLE.  THREE ROTATIONS ARE SUFFICIENT FOR ORIENTATION BUT ',
     3'YOU MAY ENTER AS MANY AS YOU WANT.'
5020  TYPE*,' 1:  AXIAL ROTATION ABOUT X-AXIS.'
      TYPE*,' 2:  AXIAL ROTATION ABOUT Y-AXIS.'
      TYPE*,' 3:  AXIAL ROTATION ABOUT Z-AXIS.'
      IF(IKIND.EQ.3)TYPE*,'-1:  120 DEGREE RIGHT-HANDED BODY DIAGONAL ',
     1'ROTATION.'
      IF(IKIND.EQ.3)TYPE*,'-2:  240 DEGREE RIGHT-HANDED BODY DIAGONAL ',
     1'ROTATION.'
      TYPE*,'ENTER NUMBER TO SPECIFY THE TYPE OF ROTATION.'
      IF(IL.NE.0.OR.NN.GE.4)TYPE*,'RETURN IF DONE.'
      READ(5,5022,ERR=9927)A
      IF(A.EQ.0.0)GOTO 5023
      NN=NN+2
      AA(NN-1)=A
      IF(A.LT.0.)THEN
        AA(NN)=0.
      ELSE
5021    TYPE*,'ENTER THE ROTATION ANGLE IN DEGREES FOR A RIGHT-HANDED ',
     1'ROTATION OF THE MODEL ABOUT THE SPECIFIED AXIS.'
        READ(5,5022,ERR=9928)AA(NN)
      ENDIF
      IF(IKIND.EQ.2)GOTO 2006
      IF(NN.GE.8)THEN
        IL=1
        ENCODE(80,3021,CARD,ERR=9929)IL,INS,(AA(I),I=1,7)
        N4=72
        TYPE 101,CARD
        WRITE(4,10)CARD(1:N4)
        NN=NN-7
        AA(1)=AA(8)
        AA(2)=AA(9)
      ENDIF
      GOTO 5020
5023  IL=0
      ENCODE(80,3021,CARD,ERR=9929)IL,INS,(AA(I),I=1,NN)
      N4=(NN+1)*9
      GOTO 491
503   TYPE*,'THIS INSTRUCTION DEFINES WORKING CARTESIAN SYSTEM ',
     1'ROTATION.  IT IS USED TO DEFINE AN ORIENTATION OF THE WORKING ',
     2'SYSTEM WHICH IS NOT COINCIDENT WITH THE REFERENCE SYSTEM. ',
     3'SEE PAGE 42 FOR FURTHER DESCRIPTION.'
5030  TYPE*,'1:  AXIAL ROTATION ABOUT X-AXIS'
      TYPE*,'2:  AXIAL ROTATION ABOUT Y-AXIS'
      TYPE*,'3:  AXIAL ROTATION ABOUT Z-AXIS'
      TYPE*,'ENTER NUMBER TO SPECIFY THE TYPE OF ROTATION.'
      READ(5,5022,ERR=9930)A
5031  TYPE*,'ENTER THE ROTATION ANGLE IN DEGREES FOR A RIGHT-HANDED ',
     1'ROTATION ABOUT THE SPECIFIED AXIS.'
      READ(5,5022,ERR=9931)B
      ENCODE(80,3021,CARD,ERR=9932)IL,INS,A,B
      N4=27
      GOTO 491
506   TYPE*,'THIS INSTRUCTION SETS VIEW DISTANCE PERPENDICULAR TO THE ',
     1'LEAST-SQUARES PLANE OF ALL THE ATOMS.'
      GOTO 1032
511   TYPE*,'THIS INSTRUCTION IS USED TO ELIMINATE OVERLAP.'
      IL=2
      ENCODE(80,4012,CARD)IL,INS
      TYPE 101,CARD(1:9)
      WRITE(4,10)CARD(1:9)
      INS=812
      IM2=2
      IM=12
      GOTO 8040
600   IM2=IM
      IF(IM2.GT.10)IM2=IM2-10
      IF(IM2.GT.4.OR.IM2.LT.1)GOTO 492
      IF(INS.EQ.614)GOTO 492
      IF(IM.LT.10)GOTO(601,602,603,604)IM
      TYPE*,'NOTE: THIS INSTRUCTION MUST BE PRECEEDED BY ',
     1'ONE OF INSTRUCTIONS 601-604 TO INITIALLY SET ORIGIN POSITION ',
     2'AND SCALE FACTORS.'
      GOTO(611,612,613),IM2
601   TYPE*,'THIS INSTRUCTION SPECIFIES THE POSITIONING OF THE ORIGIN ',
     1'POINT ON THE DRAWING AND THE SCALE OF THE THREE-DIMENSIONAL ',
     2'ASSEMBLY OF ATOMS.'
      GOTO 6040
602   TYPE*,'THIS INSTRUCTION SPECIFIES THE POSITIONING OF THE ORIGIN ',
     1'POINT ON THE DRAWING.  SCALING OF THE THREE-DIMENSIONAL ',
     2'ASSEMBLY OF ATOMS IS DONE AUTOMATICALLY.'
      GOTO 6040
603   TYPE*,'THIS INSTRUCTION SPECIFIES THE SCALE OF THE THREE-',
     1'DIMENSIONAL ASSEMBLY OF ATOMS.  CENTERING OF THE ORIGIN POINT ',
     2'ON THE DRAWING IS DONE AUTOMATICALLY.'
      GOTO 6040
604   TYPE*,'THIS INSTRUCTION AUTOMATICALLY SCALES AND POSITIONS THE ',
     1'MODEL SO THAT PERIPHERAL PROJECTED ATOM CENTERS WILL TOUCH ',
     2'TWO OPPOSITE BORDERS AND THE PERIPHERAL ATOMS IN THE REMAINING ',
     3'DIMENSIONS WILL BE CENTERED ON THE DRAWING.'
6040  TYPE*,'SEE PAGES 42-43 FOR FURTHER DESCRIPTION.'
      T1(1)=0.0
      T1(2)=0.0
      T1(3)=0.0
      T1(4)=0.0
      IF(IM.LT.3)THEN
6041    TYPE*,'ENTER X(0) AND Y(0) SEPARATED BY A COMMA TO SPECIFY ',
     1  'THE POSITION OF THE ORIGIN POINT ON THE DRAWING.  RETURN ',
     2  'FOR DEFAULTS OF 15.0 AND 5.5 RESPECTIVELY.'
        READ(5,51,ERR=9933)T1(1),T1(2)
      ENDIF
      IF(IM.EQ.1.OR.IM.EQ.3)THEN
6042    TYPE*,'ENTER THE SCALE OF THE THREE-DIMENSIONAL ASSEMBLY OF ',
     1  'ATOMS.  RETURN FOR DEFAULT OF 1.0.'
        READ(5,30,ERR=9934)T1(3)
      ENDIF
6043  TYPE 6044
6044  FORMAT(' ENTER A SCALE FACTOR RATIO TO MODIFY ALL RMS ',/,
     1' DISPLACEMENT VALUES BEFORE PLOTTING EQUI-PROBABILITY ',/,
     2' ELLIPSOIDS OR SPHERES.  (SEE PAGE 69 FOR GRAPH OF VALUES VS.',/,
     3' PROBABILITY.)  RETURN FOR DEFAULT OF 1.54 (50% PROBABILITY).')
      READ(5,30,ERR=9935)T1(4)
      ENCODE(80,1031,CARD,ERR=9936)IL,INS,T1
      N4=45
      GOTO 491
611   TYPE*,'THIS INSTRUCTION ALLOWS THE USER TO "NUDGE" THE MODEL ',
     1'AND MODIFY THE SCALE FACTOR.'
      GOTO 6130
612   TYPE*,'THIS INSTRUCTION ALLOWS THE USER TO "NUDGE" THE MODEL. ',
     1'SCALING IS DONE AUTOMATICALLY.'
      GOTO 6130
613   TYPE*,'THIS INSTRUCTION ALLOWS THE USER TO INCREMENT THE SCALE. ',
     1'REPOSITIONING IS DONE AUTOMATICALLY.'
6130  TYPE*,'SEE PAGES 43-44 FOR FURTHER DESCRIPTION.'
      T1(1)=0.0
      T1(2)=0.0
      T1(3)=0.0
      T1(4)=0.0
      IF(IM.LT.13)THEN
6131    TYPE*,'ENTER DX(0) AND DY(0), THE INCREMENTS TO BE ADDED TO ',
     1  'THE PREVIOUSLY ENTERED X(0), Y(0) POSITION FOR ORIGIN ',
     2  'PLACEMENT, SEPARATED BY A COMMA.'
        READ(5,51,ERR=9937)T1(1),T1(2)
      ENDIF
      IF(IM.NE.12)THEN
6132    TYPE*,'ENTER DSCALE TO MULTIPLY THE PREVIOUSLY ENTERED SCALE ',
     1  'FACTOR.'
        READ(5,30,ERR=9938)T1(3)
      ENDIF
6133  TYPE 6044
      READ(5,30,ERR=9935)T1(4)
      ENCODE(80,1031,CARD,ERR=9936)IL,INS,T1
      N4=45
      GOTO 491
700   IM2=IM
      IF(IM2.GT.10)IM2=IM2-10
      IF(IM2.LT.1.OR.IM2.GT.5)GOTO  492
      GOTO (701,702,703,704,705),IM2
701   TYPE*,'THIS INSTRUCTION REQUESTS THE DRAWING OF A "SHADED ',
     1'FOOTBALL" REPRESENTATION OF THE ATOM.'
      GOTO 7050
702   TYPE*,'THIS INSTRUCTION REQUESTS THE DRAWING OF A "FOOTBALL" ',
     1'REPRESENTATION OF THE ATOM.'
      GOTO 7050
703   TYPE*,'THIS INSTRUCTION REQUESTS THE DRAWING OF AN "OPEN MODEL"',
     1'REPRESENTATION OF THE ATOM.'
      GOTO 7050
704   TYPE*,'THIS INSTRUCTION REQUESTS THE DRAWING OF A "BOUNDARY ',
     1'ONLY" REPRESENTATION OF THE ATOM.'
      GOTO 7050
705   TYPE*,'THIS INSTRUCTION REQUESTS THE DRAWING OF SPECIAL ',
     1'REPRESENTATIONS OF THE ATOM.'
7050  IF(IM.GT.10)TYPE*,'THERE WILL BE NO PRINTED OUTPUT OF THE ',
     1'INDIVIDUAL COORDINATES.'
      TYPE*,'SEE PAGES 44-47 FOR FURTHER DESCRIPTION.'
      DO 7059 I=1,4
      II(I)=0
7059  AII(I)=0.
      IF(IM2.NE.5)GOTO 7053
      TYPE*,'FOR YOUR DRAWING DO YOU WANT'
      TYPE*,'A) NO ELLIPSOID COMPONENTS'
      TYPE*,'B) BOUNDARY ELLIPSE ONLY'
      TYPE*,'C) PRINCIPAL ELLIPSES ONLY'
      TYPE*,'D) BOUNDARY AND PRINCIPAL ELLIPSES.'
      TYPE*,'ENTER LETTER.'
      ACCEPT 10,CHAR1
      IF(CHAR1.EQ.'B')AII(1)=1.
      IF(CHAR1.EQ.'C')AII(1)=3.
      IF(CHAR1.EQ.'D')AII(1)=4.
      II(1)=AII(1)
      TYPE*,'FOR THE BACK SIDE OF PRINCIPAL ELLIPSES, DO YOU WANT'
      TYPE*,'A) BACK SIDE OMITTED'
      TYPE*,'B) SOLID LINE BACK SIDE'
      TYPE*,'C) 4 DOTS ON BACK SIDE'
      TYPE*,'D) 8 DOTS ON BACK SIDE'
      TYPE*,'E) 16 DOTS ON BACK SIDE'
      TYPE*,'F) 32 DOTS ON BACK SIDE.'
      TYPE*,'ENTER LETTER.'
      ACCEPT 10,CHAR1
      IF(CHAR1.EQ.'B')AII(2)=-1.
      IF(CHAR1.EQ.'C')AII(2)=3.
      IF(CHAR1.EQ.'D')AII(2)=4.
      IF(CHAR1.EQ.'E')AII(2)=5.
      IF(CHAR1.EQ.'F')AII(2)=6.
      II(2)=AII(2)
7051  TYPE*,'FOR FORWARD PRINCIPAL AXES AND SHADING, ENTER'
      TYPE*,'0:  NO FORWARD AXES OR SHADING'
      TYPE*,'1:  FORWARD PRINCIPAL AXES ONLY'
      TYPE*,'N:  FORWARD AXES AND (N-1) LINE SHADING.'
      READ(5,250,ERR=9940)AII(3)
      II(3)=AII(3)
7052  TYPE*,'FOR DASHED REVERSE PRINCIPAL AXES ENTER'
      TYPE*,'0:  NO REVERSE AXES'
      TYPE*,'N:  DASHED REVERSE AXES WITH N DASHES.'
      READ(5,250,ERR=9941)AII(4)
      II(4)=AII(4)
7053  TYPE*,'ENTER SYMBOL HEIGHT IN INCHES.'
      READ(5,30,ERR=9942)A
7054  TYPE*,'ENTER THE PARALLEL (LEFT-RIGHT) SYMBOL OFFSET IN INCHES.'
      READ(5,30,ERR=9943)B
7055  TYPE*,'ENTER THE PERPENDICULAR (UP-DOWN) SYMBOL OFFSET IN INCHES.'
      READ(5,30,ERR=9944)C
      TYPE*,'DO YOU WANT TO REQUEST BOUNDARY RETRACING?'
      ACCEPT 10,ANS
      IF(ANS(1:1).EQ.'Y')IL=1
      ENCODE(80,1013,CARD,ERR=9945)IL,INS,AII,A,B,C
      N4=72
      TYPE 101,CARD(1:N4)
      WRITE(4,10)CARD(1:N4)
      IF(IL.EQ.0)GOTO 49
7056  TYPE*,'ENTER A(0) AND A(1) SEPARATED BY A COMMA TO SPECIFY THE ',
     1'COEFFICIENTS OF'
      TYPE*,'          DELTA R (Z) = A(0)+A(1)*Z, WHERE'
      TYPE*,'     DELTA R IS THE INCREASE IN RADIAL DIMENSION TO BE ',
     1'          ADDED TO THE WIDTH OF THE SINGLE PEN LINE,'
      TYPE*,'     A(0) IS DELTA R FOR AN ATOM AT Z=0, AND'
      TYPE*,'     A(1) IS THE RATE OF INCREASE IN RADIAL DIMENSION ',
     1'WITH Z.'
      READ(5,51,ERR=9946)A,B
      ANS='      '
      ENCODE(80,8,CARD,ERR=9946)ANS,A,B
      N4=27
      GOTO 491
800   IM2=IM
      IF(IM2.GT.10)IM2=IM2-10
      IF(IM2.LT.1.OR.IM2.GT.3)GOTO 492
      GOTO(801,802,803),IM2
801   TYPE*,'THIS INSTRUCTION IS USED TO SPECIFY EXPLICIT STICK BONDS.',
     1'YOU WILL BE ENTERING 2 ATOM DESIGNATOR CODES (I.E. 155501) PER ',
     2'BOND.'
      GOTO 8030
802   TYPE*,'THIS INSTRUCTION IS USED TO SPECIFY IMPLICIT STICK BONDS.'
      GOTO 8030
803   TYPE*,'THIS INSTRUCTION IS USED TO SPECIFY IMPLICIT LINE BONDS.'
8030  IF(IM.GT.10)TYPE*,'THERE WILL BE NO PRINTED OUTPUT.'
      TYPE*,'SEE PAGES 47-49 AND 35 FOR FURTHER DESCRIPTION.'
      IF(IM2.EQ.1)THEN
        NN=0
        GOTO 4014
      ENDIF
      IL=2
      ENCODE(80,4012,CARD)IL,INS
      N4=9
8031  TYPE 101,CARD(1:N4)
      WRITE(4,10)CARD(1:N4)
8040  IF(IM2.NE.1)GOTO 1010
8032  TYPE*,'ENTER THE NUMBER OF LINES YOU WANT DRAWN BETWEEN THE ',
     1'ATOMS TO DEFINE THE BOND: 1<=N<=5.  RETURN FOR DEFAULT OF 1.'
      READ(5,250,ERR=9947)AI
      IF(AI.EQ.0.0)AI=1.
      if(ai.lt.1.or.ai.gt.5)then
        type*,'SORRY DR. SCHAEFER, YOU MADE A MISTAKE.  ONLY 1,2,3,4 OR'
        TYPE*,'5 ALLOWED.  TRY AGAIN.'
        goto 8032
      ENDIF
      I=AI
8033  TYPE*,'ENTER THE BOND RADIUS (HALF-THICKNESS) IN ANGSTROMS. ',
     1'VALUES ARE NORMALLY BETWEEN 0.01 AND 0.06.  RETURN FOR DEFAULT ',
     2'OF 0.01.'
      READ(5,30,ERR=9948)CELL(1)
      IF(CELL(1).EQ.0.0)CELL(1)=0.01
      IF(IKIND.EQ.2)GOTO 8042
8034  TYPE*,'ENTER THE LETTERING HEIGHT BEFORE PROJECTION OF ',
     1'PERSPECTIVE LABELS FOR BOND DISTANCES IN INCHES.  RETURN FOR ',
     2'NO LABELS.'
      READ(5,30,ERR=9949)CELL(2)
8035  IF(CELL(2).EQ.0.0)THEN
        CELL(3)=0.0
      ELSE
        TYPE*,'ENTER THE PERPENDICULAR OFFET FOR BOND DISTANCE ',
     1  'PERSPECTIVE LABELS IN INCHES.'
        READ(5,30,ERR=9950)CELL(3)
      ENDIF
8036  TYPE*,'ENTER THE LETTERING HEIGHT BEFORE PROJECTION OF REGULAR ',
     1'LABELS FOR BOND DISTANCES IN INCHES.  RETURN IF NO BOND ',
     2'DISTANCES CORRESPONDING TO FORESHORTENED BONDS ARE TO BE DRAWN.'
      READ(5,30,ERR=9951)CELL(4)
8037  IF(CELL(4).EQ.0.0)THEN
        CELL(5)=0.0
      ELSE
        TYPE*,'ENTER THE PERPENDICULAR OFFSET FOR BOND DISTANCE ',
     1  'REGULAR LABELS IN INCHES.'
        READ(5,30,ERR=9952)CELL(5)
      ENDIF
8038  TYPE*,'ON BOND DISTANCE LABELS, DO YOU WANT:'
      TYPE*,'     1 DIGIT AFTER DECIMAL POINT,'
      TYPE*,'     2 DIGITS AFTER DECIMAL POINT, OR'
      TYPE*,'     3 DIGITS AFTER DECIMAL POINT?'
      TYPE*,'ENTER 1, 2 OR 3.'
      READ(5,250,ERR=9953)AK
      AJ=0.
      IF(AK.EQ.3.)AJ=1.
      IF(AK.EQ.1.)AJ=-1.
8042  IL=0
      IF(IM2.EQ.2)THEN
        TYPE*,'ANY MORE VECTOR SEARCH CODES TO BE ENTERED?'
        ACCEPT 10,ANS
        IF(ANS(1:1).EQ.'Y')IL=2
      ENDIF
      IF(IKIND.EQ.2.AND.IL.EQ.0)GOTO 2105
8041  ENCODE(80,8039,CARD,ERR=9954)IL,II,I,B,A,(CELL(K),K=1,5),AJ
      N4=72
      IF(IKIND.EQ.2)THEN
        TYPE 101,CARD(1:42)
        WRITE(4,10)CARD(1:42)
        WRITE(12,10)CARD(1:42)
      ELSE
        TYPE 101,CARD(1:N4)
        WRITE(4,10)CARD(1:N4)
      ENDIF
      IF(IL.EQ.0)GOTO 49
      GOTO 1010
900   IF(IM.LT.1.OR.IM.GT.16)GOTO 492
      GOTO(901,902,903,904,905,906,492,908,909,492,492,492,913,914,
     1 915,916),IM
901   TYPE*,'THIS INSTRUCTION REQUESTS THE PLOTTING OF A ',
     1'NONPERSPECTIVE CHEMICAL SYMBOL.'
      GOTO 9160
902   TYPE*,'THIS INSTRUCTION REQUESTS THE PLOTTING OF A ',
     1'NONPERSPECTIVE TITLE.'
      IL=3
      GOTO 9160
903   TYPE*,'THIS INSTRUCTION REQUESTS THE PLOTTING OF A GENERAL ',
     1'VECTOR TITLE WITH NONPERSPECTIVE LETTERING.'
      IL=3
      GOTO 9160
904   TYPE*,'THIS INSTRUCTION REQUESTS THE PLOTTING OF A ',
     1'NONPERSPECTIVE GENERAL-VECTOR BOND LENGTH LABEL WITH ONE ',
     2'PLACE AFTER THE DECIMAL POINT.'
      GOTO 9160
905   TYPE*,'THIS INSTRUCTION REQUESTS THE PLOTTING OF A ',
     1'NONPERSPECTIVE GENERAL-VECTOR BOND LENGTH LABEL WITH TWO ',
     2'PLACES AFTER THE DECIMAL POINT.'
      GOTO 9160
906   TYPE*,'THIS INSTRUCTION REQUESTS THE PLOTTING OF A ',
     1'NONPERSPECTIVE GENERAL-VECTOR BOND LENGTH LABEL WITH THREE ',
     2'PLACES AFTER THE DECIMAL POINT.'
      GOTO 9160
908   TYPE*,'THIS INSTRUCTION REQUESTS THE DRAWING OF A CENTERED ',
     1'SYMBOL WITH THE PEN UP.'
      IL=1
      GOTO 9160
909   TYPE*,'THIS INSTRUCTION REQUESTS THE DRAWING OF A CENTERED ',
     1'SYMBOL WITH THE PEN LEFT DOWN.'
      IL=1
      GOTO 9160
913   TYPE*,'THIS INSTRUCTION REQUESTS THE PLOTTING OF A GENERAL ',
     1'VECTOR TITLE WITH PERSPECTIVE LETTERING.'
      IL=3
      GOTO 9160
914   TYPE*,'THIS INSTRUCTION REQUESTS THE PLOTTING OF A PERSPECTIVE ',
     1'GENERAL-VECTOR BOND LENGTH LABEL WITH ONE PLACE AFTER THE ',
     2'DECIMAL POINT.'
      GOTO 9160
915   TYPE*,'THIS INSTRUCTION REQUESTS THE PLOTTING OF A PERSPECTIVE ',
     1'GENERAL-VECTOR BOND LENGTH LABEL WITH TWO PLACES AFTER THE ',
     2'DECIMAL POINT.'
      GOTO 9160
916   TYPE*,'THIS INSTRUCTION REQUESTS THE PLOTTING OF A PERSPECTIVE ',
     1'GENERAL-VECTOR BOND LENGTH LABEL WITH THREE PLACES AFTER THE ',
     2'DECIMAL POINT.'
9160  TYPE*,'SEE PAGES 49-51 FOR FURTHER DESCRIPTION.'
9161  TYPE*,'ENTER THE ATOM DESIGNATOR CODE (I.E. 155501) FOR ATOM A.'
      READ(5,250,ERR=9955)AI
      I=AI
9162  TYPE*,'ENTER THE ATOM DESIGNATOR CODE (I.E. 255501) FOR ATOM B.'
      IF(IM.LT.3.OR.IM.EQ.8.OR.IM.EQ.9)TYPE*,'RETURN IF NOT NEEDED.'
      READ(5,250,ERR=9956)AJ
      J=AJ
      IF(IM.GT.10)THEN
        CELL(1)=0.0
        CELL(2)=0.0
      ELSE
9163    TYPE*,'ENTER THE X EDGE RESET VALUE IN INCHES.  IF IT IS >0 ',
     1  'THEN X IS RESET TO THIS VALUE.  IF IT IS <0, X IS RESET TO ',
     2  'THE POSITIVE X PLOT BOUNDARY MINUS THE VALUE.  RETURN FOR NO ',
     3  'RESETTING.'
        READ(5,30,ERR=9957)CELL(1)
9164    TYPE*,'ENTER THE Y EDGE RESET VALUE IN INCHES AS ABOVE.'
        READ(5,30,ERR=9958)CELL(2)
      ENDIF
9165  TYPE*,'ENTER THE LETTERING HEIGHT IN INCHES.'
      READ(5,30,ERR=9959)CELL(3)
9166  TYPE*,'ENTER THE PARALLEL OFFSET IN INCHES.'
      READ(5,30,ERR=9960)CELL(4)
9167  TYPE*,'ENTER THE PERPENDICULAR OFFSET IN INCHES.'
      READ(5,30,ERR=9961)CELL(5)
      ENCODE(80,9168,CARD,ERR=9962)IL,INS,AI,AJ,(CELL(K),K=1,5)
      N4=72
      TYPE 101,CARD(1:N4)
      WRITE(4,10)CARD(1:N4)
      IF(IL.EQ.0)GOTO 49
      IF(IL.EQ.1)GOTO 9169
      TYPE*,'ENTER A TITLE. CENTER IT ABOUT COLUMNS 36-37.'
      ACCEPT 10,CARD(1:72)
      N4=72
      GOTO 491
9169  TYPE*,'ENTER THE SYMBOL NUMBER I: 0<=I<=14.  (SEE CALCOMP ',
     1'SIMBOL ROUTINE).'
      READ(5,250,ERR=9963)AI
      ENCODE(80,9170,CARD,ERR=9963)AI
      N4=18
      GOTO 491
1100  IF(IM.LT.1.OR.IM.GT.3)GOTO 492
      GOTO(1101,1102,1103),IM
1101  TYPE*,'THIS INSTRUCTION STARTS A SAVED SEQUENCE.'
      GOTO 1104
1102  TYPE*,'THIS INSTRUCTION TERMINATES A SAVED SEQUENCE.'
      GOTO 1104
1103  TYPE*,'THIS INSTRUTION EXECUTES THE SAVED SEQUENCE.'
1104  TYPE*,'SEE PAGE 51 FOR FURTHER DESCRIPTION.'
      GOTO 1032
1000  TYPE*,' '
      ATOMS=NATOMS
      CARD(1:9)='  3   201'
      TYPE 101,CARD(1:9)
      WRITE(4,10)CARD(1:9)
      TYPE 1001
1001  FORMAT(' INITIATE PLOTTER')
      WRITE(4,1001)
      TYPE *,' '
      CARD(7:45)='301      8.0      5.0     30.0      0.5'
      TYPE 101,CARD(1:45)
      WRITE(4,10)CARD(1:45)
      TYPE 1002
1002  FORMAT(' PLOT SIZE 8X5 (FOR TERMINAL), 0.5 IN. MARGINS, VIEW ',
     1'DISTANCE 30 IN.')
      WRITE(4,1002)
      TYPE*,' '
      CARD(7:27)='401   155501    55501'
      ENCODE(4,2005,CARD(19:22))-NATOMS
      TYPE 101,CARD(1:27)
      WRITE(4,10)CARD(1:27)
      TYPE 1003
1003  FORMAT(' ALL ATOMS ON ATOM LIST ENTERED')
      WRITE(4,1003)
      TYPE*,' '
      CARD(7:9)='506'
      TYPE 101,CARD(1:9)
      WRITE(4,10)CARD(1:9)
      TYPE 1004
1004  FORMAT(' VIEW DIRECTION PERPENDICULAR TO LEAST-SQUARES ',
     1'PLANE OF ALL THE ATOMS')
      WRITE(4,1004)
      TYPE*,' '
      CARD(7:54)='502       1.      0.0       2.      0.0       3.'
      CARD(55:63)='      0.0'
      TYPE 101,CARD(1:63)
      WRITE(4,10)CARD(1:63)
      TYPE *,'THIS CARD IS ADDED AS A DUMMY, PERHAPS TO BE EDITED IN ',
     1'SUBSEQUENT RUNS.'
      TYPE 1005
1005  FORMAT(' ROTATION OF 0.0 DEGREES ABOUT X, Y, AND Z AXES')
      WRITE(4,1005)
      TYPE*,' '
      CARD(7:9)='604'
      TYPE 101,CARD(1:9)
      WRITE(4,10)CARD(1:9)
      TYPE 1006
1006  FORMAT(' AUTOMATICALLY SCALE AND CENTER THE PLOT')
      WRITE(4,1006)
      TYPE*,' '
      TYPE*,'RETURN TO CONTINUE'
      ACCEPT 10,ANS
      TYPE*,' '
      CARD(7:36)='611                        0.9'
      TYPE 101,CARD(1:36)
      WRITE(4,10)CARD(1:36)
      TYPE 1007
1007  FORMAT(' REDUCE THE SIZE BY 10 PERCENT')
      WRITE(4,1007)
      TYPE*,' '
      CARD(1:9)='  2   511'
      TYPE 101,CARD(1:9)
      WRITE(4,10)CARD(1:9)
      CARD1(1:42)='  3        1     1     1   0.5   2.1   .04'
      ENCODE(3,8039,CARD1(13:15))NATOMS
      ENCODE(3,8039,CARD1(19:21))NATOMS
      TYPE 101,CARD1(1:42)
      WRITE(4,10)CARD1(1:42)
      TYPE 1008
1008  FORMAT(' ELIMINATE OVERLAP')
      WRITE(4,1008)
      TYPE *,' '
      CARD(1:9)='  1   714'
      TYPE 101,CARD(1:9)
      WRITE(4,10)CARD(1:9)
      CARD(1:36)='  3                               1.'
      ENCODE(9,250,CARD(37:45))ATOMS
      WRITE(4,10)CARD(1:45)
      TYPE 101,CARD(1:45)
      TYPE 1009
1009  FORMAT(' PLOT ALL ATOMS WITH BOUNDARIES ONLY (EITHER ELLIPSES ',
     1'OR CIRCLES)')
      WRITE(4,1009)
      TYPE*,' '
      CARD(1:9)='  2   812'
      WRITE(4,10)CARD(1:9)
      TYPE 101,CARD(1:9)
      WRITE(4,10)CARD1(1:42)
      TYPE 101,CARD1(1:42)
      TYPE 1200
1200  FORMAT(' DRAW BONDS BETWEEN .5 AND 2.1 A IN LENGTH AS ',
     1'OPEN BONDS .04 A IN RADIUS')
      WRITE(4,1200)
      TYPE*,' '
      CARD(1:9)='  3   206'
      TYPE 101,CARD(1:9)
      WRITE(4,10)CARD(1:9)
      TYPE 1201
1201  FORMAT(' TERMINATE THE PLOT')
      WRITE(4,1201)
      TYPE*,' '
      GOTO 99
2000  TYPE*,' '
      CARD(1:9)='  3   201'
      TYPE 101,CARD(1:9)
      WRITE(4,10)CARD(1:9)
      TYPE 1001
      WRITE(4,1001)
      TYPE*,' '
      IL=3
      A=11.
      B=8.
      C=30.
      D=0.5
      TYPE*,'301 CARD'
      INS=301
      TYPE 2001,A,B,D,C
2001  FORMAT(' PLOT SIZE ',F4.1,'X',F4.1,' IN., ',F4.1,' IN. MARGINS, ',
     1'VIEW DISTANCE ',F4.1,' IN.')
      TYPE*,'THESE ARE APPROPRIATE FOR THE PRINTER.'
      TYPE*,'DO YOU WANT TO CHANGE ANY OF THESE DEFAULT VALUES?'
      ACCEPT 10,ANS
      IF(ANS(1:1).EQ.'Y')GOTO 3010
      GOTO 3013
2002  TYPE 101,CARD(1:N4)
      WRITE(4,10)CARD(1:N4)
      WRITE(4,2001)A,B,D,C
      TYPE 2001,A,B,D,C
      TYPE*,' '
      TYPE*,'FOR 401 CARD, ALL ATOMS WITH ALL SYMMETRIES WILL BE ',
     1'ENTERED.  DO YOU WANT TO CHANGE THIS?'
      ACCEPT 10,ANS
      INS=401
      IF(ANS(1:1).EQ.'Y')GOTO 4010
      CARD(7:27)='401   155501    5550 '
      ENCODE(4,2005,CARD(19:22))-NATOMS
      IF(NSYM.LT.10)THEN
        ENCODE(1,2300,CARD(27:27))NSYM
      ELSE
        ENCODE(2,2004,CARD(26:27))NSYM
      ENDIF
2004  FORMAT(I2)
2005  FORMAT(I4)
2300  FORMAT(I1)
      WRITE(4,10)CARD(1:27)
      TYPE 101,CARD(1:27)
      WRITE(4,1003)
2003  TYPE*,' '
      TYPE*,'DO YOU WANT THE 506 CARD FOR A VIEW DIRECTION ',
     1'PERPENDICULAR TO THE LEAST-SQUARES PLANE?'
      ACCEPT 10,ANS
      IF(ANS(1:1).ne.'N')THEN
        CARD(7:9)='506'
        card(1:3)='  3'
        TYPE 101,CARD(1:9)
        WRITE(4,10)CARD(1:9)
        TYPE 1004
        WRITE(4,1004)
      ELSE
        I=155501
        II(1)=155501
        II(2)=255501
        II(3)=155501
        II(4)=355501
        J=0
        INS=501
        TYPE*,'FOR 501 CARD, DEFAULTS ARE'
        TYPE 2201,I,II
2201    FORMAT(' ORIGIN:',I8,', X AXIS:',I8,' -',I8,
     1', Y AXIS:',I8,' -',I8)
        TYPE*,'DO YOU WANT TO CHANGE ANY OF THESE VALUES?'
        ACCEPT 10,ANS
        IF(ANS(1:1).EQ.'Y')GOTO 5010
2200    IL=3
        ENCODE(80,2202,CARD)IL,INS,I,II,J
        TYPE 101,CARD(1:72)
        WRITE(4,10)CARD(1:72)
2202    FORMAT(I3,I6,5I9,9X,I9)
        WRITE(4,2201)I,II
        TYPE 2201,I,II
      ENDIF
      TYPE*,' '
      NN=0
      T1(1)=0.
      T1(2)=0.
      T1(3)=0.
      CARD(1:45)='  3   502       1.      0.0       2.      0.0'
      CARD(46:63)='       3.      0.0'
      TYPE*,'502 CARD FOR PLOT ROTATION.  DEFAULT IS NO ROTATION. ',
     1'DO YOU WANT TO ROTATE?'
      ACCEPT 10,ANS
      IF(ANS(1:1).EQ.'Y')GOTO 5020
      GOTO 2007
2006  NN=AA(1)
      T1(NN)=AA(2)
      NN=AA(1)*18.
      ENCODE(9,12,CARD(NN+1:NN+9))AA(2)
      TYPE*,'ANY OTHER ROTATION?'
      ACCEPT 10,ANS
      NN=0
      IF(ANS(1:1).EQ.'Y')GOTO 5020
2007  TYPE 101,CARD(1:63)
      WRITE(4,10)CARD(1:63)
      TYPE 2008,T1(1),T1(2),T1(3)
2008  FORMAT(' ROTATIONS OF ',F4.0,', ',F4.0,', AND ',F4.0,' ABOUT ',
     1'THE X, Y, AND Z AXES RESP.')
      WRITE(4,2008)T1(1),T1(2),T1(3)
      TYPE*,' '
      CARD(1:9)='  3   604'
      WRITE(4,10)CARD(1:9)
      TYPE 101,CARD(1:9)
      TYPE 1006
      WRITE(4,1006)
      TYPE*,'DO YOU WANT A STEREO PLOT?'
      ACCEPT 10,ANS
      ISP=0
      IF(ANS(1:1).EQ.'Y')ISP=1
      TYPE*,' '
      IF(ISP.EQ.0)THEN
      CARD(7:36)='611                        0.9'
      A=0.9
      ELSE
      CARD(7:36)='611                        0.8'
      A=0.8
      ENDIF
      TYPE*,'611 CARD. DO YOU WANT TO CHANGE PLOT SCALE? DEFAULT IS ',
     1'SCALE=0.9 FOR A 10 PERCENT REDUCTION OR'
     +'SCALE=0.8 FOR A 20 PERCENT REDUCTION FOR A STEREO PLOT.'
      ACCEPT 10,ANS
2009  IF(ANS(1:1).EQ.'Y')THEN
        TYPE*,'ENTER SCALE.'
        READ(5,25,ERR=9968)A
        ENCODE(9,12,CARD(28:36),ERR=9968)A
      ENDIF
      TYPE 101,CARD(1:36)
      WRITE(4,10)CARD(1:36)
      A=100.-100.*A
      TYPE 2100,A
2100  FORMAT(' REDUCE THE PLOT SIZE BY ',F6.2,' PERCENT.')
      TYPE*,' '
      WRITE(4,2100)A
      IF(ISP.EQ.0)GOTO 2115
      TYPE*,'IS THIS STEREO PLOT ON A TERMINAL ? ANS Y/N'
       ACCEPT 10,ANS
       IF(ANS(1:1).EQ.'Y')THEN
      A=1.
      TYPE*,'FIRST 202 INSTRUCTION TO "ADVANCE PAPER."  DEFAULT FOR ',
     1'X-MOVEMENT IS 1 INCHES TO PUT FIRST VIEW ON THE LEFT HALF ',
     2'OF THE SCREEN.  DO YOU WANT TO CHANGE THIS?'
      ACCEPT 10,ANS
      CARD(1:18)='  3   202       1.'
2116  IF(ANS(1:1).EQ.'Y')THEN
        TYPE*,'ENTER X-EDGE MOVEMENT IN INCHES.'
        READ(5,25,ERR=9972)A
        ENCODE(9,5022,CARD(10:18),ERR=9972)A
      ENDIF
      TYPE 101,CARD(1:27)
      WRITE(4,10)CARD(1:27)
      I=A
      TYPE 2117,I
2117  FORMAT(' PAPER ADVANCE. X-EDGE MOVEMENT = ',I3,' INCHES')
      WRITE(4,2117)I
      ENDIF
      TYPE *,' '
      IF(ISP.EQ.0)GOTO 2122
      TYPE*,'FIRST 503 COMMAND.  DEFAULT IS'
      B=2. 
      CHAR1='Y'
      A=2.5
      I=3
      TYPE 2118,A,CHAR1
2118  FORMAT(' ROTATE ',F4.1,' DEGREES ABOUT THE ',A1,' AXIS')
      TYPE*,'DO YOU WANT TO CHANGE THIS?'
      ACCEPT 10,ANS
2119  IF(ANS(1:1).EQ.'Y')THEN
        TYPE*,'WHICH AXIS - ENTER X, Y OR Z'
        ACCEPT 10,CHAR1
        IF(CHAR1.EQ.'X')B=1.
        IF(CHAR1.EQ.'Z')B=3.
        TYPE*,'HOW MANY DEGREES ROTATION?'
        READ(5,25,ERR=9973)A
        I=A
      ENDIF
      IL=3
      INS=503
      ENCODE(80,9168,CARD,ERR=9973)IL,INS,B,A
      TYPE 101,CARD(1:27)
      WRITE(4,10)CARD(1:27)
      TYPE 2118,A,CHAR1
      WRITE(4,2118)A,CHAR1
      TYPE*,' '
      IF(ISP.EQ.0)GOTO 2123
      CARD(6:9)='1101'
      TYPE 101,CARD(1:9)
      WRITE(4,10)CARD(1:9)
      TYPE 2120
2120  FORMAT(' START SAVED SEQUENCE')
      WRITE(4,2120)
      TYPE*,' '
2115  TYPE*,'511 AND 812 CARDS FOR GENERATING BONDS.  SEE BEGINNER''S ',
     1'GUIDE, INSTRUCTION 812, FOR DESCRIPTION.'
      OPEN(UNIT=12,TYPE='NEW',FORM='FORMATTED',BLOCKSIZE=32768)
      INS=812
      IM=2
      IM2=2
      CARD(1:9)='  2   511'
      WRITE(4,10)CARD(1:9)
      TYPE 101,CARD(1:9)
      GOTO 8040
2105  IL=3
      ENCODE(80,8039,CARD1,ERR=9969)IL,II,I,B,A,CELL(1)
      TYPE 101,CARD1(1:42)
      WRITE(4,10)CARD1(1:42)
      TYPE 1008
      WRITE(4,1008)
      TYPE*,' '
      TYPE*,'DO YOU WANT ALL ATOMS PLOTTED IN OUTLINE ONLY? (714-TYPE)'
      ACCEPT 10,ANS
2108  IF(ANS(1:1).EQ.'N')THEN
        TYPE*,'DO YOU WANT:'
        TYPE*,'711 FOR SHADED FOOTBALL PLOT,'
        TYPE*,'712 FOR FOOTBALL PLOT, OR'
        TYPE*,'714 FOR OUTLINE ONLY PLOT.'
        TYPE*,'ENTER INSTRUCTION NUMBER.'
        READ(5,250,ERR=9970)C
        INS=C
        IL=1
        ENCODE(80,1031,CARD,ERR=9970)IL,INS
        TYPE 101,CARD(1:9)
        WRITE(4,10)CARD(1:9)
2109    TYPE*,'ENTER TWO ATOM NUMBERS (I.E. 1,2), SEPARATED BY A ',
     1  'COMMA, TO SPECIFY THE RANGE TO WHICH THIS INSTRUCTION SHOULD ',
     2  'BE APPLIED.'
        READ(5,250,ERR=9971)C,D
        IL=0
        ENCODE(80,2110,CARD,ERR=9971)IL,C,D
2110    FORMAT(I3,24X,2F9.0)
        TYPE 101,CARD(1:45)
        WRITE(4,10)CARD(1:45)
        TYPE*,'ANY MORE 700 INSTRUCTIONS?'
        ACCEPT 10,ANS
        IF(ANS(1:1).EQ.'Y')THEN
          ANS(1:1)='N'
          GOTO 2108
        ENDIF
      ELSE
        CARD(1:9)='  1   714'
        TYPE 101,CARD(1:9)
        WRITE(4,10)CARD(1:9)
        IL=3
        C=1.
        D=NATOMS
        ENCODE(80,2110,CARD)IL,C,D
        TYPE 101,CARD(1:45)
        WRITE(4,10)CARD(1:45)
        TYPE 1009
        WRITE(4,1009)
      ENDIF
      TYPE*,' '
      CARD(1:9)='  2   812'
      WRITE(4,10)CARD(1:9)
      TYPE 101,CARD(1:9)
      REWIND 12
2111  READ(12,10,END=2106)CARD(1:42)
      TYPE 101,CARD(1:42)
      WRITE(4,10)CARD(1:42)
      GOTO 2111
2106  CLOSE(UNIT=12,DISP='DELETE')
      WRITE(4,10)CARD1(1:42)
      TYPE 101,CARD1(1:42)
      TYPE 2107,B,A,I+1,CELL(1)
2107  FORMAT(' DRAW BONDS OF ',F5.2,' TO ',F5.2,' A IN LENGTH;',I2,
     1' LINES; ',F5.2,' A RADIUS')
      WRITE(4,2107)B,A,I+1,CELL(1)
      TYPE*,' '
      CARD(1:9)='  3   206'
      TYPE 101,CARD(1:9)
      WRITE(4,10)CARD(1:9)
      TYPE 1201
      WRITE(4,1201)
      TYPE*,' '
      IF(ISP.EQ.0)GOTO 99
      ISP=0
      CARD(1:9)='  3  1102'
      WRITE(4,10)CARD(1:9)
      TYPE 101,CARD(1:9)
      WRITE(4,2121)
2121  FORMAT(' END SAVED SEQUENCE')
      TYPE 2121
      TYPE*,' '
      TYPE*,'SECOND 202 COMMAND TO "ADVANCE PAPER."  DEFAULT FOR ',
     1'X-MOVEMENT IS 5 INCHES TO MOVE TO THE RIGHT SIDE OF THE SCREEN,'
      TYPE*,' OR TO THE RIGHT SIDE OF THE PRINTER PAPER,'
     2'DO YOU NEED TO CHANGE THIS?'
      ACCEPT 10,ANS
      CARD(1:27)='  3   202       5.'
      A=5.
      GOTO 2116
2122  B=2.
      CHAR1='Y'
      A=-2.5
      I=-3
      TYPE*,'SECOND 503 COMMAND.  DEFAULT IS'
      TYPE 2118,A,CHAR1
      TYPE*,'DO YOU NEED TO CHANGE THIS?'
      ACCEPT 10,ANS
      GOTO 2119
2123  CARD(6:9)='1103'
      TYPE 101,CARD(1:9)
      WRITE(4,10)CARD(1:9)
      TYPE 2124
2124  FORMAT(' EXECUTE SAVED SEQUENCE')
      WRITE(4,2124)
      TYPE*,' '
99    INS=-1
      TYPE*,'TERMINATE ORTEP.'
      ENCODE(80,4031,CARD)INS
      TYPE 101,CARD(1:9)
      WRITE(4,10)CARD(1:9)
      RETURN
9901  TYPE 999
      GOTO 4
9902  TYPE 999
      GOTO 1
9903   TYPE 999
      GOTO 5
9904  TYPE 999
      GOTO 26
9905  TYPE 999
      GOTO 49
9906  TYPE 999
      GOTO 1010
9907  TYPE 999
      GOTO 1011
9908  TYPE 999
      GOTO 1012
9909  TYPE 999
      GOTO 1014
9911  TYPE 999
      GOTO 202
9912  TYPE 999
      GOTO 3010
9913  TYPE 999
      GOTO 3011
9914  TYPE 999
      GOTO 3012
9915  TYPE 999
      GOTO 301
9916  TYPE 999
      GOTO 3020
9917  TYPE 999
      GOTO 302
9918  TYPE 999
      GOTO 3030
9919  TYPE 999
      GOTO 303
9920  TYPE 999
      GOTO 4011
9921  TYPE 999
      GOTO 4014
9922  TYPE 999
      GOTO 4030
9923  TYPE 999
      GOTO 5010
9924  TYPE 999
      GOTO 5011
9925  TYPE 999
      GOTO 5012
9926  TYPE 999
      GOTO 501
9927  TYPE 999
      GOTO 5020
9928  TYPE 999
      GOTO 5021
9929  TYPE 999
      GOTO 502
9930  TYPE 999
      GOTO 5030
9931  TYPE 999
      GOTO 5031
9932  TYPE 999 
      GOTO 503
9933  TYPE 999
      GOTO 6041
9934  TYPE 999
      GOTO 6042
9935  TYPE 999
      GOTO 6043
9936  TYPE 999
      GOTO 600
9937  TYPE 999
      GOTO 6131
9938  TYPE 999
      GOTO 6132
9939  TYPE 999
      GOTO 6133
9940  TYPE 999
      GOTO 7051
9941  TYPE 999
      GOTO 7052
9942  TYPE 999
      GOTO 7053
9943  TYPE 999
      GOTO 7054
9944  TYPE 999
      GOTO 7055
9945  TYPE 999
      GOTO 700
9946  TYPE 999
      GOTO 7056
9947  TYPE 999
      GOTO 8032
9948  TYPE 999
      GOTO 8033
9949  TYPE 999
      GOTO 8034
9950  TYPE 999
      GOTO 8035
9951  TYPE 999
      GOTO 8036
9952  TYPE 999
      GOTO 8037
9953  TYPE 999
      GOTO 8038
9954  TYPE 999
      GOTO 8040
9955  TYPE 999
      GOTO 9161
9956  TYPE 999
      GOTO 9162
9957  TYPE 999
      GOTO 9163
9958  TYPE 999
      GOTO 9164
9959  TYPE 999
      GOTO 9165
9960  TYPE 999
      GOTO 9166
9961  TYPE 999
      GOTO 9167
9962  TYPE 999
      GOTO 900
9963  TYPE 999
      GOTO 9169
9964  TYPE 9965,ANAM
9965  FORMAT(' FILE ',A16,' NOT FOUND. CELL PARAMETERS MUST BE ',/,
     1' ENTERED BY HAND.')
      GOTO 4
9966  TYPE 9967,ANAM
9967  FORMAT(' FILE ',A16,' NOT FOUND.  COORDS AND ANISOS SHOULD BE ',/,
     1' ENTERED BY HAND.')
      GOTO 1083
9968  TYPE 999
      GOTO 2009
9969  TYPE 999
      GOTO 8040
9970  TYPE 999
      GOTO 2108
9971  TYPE 999
      GOTO 2109
9972  TYPE 999
      GOTO 2116
9973  TYPE 999
      GOTO 2119
999   FORMAT(' ERROR ON LAST ENTRY - TRY AGAIN.')
      END
