      SUBROUTINE PREPAREIN
C  
C   INPUT FOR PREPARE PROGRAMS
C
      DIMENSION STUFF(11),KNF(12)
      CHARACTER*16 ANAM,ANAM2  ! USE ANAM FOR HKL AND INF
      COMMON/FNAME/ANAM,NAMLEN
      CHARACTER*1 ASP
      CHARACTER*2 target
      CHARACTER*6 ANS
      CHARACTER*4 AFF,CHAR4,C4
      CHARACTER*3 AN(12)
      CHARACTER*20 BRANCH
      CHARACTER*80 CARD
      DIMENSION FF(10)
      COMMON/PASS/BRANCH
1     FORMAT(A)
      INPT=4
2     FORMAT(1X,A)
2000  FORMAT(I10,:,I10)    ! FORMAT FOR INTEGERS
3000  FORMAT(F18.10)      ! FORMAT FOR REALS
840   FORMAT(4X,3I6,F8.3,F8.5,:,8X,F8.5)
855   FORMAT(3I8,F10.4,2F10.7)
392   FORMAT(9F5.2)
1021  FORMAT(6F9.0)
103   FORMAT('CELL',2X,3F8.5,3F8.4)
105   FORMAT(12(A3,A1))
107   FORMAT('KIND F',12A3,34X,I2,A2)
137   FORMAT(10F8.4)
1552  FORMAT(7(A3,A1,F8.3))
1553  FORMAT('ANOMALOUS ',7(A3,F7.3))
152   FORMAT(4X,3I6,F8.3,8X,F8.5,:,F8.5)
      ICL=0
      IOP15=0
      GOTO 100
C   ERROR MESSAGES
9     ASSIGN 1389 TO IGO   ! ERROR MESSAGE
      GOTO 999
393   ASSIGN 394 TO IGO
      GOTO 999
920   TYPE 9201,ANAM
9201  FORMAT(' ERROR OPENING FILE ',A16)
      TYPE*,'You must re-enter CELL PARAMETERS.'
      GOTO 1121
921   TYPE 9201,ANAM
      TYPE*,'You must re-enter KIND F IDENTIFIERS.'
      GOTO 202
922   TYPE 9201,ANAM
      TYPE*,'You must re-enter ANOMALOUS DISPERSION FACTORS.'
      GOTO 1414
923   TYPE*,'Error with CELL PARAMS on .INF file.  Will replace them.'
      GOTO 210
203   ASSIGN 139 TO IGO
      GOTO 999
924   TYPE*,'Error with FORMULA on .INF file.'
      GOTO 1041
925   TYPE*,'Error with MOLECULE on .INF file.'
      GO TO 1041
200   ASSIGN 202 TO IGO
      GOTO 999
1071  ASSIGN 1121 TO IGO
      GOTO 999
1556  ASSIGN 1551 TO IGO   ! ERROR MESSAGE
      GOTO 999
1471  ASSIGN 1451 TO IGO   ! ERROR MESSAGE
      GOTO 999
1521  ASSIGN 149 TO IGO    ! ERROR MESSAGE
999   TYPE*,' You''ve made an error on input just entered. Try again.'
      GOTO IGO
100   DO 1001 I=1,80
1001  CARD(I:I)=' '
      I=NAMLEN  ! OPENING INF FILE IF IT EXISTS
      ANAM2(1:I)=ANAM(1:I)   ! SAVE ANAM FOR .HKL OR .INF
      I=I+1
      ANAM(I:I+3)='.INF'
c      OPEN(NAME=ANAM,UNIT=15,TYPE='OLD',FORM='FORMATTED',ERR=230)
C       inf file will be opened and closed in addin and find
230   IF(BRANCH(1:1).EQ.'M'.OR.BRANCH(1:1).EQ.'P'.OR.BRANCH(1:1).EQ.
     1'R')THEN
        TYPE*,'Do you want to create a .CRD rather than an .HKL '
     1'file? Y/[N]'
        ACCEPT 1,ANS
        IF(ANS(1:1).EQ.'Y')CARD(21:24)='CARD'
      ENDIF
1002  N4=24
      IF(BRANCH(1:1).EQ.'R')CARD(1:10)='RE-PREPARE'
      IF(BRANCH(1:1).EQ.'M')CARD(1:16)='MAKE PHASED TAPE'
      IF(BRANCH(1:1).EQ.'E')CARD(1:4)='EDIT'
      IF(BRANCH(1:1).EQ.'L')CARD(1:4)='LIST'
      IF(BRANCH(1:1).EQ.'R')GOTO 1919
      IF(BRANCH(1:1).NE.'P')GOTO 1111
C
C   TITLE CARD
C
      TYPE*,'Are your data on disk? [Y]/N'
      ACCEPT 1,ANS
      IF(ANS(1:1).EQ.'N')INPT=1
      IF(ANS(1:1).NE.'N')THEN
        CARD(1:7)='PREPARE'
      ELSE
        CARD(1:11)='PREPARE CRD'
      ENDIF
      IF(INPT.NE.4)GOTO 1111
1919  TYPE*,'Do you want a complete listing of all reflections? ',
     1 '(Default lists first and last 5 reflections only.) Y/[N]'
      ACCEPT 1,ANS
      IF(ANS(1:1).EQ.'Y')CARD(13:17)='PRINT'
1111  TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
      IF(BRANCH(1:1).EQ.'L')GOTO 300
      IF(BRANCH(1:1).EQ.'R')INPT=4
      IF(BRANCH(1:1).EQ.'E')THEN
        INPT=1
        TYPE*,'Do you need to enter a KIND F card? Y/[N]'
        TYPE*,'One must be entered if you are hand-entering any form',
     1' FACTORS.'
        ACCEPT 1,ANS
        IF(ANS(1:1).EQ.'Y')GOTO 202
        GOTO 1601
      ENDIF
      IF(BRANCH(1:1).EQ.'R')THEN
        ANAM(NAMLEN+1:NAMLEN+4)='.HKL'
        TYPE*,'Do you want to change the CELL PARAMETERS currently ',
     1  'stored on your .HKL file? Y/[N]'
        TYPE*,'NOTE: If you are using the SWITCH option, your cell ',
     1  'parameters probably do need to be changed.'
        ACCEPT 1,ANS
        IF(ANS(1:1).EQ.'Y')GOTO 1121
        OPEN(NAME=ANAM,UNIT=12,TYPE='OLD',FORM='UNFORMATTED',
     1  BLOCKSIZE=32768,ERR=920)
        READ(12)STUFF,(FF(I),I=1,6)
        CLOSE(UNIT=12,DISP='SAVE')
        GOTO 1020
      ENDIF
1121  IADD=0
        IOP15=1     ! JUST UNTIL RETURN FROM FIND. MEANS INF EXISTS
        C4='CELL'
        ANAM(NAMLEN+1:NAMLEN+4)='.INF'
        CALL FIND(CARD,C4,I,15)  ! IS CELL CARD ALREADY ON INF FILE?
        IF(I.EQ.0)IOP15=0    ! INF FILE DOES NOT EXIST
        IF(I.EQ.1)THEN  ! YES, CELL CARD ALREADY THERE
          DECODE(80,201,CARD,ERR=923)FF(1),FF(2),FF(3),FF(4),FF(5),FF(6)
201       FORMAT(5X,F9.3,4X,F9.3,4X,F9.3,4X,F8.2,4X,F8.2,4X,F8.2)
          TYPE*,'CELL DIMENSIONS from .INF file are:'
          TYPE 204,(FF(II),II=1,6)
204       FORMAT(' A =',F8.4,', B =',F8.4,', C =',F8.4,', ALPHA =',
     1    F8.4,', BETA =',F8.4,', GAMMA =',F8.4)
          TYPE*,'DO YOU WANT TO CHANGE THESE?'
          ACCEPT 1,ANS
          IF(ANS(1:1).NE.'Y')GOTO 1020  ! USE INF CELL VALUES
        ENDIF
C210     IADD=1  ! ADD NEW CELL VALUES TO INF FILE
C      ENDIF
C
C   CELL CARD
C
210   TYPE*,'For CELL CARD, enter A, B, C, Alpha, Beta, and',
     1' Gamma, separated by commas.'
      READ(5,1021,ERR=1071)(FF(I),I=1,6)
      IADD=0
      IF(IOP15.EQ.1)IADD=1  !Add new cell values to .INF file
1020  ENCODE(80,103,CARD,ERR=1071)(FF(I),I=1,6)
      N4=54
      TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
      IF(IADD.EQ.1)THEN
        TYPE*,'Adding CELL PARAMETERS to .INF file.'
        ENCODE(80,211,CARD)FF(1),FF(2),FF(3),FF(4),FF(5),FF(6)
211     FORMAT(' CELL',3(F9.3,'(',2X,')'),3(F8.2,'(',2X,')'))
        CALL addin(CARD,15,IFLG)
      ENDIF
      IF(BRANCH(1:1).NE.'R')GOTO 202
      TYPE *,' Do you want the SWITCH option?'
      ACCEPT 1,ANS
      IF(ANS(1:1).NE.'Y')GOTO 2020
      CARD(1:6)='SWITCH'
      N4=6
      TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
      TYPE 394
394   FORMAT(' Enter the 9 elements of the transformation matrix for',
     1' the MILLER',/,' INDICES, separated by commas.')
      READ(5,137,ERR=393)(FF(I),I=1,9)
      ENCODE(80,392,CARD,ERR=393)(FF(I),I=1,9)
      N4=45
      TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
C
C  KINDF CARD
C
2020  TYPE*,'Do you want to change any of the KIND F identifiers ',
     1'currently stored on your .HKL file? Y/[N]'
      TYPE*,'  ' 
      TYPE*,'NOTE: If you are hand-entering any form factors, you ',
     1'must re-enter your KIND F card.'
      TYPE*,'If you are making any changes, you must re-enter the ',
     1'entire list.'
      ACCEPT 1,ANS
      IF(ANS(1:1).EQ.'Y')GOTO 202
      ANAM(NAMLEN+1:NAMLEN+4)='.HKL'
      OPEN(NAME=ANAM,UNIT=12,TYPE='OLD',FORM='UNFORMATTED',
     1  BLOCKSIZE=32768,ERR=921)
      READ(12)STUFF
      READ(12)(KNF(I),I=1,12)
      CLOSE(UNIT=12,DISP='SAVE')
      IFF=0
      ENCODE(80,107,CARD)(KNF(I),I=1,12),IFF
      N4=50
      GOTO 1061
C202   IF(IOP15.EQ.1)THEN   BJWFEB93 FIND LOOKS FOR INF, ETC
202     C4='FORM'
        ANAM(NAMLEN+1:NAMLEN+4)='.INF'
        CALL FIND(CARD,C4,I,15)  ! IS FORMULA ON INF FILE?
        IF(I.EQ.1)THEN  ! YES, FORMULA THERE
          DECODE(80,220,CARD,ERR=924)(AN(II),II=1,10)
220       FORMAT(6X,10(4X,A3))
          TYPE*,'KIND F from .INF file:'
          TYPE 221,(AN(II),II=1,10)
221       FORMAT(' KIND F ',10(A3,' '))
          TYPE*,'Do you want to change this? Y/[N]'
          ACCEPT 1,ANS
          IF(ANS(1:1).NE.'Y')THEN  ! USE KIND F FROM INF
            IFF=0
            GOTO 1042
          ENDIF
        ELSE           ! NO FORMULA LETS LOOK FOR MOLE
        C4='MOLE'
        ANAM(NAMLEN+1:NAMLEN+4)='.INF'
        CALL FIND(CARD,C4,I,15)  ! IS MOLECULE ON INF FILE?
        IF(I.EQ.1)THEN   ! YES MOLECULE IS THERE
          DECODE(80,2200,CARD,ERR=925)(AN(II),II=1,10)
2200      FORMAT(7X,10(4X,A3))
          TYPE*,'KIND F from .INF file:'
          TYPE 221,(AN(II),II=1,10)
          TYPE*,'Do you want to change this? Y/[N]'
          ACCEPT 1,ANS
          IF(ANS(1:1).NE.'Y')THEN    ! USE KIND F FROM INF
           IFF=0
           GO TO 1042
          ENDIF
         ENDIF
       ENDIF
C     ENDIF
      TYPE*,'For KIND F card, enter up to 12 ATOMIC SCATTERING '
      TYPE*,'FACTOR labels. Each  must be exactly THREE alphanumeric'
      TYPE*,'characters, left justified, spaces permitted, followed by',
     1' a comma.'
      READ(5,105,ERR=200)(AN(I),ASP,I=1,12)
c
      iff=0
1041  TYPE*,'Enter the number of FORM FACTORS that you are entering',
     1' yourself or "0" if blank.'
      ACCEPT *,IFF
c
      TYPE*,'Enter target [MO]/CU'
      READ(5,1)TARGET
      if (target.ne.'CU') target='MO'
1042  continue
c      IF(IFF.NE.0) THEN
c        N4=50
	ENCODE(80,107,CARD,ERR=200)(AN(I),I=1,12),IFF,target
c      ELSE
c  	ENCODE(80,107,CARD,ERR=200)(AN(I),I=1,12)
c        N4=42
c      ENDIF
1061  TYPE 2,CARD
      WRITE(4,1)CARD
139   IF(IFF.EQ.0)GO TO 155          ! DONT WANT TO ENTER FORM F'S
C
C    FORM FACTORS CARD
C
      TYPE*,'To enter FORM FACTORS, type in 30 F values at increments',
     1' of 0.05 in Sin(Theta)/Lambda, beginning at 0.0 in groups',
     2' of 10.  After you have entered three groups of 10, you will',
     3' be asked for your ATOMIC SCATTERING FACTOR label'
      DO 138 ISN=1,3
1389  READ(5,137,ERR=9)(FF(I),I=1,10)
1377  ENCODE(80,137,CARD,ERR=203)(FF(I),I=1,10)
      N4=80
      TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
138   CONTINUE
140   TYPE*,'Enter ATOMIC SCATTERING FACTOR label as on your KIND ',
     1'F card.'
      ACCEPT 1,CARD(1:3)
      N4=3
      TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
1410  IFF=IFF-1
      IF(IFF.GT.0)THEN
     	TYPE*,'For next ATOMIC SCATTERING FACTOR label,'
	GOTO 139
      ENDIF
155   IF(BRANCH(1:1).EQ.'E')GOTO 1601
      IF(BRANCH(1:1).EQ.'R')THEN
        TYPE*,'Do you need to change any of the ANOMALOUS DISPERSION ',
     1  'FACTORS currently stored on your .HKL file? [Y]/N'
        ACCEPT 1,ANS
        IF(ANS(1:1).NE.'N')GOTO 1414
        ANAM(NAMLEN+1:NAMLEN+4)='.HKL'
        OPEN(NAME=ANAM,UNIT=12,TYPE='OLD',FORM='UNFORMATTED',
     1  BLOCKSIZE=32768,ERR=922)
        READ(12)STUFF(1),(FF(I),I=1,10),(STUFF(I),I=1,9),FF(11),FF(12)
        CLOSE(UNIT=12,DISP='SAVE')
        CARD(1:10)='ANOMALOUS '
        II=11
        DO 1415 I=1,12
        IF(FF(I).NE.0.0)THEN
          ENCODE(10,1416,CARD(II:II+9))KNF(I),FF(I)
1416      FORMAT(A3,F7.3)
          II=II+10
        ENDIF
1415    CONTINUE
        N4=II-1
        GOTO 1554
      ENDIF
1414  TYPE*,' Do you want to enter the real part of any ANOMALOUS',
     1' DISPERSION FACTORS?'
      ACCEPT 1,ANS(2:2)
      IF(ANS(2:2).NE.'Y')THEN
1412    CARD(1:9)='ANOMALOUS'
        N4=9
        GOTO 1554
      ENDIF
      I=1
      N4=10
C
C   ANOMALOUS DISPERSION FACTORS
C
      type*,'For fp (ANOMALOUS DISPERSION FACTORS), enter one FORM'
      TYPE*,'LABEL as on KIND F card and the corresponding A.D.F.'
      TYPE*,'(real part) separated by a comma, for up to 7 elements.'
      TYPE*,'Enter just label to have value read from file.'
c      TYPE*,'the A.D.F''s are stored internally for elements Hs through'
c      TYPE*,'Cf for MoKalpha radiation.  For these elements, only the'
c      TYPE*,'FORM FACTOR LABEL need be entered.'
1551  TYPE*,'Enter FORM FACTOR and A.D.F (if needed).  RETURN to QUIT.'
1559  READ(5,1552,ERR=1556)AN(I),ASP,FF(I)
      IF(AN(I).EQ.'   ')GOTO 1555
c      IF(FF(I).EQ.0.0)THEN
c        CALL ANOM(II,AN(I),FF(I))  ! FIND INTERNAL A.D.F.
c        IF(II.EQ.0)THEN
c          TYPE*,'A.D.F. not stored internally for this form'
c          TYPE*,'factor.'
c          GOTO 1551
c        ENDIF
c      ENDIF
      I=I+1
      N4=N4+10
      GOTO 1551
1555  ENCODE(80,1553,CARD,ERR=1556)(AN(II),FF(II),II=1,I-1)
1554  TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
      IF(BRANCH(1:2).EQ.'MA') GO TO 144
1601  IF(INPT.EQ.4)GOTO 300
      IF(BRANCH(1:2).EQ.'ED') THEN
C   EDIT HERE
143	TYPE*,'Type "ADD", "DEL", or "SUB" for type card wanted.'
	ACCEPT 1,CARD(1:3)
        N4=3
	TYPE 2,CARD(1:N4)
	WRITE(4,1)CARD(1:N4)
        IF(CARD(1:1).EQ.'S')ICL=2
        IF(CARD(1:1).EQ.'D')ICL=1
      ENDIF
      CALL HKLIN(ICL)  ! ALL BUT MAKE PHASED TAPE - HKL DATA INPUT
      GOTO 134
C
C   MAKE PHASED TAPE HERE
C   DATA CARD
C
144   TYPE*,'Which type of data card do you need:'
      TYPE*,' [1]   H,K,L,A,B,W or'
      TYPE*,'  2    H,K,L,E,PHASE ANGLE,W'
      ACCEPT 1,ANS
      IF(ANS(1:1).EQ.'2') GO TO 149
1451  TYPE*,'Enter H,K,L,A, and B followed by commas.  If you need'
      TYPE*,'to enter a weight, type it after B (before CARRIAGE'
      TYPE*,'RETURN). A weight of 0 must be entered by typing "99." In'
      TYPE*,'the appropriate spot. After last data card, type "9999".'
147   READ(5,855,ERR=1471)IH,IK,IL,A,B,CW
      IF(IH.GE.1000) GO TO 300
      IF(CW.EQ.0.0)CW=1.0
      IF(CW.GE.99) CW=0.0
      ENCODE(80,840,CARD,ERR=1471)IH,IK,IL,A,B,CW
      N4=54
      TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
      GO TO 147
149   TYPE*,'Enter H,K,L,E, and PHASE ANGLE followed by commas.'
      TYPE*,'If you need to enter a WEIGHT, type it after PHASE ANGLE'
      TYPE*,'(before carriage return).  DEFAULT for WEIGHT is 1.0.  A'
      TYPE*,'weight of 0 must be entered by typing "99." in the'
      TYPE*,'appropriate spot.  After last data card, type "9999".'
151   READ(5,855,ERR=1521)IH,IK,IL,E,A,CW
      IF(IH.GT.1000) GO TO 300
      IF(CW.NE.0)THEN
	IF(CW.GE.99) CW=0.0
	ENCODE(80,152,CARD,ERR=1521)IH,IK,IL,E,A,CW
        N4=54
      ELSE
153	ENCODE(80,152,CARD,ERR=1521)IH,IK,IL,E,A
        N4=46
      ENDIF
      TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
      GO TO 151
134   IF(BRANCH(1:2).NE.'ED') GO TO 300  ! ALL BUT EDIT GOTO END
      ICL=0
      TYPE*,'Do you want to enter another TYPE card?'
      ACCEPT 1,ANS
      IF(ANS(1:1).EQ.'Y') GO TO 143
300   IF(BRANCH(1:1).EQ.'R')THEN
        TYPE*,' '
        TYPE*,'For RE-PREPARE, you must rename your .HKL file to ',
     1  'OLDHKL.HKL.  Type:'
        TYPE 3009,ANAM
3009    FORMAT(' RENAME ',A16,' OLDHKL.HKL')
        TYPE*,'BEFORE RUNNING THE PROGRAM!'
        TYPE*,' '
      ENDIF
      CARD(1:3)='END'
C
C   END CARD
C
      N4=3
      TYPE 2,CARD(1:N4)
      WRITE(4,1)CARD(1:N4)
c      IF(IOP15.EQ.1)CLOSE(UNIT=15,DISP='SAVE') ! CLOSE INF FILE
      RETURN
      END

