      SUBROUTINE SFLSIN(ITYP)
C  INPUT FOR STRUCTURE FACTORS, LEAST SQUARES
C  ITYP=2 FOR LEAST SQUARES, =1 FOR STRUCTURE FACTORS
      CHARACTER*4 ANS,C4,NAME(12),C44(12)
      CHARACTER*80 CARD
      CHARACTER*1 C1,CC(80),C1B,T1
      CHARACTER*2 TARGET
      CHARACTER*7 C7
      CHARACTER*8 C8
      CHARACTER*3 C3
      CHARACTER*16 ANAM
      CHARACTER*5 C5
      COMMON/FNAME/ANAM,NAMLEN
      DIMENSION S(6)
      EQUIVALENCE(CC(1),CARD)
      DOUBLE PRECISION Z
      BYTE MC                ! SIGNAL FOR COORDS IN NAM.PKS FILE
      IPUN=0
      IOP15=0
      IBRIEF=0
      IDD=0
      MC=0
1     FORMAT(A)
2     FORMAT(1X,<N4>A1)
3     FORMAT(<N4>A1)
10    FORMAT(I10)
20    FORMAT(F14.8)
      DO 2009 I=1,80
2009  CC(I)=' '
      IF(ITYP.EQ.2)THEN
        TYPE*,'Do you want to enter a few particular cards rather ',
     1'than create an entire input file? Y/[N]'
        ACCEPT 1,ANS
        IF(ANS(1:1).EQ.'Y')IBRIEF=1
        IF(IBRIEF.EQ.1)GOTO 500
      ENDIF
99    IADD=0
      II=NAMLEN+1
      ANAM(II:II+3)='.INF'
C  FIND OUT IF INF FILE EXISTS IN FIND NOW BJWFEB93
C      OPEN(NAME=ANAM,UNIT=15,TYPE='OLD',FORM='FORMATTED',ERR=100)
C       IOP15=1  ! SIGNAL FILE EXISTS  UNUSED BJWFEB93
C     GO SEE IF INF EXISTS AND IF SPACE GROUP IS THERE
      C4='SPAC'
      CALL FIND(CARD,C4,II,15)  ! IS SPACE GROUP ALREADY ON INF FILE?
      IF(II.EQ.1)THEN  ! YES, SPACE GROUP THERE. DO THEY WANT IT?
        DECODE(80,1001,CARD,ERR=923)I,C1
1001    FORMAT(14X,I3,A1)
        TYPE 1002,I,C1
1002    FORMAT(' Space group from INF file is ',I3,A1,'. Do you want')
        TYPE *,'to change this? Y/[N]'
        ACCEPT 1,ANS
        IF(ANS(1:1).NE.'Y')GOTO 101  ! USE STORED SPACE GROUP
      ENDIF
      IADD=1  ! SIGNAL TO ADD SPACE GROUP TO INF FILE
100   TYPE*,'Enter space group number - NO LETTER YET.'
      READ(5,10,ERR=901)I
      TYPE*,'Enter letter for special representation - RETURN IF NOT
     1 NEEDED.'
      ACCEPT 1,C1
      IF(IADD.EQ.1)THEN  ! ADD SPACE GROUP TO INF FILE
        ENCODE(80,1003,CARD)I,C1
1003    FORMAT(' SPACE GROUP: ',I3,A1)
        CALL addin(CARD,15,IFLG)  ! ADDS CARD TO FILE
        IF(IFLG.EQ.1)TYPE*,'Space group card added to INF file'
      ENDIF
101   C4='    '
      N4=29
      IF(ITYP.EQ.1)THEN
      TYPE*,'Do you want'
      TYPE*,' 1) "SAVE" option to establish or'
      TYPE*,' 2) "USE" option to apply'
      TYPE*,' partial contribution?'
      TYPE*,'Enter number or RETURN if neither wanted.'
      READ(5,10,ERR=902)J
      IF(J.EQ.1)C4='SAVE'
      IF(J.EQ.2)C4=' USE'
      ENCODE(32,102,CARD,ERR=901)I,C1,C4
      ELSE
      TYPE*,'Do you want the "USE" option to apply partial contributi
     1on? Y/[N]'
      ACCEPT 1,ANS
      IF(ANS(1:1).EQ.'Y')C4=' USE'
      ENCODE(32,103,CARD,ERR=901)I,C1,C4
      ENDIF
102   FORMAT('STRUCTURE FACTORS',1X,I3,A1,3X,A4)
103   FORMAT('LEAST SQUARES',5X,I3,A1,3X,A4)
      TYPE 2,(CC(IJ),IJ=1,N4)
      WRITE(4,3)(CC(IJ),IJ=1,N4)
      IF(IBRIEF.EQ.1)GOTO 500
104   TYPE*,'For weight card do you want:'
      TYPE*,' 1) Hughes option'
      TYPE*,' 2) Unit weight  (W=1.0)'
      TYPE*,'[3] External weight   (Taken from NAME.HKL file)'
      TYPE*,' 4) Other  (Equation form)'
      TYPE*,'Enter number'
      READ(5,10,ERR=903)I
      IF(I.EQ.1)GOTO 105
      IF(I.EQ.2)GOTO 108
      IF(I.EQ.4)GOTO 112
      GOTO  110
105   C7='       '
      TYPE*,'Do you want W=1/FOBS squared? Y/[N]'
      ACCEPT 1,ANS
      IF(ANS(1:1).EQ.'Y')C7='SQUARED'
106   TYPE*,'Enter value of 4*F(MIN)'
      READ(5,20,ERR=904)A
      N4=30
      ENCODE(32,107,CARD,ERR=904)C7,A
107   FORMAT('WEIGHT HUGHES',1X,A7,1X,F8.3)
      GOTO 115
108   CARD(1:12)='WEIGHT UNITY'
      N4=12
      GOTO 115
110   CARD(1:15)='WEIGHT EXTERNAL'
      N4=15
      GOTO 115
112   TYPE*,'Enter P,Q,R,S,T and U from equation, separated by commas.'
      TYPE*,'SQRT(W)=(P+Q*(SIN(THETA)/LAMBDA)**2/(R+S*F+T*F**2+U*F**3)'
      READ(5,113,ERR=905)S
113   FORMAT(6F8.6)
      ENCODE(44,114,CARD,ERR=905)S
      N4=43
114   FORMAT('WEIGHT',1X,6F6.5)
115   TYPE 2,(CC(IJ),IJ=1,N4)
      WRITE(4,3)(CC(IJ),IJ=1,N4)
      DO 1150 I=1,80
      CC(I)=' '
1150  CONTINUE
      IF(IBRIEF.EQ.1)GOTO 500
C
      TYPE*,'Do you want the default garbage card? [Y]/N'
      ACCEPT 1,ANS
      IF(ANS(1:1).EQ.'N')GOTO 174
      A=-3.0
      ENCODE(8,120,CC(9),ERR=906)A
      C1='1'
      ENCODE(1,121,CC(19))C1
      goto 173
  174 TYPE*,'Do you want a garbage card? [Y]/N'
      ACCEPT 1,ANS
      IF(ANS(1:1).EQ.'N')GOTO 124
116   TYPE*,'Enter P (Positive or Negative) such that reflections with',
     1 'F(OBS)**2 <= P*SIGMA(F) are rejected.  DEFAULT is -3.0.'
      READ(5,20,ERR=906)A
      IF(A.EQ.0.0)A=-3.0
      ENCODE(8,120,CC(9),ERR=906)A
      IF(ANS(1:1).NE.'N')C1='1'
      ENCODE(1,121,CC(19))C1
      TYPE*,'Do you want to include in a different sum reflections
     1 based on P cutoff? [Y]/N'
      ACCEPT 1,ANS
      C1=' '
      IF(ANS(1:1).NE.'N')C1='1'
      ENCODE(1,121,CC(19))C1
117   TYPE*,'Enter MAXIMUM(SIN(THETA)/LAMBDA)**2 - RETURN if not needed'
      READ(5,20,ERR=907)A
      IF(A.NE.0.0)ENCODE(6,122,CC(21),ERR=907)A
118   TYPE*,'Enter MINIMUM(SIN(THETA)/LAMBDA)**2 - RETURN if not needed'
      READ(5,20,ERR=908)A
      IF(A.NE.0.0)ENCODE(6,122,CC(27),ERR=908)A
      TYPE*,'Do you want to enter a matrix test value? Y/[N]'
      ACCEPT 1,ANS
      IF(ANS(1:1).EQ.'Y')THEN
      C3='1.D'
1180  TYPE*,'Enter an integer I for matrix test value to be "1.Di",'
      TYPE*,'i.e., for 1.D-3 enter "-3", for 1.D+2 enter "2" or "+2".'
      TYPE*,'I may be positive or negative.'
      ACCEPT 1181,C1,C1B
1181  FORMAT(A1,A1)
      IF(C1B.EQ.' ')THEN
      C1B=C1
      C1='+'
      ENDIF
      ENCODE(5,123,CC(34),ERR=9080)C3,C1,C1B
      ENDIF
  173 TYPE*,'To use fpp (imaginary part of anomalous
     1 dispersion, enter target: [  ]/MO/CU '
      ACCEPT 175,target
  175 FORMAT(A2)
      IF(TARGET.NE.'MO' .AND. TARGET.NE.'CU') TARGET='  '
      CARD(41:42)=TARGET
      CARD(1:7)='GARBAGE'
120   FORMAT(F8.5)
121   FORMAT(A1)
122   FORMAT(F6.3)
123   FORMAT(A3,A1,A1)
      N4=42
      TYPE 2,(CC(IJ),IJ=1,N4)
      WRITE(4,3)(CC(IJ),IJ=1,N4)
      IF(IBRIEF.EQ.1)GOTO 500
C
124   IK=0
      IF(ITYP.EQ.2)THEN
      TYPE*,'Do you want to refine your SCALE FACTOR? Y/[N]'
      ACCEPT 1,ANS
      IF(ANS(1:1).EQ.'Y')THEN
      IK=1
      TYPE*,'SCALE FACTOR must be entered later.'
      GOTO 128
      ENDIF
      ENDIF
125   TYPE*,'Enter SCALE FACTOR.  DEFAULT is 1.0.'
      IF(ITYP.EQ.2)TYPE*,'RETURN to have scale factor taken from NAME.
     1HKL file.'
      READ(5,20,ERR=909)A
      IF(A.EQ.0.0)A=1.0
126   TYPE 1260
1260  FORMAT(' Enter PARTIAL SHIFT FACTOR for refinement of this
     1 parameter.',/,' RETURN if not needed.')
      READ(5,20,ERR=910)B
      ENCODE(20,127,CARD,ERR=909)A,B
      N4=20
127   FORMAT('SCALE',1X,F10.7,1X,F3.1)
      TYPE 2,(CC(IJ),IJ=1,N4)
      WRITE(4,3)(CC(IJ),IJ=1,N4)
      IF(IBRIEF.EQ.1)GOTO 500
      IF(IDD.EQ.1)GOTO 137  ! REFINE SCALE - RETURN TO NEXT CARD
128   TYPE*,'Do you want to enter a SECONDARY EXTINCTION FACTOR? Y/[N]'
      IF(ITYP.EQ.2)TYPE*,'If you want your SECONDARY EXTINCTION FACTOR',
     1 'refined, enter "N" here and request the secondary extinction ',
     2 'option after you enter the appropriate matrix card.'
      ACCEPT 1,ANS
      IE=1
      IF(ANS(1:1).NE.'Y')GOTO 133
129   TYPE*,'Enter SECONDARY EXTINCTION FACTOR * 10 **6'
      READ(5,20,ERR=911)A
      IE=0
130   TYPE 1260
      READ(5,20,ERR=912)B
131   TYPE*,'Enter WAVELENGTH - RETURN for default of 0.71'
      READ(5,20,ERR=913)C
      TYPE*,'Do you want to permit the secondary extinction factor to'
      TYPE*,'become negative? Y/[N]'
      ACCEPT 1,ANS
      C3='   '
      IF(ANS(1:1).EQ.'Y')C3='NEG'
      ENCODE(50,132,CARD,ERR=911)A,B,C,C3
      N4=50
132   FORMAT('SECONDARY EXTINCTION',1X,F8.5,1X,F5.3,1X,F10.7,1X,A3)
      TYPE 2,(CC(IJ),IJ=1,N4)
      WRITE(4,3)(CC(IJ),IJ=1,N4)
      IF(IBRIEF.EQ.1)GOTO 500
      IF(IDD.EQ.1)GOTO 137  !REFINING EXTINCTION - RETURN TO NEXT CARD
133   IP=0
      TYPE*,'Do you want the "DO NOT PRINT" option to suppress output',
     1'on the first least squares cycle? Y/[N]'
      ACCEPT 1,ANS
      IF(ANS(1:1).NE.'Y')GOTO 136
      IP=1
134   TYPE*,'Enter "A" such that reflections with ABS(WDEL) > A are',
     1'listed - RETURN if not needed.'
      READ(5,20,ERR=914)A
      ENCODE(20,135,CARD,ERR=914)A
      N4=19
      IF(A.EQ.0.0)N4=12
135   FORMAT('DO NOT PRINT',1X,F6.2)
      TYPE 2,(CC(IJ),IJ=1,N4)
      WRITE(4,3)(CC(IJ),IJ=1,N4)
      IF(IBRIEF.EQ.1)GOTO 500
      IF(IDD.EQ.1)GOTO 168  ! NOT PRINTING IN LATER CYCLE - RETURN
136   TYPE*,'You will now be asked to enter the cards needed in your',
     1'data deck.  The first four letters of the card are sufficient ',
     2'to specify any card.'
      IDD=1
137   TYPE*,' '
      TYPE*,'Acceptable cards are:'
      TYPE*,' '
      IF(ITYP.EQ.2)TYPE*,'Diagonal Matrix'
      IF(ITYP.EQ.2)TYPE*,'Block Matrix'
      IF(ITYP.EQ.2)TYPE*,'Full Matrix'
      IF(ITYP.EQ.2)TYPE*,'No Refinement'
      IF(IK.EQ.1)TYPE*,'Scale factor    ** NECESSARY **'
      IF(IE.EQ.1.AND.ITYP.EQ.2)TYPE*,'Secondary extinction'
      TYPE*,'COORD'
      TYPE*,'ANISO'
      TYPE*,'ISO'
      TYPE*,'ISO-AN'
      TYPE*,'POP'
      TYPE*,'END'
      TYPE*,' '
      TYPE*,'Enter next card wanted'
      DATA NAME/'SCAL','DIAG','BLOC','FULL','NO R','COOR','ANIS',
     1 'ISO ','ISO-','POP ','SECO','END '/
      ACCEPT 1,C4
      DO 138 I=1,12
      IF(C4.EQ.NAME(I))GOTO 140
138   CONTINUE
      TYPE*,'CARD NOT FOUND - TRY AGAIN'
      GOTO 137
140   GOTO(141,142,142,145,148,150,151,152,153,154,163,164),I
C  SCALE CARD - REFINED
141   IF(IK.EQ.0)THEN
      TYPE*,'Scale card previously entered - ONLY ONE ACCEPTED.'
      GOTO 137
      ENDIF
      IK=0
      TYPE*,'Refined scale factor card'
      GOTO 125
C   DIAGONAL MATRIX AND BLOCK MATRIX CARDS
142   TYPE*,'Diagonal and block matrix cards'
      TYPE*,'Enter shift factor for every parameter - RETURN if not
     1 needed.'
      READ(5,20,ERR=915)A
      IF(I.EQ.2)THEN
      ENCODE(36,143,CARD,ERR=915)A
      N4=33
      ELSE
      ENCODE(36,144,CARD,ERR=915)A
      N4=33
      ENDIF
143   FORMAT('DIAGONAL MATRIX',15X,F3.1)
144   FORMAT('BLOCK MATRIX',18X,F3.1)
      IF(CARD(31:33).EQ.'0.0')CARD(31:33)='   '
      TYPE 2,(CC(IJ),IJ=1,N4)
      WRITE(4,3)(CC(IJ),IJ=1,N4)
      IF(IBRIEF.EQ.1)GOTO 500
      GOTO 137
145   TYPE*,'Full matrix card'
      TYPE*,'Do you need the override option to allow for 1500 ',
     1'parameters in one matrix rather than 300 parameters per '
     2'matrix? Y/[N]'
      ACCEPT 1,ANS
      C8='        '
      IF(ANS(1:1).EQ.'Y')C8='OVERRIDE'
146   TYPE*,'Enter shift factor for all parameters - RETURN if not
     1 needed.'
      READ(5,20,ERR=916)A
      ENCODE(36,147,CARD,ERR=916)C8,A
      N4=33
147   FORMAT('FULL MATRIX',1X,A8,10X,F3.1)
      IF(CARD(31:33).EQ.'0.0')CARD(31:33)='   '
      TYPE 2,(CC(IJ),IJ=1,N4)
      WRITE(4,3)(CC(IJ),IJ=1,N4)
      IF(IBRIEF.EQ.1)GOTO 500
      GOTO 137
148   TYPE*,'No refinement card'
      TYPE*,'Do you need the "SAVE" option to save A and B in special',
     1'slots on the NAME.HKL file for later use? Y/[N]'
      ACCEPT 1,ANS
      C4='    '
      IF(ANS(1:1).EQ.'Y')C4='SAVE'
      ENCODE(20,149,CARD)C4
      N4=20
149   FORMAT('NO REFINEMENT',3X,A4)
      TYPE 2,(CC(IJ),IJ=1,N4)
      WRITE(4,3)(CC(IJ),IJ=1,N4)
      IF(IBRIEF.EQ.1)GOTO 500
      GOTO 137
150   IF(ITYP.EQ.1)THEN
      TYPE*,'Do you want coordinates from MULTAN PKS file? Y/[N]'
      ACCEPT 1,ANS
      IF(ANS(1:1).EQ.'Y')MC=1
      ENDIF
      CALL COORDIN(1,MC)
      MC=0                   ! HAVE READ NAM.PKS FILE SO RESET MC
      IF(IBRIEF.EQ.1)GOTO 500
      GOTO 137
151   CALL COORDIN(5,MC)
      IF(IBRIEF.EQ.1)GOTO 500
      GOTO 137
152   CALL COORDIN(3,MC)
      IF(IBRIEF.EQ.1)GOTO 500
      GOTO 137
153   CALL COORDIN(4,MC)
      IF(IBRIEF.EQ.1)GOTO 500
      GOTO 137
154   TYPE*,'Which POP card?'
      TYPE*,' 1) 1 or more atoms constrained to the',
     1' same partial population or'
      TYPE*,' 2) Superposition of two atom types at the same atom
     2 coordinates.'
      TYPE*,'Enter number'
      READ(5,10,ERR=917)I
      IF(I.EQ.2)GOTO 161
155   TYPE*,'Enter the partial population (P).'
      READ(5,20,ERR=918)A
157   TYPE 1260
      READ(5,20,ERR=919)B
      TYPE 1570
1570  FORMAT(' Enter up to 6 atom identifiers (4 alphanumeric charac
     1ters) of atoms with',/,' Population = P, separated
     2 by commas.')
      TYPE 1571
1571  FORMAT(' 1111,2222,3333,4444,5555,6666')
      READ(5,159)(C44(I),C1,I=1,6)
      TYPE 1580
1580  FORMAT(' Enter up to 6 atom identifiers (4 alphanumeric charact
     1ers) of atoms whose',/,'  Population = 1 - P,
     2 separated by commas.')
      TYPE 1571
      READ(5,159)(C44(I),C1,I=7,12)
159   FORMAT(6(A4,A1))
      ENCODE(72,160,CARD,ERR=918)A,B,(C44(I),C44(I+6),I=1,6)
      N4=72
160   FORMAT('POP',8X,F6.3,F4.2,3X,12A4)
      TYPE 2,(CC(IJ),IJ=1,N4)
      WRITE(4,3)(CC(IJ),IJ=1,N4)
      IF(C44(6).EQ.'    '.AND.C44(12).EQ.'    ')GOTO 1605
1601  TYPE*,'Any more atoms to be constrained to this population fac
     1tor? Y/[N]'
      ACCEPT 1,ANS
      IF(ANS(1:1).NE.'Y')GOTO 1605
      TYPE 1570
      TYPE 1571
      READ(5,159)(C44(I),C1,I=1,6)
      TYPE 1580
      TYPE 1571
      READ(5,159)(C44(I),C1,I=7,12)
      ENCODE(72,1602,CARD)(C44(I),C44(I+6),I=1,6)
1602  FORMAT(24X,12A4)
      TYPE 2,(CC(IJ),IJ=1,N4)
      WRITE(4,3)(CC(IJ),IJ=1,N4)
      GOTO 1601
1605  TYPE*,'Another POP of this type?'
      ACCEPT 1,ANS
      IF(ANS(1:1).EQ.'Y')GOTO 155
      IF(IBRIEF.EQ.1)GOTO 500
      GOTO 137
161   TYPE*,'Enter atom identifier of first atom type (4 alphanumeric
     1 characters) and the partial population of this atom type,
     2 separated by a comma.'
      TYPE*,'IIII,  P  '
      READ(5,156,ERR=920)C4,C1,A
156   FORMAT(A4,A1,F8.3)
162   TYPE 1260
      READ(5,20,ERR=921)B
      TYPE*,'Enter atom form factor label (3 alphanumeric characters)
     1 of second atom.'
      ACCEPT 1,C3
      ENCODE(72,1600,CARD,ERR=920)C4,A,B,C3
1600  FORMAT('POP',3X,A4,1X,F6.3,F4.2,3X,A3)
      N4=27
      TYPE 2,(CC(IJ),IJ=1,N4)
      WRITE(4,3)(CC(IJ),IJ=1,N4)
      TYPE*,'Another POP of this type? Y/[N]'
      ACCEPT 1,ANS
      IF(ANS(1:1).EQ.'Y')GOTO 161
      IF(IBRIEF.EQ.1)GOTO 500
      GOTO 137
163   TYPE*,'Refined secondary extinction card'
      IF(IE.NE.1)THEN
      TYPE*,'Secondary extinction factor previously entered - only one
     1 allowed.'
      GOTO 137
      ENDIF
      IF(ITYP.EQ.1)TYPE*,'Secondary extinction must come before first
     1 matrix card.  You can enter it now, but be sure to transfer it
     2 to the correct place in your file before running the program!'
      GOTO 129
164   CARD(1:22)='END ATOMIC INFORMATION'
      N4=22
      TYPE 2,(CC(IJ),IJ=1,N4)
      WRITE(4,3)(CC(IJ),IJ=1,N4)
      IF(ITYP.EQ.1)THEN
C        IF(IOP15.EQ.1)CLOSE(UNIT=15,DISP='SAVE') ! CLOSE INF FILE
        RETURN
      ENDIF
      NC=2
1650  TYPE 1651,NC
1651  FORMAT(' Do you want another cycle (#',I2,') of least squares?
     1 [Y]/N')
      NC=NC+1
      ACCEPT 1,ANS
      IF(ANS(1:1).EQ.'N')GOTO 172
      TYPE*,'Do you want to print the next cycle on output? Y/N'
      ACCEPT 1,ANS
      IF(IP.EQ.0.AND.ANS(1:1).EQ.'N')THEN
        IP=1
        GOTO 134
      ENDIF
1652  IF(IP.EQ.1.AND.ANS(1:1).EQ.'Y')THEN
        C5='PRINT'
        ENCODE(8,166,CARD)C5
        N4=5
166     FORMAT(A5)
        TYPE 2,(CC(IJ),IJ=1,N4)
        WRITE(4,3)(CC(IJ),IJ=1,N4)
        IP=0
      ENDIF
      IF(IBRIEF.EQ.1)GOTO 500
168   TYPE*,'For recycle card, do you want the "SAME INVERSE" option ',
     1'to use the previous cycle''S matrix inverse?'
      ACCEPT 1,C4
      TYPE*,'Do you want the "USE" option to use A and B values
     1 previously "SAVE"D? Y/[N]'
      ACCEPT 1,ANS
      C3='   '
      IF(ANS(1:1).EQ.'Y')C3='USE'
      ENCODE(24,170,CC(1))C3
      IF(C4(1:1).EQ.'Y')ENCODE(12,169,CC(9))
169   FORMAT('SAME INVERSE')
170   FORMAT('RECYCLE',14X,A3)
      N4=24
      TYPE 2,(CC(IJ),IJ=1,N4)
      WRITE(4,3)(CC(IJ),IJ=1,N4)
      DO 171 I=1,80
      CC(I)=' '
171   CONTINUE
      IF(IBRIEF.EQ.1)GOTO 500
      GOTO 1650
172   TYPE*,'Do you want to create a NAME.TAB file of final coords ',
     1'and their shifts? Y/[N]'
      ACCEPT 1,ANS
      CARD(1:17)='END LEAST SQUARES'
      N4=17
      IF(ANS(1:1).EQ.'Y')THEN
        N4=22
        CARD(18:22)=' LIST'
      ENDIF
      TYPE 2,(CC(IJ),IJ=1,N4)
      WRITE(4,3)(CC(IJ),IJ=1,N4)
      IF(IBRIEF.EQ.1)GOTO 500
C      IF(IOP15.EQ.1)CLOSE(UNIT=15,DISP='SAVE') ! CLOSE INF FILE
      RETURN
C  HERE FOR MISCELLANOUS CARDS WANTED
500   TYPE*,' 1)Title Card                        2)Weight Card',
     1' 3)Garbage Card                      4)Scale Factor Card',
     2' 5)Secondary Extinction Factor Card  6)Do not print card',
     3' 7)Print card                        8)Diagonal Matrix Card',
     4' 9)Block Matrix Card                10)Full Matrix Card',
     5'11)No refinement card               12)Coord card',
     6'13)Aniso Card                       14)Iso Card',
     7'15)Iso-An Card                      16)POP Card',
     8'17)Recycle Card                     18)End Least Squares Card',
     9'                                                         ',
     1'Enter number.  RETURN to quit.'
      READ(5,10,ERR=922)I
      IF(I.EQ.0)THEN
C        IF(IOP15.EQ.1)CLOSE(UNIT=15,DISP='SAVE') ! CLOSE INF FILE
        STOP
      ENDIF
      GOTO (99,104,116,125,129,134,501,502,503,145,148,150,151,152,
     1 153,154,168,172),I
501   ANS(1:1)='Y'
      IP=1
      GOTO 1652
502   I=2
      GOTO 142
503   I=3
      GOTO 142
900   FORMAT(' ERROR ON LAST CARD ENTERED - TRY AGAIN.')
901   TYPE 900
      GOTO 100
902   TYPE 900
      GOTO 101
903   TYPE 900
      GOTO 104
904   TYPE 900
      GOTO 106
905   TYPE 900
      GOTO 112
906   TYPE 900
      GOTO 116
907   TYPE 900
      GOTO 117
908   TYPE 900
      GOTO 118
9080  TYPE 900
      GOTO 1180
909   TYPE 900
      GOTO 125
910   TYPE 900
      GOTO 126
911   TYPE 900
      GOTO 129
912   TYPE 900
      GOTO 130
913   TYPE 900
      GOTO 131
914   TYPE 900
      GOTO 134
915   TYPE 900
      GOTO 142
916   TYPE 900
      GOTO 146
917   TYPE 900
      GOTO 154
918   TYPE 900
      GOTO 155
919   TYPE 900
      GOTO 157
920   TYPE 900
      GOTO 161
921   TYPE 900
      GOTO 162
922   TYPE 900
      GOTO 500
923   IADD=1  ! SIGNAL TO ADD THE SPACE GROUP TO THE INF FILE
      TYPE*,'ERROR ON SPACE GROUP CARD IN INF FILE. WILL ADD NEW ONE.'
      GOTO 100
      END
