c
c  program absplot
c  takes name.psi from taperead and plots
c  only does 6 reflections now
c  many other non-general restraints imposed
c  
c
      character*1 esc,symb(13)
      dimension phi(13,72),corr(13,72)
      integer hkl(12,3)
      parameter (esc=char(27))
      data symb/'1','2','3','4','5','6','7','8','9','a','b','c','.'/
      OPEN(UNIT=5,STATUS='OLD')
      OPEN(UNIT=6,STATUS='new',carriagecontrol='list')
      read(5,1)nrefl,nps
    1 format(/2x,2i4)
      tmin=100
      tmax=0
      npsicn=0
      npsico=6
      i=1
    2 continue
      if (nrefl.lt.npsico) npsico=nrefl
      read(5,512) ((hkl(j,i),i=1,3),j=npsicn+1,npsico)
  512 format(/'   #   ',<npsico-npsicn>('  hkl=',3i4,2x))
      do i=1,nps
      read(5,516) (phi(j,I), corr(j,I),j=npsicn+1,npsico)
  516 FORMAT (4x,<npsico-npsicn>( F12.2, F8.4))
       do j=npsicn+1,npsico
        if(corr(j,i).lt.tmin .and. corr(j,i).gt.0.) tmin=corr(j,i)
        if(corr(j,i).gt.tmax) tmax=corr(j,i)
       enddo
      enddo
511   if (npsico.lt.nrefl) then
       npsicn=npsico
       npsico=npsico+6
       if (nrefl.lt.npsico) npsico=nrefl
       read(5,512) ((hkl(j,i),i=1,3),j=npsicn+1,npsico)
       do i=1,nps
        read(5,516) (phi(j,I),corr(j,I),j=npsicn+1,npsico)
        do j=npsicn+1,npsico
         if(corr(j,i).lt.tmin .and. corr(j,i).gt.0.) tmin=corr(j,i)
         if(corr(j,i).gt.tmax) tmax=corr(j,i)
        enddo
       enddo
      endif
      if (npsico.lt.nrefl) goto 511
c
c      read(5,3,end=4) (phi(j,I), corr(j,I),j=npsicn+1,npsico)
c    3 format (/4x,6( F12.2, F8.4))
c      goto 2
c      i=i+1


    4 npsi=i-1
c
      do j=1,nrefl
       do i=1,nps
        if(phi(j,i).gt.180.) phi(j,i)=phi(j,i)-180.
       enddo
      enddo
c
c
c
c
      inquire(4,exist=iexist)
      if (iexist) then
       OPEN(UNIT=4,STATUS='unknown')
       read(4,20,err=21,end=21) ncor,(corr(13,I),i=1,ncor)
   20  format(/4x,i4/12(3x,6f6.3/))
       do i=1,ncor
        phi(13,i)=360.*float(i-1)/float(ncor)
        if(corr(13,i).lt.tmin .and. corr(13,i).gt.0.) tmin=corr(13,i)
        if(corr(13,i).gt.tmax) tmax=corr(13,i)
       enddo
       go to 22
   21  iexist=.false.
      endif
   22 i=10.*tmin
      tmin=float(i)/10.
      i=10.*tmax+0.9999
      tmax=float(i)/10.
c
c      nrefl=0
c      do i=npsicn+1,npsico
c      if (corr(i,1).ne.0.0) nrefl=nrefl+1
c      enddo
c
      angmin=0.
      angmax=180.
      write(6,5)esc,esc,esc,esc,esc,esc,esc,
     1            angmin,angmax+20.,tmin,tmax
    5 format(a,'E'/a,'&l2A'/a,'&lO'/a,'*c5784x7200Y'/a,'*p0x0Y'/
     1       a,'*c0,200T'/a,'%1B'/'IN;SP1;'/
     2       'SC',f5.1,',',f5.1,',',f5.2,',',f5.2,';',/,
     3       'SD1,264,3,18,4,5.8,6,-6,7,45;SS;')
c
c
      pw=0.
      write(6,10) pw
   10 format('PW'f3.1';')
    8 format('PU;')
c
c  add this for reflection labelling
      sep=(tmax-1.0)/30.
      sthkl=1.0+sep
c
      angstep=10.
      angtic=angmin
      i=0.02*angmin+.0999*angstep
      angticb=float(i)/0.02
    9 if (angtic .gt. angmax+0.01*angstep) goto 11
      if (angtic .gt. angticb-.1*angstep .and. 
     1    angtic .lt. angticb+.1*angstep ) then 
       pw=0.4
       write(6,10)pw
       angticb=angticb+5.*angstep
       write(6,12)angtic,tmin,angtic,tmax
   12 format('PU'f5.1','f5.2';PD'f5.1','f5.2';')
       pw=0
       write(6,10)pw
      else
       write(6,12)angtic,tmin,angtic,tmax
      endif
      angtic=angtic+angstep
      goto 9
c
   11 tstep=0.01
      ttic=tmin
      tticb=tmin
   17 if (ttic .gt. tmax+0.01*tstep) goto 15
      if (ttic .gt. tticb-.1*tstep .and. 
     1    ttic .lt. tticb+.1*tstep ) then 
       pw=0.4
       write(6,10)pw
       tticb=tticb+10.*tstep
       write (6,12)angmin,ttic,angmax,ttic
       pw=0
       write(6,10)pw
      else
       write (6,12)angmin,ttic,angmax,ttic
      endif
      ttic=ttic+tstep
      goto 17
   15 write (6,8)
      write(6,24)
   24 format('DT!,1;'/'PA185,1;'/'LB1.0!')
      do l=1,nrefl
       write(6,26)sthkl,symb(l),(hkl(l,m),m=1,3)
   26  format('PA182,'f6.4';'/'LB'a1,1x,3i3'!')
       sthkl=sthkl+sep
      enddo
c
      do j=1,nrefl
      write (6,6) symb(j),(phi(j,I), corr(j,I),i=1,npsi)
    6 format('SM',a,';',<npsi/2>(/'PA',f8.2,',',f6.4,';'))
      enddo
      if (iexist) then
       write (6,23) symb(13),(phi(13,I), corr(13,I),i=1,ncor/2+1)
   23  format('SM',a,';',(/'PA',f8.2,',',f6.4,';PD;'),
     1       <ncor/2>(/'PA',f8.2,',',f6.4,';')'PU;')
      endif
c
      write(6,7)esc
    7 format(a,'E')
      stop
      end
