
C This is a temporary program to read a truncated .out file and to select
C reflections whose background GOF values are a specified number of sigma
C below the average  value. It uses absolute value of difference.
C It creates an .upd file as well as two .del files containing statistics
C and deleted reflections.
C Created for JAH4 to get rid of bad backgrounds due to pin getting in
C way of beam during FLAT mode data collection.
C
C
c      CHARACTER*20 FILEIN,FILEOUT,fileupd,fileout1
      character*1 ans
      character*80 line
      logical posds,negds
      dimension refl(10),nrefl(10),nbadref(5000)
      integer h
c   10 WRITE(*,'('' Name of .out file? '')')      
c      READ(*,1)FILEIN
c    1 FORMAT(A16)
c      namlen=16
c      do i=1,16
c      if (filein(i:i).eq.' ')then
c      namlen=i-1
c      if (namlen.eq.0) go to 10
c      goto 11
c      endif
c      enddo
c   11 filein=filein(1:namlen)
c      fileout=filein
c      fileupd=filein
c      filein(namlen+1:namlen+4)='.out'
c      fileout(namlen+1:namlen+4)='.del'
c      fileout1=fileout
c      fileupd(namlen+1:namlen+4)='.upd'
      posds=.false.
      negds=.false.
      write(*,'(a)') 
     1 ' Delete positive del/sig, negative, or both? [P]/N/B'
      read(5,'(a)') ans
      if(ans.eq.'b') ans='B'
      if(ans.eq.'n') ans='N'
      if(ans.ne.'N') posds=.true.
      if(ans.eq.'N' .or. ans.eq.'B') negds=.true.
c     
      WRITE(*,'('' Maximum Del/Sig? '')')      
      read(5,*)bad
      open(UNIT=14,STATUS='OLD')
      OPEN(UNIT=13,STATUS='new',carriagecontrol='list')
      OPEN(UNIT=15,STATUS='new',carriagecontrol='list')
      OPEN(UNIT=16,STATUS='new',carriagecontrol='list')
      nbad=0
      ntotal=0
      nlopos=0
      nloneg=0
      nhipos=0
      nhineg=0
      sneg=0.
      spos=0.
   19 READ(14,2,end=7) line
      if (line(51:57).ne.'DEL/SIG') goto 19
    3 READ(14,2,end=7) line
    2 FORMAT(a80)
      if (line(4:6).eq.'END') goto 7
      if (line(51:57).eq.'DEL/SIG') goto 3
      if(line(1:40).eq.'       ')goto 3
      decode(57,4,line)id,h,k,l,twotheta,ibone,ibtwo,delsig
    4 format(4i6,f11.2,2i7,f8.2)
      ntotal=ntotal+1
      if (abs(delsig).lt.abs(bad)) then
        if (delsig.gt.0.0) nlopos=nlopos+1
        if (delsig.lt.0.0) nloneg=nloneg+1
        goto 3
      else
        write(13,4)id,h,k,l,twotheta,ibone,ibtwo,delsig
        if (delsig.gt.0.0) then
          nhipos=nhipos+1
          if (delsig.gt.spos) spos=delsig
          if(posds)then
           nbad=nbad+1
           nbadref(nbad)=id
          endif
        endif
        if (delsig.lt.0.0) then
          nhineg=nhineg+1
          if (delsig.lt.sneg) sneg=delsig
          if(negds)then
           nbad=nbad+1
           nbadref(nbad)=id
          endif
        endif
      endif 
      goto 3
c      maxdel=200 single reflections 
c      maxcard=16.5 lines at 12 per
7     write(16,21) bad
   21 format(//' Cutoff limit for Del/Sig is' f5.2/)
      if(nbad.eq.0)goto12
      write(16,20)nloneg,nlopos,nhineg,nhipos,ntotal,sneg,spos
   20 format(/' Number within limit which are negative =',i6/
     1        '                               positive =',i6//
     2        ' Number out of limit which are negative =',i6/
     3        '                               positive =',i6//
     4        '                                  Total =',i6//
     5        ' Largest negative value =',f7.2/
     6        ' Largest positive value =',f7.2/)
      write(15,13)
   13 format('UPDATE')
      ncard=0
      nstart=1        
      nend=12
   15 if (nend.gt.nbad) nend=nbad
      write(15,14) (nbadref(l),l=nstart,nend) 
   14 format('DELETE',12i6)
      if (nend.eq.nbad)goto 16
      nstart=nstart+12
      nend=nend+12
      ncard=ncard+1
      if (ncard.eq.16)then
      ncard=0
      write(15,18)
   18 format('END'/'UPDATE')
      endif
      goto15
   16 write(15,17)
   17 format('END'/'END X-RAY')
   12 CLOSE(13)
      CLOSE(14)
      CLOSE(15)
      STOP
      END
