C This is a temporary program to read a .bad file and to select
C reflections whose F values are a specified number of sigma
C below the average F value.
C It creates a sorted .upd file and an original (.bad) ordered .wor
C file of offending reflections.
C Created for RWQ6 to get rid of weak reflections perhaps due to
C crystal movement.
C
c      CHARACTER*20 FILEIN,FILEOUT,fileupd
      character*1 type
      character*132 line
      parameter maxrefl=500
      dimension refl(maxrefl),nrefl(maxrefl),badref(2000,maxrefl)
      dimension nbadref(2000)
c   10 WRITE(*,'('' Name of .bad file? '')')      
c      READ(*,1)FILEIN
c    1 FORMAT(A16)
c      namlen=16
c      do i=1,16
c      if (filein(i:i).eq.' ')then
c      namlen=i-1
c      if (namlen.eq.0) go to 10
c      goto 11
c      endif
c      enddo
c   11 filein=filein(1:namlen)
c      fileout=filein
c      fileupd=filein
c      filein(namlen+1:namlen+4)='.bad'
c      fileout(namlen+1:namlen+4)='.wor'
c      fileupd(namlen+1:namlen+4)='.upd'
      WRITE(*,'('' Delete based on sigma or GOF? [S]/G'')')      
      read(5,'(a1)')type
      if (type.eq.'g') type = 'G'
      if (type.ne.'G') type = 'S'
      if (type.eq.'S')then
       WRITE(*,'('' Maximum sigma difference? '')')      
       read(5,*)bad
      else
       WRITE(*,'('' Minimum GOF? '')')      
       read(5,*)bad
      endif
c
      OPEN(UNIT=13,STATUS='new',carriagecontrol='list')
      open(UNIT=14,STATUS='OLD',carriagecontrol='list')
c
      nbad=0
    3 READ(14,2,end=7) line
    2 FORMAT(a132)
      if (line(22:22).ne.'*' .and. line(22:22).ne.'#') goto 3
      decode(132,4,line)gof,nh,k,l,f,fww,icnt,(refl(lj),lj=1,13)
    4 FORMAT(1x,f6.2,3I4,3x,F7.2,F5.1,10x,I5,13F6.1)
      read(14,5) (nrefl(i),i=1,13)
    5 format(49x,13i6)
      n=icnt
      if (icnt.gt.maxrefl) then
       write(3,20)nh,k,l,icnt,maxrefl
   20  format(' For indices h k l = ',3i4,', the number of'
     1        'reflections ='i5'; but only first'i6' are read.')
       n=maxrefl
      endif
      if (n.gt.13)then
       nread=(n-1)/13
       do lj=1,nread
        ls=13*lj+1
        le=ls+12
        if(le.gt.n) le=n
        read(14,21) (refl(lm),lm=ls,le)
   21   format(/49x,13f6.1)
        read(14,5) (nrefl(lm),lm=ls,le)
       enddo
      endif
c
c
      if (n.gt.1) then
        big=refl(1)
        nbig=1
          do m=2,n
            if(refl(m).gt.big) then
            big=refl(m)
            nbig=m
            endif
          enddo
          do m=1,n
            diff=(big-refl(m))
            if(diff.gt.bad*fww) then
              nbad=nbad+1
              badref(nbad,1)=nh
              badref(nbad,2)=k
              badref(nbad,3)=l
              badref(nbad,4)=f
              badref(nbad,5)=fww
              badref(nbad,6)=big
              badref(nbad,7)=nbig
              badref(nbad,8)=refl(m)
              badref(nbad,9)=nrefl(m)
              nbadref(nbad)=nrefl(m)
              badref(nbad,10)=gof
            endif
          enddo
        endif
      goto 3
c
c
c
    7 write(13,8)nbad
      if (nbad.eq.0) goto 12
      write(13,9)((badref(i,m),m=1,10),i=1,nbad)
    8 format(' nbad = 'i10//
     1 5x'h   k   l   Favg sigma  Fmax   num   Fbad IDfbad  GOF')
    9 format(3x,3f4.0,f7.2,f5.1,f7.2,f6.0,f7.2,f6.0,f6.2)
      do 19 i=nbad-1,1,-1
      do 19 ii=1,i
      if (nbadref(ii).gt.nbadref(ii+1)) then
      itemp=nbadref(ii)
      nbadref(ii)=nbadref(ii+1)
      nbadref(ii+1)=itemp
      endif
   19 continue
      OPEN(UNIT=15,STATUS='new',carriagecontrol='list')
c      maxdel=200 single reflections 
c      maxcard=16.5 lines at 12 per
      write(15,13)
   13 format('UPDATE')
      ncard=0
      nstart=1        
      nend=12
   15 if (nend.gt.nbad) nend=nbad
      write(15,14) (nbadref(l),l=nstart,nend) 
   14 format('DELETE',12i6)
      if (nend.eq.nbad)goto 16
      nstart=nstart+12
      nend=nend+12
      ncard=ncard+1
      if (ncard.eq.16)then
      ncard=0
      write(15,18)
   18 format('END'/'UPDATE')
      endif
      goto15
   16 write(15,17)
   17 format('END'/'END X-RAY')
   12 CLOSE(13)
      CLOSE(14)
      CLOSE(15)
      STOP
      END
