      PROGRAM BILL
C  TO CONVERT FROM DISTAN FILE COORDS 
c to orthogonal coordinates
C  FROM  distan,distb,ffmuro,etc
      character*80 line
C 4 letters for distan names **
      character*4 name(500)
      integer atnum(500)
      dimension coord(500,3),ff(500),x(500),y(500),z(500),RSIG(500)
      DIMENSION CELL(6)
      COMMON /GEN/ R1,R2,R3,R4,R5,S
      natom=0
      read(5,2)line
      WRITE(6,5)
    5 FORMAT('DISTANCES, ANGLES, AND PLANES   1')
      read(5,2)line
      if(line(1:4).ne.'CELL')then
       stop
      else
       decode(80,10,line) cell
   10  FORMAT('CELL  ',3F8.5,3f8.4)
        WRITE(6,10)1.,1.,1.,90.,90.,90.
      R=CELL(1)
      S=CELL(2)
      T=CELL(3)
      ALPHA=CELL(4)
      BETA=CELL(5)
      GAMMA=CELL(6)
      COSA=COS(ALPHA/57.2958)                                                159
      COSB=COS(BETA/57.2958)                                                 160
      COSC=COS(GAMMA/57.2958)                                                161
C
      DETA=4.0*(1.0-COSA**2-COSB**2-COSC**2+2.0*COSA*COSB*COSC)
      DETA=DETA/4.
      SINS=1.0-COSC*COSC                                                     163
      SING=SQRT(SINS)                                                        164
      R1=R*SING                                                              165
      R2=T*(COSB-COSA*COSC)/SING                                             166
      R3=R*COSC                                                              167
      R4=T*COSA                                                              168
      R5=T*SQRT(DETA/SINS)                                                   169
      endif   
    1 read(5,2,end=11)line
    2 format(a80)
      if(line(1:5).ne.'COORD') goto 1
      natom=natom+1
      decode(80,3,line) name(natom),ff(natom),x(natom),y(natom),
     + z(natom),RSIG(NATOM)
C **
    3 format('COORD ',a4,2x,a3,3f9.6,30x,F7.5)
      CALL ORTHOG(X(NATOM),Y(NATOM),Z(NATOM),X1,Y1,Z1)
      WRITE(6,3) NAME(NATOM),FF(NATOM),X1,Y1,Z1,RSIG(NATOM)
      goto1
   11 WRITE(6,12)
   12 FORMAT('DIST ALL       2.00      0.00'/'ANGLE ALL   1.60'/
     1       'END DISTAN'/'END X-RAY')
      STOP
      END
C
C
C     SUBROUTINE ORTHOG                                                 00000020
      SUBROUTINE ORTHOG(X,Y,Z,X1,Y1,Z1)                                 00000050
      COMMON /GEN/ R1,R2,R3,R4,R5,S
      X1=R1*X+R2*Z                                                      00000110
      Y1=S*Y+R3*X+R4*Z                                                  00000100
      Z1=R5*Z                                                           00000120
      RETURN                                                            00000130
      END                                                               00000140
