C ------------------------------------------------------------
C
c
c         PROGRAM SHELthma
c
c   to convert SHELX .LST file to thma .PAR and .ESD files
c   only does some stuff now
c   add no refine option
c   
      parameter na=600, mvar=63, nsfac=12
      CHARACTER*2 sfac(nsfac),KA(94),up
      CHARACTER*4 KC(76)
      character*4 label(na),tlabel(na),t1,t2
      character*20 name
      character*72 title
      character*124 card
      integer seg(2*mvar+1),natnum(na)
      real XYZ(na,3),mul(na),U(na,6),ueq(na),cell(6),mass(nsfac)
      real SXYZ(na,3),Smul(na),SU(na,6),sueq(na),Scell(6)
C
      DATA KC/'    ','END ','MOVE','SWAT','WPDB','BASF','EXTI',
     +'FVAR','WGHT','FRAG','FEND','REM ','CELL','ZERR','LATT',
     +'SYMM','SFAC','UNIT','GRID','MOLE','FMAP','PLAN','AFIX',
     +'TWIN','SPEC','OMIT','MERG','SUMP','RESI','SHEL','MORE',
     +'TIME','L.S.','CGLS','ACTA','DAMP','LIST','PART','DISP',
     +'hklf','SLIM','TITL','SIZE','EQIV','EXYZ','EADP','BOND',
     +'FREE','BIND','DFIX','SAME','CONF','RTAB','MPLA','FLAT',
     +'CHIV','BLOC','DELU','SIMU','ISOR','SADI','ANIS','CONN',
     +'HFIX','LAUE','BUMP','TEMP','DEFS','ABSC','FACE','EMPI',
     +'LAMI','HOPE','DMAT','SKIP','$H  '/
c
c
c      parameter na=600,ns=10,pi=3.14159265,rad=0.01745329
c      character*1 spgl,dptyp
c      character*3 sfac(ns),ffac(ns),ff
c      character*6 labelc(na),labeld(na),labelt
c      integer n(na),atno(na),Z,nunit(ns),spcgrp


         open(unit=4,status='old')
         read(4,'(a)') name
         namlen=index(name,' ')-1
      OPEN(UNIT=5,STATUS='OLD')
      OPEN(UNIT=6,STATUS='new',carriagecontrol='list')
      OPEN(UNIT=7,STATUS='new',carriagecontrol='list')
      OPEN(UNIT=8,STATUS='new',carriagecontrol='list')
c      inquire(6,exist=iexist)
c      write(6,*)exist
c
      nnat=0
      nat=0
    1 read(5,2,end=3) card
    2 format(1x,a124)
      if (card(1:4).eq.'CELL') then
       call SEPARATE(card,124,seg,mvar,nseg)
       do i=1,6
        ii=2*i+3
        read(card(seg(ii):seg(ii+1)),'(f<seg(ii+1)-seg(ii)+1>.0)')
     1       cell(i)
       enddo
       write(8,10)name(1:namlen),name(1:namlen),name(1:namlen),
     1 NAME(1:NAMLEN),name(1:namlen),name(1:namlen),name(1:namlen),cell
   10  format('$SET NOVERIFY'/
     1  '$ASS/U '   ,a,  '.PAR FOR001'/
     2  '$ASS/U '   ,a,  '.ESD FOR002'/
     3  '$ASS/U '   ,a,  '.COR FOR007'/
     3  '$ASS/U '   ,a,  '.THM FOR008'/
     3  '$ASS/U '   ,a,  '.tls sys$output'/
     3  '$ASS/U '   ,a,  '.err sys$error'/
     4  '$RUN CRY_MISC:THMA14'/
     5  'TITL RUN OF THMA14   ' ,a/
     6  'COMM COMMENT CARD ONLY'/
     7  'CELL ',3f8.3,3f7.2,/
     8  'FRMX F'/'MSDA Y'/'NVIB 0'/'IOUT 1'/
     9  'END'/
     1  '$EXIT')
c
      elseif (card(1:4).eq.'SFAC') then
       call SEPARATE(card,124,seg,mvar,nseg)
       do i=1,nseg-1
        ii=2*i+1
        read(card(seg(ii):seg(ii+1)),'(a<seg(ii+1)-seg(ii)+1>)')
     1       sfac(i)
       enddo
      natum=nseg-1
      call weight(sfac,mass,natum)
c
      elseif (card(1:4).eq.'FVAR') then
   11  read(5,2,end=3) card
       if(card(1:4).ne.'HKLF')then
        do i=1,76
         if(card(1:4).eq.kc(i)) goto 11
        enddo
        nnat=nnat+1
        decode(9,12,card,err=7)tlabel(nnat),natnum(nnat)
   12   format(a4,i5)
        goto 11       
       endif
c
      elseif (card(1:4).eq.'ATOM') then
       read(5,2,end=3) card
    4  read(5,2,end=3) card
       if (card(1:4).eq.'    ') goto 3
       nat=nat+1
       decode(124,6,card,err=7)label(nat),(xyz(nat,j),j=1,3),sof,
     1        (u(nat,j),j=1,3),(u(nat,j),j=6,4,-1),ueq(nat)
    6  format(a4,5x,3f10.5,f12.5,2x,6f10.5,f11.5)
       mul(nat)=1./sof
       read(5,2,end=3) card
       decode(124,9,card,err=7)(Sxyz(nat,j),j=1,3),Ssof,
     1        (Su(nat,j),j=1,3),(Su(nat,j),j=6,4,-1),Sueq(nat)
    9  format(9x,3f10.5,f12.5,2x,6f10.5,f11.5)
       Smul(nat)=ssof/(sof**2)
       read(5,2,end=3) card
       goto 4
      endif
      goto 1
c
c
    3  if (nat.eq.0) then
        write (6,5)
    5   format(' No atoms found.')
        stop
       endif
      do i=1,nat
       atmass=0
       t1=label(i)
       call capitalize(t1,2)
       t2=tlabel(i)
       call capitalize(t2,2)
       if (t1.eq.t2) atmass=mass(natnum(i))
       write(6,13) label(i),(xyz(i,j),j=1,3),atmass,mul(i),
     1        (u(i,j),j=1,6)
   13  format(1h',a4,1h',3f10.5,f12.6,f6.3,'/',/,6f9.5,'/')
       write(7,14) (Su(i,j),j=1,6),label(i)
   14  format(6f8.5,3h  ',a4,1h') 
      enddo
       stop
    7  write(6,8)card
    8  format(' Error reading/decoding this card'/1x,a124)
       stop
       end

C ------------------------------------------------------------
C
      subroutine CaPiTaLiZe(a,l)
c
c This subroutine capitalizes lowercase letters in a character string
c
      CHARACTER*(*) A
      DO I=1,L
      N=ICHAR(A(I:I))
      IF (N .GT. 96 .AND. N .LT. 123) A(I:I)=CHAR(N-32)
      ENDDO
      return
      END
C ------------------------------------------------------------

C -----------------------------------------------------------
       subroutine SEPARATE(line,len,seg,mseg,nseg)
       character*(*) line
       integer seg(2*mseg+1)
       do i=1,2*mseg+1
        seg(i)=0
       enddo
       nseg=0
       do i=1,len
        nnseg=2*nseg+1
        if (line(i:i).ne.' ') then
         if (seg(nnseg).eq.0) seg(nnseg)=i
        else       
         if (seg(nnseg).ne.0 .and. seg(nnseg+1).eq.0) then
          seg(nnseg+1)=i-1
          nseg=nseg+1
         endif
        endif
        if (line(len:len).ne.' ') seg(nnseg+1)=len
       enddo
       return
       end       
C -----------------------------------------------------------
      subroutine weight(name,mass,numat)
      character*2 name(numat),t1
      character*3 kindf(216),shelx(216)
      real mass(numat),atmass(103)
      integer nota(216)
c     kindf are form factors
c     shelx is shelx sfac CAUTION should be updated for available atoms
C DATA FOR ATOMIC MASSES TAKEN FROM CRC HANDBOOK, 66 ED  1985-1986 
C TABLE OF STANDARD ATOMIC WEIGHTS 1981
       DATA ATMASS/1.00794,4.0026,6.941,9.01218,10.81,12.011,
     1 14.0067,15.9994,18.998403,20.179,22.98977,24.305,26.98154,
     2 28.0855,30.97376,32.06,35.453,39.948,39.0983,40.08,44.9559,
     3 47.88,50.9415,51.996,54.9380,55.847,58.9332,58.69,63.546,
     4 65.38,69.72,72.59,74.9216,78.96,79.904,83.80,85.4678,87.62,
     5 88.9059,91.22,92.9064,95.94,98.,101.07,102.9055,106.42,
     6 107.8682,112.41,114.82,118.69,121.75,127.60,126.9045,131.29,
     7 132.9054,137.33,138.9055,140.12,140.9077,144.24,145.,150.36,
     8 151.96,157.25,158.9254,162.50,164.9304,167.26,168.9342,173.04,
     9 174.967,178.49,180.9479,183.85,186.207,190.2,192.22,195.08,
     1 196.9665,200.59,204.383,207.2,208.9804,209.,210.,222.,223.,
     1 226.0254,227.0278,232.0381,231.0359,238.0289,237.0482,244.,243.,
     2 247.,247.,251.,252.,257.,258.,259.,260./
c
C FORM FACTOR LABELS FROM FFBC.FOR, ****DIFFERENT FORMAT****
      DATA KINDF/
     1 'HS ', 'H  ', 'H1 ', 'HE ', 'LI ', 'LI1', 'BE ', 'BE2', 
     2 'B  ', 'C  ', 'CV ', 'N  ', 'O  ', 'O1 ', 'F  ', 'F1 ', 
     3 'NE ', 'NA ', 'NA1', 'MG ', 'MG2', 'AL ', 'AL3', 'SI ', 
     4 'SI4', 'P  ', 'S  ', 'CL ', 'CL1', 'AR ', 'K  ', 'K1 ', 
     5 'CA ', 'CA2', 'SC ', 'SC3', 'TI ', 'TI2', 'TI3', 'TI4', 
     6 'V  ', 'V2 ', 'V3 ', 'V5 ', 'CR ', 'CR2', 'CR3', 'MN ', 
     7 'MN2', 'MN3', 'MN4', 'FE ', 'FE2', 'FE3', 'CO ', 'CO2', 
     8 'CO3', 'NI ', 'NI2', 'NI3', 'CU ', 'CU1', 'CU2', 'ZN ', 
     9 'ZN2', 'GA ', 'GA3', 'GE ', 'GE4', 'AS ', 'SE ', 'BR ', 
     * 'BR1', 'KR ', 'RB ', 'RB1', 'SR ', 'SR2', 'Y  ', 'Y3 ', 
     1 'ZR ', 'ZR4', 'NB ', 'NB3', 'NB5', 'MO ', 'MO3', 'MO5', 
     2 'MO6', 'TC ', 'RU ', 'RU3', 'RU4', 'RH ', 'RH3', 'RH4', 
     3 'PD ', 'PD2', 'PD4', 'AG ', 'AG1', 'AG2', 'CD ', 'CD2', 
     4 'IN ', 'IN3', 'SN ', 'SN2', 'SN4', 'SB ', 'SB3', 'SB5', 
     5 'TE ', 'I  ', 'I1 ', 'XE ', 'CS ', 'CS1', 'BA ', 'BA2', 
     6 'LA ', 'LA3', 'CE ', 'CE3', 'CE4', 'PR ', 'PR3', 'PR4', 
     7 'ND ', 'ND3', 'PM ', 'PM3', 'SM ', 'SM3', 'EU ', 'EU2', 
     8 'EU3', 'GD ', 'GD3', 'TB ', 'TB3', 'DY ', 'DY3', 'HO ', 
     9 'HO3', 'ER ', 'ER3', 'TM ', 'TM3', 'YB ', 'YB2', 'YB3', 
     * 'LU ', 'LU3', 'HF ', 'HF4', 'TA ', 'TA5', 'W  ', 'W6 ', 
     1 'RE ', 'OS ', 'OS4', 'IR ', 'IR3', 'IR4', 'PT ', 'PT2', 
     2 'PT4', 'AU ', 'AU1', 'AU3', 'HG ', 'HG1', 'HG2', 'TL ', 
     3 'TL1', 'TL3', 'PB ', 'PB2', 'PB4', 'BI ', 'BI3', 'BI5', 
     4 'PO ', 'AT ', 'RN ', 'FR ', 'RA ', 'RA2', 'AC ', 'AC3', 
     5 'TH ', 'TH4', 'PA ', 'U  ', 'U3 ', 'U4 ', 'U6 ', 'NP ', 
     6 'NP3', 'NP4', 'NP6', 'PU ', 'PU3', 'PU4', 'PU6', 'AM ', 
     7 'CM ', 'BK ', 'CF ', 'ES ', 'FM ', 'MD ', 'NO ', 'LR '/ 
      DATA SHELX/
     1 'H  ', 'H  ', 'H  ', 'HE ', 'LI ', 'LI ', 'BE ', 'BE ', 
     2 'B  ', 'C  ', 'C  ', 'N  ', 'O  ', 'O  ', 'F  ', 'F  ', 
     3 'NE ', 'NA ', 'NA ', 'MG ', 'MG ', 'AL ', 'AL ', 'SI ', 
     4 'SI ', 'P  ', 'S  ', 'CL ', 'CL ', 'AR ', 'K  ', 'K  ', 
     5 'CA ', 'CA ', 'SC ', 'SC ', 'TI ', 'TI ', 'TI ', 'TI ', 
     6 'V  ', 'V  ', 'V  ', 'V  ', 'CR ', 'CR ', 'CR ', 'MN ', 
     7 'MN ', 'MN ', 'MN ', 'FE ', 'FE ', 'FE ', 'CO ', 'CO ', 
     8 'CO ', 'NI ', 'NI ', 'NI ', 'CU ', 'CU ', 'CU ', 'ZN ', 
     9 'ZN ', 'GA ', 'GA ', 'GE ', 'GE ', 'AS ', 'SE ', 'BR ', 
     * 'BR ', 'KR ', 'RB ', 'RB ', 'SR ', 'SR ', 'Y  ', 'Y  ', 
     1 'ZR ', 'ZR ', 'NB ', 'NB ', 'NB ', 'MO ', 'MO ', 'MO ', 
     2 'MO ', 'TC ', 'RU ', 'RU ', 'RU ', 'RH ', 'RH ', 'RH ', 
     3 'PD ', 'PD ', 'PD ', 'AG ', 'AG ', 'AG ', 'CD ', 'CD ', 
     4 'IN ', 'IN ', 'SN ', 'SN ', 'SN ', 'SB ', 'SB ', 'SB ', 
     5 'TE ', 'I  ', 'I  ', 'XE ', 'CS ', 'CS ', 'BA ', 'BA ', 
     6 'LA ', 'LA ', 'CE ', 'CE ', 'CE ', 'PR ', 'PR ', 'PR ', 
     7 'ND ', 'ND ', 'PM ', 'PM ', 'SM ', 'SM ', 'EU ', 'EU ', 
     8 'EU ', 'GD ', 'GD ', 'TB ', 'TB ', 'DY ', 'DY ', 'HO ', 
     9 'HO ', 'ER ', 'ER ', 'TM ', 'TM ', 'YB ', 'YB ', 'YB ', 
     * 'LU ', 'LU ', 'HF ', 'HF ', 'TA ', 'TA ', 'W  ', 'W  ', 
     1 'RE ', 'OS ', 'OS ', 'IR ', 'IR ', 'IR ', 'PT ', 'PT ', 
     2 'PT ', 'AU ', 'AU ', 'AU ', 'HG ', 'HG ', 'HG ', 'TL ', 
     3 'TL ', 'TL ', 'PB ', 'PB ', 'PB ', 'BI ', 'BI ', 'BI ', 
     4 'PO ', 'AT ', 'RN ', 'FR ', 'RA ', 'RA ', 'AC ', 'AC ', 
     5 'TH ', 'TH ', 'PA ', 'U  ', 'U  ', 'U  ', 'U  ', 'NP ', 
     6 'NP ', 'NP ', 'NP ', 'PU ', 'PU ', 'PU ', 'PU ', 'AM ', 
     7 'CM ', 'BK ', 'CF ', 'ES ', 'FM ', 'MD ', 'NO ', 'LR '/ 
C
C THIS ARRAY MAPS FORM FACTORS TO ATOMIC NUMBERS
       DATA NOTA/3*1,3,3,4,4,5,6,6,7,8,8,9,9,11,11,12,12,13,13,
     1 14,14,15,16,17,17,19,19,20,20,21,21,4*22,4*23,3*24,4*25,
     2 3*26,3*27,3*28,3*29,30,30,31,31,32,32,33,34,35,35,37,37,
     3 38,38,39,39,40,40,3*41,4*42,43,3*44,3*45,3*46,3*47,48,48,
     4 49,49,3*50,3*51,52,53,53,55,55,56,56,57,57,3*58,3*59,60,
     5 60,61,61,62,62,3*63,64,64,65,65,66,66,67,67,68,68,69,69,
     6 3*70,71,71,72,72,73,73,74,74,75,76,76,3*77,3*78,3*79,3*80,
     7 3*81,3*82,3*83,84,85,86,87,88,88,89,89,90,90,91,4*92,4*93,
     8 4*94,95,96,97,2,10,18,36,54,98,99,100,101,102,103/
C
c
      do i=1,numat
       t1=name(i)
       call capitalize(t1,2)
       do ikindf=1,216
        if (t1.eq.shelx(ikindf)(1:2))then
         mass(i)=atmass(nota(ikindf))
         goto 1
        endif
       enddo
    1 continue
      enddo       
c
      return
      end

C -----------------------------------------------------------
