C PROGRAM TO CONVERT .TAB FILES TO CCDC FILES FOR DEPOSITION TO CCDC
      REAL x,y,z,sx,sy,sz,ueq,b,sueq,sb,u11,u22,u33,u12,u13,u23
      INTEGER iu11,iu22,iu33,iu12,iu13,iu23
      INTEGER su11,su22,su33,su12,su13,su23
      CHARACTER*3 dummy_char,therm_par,answer
      CHARACTER*4 aname
      CHARACTER*129 Line
      LOGICAL file_exists
      INTEGER ix,iy,iz,isx,isy,isz,iueq,isueq
C
      WRITE(*,*)
      WRITE(*,*)
      WRITE(*,*)
      WRITE(*,8)
      WRITE(*,9)'                                                    '
      WRITE(*,9)'      CONVERT .TAB FILE TO .CCDC FILE               '
      WRITE(*,9)'                                                    '
      WRITE(*,9)'This program will read your NAME.TAB file and write '
      WRITE(*,9)'a new NAME.CIF file with atom name, coordinates,   '
      WRITE(*,9)'coordinate sigmas, and Ueq values.                  '
      WRITE(*,9)'                                                    '
      WRITE(*,8)
      WRITE(*,*)
      WRITE(*,*)
    9 FORMAT(8x,'*',3x,a52,3x,'*')
    8 FORMAT(8X,'***************************************************',
     1 '*********')
C
      WRITE(*,*)
      write(*,*)'                           RETURN to continue'
      READ(*,90)answer
   90 format(a1)
C Opening .TAB file
          INQUIRE(unit=5,EXIST=file_exists)
          IF(file_exists) THEN
               OPEN(unit=5,STATUS='OLD',READONLY) ! .TAB file
               REWIND (5)
          ELSE
               WRITE(*,*)'ERROR - INPUT FILE DOES NOT EXIST!'
               GOTO 1000
          ENDIF
C
      WRITE(*,*)
      write(7,110)
      write(*,110)
  110 format(1x,'Atom',7x,'X',13x,'Y',13x,'Z',13x,'Ueq')
      WRITE(*,*)
C
  120 READ(5,125,END=200)Line
  125 FORMAT(A129)
C
      DECODE(80,127,line)dummy_char
  127 FORMAT(11x,A3)
C
C
      IF(dummy_char .EQ. ' X ') THEN
          DECODE(80,137,line)therm_par  ! Checks for ' B '
  137     FORMAT(11x,3x,36x,A3)
          READ(5,125,END=500)Line
          goto 120
      endif
C
      if(therm_par.ne.' B ') then
         DECODE(129,140,line)aname,ix,isx,iy,isy,iz,isz,iueq,isueq
C         write(*,*)line(117:129),'dum_char = ',dummy_char
  140    format(1x,A4,1x,I7,1x,I3,2x,I7,1x,I3,2x,I7,1x,I3,73x,i7,
     1         1x,i3)
         x = float(ix) /100000.
         y = float(iy) /100000.
         z = float(iz) /100000.
         ueq = float(iueq) /10000.
      else
         DECODE(129,160,line)aname,ix,isx,iy,isy,iz,isz,b,sb
  160   format(1x,A4,2x,I6,2x,I2,3x,I6,2x,I2,3x,I6,2x,I2,2x,
     1           f7.2,2x,f4.2)
         x = float(ix) /10000.
         y = float(iy) /10000.
         z = float(iz) /10000.
         ueq = (b)/(8.*3.14159*3.14159)
         isueq = NINT((10000.*sb)/(8.*3.14159*3.14159))
      endif 
C
         write(*,145)aname,x,isx,y,isy,z,isz,ueq,isueq
         write(7,145)aname,x,isx,y,isy,z,isz,ueq,isueq
  145    format(1x,A4,3x,f7.5,'(',I3,')  ',f7.5,'(',I3,')  ',f7.5,'(',I3,
     1           ')  ',f7.4,'( ',I3,')')
C
      goto 120
  200 REWIND(5)
C
      WRITE(*,*)
      write(7,210)
      write(*,210)
  210 format(1x,'Atom',4x,'U11',9x,'U22',9x,'U33',9x,'U12',9x,
     1        'U13',9x,'U23')
      WRITE(*,*)
C Now working on Uij's
  220 READ(5,125,END=500)Line
C
      DECODE(80,127,line)dummy_char
C
      IF(dummy_char .EQ. ' X ') THEN
          DECODE(80,137,line)therm_par  ! Checks for ' B '
          READ(5,125,END=500)Line
          goto 220
      endif
C
      if(therm_par.ne.' B ') then
         DECODE(129,240,line)aname,iu11,su11,iu22,su22,iu33,su33,
     1                       iu12,su12,iu13,su13,iu23,su23
  240    format(1x,A4,38x,3x,i5,1x,i3, 3x,i5,1x,i3, 3x,i5,1x,i3,
     1          3x,i5,1x,i3, 3x,i5,1x,i3, 3x,i5,1x,i3)
         u11 = float(iu11) /10000.
         u22 = float(iu22) /10000.
         u33 = float(iu33) /10000.
         u12 = float(iu12) /10000.
         u13 = float(iu13) /10000.
         u23 = float(iu23) /10000.
      else
         goto 220
      endif 
C
         write(*,245)aname,u11,su11,u22,su22,u33,su33,u12,su12,u13,
     1               su13,u23,su23
         write(7,245)aname,u11,su11,u22,su22,u33,su33,u12,su12,u13,
     1               su13,u23,su23
  245    format(1x,A4,f7.4,'(',I2,') ',f7.4,'(',I2,') ',f7.4,'(',
     1   I2,') ',f7.4,'(',I2,') ',f7.4,'(',I2,') ',f7.4,'(',I2,')')
C
      goto 220
C
  500 WRITE(*,*)' End of .TAB file reached.'
 1000 WRITE(*,*)

      END
