     0SUBROUTINE ETOAST(
     1                  LENGTH
     2                 ,STRING
     Z                 )
C
C
      INTEGER LENGTH
      LOGICAL*1 STRING(LENGTH)
C
C**********  LOCAL VARIABLES  **********
C
      INTEGER I, J
      LOGICAL*1 ASCII(256)
     0LOGICAL*1 R0(16), R1(16), R2(16), R3(16)
     1        , R4(16), R5(16), R6(16), R7(16)
     2        , R8(16), R9(16), RA(16), RB(16)
     3        , RC(16), RD(16), RE(16), RF(16)
     0PARAMETER I0 = 1      , I1 = I0 + 16, I2 = I1 + 16, I3 = I2 + 16
     1        , I4 = I3 + 16, I5 = I4 + 16, I6 = I5 + 16, I7 = I6 + 16
     2        , I8 = I7 + 16, I9 = I8 + 16, IA = I9 + 16, IB = IA + 16
     3        , IC = IB + 16, ID = IC + 16, IE = ID + 16, IF = IE + 16
     0EQUIVALENCE (R0(1), ASCII(I0)), (R1(1), ASCII(I1))
     1          , (R2(1), ASCII(I2)), (R3(1), ASCII(I3))
     2          , (R4(1), ASCII(I4)), (R5(1), ASCII(I5))
     3          , (R6(1), ASCII(I6)), (R7(1), ASCII(I7))
     4          , (R8(1), ASCII(I8)), (R9(1), ASCII(I9))
     5          , (RA(1), ASCII(IA)), (RB(1), ASCII(IB))
     6          , (RC(1), ASCII(IC)), (RD(1), ASCII(ID))
     7          , (RE(1), ASCII(IE)), (RF(1), ASCII(IF))
C
C
C     EBCDIC    00   01   02   03   04   05   06   07
     0DATA R0 /  0,   1,   2,   3,   4,   5,   6,   7
C               08   09   0A   0B   0C   0D   0E   0F
     1       ,   8,   9,  10,  11,  12,  13,  14,  15/
C     EBCDIC    10   11   12   13   14   15   16   17
     0DATA R1 / 16,  17,  18,  19,  20,  21,  22,  23
C               18   19   1A   1B   1C   1D   1E   1F
     1       ,  24,  25,  26,  27,  28,  29,  30,  31/
C     EBCDIC    20   21   22   23   24   25   26   27
     0DATA R2 /'~', '~', '~', '~', '~', '~', '~', '~'
C               28   29   2A   2B   2C   2D   2E   2F
     1       , '~', '~', '~', '~', '~', '~', '~', '~'/
C     EBCDIC    30   31   32   33   34   35   36   37
     0DATA R3 /'~', '~', '~', '~', '~', '~', '~', '~'
C               38   39   3A   3B   3C   3D   3E   3F
     1       , '~', '~', '~', '~', '~', '~', '~', '~'/
C     EBCDIC    40   41   42   43   44   45   46   47
     0DATA R4 /' ', '~', '~', '~', '~', '~', '~', '~'
C               48   49   4A   4B   4C   4D   4E   4F
     1       , '~', '~', '~', '.', '<', '(', '+', '|'/
C     EBCDIC    50   51   52   53   54   55   56   57
     0DATA R5 /'&', '~', '~', '~', '~', '~', '~', '~'
C               58   59   5A   5B   5C   5D   5E   5F
     1       , '~', '~', '!', '$', '*', ')', ';', '^'/
C     EBCDIC    60   61   62   63   64   65   66   67
     0DATA R6 /'-', '/', '~', '~', '~', '~', '~', '~'
C               68   69   6A   6B   6C   6D   6E   6F
     1       , '~', '~', '~', ',', '%', '_', '>', '?'/
C     EBCDIC    70   71   72   73   74   75   76   77
     0DATA R7 /'~', '~', '~', '~', '~', '~', '~', '~'
C               78   79   7A   7B   7C   7D    7E   7F
     1       , '~', '~', ':', '#', '@', '''', '=', '"'/
C     EBCDIC    80   81   82   83   84   85   86   87
     0DATA R8 /'~', 'A', 'B', 'C', 'D', 'E', 'F', 'G'
C               88   89   8A   8B   8C   8D   8E   8F
     1       , 'H', 'I', '~', '~', '~', '~', '~', '~'/
C     EBCDIC    90   91   92   93   94   95   96   97
     0DATA R9 /'~', 'J', 'K', 'L', 'M', 'N', 'O', 'P'
C               98   99   9A   9B   9C   9D   9E   9F
     1       , 'Q', 'R', '~', '~', '~', '~', '~', '~'/
C     EBCDIC    A0   A1   A2   A3   A4   A5   A6   A7
     0DATA RA /'~', '~', 'S', 'T', 'U', 'V', 'W', 'X'
C               A8   A9   AA   AB   AC   AD   AE   AF
     1       , 'Y', 'Z', '~', '~', '~', '~', '~', '~'/
C     EBCDIC    B0   B1   B2   B3   B4   B5   B6   B7
     0DATA RB /'~', '~', '~', '~', '~', '~', '~', '~'
C               B8   B9   BA   BB   BC   BD   BE   BF
     1       , '~', '~', '~', '~', '~', '~', '~', '~'/
C     EBCDIC    C0   C1   C2   C3   C4   C5   C6   C7
     0DATA RC /'~', 'A', 'B', 'C', 'D', 'E', 'F', 'G'
C               C8   C9   CA   CB   CC   CD   CE   CF
     1       , 'H', 'I', '~', '~', '~', '~', '~', '~'/
C     EBCDIC    D0   D1   D2   D3   D4   D5   D6   D7
     0DATA RD /'~', 'J', 'K', 'L', 'M', 'N', 'O', 'P'
C               D8   D9   DA   DB   DC   DD   DE   DF
     1       , 'Q', 'R', '~', '~', '~', '~', '~', '~'/
C     EBCDIC    E0   E1   E2   E3   E4   E5   E6   E7
     0DATA RE /'~', '~', 'S', 'T', 'U', 'V', 'W', 'X'
C               E8   E9   EA   EB   EC   ED   EE   EF
     1       , 'Y', 'Z', '~', '~', '~', '~', '~', '~'/
C     EBCDIC    F0   F1   F2   F3   F4   F5   F6   F7
     0DATA RF /'0', '1', '2', '3', '4', '5', '6', '7'
C               F8   F9   FA   FB   FC   FD   FE   FF
     1       , '8', '9', '~', '~', '~', '~', '~', '~'/
C
C
C=======================================================================
C
  100 IF(LENGTH .LE. 0) RETURN
      DO 120 I = 1, LENGTH
          J = STRING(I)
          IF(J .LT. 0) J = J + 256
          STRING(I) = ASCII(J + 1)
  120     CONTINUE
      RETURN
C
C=======================================================================
C
C
      END

     0SUBROUTINE ATOEST(
     1                  LENGTH
     2                 ,STRING
     Z                 )
C
C
      INTEGER LENGTH
      LOGICAL*1 STRING(LENGTH)
C
C**********  LOCAL VARIABLES  **********
C
      INTEGER I, J
      LOGICAL*1 EBCDIC(128)
     0LOGICAL*1 R0(16), R1(16), R2(16), R3(16)
     1        , R4(16), R5(16), R6(16), R7(16)
     0PARAMETER I0 = 1      , I1 = I0 + 16, I2 = I1 + 16, I3 = I2 + 16
     1        , I4 = I3 + 16, I5 = I4 + 16, I6 = I5 + 16, I7 = I6 + 16
     0EQUIVALENCE (R0(1), EBCDIC(I0)), (R1(1), EBCDIC(I1))
     1          , (R2(1), EBCDIC(I2)), (R3(1), EBCDIC(I3))
     2          , (R4(1), EBCDIC(I4)), (R5(1), EBCDIC(I5))
     3          , (R6(1), EBCDIC(I6)), (R7(1), EBCDIC(I7))
C
C
C     ASCII       00     01     02     03     04     05     06     07
     0DATA R0 /    0,     1,     2,     3,     4,     5,     6,     7
C                 08     09     0A     0B     0C     0D     0E     0F
     1       ,     8,     9,    10,    11,    12,    13,    14,    15/
C     ASCII       10     11     12     13     14     15     16     17
     0DATA R1 /   16,    17,    18,    19,    20,    21,    22,    23
C                 18     19     1A     1B     1C     1D     1E     1F
     1       ,    24,    25,    26,    27,    28,    29,    30,    31/
C     ASCII      ' '    '!'    '"'    '#'    '$'    '%'    '&'   ''''
     0DATA R2 /'40'X, '5A'X, '7F'X, '7B'X, '5B'X, '6C'X, '50'X, '7D'X
C                '('    ')'    '*'    '+'    ','    '-'    '.'    '/'
     1       , '4D'X, '5D'X, '5C'X, '4E'X, '6B'X, '60'X, '4B'X, '61'X/
C     ASCII      '0'    '1'    '2'    '3'    '4'    '5'    '6'    '7'
     0DATA R3 /'F0'X, 'F1'X, 'F2'X, 'F3'X, 'F4'X, 'F5'X, 'F6'X, 'F7'X
C                '8'    '9'    ':'    ';'    '<'    '='    '>'    '?'
     1       , 'F8'X, 'F9'X, '7A'X, '5E'X, '4C'X, '7E'X, '6E'X, '6F'X/
C     ASCII      '@'    'A'    'B'    'C'    'D'    'E'    'F'    'G'
     0DATA R4 /'7C'X, 'C1'X, 'C2'X, 'C3'X, 'C4'X, 'C5'X, 'C6'X, 'C7'X
C                'H'    'I'    'J'    'K'    'L'    'M'    'N'    'O'
     1       , 'C8'X, 'C9'X, 'D1'X, 'D2'X, 'D3'X, 'D4'X, 'D5'X, 'D6'X/
C     ASCII      'P'    'Q'    'R'    'S'    'T'    'U'    'V'    'W'
     0DATA R5 /'D7'X, 'D8'X, 'D9'X, 'E2'X, 'E3'X, 'E4'X, 'E5'X, 'E6'X
C                'X'    'Y'    'Z'    '['    '\'    ']'    '^'    '_'
     1       , 'E7'X, 'E8'X, 'E9'X, '4A'X, '4A'X, '4A'X, '5F'X, '6D'X/
C     ASCII      '`'    'a'    'b'    'c'    'd'    'e'    'f'    'g'
     0DATA R6 /'4A'X, 'C1'X, 'C2'X, 'C3'X, 'C4'X, 'C5'X, 'C6'X, 'C7'X
C                'h'    'i'    'j'    'k'    'l'    'm'    'n'    'o'
     1       , 'C8'X, 'C9'X, 'D1'X, 'D2'X, 'D3'X, 'D4'X, 'D5'X, 'D6'X/
C     ASCII      'p'    'q'    'r'    's'    't'    'u'    'v'    'w'
     0DATA R7 /'D7'X, 'D8'X, 'D9'X, 'E2'X, 'E3'X, 'E4'X, 'E5'X, 'E6'X
C                'x'    'y'    'z'    '{'    '|'    '}'    '~'     7F
     1       , 'E7'X, 'E8'X, 'E9'X, '4A'X, '4F'X, '4A'X, '4A'X, '4A'X/
C
C
C=======================================================================
C
  100 IF(LENGTH .LE. 0) RETURN
      DO 120 I = 1, LENGTH
          J = STRING(I) .AND. '7F'X
          STRING(I) = EBCDIC(J + 1)
  120     CONTINUE
      RETURN
C
C=======================================================================
C
C
      END

     0SUBROUTINE ETOACH(
     1                  CHARAC
     Z                 )
C
C
      CHARACTER*(*) CHARAC
C
C
C=======================================================================
C
  100 CONTINUE
     0CALL ETOAST(
     1            LEN(CHARAC)
     2           ,%VAL(%LOC(CHARAC))
     Z           )
      RETURN
C
C=======================================================================
C
C
      END

     0SUBROUTINE ATOECH(
     1                  CHARAC
     Z                 )
C
C
      CHARACTER*(*) CHARAC
C
C
C=======================================================================
C
  100 CONTINUE
     0CALL ATOEST(
     1            LEN(CHARAC)
     2           ,%VAL(%LOC(CHARAC))
     Z           )
      RETURN
C
C=======================================================================
C
C
      END
