     0SUBROUTINE MTOPEN(
     1                  CHANNO
     2                 ,RESULT
     Z                 )
C
C
      INTEGER CHANNO
      INTEGER RESULT
C
C
      INCLUDE 'MTOC00.INS /NOLIST'
C
C
      INCLUDE 'MTERCS.INS /NOLIST'
C
C
C**********  SYSTEM PARAMETERS  **********
C
      INCLUDE '($SSDEF)'
C
C
      INCLUDE 'DIBDEF.INS /NOLIST'
C
C
      INCLUDE '($DCDEF)'
C
C**********  EXTERNAL FUNCTIONS  **********
C
      INTEGER SYS$ALLOC
      INTEGER SYS$ASSIGN
      INTEGER SYS$DALLOC
      INTEGER SYS$GETCHN
C
C**********  LOCAL PARAMETERS  **********
C
      PARAMETER CLSF = DIB$B_DEVCLASS + 1
C
C**********  LOCAL VARIABLES  **********
C
      INTEGER STATUS
      INTEGER DUMMY
      CHARACTER*6 DIBBUF
C
C
C=======================================================================
C
  100 CONTINUE
      RESULT = 0
      CONTINUE
C
C**********  CHECK FOR AN AVAILABLE SLOT  **********
C
  200 CONTINUE
      CHANNO = 1
      DO WHILE((CHANNO .LE. MTCMAX) .AND. MTOPND(CHANNO))
          CHANNO = CHANNO + 1
      END DO
      IF(CHANNO .GT. MTCMAX) THEN
          RESULT = MTRNDV
          RETURN
      END IF
      CONTINUE
C
C**********  ALLOCATE A TAPE DRIVE  **********
C
  300 CONTINUE
     0STATUS = SYS$ALLOC(
     1                   'MU:'
     2                  ,
     3                  ,MTPNAM(CHANNO)
     4                  ,
     Z                  )
      IF(STATUS .NE. SS$_NORMAL) THEN
          IF(STATUS .EQ. SS$_NODEVAVL) THEN
              RESULT = MTRNDV
          ELSE IF(STATUS .EQ. SS$_NOSUCHDEV) THEN
              RESULT = MTRNDV
          ELSE IF(STATUS .EQ. SS$_DEVALLOC) THEN
              RESULT = MTRNDV
          ELSE IF(STATUS .EQ. SS$_DEVMOUNT) THEN
              RESULT = MTRNDV
          ELSE
              CALL LIB$STOP(%VAL(STATUS))
          END IF
          RETURN
      END IF
      CONTINUE
C
C**********  ASSIGN AN I/O CHANNEL  **********
C
  400 CONTINUE
     0STATUS = SYS$ASSIGN(
     1                    MTPNAM(CHANNO)
     2                   ,MTCHAN(CHANNO)
     3                   ,
     4                   ,
     Z                   )
      IF(STATUS .NE. SS$_NORMAL) THEN
          IF(STATUS .EQ. SS$_NOIOCHAN) THEN
              RESULT = MTRNCH
          ELSE
              CALL LIB$STOP(%VAL(STATUS))
          END IF
          RETURN
      END IF
     0STATUS = SYS$GETCHN(
     1                    %VAL(MTCHAN(CHANNO))
     2                   ,DUMMY
     3                   ,DIBBUF
     4                   ,
     5                   ,
     Z                   )
      IF(STATUS .EQ. SS$_BUFFEROVF) STATUS = SS$_NORMAL
      IF(STATUS .EQ. SS$_NORMAL) THEN
          IF(DIBBUF(CLSF:CLSF) .NE. CHAR(DC$_TAPE)) THEN
              STATUS = SS$_UNSAFE
          END IF
      END IF
      IF(STATUS .NE. SS$_NORMAL) THEN
          CALL LIB$STOP(%VAL(STATUS))
      END IF
      CONTINUE
C
C**********  INITIALIZE THE MAGTAPE STATUS VECTORS  **********
C
  500 CONTINUE
      MTSTAT(CHANNO) = -1
      MTWTRT(CHANNO) = 0
      MTWTVA(CHANNO) = 0
      MTWTOP(CHANNO) = 0
      MTOPND(CHANNO) = .TRUE.
      MTNOER(CHANNO) = .FALSE.
      MTUSED(CHANNO) = .FALSE.
      MTWTMD(CHANNO) = .FALSE.
      MTASTL(CHANNO) = 0
     0CALL ALLOC_EFN(
     1               
     2              ,
     3              ,MTEFNO(CHANNO)
     4              ,
     5              ,STATUS
     Z              )
      IF(STATUS .NE. 0) THEN
          MTEFNO(CHANNO) = -1
          CALL MTCLOS(CHANNO, RESULT)
          RESULT = MTRNEF
      END IF
      RETURN
C
C=======================================================================
C
C
      END

     0SUBROUTINE MTNAME(
     1                  CHANNO
     2                 ,NAME
     3                 ,LENGTH
     4                 ,RESULT
     Z                 )
C
C
      INTEGER CHANNO
      CHARACTER*(*) NAME
      INTEGER LENGTH
      INTEGER RESULT
C
C
      INCLUDE 'MTOC00.INS /NOLIST'
C
C
      INCLUDE 'MTERCS.INS /NOLIST'
C
C
C**********  EXTERNAL FUNCTIONS  **********
C
      INTEGER MTVCN1
C
C**********  LOCAL VARIABLES  **********
C
      INTEGER DUMMY
      INTEGER NAMLEN
      EQUIVALENCE (NAMLEN, DUMMY)
C
C
C=======================================================================
C
  100 CONTINUE
      DUMMY = MTVCN1(CHANNO, .TRUE.)
      LENGTH = LEN(MTPNAM(CHANNO))
      NAMLEN = MIN0(LENGTH, LEN(NAME))
      NAME = MTPNAM(CHANNO)(1:NAMLEN)
      RESULT = 0
      IF(NAMLEN .LT. LENGTH) RESULT = MTRTRN
      MTWTVA(CHANNO) = LENGTH
      MTWTRT(CHANNO) = RESULT
      RETURN
C
C=======================================================================
C
C
      END

     0SUBROUTINE MTPREP(
     1                  CHANNO
     2                 ,DENSITY
     3                 ,RESULT
     Z                 )
C
C
      INTEGER CHANNO
      INTEGER DENSITY
      INTEGER RESULT
C
C
      INCLUDE 'MTOC00.INS /NOLIST'
C
C
      INCLUDE 'IOSB00.INS /NOLIST'
C
C
      INCLUDE 'MTERCS.INS /NOLIST'
C
C
C**********  SYSTEM PARAMETERS  **********
C
      INCLUDE '($MTDEF)'
C
C
      INCLUDE '($DCDEF)'
C
C
      INCLUDE '($IODEF)'
C
C
      INCLUDE '($SSDEF)'
C
C**********  EXTERNAL FUNCTIONS  **********
C
      INTEGER SYS$QIOW
C
C**********  LOCAL PARAMETERS  **********
C
     0PARAMETER MTCHAR08 = 0
     1    + (2 ** MT$V_FORMAT ) * MT$K_NORMAL11
     2    + (2 ** MT$V_DENSITY) * MT$K_NRZI_800
     0PARAMETER MTCHAR16 = 0
     1    + (2 ** MT$V_FORMAT ) * MT$K_NORMAL11
     2    + (2 ** MT$V_DENSITY) * MT$K_PE_1600
     0PARAMETER MTCHAR62 = 0
     1    + (2 ** MT$V_FORMAT ) * MT$K_NORMAL11
     2    + (2 ** MT$V_DENSITY) * MT$K_GCR_6250
C
C**********  LOCAL VARIABLES  **********
C
      INTEGER OPCODE
      INTEGER DUMMY
      INTEGER IOCB(2)
      INTEGER IOCB_MTCHAR
      EQUIVALENCE (IOCB_MTCHAR, IOCB(2))
      INTEGER*2 IOCTBS(2)
      EQUIVALENCE (IOCTBS(1), IOCB(1))
      INTEGER*2 IOCB_BUFSIZ
      EQUIVALENCE (IOCB_BUFSIZ, IOCTBS(2))
      LOGICAL*1 IOCLTY(2)
      EQUIVALENCE (IOCLTY(1), IOCTBS(1))
      LOGICAL*1 IOCB_CLASS, IOCB_TYPE
      EQUIVALENCE (IOCB_CLASS, IOCLTY(1)), (IOCB_TYPE, IOCLTY(2))
C
C
      DATA IOCB_CLASS  /DC$_TAPE/
      DATA IOCB_TYPE   /DT$_TU77/
      DATA IOCB_BUFSIZ /   32768/
C
C
C=======================================================================
C
  100 CONTINUE
C
C**********  REWIND THE TAPE  **********
C
  200 CONTINUE
      CALL MTREWI(CHANNO, RESULT)
      IF(MTWTMD(CHANNO)) CALL MTWAIT(CHANNO, DUMMY, RESULT)
      IF(RESULT .NE. 0) RETURN
C     MTWTVA(CHANNO) = 0
C     MTWTRT(CHANNO) = RESULT
      CONTINUE
C
C**********  SET THE TAPE CHARACTERISTICS  **********
C
  300 CONTINUE
      IF(DENSITY .EQ. 800) THEN
          IOCB_MTCHAR = MTCHAR08
      ELSE IF(DENSITY .EQ. 1600) THEN
          IOCB_MTCHAR = MTCHAR16
      ELSE IF(DENSITY .EQ. 6250) THEN
          IOCB_MTCHAR = MTCHAR62
      ELSE
          RESULT = MTRBDN
          MTWTRT(CHANNO) = RESULT
          RETURN
      END IF
      OPCODE = IO$_SETMODE
     0RESULT = SYS$QIOW(
     1                  %VAL(MTEFNO(CHANNO))
     2                 ,%VAL(MTCHAN(CHANNO))
     3                 ,%VAL(OPCODE)
     4                 ,IOSB
     5                 ,
     6                 ,
     7                 ,IOCB
     8                 ,
     9                 ,
     A                 ,
     B                 ,
     C                 ,
     Z                 )
      MTSTAT(CHANNO) = IOSB(2)
      IF(RESULT .NE. SS$_NORMAL) THEN
          CALL LIB$STOP(%VAL(RESULT))
      END IF
      CONTINUE
C
C**********  ANALYZE THE COMPLETION STATUS  **********
C
  400 CONTINUE
      RESULT = IOSB_STATUS
      IF(RESULT .EQ. SS$_NORMAL) THEN
          RESULT = 0
      ELSE IF(RESULT .EQ. SS$_CTRLERR) THEN
          RESULT = MTRERR
      ELSE IF(RESULT .EQ. SS$_DRVERR) THEN
          RESULT = MTRERR
      ELSE IF(RESULT .EQ. SS$_PARITY) THEN
          RESULT = MTRERR
      ELSE IF(RESULT .EQ. SS$_UNSAFE) THEN
          RESULT = MTRERR
      ELSE IF(RESULT .EQ. SS$_MEDOFL) THEN
          RESULT = MTROFL
      ELSE
          CALL LIB$STOP(%VAL(RESULT))
      END IF
      MTWTRT(CHANNO) = RESULT
      RETURN
C
C=======================================================================
C
C
      END

     0SUBROUTINE MTCLOS(
     1                  CHANNO
     2                 ,RESULT
     Z                 )
C
C
      INTEGER CHANNO
      INTEGER RESULT
C
C
      INCLUDE 'MTOC00.INS /NOLIST'
C
C
C**********  SYSTEM PARAMETERS  **********
C
      INCLUDE '($SSDEF)'
C
C**********  EXTERNAL FUNCTIONS  **********
C
      INTEGER MTVCN1
      INTEGER SYS$DASSGN
      INTEGER SYS$DALLOC
C
C**********  LOCAL VARIABLES  **********
C
      INTEGER CHAN
      INTEGER STATUS
C
C
C=======================================================================
C
  100 CONTINUE
      CHAN = MTVCN1(CHANNO, .FALSE.)
      RESULT = 0
      MTOPND(CHANNO) = .FALSE.
      CONTINUE
C
C**********  DEASSIGN THE I/O CHANNEL  **********
C
  200 CONTINUE
     0STATUS = SYS$DASSGN(
     1                    %VAL(CHAN)
     Z                   )
      IF(STATUS .NE. SS$_NORMAL) THEN
          CALL LIB$STOP(%VAL(STATUS))
      END IF
      CONTINUE
C
C**********  DEALLOCATE THE TAPE DRIVE  **********
C
  300 CONTINUE
     0STATUS = SYS$DALLOC(
     1                    MTPNAM(CHANNO)
     2                   ,
     Z                   )
      IF(STATUS .NE. SS$_NORMAL) THEN
          CALL LIB$STOP(%VAL(STATUS))
      END IF
      CONTINUE
C
C**********  DEALLOCATE THE I/O EVENT FLAG  **********
C
  400 CONTINUE
      IF(MTEFNO(CHANNO) .GE. 0) THEN
     0    CALL DEALL_EFN(
     1                   
     2                  ,
     3                  ,MTEFNO(CHANNO)
     4                  ,
     5                  ,STATUS
     Z                  )
          IF(STATUS .NE. 0) THEN
              STATUS = SS$_ILLEFC
              CALL LIB$STOP(%VAL(STATUS))
          END IF
      END IF
      RETURN
C
C=======================================================================
C
C
      END

     0SUBROUTINE MTSERM(
     1                  CHANNO
     2                 ,INHERC
     3                 ,RESULT
     Z                 )
C
C
      INTEGER CHANNO
      LOGICAL INHERC
      INTEGER RESULT
C
C
      INCLUDE 'MTOC00.INS /NOLIST'
C
C
      INCLUDE 'MTERCS.INS /NOLIST'
C
C
C**********  EXTERNAL FUNCTIONS  **********
C
      INTEGER MTVCN1
C
C**********  LOCAL VARIABLES  **********
C
      INTEGER DUMMY
C
C
C=======================================================================
C
  100 CONTINUE
      DUMMY = MTVCN1(CHANNO, .TRUE.)
      IF(INHERC .EQV. MTNOER(CHANNO)) THEN
          RESULT = MTRERU
      ELSE
          RESULT = 0
      END IF
      MTNOER(CHANNO) = INHERC
      MTWTVA(CHANNO) = 0
      MTWTRT(CHANNO) = RESULT
      RETURN
C
C=======================================================================
C
C
      END

     0FUNCTION MTVCN0(
     1                CHANNO
     Z               )
C
C
      INTEGER MTVCN0
      INTEGER CHANNO
C
C
      INCLUDE 'MTOC00.INS /NOLIST'
C
C
C**********  SYSTEM PARAMETERS  **********
C
      INCLUDE '($SSDEF)'
C
C**********  LOCAL VARIABLES  **********
C
      INTEGER RESULT
C
C
C=======================================================================
C
  100 CONTINUE
     0IF((CHANNO .LE. 0) .OR.
     1   (CHANNO .GT. MTCMAX) .OR.
     2   (.NOT. MTOPND(CHANNO)) .OR.
     3   ((MTWTMD(CHANNO)) .AND. (MTWTOP(CHANNO) .NE. 0))) THEN
          CALL LIB$STOP(%VAL(SS$_IVCHAN))
      END IF
      MTVCN0 = MTCHAN(CHANNO)
      IF(.NOT. MTUSED(CHANNO)) THEN
          CALL MTACK0(CHANNO, RESULT)
          MTUSED(CHANNO) = RESULT .EQ. 0
      END IF
      RETURN
C
C=======================================================================
C
C
      END

     0FUNCTION MTVCN1(
     1                CHANNO
     2               ,CHECKW
     Z               )
C
C
      INTEGER MTVCN1
      INTEGER CHANNO
      LOGICAL CHECKW
C
C
      INCLUDE 'MTOC00.INS /NOLIST'
C
C
C**********  SYSTEM PARAMETERS  **********
C
      INCLUDE '($SSDEF)'
C
C
C=======================================================================
C
  100 CONTINUE
     0IF((CHANNO .LE. 0) .OR.
     1   (CHANNO .GT. MTCMAX) .OR.
     2   (.NOT. MTOPND(CHANNO)) .OR.
     3   (CHECKW .AND. MTWTMD(CHANNO) .AND. (MTWTOP(CHANNO) .NE. 0)))
     4                                                              THEN
          CALL LIB$STOP(%VAL(SS$_IVCHAN))
      END IF
      MTVCN1 = MTCHAN(CHANNO)
      RETURN
C
C=======================================================================
C
C
      END

     0SUBROUTINE MTSETW(
     1                  CHANNO
     2                 ,WAIT
     3                 ,RESULT
     Z                 )
C
C
      INTEGER CHANNO
      LOGICAL WAIT
      INTEGER RESULT
C
C
      INCLUDE 'MTOC00.INS /NOLIST'
C
C
      INCLUDE 'MTERCS.INS /NOLIST'
C
C
C**********  EXTERNAL FUNCTIONS  **********
C
      INTEGER MTVCN1
C
C**********  LOCAL VARIABLES  **********
C
      INTEGER DUMMY
C
C
C=======================================================================
C
  100 CONTINUE
      DUMMY = MTVCN1(CHANNO, .TRUE.)
      IF(WAIT .EQV. MTWTMD(CHANNO)) THEN
          RESULT = MTRWMU
      ELSE
          RESULT = 0
      END IF
      MTWTMD(CHANNO) = WAIT
      MTWTVA(CHANNO) = 0
      MTWTRT(CHANNO) = RESULT
      RETURN
C
C=======================================================================
C
C
      END

     0SUBROUTINE MTWAIT(
     1                  CHANNO
     2                 ,COUNT
     3                 ,RESULT
     Z                 )
C
C
      INTEGER CHANNO
      INTEGER COUNT
      INTEGER RESULT
C
C
     0ENTRY      MTCHCK(
     1                  CHANNO
     2                 ,COUNT
     3                 ,RESULT
     Z                 )
C
C
      INCLUDE 'MTOC00.INS /NOLIST'
C
C
C**********  SYSTEM PARAMETERS  **********
C
      INCLUDE '($MTDEF)'
C
C
      INCLUDE '($IODEF)'
C
C**********  EXTERNAL FUNCTIONS  **********
C
      INTEGER MTVCN1
C
C**********  LOCAL PARAMETERS  **********
C
      INCLUDE 'MTERCS.INS /NOLIST'
C
C**********  LOCAL VARIABLES  **********
C
      INTEGER DUMMY
      INTEGER FILES
      LOGICAL*1 DUMREC(MTMINR)
C
C
C=======================================================================
C
  100 CONTINUE
      DUMMY = MTVCN1(CHANNO, .FALSE.)
      IF(MTWTMD(CHANNO) .AND. (MTWTOP(CHANNO) .NE. 0)) THEN
          GO TO (1, 2, 3, 4, 5, 6), MTWTOP(CHANNO)
C
C..........MTWTOP=1:  READ FORWARD, READ BACKWARD
    1     CONTINUE
          CALL MTWAI1(CHANNO)
          GO TO 200
C
C..........MTWTOP=2:  WRITE
    2     CONTINUE
          CALL MTWAI2(CHANNO)
          GO TO 200
C
C..........MTWTOP=3:  WRITE END-OF-FILE
    3     CONTINUE
          CALL MTWAI3(CHANNO)
          GO TO 200
C
C..........MTWTOP=4:  REWIND, REWIND-UNLOAD
    4     CONTINUE
          CALL MTWAI4(CHANNO)
          GO TO 200
C
C..........MTWTOP=5:  SKIP FILE
    5     CONTINUE
          CALL MTWAI5(CHANNO)
          IF(MTWTRT(CHANNO) .NE. MTREOV) GO TO 200
          FILES = MTWTVA(CHANNO)
          MTWTMD(CHANNO) = .FALSE.
  120         CONTINUE
              CALL MTREAD(CHANNO, MTMINR, DUMREC, COUNT, RESULT)
              IF(RESULT .NE. MTREOF) GO TO 140
              FILES = FILES + 1
              IF((MTSTAT(CHANNO) .AND. MT$M_EOT) .EQ. 0) THEN
                  RESULT = 0
              ELSE
                  RESULT = MTREOT
              END IF
              MTWTRT(CHANNO) = RESULT
              IF(FILES .EQ. MTSKFC(CHANNO)) GO TO 140
     0        CALL MTSKP0(
     1                    IO$_SKIPFILE
     2                   ,CHANNO
     3                   ,MTSKFC(CHANNO) - FILES
     4                   ,COUNT
     5                   ,RESULT
     Z                   )
              FILES = FILES + COUNT
              IF(RESULT .EQ. MTREOV) GO TO 120
  140     CONTINUE
          MTWTMD(CHANNO) = .TRUE.
          MTWTVA(CHANNO) = FILES
          GO TO 200
C
C..........MTWTOP=6:  SKIP RECORD
    6     CONTINUE
          CALL MTWAI5(CHANNO)
          IF(MTWTRT(CHANNO) .EQ. MTREOV) THEN
              MTWTMD(CHANNO) = .FALSE.
              CALL MTREAD(CHANNO, MTMINR, DUMREC, COUNT, RESULT)
              MTWTMD(CHANNO) = .TRUE.
              IF(RESULT .EQ. MTREOF) COUNT = 1
              MTWTVA(CHANNO) = COUNT
          END IF
          GO TO 200
C
C...................
  200     CONTINUE
          MTWTOP(CHANNO) = 0
      END IF
      COUNT = MTWTVA(CHANNO)
      RESULT = MTWTRT(CHANNO)
      RETURN
C
C=======================================================================
C
C
      END

     0SUBROUTINE MTNOOP(
     1                  CHANNO
     2                 ,VALUE
     3                 ,RESULT
     Z                 )
C
C
      INTEGER CHANNO
      INTEGER VALUE
      INTEGER RESULT
C
C
      INCLUDE 'MTOC00.INS /NOLIST'
C
C
C**********  EXTERNAL FUNCTIONS  **********
C
      INTEGER MTVCN0
C
C**********  LOCAL VARIABLES  **********
C
      INTEGER DUMMY
C
C
C=======================================================================
C
  100 CONTINUE
      DUMMY = MTVCN0(CHANNO)
      MTWTVA(CHANNO) = VALUE
      MTWTRT(CHANNO) = 0
      RESULT = 0
      RETURN
C
C=======================================================================
C
C
      END

     0SUBROUTINE MTSAST(
     1                  CHANNO
     2                 ,ASTLOC
     3                 ,OLDAST
     4                 ,RESULT
     Z                 )
C
C
      INTEGER CHANNO
      INTEGER ASTLOC
      INTEGER OLDAST
      INTEGER RESULT
C
C
      INCLUDE 'MTOC00.INS /NOLIST'
C
C
C**********  EXTERNAL FUNCTIONS  **********
C
      INTEGER MTVCN1
C
C**********  LOCAL VARIABLES  **********
C
      INTEGER DUMMY
C
C
C=======================================================================
C
  100 CONTINUE
      DUMMY = MTVCN1(CHANNO, .FALSE.)
      RESULT = 0
      OLDAST = MTASTL(CHANNO)
      MTASTL(CHANNO) = %LOC(ASTLOC)
      MTWTVA(CHANNO) = 0
      MTWTRT(CHANNO) = RESULT
      RETURN
C
C=======================================================================
C
C
      END

     0SUBROUTINE MTREAD(
     1                  CHANNO
     2                 ,LENGTH
     3                 ,BUFFER
     4                 ,ACTLEN
     5                 ,RESULT
     Z                 )
C
C
      INTEGER CHANNO
      INTEGER LENGTH
      LOGICAL*1 BUFFER(LENGTH)
      INTEGER ACTLEN
      INTEGER RESULT
C
C
      INCLUDE 'MTOC00.INS /NOLIST'
C
C
C**********  SYSTEM PARAMETERS  **********
C
      INCLUDE '($IODEF)'
C
C
C=======================================================================
C
  100 CONTINUE
     0CALL MTRD00(
     1            IO$_READLBLK
     2           ,CHANNO
     3           ,LENGTH
     4           ,BUFFER
     5           ,ACTLEN
     6           ,RESULT
     Z           )
      RETURN
C
C=======================================================================
C
C
      END

     0SUBROUTINE MTRDBK(
     1                  CHANNO
     2                 ,LENGTH
     3                 ,BUFFER
     4                 ,ACTLEN
     5                 ,RESULT
     Z                 )
C
C
      INTEGER CHANNO
      INTEGER LENGTH
      LOGICAL*1 BUFFER(LENGTH)
      INTEGER ACTLEN
      INTEGER RESULT
C
C
      INCLUDE 'MTOC00.INS /NOLIST'
C
C
C**********  SYSTEM PARAMETERS  **********
C
      INCLUDE '($IODEF)'
C
C
C=======================================================================
C
  100 CONTINUE
     0CALL MTRD00(
     1            IO$_READLBLK .OR. IO$M_REVERSE
     2           ,CHANNO
     3           ,LENGTH
     4           ,BUFFER
     5           ,ACTLEN
     6           ,RESULT
     Z           )
      RETURN
C
C=======================================================================
C
C
      END

     0SUBROUTINE MTRD00(
     1                  FUNC
     2                 ,CHANNO
     3                 ,LENGTH
     4                 ,BUFFER
     5                 ,ACTLEN
     6                 ,RESULT
     Z                 )
C
C
      INTEGER FUNC
      INTEGER CHANNO
      INTEGER LENGTH
      LOGICAL*1 BUFFER(LENGTH)
      INTEGER ACTLEN
      INTEGER RESULT
C
C
      INCLUDE 'MTOC00.INS /NOLIST'
C
C
      INCLUDE 'MTASTP.INS /NOLIST'
C
C
      INCLUDE 'MTERCS.INS /NOLIST'
C
C
      INCLUDE 'IOSB00.INS /NOLIST'
C
C
C**********  SYSTEM PARAMETERS  **********
C
      INCLUDE '($IODEF)'
C
C
      INCLUDE '($SSDEF)'
C
C
      INCLUDE '($MTDEF)'
C
C**********  EXTERNAL FUNCTIONS  **********
C
      INTEGER MTVCN0
      INTEGER SYS$QIO
      INTEGER SYS$WAITFR
C
C**********  LOCAL VARIABLES  **********
C
      INTEGER DUMMY, OPCODE
      EQUIVALENCE (DUMMY, OPCODE)
      INTEGER ASTLOC, ASTPAR
      LOGICAL RETRY
      INTEGER LEN, STATUS
C
C
C=======================================================================
C
  100 CONTINUE
      DUMMY = MTVCN0(CHANNO)
      CONTINUE
C
C**********  START THE I/O OPERATION  **********
C
  200 CONTINUE
      OPCODE = FUNC
      IF(MTWTMD(CHANNO)) THEN
          ASTLOC = MTASTL(CHANNO)
      ELSE
          ASTLOC = 0
      END IF
      IF(ASTLOC .NE. 0) THEN
          IF(OPCODE .EQ. IO$_READLBLK) THEN
              ASTPAR = MTAPRD
          ELSE
              ASTPAR = MTAPRB
          END IF
      ELSE
          ASTPAR = 0
      END IF
      IF(MTNOER(CHANNO)) OPCODE = OPCODE .OR. IO$M_INHRETRY
      MTSTAT(CHANNO) = OPCODE
      MTWTVA(CHANNO) = LENGTH
      MTWTRT(CHANNO) = %LOC(BUFFER(1))
      RETRY = .FALSE.
  220 CONTINUE
     0RESULT = SYS$QIO(
     1                 %VAL(MTEFNO(CHANNO))
     2                ,%VAL(MTCHAN(CHANNO))
     3                ,%VAL(MTSTAT(CHANNO))
     4                ,MTIOSB(CHANNO)
     5                ,%VAL(ASTLOC)
     6                ,ASTPAR
     7                ,%VAL(MTWTRT(CHANNO))
     8                ,%VAL(MTWTVA(CHANNO))
     9                ,
     A                ,
     B                ,
     C                ,
     Z                )
      IF(RESULT .NE. SS$_NORMAL) THEN
          CALL LIB$STOP(%VAL(RESULT))
      END IF
      IF(MTWTMD(CHANNO) .AND. (.NOT. RETRY)) THEN
          MTWTOP(CHANNO) = 1
          ACTLEN = 0
          RESULT = 0
          RETURN
      END IF
      GO TO 300
C
C**********  ANALYZE THE COMPLETION STATUS  **********
C
      ENTRY MTWAI1(CHANNO)
      RETRY = .FALSE.
  300 CONTINUE
      STATUS = SYS$WAITFR(%VAL(MTEFNO(CHANNO)))
      IF(STATUS .NE. SS$_NORMAL) THEN
          CALL LIB$STOP(%VAL(STATUS))
      END IF
      IOSD = MTIOSB(CHANNO)
      LEN = IOSB_COUNT
      IF(LEN .LT. 0) LEN = LEN + 65536
      STATUS = IOSB_STATUS
     0IF((STATUS .EQ. SS$_NORMAL) .OR.
     1   (STATUS .EQ. SS$_DATAOVERUN) .OR.
     2   ((MTNOER(CHANNO)) .AND.
     3    (STATUS .EQ. SS$_CTRLERR) .AND.
     4    (LEN .NE. MTWTVA(CHANNO)))) THEN
          IF((IOSB(2) .AND. MT$M_BOT) .EQ. 0) THEN
              STATUS = 0
          ELSE
              STATUS  = MTREOT
          END IF
          IF(MTNOER(CHANNO)) THEN
              IF((IOSB(2) .AND. MT$M_EOF) .NE. 0) STATUS = MTREOF
     0        IF((IOSB(2) .AND. (MT$M_EOT .OR. MT$M_BOT)) .NE. 0)
     1                                                   STATUS = MTREOT
          END IF
      ELSE IF(STATUS .EQ. SS$_CTRLERR) THEN
          STATUS = MTRERR
      ELSE IF(STATUS .EQ. SS$_DRVERR) THEN
          STATUS = MTRERR
      ELSE IF(STATUS .EQ. SS$_PARITY) THEN
          STATUS = MTRERR
      ELSE IF(STATUS .EQ. SS$_UNSAFE) THEN
          STATUS = MTRERR
      ELSE IF(STATUS .EQ. SS$_MEDOFL) THEN
          STATUS = MTROFL
      ELSE IF(STATUS .EQ. SS$_ENDOFFILE) THEN
          IF((IOSB(2) .AND. NT$M_BOT) .EQ. 0) THEN
              STATUS = MTREOF
          ELSE
              STATUS = MTREOT
          END IF
      ELSE IF(STATUS .EQ. SS$_ENDOFTAPE) THEN
          STATUS = MTREOT
      ELSE IF(STATUS .EQ. SS$_OPINCOMPL) THEN
          STATUS = MTRNOR
      ELSE IF(STATUS .EQ. SS$_TIMEOUT) THEN
          STATUS = MTRNOR
      ELSE
          CALL LIB$STOP(%VAL(STATUS))
      END IF
      IF(MTNOER(CHANNO) .AND. (STATUS .EQ. MTRERR)) THEN
          RETRY = (LEN .GT. 0) .AND. (LEN .LT. MTMINR)
          IF(RETRY) GO TO 220
      END IF
      MTSTAT(CHANNO) = IOSB(2)
      MTWTVA(CHANNO) = LEN
      MTWTRT(CHANNO) = STATUS
      IF(MTWTMD(CHANNO)) RETURN
      ACTLEN = LEN
      RESULT = STATUS
      RETURN
C
C=======================================================================
C
C
      END

     0SUBROUTINE MTWRIT(
     1                  CHANNO
     2                 ,LENGTH
     3                 ,BUFFER
     4                 ,ACTLEN
     5                 ,RESULT
     Z                 )
C
C
      INTEGER CHANNO
      INTEGER LENGTH
      LOGICAL*1 BUFFER(LENGTH)
      INTEGER ACTLEN
      INTEGER RESULT
C
C
      INCLUDE 'MTOC00.INS /NOLIST'
C
C
      INCLUDE 'MTASTP.INS /NOLIST'
C
C
      INCLUDE 'MTERCS.INS /NOLIST'
C
C
      INCLUDE 'IOSB00.INS /NOLIST'
C
C
C**********  SYSTEM PARAMETERS  **********
C
      INCLUDE '($IODEF)'
C
C
      INCLUDE '($SSDEF)'
C
C**********  EXTERNAL FUNCTIONS  **********
C
      INTEGER MTVCN0
      INTEGER SYS$QIO
      INTEGER SYS$WAITFR
C
C**********  LOCAL VARIABLES  **********
C
      INTEGER CHAN, OPCODE
      INTEGER ASTLOC, ASTPAR
      INTEGER LEN, STATUS
C
C
C=======================================================================
C
  100 CONTINUE
      CHAN = MTVCN0(CHANNO)
      CONTINUE
C
C**********  START THE I/O OPERATION  **********
C
  200 CONTINUE
      OPCODE = IO$_WRITELBLK
      IF(MTWTMD(CHANNO)) THEN
          ASTLOC = MTASTL(CHANNO)
      ELSE
          ASTLOC = 0
      END IF
      IF(ASTLOC .NE. 0) THEN
          ASTPAR = MTAPWR
      ELSE
          ASTPAR = 0
      END IF
     0RESULT = SYS$QIO(
     1                 %VAL(MTEFNO(CHANNO))
     2                ,%VAL(CHAN)
     3                ,%VAL(OPCODE)
     4                ,MTIOSB(CHANNO)
     5                ,%VAL(ASTLOC)
     6                ,ASTPAR
     7                ,BUFFER
     8                ,%VAL(LENGTH)
     9                ,
     A                ,
     B                ,
     C                ,
     Z                )
      IF(RESULT .NE. SS$_NORMAL) THEN
          CALL LIB$STOP(%VAL(RESULT))
      END IF
      IF(MTWTMD(CHANNO)) THEN
          MTWTOP(CHANNO) = 2
          ACTLEN = 0
          RESULT = 0
          RETURN
      END IF
      CONTINUE
C
C**********  ANALYZE THE COMPLETION STATUS  **********
C
      ENTRY MTWAI2(CHANNO)
  300 CONTINUE
      STATUS = SYS$WAITFR(%VAL(MTEFNO(CHANNO)))
      IF(STATUS .NE. SS$_NORMAL) THEN
          CALL LIB$STOP(%VAL(STATUS))
      END IF
      IOSD = MTIOSB(CHANNO)
      LEN = IOSB_COUNT
      IF(LEN .LT. 0) LEN = LEN + 65536
      STATUS = IOSB_STATUS
      IF(STATUS .EQ. SS$_NORMAL) THEN
          STATUS = 0
      ELSE IF(STATUS .EQ. SS$_CTRLERR) THEN
          STATUS = MTRERR
      ELSE IF(STATUS .EQ. SS$_DRVERR) THEN
          STATUS = MTRERR
      ELSE IF(STATUS .EQ. SS$_PARITY) THEN
          STATUS = MTRERR
      ELSE IF(STATUS .EQ. SS$_UNSAFE) THEN
          STATUS = MTRERR
      ELSE IF(STATUS .EQ. SS$_MEDOFL) THEN
          STATUS = MTROFL
      ELSE IF(STATUS .EQ. SS$_WRITLCK) THEN
          STATUS = MTRWLK
      ELSE IF(STATUS .EQ. SS$_ENDOFTAPE) THEN
          STATUS = MTREOT
      ELSE
          CALL LIB$STOP(%VAL(STATUS))
      END IF
      MTSTAT(CHANNO) = IOSB(2)
      MTWTVA(CHANNO) = LEN
      MTWTRT(CHANNO) = STATUS
      IF(MTWTMD(CHANNO)) RETURN
      ACTLEN = LEN
      RESULT = STATUS
      RETURN
C
C=======================================================================
C
C
      END

     0SUBROUTINE MTWEOF(
     1                  CHANNO
     2                 ,RESULT
     Z                 )
C
C
      INTEGER CHANNO
      INTEGER RESULT
C
C
      INCLUDE 'MTOC00.INS /NOLIST'
C
C
      INCLUDE 'MTERCS.INS /NOLIST'
C
C
C**********  SYSTEM PARAMETERS  **********
C
      INCLUDE '($IODEF)'
C
C
      INCLUDE '($SSDEF)'
C
C**********  LOCAL VARIABLES  **********
C
      INTEGER DUMMY
      INTEGER STATUS
C
C
C=======================================================================
C
  100 CONTINUE
C
C**********  START THE I/O OPERATION  **********
C
  200 CONTINUE
     0CALL MTCON0(
     1            IO$_WRITEOF
     2           ,0
     3           ,CHANNO
     4           ,DUMMY
     5           ,STATUS
     Z           )
      IF(MTWTMD(CHANNO)) THEN
          MTWTOP(CHANNO) = 3
          RESULT = 0
          RETURN
      END IF
      GO TO 300
C
C**********  ANALYZE THE COMPLETION STATUS  **********
C
      ENTRY MTWAI3(CHANNO)
      CALL MTCWT0(CHANNO, DUMMY, STATUS)
  300 CONTINUE
      IF(STATUS .EQ. SS$_NORMAL) THEN
          STATUS = 0
      ELSE IF(STATUS .EQ. SS$_CTRLERR) THEN
          STATUS = MTRERR
      ELSE IF(STATUS .EQ. SS$_DRVERR) THEN
          STATUS = MTRERR
      ELSE IF(STATUS .EQ. SS$_PARITY) THEN
          STATUS = MTRERR
      ELSE IF(STATUS .EQ. SS$_UNSAFE) THEN
          STATUS = MTRERR
      ELSE IF(STATUS .EQ. SS$_MEDOFL) THEN
          STATUS = MTROFL
      ELSE IF(STATUS .EQ. SS$_WRITLCK) THEN
          STATUS = MTRWLK
      ELSE IF(STATUS .EQ. SS$_ENDOFTAPE) THEN
          STATUS = MTREOT
      ELSE
          CALL LIB$STOP(%VAL(STATUS))
      END IF
      MTWTVA(CHANNO) = 1
      MTWTRT(CHANNO) = STATUS
      IF(.NOT. MTWTMD(CHANNO)) RESULT = STATUS
      RETURN
C
C=======================================================================
C
C
      END

     0SUBROUTINE MTREWI(
     1                  CHANNO
     2                 ,RESULT
     Z                 )
C
C
      INTEGER CHANNO
      INTEGER RESULT
C
C
C**********  SYSTEM PARAMETERS  **********
C
      INCLUDE '($IODEF)'
C
C
C=======================================================================
C
  100 CONTINUE
     0CALL MTREW0(
     1            IO$_REWIND
     2           ,CHANNO
     3           ,RESULT
     Z           )
      RETURN
C
C=======================================================================
C
C
      END

     0SUBROUTINE MTUNLD(
     1                  CHANNO
     2                 ,RESULT
     Z                 )
C
C
      INTEGER CHANNO
      INTEGER RESULT
C
C
C**********  SYSTEM PARAMETERS  **********
C
      INCLUDE '($IODEF)'
C
C
C=======================================================================
C
  100 CONTINUE
     0CALL MTREW0(
     1            IO$_REWINDOFF
     2           ,CHANNO
     3           ,RESULT
     Z           )
      RETURN
C
C=======================================================================
C
C
      END

     0SUBROUTINE MTREW0(
     1                  FUNC
     2                 ,CHANNO
     3                 ,RESULT
     Z                 )
C
C
      INTEGER FUNC
      INTEGER CHANNO
      INTEGER RESULT
C
C
      INCLUDE 'MTOC00.INS /NOLIST'
C
C
      INCLUDE 'MTERCS.INS /NOLIST'
C
C
C**********  SYSTEM PARAMETERS  **********
C
      INCLUDE '($SSDEF)'
C
C**********  LOCAL VARIABLES  **********
C
      INTEGER DUMMY
      INTEGER STATUS
C
C
C=======================================================================
C
  100 CONTINUE
C
C**********  START THE CONTROL OPERATION  **********
C
  200 CONTINUE
     0CALL MTCON0(
     1            FUNC
     2           ,0
     3           ,CHANNO
     4           ,DUMMY
     5           ,STATUS
     Z           )
      IF(MTWTMD(CHANNO)) THEN
          MTWTOP(CHANNO) = 4
          RESULT = 0
          RETURN
      END IF
      GO TO 300
C
C**********  ANALYZE THE COMPLETION STATUS  **********
C
      ENTRY MTWAI4(CHANNO)
      CALL MTCWT0(CHANNO, DUMMY, STATUS)
  300 CONTINUE
      IF(STATUS .EQ. SS$_NORMAL) THEN
          STATUS = 0
      ELSE IF(STATUS .EQ. SS$_CTRLERR) THEN
          STATUS = MTRERR
      ELSE IF(STATUS .EQ. SS$_DRVERR) THEN
          STATUS = MTRERR
      ELSE IF(STATUS .EQ. SS$_PARITY) THEN
          STATUS = MTRERR
      ELSE IF(STATUS .EQ. SS$_UNSAFE) THEN
          STATUS = MTRERR
      ELSE IF(STATUS .EQ. SS$_MEDOFL) THEN
          STATUS = MTROFL
      ELSE
          CALL LIB$STOP(%VAL(STATUS))
      END IF
      MTWTVA(CHANNO) = 0
      MTWTRT(CHANNO) = STATUS
      IF(.NOT. MTWTMD(CHANNO)) RESULT = STATUS
      RETURN
C
C=======================================================================
C
C
      END

     0SUBROUTINE MTSKFI(
     1                  CHANNO
     2                 ,COUNT
     3                 ,ACTCNT
     4                 ,RESULT
     Z                 )
C
C
      INTEGER CHANNO
      INTEGER COUNT
      INTEGER ACTCNT
      INTEGER RESULT
C
C
      INCLUDE 'MTOC00.INS /NOLIST'
C
C
C**********  SYSTEM PARAMETERS  **********
C
      INCLUDE '($IODEF)'
C
C
      INCLUDE '($MTDEF)'
C
C**********  LOCAL PARAMETERS  **********
C
      INCLUDE 'MTERCS.INS /NOLIST'
C
C**********  LOCAL VARIABLES  **********
C
      INTEGER FILES
      LOGICAL*1 DUMREC(MTMINR)
C
C
C=======================================================================
C
  100 CONTINUE
      IF(MTWTMD(CHANNO)) MTSKFC(CHANNO) = COUNT
     0CALL MTSKP0(
     1            IO$_SKIPFILE
     2           ,CHANNO
     3           ,COUNT
     4           ,ACTCNT
     5           ,RESULT
     Z           )
      IF(RESULT .NE. MTREOV) RETURN
      FILES = ACTCNT
  120     CONTINUE
          CALL MTREAD(CHANNO, MTMINR, DUMREC, ACTCNT, RESULT)
          IF(RESULT .NE. MTREOF) GO TO 140
          FILES = FILES + 1
          IF((MTSTAT(CHANNO) .AND. MT$M_EOT) .EQ. 0) THEN
              RESULT = 0
          ELSE
              RESULT = MTREOT
          END IF
          MTWTRT(CHANNO) = RESULT
          IF(FILES .EQ. COUNT) GO TO 140
     0    CALL MTSKP0(
     1                IO$_SKIPFILE
     2               ,CHANNO
     3               ,COUNT - FILES
     4               ,ACTCNT
     5               ,RESULT
     Z               )
          FILES = FILES + ACTCNT
          IF(RESULT .EQ. MTREOV) GO TO 120
  140 CONTINUE
      MTWTVA(CHANNO) = FILES
      ACTCNT = FILES
      RETURN
C
C=======================================================================
C
C
      END

     0SUBROUTINE MTSKRE(
     1                  CHANNO
     2                 ,COUNT
     3                 ,ACTCNT
     4                 ,RESULT
     Z                 )
C
C
      INTEGER CHANNO
      INTEGER COUNT
      INTEGER ACTCNT
      INTEGER RESULT
C
C
      INCLUDE 'MTOC00.INS /NOLIST'
C
C
C**********  SYSTEM PARAMETERS  **********
C
      INCLUDE '($IODEF)'
C
C**********  LOCAL PARAMETERS  **********
C
      INCLUDE 'MTERCS.INS /NOLIST'
C
C**********  LOCAL VARIABLES  **********
C
      LOGICAL*1 DUMREC(MTMINR)
C
C
C=======================================================================
C
  100 CONTINUE
     0CALL MTSKP0(
     1            IO$_SKIPRECORD
     2           ,CHANNO
     3           ,COUNT
     4           ,ACTCNT
     5           ,RESULT
     Z           )
      IF(RESULT .EQ. MTREOV) THEN
          CALL MTREAD(CHANNO, MTMINR, DUMREC, ACTCNT, RESULT)
          IF(RESULT .EQ. MTREOF) ACTCNT = 1
          MTWTVA(CHANNO) = ACTCNT
      END IF
      RETURN
C
C=======================================================================
C
C
      END

     0SUBROUTINE MTSKP0(
     1                  FUNC
     2                 ,CHANNO
     3                 ,COUNT
     4                 ,ACTCNT
     5                 ,RESULT
     Z                 )
C
C
      INTEGER FUNC
      INTEGER CHANNO
      INTEGER COUNT
      INTEGER ACTCNT
      INTEGER RESULT
C
C
      INCLUDE 'MTOC00.INS /NOLIST'
C
C
      INCLUDE 'MTERCS.INS /NOLIST'
C
C
      INCLUDE 'IOSB00.INS /NOLIST'
C
C
C**********  SYSTEM PARAMETERS  **********
C
      INCLUDE '($IODEF)'
C
C
      INCLUDE '($SSDEF)'
C
C
      INCLUDE '($MTDEF)'
C
C**********  LOCAL VARIABLES  **********
C
      INTEGER LEN, STATUS
C
C
C=======================================================================
C
  100 CONTINUE
C
C**********  START THE CONTROL OPERATION  **********
C
  200 CONTINUE
     0CALL MTCON0(
     1            FUNC
     2           ,COUNT
     3           ,CHANNO
     4           ,LEN
     5           ,STATUS
     Z           )
      IF(MTWTMD(CHANNO)) THEN
          IF(FUNC .EQ. IO$_SKIPFILE) THEN
              MTWTOP(CHANNO) = 5
          ELSE
              MTWTOP(CHANNO) = 6
          END IF
          ACTCNT = 0
          RESULT = 0
          RETURN
      END IF
      GO TO 300
C
C**********  ANALYZE THE COMPLETION STATUS  **********
C
      ENTRY MTWAI5(CHANNO)
      CALL MTCWT0(CHANNO, LEN, STATUS)
  300 CONTINUE
      IF(STATUS .EQ. SS$_NORMAL) THEN
          IF((IOSB(2) .AND. MT$M_BOT) .EQ. 0) THEN
              STATUS = 0
          ELSE
              STATUS = MTREOT
          END IF
      ELSE IF(STATUS .EQ. SS$_CTRLERR) THEN
          STATUS = MTRERR
      ELSE IF(STATUS .EQ. SS$_DRVERR) THEN
          STATUS = MTRERR
      ELSE IF(STATUS .EQ. SS$_PARITY) THEN
          STATUS = MTRERR
      ELSE IF(STATUS .EQ. SS$_UNSAFE) THEN
          STATUS = MTRERR
      ELSE IF(STATUS .EQ. SS$_MEDOFL) THEN
          STATUS = MTROFL
      ELSE IF(STATUS .EQ. SS$_ENDOFFILE) THEN
          IF((IOSB(2) .AND. MT$M_BOT) .EQ. 0) THEN
              STATUS = MTREOF
          ELSE
              STATUS = MTREOT
          END IF
      ELSE IF(STATUS .EQ. SS$_ENDOFTAPE) THEN
          STATUS = MTREOT
      ELSE IF(STATUS .EQ. SS$_OPINCOMPL) THEN
          STATUS = MTRNOR
      ELSE IF(STATUS .EQ. SS$_TIMEOUT) THEN
          STATUS = MTRNOR
      ELSE IF(STATUS .EQ. SS$_ENDOFVOLUME) THEN
          STATUS = MTREOV
      ELSE
          CALL LIB$STOP(%VAL(STATUS))
      END IF
      MTWTVA(CHANNO) = LEN
      MTWTRT(CHANNO) = STATUS
      IF(MTWTMD(CHANNO)) RETURN
      ACTCNT = LEN
      RESULT = STATUS
      RETURN
C
C=======================================================================
C
C
      END

     0SUBROUTINE MTCON0(
     1                  FUNC
     2                 ,COUNT
     3                 ,CHANNO
     4                 ,ACTCNT
     5                 ,STATUS
     Z                 )
C
C
      INTEGER FUNC
      INTEGER COUNT
      INTEGER CHANNO
      INTEGER ACTCNT
      INTEGER STATUS
C
C
      INCLUDE 'MTOC00.INS /NOLIST'
C
C
      INCLUDE 'MTASTP.INS /NOLIST'
C
C
      INCLUDE 'MTERCS.INS /NOLIST'
C
C
      INCLUDE 'IOSB00.INS /NOLIST'
C
C
C**********  SYSTEM PARAMETERS  **********
C
      INCLUDE '($IODEF)'
C
C
      INCLUDE '($SSDEF)'
C
C**********  EXTERNAL FUNCTIONS  **********
C
      INTEGER MTVCN0
      INTEGER SYS$QIO
      INTEGER SYS$WAITFR
      INTEGER SYS$QIOW
C
C**********  LOCAL VARIABLES  **********
C
      INTEGER DUMMY
      INTEGER ASTLOC, ASTPAR
C
C
C=======================================================================
C
  100 CONTINUE
      DUMMY = MTVCN0(CHANNO)
      CONTINUE
C
C**********  PERFORM THE CONTROL OPERATION  **********
C
  200 CONTINUE
      MTSTAT(CHANNO) = FUNC
      MTWTVA(CHANNO) = COUNT
      IF(MTWTMD(CHANNO)) THEN
          ASTLOC = MTASTL(CHANNO)
      ELSE
          ASTLOC = 0
      END IF
      IF(ASTLOC .NE. 0) THEN
          IF(FUNC .EQ. IO$_WRITEOF) THEN
              ASTPAR = MTAPWE
          ELSE IF(FUNC .EQ. IO$_SKIPRECORD) THEN
              ASTPAR = MTAPSR
          ELSE IF(FUNC .EQ. IO$_SKIPFILE) THEN
              ASTPAR = MTAPSF
          ELSE IF(FUNC .EQ. IO$_REWIND) THEN
              ASTPAR = MTAPRW
          ELSE
              ASTPAR = MTAPUL
          END IF
      ELSE
          ASTPAR = 0
      END IF
     0STATUS = SYS$QIO(
     1                 %VAL(MTEFNO(CHANNO))
     2                ,%VAL(MTCHAN(CHANNO))
     3                ,%VAL(MTSTAT(CHANNO))
     4                ,MTIOSB(CHANNO)
     5                ,%VAL(ASTLOC)
     6                ,ASTPAR
     7                ,%VAL(MTWTVA(CHANNO))
     8                ,
     9                ,
     A                ,
     B                ,
     C                ,
     Z                )
      IF(STATUS .NE. SS$_NORMAL) THEN
          CALL LIB$STOP(%VAL(STATUS))
      END IF
      IF(MTWTMD(CHANNO)) RETURN
      CONTINUE
C
C**********  ANALYZE THE COMPLETION STATUS  **********
C
      ENTRY MTCWT0(CHANNO, ACTCNT, STATUS)
  300 CONTINUE
      STATUS = SYS$WAITFR(%VAL(MTEFNO(CHANNO)))
      IF(STATUS .NE. SS$_NORMAL) THEN
          CALL LIB$STOP(%VAL(STATUS))
      END IF
      IOSD = MTIOSB(CHANNO)
      STATUS = IOSB_STATUS
      IF(STATUS .EQ. SS$_VOLINV) THEN
          CALL MTACK0(CHANNO, STATUS)
     0    STATUS = SYS$QIOW(
     1                      %VAL(MTEFNO(CHANNO))
     2                     ,%VAL(MTCHAN(CHANNO))
     3                     ,%VAL(MTSTAT(CHANNO))
     4                     ,IOSB
     5                     ,
     6                     ,
     7                     ,%VAL(MTWTVA(CHANNO))
     8                     ,
     9                     ,
     A                     ,
     B                     ,
     C                     ,
     Z                     )
          IF(STATUS .EQ. SS$_NORMAL) THEN
              STATUS = IOSB_STATUS
          ELSE
              CALL LIB$STOP(%VAL(STATUS))
          END IF
      END IF
      ACTCNT = IOSB_COUNT
      IF(ACTCNT .LT. 0) ACTCNT = ACTCNT + 65536
      MTSTAT(CHANNO) = IOSB(2)
      RETURN
C
C=======================================================================
C
C
      END

     0SUBROUTINE MTACK0(
     1                  CHANNO
     2                 ,RESULT
     Z                 )
C
C
      INTEGER CHANNO
      INTEGER RESULT
C
C
      INCLUDE 'MTOC00.INS /NOLIST'
C
C
      INCLUDE 'IOSB00.INS /NOLIST'
C
C
      INCLUDE 'MTERCS.INS /NOLIST'
C
C
C**********  SYSTEM PARAMETERS  **********
C
      INCLUDE '($IODEF)'
C
C
      INCLUDE '($SSDEF)'
C
C**********  EXTERNAL FUNCTIONS  **********
C
      INTEGER SYS$QIOW
C
C**********  LOCAL VARIABLES  **********
C
      INTEGER CHAN, EFNO
      INTEGER STATUS
C
C
C=======================================================================
C
  100 CONTINUE
      CHAN = MTCHAN(CHANNO)
      EFNO = MTEFNO(CHANNO)
      CONTINUE
C
C**********  PERFORM "PACK ACKNOWLEDGE"  **********
C
  200 CONTINUE
     0STATUS = SYS$QIOW(
     1                  %VAL(EFNO)
     2                 ,%VAL(CHAN)
     3                 ,%VAL(IO$_PACKACK)
     4                 ,IOSB
     5                 ,
     6                 ,
     7                 ,
     8                 ,
     9                 ,
     A                 ,
     B                 ,
     C                 ,
     Z                 )
      MTSTAT(CHANNO) = IOSB(2)
      IF(STATUS .NE. SS$_NORMAL) THEN
          CALL LIB$STOP(%VAL(STATUS))
      END IF
      CONTINUE
C
C**********  ANALYZE THE COMPLETION STATUS  **********
C
  300 CONTINUE
      STATUS = IOSB_STATUS
      IF(STATUS .EQ. SS$_NORMAL) THEN
          RESULT = 0
      ELSE IF(STATUS .EQ. SS$_CTRLERR) THEN
          RESULT = MTRERR
      ELSE IF(STATUS .EQ. SS$_DRVERR) THEN
          RESULT = MTRERR
      ELSE IF(STATUS .EQ. SS$_PARITY) THEN
          RESULT = MTRERR
      ELSE IF(STATUS .EQ. SS$_UNSAFE) THEN
          RESULT = MTRERR
      ELSE IF(STATUS .EQ. SS$_MEDOFL) THEN
          RESULT = MTROFL
      ELSE
          CALL LIB$STOP(%VAL(STATUS))
      END IF
      RETURN
C
C=======================================================================
C
C
      END

     0SUBROUTINE MTSENS(
     1                  CHANNO
     2                 ,STATUS
     3                 ,RESULT
     Z                 )
C
C
      INTEGER CHANNO
      INTEGER STATUS
      INTEGER RESULT
C
C
      INCLUDE 'MTOC00.INS /NOLIST'
C
C
      INCLUDE 'IOSB00.INS /NOLIST'
C
C
      INCLUDE 'MTERCS.INS /NOLIST'
C
C
C**********  SYSTEM PARAMETERS  **********
C
      INCLUDE '($IODEF)'
C
C
      INCLUDE '($SSDEF)'
C
C**********  EXTERNAL FUNCTIONS  **********
C
      INTEGER MTVCN1
      INTEGER SYS$QIOW
C
C**********  LOCAL VARIABLES  **********
C
      INTEGER CHAN, EFNO
C
C
C=======================================================================
C
  100 CONTINUE
      CHAN = MTVCN1(CHANNO, .TRUE.)
      EFNO = MTEFNO(CHANNO)
      STATUS = MTSTAT(CHANNO)
      CONTINUE
C
C**********  PERFORM A SENSE-MODE OPERATION  **********
C
  200 CONTINUE
     0RESULT = SYS$QIOW(
     1                  %VAL(EFNO)
     2                 ,%VAL(CHAN)
     3                 ,%VAL(IO$_SENSEMODE)
     4                 ,IOSB
     5                 ,
     6                 ,
     7                 ,
     8                 ,
     9                 ,
     A                 ,
     B                 ,
     C                 ,
     Z                 )
      IF(RESULT .NE. SS$_NORMAL) THEN
          CALL LIB$STOP(%VAL(RESULT))
      END IF
      IF(STATUS .LT. 0) THEN
          MTSTAT(CHANNO) = IOSB(2)
          STATUS = IOSB(2)
      END IF
      CONTINUE
C
C**********  ANALYZE THE COMPLETION STATUS  **********
C
  300 CONTINUE
      RESULT = IOSB_STATUS
      IF(RESULT .NE. SS$_VOLINV) THEN
          IF(RESULT .EQ. SS$_NORMAL) THEN
              RESULT = 0
          ELSE IF(RESULT .EQ. SS$_CTRLERR) THEN
              RESULT = MTRERR
          ELSE IF(RESULT .EQ. SS$_DRVERR) THEN
              RESULT = MTRERR
          ELSE IF(RESULT .EQ. SS$_PARITY) THEN
              RESULT = MTRERR
          ELSE IF(RESULT .EQ. SS$_UNSAFE) THEN
              RESULT = MTRERR
          ELSE IF(RESULT .EQ. SS$_MEDOFL) THEN
              RESULT = MTROFL
          ELSE
              CALL LIB$STOP(%VAL(RESULT))
          END IF
          MTWTVA(CHANNO) = STATUS
          MTWTRT(CHANNO) = RESULT
          RETURN
      END IF
      CONTINUE
C
C**********  PERFORM A NO-OPERATION  **********
C
  400 CONTINUE
     0RESULT = SYS$QIOW(
     1                  %VAL(EFNO)
     2                 ,%VAL(CHAN)
     3                 ,%VAL(IO$_NOP)
     4                 ,IOSB
     5                 ,
     6                 ,
     7                 ,
     8                 ,
     9                 ,
     A                 ,
     B                 ,
     C                 ,
     Z                 )
      IF(RESULT .NE. SS$_NORMAL) THEN
          CALL LIB$STOP(%VAL(RESULT))
      END IF
      MTSTAT(CHANNO) = IOSB(2)
      STATUS = IOSB(2)
      CONTINUE
C
C**********  ANALYZE THE COMPLETION STATUS  **********
C
  500 CONTINUE
      RESULT = IOSB_STATUS
      IF(RESULT .EQ. SS$_NORMAL) THEN
          CALL MTACK0(CHANNO, RESULT)
          MTUSED(CHANNO) = RESULT .EQ. 0
          RESULT = MTRVIN
      ELSE IF(RESULT .EQ. SS$_MEDOFL) THEN
          RESULT = MTROFL
      ELSE IF(RESULT .EQ. SS$_CTRLERR) THEN
          RESULT = MTRERR
      ELSE IF(RESULT .EQ. SS$_DRVERR) THEN
          RESULT = MTRERR
      ELSE IF(RESULT .EQ. SS$_PARITY) THEN
          RESULT = MTRERR
      ELSE IF(RESULT .EQ. SS$_UNSAFE) THEN
          RESULT = MTRERR
      ELSE
          CALL LIB$STOP(%VAL(RESULT))
      END IF
      MTWTVA(CHANNO) = STATUS
      MTWTRT(CHANNO) = RESULT
      RETURN
C
C=======================================================================
C
C
      END
