       SUBROUTINE CDHEX
C      DOES PARITY TEST, IF ANY AND RETURNS WITH APPROPRIATE
C      CODE WORD FOR CALCULATING A AND B IN COMMON LOCATION 'CODE'.
C      IF INDICES DO NOT PASS PARITY TEST, IF ANY, RETURNS WITH
C      ERROR SIGNAL ( 99 IN COMMON LOCATION ERR).
C
       INTEGER H,K,L,DF
       BYTE IDER(4,40),TDRCD(96),HDRCD(96),CODE(2,40),R,FIRST,
     1 RS(2),HRS(5),CDAT(40,32),R169(5),R178(5),N180(2),CD(1280)
       EQUIVALENCE (CD(1),CDAT(1,1))
      COMMON /CDCOM/CODE,IDER,NUM,ISPG,IPAR,IMOD,H,K,L
      DATA TDRCD/-3,-3,1,0,  !CODE FOR DERIV. OF EXP 1
     2 0,0,0,0,          ! THERE IS NO EXP 2 IN TRIG.
C234567
     3 1,1,3,0,          ! EXPRESSION 3 DERIVATIVE CODE
     4 0,0,0,0,               ! AND SO ON
     5 -7,-7,5,1,    ! FIRST NUMBER IS FOR X,Y DERIV.
     6 0,0,0,0,         ! 2ND FOR Z, 3RD FOR B13,B23
     7 5,5,7,1,      ! 4TH INDICATES SET1, SET2, SET3,...
     8 0,0,0,0,      ! .SET6 CODE FOR MULT. CONST. USED
     9 -11,-11,9,2,     ! BY GETAB TO CALCULATE DERIVATIVES.
     1 0,0,0,0,
     1 9,9,11,2,
     2 0,0,0,0,       ! NO EXPRESSION 12 IN TRIGONAL
     3 -15,-15,13,3,
     4  16,-16,-14,3,   !  DERIVATIVE CODE FOR 14 CORRECTED
     5 13,13,15,3,
     6 -14,14,-16,3,  !   
     7 -19,-19,17,4,    ! AS AN EXAMPLE FOR EXPRESSION 9
     8 20,-20,-18,4,    ! FOR X -2PII*11, Y -2PIH*11, Z -2PIL*11
     9 17,17,9,4,      ! B11 S*9,ETC, B13 -V*9, B23 HL*9
     1 -18,18,-20,4,
     1 -23,-23,21,5,
     2 24,-24,-22,5,
     3 21,21,23,5,
     4 -22,22,-24,5/    ! DERIVATIVE CODE FOR EXPR.  24
C23456
      DATA HDRCD/-4,-3,2,0,  !       EXPRESSION  1
     2 -3,-4,1,0,         ! CODE FOR EXPRESSION  2
     3 2,1,4,0,           !                      3
     4 1,2,3,0,           !                      4
     5 -8,-7,6,1,         !                      5
     6 -7,-8,5,1,         !                      6
     7 6,5,8,1,
     8 5,6,7,1,
     9 -12,-11,10,2,   ! D9/DX -2PII*12,D9/DZ -2PIL*11
     1 -11,-12,9,2,    ! D9/DB11 S*9,-D9/DB13=-V*10
     1 10,9,12,2,      ! THE S,T,U,V OF THESIS ARE
     2 9,10,11,2,      ! -S,-T,-U,-V IN THIS PROGRAM
     3 -16,-15,14,3,      ! CODE FOR EXPRESSION 13
     4 -15,-16,13,3,      !                     14
     5 14,13,16,3,        !                     15
     6 13,14,15,3,        !                     16
     7 -20,-19,18,4,      !                     17
     8 -19,-20,17,4,      !                     18
     9 18,17,20,4,        !                     19
     2 17,18,19,4,        !                     20
     1 -24,-23,22,5,      !                     21
     2 -23,-24,21,5,      !                     22
     3 22,21,24,5,        !                     23
     4 21,22,23,5/        !                     24
      DATA RS/2,1/        ! TO CHANGE REM. OF 1,2 TO 2,1
      DATA HRS/5,4,3,2,1/  ! REM OF 1,2,3,4,5 TO 5,4,3,2,1
      DATA R169/14,15,16,17,18/    ! INDEX FOR CDAT
      DATA R178/20,21,22,23,24/    ! INDEX FOR CDAT
      DATA N180/21,23/
C      THERE ARE 32 CODES FOR CALCULATING A AND B IN CD
      DATA CD/1,1,1,5,1,9,1,3,1,7,1,11,28*0,  ! 143  1
     1 1,1,5,5,5,9,6,7,3,11,1,3,5,7,5,11,3,5,6,9,20*0,   ! 144 R=1 2
     2 1,1,5,5,5,9,3,7,6,11,1,3,5,7,5,11,6,5,3,9,20*0, ! 144 R=2  3
C    CODE FOR 149
     3 1,1,1,5,1,9,1,13,1,17,1,21,1,3,1,7,1,11,4,15,4,19,4,23,16*0,
C    CODE FOR 150
     4 1,1,1,5,1,9,4,14,4,18,4,22,1,3,1,7,1,11,1,16,1,20,1,24,16*0,
     5 1,1,1,13,5,5,5,9,5,17,5,21,6,7,3,11,3,19,6,23,  ! 151 R=1 A 6
     5 1,3,4,15,5,7,5,11,2,19,2,23,3,5,6,9,3,17,6,21,  ! 151 R=1 B
     6 1,1,1,13,5,5,5,9,5,17,5,21,3,7,6,11,6,19,3,23,  ! 151 R=2 A 7
     6 1,3,4,15,5,7,5,11,2,19,2,23,6,5,3,9,3,18,6,22,  ! 151 R=2 B
     7 1,1,4,14,5,5,5,9,2,18,2,22,6,7,3,11,6,20,3,24,  ! 152 R=1 A 8
     7 1,3,1,16,5,7,5,11,5,20,5,24,3,5,6,9,6,18,3,22,  ! 152 R=1 B
     8 1,1,4,14,5,5,5,9,2,18,2,22,3,7,6,11,3,20,6,24,  ! 152 R=2 A 9
     8 1,3,1,16,5,7,5,11,5,20,5,24,6,5,3,9,3,18,6,22,  ! 152 R=2 B
     9 1,1,1,5,1,9,4,14,4,18,4,22,   ! 156 A 10
     9 1,3,1,7,1,11,4,16,4,20,4,24,16*0, ! 156 B
     1 1,1,1,5,1,9,1,13,1,17,1,21,   ! 157 A 11
     1 1,3,1,7,1,11,1,15,1,19,1,23,16*0,  ! 157 B
     2 1,1,1,5,1,9,1,14,1,18,1,22,   ! 158 R=1 A 12
     2 1,3,1,7,1,11,1,16,1,20,1,24,16*0,  ! 158 R=1 B
     3 1,1,1,5,1,9,4,13,4,17,4,21,   ! 159 R=1 A 13
     3 1,3,1,7,1,11,4,15,4,19,4,23,16*0,  ! 159 R=1 B
     4 1,2,5,6,5,10,6,8,3,12,   ! 169 R=1 A 14
     4 1,4,5,8,5,12,3,6,6,10,20*0, !169 R=1 B
     5 1,1,5,5,5,9,3,7,6,11,  ! 169 R=2 A   15
     5 1,3,5,7,5,11,6,5,3,9,20*0, !169 R=2 B
     6 1,2,1,6,1,10,1,4,1,8,1,12,28*0, !169 R=3 A B 16
     7 1,1,5,5,5,9,6,7,3,11, !169 R=4 A  17
     7 1,3,5,7,5,11,3,5,6,9,20*0, !169 R=4 B
     8 1,2,5,6,5,10,3,8,6,12,  !169 R=5 A  18
     8 1,4,5,8,5,12,6,6,3,10,20*0,  !  R=5 B
     9 1,1,1,5,1,9,1,4,1,8,1,12,28*0, !174 A B 19
     1 1,2,4,22,5,6,5,10,2,14,2,18,6,8,3,12,6,16,3,20, !178 R=1 A 20
     1 1,4,1,24,5,8,5,12,5,16,5,20,3,6,6,10,6,14,3,18, !178 R=1 B
     2 1,1,1,21,5,5,5,9,5,13,5,17,3,7,6,11,6,15,3,17, !178 R=2 A 21
     2 1,3,4,23,5,7,5,11,2,15,2,19,6,5,3,9,6,13,3,17, !178 R=2 B
     3 1,2,1,6,1,10,4,14,4,18,4,22,  !178 R=3 A 22
     3 1,4,1,8,1,12,1,16,1,20,1,24,16*0,  !178 R=3 B
     4 1,1,1,21,5,5,5,9,5,13,5,17,6,7,3,11,3,15,6,19, !178 R=4 A 23
     4 1,3,4,23,5,7,5,11,2,15,2,19,3,5,6,9,3,13,6,17, !178 R=4 B
     5 1,2,4,22,5,6,5,10,2,14,2,18,3,8,6,12,3,16,6,20, !178 R=5 A 24
     5 1,4,1,24,5,8,5,12,5,16,5,20,6,6,3,10,3,14,6,18, !178 R=5 B
     6 1,1,1,5,1,9,1,13,1,17,1,21,  !183 A   25
     6 1,3,1,7,1,11,1,15,1,19,1,23,16*0, !183 B
     7 1,1,1,5,1,9,4,13,4,17,4,21,  !184 R=1 A 26
     7 1,3,1,7,1,11,4,15,4,19,4,23,16*0,  !184 R=1 B
     8 1,2,1,6,1,10,1,14,1,18,1,22,  !185 R=1 A  27
     8 1,4,1,8,1,12,1,16,1,20,1,24,16*0,  !185 R=1 B
     9 1,2,1,6,1,10,4,14,4,18,4,22,  !186 R=1 A   28
     9 1,4,1,8,1,12,4,16,4,20,4,24,16*0,  !186 R=1 B
     7 1,1,1,5,1,9,1,13,1,17,1,21,        ! 187 A  29
     7 1,4,1,8,1,12,4,16,4,20,4,24,16*0,  ! 187 B
     8 1,2,1,6,1,10,1,14,1,18,1,22,       ! 188 A  30
     8 1,3,1,7,1,11,4,15,4,19,4,23,16*0,  ! 188 B
     9 1,1,1,5,1,9,1,13,1,17,1,21,        ! 189 A  31
     9 1,4,1,8,1,12,1,16,1,20,1,24,16*0,  ! 189 B
     9 1,2,1,6,1,10,4,14,4,18,4,22,       ! 190 A R=1  32
     9 1,3,1,7,1,11,4,15,4,19,4,23,16*0/  ! 190 B R=1
C      IPAR=0,1,2,3  FOR NOTEST,L,-H+K+L, L AND -H+K+L
C                     
       INDEX=IABS(ISPG)-142       ! FROM 1 TO 52
C      WRITE(13,10)INDEX,ISPG
C10     FORMAT('   INDEX=',I5,'   ISPG=',I5)
C    MAY WANT A BRANCH HERE AFTER THE FIRST CALL TO CDGET
      IF(IPAR.EQ.0)GO TO 100
      IF(IPAR.GT.1)THEN     ! FIRST TEST -H+K+L
      DF=(K-H+L)
      R=DF-3*(DF/3)
       IF(R.NE.0)H=99
       IF(R.NE.0)GO TO 101
      IF(IPAR.EQ.2)GO TO 100
       ELSE
       ENDIF
C    TEST L
       R=L-IMOD*(L/IMOD)   ! R MAY BE 0 1,2,3,4,5
       IF (R.EQ.0)GO TO 100
       IF(L.LT.0)THEN       ! CHANGE REM. FOR NEG L
       IF(IMOD.EQ.2)R=R+1
       IF(IMOD.NE.2)R=R+IMOD
       ELSE
       ENDIF
C       NOW HAVE INDEX IN R TO BE USED IN CODE TABLE
100    GO TO (143,144,145,143,147,147,149,150,151,152,153,154,150,
     1 156,157,158,159,156,158,162,163,164,165,166,165,143,
     1 169,170,145,144,173,174,147,176,149,178,179,180,181,182,183,
     1 184,185,186,187,188,189,190,191,191,191,191),INDEX

143    NUM=6
1431    IN=1          ! 1+5+9   3+7+11
        GO TO 90      ! GO FILL CODE ARRAY
144    IF(R.EQ.0)GO TO 143
       NUM=10                ! 10 EXPRESSIONS TO CALCULATE
       IF(R.EQ.1)IN=2    ! 1-1/2(5+9)-3**1/2/2(7-11) A
C                          3_1/2(7+11)+3**1/2/2(5-9) B
       IF(R.EQ.2)IN=3    !           +3**1/2/2(7-11) A
C                          3-1/2(7+11)-3**1/2/2(5-9) B
      GO TO 90
145    IF(R.EQ.0)GO TO 143
      IR=R
      R=RS(IR)     ! CHANGE REM OF 1,2,  TO 2,1
      GO TO 144
147    NUM=3
       GO TO 1431
149    NUM=12
      IN=4
       GO TO 90
150    NUM=12
      IN=5
      GO TO 90
151    IF(R.EQ.0)GO TO 149
1510   IN=5+R       !  REM=1 CODE 6
       NUM=20       !  REM=2 CODE=7
       GO TO 90
152    IF(R.EQ.0)GO TO 150
1521   IN=R+7      ! REM=1 CODE 8
       NUM=20
       GO TO 90    ! REM=2 CODE 9
153    IF(R.EQ.0)GO TO 149
       IR=R
       R=RS(IR)
       GO TO 1510
154    IF(R.EQ.0)GO TO 150
      IR=R
       R=RS(IR)
       GO TO 1521
156    NUM=12
1560   IN=10          ! 1+5+9-14-18-22  3+7+11-16-20-24
       GO TO 90
157    NUM=12
1570   IN=11          ! 1+5+9+13+17+21  3+7+11+15+19+23
       GO TO 90
158    IF(R.EQ.0)GO TO 156
       NUM=12
1580   IN=12      ! 1+5+9+14+18+22  3+7+11+16+20+24
       GO TO 90
159    IF(R.EQ.0)GO TO 157
       NUM=12
1590   IN=13     ! 1+5+9-13-17-21  3+7+11-15-19-23
       GO TO 90
162    NUM=6       ! 1+5+9+13+17+21
       GO TO 1570
163    NUM=6
      IF(R.EQ.0)GO TO 1570
164    NUM=6
C       WRITE(13,11)
C11     FORMAT('  GOT TO 164')
       GO TO 1560
165    NUM=6      
       IF(R.EQ.0)GO TO 1560
       GO TO 1580       ! 1+5+9+14+18+22
166    NUM=6
       GO TO 1560
169    IF(R.EQ.0)GO TO 143   ! 1+5+9   3+7+11
1690   NUM=10
      IN=R169(R)   ! CODE INDEX IS 14,15,16,17,18
      IF(R.EQ.3)NUM=6
       GO TO 90
170    IF(R.EQ.0)GO TO 143
      IR=R
C234567
      R=HRS(IR)     ! CHANGE 1,2,3,4,5 TO 5,4,3,2,1
      GO TO 1690
173    NUM=6
1730   IF(R.EQ.0)GO TO 1431
       IN=16     ! 2+6+10   4+8+12
       GO TO 90
174    NUM=6
       IN=19     ! 1+5+9    4+8+12
       GO TO 90
176    NUM=3
       GO TO 1730
178    IF(R.EQ.0)GO TO 149
1780   NUM=20
       IF(R.EQ.3)NUM=12
      IN=R178(R)   ! 20,21,22,23,24
      GO TO 90
179    IF(R.EQ.0)GO TO 149
       IR=R
       R=HRS(IR)  !    1,2,3,4,5   TO 5,4,3,2,1
       GO TO 1780
180     IF (R.EQ.0)GO TO 149
1800   NUM=20
       IN=N180(R)     !  21,23
       GO TO 90
181    IF(R.EQ.0)GO TO 149
       IR=R
       R=RS(IR)   ! 1,2   TO 2,1
       GO TO 1800
182    IF(R.EQ.0)GO TO 149
       NUM=12
       IN=22    ! 2+6+10-14-18-22  4+8+12+16+20+24
       GO TO 90
183    NUM=12
1830   IN=25     ! 1+5+9+13+17+21  3+7+11+15+19+23
      GO TO 90
184    NUM=12
1840    IN=25+R    ! 25 26   R= 0 OR R=1
       GO TO 90
185    NUM=12
1850   IF(R.EQ.0)GO TO 183
       IN=27   ! 2+6+10+14+18+22  4+8+12+16+20+24
       GO TO 90
186    IF(R.EQ.0)GO TO 183
1860   NUM=12
       IN=28   ! 2+6+10-14-18-22  4+8+12-16-20-24
       GO TO 90
187    NUM=12
       IN=29   ! 1+5+9+13+17+21   4+8+12-16-20-24
       GO TO 90
188    IF(R.EQ.0)GO TO 187
       NUM=12
      IN=30    ! 2+6+10+14+18+22  3+7+11-15-19-23
      GO TO 90
189    NUM=12
1890      IN=31    ! 1+5+9+13+17+21   4+8+12+16+20+24
       GO TO 90
190    NUM=12
1900   IF(R.EQ.0)GO TO 1890
1901   IN=32      ! 2+6+10-14-18-22  3+7+11-15-19-23
      GO TO 90
191    NUM=6
       IR=(INDEX-48)    ! 1,2,3,4
       IF(IR.EQ.1)GO TO 1840
       IF(R.EQ.0)GO TO 1830
       IF(IR.EQ.2)GO TO 1840
       IF(IR.EQ.4)GO TO 1901
       IN=30
       GO TO 90
C     COME HERE AFTER FILLING ARRAY CODE(2,N)
90     JJ=1
      DO 91 I=1,NUM
       DO 91 J=1,2
       CODE(J,I)=CDAT(JJ,IN)
       JJ=JJ+1
91     CONTINUE
       GO TO 1000
1000   IF(ISPG.GT.0)GO TO 101     !  STRUCTURE FACTOR RETURNS
C     LEAST SQUARES GETS DERIVATIVE CODE AND THEN RETURNS
       DO 1002 IN=1,NUM
       J=CODE(2,IN)    ! EXPRESSION NUMBER
       IS=(4*J)-4
       DO 1001,I=1,4
       KK=IS+I
       IF(INDEX.LT.26)THEN
       IDER(I,IN)=TDRCD(KK)  ! J POINTS TO EXPRESSION NUMBER
       ELSE
       IDER(I,IN)=HDRCD(KK)   ! HEXAGONAL DERIVATIVE CODE
       ENDIF
1001   CONTINUE
1002   CONTINUE
101       RETURN
       END
