      SUBROUTINE DECAY2
C
C   THIS PROGRAMS CALULATES THE COEFFICIENTS AND CORRESPONDING STANDARD
C   DEVIATIONS FOR CONSTANT, LINEAR AND QUADRATIC TIME DECAY CURVES.
C
      INTEGER*2 H,K,L,ID(1000),IDD(100,2),NCK(3),NOCK(16),ID1(200),
     1NUID(50,3),IUSE(1000,3),NDCK(3),HH(16),INO(16,1000),NND,NFLAG,
     2KK(16),LL(16),NOCHEK,NI,NMT,II,IH,ND,NID,IP(5),NTF,NAMLEN,
     3IDNO,IDHKL(4),IDDEL(500)
      REAL*4 INT(1000)
      INTEGER*4 SYS$TRNLOG
      CHARACTER*2 NT(10)
      CHARACTER*1 DASH(11)
      CHARACTER*17 NFILE
      CHARACTER*10 NAMDES
      DIMENSION SCL(4),SCARD(20)
      DIMENSION EXPTM(1000),SIG(1000),A(16,3,3),AI(3,3,3),B(16,3),
     1X(3,3),W(3),STDV(3),G(3),RESI(3),ACOR(3,3,3),BCOR(3,3),
     2CARD(20),JJ(1000),N(1000),GOF1(3),FAVG(16),REAL(13),NDR(12)
      EQUIVALENCE(REAL(9),EXTM),(REAL(7),SCAN),(REAL(6),BG1),
     1(REAL(8),BG2),(REAL(10),TBTS),(REAL(5),SPEED),(IDHKL(1),IDNO),
     2(IDHKL(2),H),(IDHKL(3),K),(IDHKL(4),L),(REAL(4),RANGE)
      COMMON IS1,IS2,IS3,IS4,IS5,IS6,SCF,B2,CARD
      PARAMETER ATT=20.9
      DATA DEL/'DELE'/
      DATA STAR/'(*)'/
      DATA BLANK/'   '/
      DATA TIME/'TIME'/  ! STARTING TIME
      DATA END/'END '/
      DATA SCAL/'SCAL'/
      DATA SITM/' T  '/
      DATA SITM2/' TIM'/
C
C   INTIALIZE
C
      ISCT=0
      ND=0
      ND1=0
      NDTOT=0
      NOCHEK=0
      NOF=1
      DO 101 NN=1,16
        NOCK(NN)=0  ! NUMBER OF REFLECTIONS IN EACH CHECK
        DO 100 IH=1,1000
100       INO(NN,IH)=0  ! ID NUMBERS OF REFLECTIONS IN EACH CHECK
        DO 101 I=1,3
          B(NN,I)=0.0  ! COLUMN MATRIX FOR EACH CHECK
          DO 101 NI=1,3
            A(NN,I,NI)=0.0 ! MATRIX FOR EACH CHECK
101   CONTINUE
      IN=14   ! READ IN FROM UNIT 14 (MAG FILE)
      IOUT=15
C  IF THERE IS MORE THAN ONE MAG FILE, THEY WILL BE MERGED AND WRITTEN
C  ON FILE 15 AND THEN READ FROM 15 AS ONE FILE.  15 IS TEMPORARY AND
C  IS DELETED AT END OF PROGRAM
C
C   TITLE CARD - NMT IS NUMBER OF TAPES MERGED
C
      DECODE(80,102,CARD)TITLE,NT
102   FORMAT(A4,2X,10A2)
      NMT=1
103   IF(NT(NMT).EQ.'  ')GOTO 104
      NMT=NMT+1
      GOTO 103
104   NMT=NMT-1
C
C   STARTING TIME AND DELMAX CARD
C   BEXPT - STARTING X-RAY TIME
C
      READ(1,120)CARD
      WRITE(3,121)CARD
      IF(CARD(1).EQ.TIME)GOTO 1090
      BEXPT=0.0   ! DEFAULT FOR STARTING TIME IS 0.0
C   HERE IF NO STARTING TIME AND DELMAX CARD - THEY ARE SET TO DEFAULT
      WRITE(3,111)
111   FORMAT(' STARTING TIME ASSUMED 0.0')
      TCHEK=BLANK
      DELMAX=10.0   ! DEFAULT FOR DELMAX IS 10.0
      WRITE(3,112)   ! MESSAGE THAT DELMAX SET TO 10.0
      GOTO 1190
1090  DECODE(80,110,CARD)ICAL,BEXPT,DELMAX
C  HERE FOR READING IN STARTING TIME AND DELMAX CARD
110   FORMAT(A4,1X,F8.2,F6.2)
C23456789012345678901234567890
CIME TTTTTTTTDDDDDD
      IF(BEXPT.EQ.0.0)THEN
      WRITE(3,111)
      TCHEK=BLANK
      ELSE
      TCHEK=STAR   ! STAR IN OUTPUT TO INDICATE STARTING TIME <> 0.0
      ENDIF
      IF(DELMAX.EQ.0.0)THEN
      DELMAX=10.0   ! DEFAULT FOR DELMAX IS 10.0
      WRITE(3,112)
112   FORMAT(' STANDARD DEVIATION IN CHECK REFLECTIONS ASSUMED 10.0')
      ENDIF
C
C   DELETE CARDS HERE IF ANY - ND IS TOTAL NUMBER OF DELETIONS
c
C     6/93 - kaf - modify DECAY into DECAY2 to apply corrections
c     from scale on time.
c
119   READ(1,120)CARD
120   FORMAT(20A4)
      IF(CARD(1).NE.END)WRITE (3,121)CARD
121   FORMAT(1X,20A4)
1190  IF(CARD(1).EQ.DEL)THEN
        GOTO 1211
      ELSE IF(CARD(1).EQ.SCAL)THEN
        GOTO 1210  !KAF 6/93
      ELSE IF(CARD(1).NE.END)THEN
        WRITE(3,114)
114     FORMAT(' UNRECOGNIZED COMMAND.  CARD SKIPPED.')
        GOTO 119 ! READ NEXT CARD
      ELSE   ! END CARD
        GOTO 130
      ENDIF
1210  ISCT=1                 !KAF 6/93
      DECODE(80,12,CARD)SCL  !KAF 6/93
12    FORMAT(22X,F8.2,2F10.6,F8.2)  !KAF 6/93
      scl(2)=SCL(2)/1000.0   !KAF 6/93
      SCL(3)=SCL(3)/1000000.0!KAF 6/93
      GOTO 119               !KAF 6/93
1211  DECODE(80,122,CARD)(NDR(I),DASH(I),I=1,11),NDR(12)
122   FORMAT(7X,11(I5,A1),I5)
      I=1
123   IF(NDR(I).EQ.0)GOTO 119
      IF(DASH(I).EQ.'-')THEN
C       ! DASH SIGNIFIES RANGE OF ID'S TO BE DELETED
        ND=ND+1
        IF(ND.GT.100)THEN
C         ! 100 RANGES OF DELETION ID'S ALLOWED
          ND=100
          WRITE(3,124)NDR(I)
124   FORMAT(' DELETION ARRAY OVERFLOW.  REFLECTION NUMBER ',I6,' NOT',
     1    ' DELETED.')
        ENDIF
        IDD(ND,1)=NDR(I)
        IDD(ND,2)=NDR(I+1)
        I=I+2
      ELSE
C       ! SINGLE ID TO BE DELETED
        ND1=ND1+1
        IF(ND1.GT.200)THEN
C         ! 200 SINGLE DELETIONS ALLOWED
          ND1=200
          WRITE(3,124)NDR(I)
        ENDIF
        ID1(ND1)=NDR(I)
        I=I+1
      ENDIF
      IF(I.LE.12)GOTO 123
      GOTO 119
C  OPEN MAG FILE
130   ICD=SYS$TRNLOG('NAM',NAMLEN,NAMDES,,,)
      IF(.NOT. ICD)THEN
        WRITE(3,999)
999     FORMAT(' ERROR ON RETURN FROM TRNLOG')
        RETURN
      ENDIF
      NFILE(1:NAMLEN)=NAMDES
      NAMLEN=NAMLEN+1
      NFILE(NAMLEN:NAMLEN+4)='.MAG;'
      NAMLEN=NAMLEN+5
      I=0
      IF(NMT.EQ.0)GOTO 1302
1303  NFILE(NAMLEN:NAMLEN+1)=NT(NOF)
1302  OPEN(NAME=NFILE,UNIT=IN,TYPE='OLD',FORM='UNFORMATTED',
     1 BLOCKSIZE=32768)
C
C   READ IN REFLECTIONS HERE
C
131   I=I+1
132   READ(IN)IDHKL,REAL
c      real(1)=abs(real(1))
c     set tth positive  not needed for now, leave out
      IF(IDNO.EQ.0)GOTO 135  ! LAST CHECK
      IF(IDNO.GT.0)GOTO 132   ! NOT A CHECK REFLECTION
      IF(SPEED.LT.0.0)THEN
        NDTOT=NDTOT+1
        IF(NDTOT.GT.500)NDTOT=500  !PREVENT ARRAY OVERFLOW
        IDDEL(NDTOT)=IDNO
        GOTO 132
      ENDIF
C  PREVIOUSLY DELETED REFLECTION (UPDATE) MARKED ON MAG FILE WITH
C  NEGATIVE SCAN SPEED.
C
C     Formulas from INITIA to calculate corrections for SCALE on TIME
C     on the CHECK Reflections - 6/93 - kaf
C
      T2=EXTM-SCL(4)                        !6/93-KAF
      SCLN=SCL(1)*(1+SCL(2)*T2+SCL(3)*T2**2)!6/93-KAF
      SCLN=(SCL(1)**2)/SCLN                 !6/93-KAF
      ID(I)=IDNO
      EXPTM(I)=ABS(EXTM)
      TSTB=1./TBTS
      WT=WT/SCLN               !6/93-KAF-SCALE ON TIME CORRECTIONS
      WF=WF*SCLN               !6/93-KAF-SCALE ON TIME CORRECTIONS
      SIG(I)=SQRT(SPEED**2*(SCAN+(BG1+BG2)*TSTB**2))
      INT(I)=(SCAN-(BG1+BG2)*TSTB)*SPEED
      SIG(I)=SIG(I)*SCLN
      INT(I)=INT(I)*SCLN**2
      IF(EXTM.LT.0.0)THEN
C       TIME LESS THAN 0.0, MEANS ATTENUATOR WAS SET
        SIG(I)=SIG(I)*ATT
        INT(I)=INT(I)*ATT
      ENDIF
      IF(INT(I).LT.0)THEN
        WRITE(3,1331)IDNO
1331    FORMAT(' INT IS NEGATIVE NUMBER ON ID NO. ',I5)
        GOTO 132
      ENDIF
      IF(ND.EQ.0)GOTO 134  ! NO DELETIONS
      DO 134 II=1,ND   ! CHECKING IF IT IS ONE OF THE DELETED ID#S
        IF(IABS(ID(I)).GE.IDD(II,1).AND.IABS(ID(I)).LE.IDD(II,2))THEN
          NDTOT=NDTOT+1
          IF(NDTOT.GT.500)NDTOT=500  ! PREVENT ARRAY OVERFLOW
          IDDEL(NDTOT)=ID(I)
          GOTO 132
        ENDIF
134   CONTINUE
      IF(ND1.EQ.0)GOTO 1347
      DO 1347 II=1,ND1
        IF(IABS(ID(I)).EQ.ID1(II))THEN
          NDTOT=NDTOT+1
          IF(NDTOT.GT.500)NDTOT=500   ! PREVENT ARRAY OVERFLOW
          IDDEL(NDTOT)=ID(I)
          GOTO 132
        ENDIF
1347  CONTINUE
      IF(NOCHEK.EQ.0)GOTO 1342
      DO 1342 J=1,NOCHEK
        IF(HH(J).EQ.H.AND.KK(J).EQ.K.AND.LL(J).EQ.L)THEN
          N(I)=J
          GOTO 1345
        ENDIF
1342  CONTINUE
      NOCHEK=NOCHEK+1
      N(I)=NOCHEK
      HH(NOCHEK)=H
      KK(NOCHEK)=K
      LL(NOCHEK)=L
1345  NOCK(N(I))=NOCK(N(I))+1
      INO(N(I),NOCK(N(I)))=I
      EXPTM(I)=EXPTM(I)-BEXPT  ! TIME=T(TRUE)-STARTING TIME
      WT=(2*SQRT(INT(I)))/SIG(I)
      DO 1341 II=1,3
1341  W(II)=WT*(EXPTM(I)**(II-1))
      WF=WT*SQRT(INT(I))
      DO 136 NI=1,3
        B(N(I),NI)=B(N(I),NI)+WF*W(NI)
C       ! B IS A 1X3 COLUMN MATRIX
        DO 136 II=1,3
          A(N(I),NI,II)=A(N(I),NI,II)+W(NI)*W(II)
C         ! A IS A 3X3 MATRIX
136   CONTINUE
      GOTO 131   ! READ NEXT REFLECTION
135   NID=I-1   ! TOTAL NUMBER OF REFLECTIONS
      CLOSE(UNIT=IN,DISP='SAVE')
      IF(NOF.LT.NMT)THEN
        NOF=NOF+1
        GOTO 1303
      ENDIF
      DO 165 NN=1,NOCHEK
C       ! CALCULATING COEFFICIENTS ONE REFLECTION AT A TIME
1505    FORMAT(1H1)
        WRITE(3,150)NN,HH(NN),KK(NN),LL(NN)
150     FORMAT(/' CHECK # ',I3,':  H= ',I4,'  K= ',I4,'  L= ',I4/)
        WRITE(3,1501)TCHEK
1501  FORMAT(76X,'F(CALC)',/,3X,'ID#',7X,'T',A3,3X,'F(OBS)',5X,'SIGMA',
     1  9X,'NO DECAY',3X,'RESIDUAL',8X,'LINEAR',3X,'RESIDUAL',6X,
     2  'QUADRATIC',3X,'RESIDUAL'/)
        DO 1361 I=1,3
          NDCK(I)=0
          DO 1361 II=1,3
            X(I,II)=0.0
1361    CONTINUE
        IF(NOCK(NN).LT.2)GOTO 138 ! TOO FEW REFLECTIONS FOR CALCULATIONS
C
C       ! CALCULATING ORIGINAL COEFFICIENTS
C       ! SOLVING EQUATION AX=B FOR X (X=A(INVERSE)*B)
C
        X(1,1)=B(NN,1)/A(NN,1,1)
        IF(NOCK(NN).LT.3)GOTO 138  ! TOO FEW REFLECTIONS FOR LINEAR CASE
        CALL INVERSE2(A(NN,1,1),A(NN,1,2),A(NN,2,1),A(NN,2,2),AI)
C  INVERSE2 IN DECAY
C       ! FINDING INVERSE OF 2X2 MATRIX
        IF(NOCK(NN).LT.4)GOTO 138  ! TOO FEW REFLECTIONS FOR QUAD. CASE
        CALL INVERSE3 (A(NN,1,1),A(NN,1,2),A(NN,1,3),A(NN,2,1),
     1  A(NN,2,2),A(NN,2,3),A(NN,3,1),A(NN,3,2),A(NN,3,3),AI)
C  INVERSE3 IN DECAY
C      ! FINDING INVERSE OF 3X3 MATRIX
        DO 138 NI=2,3
C         ! LINEAR AND QUADRATIC COEFFICIENTS
          DO 138 I=1,NI
            DO 138 II=1,NI
              X(I,NI)=X(I,NI)+AI(I,II,NI)*B(NN,II)
138     CONTINUE
        DO 145 IH=1,3
          GOF1(IH)=0.0
          NCK(IH)=0
          DO 145 I=1,3
            BCOR(IH,I)=0.0
            DO 145 II=1,3
              ACOR(IH,I,II)=0.0
145     CONTINUE
        DO 1482 IH=1,NOCK(NN)
C 
C         ! DISCARDING BAD F'S
C
          I=INO(NN,IH)
          WT=(2*SQRT(INT(I)))/SIG(I)
          DO 148 NI=1,3
            G(NI)=0.0
            DO 146 II=1,NI
146         G(NI)=G(NI)+X(II,NI)*(EXPTM(I)**(II-1))
            RESI(NI)=(SQRT(INT(I))-G(NI))/(1/WT)  ! RESIDUAL
            GOF1(NI)=GOF1(NI)+(WT*(SQRT(INT(I))-G(NI)))**2
            IF(ABS(RESI(NI)).GT.DELMAX)THEN  ! BAD F
              NDCK(NI)=NDCK(NI)+1
              IF(NDCK(NI).GT.(NOCK(NN)/3))GOTO 148
              NUID(NDCK(NI),NI)=ID(I)
            ELSE    ! DFLIM<DELMAX (F NOT "BAD")
C             ! CREATING MATRIX OF GOOD F'S
              NCK(NI)=NCK(NI)+1
              DO 1471 II=1,3
1471          W(II)=WT*(EXPTM(I)**(II-1))
              WF=WT*SQRT(INT(I))
              DO 152 II=1,NI
                BCOR(II,NI)=BCOR(II,NI)+WF*W(II)
                DO 152 IT=1,NI
                  ACOR(II,IT,NI)=ACOR(II,IT,NI)+W(II)*W(IT)
152           CONTINUE
              IUSE(NCK(NI),NI)=I
            ENDIF
148       CONTINUE
C         ! ENDTIME and STARTTIME added 1/92 by kaf as part of adding a 
C         ! percent decay to the output.
          ENDTIME=exptm(I)
          STARTTIME=EXPTM(1)
          WRITE(3,1481)ID(I),EXPTM(I),SQRT(INT(I)),1/WT,(G(IT),
     1    RESI(IT),IT=1,3)
1481      FORMAT(1X,I6,2X,F8.2,2X,F8.3,2X,F7.3,3X,3(6X,F8.3,3X,F8.3))
1482    CONTINUE
        IF(NOCK(NN).GT.3)THEN
          DO 1483 NI=1,3
            GOF1(NI)=SQRT(GOF1(NI)/(NOCK(NN)-NI))
            IF(NI.GT.1)THEN
C             ! EQUATION SOLVED FOR F+AT+BT**2 - NOW NEED TO TRANSLATE TO 
C             ! F(1+AT+BT**2).
C             ! ALSO A IN WRITE-OUT IS A*10**3 AND B IS B*10**6
              DO 1484 I=2,NI
                IT=3*(I-1)
1484          X(I,NI)=(X(I,NI)/X(1,NI))*10**IT
            ENDIF
1483      CONTINUE
          WRITE(3,1495)X(1,1),(X(I,2),I=1,2),(X(I,3),I=1,3)
1495      FORMAT(/44X,'F=',F8.2,12X,'F=',F8.2,'  A=',F8.4,4X,'F=',F8.2,
     1    '  A=',F8.4,'  B=',F8.4)
          FAVG(NN)=X(1,1)
          WRITE(3,1496)(GOF1(I),I=1,3)
1496      FORMAT(44X,'GOF=',E10.3,12X,'GOF=',E10.3,16X,'GOF=',E10.3)
        ENDIF
        IF(BEXPT.NE.0.0)WRITE(3,1591)BEXPT
1591    FORMAT(/,' *  T(TRUE) -',F8.2/)
C
C       ! CALCULATE CORRECTED COEFFICIENTS
C
        DO 1520 I=1,3
          DO 1520 II=1,3
1520    X(I,II)=0.0
C        1         2         3         4         5         6         7
C234567890123456789012345678901234567890123456789012345678901234567890
        IF(NCK(1).GT.1.AND.NDCK(1).LE.(NOCK(NN)/3))
     1    AI(1,1,1)=1/ACOR(1,1,1)
        IF(NCK(2).GT.2.AND.NDCK(2).LE.(NOCK(NN)/3))THEN
          CALL INVERSE2(ACOR(1,1,2),ACOR(1,2,2),ACOR(2,1,2),
     1      ACOR(2,2,2),AI)
C      INVERSE2 IN DECAY
        ENDIF
        IF(NCK(3).GT.3.AND.NDCK(3).LE.(NOCK(NN)/3))THEN
          CALL INVERSE3(ACOR(1,1,3),ACOR(1,2,3),ACOR(1,3,3),
     1      ACOR(2,1,3),ACOR(2,2,3),ACOR(2,3,3),ACOR(3,1,3),
     2      ACOR(3,2,3),ACOR(3,3,3),AI)
C      INVERSE3 IN DECAY
        ENDIF
        DO 153 NI=1,3
          IF(NCK(NI).LT.(NI+1).OR.NDCK(NI).GT.(NOCK(NN)/3))GOTO 153
          DO 153 I=1,NI
            DO 153 II=1,NI
              X(I,NI)=X(I,NI)+AI(I,II,NI)*BCOR(II,NI)
153     CONTINUE
        DO 165 NI=1,3
C         ! NI CORRESPONDS TO CONSTANT, LINEAR AND QUADRATIC CASES
          NND=NDCK(NI)
          IF(NDCK(NI).GT.(NOCK(NN)/3))NND=NOCK(NN)/3
          IF(NDCK(NI).GT.0.AND.NDCK(NI).LE.NOCK(NN)/3)WRITE(3,1505)
C         ! ONLY FIRST THIRD OF BAD REFLECTIONS ARE PRINTED
          GOTO(154,155,1550)NI
154       WRITE(3,1600)NCK(1),NDCK(1)
1600      FORMAT(/' NO DECAY MODEL:',10X,I3,' VALUES, ',I2,
     1    ' DELETED REFLECTIONS: ')
          IF(NND.LT.23)THEN
            WRITE(3,1603)(NUID(II,1),II=1,NND)
1603        FORMAT(I5,21I6)
          ELSE
            IF(NND.LT.45)THEN
              WRITE(3,1603)(NUID(II,1),II=1,22)
              WRITE(3,1603)(NUID(II,1),II=23,NND)
            ELSE
              WRITE(3,1603)(NUID(II,1),II=1,22)
              WRITE(3,1603)(NUID(II,1),II=23,44)
              WRITE(3,1603)(NUID(II,1),II=45,NND)
            ENDIF
          ENDIF
          GOTO 1551
155       WRITE(3,1610)NCK(2),NDCK(2)
1610      FORMAT(' LINEAR DECAY MODEL:',6X,I3,' VALUES, ',I2,
     1    ' DELETED REFLECTIONS: ')
          IF(NND.LT.23)THEN
            WRITE(3,1603)(NUID(II,2),II=1,NND)
          ELSE
            IF(NND.LT.45)THEN
              WRITE(3,1603)(NUID(II,2),II=1,22)
                WRITE(3,1603)(NUID(II,2),II=23,NND)
          ELSE
            WRITE(3,1603)(NUID(II,2),II=1,22)
            WRITE(3,1603)(NUID(II,2),II=23,44)
            WRITE(3,1603)(NUID(II,2),II=45,NND)
          ENDIF
        ENDIF
        GOTO 1551
1550    WRITE(3,1620)NCK(3),NDCK(3)
1620    FORMAT(' QUADRATIC DECAY MODEL:',3X,I3,' VALUES, ',I2,
     1  ' DELETED REFLECTIONS: ')
        IF(NND.LT.23)THEN
          WRITE(3,1603)(NUID(II,3),II=1,NND)
        ELSE
          IF(NND.LT.45)THEN
            WRITE(3,1603)(NUID(II,3),II=1,22)
            WRITE(3,1603)(NUID(II,3),II=23,NND)
          ELSE
            WRITE(3,1603)(NUID(II,3),II=1,22)
            WRITE(3,1603)(NUID(II,3),II=23,44)
            WRITE(3,1603)(NUID(II,3),II=45,NND)
          ENDIF
        ENDIF
1551    IF(NDCK(NI).GT.0.AND.NDCK(NI).LE.(NOCK(NN)/3))WRITE(3,1552)TCHEK
1552    FORMAT(/2X,'ID#',7X,'T',A3,3X,'F(OBS)',5X,'SIGMA',
     1  9X,'F(CALC)',4X,'RESIDUAL'/)
C
C       ! CALCULATING STD DEVS AND GOFS
C
        GOF=0.0
        IF(NCK(NI).LT.1)GOTO 160
156     DO 157 I=1,NCK(NI)
        GG=0.0
        II=IUSE(I,NI)
        DO 1561 IH=1,NI
1561      GG=GG+X(IH,NI)*(EXPTM(II)**(IH-1))
        WT=(2*SQRT(INT(II)))/SIG(II)
        RESI(NI)=(SQRT(INT(II))-GG)/(1/WT)
        GOF=GOF+(WT*(SQRT(INT(II))-GG))**2
        IF(NDCK(NI).EQ.0.OR.NDCK(NI).GT.(NOCK(NN)/3))GOTO 157
        WRITE(3,1572)ID(II),EXPTM(II),SQRT(INT(II)),1/WT,GG,RESI(NI)
1572    FORMAT(1X,I6,2X,F8.2,2X,F8.3,2X,F7.3,9X,F8.3,3X,F8.3)
157   CONTINUE
      IF(NCK(NI).LE.NI.OR.NDCK(NI).GT.(NOCK(NN)/3))GOTO 160
      GOF=SQRT(GOF/(NCK(NI)-NI))
      DO 158 I=1,NI
158   STDV(I)=SQRT(ABS(AI(I,I,NI)))*GOF
      IF(NI.GT.1)THEN
C   EQUATION SOLVED FOR F+AT+BT**2 - NOW NEED TO TRANSLATE TO 
C   F(1+AT+BT**2).
C   ALSO A IN WRITE-OUT IS A*10**3 AND B IS B*10**6
      DO 159 I=2,NI
      IT=3*(I-1)
      STDV(I)=(STDV(I)/X(1,NI))*10**IT
159   X(I,NI)=(X(I,NI)/X(1,NI))*10**IT
      ENDIF
160   IF(NCK(NI).LE.NI.OR.NDCK(NI).GT.(NOCK(NN)/3))THEN
      WRITE(3,1601)
1601  FORMAT(/' TOO FEW REFLECTIONS OR TOO MANY BAD REFLECTIONS.',
     1' CALCULATION SKIPPED.'//)
      GOTO 165
      ENDIF
      GOTO(1590,1592,1593)NI
1590  WRITE(3,161)X(1,1),STDV(1),GOF
161   FORMAT(/' F= ',F8.2,' (',F7.4,')',61X,'GOF= ',E10.3//)
      GOTO 165
1592  CALL PERCENTDEC(X(2,2),STARTTIME,ENDTIME,0,PERCENT)  !ADDED  1/92 BY KAF
      WRITE(3,1611)                 !PERCENTDEC IN DECAY
1611  FORMAT(/' F(CALC)=F(1+AT)')
      WRITE(3,162)(X(I,2),STDV(I),I=1,2),GOF,PERCENT
162   FORMAT(/' F= ',F8.2,' (',F7.4,')  A*10**3= ',F8.4,' (',F7.4,')',
     132X,'GOF= ',E10.3,3X,'PERCENT DECAY=',F8.2//)
      GOTO 165
1593  CALL PERCENTDEC(X(2,3),STARTTIME,ENDTIME,X(3,3),PERCENT) !1/92 KAF
      WRITE(3,1621)                        !PERCENTDEC IN DECAY
1621  FORMAT(/' F(CALC)=F(1+AT+BT**2)')
      WRITE(3,163)(X(I,3),STDV(I),I=1,3),GOF,PERCENT
163   FORMAT(/' F= ',F8.2,' (',F7.4,')  A*10**3= ',F8.4,' (',F7.4,
     1')  B*10**6= ',F8.4,' (',F7.4,')   GOF= ',E10.3,3X,
     2'PERCENT DECAY=',F8.2//)
165   CONTINUE
      TMAX=0
      IF(NOCHEK.GT.5)NOCHEK=5
      DO 175 NN=1,NOCHEK
      IP(NN)=1
      J=INO(NN,NOCK(NN))
      IF(EXPTM(J).GT.TMAX)TMAX=EXPTM(J)   ! FINDING "LATEST" REFLECTION
175   CONTINUE
C
C    GRAPH OF TIME VS. INTENSITY - GRAPH IS 80(TIME)x100(INTENSITY)
C
      WRITE(3,176)
176   FORMAT(1H1,8X,'0        0.1       0.2       0.3       0.4      ',
     1' 0.5 F(CK) 0.6       0.7       0.8       0.9       1.0       ',
     2'1.1')
      WRITE(3,185)
185   FORMAT(/,7X,'0',1X,'l---------l---------l---------l---------l--',
     1'-------l---------l---------l---------l---------l---------l---',
     2'------l')
      IH=1
177   TP=IH*TMAX/80    ! TIME INTERVAL
      WRITE(3,178)
178   FORMAT(9X,'l')
      IF(IH.EQ.38)WRITE(3,181)
181   FORMAT('+',1X,'TIME')
      IF(IMOD(IH,5).EQ.0)WRITE(3,182)TP
182   FORMAT('+',1X,F6.2,1X,'-')
      DO 180 NN=1,NOCHEK
      IF(NOCK(NN).LT.5)GOTO 180 ! CHECK NOT GRAPHED IF < 5 TOTAL REF.S
C   DOES CHECK REFLECTION HAVE A POINT IN THIS TIME INTERVAL?
179   IF(IP(NN).GT.NOCK(NN))GOTO 180
      II=INO(NN,IP(NN))
      IF(EXPTM(II).LE.TP+TMAX/160)THEN
      IX=7.5+(SQRT(INT(II))/FAVG(NN)-(.1*(NN-1)))*100
C   SCALING TO FAVG
C   IX IS HORIZONTAL DISTANCE ON GRAPH
       IF(IX.LT.1)WRITE(3,9000)IX,INT(II),FAVG(NN),NN
9000   FORMAT('  IX=',I10,' INT(II)=',F16.6,' FAVG=',F16.6,'  NN=',I10)
      IF(IX.GT.0)WRITE(3,183)NN
183   FORMAT('+',<IX>X,I2)
      IP(NN)=IP(NN)+1
      GOTO 179   ! CHECK FOR ANOTHER REFLECTION IN THIS INTERVAL
      ENDIF
180   CONTINUE
      IH=IH+1
      IF(IH.LE.80)GOTO 177
      IF(NDTOT.EQ.0)GOTO 1801
      WRITE(3,1800)
1800  FORMAT(1H1,' THE FOLLOWING REFLECTIONS HAVE BEEN DELETED FROM',
     1' CALCULATIONS: ')
      IF(NDTOT.GE.500)WRITE(3,1807)
1807  FORMAT(' NOTE: ONLY THE FIRST 500 REFLECTIONS WRITTEN HERE.')
      II=0
1802  II=II+1
      I1=15*II-14
      I2=15*II
      IF(I2.GT.NDTOT)NDTOT=I2
      WRITE(3,1803)(IDDEL(J),J=I1,I2)
1803  FORMAT(1X,15(1X,I6))
      IF(I2.LT.NDTOT)GOTO 1802
1801  RETURN
      END
