	SUBROUTINE FPEAK3
C     FPEAK  PROGRAM FOR EXTRACTING PEAKS FROM FOURIER MAPS             00000030
C          DEC87 VERSION WITH NEGATIVE PEAKS
      REAL LB,LD,LH
      REAL NPX,NPY,NPZ,NPH,nmhpk,ndpk
      CHARACTER*1 SPGL,XYZ(3),PXYZ(3),SDH(3),SDV(3),TFL(500),TA,ASP,
     + NTFL(500),ov(500),atfl(500),AOV(500),NOV(500),SL
      CHARACTER*16 NFILE
      INTEGER*2 SPG,LC1,LC2,LC3,SGSV,LCN,PRTM
       PARAMETER(XAR=0.0174532925)     ! DEGREES TO RADIANS
       parameter(msym=9999)
c      above in distan as well as elsewhere - reset arrays as below to msym
c     +sa(9999),sb(9999),sc(9999),sd(9999),se(9999),sf(9999),sg(9999),
c     +sh(9999),spS(9999),sq(9999),rr(9999),ss(9999) 
c  the guk common
       INTEGER*2 IA(203,203,3)    ! keep 3 sections at one time
c                                 ! to find peaks between sections
      DIMENSION IPR(500),JPR(500),R(19),CARD(20), 
     1APX(500),APY(500),APZ(500),APH(500),CEL(3),ANG(3),SP(3),DELH(3),  00000060
     2DELV(3),LB(3),LD(3),LH(3),PX(500),PY(500),PZ(500),
     3PH(500),IPC(500),XO(500),YO(500),ZO(500),X(300),Y(300),Z(300),
     2NPX(500),NPY(500),NPZ(500),NPH(500),NIPC(500) 
      DIMENSION NATM(300),TQ(300),BAT(300),PT(3),IOV(40),JSYV(40),
     +sa(9999),sb(9999),sc(9999),sd(9999),se(9999),sf(9999),sg(9999),
     +sh(9999),spS(9999),sq(9999),rr(9999),ss(9999) 
      DIMENSION dcop(3),cell(6),AM(3,3),AR(3,3),DC(3,3)
      DIMENSION S(5,6)          ! USE OLD ROUTINES FOR GENERAL PLANE
      EQUIVALENCE(A,S(1,6)),(B,S(2,6)),(D,S(3,6)),(E,S(4,6)),(C,S(5,6)),00000110
     3(DCOP(1),DX),(DCOP(2),DY),(DCOP(3),DZ)                            00000140
       EQUIVALENCE (CEL(1),CELL(1)),(ANG(1),CELL(4)),(DELV(1),DEL1V),
     +(DELV(2),DEL2V),(DELV(3),DEL3V),(DELH(1),DEL1H),(DELH(2),DEL2H),
     +(DELH(3),DEL3H)
      DIMENSION DH(3),DV(3)
      character*12 namex,namex1
      CHARACTER*20 DIN
      COMMON IS1,IS2,IS3,IS4,IS5,IS6,SCF,B2,CARD,JPAGE,IT1,IT2,X,Y,Z,   00000150
     1NATM,TQ,BAT,IPR,JPR,R,IPC,NAMEX1                                  00000160
      integer clpkst,clsto,CICRD
      common/pkcom/csmhpk,Cdmpk,CICRD,Clpkst,CNMHPK,CNDPK
      COMMON/PRNT/FTE,LC1,LC2,LC3,ISPEC,ITYP,IXX,NAMEX,XYZ,LPKST,
     +NEG
      COMMON/SRTCM/XO,YO,ZO,ispek,R1,R2,R3,R4,R5,R6,DMPK,DMS,LCN,ISYM
      COMMON/FNAME/NFILE,NAMLEN
      COMMON/SOLV/SVX,SVY,SVZ,RH,ITYPP
      COMMON /GUK/sA,sB,sC,sD,sE,sF,sG,sH,sPS,sQ,RR,SS
C       FORMATS                                                         00000180
  101 FORMAT ('0','          ',A,'         ',A,'         ',A,
     +'        HEIGHT',/)
  103 FORMAT (' ',I3,3F10.3,5X,F6.1,1X,A)                           
  104 FORMAT('+',48X,'EDGE')                                            00000220
  105 FORMAT('+',48X,'ERROR')                                           00000230
  108 FORMAT ('0 NUMBER OF ROWS AND/OR COLUMNS PER SECTION IS TOO LARGE 00000240
     1FOR FPEAK PROGRAM')                                               00000250
  109 FORMAT('+',30X,A4,F7.4/)                                          00000260
  110 FORMAT ('0',10X,'PEAK LISTING',20X,A,/'0',12X,A,/)        
1000  format (' ')           ! advances one line
  111 FORMAT ('+',30X,'GENERAL PLANE')                                  00000280
  112 FORMAT ('+',30X,'PROJECTION ',A4,'AXIS')                          00000290
  113 FORMAT ('+',30X,'COMPOSITE 3-DIM')                                00000300
  114 FORMAT ('0  TOO MANY PEAKS')                                      00000310
  115 FORMAT(20('P',I3))                                                00000320
  116 FORMAT(20A4)                                                      00000330
  117 FORMAT ('0   SYMMETRY TRANSFORMATIONS IN USE'//' ',11X,'A',7X,'B',00000340
     17X,'C',7X,'D',7X,'E',7X,'F'/)                                     00000350
  118 FORMAT (' ',6X,6F8.3)                                             00000360
       DATA XYZ/'X','Y','Z'/
C       SET LIMITS OF PROGRAM                                           00000380
C                   NMHPK IS NEG PEAK HEIGHT AND NDPK IS DISTANCE 
C                         BETWEEN NEG PEAKS
      NMPS=IS3                                                          00000400
      KT=12                                                              000001210
      JT=5                                                              00000420
      NEG=0      ! INITIALIZE. LATER, N=0 MEANS POSITIVE PEAKS ONLY
      SL=' '
      PRTM=0       ! SIGNAL TO PRINT ERROR MESSAGE
      NGMX=0     ! NEG=99 MEANS NEGATIVE ONLY, NEG=9 MEANS BOTH AND
      IPKL=0
      NPKL=0     ! THE NEGATIVE PEAK LIST IS YET TO BE DONE
      NMHPK=0.0
      SMHPK=0.0
      IPKMX=500  !  NEG=1 MEANS BOTH AND THE NEG LIST IS DONE     
      IPKST=150                                                         00000440
      DO I=1,500
      TFL(I)=' '         ! SIGNAL THAT SOLVN WORKED OR DIDNT
      NTFL(I)=' '        ! FOR NEGATIVE PEAKS TOO
      ov(i)=' '          ! overflow signal   9999
      NOV(I)=' '
      ENDDO
C2004  format('  in fpeak3 is1=',i3,' smhpk=',f8.3,' dmpk=',f8.3)
C     CYCLE OVER MAPS                                                   00000460
C     DO 23 JCM=1,NMPS         ! NOT IN THIS VERSION                    00000480
C     READ PARAMETERS FROM MAP FILE                                     00000500
      READ(KT)NAMEX,CELL,SGSV,SPGL,ITYP,LC1,LC2,LC3,LB,LH,DEL1V,              
     +DEL2V,DEL3V,DEL1H,DEL2H,DEL3H,NSEC,NUMROW,NUMCOL,NUMROB,NUMCOB,
     +OSDV,OSDH,SP,MXPEAK,SMHPK,DMPK,LPKST,NMHPK,NDPK,INCHES,ICRD,SPG
      ITYPP=ITYP      ! FOR COMMON BLOCK
      if(spgl.eq.' ')then
      IS4=SPG               ! SPACE GROUP NUMBER FOR SYMM AND SPACE
      else
      is4=sgsv                ! bjw sept 10 87
      endif                   ! want SPECIAL space group
      IF(IS1.EQ.1)IS4=SPG       ! PATTERSON     BJW 10/16/87
C     WRITE(3,8009)IS4,SPG,SGSV,SPGL
C8009  FORMAT('  IS4=',I3,'  SPG=',I4,'  SGSV=',I4,'  SPGL=',A)
C     WRITE(3,3001)IS4,SPGL          ! PEAK LIST
C3001  FORMAT('  IN FPEAKR3 IS4=',I3,' SPGL=',A)
      IF(IS1.EQ.6)THEN
      SMHPK=CSMHPK
      DMPK=CDMPK       ! GET THESE FROM COMMON
      LPKST=CLPKST     ! SIGNAL TP PRINT SECTION BY SECTION PEAKS
C     WRITE(3,4000)LPKST
4000  FORMAT('   LPKST SIGNAL TO PRINT =',I3)
      ICRD=CICRD
      LSTO=CLSTO
      mxpeak=1          ! set this here  did not come from setcal
      NMHPK=CNMHPK
      NDPK=CNDPK
C      IF IS1=6 THIS IS STAND ALONE PEAK LIST AND THE PATTERSON SIGNAL
C       IS LOST. SO TRY TO FIND OUT IF THIS WAS A PATTERSON.
      IF (SPG.LT.SGSV)THEN          ! PROBABLY A PATTERSON
      IS4=SPG       ! KEEP THE SPACE GROUP NUMBER USED BY FOURIER
      SL=' '
      ENDIF
      IF(SPG.EQ.SGSV)SL=SPGL
      ELSE
      CICRD=ICRD           ! FOR COMMON BLOCK
      ENDIF
      IF(NDPK.EQ.0.0)NDPK=0.1             ! DEFAULT
      IF(DMPK.EQ.0.0)DMPK=0.1             ! DEFAULT
      MAXSYM=50
       MI=NUMCOL
       MJ=NUMROW
C             NOW CALCULATE 2 EXTRA ROWS AND COLS FOR EDGES
      MMI=MI-2
      MMJ=MJ-2
      LCN=LC2             ! FOR SORTPK
      LD(LC1)=DEL1V                  ! SECTION
      LD(LC2)=DEL2V                   !VERTICAL
      LD(LC3)=DEL3H                       ! HORIZONTAL
      I42=0
      IF(ICRD.NE.0)THEN
        NFILE(NAMLEN+1:NAMLEN+4)='.PKL'
        OPEN(NAME=NFILE,UNIT=42,TYPE='NEW',FORM='FORMATTED',
     1  BLOCKSIZE=32768)
        I42=1
      ENDIF
C  OPENING PKL FILE TO WRITE COORDS OF PEAKS
C     WRITE(3,2000)SPG,ITYP,MXPEAK,DMPK,SMHPK,LD(LC1),LD(LC2),LD(LC3),SP
      IF(IS1.EQ.6)THEN
      WRITE(3,2000)SPG,SL
2000    FORMAT('0 PEAK LIST OF SPACE GROUP ',I4,A1)    ! SAME PAGE
      ELSE
      IF(IS1.NE.1)THEN
      WRITE(3,2002)SGSV,SPGL
      ELSE
      WRITE(3,2003)
2002    FORMAT('0 PEAK LIST OF SPACE GROUP ',I4,A1)    ! NEW PAGE
2003    FORMAT('0 PEAK LIST  ')   ! NEW PAGE
      ENDIF
      ENDIF
C2001    FORMAT('  ',A,4X,A,/:,'  STARTING POINT IS ',3F8.5)
      DO II=1,3
      IF(DELH(II).GE.0.0)THEN
      DH(II)=DELH(II)
      SDH(II)='+'
      ELSE
      SDH(II)='-'
      DH(II)=ABS(DELH(II))
      ENDIF
      IF(DELV(II).GE.0.0)THEN
      DV(II)=DELV(II)
      SDV(II)='+'
      ELSE
      DV(II)=ABS(delv(ii))
      SDV(II)='-'
      ENDIF
      ENDDO
C     WRITE(3,2001)(SP(JJ),SDv(JJ),DV(JJ),SDH(JJ),DH(JJ),JJ=1,3)
2001  FORMAT( '0  TO FIND THE COORDINATES OF A POINT ON ROW r AND',
     + ' COLUMN c (ROWS AND COLUMNS BEING NUMBERED FROM ZERO)',
     + ' USE:',//,'  X(r,c) = ',f8.5,1X,A,f8.5,' *r ',1X,A,f8.5,' *c '/,
     +            '  Y(r,c) = ',f8.5,1X,A,f8.5,' *r ',1X,A,f8.5,' *c '/,
     +            '  Z(r,c) = ',f8.5,1X,A,f8.5,' *r ',1X,A,f8.5,' *c')
c      IF(ICRD.EQ.1)WRITE(3,2991)    !kaf 4/93 per wps
2991  FORMAT(' COORDINATES OF PEAKS WILL BE LISTED IN A PKL FILE.')
      if (ITYP.EQ.2)THEN               ! THIS FOR 
      PXYZ(3)=XYZ(LC1)             ! SECTION OF CONSTANT X,Y, OR Z
      PXYZ(2)=XYZ(LC2)          ! X,Y, OR Z CON. HORIZ.
      PXYZ(1)=XYZ(LC3)
      ELSE
C      PXYZ(1)=XYZ(LC1)      ! X,Y OR Z CON HORIZ. OR SECTION DOWN X,Y,Z
C      PXYZ(2)=XYZ(LC2)
C     PXYZ(3)=XYZ(LC3)                ! TO IDENTIFY PEAK COORDINATES
C     WRITE(3,9001)PXYZ
C9001  FORMAT(' PXYZ=',3X,A1,3X,A1,3X,A1)
      ENDIF
C     IF (MXPEAK.NE.0)GO TO 1405
C     IF (JCM.GT.NMPS)GO TO 25  
C      DO JSC=1,NSEC-1                         ! JSC+1=SECTION NUMBER
C       READ(KT)          READ COL MARKER RECORD
C       READ(KT)           READ ROW COL MARKER
C     DO J=1,MJ                                      
C     READ (KT)                                    
C     ENDDO
C     ENDDO
C     GO TO 23                                                          00000610
1405  IF(ITYP.EQ.1)THEN
      C2=1.0                    ! GENERAL PLANE               
      C3=1.0                                                            00000640
      ELSE
      C1=LD(LC1)
      C2=LD(LC2)       !  LD,LB,LH ARE NOW REAL NUMBERS         
      C3=LD(LC3)                                        
      D1=LB(LC1)         ! STARTING VALUE FOR SECTION
      D2=LB(LC2)                                                        00000680
      D3=LB(LC3)                                                        00000690
      RLY=LB(LC1)+C1    ! NOW CALCULATE EXTRA SECTION BEFORE 1ST                                             
      RDY=LD(LC1)         ! 1ST DIM IS CONSTANT FOR A SECTION 
C     WRITE(3,2009)LC1,LD(LC1),RLY,RDY
C009  FORMAT('  LD(',I2,')=',F6.4,' RLY=',F6.4,' RDY=',F6.4)
      ENDIF
C     TEST MAP SIZE                                                     00000790
      IF (MJ.GT.203)GO TO 500
      IF(MI.GT.203)GO TO 500
      IF(SMHPK.NE.0.0)THEN
      NMAX=SMHPK+.5             ! DOING POSITIVE PEAKS
      DMS=DMPK*DMPK
      IF(NMHPK.NE.0.0)NEG=1     ! BOTH POS AND NEG PEAKS
        ELSE
       IF(NMHPK.NE.0.0)NMAX=ABS(NMHPK)+.5           ! DO NEGATIVE PEAKS
       DMS=NDPK*NDPK               ! MIN DISTANCE FOR NEGATIVE PEAKS
      NEG=99                ! DO ONLY NEGATIVE PEAKS
       IF(NMHPK.EQ.0.0)THEN                   ! ALLDONE
       WRITE(3,5000)
5000     FORMAT('  NO MINIMUM HEIGHT FOR PEAKS IS GIVEN')
      GO TO 25                ! RETURN
       ENDIF
      ENDIF
      IF(ITYP.EQ.1)THEN    !kaf
c      WRITE(3,2007)MI,MJ   !4/93
        NSS=2                !per
      ELSE                 !wps
c      WRITE(3,2007)MMI,MMJ !to eliminate extra lines
        NSS=3            ! FOR THREE DIM
      ENDIF
2007    FORMAT('0  MAP HAS ',I4,' COLUMNS AND ',I4,' ROWS')
C     INITIALIZE                                                        00000850
      IF(NMHPK.NE.0.0)THEN     ! DOING NEGATIVE PEAKS
        NGMX=ABS(NMHPK)+.5    ! NEGATIVE MINIMUM HEIGHT
        NGMX=-NGMX
        IF(NEG.EQ.99)THEN    ! ONLY NEGATIVE PEAKS        
2010      FORMAT('   NEGATIVE MINIMUM HEIGHT = ',I5)
          WRITE(3,2010)NGMX
        ELSE
          WRITE(3,2009)NMAX,NGMX
        ENDIF
      ELSE
        WRITE(3,2009)NMAX
      ENDIF
2009  FORMAT('   MIN PEAK HEIGHT =',I5,:,'  NEGATIVE MIN PEAK HEIGHT =',
     +I5)
      NS=2      ! LOOK FOR PEAKS ON THE MIDDLE SECTION, INIT AT 2
      IF(ITYP.NE.3)NSS=2
      COSA=COS(ANG(1)*XAR)                        
      COSB=COS(ANG(2)*XAR)                                   
      COSC=COS(ANG(3)*XAR)                             
      SINC=SIN(ANG(3)*XAR)                                
      SIND=(COSB-COSA*COSC)/SINC                                        00000910
      R1=CEL(1)*SINC                                                    00000920
      R2=CEL(3)*SIND                                                    00000930
      R3=CEL(1)*COSC                                                    00000940
      R4=CEL(3)*COSA                                                    00000950
      R5=CEL(3)*SQRT(1.0-COSA*COSA-SIND*SIND)                           00000960
      R6=CEL(2)                                                         00000970
C     IF(DMPK.EQ.0.0)DMPK=0.1          ! DEFAULT MIN DISTANCE BETWEEN
C     DMS=DMPK*DMPK                    ! PEAKS       
      AM(1,1)=CELL(1)*CELL(1) 
      AM(2,2)=CELL(2)*CELL(2)
      AM(3,3)=CELL(3)*CELL(3)
      AM(1,2)=0.0                                                            173
      IF(CELL(6).NE.90.0)THEN
      AM(1,2)=CELL(1)*CELL(2)*COS(ANG(3))             
      ELSE
      AM(2,1)=AM(1,2)                                    
      ENDIF
      AM(1,3)=0.0                                                            177
      IF(CELL(5).NE.90.0)THEN
      AM(1,3)=CELL(1)*CELL(3)*COS(ANG(2))
      ELSE
      AM(3,1)=AM(1,3)                      
      ENDIF
      AM(2,3)=0.0                                     
       IF(CELL(4).NE.90.0)THEN
      AM(2,3)=CELL(2)*CELL(3)*COS(ANG(1))
      ELSE
      AM(3,2)=AM(2,3)                                
      ENDIF
      DO I=1,3                                                            185
      DO J=1,3                                                             186
      DC(I,J)=0.0                                                            187
      DC(I,I)=1.0                                          
      ENDDO
      ENDDO
      CALL AXEQB(AM,AR,DC,3)                                     
C          CALL SYMM          SPG,SPGL
c      MSYM=500
      ASP=SPGL
      IF(SPG.LT.SGSV.AND.IS1.EQ.6)ASP=' ' ! PATTERSON
C       SEND MIN AND MAX VALUES OF X,Y,Z TO SYMM
      X(1)=LB(1)-(2*LD(LC1))
      X(2)=LH(1)+(2*LD(LC1))
      Y(1)=LB(2)-(2*LD(LC2))
      Y(2)=LH(2)+(2*LD(LC2))
      Z(1)=LB(3)-(2*LD(LC3))
      Z(2)=LH(3)+(2*LD(LC3))
      ADMX=1.1         ! DISTANCE
      
      CALL FSYMM(X,Y,Z,NA,ADMX,NSYM,AM,AR,MSYM,ASP)     
       ISYM=NSYM
      NPRNT=NSYM
      IF(NSYM.GT.MAXSYM) NPRNT=MAXSYM
    	IER=SYS$ASCTIM(,DIN,,)
c      WRITE (3,110) DIN,NAMEX                                           00001010
c      WRITE(3,136)
  136 FORMAT('0',20X,18HSYMMETRY RELATIONS/)                     
c      DO J=1,NPRNT
c      WRITE(3,131)J,SA(J),SB(J),SC(J),SD(J),SE(J),SF(J),SG(J),SH(J),
c     +SPS(J),SQ(J),RR(J),SS(J)
c131   FORMAT(I6,12F6.2)                                        
c      ENDDO
c      WRITE(3,9251)NSYM,NPRNT
c9251  FORMAT(5X,I3,' SYMMETRY RELATIONS HAVE BEEN CALCULATED.',I4,
c     1' OF THEM HAVE BEEN PRINTED.')
c        xyz are the indices of peaks
         write(3,1000)        ! insert one blank line
 3010 ISPEC=0                                                           00001050
      ISPEK=0                    ! FOR COMPOSITE SIGNAL
      IF(ITYP.EQ.3)THEN    ! 3 DIMENSIONAL MAP
      DO K=1,2             ! READ IN 1ST TWO SECTIONS
      read(kt)               ! get rid of col markers
      READ(KT)               ! AND ROW MARKERS
      DO J=1,MJ                                     
      READ (KT) (IA(I,J,k),I=1,MI)                       
      IF(NEG.EQ.99)THEN      ! 99 MEANS DOING NEGATIVE PEAKS
      DO I=1,MI              ! ONLY. NO POSITIVE PEAKS.
      IA(I,J,K)=-IA(I,J,K)          
      ENDDO
      ENDIF
      ENDDO
      enddo            ! end of section loop
      ENDIF           ! END OF 3-DIMENSIONAL ONLY IF
      REWIND JT                                   
C     WRITE(50,5000)MJ,MI
C5000  FORMAT('  IN FPEAKR3 MJ=',I4,'  AND MI=',I4)
      IF(ITYP.NE.3)NSEC=3         ! ONLY DO ONCE
      IF(NEG.EQ.9)NEG=1            ! DO POSITIVE PEAKS FIRST
C     CYCLE OVER SECTIONS                                               00000770
      DO 22 JSC=1,NSEC-2             ! JSC+1=CURRENT SECTON NUMBER  
      DO ITO=1,500
      TFL(ITO)=' '
      OV(ITO)=' '
      NOV(ITO)=' '
      ENDDO
      LPR=78                                                            00001090
      NPR=0                                                             00001100
      NPKS=0                                                            00001110
      IMATCH=0                                                          00001120
      NMT=0                                                             00001130
C     READ MAP FROM SEQUENTIAL FILE                                     00001150
      read(kt)               ! get rid of col markers
      READ(KT)               ! AND ROW MARKERS
      DO J=1,MJ                                     
        READ (KT) (IA(I,J,NSS),I=1,MI)       ! READ IN NEXT SECTION 
        IF(NEG.EQ.99)THEN            ! NEGATIVE PEAKS ONLY
          DO I=1,MI
            IA(I,J,NSS)=-IA(I,J,NSS)    ! CHANGE SIGN OF 3RD SECTION
          ENDDO
        ENDIF
      ENDDO                    ! this is 3rd of 3 sections
      IF (ITYP.NE.1)THEN    
        FTE=RLY                                                            00001200
        PT(LC1)=FTE                                                       00001220
C       WRITE(3,2010)LC1,PT(LC1),LC2,LC3,FTE
C2010   FORMAT(' PT(',I1,') ,LC2,LC3=',F4.2,2I2,'  FTE=',F7.4)
        RLY=RLY+RDY                                                        
      ENDIF
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                        BEGIN LOOP OVER MAP                          C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
7000  ns=2              ! for reading middle section
      DO 20 J=2,MJ-1      ! have calculated an extra column on each edge
      DO 21 I=2,MI-1      ! and an extra row    
      NUM=IA(I,J,NS)             !  ns=2 to read middle of 3   
      IF(NUM.LT.NMAX)GO TO 21
      KNUM=NUM                                                          00001280
8080  FORMAT(' LOOKING AT MAP, KNUM=',I5,'  KI,KJ=',2I3)
      KI=I                                                              00001290
      KJ=J                                                              00001300
C     WRITE(3,8080)KNUM,KI,KJ
      IF(I.LT.MI-1)THEN
      IF(IA(I+1,J,NS).GT.KNUM)THEN
   16 KNUM=IA(I+1,J,ns)                                         
      KI=I+1                                                            00001340
C     WRITE(3,8016)KNUM,KI,KJ
8016  FORMAT('  AT 16 KNUM=',I5,'  KI,KJ=',2I3)
      ENDIF
14    IF(I.LE.1)GO TO 10        ! WANT TO SEE IF I=1
      ENDIF
      IF(IA(I-1,J,ns).LE.KNUM)GO TO 10                          
      KNUM=IA(I-1,J,ns)                                        
      KI=I-1                                                            00001380
10    if(j.ge.mj-1)go to 11     ! J ON EDGE
6      IF(IA(I,J+1,NS).GT.KNUM)THEN
      KNUM=IA(I,J+1,NS)
      KI=I
      KJ=J+1
      ENDIF
       IF(IA(I+1,J+1,NS).GT.KNUM)THEN
      KNUM=IA(I+1,J+1,NS)
      KI=I+1
      KJ=J+1
      ENDIF
       IF(IA(I-1,J+1,NS).GT.KNUM)THEN
      KNUM=IA(I-1,J+1,NS)
      KI=I-1
      KJ=J+1
      ENDIF
11     if(j.le.1)go to 14      ! SEE IF PEAK IS OUTSIDE THIS MAP
7      IF(IA(I,J-1,NS).GT.KNUM)THEN
       KNUM=IA(I,J-1,NS)
       KI=I
       KJ=J-1
       ENDIF
      IF(IA(I-1,J-1,NS).GT.KNUM)THEN
      KNUM=IA(I-1,J-1,NS)
      KI=I-1
      KJ=J-1
      ENDIF
      IF(IA(I+1,J-1,NS).GT.KNUM)THEN
      KNUM=IA(I+1,J-1,NS)
      KI=I+1
      KJ=J-1
      ENDIF
C     WRITE(3,800)KNUM,KI,KJ,JSC,NUM
        if(knum.le.num)go to 59
800   FORMAT('  KNUM=',I5,'  KI,KJ=',2I4,'   JSC=',I3,' NUM=',I5)
C     TEST NEXT HIGHEST PEAK                                             00001510
      JI=KI                                                             00001530
      JJ=KJ                                                             00001540
      JNUM=IA(JI,JJ,NS)                                    
100   IF(KI.GE.MI-1)GO TO 42
40    IF(IA(KI+1,KJ,NS).GT.JNUM)THEN
      JNUM=IA(KI+1,KJ,NS)
      JI=KI+1
      ENDIF
      IF(KJ.GE.MJ-1)GO TO 42
      IF(IA(KI+1,KJ+1,NS).GT.JNUM)THEN
      JNUM=IA(KI+1,KJ+1,NS)
      JI=KI+1
      JJ=KJ+1
      ENDIF
42     IF(KI.LE.1)GO TO 45
C  43 IF (IA(KI-1,KJ,NS)-JNUM) 45,45,44                  
43    IF(IA(KI-1,KJ,NS).GT.JNUM)THEN
      JNUM=IA(KI-1,KJ,NS)
      JI=KI-1
      ENDIF
      IF(KJ.LE.1)GO TO 45
      IF(IA(KI-1,KJ-1,NS).GT.JNUM)THEN
      JNUM=IA(KI-1,KJ-1,NS)
      JI=KI-1
      JJ=KJ-1
      ENDIF
45     IF(KJ.GE.MJ)GO TO 48
   46 IF (IA(KI,KJ+1,NS)-JNUM) 48,48,47                   
   47 JNUM=IA(KI,KJ+1,NS)                              
      JJ=KJ+1                                                           00001670
      JI=KI                                                             00001680
48    IF(KJ.LE.1)GO TO 51
   49 IF (IA(KI,KJ-1,NS)-JNUM) 51,51,50                       
   50 JNUM=IA(KI,KJ-1,NS)                                    
      JJ=KJ-1                                                           00001720
      JI=KI                                                             00001730
   51 IF (JNUM-KNUM) 59,59,52                                           00001740
   52 KNUM=JNUM                                                         00001750
      KI=JI                                                             00001760
      KJ=JJ                                                             00001770
      GO TO 100                                                         00001780
59     IF(KI.LE.1.OR.KI.GE.MI)GO TO 21        ! PEAK IS OUTSIDE MAP
      IF(KJ.LE.1.OR.KJ.GE.MJ)GO TO 21         ! PEAK OUTSIDE MAP
      IF(NPR.LT.1)GO TO 62
   60 DO 99 L=1,NPR                                                     00001800
      IF (KI-IPR(L)) 99,61,99                                           00001810
   61 IF (KJ-JPR(L)) 99,21,99              !ALREADY HAVE THIS ONE       00001820
   99 CONTINUE                                                          00001830
   62 NPR=NPR+1                                                         00001840
      IPR(NPR)=KI                                                       00001850
      JPR(NPR)=KJ                                                       00001860
C     WRITE(3,8081)NPR,KNUM,KI,KJ
8081  FORMAT(' BEFORE 64 NPR=',I4,' KNUM=',I5,'  KI, KJ=',2I3)
64    IF(KI.GE.MI)THEN          
      IERR=1
      WRITE(3,900)KI
900   FORMAT('  POINT ON EDGE INDEX=',I4)
      GO TO 80               ! AN EDGE
      ENDIF
      IF(KI.LE.1)THEN
      IERR=1
      WRITE(3,900)KI
      GO TO 80
      ENDIF
C  32 IF (KJ-MJ) 33,80,80                                               00001890
       IF(KJ.GE.MJ)THEN
       IERR=1
       WRITE(3,900)KJ
       GO TO 80
       ENDIF
      IF(KJ.LE.1)THEN
      IERR=1
      WRITE(3,900)KJ
      GO TO 80
      ENDIF
C     LOOK ONE SECTION DOWN AND ONE SECTION UP
34    IF(ITYP.NE.1)THEN             !     THIS MAY BE 3DIM
      IF(NSEC.GT.3)THEN             ! THIS IS NOT SECTION OR PROJECTION
      IF(IA(KI,KJ,NS+1).GT.IA(KI,KJ,NS))GO TO 21    ! SKIP IT
      IF(IA(KI+1,KJ,NS+1).GT.IA(KI,KJ,NS))GO TO 21
      IF(IA(KI,KJ+1,NS+1).GT.IA(KI,KJ,NS))GO TO 21
      IF(IA(KI-1,KJ,NS+1).GT.IA(KI,KJ,NS))GO TO 21
      IF(IA(KI,KJ-1,NS+1).GT.IA(KI,KJ,NS))GO TO 21
      IF(IA(KI,KJ,NS-1).GT.IA(KI,KJ,NS))GO TO 21    ! SKIP IT
      IF(IA(KI,KJ-1,NS-1).GT.IA(KI,KJ,NS))GO TO 21   ! SKIP IT
      IF(IA(KI-1,KJ,NS-1).GT.IA(KI,KJ,NS))GO TO 21   ! SKIP IT
      IF(IA(KI+1,KJ,NS-1).GT.IA(KI,KJ,NS))GO TO 21
      IF(IA(KI,KJ+1,NS-1).GT.IA(KI,KJ,NS))GO TO 21
      ENDIF
      R(1)=IA(KI,KJ,NS)              ! 000 KI IS COLS, KJ IS ROWS
      R(2)=IA(KI,KJ+1,NS)            ! 100  1 DOWN
      R(3)=IA(KI,KJ-1,NS)            ! -100  1 UP
      R(4)=IA(KI+1,KJ,NS)            ! 010  1 TO THE RIGHT
      R(5)=IA(KI-1,KJ,NS)            ! 0-10  1 TO THE LEFT
      R(6)=IA(KI,KJ,NS+1)            ! 001     NEXT SECTION
      R(7)=IA(KI,KJ,NS-1)            ! 00-1    previous SECTION
      R(8)=IA(KI+1,KJ+1,NS)          ! 110    RIGHT DOWN CORNER
      R(9)=IA(KI-1,KJ+1,NS)          ! 1-10   LEFT DOWN CORNER
      R(10)=IA(KI+1,KJ-1,NS)         ! -110   RIGHT UP CORNER
      R(11)=IA(KI-1,KJ-1,NS)         ! -1-10   LEFT UP CORNER
      R(12)=IA(KI,KJ+1,NS+1)         ! 101
      R(13)=IA(KI,KJ+1,NS-1)         ! 10-1
      R(14)=IA(KI,KJ-1,NS+1)         ! -101
      R(15)=IA(KI,KJ-1,NS-1)         ! -10-1
      R(16)=IA(KI+1,KJ,NS+1)         ! 011
      R(17)=IA(KI+1,KJ,NS-1)         ! 01-1
      R(18)=IA(KI-1,KJ,NS+1)         ! 0-11
      R(19)=IA(KI-1,KJ,NS-1)         ! 0-1-1
      IF(NSEC.GT.3)THEN
       DO IRP=2,19
       IF(R(IRP).GT.R(1))GO TO 21           ! SKIP IT THIS IS NOT A PEAK
       ENDDO
      ENDIF
      ELSE                       ! THIS IS GENERAL PLANE
      IF(KJ.LE.1)THEN
      IERR=8
      GO TO 8000
      ENDIF
      RI=KI-1                                                           00001910
      RJ=KJ-1                                                           00001920
      s(1,6)=IA(KI,KJ,NS)                                                  00001930
      DO IX=1,5
      S(IX,5)=1.0
      ENDDO
      S(1,4)=C3*RI           !   C3=HORIZ.INCREMENT                  
      S(1,3)=S(1,4)*S(1,4)                                              00001970
      S(1,2)=C2*RJ          ! C2=VERTICAL INCREMENT
      S(1,1)=S(1,2)*S(1,2)                                              00001990
      RI=KI-2                                                           00002000
      S(2,6)=IA(KI-1,KJ,NS)                                                00002010
      S(2,4)=C3*RI                                                      00002020
      S(2,3)=S(2,4)*S(2,4)                                              00002030
      S(2,2)=C2*RJ                                                      00002040
      S(2,1)=S(2,2)*S(2,2)                                              00002050
      RI=KI                                                             00002060
      S(3,6)=IA(KI+1,KJ,NS)                                                00002070
      S(3,4)=C3*RI                                                      00002080
      S(3,3)=S(3,4)*S(3,4)                                              00002090
      S(3,2)=C2*RJ                                                      00002100
      S(3,1)=S(3,2)*S(3,2)                                              00002110
      RI=KI-1                                                           00002120
      RJ=KJ-2                                                           00002130
      S(4,6)=IA(KI,KJ-1,NS)                                                00002140
      S(4,4)=C3*RI                                                      00002150
      S(4,3)=S(4,4)*S(4,4)                                              00002160
      S(4,2)=C2*RJ                                                      00002170
      S(4,1)=S(4,2)*S(4,2)                                              00002180
      RJ=KJ                                                             00002190
      S(5,6)=IA(KI,KJ+1,NS)                                                00002200
      S(5,4)=C3*RI                                                      00002210
      S(5,3)=S(5,4)*S(5,4)                                              00002220
      S(5,2)=C2*RJ                                                      00002230
      S(5,1)=S(5,2)*S(5,2)                                              00002240
      ENDIF
      IF(ITYP.EQ.1)THEN
      CALL SOLVG(S,IERR)
8000  IF(IERR.NE.0.OR.D.lt.0.0000001.or.a.lt.0.0000001)THEN
      RI=KI-1                                                           00002300
      RJ=KJ-1                                                           00002310
      HOR=C2*RJ                                                         00002320
      VER=C3*RI                                                         00002330
      HEIGHT=KNUM                                                       00002340
      ta='*'       ! general plane interpolation failed
      ELSE
      HOR=-B/(2*A)                                                      00002360
      VER=-E/(2*D)                                                      00002370
      HEIGHT=A*HOR**2+B*HOR+D*VER**2+E*VER+C                            00002380
      ENDIF
      DO IXX=1,3                                                
      PT(IXX)=DELH(IXX)*VER+DELV(IXX)*HOR+SP(IXX)                       00002410
      ENDDO
      GO TO 4230                                                        00002420
      ELSE
      CALL SOLVN(R,IERR)                                                00002280
      RI=KI-1
      RJ=KJ-1
      RS=JSC                   ! CURRENT SECTION -1
      IF(IERR.EQ.0)THEN
      PT(LC1)=(SVZ*C1)+(RS*C1)+D1
      PT(LC2)=(SVX*C2)+(RJ*C2)+D2                       ! VERT.
      PT(LC3)=(SVY*C3)+(RI*C3)+D3                      ! HORIZ.
      HEIGHT=RH                     ! MAX PEAK HEIGHT 
      ELSE
80    PT(LC2)=(C2*RJ)+D2               ! calculations for
      PT(LC3)=(C3*RI)+D3               ! coordinates of peak
      PT(LC1)=(C1*RS)+D1
      HEIGHT=KNUM          ! point is on edge or solvn routine failed
C     write(3,8003)height,knum,r
C8003  format('  height=',f12.3,'  knum=',i6,'  R=',9(F8.2),/,
C    +4X,10F8.2)
      TA='*'             ! SIGNAL THAT MAX HEIGHT ROUTINE FAILED
      PRTM=9           ! PRINT EXPLANATION OF *
      ENDIF               ! PUT IN IERR=1 VALUES FOR PT
      ENDIF          
 4230 NPKS=NPKS+1                                                       00002480
      IF(NPKS.GT.IPKMX)THEN  ! TOO MANY PEAKS, PRINT MESSAGE
 4320 WRITE (3,114)                                                     00002430
      NPKS=NPKS-1                                                       00002440
      GO TO 4250                                                        00002450
      ENDIF
      IF(NEG.LT.9)THEN           ! NEG=0  POSITIVE ONLY
      PX(NPKS)=PT(1)             ! NEG=1  POS AND NEG     
      IF(PX(NPKS).GT.1.0)PX(NPKS)=PX(NPKS)-1.0
      PY(NPKS)=PT(2)                                       
      IF(PY(NPKS).GT.1.0)PY(NPKS)=PY(NPKS)-1.0
      PZ(NPKS)=PT(3)                                      
      IF(PZ(NPKS).GT.1.0)PZ(NPKS)=PZ(NPKS)-1.0
      IPC(NPKS)=0                                                       00002530
      PH(NPKS)=HEIGHT                                                   00002540
      IF(KNUM.EQ.9999)OV(NPKS)='O'   ! OVERFLOW
C     IF(KNUM.EQ.9999)WRITE(3,8001)KNUM,NPKS
C8001   FORMAT('  KNUM=',I6,'  NPKS=',I4)
      IF(PH(NPKS).GT.9999.)OV(NPKS)='O'  ! OVERFLOW
C     IF(PH(NPKS).GT.9999.)WRITE(3,8002)PH(NPKS),NPKS
C8002   FORMAT('  PH=',F10.3,'  NPKS=',I4)
      TFL(NPKS)=TA   
      TA=' '           ! SET TO BLANK
      ELSE                   ! NEGATIVE PEAKS NEG=9 OR 99
      NPX(NPKS)=PT(1)        ! NEG=99 MEANS NEG PEAKS ONLY
      IF(NPX(NPKS).GT.1.0)NPX(NPKS)=NPX(NPKS)-1.0
      NPY(NPKS)=PT(2)                                       
      IF(NPY(NPKS).GT.1.0)NPY(NPKS)=NPY(NPKS)-1.0
      NPZ(NPKS)=PT(3)                                      
      IF(NPZ(NPKS).GT.1.0)NPZ(NPKS)=NPZ(NPKS)-1.0
      NIPC(NPKS)=0                                                       00002530
      NPH(NPKS)=HEIGHT                                                   00002540
      IF(KNUM.EQ.9999)NOV(NPKS)='O'    ! OVERFLOW
      IF(HEIGHT.GT.9999.)NOV(NPKS)='O'  ! ALSO OVERFLOW
      NTFL(NPKS)=TA   
      TA=' '               ! RESET TA TO BLANK
      ENDIF                !  HAVE JUST FINISHED NEG
   21 CONTINUE              ! END OF ROW    00002550
   20 CONTINUE              ! END OF SECTION    00002560
C     HAVE ALL PEAKS THIS SECTION                                       00002580
4250     CONTINUE
 4251 IXX=NPKS-1                                                        00002610
C     IF (IXX) 4326,3310,4252                                           00002620
      IF(IXX.LT.0)THEN
        IF(ITYP.NE.3)GO TO 523   ! NO PEAKS, ALL DONE
        WRITE(JT)PX,PY,PZ,PH,TFL,OV,NPKS,NG   ! WRITE 0  RECORD FOR NO PEAKS
      ELSE                        ! THERE IS AT LEAST ONE PEAK
C     SORT BY SIZE                                                      00002640
140     if(neg.LE.1)then       ! NEG=0 FOR ALL POS. NEG=1 FOR POS NOW
          IF(NPKS.GT.1)call SORTPK(NPKs,PX,PY,PZ,PH,ipc,TFL,OV)
C         PRINT AS REQUIRED                         
          CALL prntpk(px,py,pz,ph,ipc,npks,TFL,ov)
        ELSE    ! HERE FOR NEG=9 OR NEG=99 9FOR NOW AND 99 FOR ALL NEG
          IF(NPKS.GT.1)CALL SORTPK(NPKS,NPX,NPY,NPZ,NPH,NIPC,NTFL,OV)
          CALL prntpk(NPX,NPY,NPZ,NPH,NIPC,NPKS,NTFL,ov)
        ENDIF
      ENDIF
      IF(NMHPK.NE.0.0)THEN      ! WE WANT TO FIND NEGATIVE PEAKS
      IF(NEG.EQ.1)THEN          ! HAVE JUST FINISHED POS PEAKS
      NMAX=ABS(NMHPK)+.5        ! NEGATIVE PEAK MIN                
      DPK=DMPK                  ! SAVE POSITIVE PEAK DISTANCE
      DMSV=DMS                  ! SAVE POS DMS
      DMPK=NDPK
      DMS=DMPK*DMPK
      NEG=9                      ! GO GET NEGATIVE PEAKS
      DO K=1,3
      DO J=1,MJ
      DO I=1,MI
      IA(I,J,K)=-IA(I,J,K)
      ENDDO
      ENDDO
      ENDDO
      GO TO 7000            ! REDO SECTION FOR NEGATIVE PEAKS
      ELSE               !  NEG.NE.1
      IF(NEG.EQ.9)THEN
      DO NJ=1,MJ
      DO NI=1,MI
      IA(NI,NJ,2)=-IA(NI,NJ,2)    ! SET FOR POSITIVE PEAKS
      IA(NI,NJ,3)=-IA(NI,NJ,3)    ! 2,3 WILL BE 1,2 OF NEXT SECTION
      ENDDO
      ENDDO
      NMAX=SMHPK+.5         ! POSITIVE MIN. HEIGHT
      DMS=DMSV
      DMPK=DPK
      NEG=1                 ! SET SIGNAL TO DO POSITIVE PEAKS
      ENDIF                     ! 
      ENDIF
      ENDIF
       DO NJ=1,MJ          ! MOVE CURRENT SECTION BACK ONE
       DO NI=1,MI         
       IA(NI,NJ,1)=IA(NI,NJ,2)
       IA(NI,NJ,2)=IA(NI,NJ,3)  ! AND MOVE SECTION ABOVE TO CURRENT
       ENDDO
       ENDDO
   22 CONTINUE                                                          00004050
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C     HAVE SECTION BY SECTION LISTINGS                                 C
C     MAKE COMPOSITE                                                   C00004090
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      IF(ITYP.LT.3)GO TO 523        ! NO COMPOSITE FOR GEN PLANE 
       LPKST=0         ! SECTION BY SECTION LISTINGS ARE DONE
      NPKS=0                                                            00004000
      npkn=0        ! composite count of negative peaks
      ISPEK=1          ! COMPOSITE SIGNAL      
      KI=0                                                              00004130
      JI=0               !COUNT OF READS FROM JT            
      IF(NEG.EQ.0.OR.NEG.EQ.99)THEN
      NSCM2=NSEC-2       ! NUMBER OF SECTIONS LEFT
      ELSE
      NSCM2=2*(NSEC-2)   ! HAVE BOTH NEG AND POS PEAKS ON JT
      ENDIF
      REWIND JT                                                         00004150
C           START READING PEAKS OFF DISK FOR COMPOSITE
 4390 READ (JT) APX,APY,APZ,APH,ATFL,AOV,NP,NG                       
C     WRITE(3,8008)(ATFL(IKK),IKK=1,50)
C8008  FORMAT(1X,'ATFL=',50A1)
      JI=JI+1       ! COUNT OF RECORDS READ FROM JT        
      IF(NP.EQ.0)GO TO 4409     ! NO PEAKS THIS RECORD
      MA=1                                                              00004180
4400  IF(NP.GT.0)THEN          ! RECORD OF POSITIVE PEAKS
      DO J=MA,NP                                       
      IF(NPKS.GE.IPKMX)THEN
      WRITE(3,114)
      ELSE
      NPKS=NPKS+1
      ENDIF
      PX(NPKS)=APX(J)                                                   00004210
      PY(NPKS)=APY(J)                                                   00004220
      PZ(NPKS)=APZ(J)                                                   00004230
      PH(NPKS)=APH(J)                                                   00004240
      TFL(NPKS)=ATFL(J)              ! SO COMPOSITE LISTING HAS
      OV(NPKS)=AOV(J)
      IPC(NPKS)=0                    ! CORRECT *'S AND A'S  
      ENDDO
      ENDIF
      IF(NP.LT.0)THEN
      NNP=IABS(NP)
      DO J=MA,NNP
      IF(NPKN.GE.IPKMX)THEN
      WRITE(3,114)
      ELSE
      IF(NPH(NPKN).NE.0.0)NPKN=NPKN+1
      ENDIF
      NPX(NPKN)=APX(J)
      NPY(NPKN)=APY(J)
      NPZ(NPKN)=APZ(J)
      NPH(NPKN)=APH(J)
      NTFL(NPKN)=ATFL(J)       ! NEGATIVE TFL SIGNALS
      NOV(NPKN)=AOV(J)
      NIPC(NPKN)=0
      ENDDO
      ENDIF
4409  IF(JI.LT.NSCM2) GO TO 4390          ! ANOTHER SECTION LISTED ON JT
      ITYP=4
      ITYPP=4
C     ISPEC=1                                                           00004310
C     SORT BY SIZE                                                      00002640
      if(NPKS.GT.0)then       ! POSITIVE PEAKS
      IF(NEG.EQ.9)NEG=1
       IF(NPKS.GT.1)call SORTPK(NPKs,PX,PY,PZ,PH,ipc,TFL,OV)
C     PRINT AS REQUIRED                         
      CALL prntpk(px,py,pz,ph,ipc,npks,TFL,ov)
      ENDIF
       IF(NPKN.GT.0)THEN
      IF(NEG.EQ.1)NEG=9
      IF(NPKN.GT.1)CALL SORTPK(NPKN,NPX,NPY,NPZ,NPH,NIPC,NTFL,OV)
      CALL prntpk(NPX,NPY,NPZ,NPH,NIPC,NPKN,NTFL,ov)
       ENDIF
C       SAVE FOR OTHER PROGRAM IF REQUESTED                             00004420
  523 IF (LSTO) 1523,23,524                                             00004440
 1523 LSTO=IABS(LSTO)                                                   00004450
      IMATCH=1                                                          00004460
      NMT=IS2                                                           00004470
  524 IF(NPKS-LSTO) 525,526,526                                         00004480
  525 LSTO=NPKS                                                         00004490
  526 IF(LSTO-IPKST) 528,528,527                                        00004500
  527 LSTO=IPKST                                                        00004510
  528 DO 530 J=1,LSTO                                                   00004520
  530 IPC(J)=J                                                          00004530
      KI=1                                                              00004540
C     REWIND JT                                                         00004550
C     WRITE (JT,115)(IPC(J),J=1,LSTO)                                   00004560
      WRITE (31,115)(IPC(J),J=1,LSTO)
C     REWIND JT                                                         00004570
       REWIND 31
C     READ(JT,116)(IPC(J),J=1,LSTO)                                     00004580
       READ(31,116)(IPC(J),J=1,LSTO)
      IF (IMATCH)542,542,535                                            00004590
  535 DO 538 J=1,LSTO                                                   00004600
      YO(J)=R6*PY(J)+R3*PX(J)+R4*PZ(J)                                  00004610
      XO(J)=R1*PX(J)+R2*PZ(J)                                           00004620
  538 ZO(J)=R5*PZ(J)                                                    00004630
      DO 540 J=1,NMT                                                    00004640
      APY(J)=R6*Y(J)+R3*X(J)+R4*Z(J)                                    00004650
      APX(J)=R1*X(J)+R2*Z(J)                                            00004660
  540 APZ(J)=R5*Z(J)                                                    00004670
  542 DO 580 J=1,LSTO                                                   00004680
      IF (IMATCH) 545,570,545                                           00004690
C       MATCH WITH STORED COORDINATES                                   00004710
C       DUMMY NOW                                                       00004720
  545 IF(J-NMT) 548,548,570                                             00004740
  548 GO TO 570                                                         00004750
C       STORE NEW PEAK                                                  00004770
  570 X(J)=PX(KI)                                                       00004790
      Y(J)=PY(KI)                                                       00004800
      Z(J)=PZ(KI)                                                       00004810
      NATM(J)=IPC(J)                                                    00004820
      TQ(J)=CARD(20)                                                    00004830
      BAT(J)=4.0                                                        00004840
      KI=KI+1                                                           00004850
  580 CONTINUE                                                          00004860
      REWIND JT                                                         00004870
      REWIND 31
      IS2=LSTO                                                          00004880
   23 CONTINUE                                                          00004890
      GO TO 25                                                          00004900
  500 WRITE (3,108)                                                     00004910
   25 REWIND KT                                                         00004920
      DO I=1,500
      PX(I)=0.0
      PY(I)=0.0
      PZ(I)=0.0
      PH(I)=0.0
      NPX(I)=0.0
      NPY(I)=0.0
      NPZ(I)=0.0
      NPH(I)=0.0
      ENDDO
      NPKN=0
      NPKS=0
      IF(I42.EQ.1)CLOSE(UNIT=42,DISP='SAVE')
      IF(PRTM.EQ.9)THEN
      WRITE(3,8009)
8009  FORMAT(1X,/,'   *   PRINTED AFTER HEIGHT INDICATES THE ',
     +'INTERPOLATION ROUTINE FAILED AND,',/,
     +'      THE HEIGHT PRINTED IS THE POINT TAKEN FROM THE MAP WITH NO',
     +' INTERPOLATION CALCULATION.')
      ENDIF
      RETURN                                                            00004930
      END                                                               00004940

