C     FPLOT                                                             00000010
C     FOURIER PLOTTING PROGRAM                                          00000020
C     MAP(S) TO BE PLOTTED ARE                                          00000030
C     STORED ON SEQUENTIAL FILE                                         00000040
C     WHERE NMPS = NUMBER OF MAPS TO BE CONTOURED=IS2                   00000050
C     MAP FILE (KT) IS ASSUMED TO BE POSITIONED TO READ FIRST MAP'S     00000060
C     PARAMETER.                                                        00000070
      SUBROUTINE FPLOT(RRAY,RRAY2,NCOL,NROW,PHR,PVR)          
      DIMENSION XPAR(6),YPAR(6),PLX(800),PLY(800),XAR(10),
     1YAR(10),CARD(20),ACARD(20),DIN(5),DUM(2000),CELL(6),ANG(3),
     2MH(3),SP(3),DELH(3),DELV(3)                        
      DIMENSION TR(6)       ! FOR CONTOUR PROGRAM
      DIMENSION RRAY2(NCOL-2,NROW-2)             ! FOR CONTOUR PROGRAM
      DIMENSION RRAY(NCOL,NROW)
      INTEGER*2  IRAY(500)              ! FOR CONTOUR PROGRAM
      INTEGER*2 PHR(NCOL),PVR(NROW),SECNUM,fc,lc
      DIMENSION ACLEV(50)                  ! ARRAY FOR CONTOUR LEVELS
      CHARACTER*12 NAMEX    
        CHARACTER*1 XYZT(3)
        CHARACTER*5 HOLHKO(3)
      LOGICAL*1 CENTER,ABSXY,BRDR
      BYTE RST
      DIMENSION XBR(2),YBR(2)
	INTEGER       DEFTYP,GRDTYP,GROPEN,L,NXSUB,NYSUB,UNIT
       CHARACTER*20 DEFSTR
	REAL          DUMMY,XCHSIZ,XCSZ
      COMMON IS1,IS2,IS3,IS4,IS5,IS6,SCF,B2,CARD,JPAGE,IT1,IT2          00000130
      COMMON /PLTCOM/ab,ad,ae,
     + NAMEX,CELL,SPG,SPGL,ITYP,LC1,LC2,LC3,LB,highx,DEL1V,              
     +DEL2V,DEL3V,DEL1H,DEL2H,DEL3H,NSEC,NR,NC,NUMROB,NUMCOB,
     +OSDV,OSDH,SP,MXPEAK,SMHPK,DMPK,LPKST,LSTO,SCLP
       COMMON/SIZE/IDENT,NX,NY,NXC,NYC,XPERIN,YPERIN,XSP,YSP,XLEN,
     +YLEN,XORG,YORG,XSCALE,YSCALE
      EQUIVALENCE (DUM(1),IS1)                                          00000140
      EQUIVALENCE (CELL(4),ANG(1))
      INTEGER*2 SPG,LC1,LC2,LC3
      REAL LNG
      DATA HOLHKO/'O K L','H O L','H K O'/
      DATA XYZT/'X','Y','Z'/
       INCLUDE 'cry_graphics:grattrib.for'
      CHARACTER*1 SPGL
      integer pgbegin, ier, i,j
      INTEGER PGOPEN,PGSETUP
      character*128 device,FILE
      EQUIVALENCE (DEVICE(1:1),FILE(1:1))
      CHARACTER*400 TEXT
      data tr/0.,1.,0.,0.,0.,1.0/
      REAL*4 LB(3),LD(3),hIGHX(3)
      INTEGER*4 SYS$ASCTIM
  	IER=SYS$ASCTIM(,DIN,,)
      WRITE (3,506)DIN                                           
      IT1S=IT1
      IT2S=IT2
      FST=0.0                                                           00000170
C     write(3,8200)ityp
C8200  format('   ityp=',i6)
      IF(ITYP.EQ.1)THEN
      NPH=NCOL
      NPV=NROW
      I1=1
      J1=1
      I2=NPH
      J2=NPV
      COL=NCOL
      ROW=NROW
      ELSE               ! 3-DIM, SECTION, AND PROJECTION
      NPH=NCOL-2                 ! 2 EXTRA COLS
      NPV=NROW-2                  ! AND ROWS FOR 3-DIM
C     WRITE(3,3838)NPH,NPV
      I1=1
      J1=1
      I2=NCOL-2
      J2=NROW-2
      ENDIF
      RST=0          ! SIGNAL THAT XMAX AND YMAX HAVE BEEN RESET
      SECNUM=0        ! INITIALIZE
      NMPS=IS3                                                          00000180
      ITYPE=ITYP        ! FORM COMMON
C     write(3,8300)itype
C8300  format('   itype=',i6)
      VAL1=LB(LC1)     ! INITIALIZE FOR HEADING
C     WRITE(3,44)SECNUM,XYZT(LC1),VAL1,NAMEX  ! DO THIS HERE FOR SECTION
C              12345678901234567890123456789012345678901234567890
      
      NPTL=1          ! FIGURE THIS OUT LATER
      DO 1300 I=1,20                                                    00000190
 1300 ACARD(I)=CARD(I)                                                  00000200
      KT=12                                                              00000230
      JT=5                                                              00000240
C                                                                       00000280
C
C            Open device for graphics.
C               input for device is /vt125  for term.
C               OR /TEK4010  FOR HDS TERMINAL
C               OR /TK4100   FOR HDS TERMINAL
   10 write (3,'(A)') '$Graphics device/type: '
      read (unit=1,fmt='(A)',iostat=ier) device
      WRITE(3,FMT='(1X,A)')DEVICE
      JPR=index(device(1:),'PRI')
      JLA=INDEX(DEVICE(1:),'LAS')
C11    FORMAT('    IER=',I3,'   JPR=',I3,'   JLA=',I3)
      if (ier.ne.0) call exit
       CALL LIB$SYS_TRNLOG('PLT$TYPE',L,DEFSTR,,,)
       DEFTYP=GRDTYP(DEFSTR(1:L))
      IF(GROPEN(0,0,DEVICE,IDENT).NE.1)THEN
       DEVICE='PLOT.PS/PS'
      UNIT=12
      PGBEGIN=GROPEN(DEFTYP,UNIT,FILE,IDENT)
C9393  FORMAT('  PGBEGIN=',I20)
C     WRITE(3,9393)PGBEGIN
      if(pgbegin.ne.1)return
      ENDIF
C         DO THIS STUFF TO SATISFY PGPLOT
	PGOPEN = 1
	PGSETUP = 0
C UNIT (input, integer): this argument is ignored by PGBEGIN.
C FILE (input, character): the "device specification" for the
C	plot device, or a logical name equivalent to such a
C	specification.  Device specifications are of the same
C	form as those used by GRPCKG, viz. "device/type", e.g.
C	"TTA4:/TEK4100", "PLOT.LIS/PRINTRONIX". Either device or
C	type may be a logical name. The default type is 
C	the translation of logical name "PLT$TYPE".
C NXSUB (input, integer): the number of subdivisions of the view
C	surface in X.
C NYSUB (input, integer): the number of subdivisions of the view
C	surface in Y. PGPLOT puts NXSUB x NYSUB graphs on each
C	plot page or screen; when the view surface is sub-divided
C	in this way, PGADVANCE moves to the next sub-page, not the
C	next physical page.
C
C (1-Jan-1984)
C-----------------------------------------------------------------------
C		Open the plot file; default type is logical-name
C		equivalence of PLT$TYPE (if defined).
C
C
C		Success: determine device characteristics
C
	PGOPEN = 1
	PGSETUP = 0
       NX=1
       NY=1
cXSZ = XSZ/NX
cYSZ = YSZ/NY
	NXC = NX
	NYC = NY
C
C		Set the prompt state to ON, so that terminal devices
C		pause between pages; this can be changed with PGASK. 
C
C
C		If logical name PLT$TYPE is defined and equivalent to
C		DEFERRED, set the update mode to DEFERRED; otherwise
C		set it to IMMEDIATE. This can be changed with PGUPDT.
C
C		Set the default window (unit square)
C
	XBLC = 0.0
	XTRC = 1.0
	YBLC = 0.0
	YTRC = 1.0
      CALL GRSIZE(IDENT,XSZDEF,YSZDEF,XSZMAX,YSZMAX,XPERIN,YPERIN)
	CALL GRCHSZ(IDENT,XCSZ,YCSZ,XSP,YSP)
        XCN=XCSZ
        YCN=YCSZ
        YC=YCN/YPERIN         ! FOR CORRECTION TERM
c     WRITE(3,9006)XCSZ,YCSZ,XSP,YSP
 9006  FORMAT(' XCHAR=',F8.4,' YCHAR=',F8.4,' XSP, YSP=',2F10.5)
C		pause between pages; this can be changed with PGASK. 
C
C
C
C      WRITE(3,9000)IDENT,XSZDEF,YSZDEF,XSZMAX,YSZMAX,XPERIN,YPERIN
      WIDE=(XSZMAX-XCSZ-(2*XSP))/XPERIN
C     IF(YSZMAX.GT.0.0)LNG=(YSZMAX-YCSZ-(2*YSP))/YPERIN
      LNG=(YSZDEF-YCSZ-(2*YSP))/YPERIN
9004   FORMAT(' WIDE=XSZMAX/XPERIN LNG=YSZDEF/YPERIN ',2F8.3)
C     WRITE(3,9004)WIDE,LNG
c   if ysmax is negative there is no fixed max.
C            Clear the screen.
200     CALL GRPAGE(IDENT)
 9000   FORMAT(' ID=',I5,/,' XSZDEF,YSZDEF=',2(1X,F10.4),/,
     +' XSZMAX,YSZMAX=',2(1X,F10.4),' XPERIN,YPERIN=',2(1X,F10.4))
C                                                                       00000540
C     CYCLE OVER MAPS.                                                  00000550
C    TRILOG PAPER SIZE IS 11X15  PLOT SIZE IS 10.5X13.2
C      X (HORIZONTAL) IS 13.2   Y (VERTICAL) IS 10.5
C                                                                       00000560
      NMPS=1
      WRITE(3,20)
20    FORMAT('   NOW GOING TO READ FROM MAP FILE')
C          1ST RECORD IS READ IN CRYM2. NOW READY TO READ COL HEADING
C          IN 2ND RECORD AND ROW ID IN 3RD RECORD.
C     ROW ID IS ENCODED INTO PVR AND IS WRITTEN AS ALPHA 
      LD(LC1)=DEL1V
      LD(LC2)=DEL2V
      LD(LC3)=DEL3H
      NBEC=AB
      NDEL=AD
      NENC=AE
      AB=AB+.01
      AE=AE+.01           ! FOR SMOOTHER CONTOURS
      IF(ITYPE.NE.1)THEN
      ROW=NROW-2
      COL=NCOL-2
      ENDIF
      PH=2.0      ! SCALE POINTS PER INCH HORIZ.
      PV=4.0      ! SCALE POINTS PER INCH VERT.
      HINCH=COL/PH      ! INCHES HORIZ.
      VINCH=ROW/PV        ! INCHES VERT
      AR=VINCH/HINCH        ! RATIO HEIGHT/WIDTH
      XMX=COL/2.0           ! HORIZONTAL MAX FOR TRILOG (COL'S/INCH)
      XMXB=(COL+5.)/2.        ! HORIZ MAX INCLUDING BORDER OF 2 CHAR.
      XMX=XMX+.05
      XMXB=XMXB+.05
      YMX=ROW/4.0                 ! VERTICAL MAX ROWS/INCH
      YMXB=(ROW+4.)/4.       ! FOR LABEL AND COL. MARKERS
      YMX=YMX+.05
      SCX=XMX
      SCY=YMX            ! SAVE THIS TO CALCULATE REDUCTION FACTOR
      YMXB=YMXB+.05
      YMXBP=YMXB+YC         
C     WRITE(3,9008)ROW,COL,PV,PH,XMX,YMX,XMXB,YMXB
9008  FORMAT('  ROWS='F5.2,' COLS=',F5.2,' PH=',F4.2,' PV=',F4.2,/,
     + '  XMX=',F8.5,'  YMX=',F8.5,'  XMXB=',F8.5,'  YMXB=',F8.5)
      XCWD=((XSP*COL*5.)+(2.0*XSP)+XCSZ)/XPERIN !WIDTH OF CHAR PLOT OF NUM
C      WIDTH NOW INCLUDES ROW MARKERS MUST FIT INTO POSSIBLE PLOTTER SIZ
C      LIMITS AND MUST BE BIG ENOUGH TO SATISFY PARTICULAR PLOT SIZE
C     IF(XMXB.GT.WIDE)THEN
      xmxb=wide                    ! FIT INTO PLOTTER LIMITATIONS
      YMXB=AR*XMXB        ! XMX AND YMX ARE IN INCHES
      XMX=WIDE
      YMX=AR*WIDE
C      WRITE(3,9002)XMXB,YMXB,AR,XMX,YMX
      RST=1
 9002  FORMAT('  XMXB AND YMXB RESET TO ',2(1X,F6.3),'  AR=',F6.3,/,
     +'  XMX AND YMX=',2(1X,F6.3))
c     WRITE(3,9011)XCWD,XMXB
9011  FORMAT('  XCWD=',F8.4,'   XMXB=',F8.4)
C     ENDIF
!     IF (XCWD.GE.XMXB)THEN   NEED TO DO THIS IN EVERY CASE
      XXXX=XMXB
      XSPN=(XXXX*XPERIN)/((COL*5.)+2.0)         ! NEW SPACE WIDTH
      IF(XSP.EQ.0.0)XSP=1.0
      CHSC=XSPN/XSP        ! SCALE TO REDUCE CHARACTER PLOT SIZE
      WSC=XMXB/XCWD
      XCN=WSC*XCSZ              ! NEW CHARACTER WIDTH
      YCN=WSC*YCSZ
      YC=YCN/YPERIN
C     WRITE(3,9007)XCWD,XSPN,CHSC,WSC,XCSZ,XCN,YCN
      CALL GRSETC(IDENT,XCN)
C     ENDIF
C     ENDIF
C     IF(YSZMAX.GT.0.0)THEN     ! PLOTTING ON DEVICE WITH Y AXIS LIMIT
      YMXBP=YMXB+YC
      IF(YMXBP.GT.LNG)THEN   
      YMXBP=LNG
      YMXB=YMXBP-YC 
      YMX=YMXB
      XMXB=YMXB/AR               ! RESCALE TO FIT ON SCREEN
      XMX=YMX/AR
C     WRITE(3,9005)XMXB,YMXB,XMX,YMX
      RST=2
      XSPN=(XMXB*XPERIN)/((COL*5.)+2.0)         ! NEW SPACE WIDTH
      IF(XSP.EQ.0.0)XSP=1.0
      CHSC=XSPN/XSP        ! SCALE TO REDUCE CHARACTER PLOT SIZE
C     IF(XCWD.GT.XMXB)THEN
      WSC=XMXB/XCWD
      XCN=WSC*XCSZ              ! NEW CHARACTER WIDTH
      YCN=WSC*YCSZ
      YC=YCN/YPERIN
C     WRITE(3,9007)XCWD,XSPN,CHSC,WSC,XCSZ,XCN,ycn
9007  FORMAT('  CHARACTER WIDTH=',F8.4,'  XSPN=',F8.4,' CHSC=',F8.4,
     +/,'   WSC=',F8.4,'  XSCZ=',F8.4,' XCN=',F8.4,' YCN=',F8.4)
      CALL GRSETC(IDENT,XCN)
      YMXB=YMXBP-YC 
      YMX=YMXB
C     ENDIF
 9005  FORMAT('   XMXB AND YMXB ARE RESET TO ',2F6.3,/,
     +'    XMX AND YMX ARE RESET TO ',2F6.3)
      ENDIF
      XMXN=XMX*XPERIN
      XMXB=XMXB*XPERIN
      YMXB=YMXB*YPERIN
      YMXN=YMX*YPERIN
      YMXBP=YMXBP*YPERIN        ! ADD CHAR SIZE TO INCLUDE TOP LINE
      XMXBP=XMXB+XCN+XCN             ! A LITTLE EXTRA FOR BORDER
C      write(3,9013)XMXBP,YMXBP
9013  FORMAT('  BEFORE CALL TO GRSETS XMXBP, AND CORRECTED YMXBP=',
     +2(1X,F14.4))
      CALL GRSETS(IDENT,XMXBP,YMXBP)
 9020  FORMAT(' FOR GRTRAN ',F12.5,'/',F12.5,' = ',F12.5,/,
     +       '             XMXN    /  COL     =     XW')
      XW=XMXN/COL       
C     WRITE(3,9020)XMXN,COL,XW
      IF(RST.NE.0)THEN
      DY=YMXB/(ROW+2.0)
      YMXN=YMXB-(2*DY)
C     WRITE(3,9301)YMXN,DY
 9301  FORMAT('  YMXN=',F10.4,'   DY=',F12.6)
      ENDIF
      YW=YMXN/ROW
C     WRITE(3,9302)YW,YMXN,ROW
c9302  FORMAT('  YW=',F12.5,'  YMXN=',F12.5,'  ROW=',F8.2)
      XORG=0.00
      YORG=0.0
C     WRITE(3,9014)XW,YW
c9014  FORMAT(' BEFORE CALL TO GRTRAN XW,YW=',2(1X,F12.8))
C     ABSXY=.TRUE.
C      CALL GRTRAN(IDENT,XORG,YORG,XW,YW)
c     write(3,600)ab,ad,ae,nrow,ncol,nptl
c600   format('  in fplot ab=',F6.0,' ad=',F6.0,' ae='F6.0,' nrow=',i5,
c    +' ncol=',i5,'  nptl=',i5)
C                                                                       00000890
C                                                                       00001070
C                                                                       00001170
C     CYCLE OVER SECTIONS.                                              00001180
C                                                                       00001190
c     write(3,8300)itype
      IF(ITYPE.NE.1)THEN
      READ(KT)      ! COL MARKER
      READ(KT)      ! ROW MARKER
      DO I=1,NROW
      READ(KT)
      ENDDO          !  READ THRU 1ST SECTION
      IB=2
      IE=NSEC-1
      VAL1=VAL1+LD(LC1)     ! INCREMENT FOR NEXT SECTION
      ELSE
      IB=1
      IE=NSEC
      if(itype.eq.1)ie=1
      ENDIF
      LJ=1
      if(itype.eq.1)then
      do jjj=1,npv
      pvr(jjj)=0
      enddo
      endif
      DO 316 JSC=IB,IE              
C     WRITE(3,3838)NPH,NPV
 3838  FORMAT('   IN FPLOT NPH=',I3,' AND NPV=',I3)
         READ(KT,ERR=500)(PHR(I),I=1,NPH)     ! EACH SECTION BEGINS WITH
C     write(3,8000)phr(1),phr(nph)
 8000  format('  phr(1)=',i6,'  phr(nph)=',i6)
         READ(KT,ERR=5001)(PVR(I),I=1,NPV)        ! COL AND ROW MARKERS
 8100  format('  pvr(1)=',i6,'  pvr(npv)=',i6)
C    IN FOO PHR AND PVR ARE WRITTEN WITH NUMCOL AND NUMROW AS DIMENSION
C     READ MAP FROM SEQUENTIAL FILE.                                    00001220
9003    CONTINUE
      NCH=(NPH*5)+2       ! NUMBER OF CHARACTERS ACROSS PAGE
      IF(NCH.GT.199)NCH=199              
      NBL=399-NCH
      NCH=(NCH-2)/5          ! CONVERT NCH TO COLS PRINTABLE
      YTX=YMXB
C     WRITE(3,9012)YTX,YCN,YMXB,YMX
c9012  FORMAT('  YTX=',F10.4,' YCN=',F10.4,' YMXB=',F10.4,' YMX=',F10.4)
      XTX=XCN
      ABSXY=.TRUE.    ! if true xo,yo are absolute and no transformation
      BRDR=.TRUE.      ! FOR BOX AROUND PLOT
      CENTER=.FALSE.  ! is applied.
       DY=YTX/(ROW+2.)    ! FOR COL MARKER AND HEADING ADD 2 TO ROW
C     IF(YD.GT.0.0)YTX=YTX-YD
C     WRITE(3,9009)YTX,DY,ROW
c     WRITE(3,9010)XCSZ,YCSZ,XSP,YSP
c 9010  FORMAT(' XCSZ=',F10.6,' YCSZ=',F10.6,' XSP=',F12.6,' YSP=',F12.6)
c 9009  FORMAT('  YTX=',F12.6,' DY=',F12.6,' ROW=',F6.2,' J=',I4)
      IF(ITYP.EQ.1)THEN       ! GENERAL PLANE
      ENCODE(132,49,TEXT(1:132))NAMEX
49     FORMAT(15X,'GENERAL PLANE',5X,A12,87X)
C                  123456789012345  15+13+17=45, 45+87=132
      ENDIF
      IF(ITYP.EQ.2)THEN    ! PROJECTION
      ENCODE(132,43,TEXT(1:132))HOLHKO(LC1),NAMEX
43     FORMAT(15X,'PROJECTION 'A5,13X,A12,76X)
      ENDIF
      IF(ITYP.EQ.3)THEN
      ENCODE(132,44,TEXT(1:132))SECNUM,XYZT(LC1),VAL1,NAMEX
44     FORMAT(' 3-DIM MAP     SECTION  ',I3,4X,A1,' = ',F6.4,8X,A12,71X)
      VAL1=VAL1+LD(LC1)     ! INCREMENT FOR NEXT SECTION
      SECNUM=SECNUM+1       ! LIKEWISE
      ENDIF
C     WRITE(3,9090)XTX,YTX
C9090  FORMAT(' BEFORE GRCHAR XTX,YTX=',2F20.10)
      CALL GRCHAR(IDENT,CENTER,ORIENT,ABSXY,XTX,YTX,TEXT)
C     WRITE(3,3000)NCH,NBL,NPH
3000  FORMAT('  NCH=',I4,' NBL=',I4,' NPH=',I4)
      ENCODE(400,9201,TEXT)(PHR(L),L=1,NPH)    ! COL HEADING
9201  FORMAT(2X,<NCH>I5,<NBL>X)
      YTX=YTX-DY             ! GET READING TO PLOT COL MARKER
C     WRITE(3,9090)XTX,YTX
      CALL GRCHAR(IDENT,CENTER,ORIENT,ABSXY,XTX,YTX,TEXT)
      XBR(1)=XCN*3.          
      XBR(2)=XMXB+2.*XCN                        ! XMXB*XPERIN
      XBR(1)=XBR(1)+XCN    
      YBR(1)=YTX-(YCN/2.0)             ! BORDER
      YBR(2)=YBR(1)           ! DRAW UPPER LINE ACROSS PLOT
      YSV=YBR(1)
      XO=XBR(1)
      YO=YBR(1)
C     WRITE(3,9300)XBR,YBR
      XTRAN=XBR(2)-XBR(1)
      XAREA=XBR(2)
 9300  FORMAT('  XBR=',2F10.4,'  YBR=',2F10.4)
      CALL GRVECT(IDENT,2,BRDR,2,XBR,YBR)
      YTX=YTX-DY             ! NEXT LINE OF DECREASING Y 
      IR=2            ! INDEX FOR ROW MARKER
      IF(ITYPE.EQ.1)THEN               ! FOR GENERAL PLANE
      ir=1
      fc=1
      lc=ncol
      IB=1
      IC=NPH
      nend=1
      irw=nrow
      ELSE
      IB=2
      IC=NCOL-1
      IRW=NROW-1
      fc=2
      lc=ncol-1
      READ(KT)                ! THROW AWAY 1ST ROW
      NEND=2           ! AND LAST
      ENDIF
      DO 210 J=IRW,NEND,-1              
      READ(KT)(IRAY(L),L=1,NCOL)   ! 1 DIM IRAY,GET RID OF 1ST AND LAST
      ENCODE(400,9200,TEXT)PVR(IR),(IRAY(L),L=fc,lc)   ! READY TO PLOT
9200  FORMAT(A2,<NCH>I5,<NBL>X)
         IR=IR+1          
C     WRITE(3,9090)XTX,YTX
      CALL GRCHAR(IDENT,CENTER,ORIENT,ABSXY,XTX,YTX,TEXT)
c               xtx and ytx are absolute coordinates and are not 
c               transformed.
      YTX=YTX-DY             ! NEXT LINE OF DECREASING Y 
C     WRITE(3,9009)YTX,DY,ROW,J
      IF(ITYP.EQ.1)THEN
      JJ=J              ! J=NROW TO 1
      KK=1
      IEND=NPH
      ELSE
      JJ=J-1         ! J= NROW-1 TO 2
      KK=2
      IEND=NPH  
      ENDIF
      DO L=1,IEND      ! IEND=NPH, # POINTS HORIZONTAL
      IF(ITYP.EQ.1)THEN
      rray(L,JJ)=IRAY(KK)   ! J CHANGES IN LOOP TO 210
      ELSE
      RRAY2(L,JJ)=IRAY(KK)    ! THIS FOR 3-DIM
      ENDIF
      KK=KK+1
      ENDDO                             ! ARRAY
601    FORMAT(1X,<NPR>F5.0)   ! WONT WORK FOR NCOL.GT.25
      NPR=NPH
      IF(NPH.GT.25)NPR=25
C     WRITE(3,601)(RRAY(L,JJ),L=1,NPR)
  210 CONTINUE                                  
      IF(ITYPE.NE.1)READ (KT)        ! THROW AWAY LAST ROW
      YBR(2)=YTX+(DY/2.)             ! DRAW RIGHT BORDER VERTICAL
      XSV=XBR(1)         ! SAVE THIS FOR LATER
      XBR(1)=XBR(2)
C     WRITE(3,9300)XBR,YBR
      YTRAN=YBR(1)-YBR(2)      ! MAX-MIN OF Y BORDER
      YAREA=YBR(1)
      YO=YBR(2)             ! MIN OF YBORDER
      CALL GRVECT(IDENT,2,BRDR,2,XBR,YBR)
      XBR(1)=XBR(2)
      XBR(2)=XSV                
      YBR(1)=YBR(2)             ! DRAW BOTTOM LINE HORIZONTAL
C     WRITE(3,9300)XBR,YBR
      CALL GRVECT(IDENT,2,BRDR,2,XBR,YBR)
      XBR(1)=XBR(2)
      YBR(2)=YSV             ! DRAW LEFT SIDE VERTICAL
C     WRITE(3,9300)XBR,YBR
      CALL GRVECT(IDENT,2,BRDR,2,XBR,YBR)
C     DRAW THE CONTOURS.                                                00001780

      XW=XTRAN/COL
      YW=YTRAN/ROW
      CALL GRTRAN(IDENT,XORG,YORG,XW,YW)
C     WRITE(3,9456)XO,YO,XW,YW
9456  FORMAT('  GRTRAN HAS XO,YO=',2F12.5,'  XW,YW=',2F14.6)
C                                                                       00001790
201   ACLEV(1)=AB
      DO I=2,50
      ACLEV(I)=ACLEV(I-1)+AD
      IF(ACLEV(I).GT.AE)THEN
      NN=I
      GO TO 100
      ENDIF
      ENDDO
      IF(NN.EQ.0)NN=50
100   XTICK=XMX/COL
      YTICK=YMX/ROW
      CALL LIB$INIT_TIMER
C     WRITE(3,5002)NCOL,NROW,(ACLEV(I),I=1,10),NN
5002    FORMAT('  BEFORE PGCONT NCOL,NROW=',2I4,' ACLEV=',10F5.0,
     +' NN=',I6)
C     tr(4)=-.5*YTICK               ! move plotted contour down a row
C     TR(1)=2.*XTICK
      IF(ITYP.NE.1)THEN
C      TR(1)=-1.*XTICK
C     TR(4)=-2.*YTICK
      ENDIF
C     write(3,900)tr(4),YTICK,TR(1),XTICK
C900   format('  before call to pgcons tr(4)=',f10.6,'  YTICK=',/,
c    +F12.5,/,
C    +'    AND TR(1)=',F10.6,'   XTICK=',F12.5)
      DO I=1,NN
          CLEV=ACLEV(I)
      IF(ITYP.EQ.1)THEN    ! THIS IS GENERAL PLANE
      call pgcons(RRAY,NPH,J2,I1,I2,J1,J2,CLEV,1,tr)
      ELSE     ! THIS IS 3 DIM MAP
      CALL pGCONs(RRAY2,NPH,J2,I1,I2,J1,J2,CLEV,1,TR)
c     WRITE(3,9090)NPH,J2,I1,I2,J1,J2
c9090  FORMAT('  pGCONs HAS NPH,J2,I1,I2,J1,J2=',6I5)
      ENDIF
      ENDDO
      NPLTS=NPLTS+1                                                     00002000
      TP = NPLTS                                                        00002010
      IF(JSC.LT.IE)THEN     ! IE=NSEC, OR NSEC-1
C            INSERT PAUSE FOR TEK TERMINALS
      JTK=INDEX(DEVICE,'TEK')
      IF(JTK.EQ.0)JTK=INDEX(DEVICE,'TK')
      IF(JTK.NE.0)PAUSE
      CALL GRPAGE(IDENT)     ! CLEARS SCREEN
      ENDIF
C     CALL GRSETS(IDENT,XMXBP,YMXBP)
  316 CONTINUE                                                          00002050
 2316 CONTINUE                                                          00002060
C                                                                       00002070
C     TERMINATE.                                                        00002080
C                                                                       00002090
  317 IF (NPLTS) 1318,318,1318                                          00002100
 1318 CONTINUE
C     WRITE (15,25)NPLTS                                                00002120
      IF(NPLTS.LT.2)THEN
      WRITE(3,26)NPLTS
      ELSE
      WRITE(3,25)NPLTS                                                  00002130
      ENDIF
C         IF THIS IS TEK TERMINAL TRY SKIPPING OVER THE GRCLOS
      IF(JTK.NE.0)PAUSE
      CALL GRCLOS(IDENT)
  318 IT1 = IT1S                                                        00002140
      IT2 = IT2S                                                        00002150
      REWIND KT                                                         00002160
      IS1=0                                                             00002200
      RETURN                                                            00002210
500   WRITE(3,5003)NPH
5003   FORMAT('  ERROR READING IN COL HEADING, NPH=',I4)
      GO TO 9003
5001   WRITE(3,5004)NPV
5004   FORMAT('  ERROR READING IN ROW MARKER,NPV=',I4)
      GO TO 9003
   25 FORMAT (I4,'  PLOTS HAVE BEEN PLACED IN A PLOT FILE.')              00002220
26    FORMAT(1X,I3,' PLOT HAS BEEN PLACED IN A PLOT FILE.')
C                                                                       00002230
  501 FORMAT('1  NUMBER OF POINTS PER SECTION IS TOO LARGE FOR PLOTTING 00002430
     1PROGRAM')                                                         00002440
  503 FORMAT (20A1)                                                     00002450
  504 FORMAT (' SECTION  ',A4,F6.2)                                     00002460
  505 FORMAT (' PROJECTION ',A4,'AXIS')                                 00002470
  506 FORMAT ('0',15X,'FOURIER PLOTTING PROGRAM',15X,5A4/)              00002480
  507 FORMAT ('0   MAP',I4,'  ,',I4,' SECTIONS'/,
     1/'     BEGINNING CONTOUR LEVEL =',I6/'     DIFFERENCE BETWEEN',    
     2' CONTOURS =',I6//)                                     
  508 FORMAT (' GENERAL PLANE MAP  ')                                   00002520
  509 FORMAT ('0',3X,A)                                             
      END                                                               00002540
