c
c  add check reflection write out?
c 
c
      SUBROUTINE NONIUS
C   THIS ROUTINE READS A cad4 .dat file AND CREATES A MAG FILE OF ITS
C   CONTENTS.  MAG FILE CONTAINS ID,H,K,L,TTH,PHI,CHI,RANGE,SPEED,
C   B1,SCAN,B2,EXPTM,TBTS AND THREE BLANK FIELDS WHICH WILL BE FILLED
C   BY LATER PROGRAMS.  (BLANK FIELDS INCLUDED SO THAT MAG FILE WILL
C   ALWAYS BE THE SAME LENGTH AND NOT INCREASE IN SIZE, WITH THE DANGER
C   OF OVERFLOWING DISK SPACE, WHEN THE LATER PROGRAMS ARE RUN.)
c   ihab,ikab,ilab,isym (integer) 
c   iiab,iisi,iisym (real) 
c   absent,index,parity (char)
c   are all for storing information for printing a truncated summary
c   of reflections bearing on common space group absences
c23456789012345678901234567890123456789012345678901234567890123456789012
C incorporates abcor  PROGRAM TO PROVIDE CORRECTION FACTORS FOR ABSORPTION.
C
c abcor modified to read .dat file, pluck out psiscan stuff
c set up for up to 12 reflections with 5 degree intervals 
c
c

c    for absorption correction
      DIMENSION AINT(12,73), CORR(12,72), PHI(12,73),smint(12)
      Dimension npsi(12),avgint(12)
      Integer h2,hkl(12,3)
      CHARACTER*6 npsifl,psityp
      LOGICAL psiscan,counts,spill,special
c
      INTEGER*2 ID,H,K,L,IH(10),IK(10),IL(10),IDCNT,IHAB(18,25),
     1 IKAB(18,25),ILAB(18,25),isym(35)
      integer*2 IDD(100,2),ID1(200),IDEL(500),NDR(12)
      INTEGER*2 SKIP,FIL     ! COUNT OF FILES SKIPPED AND FILE POSITION
      INTEGER H1,isab(18)
      REAL KAPPA
      REAL*4 INT,INTCOR,IIAB(18,25),iisi(18,25),iisym(35,4)
      CHARACTER*1 C1,nf,dash(11),index(3)
      CHARACTER*2 LA
      CHARACTER*4 CARD(20),parity(3)
      character*5 absent(6)
      CHARACTER*16 NAMFI,NAMFIL 
      CHARACTER*20 NAM,sums(35)
      CHARACTER*64 CHAR     
      CHARACTER*80 Card1     
      data index /'h','k','l'/
      data parity/'even','odd ','even'/
      data absent/'h 0 0','0 k 0','0 0 l','h k 0','h 0 l','0 k l'/
      DATA IBLANK/'    '/
      DATA NAMFIL/'                '/
      data sums/'h k 0  h=2n+1       ','h 0 l  h=2n+1       ',
     1'h k 0  k=2n+1       ',
     1'0 k l  k=2n+1       ','h 0 l  l=2n+1       ',
     1'0 k l  l=2n+1      ',
     2'h k 0  h+k=2n+1     ','h 0 l  h+l=2n+1     ',
     2'0 k l  k+l=2n+1     ',
     3'h 0 0  h=2n+1       ','0 k 0  k=2n+1       ',
     3'0 0 l  l=2n+1       ',
     4'h k l  h+l=2n+1     ','h k l  h+k=2n+1     ',
     4'h k l  k+l=2n+1     ',
     5'h k l  h=2n+1       ','h k l  k=2n+1       ',
     5'h k l  l=2n+1       ',
     6'h k l  h+k+l=2n+1   ','h k 0  h=2n+1,k=2n+1',
     7'h 0 l  h=2n+1,l=2n+1','0 k l  k=2n+1,l=2n+1',
     8'h 0 0  h<>4n        ','0 k 0  k<>4n        ',
     9'0 0 l  l<>4n        ','h k 0  h+k<>4n      ',
     1'h 0 l  h+l<>4n      ','0 k l  k+l<>4n      ',
     2'h h l  l=2n+1       ','h h l  2h+l<>4n     ',
     3'h k l  -h+k+l<>3n   ','h k l  h-k+l<>3n    ',
     4'0 0 l  l<>3n        ','0 0 l  l<>6n        ',
     5'All reflections     '/
      data isym,isab /53*0/
      data iiab,iisi,iisym /1040*0.0/
C                  1234567890123456
c this needs to be checked  (lmh) jan 1990

CAUTION   att also used in initia  !!!!!!!!!!!

      PARAMETER ATT = 20.9	!1987(BDS) revised value
      COMMON/FNAME/NAMFI,NAMLEN
      common/faddup/isym,iisym,intcor,sigcor
      OUT=7
      BL1=0.0   ! BLANK FIELDS
      BL2=0.0
      BL3=0.0
      NOE=0
      IRD=0
      SKIP=0
      FIL=1              ! BEGIN AT FILE ONE
      ND=0
      ND1=0
      NTOT=0
      SPECIAL=1
c     means no special reflections to be printed;   special means
c        a) background less than or equal to zero
c        b) attenuator used
c
      psiscan=.false.
c true if reflection group is a AZIMUT psiscan reflection; detected by
c
c
c     if spill is true, then use scan count + difference in backgrounds
c rather than int for psiscan
      spill=.false.
c
c     if counts is true use scan counts only
      counts=.false.
c
c
c  flag in starting cards (record type ) and non-check.
c
c    nreflm is max number of psi scan reflections
      nreflm=12
c    nrefl is number of psi scan reflections
      nrefl=0
c    nrpsim is max number of psi scans
      nrpsim=73
c    npsi is number of psi scan currently being measured
c    assumed to be in order
c     
c       total number of reflections less deleted reflections
      nref=0
c
      N=NAMLEN+1
      NAMFIL=NAMFI
      NAMFI(N:N+3)='.MAG'
      NAMFIL(N:N+3)='.Dat'
C   OPENING MAG FILE
25    OPEN(NAME=NAMFI,UNIT=OUT,TYPE='NEW',FORM='UNFORMATTED',
     1BLOCKSIZE=32768,BUFFERCOUNT=2)
      NOCHEK=0   ! NUMBER OF CHECKS
      NOL=10
C
C  FILE CARD 
C2345678901234567890
C####NN LIST
C ##### IS NUMBER OF LAST REFLECTION TO BE READ
C  NN IS NUMBER OF THE FILE TO BE READ FROM TAPE
C  LIST TELLS WHETHER OR NOT TO LIST CONTENTS OF TAPE
C
      IF(IRD.EQ.0)THEN
       READ(1,10)LENGTH,IFILE,NLIST,NPROF,psityp
10     FORMAT(I5,I2,1X,A4,1X,A7,1X,A6)
       IRD=1                 ! IF YOU COME HERE AGAIN USE DECODE
       if (psityp(1:1).eq.'c' .or. psityp(1:1).eq.'C') counts=.true.
       if (psityp(1:1).eq.'s' .or. psityp(1:1).eq.'S') spill=.true.
      ELSE                  ! YOU WILL BE READING IN MORE THAN ONE FILE
C   IRD NOT=0 IF READING MORE THAN ONE FILE FROM SAME MAG TAPE
c   more than one file not supported
       DECODE(80,10,CARD)LENGTH,IFILE,NLIST
      ENDIF
      IF(NLIST.EQ.IBLANK)THEN
      ILIST=1
      WRITE(3,15)
15    FORMAT(' As requested, you will have printed output of tape',
     1' contents.')
      ELSE
      ILIST=0
      WRITE(3,16)
16    FORMAT(' No printed output of tape contents.')
      ENDIF
      IF(IFILE.EQ.0)IFILE=1
C     NNN=NAMLEN+6
C     ENCODE(1,17,NAMFIL(NNN:NNN+1))IFILE
17    FORMAT(I1)
C     OPEN(UNIT=12,STATUS='OLD')
C     INQUIRE(UNIT=12,NAME=NAM)
C     NAM(1:5)='MTA0:' 
C     J=INDEX(NAMFIL(1:),';')
C     NAM(6:J)=NAMFIL         ! GET RID OF INQUIRE AND EXTRA OPEN
C     J=INDEX(NAM(1:),';')
C     J=J+1
C     ENCODE(1,17,NAM(J:J+1))IFILE
C     OPEN(UNIT=12,FILE=NAM,STATUS='OLD')
      OPEN(UNIT=12,FILE=NAMFIL,STATUS='OLD')
      WRITE(3,70)NAMFIL   
      WRITE(11,70)NAMFIL   
70    FORMAT(' File ',a,' is opened.')
c
      IF(LENGTH.gt.0) then
       WRITE(3,7)IFILE,LENGTH
 7     FORMAT(' Last ID # to be read from file ',i2,' is: ',i5.)
      else
       write(3,901)
  901  format(' All reflections will be read.')
      endif
c
181   READ(1,18)CARD
18    FORMAT(20A4)
      IF(CARD(1).NE.'DELE')GOTO 253
C DELETE CARDS HERE - DELETED REFLECTIONS NOT STORED ON MAG FILE!
      DECODE(80,21,CARD)(NDR(I),DASH(I),I=1,11),NDR(12)
21    FORMAT(7X,11(I5,A1),I5)
      WRITE(3,22)(NDR(I),DASH(I),I=1,11),NDR(12)
22    FORMAT(1X,'DELETE ',11(I5,A1),I5)
      I=1
23    IF(NDR(I).EQ.0)GOTO 181
      IF(DASH(I).EQ.'-')THEN
C  DASH MEANS RANGE OF IDS TO BE DELETED
      ND=ND+1
C  ND KEEPS TRACK OF RANGES OF DELETIONS
      IF(ND.GT.100)THEN
C  PREVENT ARRAY OVERFLOW - 100 DELETION RANGES ALLOWED
      ND=100
      WRITE(3,24)NDR(I)
24    FORMAT(' Deletion array overflow - reflection # ',i6,
     1' not deleted.')
      ENDIF
      IDD(ND,1)=NDR(I)
      IDD(ND,2)=NDR(I+1)
      I=I+2
      ELSE ! SINGLE DELETION
      ND1=ND1+1
C  ND1 KEEPS TRACK OF NUMBER OF SINGLY DELETED REFLECTIONS
      IF(ND1.GT.200)THEN
C  PREVENT ARRAY OVERFLOW - 200 SINGLE DELETIONS ALLOWED
      ND1=200
      WRITE(3,24)NDR(I)
      ENDIF
      ID1(ND1)=NDR(I)
      I=I+1
      ENDIF
      IF(I.LE.12)GOTO 23
      GOTO 181
253   CONTINUE
C    READ IN DATA TAPE HERE                                                  184
C   CODE HERE REPLACES CALL TO RDTP IN IBM VERSION
      RLP = 1                                                           PR   186
      FIRST=0                                                           
      IF(ILIST.EQ.1)WRITE(3,3001)
      NNREC=NNREC+1
c   read data in 1 line a time now no longer 8 from tape record length
c   8  causes problems with end of file if all records are desired
c
c  beginning of read data loop
c
300   READ(12,63,END=301)CHAR
63    FORMAT(a64)
      DECODE(64,64,CHAR,ERR=5039)NTYP
64    FORMAT(2X,I2,60X)
c   get ntyp, reflection type 
c   CAD4 diffractometer manual orange v5.0 1988  chapter XI  p 29
c
c   decode type 1 record
c
      IF(NTYP.EQ.1)THEN
      DECODE(64,501,CHAR,ERR=5041)IDNO,H1,K1,L1,C1,NPI,BG1,SCAN,BG2
501   FORMAT(4X,I6,3I5,1X,A1,12X,I4,F6.0,F7.0,F6.0,2X)
      IBG1=BG1
      IBG2=BG2
      ISCAN=SCAN
      ID=IDNO
      IF(C1.EQ.'I')ID=-ID
c reset these if lines below fro card type 19 changed
c      finet=0
c      sigmi=0
      H=H1
      K=K1
      L=L1
        if(npi.ne.0)then
         SPEED=16.48/NPI		!1985(BDS) revised value FROM WHAT ?
        else
c so what happens later if speed is zero ?
         speed=0.0
        endif
      TBTS=0.5
c
c  decode type 2 reflection
c
      ELSEif (ntyp.eq.2) then
      DECODE(64,502,CHAR,err=5041)
     1      idno2,THETA,PHIK,OMK,KAPPA,WIDTH,ITIME
502   FORMAT(4X,i6,F8.3,3F9.3,F7.3,I7,5X)
        if(idno2.ne.idno) goto 5043
      RANGE=ABS(2./3.*WIDTH)
      TTH=2.*THETA
      EXPTM=ITIME/3600.
	CALL ANGLES(PHIK,KAPPA,omk,PHIE,CHI,ome)
      if(c1.ne.'S') GOTO 504
c what if i and s ????
c
c  decode type 19 record
c
      elseif (ntyp.eq.19) then
      decode(64,505,char,err=5041) 
     1      idno19,finet,sigmi,res,timl,timp,timr
505   format(4x,i6,f8.1,f6.1,f5.2,8x,6x,f6.0,f7.0,f6.0)
        if(idno19.ne.idno) goto 5043
      tbts=(timl+timr)/timp
      range=abs(width)
c  these two lines + modified prints later included temporarily ??
c      finet=16.48*finet   ! attenuation factor not included
c      sigmi=16.48*sigmi    
c see two lines above which set these to zero for 'normal' reflections
      goto 504
c
c
c   decode type 23 record
c   if azimut, look for psiscan data
c
c
      ELSEIF(NTYP.EQ.23)THEN
       DECODE(64,506,CHAR,ERR=5041) npsifl,nrpsi
506    format(7x,a6,i5,46x)
c
c     npsifl is psi key; BISECT for data and AZIMUT for psi scans
c     nrpsi is number of psi scans to do, if AZIMUT
c
        if (npsifl.eq.'AZIMUT')then
         psiscan=.true.
          if (nrpsi .gt. nrpsim) then
            write (13,507) nrpsi,nrpsim
 507        format(i4,' is greater than the'i4' psi values allowed.')
            goto300  
          endif
        else
         psiscan=.false.
        endif
      ENDIF
c
c  do more reading
c
      goto 300
c  a reflection has been read in
c  process it - check, delete, data
c
504   IDCNT=ID
      IF(IDCNT.GT.0)GOTO 210
c
c  check reflection
c
      IDCNT=-IDCNT
      IF(NOCHEK.EQ.0)GOTO 206
      DO 205 I=1,NOCHEK
      IF(H.EQ.IH(I).AND.K.EQ.IK(I).AND.L.EQ.IL(I))THEN
      ICK=I
      GOTO 210
      ENDIF
205   CONTINUE
206   NOCHEK=NOCHEK+1
      ICK=NOCHEK
      IH(ICK)=H
      IK(ICK)=K
      IL(ICK)=L
210   IF(ND.EQ.0)GOTO 211
c
c   deleted reflection stuff
c
      DO 211 I=1,ND
C  IS REFLECTION IN ONE OF THE DELETION RANGES
      IF(IDCNT.GE.IDD(I,1).AND.IDCNT.LE.IDD(I,2))THEN
      NTOT=NTOT+1
      IF(NTOT.GT.500)NTOT=500  ! PREVENT ARRAY OVERFLOW
C  NTOT KEEPS TRACK OF TOTAL NUMBER OF DELETED REFLECTIONS
      IDEL(NTOT)=ID
      GOTO 300
      ENDIF
211   CONTINUE
      IF(ND1.EQ.0)GOTO 212
C  SEEING IF REFLECTION IS ONE OF THE SINGLE DELETIONS
      DO 212 I=1,ND1
      IF(IDCNT.EQ.ID1(I))THEN
      NTOT=NTOT+1
      IF(NTOT.GT. 500)NTOT=500  !PREVENT ARRAY OVERFLOW
      IDEL(NTOT)=ID
      GOTO 300
      ENDIF
212   CONTINUE
c
c  last reflection to be read in type; add read till end
c
      IF(LENGTH.NE.0)THEN
       IF(IDCNT.GT.LENGTH)GO TO 301  ! IS ID > LAST ID TO BE READ IN
      ENDIF
c      keep track of total number reflections
      nref=nref+1
c
      IF(SPEED.LT.0.0)THEN
C  SPEED LESS THAN 0.0 MEANS ATTENUATOR WAS SET - MARK ON MAG FILE BY
C  SETTING EXPTM LESS THAN 0.0
      SPEED=ABS(SPEED)
      EXPTM=-EXPTM
      ENDIF
      TSTB=1./TBTS
      INTCOR=(SCAN-(BG1+BG2)*TSTB)*SPEED
      SIGCOR=SQRT(SPEED**2*(SCAN+(BG1+BG2)*TSTB**2))
      IF(NPI.LT.0.0)then
       INTCOR=INTCOR*ATT
       SIGCOR=SIGCOR*ATT
      ENDIF
      WRITE(OUT)ID,H,K,L,TTH,PHIE,CHI,RANGE,SPEED,BG1,SCAN,BG2,EXPTM,
     1 TBTS,ome,-1.,BL3
c
c
c   if this is a psiscan and not a check
c
c
      IF (PSISCAN .and. id.gt.0) THEN
       if (nrefl.eq.0) then
       nrefl=1
       hkl(nrefl,1)=h
       hkl(nrefl,2)=k
       hkl(nrefl,3)=l
       h2=h
       k2=k
       l2=l
       npsi(nrefl)=0
       smint(nrefl)=0.
      else
       if (h.ne.h2 .or. k.ne.k2 .or. l.ne.l2) then
        nrefl=nrefl+1
        if (nrefl.gt.nreflm) then
         write (13,508) nrefl,nreflm
 508     format(i4,' is greater than the'i4' psiscans allowed.')
         goto300
        endif
       hkl(nrefl,1)=h
       hkl(nrefl,2)=k
       hkl(nrefl,3)=l
       h2=h
       k2=k
       l2=l
       npsi(nrefl)=0
       smint(nrefl)=0.
      endif
      endif
c
c
      npsi(nrefl)=npsi(nrefl)+1
          if (npsi(nrefl) .gt. nrpsim) then
            write (13,509) npsi(nrefl),nrpsim,nrefl
 509        format(' There seem to be 'i4,' scans, not'i4,
     1              ' for reflection'i3'.')   
            goto 300
          endif
      aint(nrefl,npsi(nrefl))=intcor
      if (spill) then 
       bgmin=bg1
       if (bg2.lt.bgmin) bgmin=bg2
       bgmax=bg2
       if (bg1.gt.bgmax) bgmax=bg1
       aint(nrefl,npsi(nrefl))=(SCAN-(3.*bgmin-bgmax)*TSTB)*SPEED
       IF(NPI.LT.0.0) 
     1    aint(nrefl,npsi(nrefl))=aint(nrefl,npsi(nrefl)) *att
      endif
      if (counts) then 
       aint(nrefl,npsi(nrefl))=(SCAN)*SPEED
       IF(NPI.LT.0.0) 
     1    aint(nrefl,npsi(nrefl))=aint(nrefl,npsi(nrefl)) *att
      endif
C
C  For Psi scan peak spillover into background, add
C   quicky option to add difference between backgrounds
C
C
      SMINT(nrefl) = SMINT(nrefl) + AINT(nrefl,npsi(nrefl))
      phi(nrefl,npsi(nrefl))=phie
c
      ENDIF
c  end psiscan insert for here
c
Caution
C   stick omega in background corrected intensity slot for possible later 
C   use.     One other such write below.
Caution
      if ( bg1.gt.0. .and. bg2.gt.0. .and. exptm.gt.0. ) goto 1
      if (SPECIAL) then 
      write(11,2)
    2 format(///' Special reflections: '/
     1           '          Backgrounds less than or equal 0, or'/
     2           '          Attenuator used '///
     3'    ID     h     k     l    Ck    B1     Scan  ',
     4'   B2     Int      Sig      2Th    Phi     Chi    Time  ',
     5' Speed  TB/TS',/)
      SPECIAL=0
      endif
      WRITE(11,3000)ID,H,K,L,IBG1,ISCAN,IBG2,INTCOR,SIGCOR,TTH,
     1PHIE,CHI,EXPTM,SPEED,TBTS
c  the last two fields f10.2,f7.2 for finet,sigmi no longer printed
c
C  FOR SPACE GROUP ABSENCES
c  checks not included
    1 if (h.ne.0 .and. k.ne.0 .and. l.ne.0) go to 2126
      if (id.le.0) goto 3050
C  H 0 0
      IF(K.EQ.0.AND.L.EQ.0)THEN
        if (imod(h,2).eq.0)then
          ISAB(1)=ISAB(1)+1
          I=ISAB(1)  
          IF(I.GT.25)GOTO 2126
          IHAB(1,I)=H
          IKAB(1,I)=K
          ILAB(1,I)=L
          IIAB(1,I)=INTCOR
          iisi(1,i)=sigcor
        else
          ISAB(2)=ISAB(2)+1
          I=ISAB(2)
          IF(I.GT.25)GOTO 2126
          IHAB(2,I)=H
          IKAB(2,I)=K
          ILAB(2,I)=L
          IIAB(2,I)=INTCOR
          iisi(2,i)=sigcor
        endif
      goto 2126
2121  ENDIF
C  0 K 0
      IF(H.EQ.0.AND.L.EQ.0)THEN
        if (imod(k,2).eq.0)then
          ISAB(3)=ISAB(3)+1
          I=ISAB(3)
          IF(I.GT.25)GOTO 2126
          IHAB(3,I)=H
          IKAB(3,I)=K
          ILAB(3,I)=L
          IIAB(3,I)=INTCOR
          iisi(3,i)=sigcor
        else
          ISAB(4)=ISAB(4)+1
          I=ISAB(4)
          IF(I.GT.25)GOTO 2126
          IHAB(4,I)=H
          IKAB(4,I)=K
          ILAB(4,I)=L
          IIAB(4,I)=INTCOR
          iisi(4,i)=sigcor
        endif
      goto 2126
2122  ENDIF
C  0 0 L
      IF(H.EQ.0.AND.K.EQ.0)THEN
        if (imod(l,2).eq.0)then
          ISAB(5)=ISAB(5)+1
          I=ISAB(5)
          IF(I.GT.25)GOTO 2126
          IHAB(5,I)=H
          IKAB(5,I)=K
          ILAB(5,I)=L
          IIAB(5,I)=INTCOR
          iisi(5,i)=sigcor
        else
          ISAB(6)=ISAB(6)+1
          I=ISAB(6)
          IF(I.GT.25)GOTO 2126
          IHAB(6,I)=H
          IKAB(6,I)=K
          ILAB(6,I)=L
          IIAB(6,I)=INTCOR
          iisi(6,i)=sigcor
        endif
      goto 2126
2123  ENDIF
C  H K 0  (ONLY FOR -5 <= H,K <= 5)
      IF(L.EQ.0.AND.IABS(H).LT.6.AND.IABS(K).LT.6)THEN
        if (imod(h,2).eq.0)then
          if (imod(k,2).eq.0)then
            ISAB(7)=ISAB(7)+1
            I=ISAB(7)
            IF(I.GT.25)GOTO 2126
            IHAB(7,I)=H
            IKAB(7,I)=K
            ILAB(7,I)=L
            IIAB(7,I)=INTCOR
            iisi(7,i)=sigcor
          else
            ISAB(8)=ISAB(8)+1
            I=ISAB(8)
            IF(I.GT.25)GOTO 2126
            IHAB(8,I)=H
            IKAB(8,I)=K
            ILAB(8,I)=L
            IIAB(8,I)=INTCOR
            iisi(8,i)=sigcor
          endif
        else
          if (imod(k,2).eq.0)then
            ISAB(9)=ISAB(9)+1
            I=ISAB(9)
            IF(I.GT.25)GOTO 2126
            IHAB(9,I)=H
            IKAB(9,I)=K
            ILAB(9,I)=L
            IIAB(9,I)=INTCOR
            iisi(9,i)=sigcor
          else
            ISAB(10)=ISAB(10)+1
            I=ISAB(10)
            IF(I.GT.25)GOTO 2126
            IHAB(10,I)=H
            IKAB(10,I)=K
            ILAB(10,I)=L
            IIAB(10,I)=INTCOR
            iisi(10,i)=sigcor
          endif
        endif
      goto 2126
2124  ENDIF
C  H 0 L  (ONLY FOR -5 <= H,L <= 5)
      IF(K.EQ.0.AND.IABS(H).LT.6.AND.IABS(L).LT.6)THEN
        if (imod(h,2).eq.0)then
          if (imod(l,2).eq.0)then
            ISAB(11)=ISAB(11)+1
            I=ISAB(11)
            IF(I.GT.25)GOTO 2126
            IHAB(11,I)=H
            IKAB(11,I)=K
            ILAB(11,I)=L
            IIAB(11,I)=INTCOR
            iisi(11,i)=sigcor
          else
            ISAB(12)=ISAB(12)+1
            I=ISAB(12)
            IF(I.GT.25)GOTO 2126
            IHAB(12,I)=H
            IKAB(12,I)=K
            ILAB(12,I)=L
            IIAB(12,I)=INTCOR
            iisi(12,i)=sigcor
          endif
        else
          if (imod(l,2).eq.0)then
            ISAB(13)=ISAB(13)+1
            I=ISAB(13)
            IF(I.GT.25)GOTO 2126
            IHAB(13,I)=H
            IKAB(13,I)=K
            ILAB(13,I)=L
            IIAB(13,I)=INTCOR
            iisi(13,i)=sigcor
          else
            ISAB(14)=ISAB(14)+1
            I=ISAB(14)
            IF(I.GT.25)GOTO 2126
            IHAB(14,I)=H
            IKAB(14,I)=K
            ILAB(14,I)=L
            IIAB(14,I)=INTCOR
            iisi(14,i)=sigcor
          endif
        endif
      goto 2126
2125  ENDIF
C  0 K L  (ONLY FOR -5 <= K,L <= 5)
      IF(H.EQ.0.AND.IABS(K).LT.6.AND.IABS(L).LT.6)THEN
        if (imod(k,2).eq.0)then
          if (imod(l,2).eq.0)then
            ISAB(15)=ISAB(15)+1
            I=ISAB(15)
            IF(I.GT.25)GOTO 2126
            IHAB(15,I)=H
            IKAB(15,I)=K
            ILAB(15,I)=L
            IIAB(15,I)=INTCOR
            iisi(15,i)=sigcor
          else
            ISAB(16)=ISAB(16)+1
            I=ISAB(16)
            IF(I.GT.25)GOTO 2126
            IHAB(16,I)=H
            IKAB(16,I)=K
            ILAB(16,I)=L
            IIAB(16,I)=INTCOR
            iisi(16,i)=sigcor
          endif
        else
          if (imod(l,2).eq.0)then
            ISAB(17)=ISAB(17)+1
            I=ISAB(17)
            IF(I.GT.25)GOTO 2126
            IHAB(17,I)=H
            IKAB(17,I)=K
            ILAB(17,I)=L
            IIAB(17,I)=INTCOR
            iisi(17,i)=sigcor
          else
            ISAB(18)=ISAB(18)+1
            I=ISAB(18)
            IF(I.GT.25)GOTO 2126
            IHAB(18,I)=H
            IKAB(18,I)=K
            ILAB(18,I)=L
            IIAB(18,I)=INTCOR
            iisi(18,i)=sigcor
          endif
        endif
      goto 2126
2126  ENDIF
c
c   quicky fix  include initia totals as separate calculation
c   do not include checks
c
C  HERE FOR CALCULATING int SUMS FOR IDENTIFYING ABSENCES.
c  redefine indices
      iii=h
      jjj=k
      kkk=l
3407  IONE=III/2
      AIONE=III/2.
      JONE=JJJ/2
      AJONE=JJJ/2.
      KONE=KKK/2
      AKONE=KKK/2.
      IJONE=(III+JJJ)/2
      AIJONE=(III+JJJ)/2.
      IKONE=(III+KKK)/2
      AIKONE=(III+KKK)/2.
      JKONE=(JJJ+KKK)/2
      AJKONE=(JJJ+KKK)/2.
      IF(KKK.EQ.0.AND.IONE.NE.AIONE)CALL addup(1)
C  POINT GROUP 1 - H K 0, H=2N
      IF(JJJ.EQ.0.AND.IONE.NE.AIONE)CALL addup(2)
C  POINT GROUP 2 - H 0 L, H=2N
      IF(KKK.EQ.0.AND.JONE.NE.AJONE)CALL addup(3)
C  POINT GROUP 3 - H K 0, K=2N
      IF(III.EQ.0.AND.JONE.NE.AJONE)CALL addup(4)
C  POINT GROUP 4 - 0 K L, K=2N
      IF(JJJ.EQ.0.AND.KONE.NE.AKONE)CALL addup(5)
C  POINT GROUP 5 - H 0 L, L=2N
      IF(III.EQ.0.AND.KONE.NE.AKONE)CALL addup(6)
C  POINT GROUP 6 - 0 K L, L=2N
      IF(KKK.EQ.0.AND.IJONE.NE.AIJONE)CALL addup(7)
C  POINT GROUP 7 - H K 0, H+K=2N
      IF(JJJ.EQ.0.AND.IKONE.NE.AIKONE)CALL addup(8)
C  POINT GROUP 8 - H 0 L, H+L=2N
      IF(III.EQ.0.AND.JKONE.NE.AJKONE)CALL addup(9)
C  POINT GROUP 9 - 0 K L, K+L=2N
      IF(JJJ.EQ.0.AND.KKK.EQ.0.AND.IONE.NE.AIONE)CALL addup(10)
C  POINT GROUP 10 - H 0 0, H=2N
      IF(III.EQ.0.AND.KKK.EQ.0.AND.JONE.NE.AJONE)CALL addup(11)
C  POINT GROUP 11 - 0 K 0, K=2N
      IF(III.EQ.0.AND.JJJ.EQ.0.AND.KONE.NE.AKONE)CALL addup(12)
C  POINT GROUP 12 - O O L, L=2N
      IF(IKONE.NE.AIKONE)CALL addup(13)
C  POINT GROUP 13 - H K L, H+L=2N
      IF(IJONE.NE.AIJONE)CALL addup(14)
C  POINT GROUP 14 - H K L, H+K=2N
      IF(JKONE.NE.AJKONE)CALL addup(15)
C  POINT GROUP 15 - H K L, K+L=2N
      IF(IONE.NE.AIONE)CALL addup(16)
C  POINT GROUP 16 - H K L, H=2N
      IF(JONE.NE.AJONE)CALL addup(17)
C  POINT GROUP 17 - H K L, K=2N
      IF(KONE.NE.AKONE)CALL addup(18)
C  POINT GROUP 18 - H K L, L=2N
      IF(III.EQ.JJJ.AND.KONE.NE.AKONE)CALL addup(29)
C  POINT GROUP 29 - H H L, L=2N
      IJKONE=(III+JJJ+KKK)/2
      AIJKONE=(III+JJJ+KKK)/2.
      IF(IJKONE.NE.AIJKONE)CALL addup(19)
C  POINT GROUP 19 - H K L, H+K+L=2N
      IF(KKK.EQ.0.AND.IONE.NE.AIONE.AND.JONE.NE.AJONE)CALL addup(20)
C  POINT GROUP 20 - H K 0, H=2N, K=2N
      IF(JJJ.EQ.0.AND.IONE.NE.AIONE.AND.KONE.NE.AKONE)CALL addup(21)
C  POINT GROUP 21 - H 0 L, H=2N, L=2N
      IF(III.EQ.0.AND.JONE.NE.AJONE.AND.KONE.NE.AKONE)CALL addup(22)
C  POINT GROUP 22 - 0 K L, K=2N, L=2N
      IONE=III/4
      AIONE=III/4.
      JONE=JJJ/4
      AJONE=JJJ/4.
      KONE=KKK/4
      AKONE=KKK/4.
      IF(JJJ.EQ.0.AND.KKK.EQ.0.AND.IONE.NE.AIONE)CALL addup(23)
C  POINT GROUP 23 - H 0 0, H=4N
      IF(III.EQ.0.AND.KKK.EQ.0.AND.JONE.NE.AJONE)CALL addup(24)
C  POINT GROUP 24 - 0 K 0, K=4N
      IF(III.EQ.0.AND.JJJ.EQ.0.AND.KONE.NE.AKONE)CALL addup(25)
C  POINT GROUP 25 - O O L, L=4N
      IJONE=(III+JJJ)/4
      AIJONE=(III+JJJ)/4.
      IKONE=(III+KKK)/4
      AIKONE=(III+KKK)/4.
      JKONE=(JJJ+KKK)/4
      AJKONE=(JJJ+KKK)/4.
      IIKONE=(III+III+KKK)/4
      AIIKONE=(III+III+KKK)/4.
      IF(KKK.EQ.0.AND.IJONE.NE.AIJONE)CALL addup(26)
C  POINT GROUP 26 - H K 0, H+K=2N
      IF(JJJ.EQ.0.AND.IKONE.NE.AIKONE)CALL addup(27)
C  POINT GROUP 27 - H 0 L, H+L=2N
      IF(III.EQ.0.AND.JKONE.NE.AJKONE)CALL addup(28)
C  POINT GROUP 28 - 0 K L, K+L=2N
      IF(III.EQ.JJJ.AND.AIIKONE.NE.IIKONE)CALL addup(30)
C  POINT GROUP 30 - H H L, 2H+L=4N
      IONE=(-III+JJJ+KKK)/3
      AONE=(-III+JJJ+KKK)/3.
      IF(IONE.NE.AONE)CALL addup(31)
C  POINT GROUP 31 - H K L, -H+K+L=3N
      IONE=(III-JJJ+KKK)/3
      AONE=(-III+JJJ+KKK)/3.
      IF(IONE.NE.AONE)CALL addup(32)
C  POINT GROUP 32 - H K L, H-K+L=3N
      IONE=(KKK/3)
      AONE=(KKK/3.)
      IF(III.EQ.0.AND.JJJ.EQ.0.AND.IONE.NE.AONE)CALL addup(33)
C  POINT GROUP 33 - 0 0 L, L=3N
      IONE=(KKK/6)
      AONE=(KKK/6.)
      IF(III.EQ.0.AND.JJJ.EQ.0.AND.IONE.NE.AONE)CALL addup(34)
C  POINT GROUP 34 - 0 0 L, L=6N
      CALL addup(35)
C  35 KEEPS TRACK OF ALL REFLECTIONS
c
3050  IF(ILIST.EQ.1)THEN
      IF(NOL.EQ.78)THEN
      WRITE(3,3001)
      NOL=1
3001  FORMAT(1H1,'   ID     h     k     l    Ck    B1     Scan  ',
     1'   B2     Int      Sig    2Th     Phi     Chi    Time  ',
     2' Speed  TB/TS',/,/)
      ENDIF
      NOL=NOL+1  ! KEEPS TRACK OF NUMBER OF LINES
      IF(ID.GT.0)THEN
C  NOT A CHECK
      WRITE(3,3000)ID,H,K,L,IBG1,ISCAN,IBG2,INTCOR,SIGCOR,TTH,
     1PHIE,CHI,EXPTM,SPEED,TBTS
c  the last two fields f10.2,f7.2 for finet,sigmi no longer printed
3000  FORMAT(1X,4I6,5X,I7,I9,I7,F11.2,F8.2,F7.2,3F8.2,F7.2,
     1F6.2,f10.2,f7.2)
      ELSE  ! CHECK
      WRITE(3,3002)ID,H,K,L,ICK,IBG1,ISCAN,IBG2,INTCOR,SIGCOR,TTH,
     1PHIE,CHI,EXPTM,SPEED,TBTS
3002  FORMAT(1X,4I6,1X,1H(,I2,1H),I7,I9,I7,F11.2,F8.2,F7.2,3F8.2,
     1F7.2,F6.2,f10.2,f7.2)
      ENDIF
      ENDIF
      IF(IDCNT.EQ.LENGTH)GOTO 301
      GOTO 300 ! READ NEXT REFLECTION
301   ID=0  ! LAST REFLECTION MARKED WITH ID=0
      WRITE(OUT)ID,H,K,L,TTH,PHIE,CHI,RANGE,SPEED,BG1,SCAN,BG2,EXPTM,
     1 TBTS,ome,BL2,BL3
Caution
C   stick omega in background corrected intensity slot for possible later 
C   use.    One other such write above.
Caution
c
c  psiscan calcs here
c
      if (nrefl.eq.0)goto 513
      DO 5 J = 1, nrefl
      AINT(j,1) = (AINT(j,1) + AINT(j,npsi(j)))/2.0
c   reset to avoid possible confusion later on
      aint(j,npsi(j))=0
      AVGINT(j) = (SMINT(j)-aint(j,1)) / float(npsi(j)-1)
      DO 4 I = 1, npsi(j)-1
      CORR(j,I) = AINT(j,I) / AVGINT(j)
    4 CONTINUE
c
c  sort in increasing phi order
c
c  CAUTION aint, smint,avgint, npsi not sorted
c
c
      do l=1,npsi(j)-2
      do m=l+1,npsi(j)-1
      if (phi(j,m).lt.phi(j,l)) then
         temp=phi(j,m)
         phi(j,m)=phi(j,l)
         phi(j,l)=temp
         temp=corr(j,m)
         corr(j,m)=corr(j,l)
         corr(j,l)=temp
c         temp=aint(j,m)
c         aint(j,m)=aint(j,l)
c         aint(j,l)=temp
      endif
      enddo
      enddo
    5 CONTINUE
c
c
c switch reflections in order of increasing phi angle
c (by sorting initial scan of the six psi scan reflections)
c
c  replace npsi(1) with max
c
      maxnps=npsi(1)
      do j=1,nrefl
      if (npsi(j).gt.maxnps) maxnps=npsi(j)
      enddo
      do l=1,nrefl-1
      do m=l+1,nrefl
      if (phi(m,1).lt.phi(l,1)) then
         do n=1,maxnps-1
          temp=phi(m,n)
          phi(m,n)=phi(l,n)
          phi(l,n)=temp
          temp=corr(m,n)
          corr(m,n)=corr(l,n)
          corr(l,n)=temp
c          temp=aint(m,n)
c          aint(m,n)=aint(l,n)
c          aint(l,n)=temp
         enddo
         do n=1,3
          temp=hkl(m,n)
          hkl(m,n)=hkl(l,n)
          hkl(l,n)=temp
         enddo
c        temp=avgint(m)
c        avgint(m)=avgint(l)
c        avgint(l)=temp
c        temp=smint(m)
c        smint(m)=smint(l)
c        smint(l)=temp
c        temp=npsi(m)
c        npsi(m)=npsi(l)
c        npsi(l)=temp
      endif
      enddo
      enddo
c
c
c
c    stick in max value npsi here 
c
      npsicn=0
      npsico=6
      if (nrefl.lt.npsico) npsico=nrefl
      write (13,512) nrefl,maxnps-1,
     1               ((hkl(j,i),i=1,3),j=npsicn+1,npsico)
  512 format('1'/2x,2i4//'   #   ',<npsico-npsicn>('  hkl=',3i4,2x))
      do i=1,maxnps-1
      WRITE (13, 6) I,(phi(j,I), corr(j,I),j=npsicn+1,npsico)
    6 FORMAT (I4,<npsico-npsicn>( F12.2, F8.4))
      enddo
511   if (npsico.lt.nrefl) then
       npsicn=npsico
       npsico=npsico+6
       if (nrefl.lt.npsico) npsico=nrefl
       write (13,516) ((hkl(j,i),i=1,3),j=npsicn+1,npsico)
  516 format('1'/'   #   ',<npsico-npsicn>('  hkl=',3i4,2x))
       do i=1,maxnps-1
       WRITE(13,6) I,(phi(j,I),corr(j,I),j=npsicn+1,npsico)
       enddo
      endif
      if (npsico.lt.nrefl) goto 511
c
c  end psiscan insert here
c
c
  513 write(3,514)nref
      write(11,514)nref
  514 format(' The number of measured reflections is'i6'.')
          encode(80,53,card1) nref
53      FORMAT(' REFLECTIONS MEASURED: ',I5)
          call addOn(card1,27,IFLG)
        IF(IFLG.EQ.0)WRITE(3,1420)
1420    FORMAT('  Unable to write to .INF file.' )
c
      CLOSE(UNIT=OUT,DISP='SAVE')
      IF(CARD(1).NE.'END ')GOTO 25 ! READ NEXT FILE FROM SAME TAPE
      IF(NTOT.NE.0)THEN
C  LISTING DELETED REFLECTIONS
      WRITE(3,304)
304   FORMAT(//,' These reflections have been deleted and are not',
     1' included on the mag file: ',/)
      IF(NTOT.GE.500)WRITE(3,305)
305   FORMAT(' Note - only the first 500 reflections are listed here.')
      I=0
302   I=I+1
      I1=15*I-14
      I2=15*I
      IF(NTOT.LT.I2)I2=NTOT
      WRITE(3,303)(IDEL(II),II=I1,I2)
303   FORMAT(1X,15(I6,1X))
      IF(I2.LT.NTOT)GOTO 302
      ENDIF
      IF(NOE.NE.0) then
       WRITE(3,3031)
       WRITE(11,3031)
3031   FORMAT(/,I5,' Errors occurred while decoding.')
      endif
c
C  WRITING OUT LIST FOR SPACE GROUP ABSENCES
c
      write(11,3047)
3047  format(//' No check reflections are included in ',
     1       'specialized lists.'/)
c
c   write lines
c
      do 3042 ii=1,3
      m=2*ii
      j=m-1
      i=isab(j)+isab(m)
      WRITE(11,3032)absent(ii),i
3032  FORMAT(//' Reflections of type 'A5':  Total number: ',i5)
      if (i.le.0) goto 3042
      IF(isab(j).GT.25 .or. isab(m).gt.25)THEN
        if(isab(j).gt.25) isab(j)=25
        if(isab(m).gt.25) isab(m)=25
        i=isab(j)+isab(m)
        WRITE(11,3033)i
3033  FORMAT(' Only'I3' are listed.')
      ENDIF
      nn=1
      n=0
      if(isab(j).lt.isab(m))then
      n=j
      j=m
      m=n
      nn=2
      endif
      n=isab(j)-isab(m)
      write(11,3045) index(ii),parity(nn),index(ii),parity(nn+1)
3045  format(2(1x,a1,1x,a4,46x))
      WRITE(11,3034)
3034  FORMAT('      h     k     l       Int     Sig                 h  '
     1,'   k     l      Int      Sig')
      WRITE(11,3035)(IHAB(j,I),IKAB(j,I),ILAB(j,I),IIAB(j,I),iisi(j,i),
     1 IHAB(m,I),IKAB(m,I),ILAB(m,I),IIAB(m,I),iisi(m,i),I=1,isab(m))
3035  FORMAT(I7,I6,I6,F11.2,f9.2,10X,I6,I6,I6,F11.2,f9.2)
      if (n.ne.0)then
      WRITE(11,3041)(IHAB(j,I),IKAB(j,I),ILAB(j,I),IIAB(j,I),
     1 iisi(j,i),I=1,n)
3041  FORMAT(I7,I6,I6,F11.2,f9.2)
      endif
3042  continue
c
c   write planes
c
      write(11,3044)
3044  format(///' Only indices of 5 or less included below.')
      do 3043 ii=1,3
      ind1=(ii+1)/2
      ind2=(ii+4)/2
      j=4*ii+3
      m=j+1
      jj=m+1
      mm=jj+1
      i=isab(j)+isab(m)+isab(jj)+isab(mm)
      WRITE(11,3032)absent(ii+3),i
      if (i.le.0) goto 3043
      if (isab(j).gt.25 .or. isab(m).gt.25   .or.
     1   isab(jj).gt.25 .or. isab(mm).gt.25) then
        if(isab(j).gt.25) isab(j)=25
        if(isab(m).gt.25) isab(m)=25
        if(isab(jj).gt.25) isab(jj)=25
        if(isab(mm).gt.25) isab(mm)=25
        i=isab(j)+isab(m)+isab(jj)+isab(mm)
        WRITE(11,3033)i
      endif
      if (j+m.le.0) goto 3048
      nn=1
      n=0
      if(isab(j).lt.isab(m))then
      n=j
      j=m
      m=n
      nn=2
      endif
      n=isab(j)-isab(m)
      write(11,3046) index(ind1),parity(1),index(ind2),parity(nn),
     1              index(ind1),parity(1),index(ind2),parity(nn+1)
3046  format(2(1x,a1,1x,a4,3x,a1,1x,a4,37x))
      WRITE(11,3034)
      WRITE(11,3035)(IHAB(j,I),IKAB(j,I),ILAB(j,I),IIAB(j,I),iisi(j,i),
     1 IHAB(m,I),IKAB(m,I),ILAB(m,I),IIAB(m,I),iisi(m,i),I=1,isab(m))
      if (n.ne.0)then
      WRITE(11,3041)(IHAB(j,I),IKAB(j,I),ILAB(j,I),IIAB(j,I),
     1 iisi(j,i),I=1,n)
      endif
3048  if (jj+mm.le.0) goto 3043
      nn=1
      n=0
      if(isab(jj).lt.isab(mm))then
      n=jj
      jj=mm
      mm=n
      nn=2
      endif
      n=isab(jj)-isab(mm)
        write(11,3046) index(ind1),parity(2),index(ind2),parity(nn),
     1              index(ind1),parity(2),index(ind2),parity(nn+1)
      WRITE(11,3035)(IHAB(jj,I),IKAB(jj,I),ILAB(jj,I),IIAB(jj,I),
     1 iisi(jj,i),IHAB(mm,I),IKAB(mm,I),ILAB(mm,I),IIAB(mm,I),
     2 iisi(mm,i),I=1,isab(mm))
      if (n.ne.0)then
      WRITE(11,3041)(IHAB(jj,I),IKAB(jj,I),ILAB(jj,I),IIAB(jj,I),
     1 iisi(jj,i),I=1,n)
      endif
3043  continue
      WRITE(11,1202)  ! WRITING POINT GROUP SUMS  
1202  FORMAT('1','  Symmetry Code           N      Sum(Int)',
     1'      <Int>        <Sig>',/)
      DO I=1,35
        if(isym(i).ne.0)then
          iisym(i,1)=isym(i)
          iisym(i,3)=iisym(i,2)/iisym(i,1)
          iisym(i,4)=iisym(i,4)/iisym(i,1)
        ENDIF
        WRITE(11,1203)SUMS(I),isym(i),iisym(i,2),iisym(i,3),iisym(i,4)
1203    FORMAT(2X,A20,1X,I6,F14.2,F13.2,F11.2)
      ENDDO
      write(11,1204)
1204  format(//////)
      RETURN
c
c   error printout
c
5039  if (char(1:1).eq.'$')goto300
      WRITE(3,5038) char(2:63)
5038  FORMAT(' error decoding ntyp ',a62)
      goto 515
5041  WRITE(3,5040) ntyp,char(2:63)
5040  FORMAT(' error decoding type',i3,' record: ',a62)
      goto 515
5043  WRITE(3,5042) char(2:63)
5042  FORMAT(' decoding error - format or mismatched id numbers',a62)
      goto 515
  515 NOL=NOL+1
      NOE=NOE+1
      goto 300
      END
	SUBROUTINE ANGLES(PHIK,KAPPA,omk,PHIE,CHI,ome)
	REAL KAPPA
	RAD = 180./ACOS(-1.)
C
C	CALTECH CAD4 DIFFRACTOMETER CONSTANTS (1984)
C
	CON1 = 0.5869781	!SIN(ALF**2)
	CON2 = 0.6426679	!COS(ALF)
	SINALF = SQRT(CON1)
	RKAP = KAPPA/(2.*RAD)	!KAPPA/2 IN RADS
	SINHC = SINALF * SIN(RKAP)
	COSHC = SQRT(CON2**2 + CON1*COS(RKAP)*COS(RKAP))
	CHI = 2. * RAD * ASIN(SINHC)	!CHI IN DEGS
	SINDEL = CON2*SIN(RKAP)/COSHC
	COSDEL = COS(RKAP)/COSHC
	DELTA = RAD * ASIN(SINDEL)
	OME = OMK + DELTA
	PHIE = PHIK + DELTA
	IF(PHIE.LT.0.)  PHIE = PHIE + 360.
  900	RETURN
	END
      SUBROUTINE addup(I)
      real*4 fftot(35,4),intcor
      integer*2 noof(35) 
      COMMON/fadduP/NOOF,FFTOT,ff,ss
C  THIS SUBROUTINE KEEPS TRACK OF F*F  SUMS FOR 28 POINT
C  GROUPS AND FOR ALL REFLECTIONS.   THIS WILL HELP IN
C  DETERMINING SPACE GROUP ABSENCES.  
      NOOF(I)=NOOF(I)+1
      fftot(i,2)=fftot(i,2)+ff
      fftot(i,4)=fftot(i,4)+ss
      RETURN
      END
