C           QCOS ROUTINE FROM REEKE FOURIER
C         TABLE IS OF C(TH)=.25(COS(TH-E)+2COS(TH)+COS(TH+E))
C             AT INTERVALS TH=(N+1/2)E AND N=0,1023  E=2PI/1024
C          TO EVALUATE COS (X)
C          FIND TH SUCH THAT TH-E/2 < X < TH+E/2
C          COS(X) = C(TH)-(X-TH)*S(TH)        S(TH)=C(TH-PI/2)
C                  
C           INPUT IS R OUTPUT IS VALU
      SUBROUTINE QCOS
      INTEGER*4 ARG,S,SHR,MSK1023,FOURTH
      COMMON /Q/R,VALU
      COMMON /CSSN/SC,C
      DIMENSION SC(1024),C(1024),
     +          SCTB(2050)
       EQUIVALENCE (SC(1),SCTB(1)),
     +             (C(1),SCTB(1025))
      PARAMETER (S=24)
      PARAMETER (MSK1023=1023)
      PARAMETER (SHR=15)
      PARAMETER (FOURTH=256)        ! FOR SIN
C        COS ENTRY HERE
        R1024=R*1024.              ! COSINE IS BETWEEN ENTRIES IN TABLE
        IF(R.LT.0.0)R1024=-R1024
       ARG=R1024+0.5
      COR=R1024-ARG-0.5
         ARG=ARG+1              ! INDEX FRON 1 TO 1024
1      IF(ARG.LT.0)ARG=-ARG
      IF(ARG.GT.1024)THEN
       ARG=IAND(ARG,MSK1023)
      ENDIF
       VALU=C(ARG)              
      COR=COR*SC(ARG)
      VALU=VALU-COR
      RETURN
      ENTRY QSIN
      IF(R.EQ.0.0)THEN
      VALU=0.0
      RETURN
      ENDIF
       R1024=R*1024
       IF(R.GT.0)THEN    
      ARG=R1024-0.5
      COR=R1024-ARG+0.5
      ELSE                                         
       ARG=R1024+0.5
       COR=R1024-ARG-0.5
      ARG=ARG+1
      ENDIF
       IF(ARG.LT.257)THEN       
        ARG=ARG-1
          COR=COR*-1.
       ENDIF
       ARG=ARG-FOURTH
       GO TO 1
      END
