       SUBROUTINE RKFINT
C      PROGRAM SETS CODE AND DOES INITIALIZATION ACCORDING TO SPACE
C      GROUP. INITIALIZED VALUES AND CODE WORDS ARE PASSED IN COMMON
      BYTE NGN(9)               
      BYTE LAUETB(12)
      BYTE MULTAB(2,12)      ! INDEXED BY LAUE NUMBER
       BYTE WORDS (2,6,16)
       INTEGER*2 ATRIG(4,17),BTRIG(4,17)
      INTEGER*2 SSS,MSKF,DONE,SGC,OR,DEC,SGCB
      CHARACTER*1 N,A,L
      INTEGER*2 SPGA(9),SPGN(3),SPA(9),SPN(3)
      DIMENSION FROM(8),TO(8)           ! DEFAULT BOUNDS
      COMMON/CALC/SHRPB,SHPR,SHPA,SHPE,SHPC,SHPD,TWOB,CUTA,CUTB,CUTC,
     +FSCALE,PSCALE,PRTOP,XFRACT,DL1V,LOWX,HIGHX,CENX,DIRX,ORIENT,CUTOFF
     +,SS,SB1,SB2,SB3,SB4,FPK,FPLT,MSC,SGSV
C CALC
      REAL LOWX(3),HIGHX(3)
      DIMENSION XFRACT(3),CENX(3),DIRX(3),SS(6)
      INTEGER PRTOP
      INTEGER*2 ORIENT(2),SGSV
      BYTE SHRPB,CUTOFF,SB1,SB2,SB3,SB4,FPK,FPLT,MSC
      COMMON /INIT/ACODE,BCODE,SPG,SPGL,MGO,SYMGO,PAR,GPAR,CEN,LAUE,ACN,
     + FZ,VSCALE,CUT,GD,GEN,NGEN,NOAS,SGA,SGR,GP,PRJ,SCT,TRD,TSC,TS,MNP,
     + HR2,HR1,RX1,RX2,RX3,INCHES,PV,PH,INCHOR,INCHV,HM(6),LB,LR,LS,TWT,
     + LRJCT,SCRD,DHORIZ,DVERTI
C  INIT
      BYTE MGO,SYMGO,CEN,ACN,FZ,CUT,GD,GEN,NGEN,NOAS,SGA(4),SGR(4),GP,
     + PRJ,SCT,TRD,TSC,TS,MNP,LB(3),LR,LS,TWT,LRJCT,SCRD,SQG
      INTEGER*2 ACODE(8,8),BCODE(8,8),SPG,PAR,GPAR,LAUE,HR2,HR1,RX1,
     + RX2,RX3
      REAL*4 INCHES,INCHOR,INCHV
      CHARACTER*1 SPGL
      COMMON IS1,IS2,IS3,IS4,IS5,IS6,SCF,B2,CARD,IT1,IT2
C  CODES FOR REEKE FOURIER CD(21,242)  INCLUDES SPECIAL SPACE GROUPS
C  21 BYTES PER SPACE GROUP.
C 1 ST BYTE IS PATTERSON NUMBER-1,SECOND IS LAUE GROUP, THIRD INDICATES
C  CENTRIC OR ACENTRIC AND IS 1 OR 0,( 0 MEANS ACENTRIC),
C  4TH IS CENTERING : 1,2,3,4,5,6  FOR  A,B,C,F,I,R
C  5TH SIGNALS IST DIM PARITY CHANGE IN GEN ROUTINE AND SCREW AXIS,
C  6TH 1ST DIM PARITY, 7-14 ARE 8 EXPRESSION CODES,
C  15-17 ARE BOUNDS CODES, 18 SIGNAL FOR ORTH TET OR CUBIC,
C  19 IS PARITY FOR GENERATING ROUTINE, 20-21 ARE SIGN CODES FOR GEN.
      INTEGER*2 CD,cd1,cd2,cd3
      dimension CD1(21,90),CD2(21,90),CD3(21,62)
      EQUIVALENCE (CD(1,1),CD1(1,1)),(CD(1,91),CD2(1,1)),
     +(CD(1,181),CD3(1,1))
      DIMENSION CD(21,242)
      DATA CD1/1,0,0,0,0,0,6*0,9,9,4,4,4,0,3*0,     !1
     +        1,0,1,0,0,0,7*0,9,4,1,4,4*0,         !2
     +        9,1,0,0,0,0,6*0,5,5,1,4,4,4*0,       !3
     +        9,1,0,0,0,2,4*0,7,7,5,5,4,1,4,4*0,   !4
     +       11,1,0,3,0,0,6*0,5,5,1,1,4,4*0,       !5
     +        9,1,0,0,0,0,6*0,7,5,4,1,4,4*0,       !6
     +        9,1,0,0,0,3,4*0,5,7,7,5,4,1,4,4*0,   !7
     +       11,1,0,3,0,0,6*0,7,5,4,2,4,4*0,       !8
     +       11,1,0,3,0,3,4*0,5,7,7,5,4,2,4,4*0,   !9
     +        9,1,1,0,0,0,7*0,5,1,1,4,4*0,           !10
     +        9,1,1,0,0,2,6*0,7,5,4,2,4,4*0,       !11
     +       11,1,1,3,0,0,7*0,5,1,2,4,4*0,         !12
     +        9,1,1,0,0,3,6*0,7,5,1,1,4,4*0,       !13
     +        9,1,1,0,0,5,6*0,7,5,4,2,4,4*0,       !14
     +       11,1,1,3,0,3,6*0,7,5,1,2,4,4*0,       !15
C      ORTHORHOMBIC BEGINS HERE
     +       46,2,0,0,0,0,6*0,1,1,1,1,4,1,3*0,              !16
     +       46,2,0,0,0,3,4*0,3,4,1,1,1,1,4,1,3*0,          !17
     +       46,2,0,0,0,4,4*0,2,2,1,1,1,1,4,1,3*0,          !18
     +       46,2,0,0,0,13,2,2,4,3,3,4,1,1,1,1,4,1,3*0,     !19
     +       64,2,0,3,0,3,4*0,3,4,1,1,2,1,4,1,3*0,          !20
     +       64,2,0,3,0,0,6*0,1,1,2,1,4,1,3*0,              !21
     +       68,2,0,5,0,0,6*0,1,1,2,2,4,1,3*0,              !22
     +       70,2,0,4,0,0,6*0,1,1,2,1,4,1,3*0,              !23
     +       70,2,0,4,0,10,3,4,2,2,4,3,1,1,2,1,4,1,3*0,     !24
     +       46,2,0,0,0,0,6*0,2,1,1,1,4,1,3*0,              !25
     +       46,2,0,0,0,3,4*0,4,4,2,1,1,1,4,1,3*0,          !26
     +       46,2,0,0,0,3,4*0,1,2,2,1,1,1,4,1,3*0,          !27
     +       46,2,0,0,0,1,4*0,1,2,2,1,2,4,4,1,3*0,          !28
     +       46,2,0,0,0,11,4,4,1,2,3,3,2,1,2,4,4,1,3*0,     !29
     +       46,2,0,0,0,5,4*0,1,2,2,1,1,4,1,1,3*0,          !30
     +       46,2,0,0,0,6,4*0,4,4,2,1,1,1,4,1,3*0,          !31
     +       46,2,0,0,0,4,4*0,1,2,2,1,2,4,4,1,3*0,          !32
     +       46,2,0,0,0,15,4,4,1,2,3,3,2,1,2,4,4,1,3*0,     !33
     +       46,2,0,0,0,7,4*0,1,2,2,1,2,4,4,1,3*0,          !34
     +       64,2,0,3,0,0,6*0,2,1,2,1,4,1,3*0,              !35
     +       64,2,0,3,0,3,4*0,4,4,2,1,2,1,4,1,3*0,          !36
     +       64,2,0,3,0,3,4*0,1,2,2,1,2,1,4,1,3*0,          !37
     +      241,2,0,1,0,0,6*0,2,1,1,2,4,1,3*0,              !38
     +      241,2,0,1,0,2,4*0,1,2,2,1,1,2,4,1,3*0,          !39
     +      241,2,0,1,0,1,4*0,1,2,2,1,2,1,4,1,3*0,          !40
     +      241,2,0,1,0,4,4*0,1,2,2,1,1,2,4,1,3*0,          !41 PAR=4 TEST
     +       68,2,0,5,0,0,6*0,2,1,2,1,1,1,3*0,              !42
     +       68,2,0,5,0,18,11,11,1,2,10,10,2,1,2,2,4,1,3*0, !43
     +       70,2,0,4,0,0,4*0,1,2,2,1,2,1,4,1,3*0,          !44
     +       70,2,0,4,0,3,4*0,1,2,1,2,2,1,4,1,3*0,          !45
     +       70,2,0,4,0,1,4*0,1,2,1,2,2,4,1,1,3*0,          !46
     +       46,2,1,0,0,0,7*0,1,1,1,1,1,3*0,                !47
     +       46,2,1,0,0,13,4*0,3,4,2,1,5,4,2,1,3*0,         !48
     +       46,2,1,0,0,3,6*0,2,1,1,1,1,1,3*0,              !49
     +       46,2,1,0,0,10,4*0,2,4,3,1,2,4,1,1,3*0,         !50
     +       46,2,1,0,0,1,6*0,3,1,2,1,4,1,3*0,              !51
     +       46,2,1,0,0,16,4*0,3,4,2,1,1,2,4,1,3*0,         !52
     +       46,2,1,0,0,6,6*0,4,1,2,1,4,1,3*0,              !53
     +       46,2,1,0,0,11,4*0,4,3,2,1,2,1,4,1,3*0,         !54
     +       46,2,1,0,0,4,6*0,2,1,2,4,1,1,3*0,              !55
     +       46,2,1,0,0,14,4*0,3,4,2,1,2,4,1,1,3*0,         !56
     +       46,2,1,0,0,12,4*0,3,2,4,1,1,4,2,1,3*0,         !57
     +       46,2,1,0,0,7,6*0,2,1,2,4,1,1,3*0,              !58
     +       46,2,1,0,0,10,4*0,2,3,4,1,5,5,1,1,3*0,         !59
     +       46,2,1,0,0,15,4*0,2,3,4,1,2,1,4,1,3*0,         !60
     +       46,2,1,0,0,13,4*0,2,3,4,1,2,4,1,1,3*0,         !61
     +       46,2,1,0,0,17,4*0,4,3,2,1,1,2,4,1,3*0,         !62
     +       64,2,1,3,0,3,6*0,4,1,2,4,2,1,3*0,              !63
     +       64,2,1,3,0,5,6*0,4,1,2,4,2,1,3*0,              !64
     +       64,2,1,3,0,0,7*0,1,2,1,1,1,3*0,                !65
     +       64,2,1,3,0,3,6*0,2,1,2,1,1,1,3*0,              !66
     +       64,2,1,3,0,1,6*0,4,1,2,2,4,1,3*0,              !67
     +       64,2,1,3,0,12,4*0,4,3,2,1,2,2,4,1,3*0,         !68
     +       68,2,1,5,0,0,7*0,1,2,2,1,1,3*0,                !69
     +       68,2,1,5,0,23,15,3,4,14,2,13,12,1,3,6,4,1,3*0, !70
     +       70,2,1,4,0,0,7*0,1,2,1,1,1,3*0,                !71
     +       70,2,1,4,0,3,6*0,2,1,2,1,1,1,3*0,              !72
     +       70,2,1,4,0,10,4*0,4,2,3,1,2,1,1,1,3*0,         !73
     +       70,2,1,4,0,2,6*0,4,1,2,2,4,1,3*0,              !74
C       LAUE=3
     +    82,3,0,0,0,0,6*0,6,6,1,1,4,1,3*0,                 !75
C2345678901
     +    82,3,0,0,0,3,4*0,8,8,6,6,4,4,2,1,22,'63'X,'50'X,  !76
     +    82,3,0,0,0,0,6*0,6,6,4,1,1,1,0,0,'30'X,           !77
     +    82,3,0,0,0,3,4*0,8,8,6,6,4,4,2,1,22,'53'X,'60'X,  !78
     +    86,3,0,4,0,0,6*0,6,6,1,1,1,1,3*0,                 !79
     +    86,3,0,4,0,0,6*0,6,6,1,4,2,1,21,'63'X,'50'X,      !80
     +    82,3,0,0,0,0,6*0,6,6,1,4,1,1,0,0,1,               !81
     +    86,3,0,4,0,0,6*0,6,6,1,1,1,1,0,0,1,             !82
     +    82,3,1,0,0,0,7*0,6,1,1,1,1,3*0,                   !83
     +    82,3,1,0,0,0,7*0,6,1,1,1,1,3,0,'20'X,             !84
     +    82,3,1,0,0,4,6*0,8,6,2,4,1,1,2,0,'20'X,           !85
     +    82,3,1,0,0,4,6*0,8,6,5,4,2,1,6,0,'20'X,            !86
     +    86,3,1,4,0,0,7*0,6,1,1,2,1,3*0,                   !87
     +    86,3,1,4,4,2,6*0,8,6,1,5,2,1,9,0,'20'X,           !88
C     LAUE=4
     +122,4,0,0,0,0,6*0,1,1,1,1,1,1,0,0,1,                 !89
     +122,4,0,0,0,4,4*0,2,2,1,1,1,1,1,1,0,0,1/             !90
      DATA CD2/122,4,0,0,0,3,4*0,4,3,1,1,1,1,4,1,22,'72'X,'41'X,  !91
     +122,4,0,0,0,19,17,17,2,2,16,16,1,1,1,1,1,1,3,0,'21'X,  !92
     +122,4,0,0,0,0,6*0,1,1,1,4,2,1,3,0,'21'X,               !93
     +122,4,0,0,0,7,4*0,2,2,1,1,1,4,2,1,0,0,1,                !94
     +122,4,0,0,0,3,4*0,4,3,1,1,1,1,4,1,22,'42'X,'71'X,       !95
     +122,4,0,0,0,19,16,16,2,2,17,17,1,1,1,1,1,1,3,0,'21'X,   !96
     +138,4,0,4,0,0,6*0,1,1,1,1,2,1,0,0,1,                    !97
     +138,4,0,4,4,20,11,10,2,2,10,11,1,1,1,4,3,1,0,0,1,       !98
     +122,4,0,0,0,0,6*0,2,1,1,1,4,1,3*0,                      !99
     +122,4,0,0,0,4,4*0,1,2,2,1,1,1,4,1,4,0,'30'X,           !100
     +122,4,0,0,0,3,4*0,1,2,2,1,1,4,1,1,0,0,0,               !101
     +122,4,0,0,0,7,4*0,1,2,2,1,1,4,1,1,3*0,                 !102
     +122,4,0,0,0,3,4*0,1,2,2,1,1,1,1,1,3,0,'30'X,           !103
     +122,4,0,0,0,7,4*0,1,2,2,1,1,1,1,1,7,0,'30'X,           !104
     +122,4,0,0,0,0,6*0,2,1,1,1,1,1,3,0,'30'X,                !105
     +122,4,0,0,0,4,4*0,1,2,2,1,1,1,1,1,7,0,'30'X,           !106
     +138,4,0,4,0,0,6*0,2,1,1,1,1,1,3*0,                     !107
     +138,4,0,4,0,3,4*0,1,2,2,1,1,1,1,1,3,0,'30'X,           !108
     +138,4,1,4,0,0,6*0,2,1,1,1,2,1,20,'53'X,'60'X,          !109
     +138,4,0,4,0,3,4*0,1,2,2,1,1,1,2,1,20,'63'X,'50'X,      !110
     +122,4,1,0,0,0,6*0,1,1,1,4,1,1,3*0,                     !111
     +122,4,0,0,0,3,4*0,2,2,1,1,1,1,1,1,3,0,'30'X,           !112
     +122,4,0,0,0,4,4*0,2,2,1,1,1,4,1,1,4,0,'30'X,           !113
     +122,4,0,0,0,7,4*0,2,2,1,1,1,1,1,1,7,0,'30'X,           !114
     +122,4,0,0,0,0,6*0,2,1,1,1,1,1,0,0,1,                   !115
     +122,4,0,0,0,3,4*0,1,2,2,1,1,4,2,1,3,0,'21'X,           !116
     +122,4,0,0,0,4,4*0,1,2,2,1,1,1,1,1,4,0,'21'X,           !117
     +122,4,0,0,0,7,4*0,1,2,2,1,1,4,2,1,7,0,'21'X,           !118
     +138,4,0,4,0,0,6*0,2,1,1,1,2,1,0,0,1,                   !119
     +138,4,0,4,0,3,4*0,1,2,2,1,1,1,2,1,3,0,'21'X,           !120
     +138,4,0,4,0,0,6*0,1,1,1,4,2,1,3*0,                     !121
     +138,4,0,4,4,21,10,11,2,2,11,10,1,1,1,1,1,1,21,'63'X,'50'X, !122
     +122,4,0,0,0,0,7*0,1,1,1,1,1,3*0,                            !123
     +122,4,1,0,0,3,6*0,2,1,1,1,2,1,3,0,'20'X,                   !124
     +122,4,1,0,4,10,4*0,2,4,3,1,2,4,1,1,4,0,'20'X,              !125
     +122,4,1,0,4,13,4*0,3,4,2,1,5,5,2,1,7,0,'20'X,              !126
     +122,4,1,0,0,4,6*0,2,1,1,1,1,1,4,0,'20'X,                   !127
     +122,4,1,0,0,7,6*0,2,1,1,1,2,1,7,0,'20'X,                   !128
     +122,4,1,0,4,10,4*0,2,3,4,1,2,4,1,1,3*0,                    !129
     +122,4,1,0,4,13,4*0,4,3,2,1,2,4,2,1,3,0,'20'X,              !130
     +122,4,1,0,0,0,7*0,1,1,1,2,1,3,0,'20'X,                     !131
     +122,4,1,0,0,3,6*0,2,1,1,1,1,1,3*0,                         !132
     +122,4,1,0,4,10,4*0,2,4,3,1,2,4,2,1,7,0,'20'X,              !133
     +122,4,1,0,4,13,4*0,3,4,2,1,5,4,2,1,4,0,'20'X,              !134
     +122,4,1,0,0,4,6*0,2,1,1,1,2,1,7,0,'20'X,                   !135
     +122,4,1,0,0,7,6*0,2,1,1,4,2,1,3*0,                         !136
     +122,4,1,0,4,10,4*0,2,3,4,1,5,5,2,1,3,0,'20'X,              !137
     +122,4,1,0,4,13,4*0,4,3,2,1,2,4,2,1,3*0,                    !138
     +138,4,1,4,0,0,7*0,1,1,1,2,1,3*0,                           !139
     +138,4,1,4,0,3,6*0,2,1,1,1,2,1,3,0,'20'X,                   !140
     +138,4,1,4,4,2,6*0,4,1,2,2,4,1,8,0,'20'X,                   !141
     +138,4,1,4,4,10,4*0,4,2,3,1,2,2,4,1,9,0,'20'X,              !142
C   LAUE = 7
     +146,7,0,0,0,0,6*0,9,9,4,4,4,0,3*0,                         !143
     +146,7,0,0,1,0,6*0,9,9,4,4,7,0,24,'0B'X,0,                  !144
     +146,7,0,0,1,0,6*0,9,9,4,4,7,0,24,'0A'X,0,                  !145
     +147,7,0,6,0,0,6*0,9,9,4,4,7,4*0,                           !146
     +146,7,1,0,0,0,7*0,9,4,4,1,4*0,                             !147
     +147,7,1,6,0,0,7*0,9,1,4,7,4*0,                             !148
C      LAUE = 11    AND LAUE = 8
     +161,11,0,0,0,0,6*0,9,9,4,4,1,3*0,1,                        !149
     +163,8,0,0,0,0,6*0,9,9,4,4,1,4*0,                           !150
     +161,11,0,0,1,0,6*0,9,9,4,4,7,0,24,'0B'X,1,                 !151
     +163,8,0,0,1,0,6*0,9,9,4,4,7,0,24,'0B'X,0,                  !152
     +161,11,0,0,1,0,6*0,9,9,4,4,7,0,24,'0A'X,1,                 !153
     +163,8,0,0,1,0,6*0,9,9,4,4,7,0,24,'0A'X,0,                  !154
     +165,8,0,6,0,0,6*0,9,9,4,4,7,4*0,                           !155
     +163,8,0,0,0,0,6*0,9,9,4,4,4,0,0,0,1,                       !156
     +161,11,0,0,0,0,6*0,9,9,1,4,4,0,3*0,                        !157
     +163,8,0,0,0,0,6*0,9,9,4,4,1,0,3,0,'21'X,                   !158
     +161,11,0,0,0,0,6*0,9,9,4,4,1,0,3,0,'30'X,                  !159
     +165,8,0,6,0,0,6*0,9,9,4,4,7,0,0,0,1,                       !160
     +165,8,0,6,0,0,6*0,9,9,4,4,0,0,3,0,'21'X,                   !161
     +161,11,1,0,0,0,7*0,9,4,4,1,4*0,                            !162
     +161,11,1,0,0,0,7*0,9,4,4,2,0,3,0,'30'X,                    !163
     +163,8,1,0,0,0,7*0,9,4,4,1,4*0,                             !164
     +163,8,1,0,0,0,7*0,9,4,4,2,0,3,0,'30'X,                     !165
     +165,8,1,6,0,0,7*0,9,4,4,0,4*0,                             !166
     +165,8,1,6,0,0,7*0,9,4,4,0,0,3,0,'30'X,                     !167
C  LAUE = 9
     +179,9,0,0,0,0,6*0,6,6,1,4,4,4*0,                           !168
     +174,9,0,0,0,0,4*0,8,8,6,6,4,4,0,0,25,8,0,                  !169
     +174,9,0,0,0,3,4*0,8,8,6,6,4,4,0,0,25,9,0,                  !170
     +174,9,0,0,0,0,6*0,6,6,4,4,7,0,24,'0A'X,0,                  !171
     +174,9,0,0,0,0,6*0,6,6,4,4,7,0,24,'0B'X,0,                  !172
     +174,9,0,0,0,3,4*0,8,8,6,6,4,4,1,0,3,'30'X,0,               !173
     +174,9,0,0,0,0,6*0,8,6,4,4,1,0,0,1,0,                       !174
     +174,9,1,0,0,0,7*0,6,1,4,1,4*0,                             !175
     +174,9,1,0,0,3,6*0,8,6,4,4,2,0,3,'30'X,0,                   !176
C   LAUE = 10
     +190,10,0,0,0,0,6*0,6,6,1,4,1,0,0,0,1,                      !177
     +190,10,0,0,2,3,4*0,8,8,6,6,4,4,0,0,25,8,8,                 !178
     +190,10,0,0,2,3,4*0,8,8,6,6,4,4,0,0,25,9,9,                 !179
     +190,10,0,0,2,0,6*0,6,6,4,4,0,0,24,'0A'X,'0A'X/             !180
      DATA CD3/190,10,0,0,2,0,6*0,6,6,4,4,0,0,24,'0B'X,'0B'X,     !181
     +190,10,0,0,0,3,4*0,8,8,6,6,4,4,2,0,3,'30'X,'21'X,          !182
     +190,10,0,0,0,0,6*0,6,6,1,4,4,4*0,                          !183
     +190,10,0,0,0,0,6*0,6,6,1,4,1,0,3,0,'30'X,                  !184
     +190,10,0,0,0,3,4*0,8,8,6,6,4,4,1,0,3,'30'X,'00'X,          !185
     +190,10,0,0,0,3,4*0,8,8,6,6,4,4,1,0,3,'30'X,'30'X,          !186
     +190,10,0,0,0,0,6*0,8,6,4,4,1,0,0,1,1,                      !187
     +190,10,0,0,0,3,4*0,6,8,8,6,4,4,2,0,3,'21'X,'11'X,          !188
     +190,10,0,0,0,0,6*0,8,6,4,4,1,0,0,1,0,                      !189
     +190,10,0,0,0,3,4*0,6,8,8,6,4,4,2,0,3,'21'X,'30'X,          !190
     +190,10,1,0,0,0,7*0,6,1,4,1,4*0,                            !191
     +190,10,1,0,0,0,7*0,6,1,4,2,0,3,0,'30'X,                    !192
     +190,10,1,0,0,3,6*0,8,6,1,4,2,0,3,'30'X,0,                  !193
     +190,10,1,0,0,3,6*0,8,6,4,4,2,0,3,'30'X,'30'X,              !194
C      LAUE = 5
     +190,5,0,0,0,0,6*0,1,1,1,1,4,10,3*0,                        !195
     +190,5,0,5,0,0,6*0,1,1,2,1,1,10,3*0,                        !196
     +203,5,0,4,0,0,6*0,1,1,1,1,1,10,3*0,                        !197
     +199,5,10,0,4,13,2,2,4,3,3,4,1,1,1,1,4,10,3*0,              !198
     +203,5,0,4,4,13,2,2,4,3,3,4,1,1,1,1,1,10,3*0,              !199 
     +199,5,1,0,0,0,7*0,1,1,1,1,10,3*0,                          !200
     +199,5,1,0,0,13,4*0,3,4,2,1,5,5,1,10,3*0,                   !201
     +201,5,1,5,0,0,7*0,1,2,2,1,10,3*0,                         !202
     +201,5,1,5,4,23,15,3,4,14,2,13,12,1,3,6,4,10,3*0,          !203
     +203,5,1,4,0,0,7*0,1,2,1,1,10,3*0,                         !204
     +199,5,1,0,4,13,4*0,2,3,4,1,1,1,1,10,3*0,                  !205
     +203,5,1,4,4,13,4*0,4,2,3,1,2,1,1,10,3*0,                  !206
     +230,6,0,0,0,0,6*0,1,1,1,1,1,10,3*0,                       !207
     +230,6,0,0,0,0,6*0,1,1,2,4,1,10,7,0,'21'X,                 !208
     +224,6,0,5,0,0,6*0,1,1,2,2,1,10,0,0,1,                     !209
     +224,6,0,5,0,0,6*0,1,1,3,2,4,10,18,'72'X,'41'X,            !210
     +228,6,0,4,0,0,6*0,1,1,2,1,1,10,0,0,1,                     !211
     +220,6,0,0,4,13,2,2,4,3,3,4,1,1,5,5,4,10,18,'72'X,'41'X,   !212
     +220,6,0,0,4,13,2,2,4,3,3,4,1,1,5,5,4,10,18,'42'X,'71'X,   !213
     +228,6,0,4,4,10,3,4,2,2,4,3,1,1,3,1,4,10,9,0,'21'X,        !214
     +220,6,0,0,0,0,6*0,1,1,1,1,4,10,3*0,                       !215
     +224,6,0,5,0,0,6*0,1,1,2,2,4,10,3*0,                       !216
     +228,6,0,4,0,0,6*0,1,1,1,1,1,10,3*0,                       !217
     +220,6,0,0,0,0,6*0,1,1,1,1,1,10,7,0,'30'X,                 !218
     +224,6,0,5,0,0,6*0,1,1,2,1,1,10,7,0,'30'X,                 !219
     +228,6,0,4,4,13,2,2,4,3,3,4,1,1,2,1,1,10,9,0,'30'X,        !220
     +220,6,1,0,0,0,7*0,1,1,1,1,10,3*0,                         !221
     +220,6,1,0,4,13,4*0,3,4,2,1,5,5,2,10,7,0,'20'X,            !222
     +220,6,1,0,0,0,7*0,1,2,1,1,1,7,0,'20'X,                    !223
     +220,6,1,0,4,13,4*0,3,4,2,1,5,4,2,10,3*0,                  !224
     +224,6,1,5,0,0,7*0,1,2,2,1,10,3*0,                         !225
     +224,6,1,5,0,0,7*0,1,2,2,2,10,7,0,'20'X,                   !226
     +224,6,1,5,4,23,15,3,4,14,2,13,12,1,3,1,4,10,3*0,          !227
     +224,6,1,5,4,23,15,3,4,14,2,13,12,1,3,1,1,10,7,0,'20'X,    !228
     +228,6,1,4,0,0,7*0,1,2,1,1,10,3*0,                         !229
     +228,6,1,4,4,10,4*0,4,2,3,1,2,1,2,10,9,0,'20'X,             !230
     +235,1,0,1,0,0,6*0,5,5,1,1,4,0,3*0,                        !231
     +9,1,0,0,0,1,4*0,5,7,7,5,4,1,4,0,3*0,                      !232
     +9,1,0,0,0,6,4*0,5,7,7,5,4,1,4,0,3*0,                       !233
     +235,1,0,1,0,0,6*0,7,5,4,2,4,0,3*0,                        !234
     +235,1,0,1,0,1,4*0,5,7,7,5,4,2,4,0,3*0,                    !235
     +235,1,1,1,0,0,7*0,5,4,2,1,0,3*0,                          !236
     +9,1,1,0,0,1,6*0,7,5,4,1,1,0,3*0,                          !237
     +9,1,1,0,0,6,6*0,7,5,2,4,4,0,3*0,                          !238
     +9,1,1,0,0,4,6*0,7,5,4,2,4,0,3*0,                          !239
     +9,1,1,0,0,7,6*0,7,5,4,2,4,0,3*0,                          !240
     +235,1,1,1,0,1,6*0,7,5,4,2,1,0,3*0,                        !241
     +371,2,1,1,0,0,7*0,1,1,1,2,10,3*0/                         !242
C      TRIG CODES FOR REEKE
       DATA ATRIG /0,0,0,0,                     ! 1=C
     +       0,0,0,1,                     ! 2=D
     +       0,0,0,2,                     ! 3=E
     +       0,0,0,3,                     ! 4=F
     +       0,0,2,0,                     ! 5=E+C
     +       0,0,1,0,                     ! 6=D+C
     +       0,0,3,1,                     ! 7=F+D
     +       0,0,3,2,                     ! 8=F+E
     +       3,2,1,0,                     ! 9=F+E+D+C
     +       -13,8,1,0,                   ! 10=(P+K+D+C)/2
     +       -12,9,1,0,                   ! 11=(O+L+D+C)/2
     +       -6,3,1,0,                    ! 12=(I+F+D+C)/2N
     +       -7,2,1,0,                    ! 13=(J+E+D+C)/2
     +       -5,3,2,0,                    ! 14=(H+F+E+C)/2
     +       -4,3,2,1,                    ! 15=(G+F+E+D)/2
     +       -15,10,3,2,                  ! 16=(R+M+F+E)/2
     +       -14,11,3,2/                  ! 17=(Q+N+F+E//2
       DATA BTRIG /0,0,0,8,                     ! K
     +       0,0,0,9,                     ! L
     +       0,0,0,10,                    ! M
     +       0,0,0,11,                    ! N
     +       0,0,11,8,                    ! N+K
     +       0,0,9,8,                     ! L+K
     +       0,0,10,9,                    ! M+L
     +       0,0,11,10,                   ! N+M
     +       11,10,9,8,                   ! N+M+L+K
     +       -9,8,5,0,                    ! (L+K+H+C//2
     +       -9,8,4,1,                    ! (L+K+G+D)/2
     +       0,0,0,0,                     ! NO EXPRESSION
     +       -14,11,9,8,                  ! (Q+N+L+K)/2
     +       0,0,0,0,                     ! NO EXPRESSION
     +       0,0,0,0,                     ! NO EXPRESSION
     +       -11,10,7,2,                  ! (N+M+J+E)/2
     +       -11,10,6,3/                  ! (N+M+I+F//2
C    CODE WORDS 6 2 BYTE CODES FOR ALL POSSIBLE INDEX PERMUTATIONS
C           1   2   3   4   5   6
C          HKL HLK KHL KLH LHK LKH
C      THE FIRST OF 2 BYTES IS THE 1ST DIM TRIG CODE
C           0 MEANS +COS       2 MEANS -COS
C           1 MEANS +SIN      3 MEANS -SIN
C      THE SECOND IS 2ND AND 3RD DIM BLOCK CODE
C      0 = COS COS   1 = SINCOS   2 = COSSIN   3 = SIN SIN
      DATA WORDS/12*0,                         !   C 1
     +           3,1,3,2,3,1,3,2,2,3,2,3,   !   D  2
     +           3,2,3,1,2,3,2,3,3,1,3,2,   !   E  3
C                                               SUMMATION. 
     +           2,3,2,3,3,2,3,1,3,2,3,1,  !   F   4
     +           2,0,2,0,2,0,2,0,2,0,2,0,      !   G  5
     +           1,1,1,2,1,1,1,2,0,3,0,3,      !    H  6
     +           1,2,1,1,0,3,0,3,1,1,1,2,      !    I  7
     +           0,3,0,3,1,2,1,1,1,2,1,1,      !    J  8
     +           3,3,3,3,3,3,3,3,3,3,3,3, !    K  9
     +           0,2,0,1,0,2,0,1,1,0,1,0,      !    L 10
     +           1,0,1,0,0,1,0,2,0,1,0,2,      !    M  11
     +           0,1,0,2,1,0,1,0,0,2,0,1,      !    N  12
     +           1,3,1,3,1,3,1,3,1,3,1,3,      !    O  13
     +           2,2,2,1,2,2,2,1,3,0,3,0,     !    P  14
     +           3,0,3,0,2,1,2,2,2,1,2,2,     !    Q  15
     +           2,1,2,2,3,0,3,0,2,2,2,1/    !    R  16
      DATA ACODE/64*9/     ! EXPRESSION CODES WILL REPLACE THE 9'S
      DATA BCODE/64*9/     ! AND 9 WILL BE SIGNAL THAT ALL EXPRESSIONS
C                          ! ARE IN. WHEN YOU FIND 9, STOP.
C                             ! FIRST NUMBER IS OVERALL MULTIPLICITY
      DATA MULTAB/2,1,        ! laue=0  (1)
     +            4,2,        ! LAUE=1   (2)
     +            8,3,        ! LAUE=2   (3)
     +            4,4,        ! LAUE=3  (4)
     +            8,3,        ! LAUE=4  (5)
     +            8,3,        ! LAUE=5  (6)
     +            8,3,        ! LAUE=6   (7)   
     +            2,1,          ! LAUE=7 (8)
     +            2,1,          ! LAUE=8  (9)                           
     +            4,4,          ! LAUE=9   (10)
     +            4,4,          ! LAUE=10   (11)
     +            2,1/          ! LAUE=11    (12)
C  LAUETB                                         
      DATA LAUETB/1,2,3,3,4,7,8,5,3,6,4,9/
      DATA NGN/1,1,2,5,2,5,2,5,5/
C   INITIALIZATION COMES HERE
       DATA SPA,SPN/231,232,234,235,236,237,239,241,242,233,238,240/
       DATA SPGA/5,7,8,9,12,13,14,15,65/
       DATA SPGN/7,13,14/
      DATA A,N/'A','N'/
      ASSIGN 10 TO DONE
      SGSV=SPG
C     WRITE(3,92)SPG,SPGL 
C92     FORMAT('  IN RKFINT SPACE GROUP IS ',I3,A)
      IF(SPGL.EQ.A)THEN
      SGSV=SPG
      DO I=1,9
      IF(SPG.EQ.SPGA(I))THEN
       SPG=SPA(I)
      GO TO 305
       ENDIF
       ENDDO
      L=A
302   WRITE(3,303)SPG,SPGL,L
303    FORMAT(1X,'YOUR SPACE GROUP HAS BEEN READ AS ',I3,A1,/,
     + ' ONLY 5,7,8,9,12,13,14,15,65 ARE PROGRAMMED FOR',A1)
         ERR=9
         RETURN
       ELSE IF(SPGL.EQ.N)THEN
      SGSV=SPG                ! SAVE SPECIAL SPACE GROUP NUMBER
       DO I=1,3
       IF(SPG.EQ.SPGN(I))THEN 
        SPG=SPN(I)
        GO TO 305
        ENDIF
        ENDDO
       L=N
       GO TO 302
       ENDIF
      IF(SPG.LT.0)THEN
306    WRITE(3,307)CARD,SPG,SPGL
307    FORMAT(1X,'YOUR INPUT IS ',80A,/,
     + 1X,'YOUR SPACE GROUP HAS BEEN INTERPRETED AS ',I3,A1,/,
     + 1X,' THIS SPACE GROUP IS INVALID OR NOT SUPPLIED')
       RETURN
      ELSE IF(SPG.GT.230)THEN
      GO TO 306
      ENDIF
305   IF(IS1.EQ.1)SPG=CD(1,SPG)+1  ! GET PATTERSON SPACE GROUP    
      SYMGO=0
C     WRITE(3,90)SPG,CD(2,SPG)               
C90     format(' IN RKFINT  CD(2,',I3,')=',I10)
      LAUE=CD(2,SPG)+1   ! LAUE NUMBER GOES FROM 0 TO 11
C     WRITE(3,91)LAUE
C91     FORMAT('  IN RKFINT LAUE= ',I5)
      IF(NOAS.EQ.0)SYMGO=LAUETB(LAUE) ! BRANCH FOR APPROPRIATE ASYM TEST
      CEN=CD(4,SPG)       ! 1,2,3,4,5,6  FOR A,B,C,F,I,R
C     WRITE(3,40)CEN
C40    FORMAT(' IN RKFINT CEN=',I2)
      GPAR=CD(19,SPG)             ! 1ST DIM PARITY FOR GENERATED REFLECT
      ACN=CD(3,SPG)           ! =0 FOR ACENTRIC, =1 FOR CENTRIC
      GD=0
      SCRD=CD(5,SPG)       ! SIGNAL OF GEN PAR DISTURBANCE, SCRDEW
      IF(SCRD.GT.2)THEN
      GD=4                ! GENERATE DISTURBS PARITY
      SCRD=SCRD-4       ! =1 FOR 3FOLD SCRDEW, =2 FOR 6FOLD SCRDEW
      ELSE
      GD=0
      ENDIF
C     WRITE(3,800)GPAR,SCRD,GD,ACN
C800    FORMAT(' IN RKFINT GPAR=',I3,' SCRD=',I3,' GD=',I3,' ACN=',I3)
      IF(IS1.EQ.0)THEN             ! FOURIER
      FZ=1+CD(4,SPG)           ! ACENTRIC OR CENTRIC
C    IF(CUT.EQ.9)ASSIGN NNM TO CUTF   ! CUTOFF FUNCTION
      IF(MODEL.EQ.9)FZ=FZ+2           ! MODEL OPTION ACENTRIC OR CENTRIC
      ELSE IF(IS1.EQ.1)THEN         ! PATTERSON
      FZ=5
      IF(MODEL.EQ.9)FZ=FZ+1
      ENDIF
C      1=NORMAL ACENTRIC FOURIER
C      2=         CENTRIC FOURIER
C      3=PREVIOUSLY ASSIGNED PHASES ACENTRIC
C      4=PREVIOUSLY  ASSIGNED PHASES CENTRIC
C      5=PATTERSON
C      6=PATTERSON MODEL
C      7=DIFFERENCE FOURIER
C      8=DIFFERENCE FOURIER CENTRIC
C    IF SHRPN.EQ.9 SET BAL 3,SHARPN IN APPROPRIATE PLACE
C      NEED TO FINISH PHASE CODE
c      GET OVERALL MULTIPLICITY
C                             ! FIRST NUMBER IS OVERALL MULTIPLICITY
      DATA FROM/5*0.0,-0.25,-0.125,0.0/
      DATA TO/0.16666667,0.5,0.25,0.125,1.0,0.25,0.125,.333333333/
      VSCALE=MULTAB(1,LAUE)  ! TO USE AS AN INDEX MUST GO FROM 1 TO 12
      MGO=MULTAB(2,LAUE)     ! FOR BRANCH TO MULTIPLICITY ROUTINE LATER
C       write(3,98)vscale,mgo
C98     format(' IN RKFINT VSCALE=',F7.3,' MGO FOR BRANCH =',I3)
      GEN=0
      IF(LAUE.GE.4)THEN
      GEN=LAUE-3
      NGEN=NGN(GEN) 
C       WRITE(3,93)SPG,GEN,NGEN
C93     FORMAT(' SPACE GROUP ',I3,'  GEN=',I3,'  NGEN=',I2)
      ENDIF
C          THERE ARE 4 4 BIT CODES IN WORD 21 AND 20 
      MSKF='0F'X   ! MASK USED TO ISOLATE 4 BITS OF CODE
C234567
      LAUE=CD(2,SPG)    ! RESTORE LAUE TO TRUE VALUE FOR THIS SECTION
C          ORDER IS FROM RIGHT TO LEFT
      SSS=IAND(CD(21,SPG),MSKF)       ! CODES FOR SIGNS ON GENERATED A,B
      SGA(1)=SSS               ! THERE ARE 4 CODES IN ONE HALF WORD
C      WRITE(3,801)CD(20,SPG),SPG,SSS
C801   FORMAT('   CD(20,SPG)=',I4,'  SPG=',I4,' SSS=',I4)
      IF(SSS.GE.8)THEN
       SSS=IAND(CD(20,SPG),MSKF)  ! SKIP 2ND 4 BITS
       SGR(1)=SSS                 ! CODE GOES INTO SGR INSTEAD OF SGA
       GO TO DONE
      ELSE                 ! HERE FOR SS<8
       SSS=ISHFT(CD(21,SPG),-4)   ! GET CODE 2
       SGA(2)=SSS
       SSS=IAND(CD(20,SPG),MSKF)  ! GET CODE 3
       IF(LAUE.GT.6)THEN
       SGR(1)=SSS
       SSS=ISHFT(CD(20,SPG),-4)    ! GET CODE 4
       SGR(2)=SSS                 ! LAUE>6 3 AND FOR ARE IN SGR
       ELSE
       SGA(3)=SSS
       SSS=ISHFT(CD(20,SPG),-4)    ! GET CODE 4
       SGA(4)=SSS
       ENDIF
       ENDIF
      LAUE=LAUE+1    ! TO USE AS AN INDEX
10     CONTINUE
C          FILL ACODE AND BCODE
C    TO GET ORIENTATION CODE
C     WRITE(3,9000)RX1,RX2,RX3
C9000  FORMAT('  RX1=',I2,'  RX2=',I2,'  RX3=',I2)
      IF(RX1.EQ.1)THEN
       OR=1
      IF(RX2.EQ.3)OR=OR+1
      ELSE IF(RX1.EQ.2)THEN
      OR=3
      IF(RX2.EQ.3)OR=OR+1
      ELSE IF(RX1.EQ.3)THEN
       OR=5
      IF(RX2.EQ.2)OR=OR+1
      ENDIF
C           OR = 1,2,3,4,5,6
      DEC=-1      ! DECREMENT FOR CENTRIC LOOP
      IF(ACN.EQ.0)DEC=-2      ! DECREMENT FOR ACENTRIC LOOP
      PAR=0                  ! FOR CODE ACCORDING TO PARITY
      DO 12 I=14,7,DEC     ! PICK UP 8 POSIBLE CODES
       PAR=PAR+1         ! 1,2,3,4,5,6,7,8
      SGC=CD(I,SPG)         ! PICK UP EXPRESSION CODE FOR A
C     WRITE(3,901)I,SPG,SGC
C901    FORMAT('  I=',I3,' SPG=',I4,'  SGC=',I4)
      IF(SGC.EQ.0) GO TO 11   ! NO MORE EXPRESSIONS
       j=1         ! J = 1,2,3,4,5,6,7,8
      DO K=4,1,-1          ! 4 CODES
       IC=ATRIG(K,SGC)
      IF(K.NE.4.AND.IC.EQ.0)GO TO 12    ! LEAVE 9'S IN UNUSED CODE
C     WRITE(3,902)K,SGC,ATRIG(K,SGC)
C902    FORMAT('  ATRIG(',I2,',',I2,')= ',I3)
       IF(ATRIG(K,SGC).LT.0)IC=-IC    ! ABS VALUE OF IC
       IC=IC+1           ! FIX AS AN INDEX
       ACODE(J,PAR)=WORDS(1,OR,IC)    ! TRIG CODE
       IF(ATRIG(K,SGC).LT.0)ACODE(J,PAR)=-ACODE(J,PAR)
C     WRITE(3,900)J,PAR,ACODE(J,PAR),OR,IC
      IF(ACN.EQ.0)THEN
      II=I-1               ! INDEX FOR B CODE
      SGCB=CD(II,SPG)    ! SGCB IS NEW 6/27/85
       ICB=BTRIG(K,SGCB)     ! SO THAT SGC IS NOT DISTURBED
C      WRITE(3,903)K,SGCB,BTRIG(K,SGCB)
C903    FORMAT('  BTRIG(',I2,',',I2,')= ',I3)
       IF(BTRIG(K,SGCB).LT.0)ICB=-ICB    ! ABS VALUE OF IC
       ICB=ICB+1           ! FIX AS AN INDEX
       BCODE(J,PAR)=WORDS(1,OR,ICB)    ! TRIG CODE
       IF(BTRIG(K,SGCB).LT.0)THEN   ! MINUS SIGN USED BY FOO AS SIGNAL
       IF(BCODE(J,PAR).EQ.0)BCODE(J,PAR)=10   ! THERE IS NO - ZERO
       BCODE(J,PAR)=-BCODE(J,PAR)     ! SIGNAL TO DIVIDE BY 2
       ENDIF                         ! FOO MUST USE -10 AS  -0
C     WRITE(3,904)J,PAR,BCODE(J,PAR),OR,ICB
C904    FORMAT('  BCODE(',I2,','I2,')=',I4,' OR=',I4,' INDEX ICB=',I4)
      ENDIF
       J=J+1
       ACODE(J,PAR)=WORDS(2,OR,IC)    ! BLOCK CODE
      IF(ACODE(J,PAR).EQ.0)SB1=1
      IF(ACODE(J,PAR).EQ.1)SB2=2
      IF(ACODE(J,PAR).EQ.2)SB3=3
      IF(ACODE(J,PAR).EQ.3)SB4=4
C     WRITE(3,900)J,PAR,ACODE(J,PAR),OR,IC
C900    FORMAT('  ACODE(',I2,','I2,')=',I4,' OR=',I4,' IC=',I4)
      IF(ACN.EQ.0)THEN
       BCODE(J,PAR)=WORDS(2,OR,ICB)    ! BLOCK CODE
      IF(BCODE(J,PAR).EQ.0)SB1=1
      IF(BCODE(J,PAR).EQ.1)SB2=2
      IF(BCODE(J,PAR).EQ.2)SB3=3
      IF(BCODE(J,PAR).EQ.3)SB4=4
C     WRITE(3,904)J,PAR,BCODE(J,PAR),OR,ICB
       ENDIF
       J=J+1
      ENDDO
12      CONTINUE       ! END OF OUTER LOOP
C  ACODE HAS TRIGCODE,BLOCKCODE,TRIG,BLOCK,TRIG,BLOCK,ETC
C  BCODE HAS TRIGCODE,BLOCKCODE,ETC.
11    DO I=1,3
      IF(LB(I).NE.7)THEN          ! INSERT DEFAULT BOUNDS IF EQEDED
      J=14+I                  ! 15 TO 17 IN CODE WORD
      IND=CD(J,SPG)+1         ! GET CORRECT INDEX FOR BOUNDS TABLE
      LOWX(I)=FROM(IND)     ! NEED LOWX AT LEAST
      IF(LB(I).EQ.0)HIGHX(I)=TO(IND)     ! NEED BOTH LOW AND HIGH
      ENDIF
      ENDDO            ! LOOK AT X, Y, AND Z
      PAR=CD(6,SPG)               ! PARITY CODE FOR 1ST DIM
      RETURN
      END
