      SUBROUTINE SWITCH
C  PROGRAM PARAMETER SWITCH - TRANSFORMS COORDS AND ANISOS
      CHARACTER*1 IUCK,II1
      CHARACTER*10 CARD10
      CHARACTER*60 CARD60
      CHARACTER*15 CARD15
      CHARACTER*27 CARD27
      CHARACTER*5 TITLE
      CHARACTER*4 CARD(20),IDENT
      CHARACTER*3 FFL
      CHARACTER*37 C37
      CHARACTER*10 NAMDES
      CHARACTER*17 NFILE,NFILE2
      INTEGER*4 SYS$TRNLOG
      INTEGER*2 ICH,ICELL,IANIS,IUANIS,NOCO,NOAN
      INTEGER*2 IIJ(6)
      CHARACTER*2 NVERS
      DIMENSION SW(3,3),CS(3,3),AS(6,6),COORD(3),ANISO(6),TEMP(6),
     1 CNV(2,6),ALEN(3),ANG(3),AE(6,6)
      COMMON IS1,IS2,IS3,IS4,IS5,IS6,SCF,B2,CARD
      ICELL=0
      ICOOR=0
      ICH=0
      IANIS=0
      IAEQ=0
      IIN=0
      NOCO=0
      NOAN=0
      DECODE(80,101,CARD)NVERS
C  SEEING IF VERSION NUMBER OF NAME.CRD FILE ENTERED
101   FORMAT(17X,A2)
      ICD=SYS$TRNLOG('NAM',NAMLEN,NAMDES,,,)
C  RETRIEVING NAME FROM SYSTEM
      IF(.NOT.ICD)THEN
      WRITE(3,901)
901   FORMAT(' ERROR ON RETURN FROM TRNLOG.')
      RETURN
      ENDIF
      NFILE(1:NAMLEN)=NAMDES
      N=NAMLEN+1
      NFILE(1:NAMLEN)=NAMDES
      N=NAMLEN+1
      NFILE(N:N+4)='.CRD;'
      N=N+5
      NFILE2=NFILE
      IF(NVERS.NE.'  ')NFILE(N:N+1)=NVERS
      READ(1,102)CARD
102   FORMAT(20A4)
      IF(CARD(1).NE.'CELL')GOTO 105
      ICELL=1
      DECODE(80,103,CARD)R,S,T,ALPHA,BETA,GAMMA
103   FORMAT(6X,6F8.4)
      IF(ALPHA.EQ.0.0)ALPHA=90.
      IF(BETA.EQ.0.0)BETA=90.
      IF(GAMMA.EQ.0.0)GAMMA=90.
      WRITE(3,104)R,S,T,ALPHA,BETA,GAMMA
104   FORMAT(' CELL A=',F10.5,' B=',F10.5,' C=',F10.5,' ALPHA=',
     1 F10.5,' BETA=',F10.5,' GAMMA=',F10.5)
      READ(1,102)CARD
105   DECODE(80,106,CARD)(SW(1,J),J=1,3),(SW(2,J),J=1,3),(SW(3,J),J=1,
     1 3),II1,IUCK
      DO J=1,3
        DO I=1,3
        ASW=0.0
        SWT=ABS(SW(I,J))
        DO III=1,9
        IF (SWT.GT.1)THEN
        SWT=SWT-1.0
        ASW=ASW+1.0
        ENDIF
        ENDDO
        IF( SWT.GT.0.299.AND.SWT.LT.0.4)SWT=1.0/3.0
        IF(SWT.GT.0.599.AND.SWT.LT.0.7)SWT=2.0/3.0
        SWT=SWT+ASW
        IF(SW(I,J).LT.0.0)SWT=-SWT
        SW(I,J)=SWT
        ENDDO
        ENDDO
106   FORMAT(9F6.3,1X,2A1)
1006  FORMAT(' TRANSFORMATION MATRIX ',9F8.5,1X,2A1)
      WRITE(3,1006)(SW(1,J),J=1,3),(SW(2,J),J=1,3),(SW(3,J),J=1,3),II1,
     1 IUCK
      IF(IUCK.NE.' ')ICH=1
      IF(II1.NE.' ')IIN=1
      IF(ICELL.EQ.0)GOTO 1079
      COSA=COS(ALPHA/57.2958)
      COSB=COS(BETA/57.2958)  
      COSC=COS(GAMMA/57.2958) 
      DO 1061 I=1,3
      A=R*SW(I,1)
      B=S*SW(I,2)
      C=T*SW(I,3)
      ALEN(I)=SQRT(A*A+B*B+C*C+2*A*B*COSC+2*A*C*COSB+2*B*C*COSA)
1061  CONTINUE
      DO 1062 I=1,3
      J=1
      K=3
      IF(I.EQ.1)J=2
      IF(I.EQ.3)K=2
      A=R*SW(J,1)
      B=S*SW(J,2)
      C=T*SW(J,3)
      D=R*SW(K,1)
      E=S*SW(K,2)
      F=T*SW(K,3)
      ANG(I)=A*D+B*E+C*F+A*E*COSC+A*F*COSB+B*D*COSC+B*F*COSA+C*D*COSB
     1 +C*E*COSA
      ANG(I)=ACOS(ANG(I)/(ALEN(J)*ALEN(K)))*57.2958
1062  CONTINUE
      WRITE(3,1063)
1063  FORMAT('          TRANSFORMED CELL DIMENSIONS:')
      WRITE(3,104)ALEN,ANG
      WRITE(3,1069)
      WRITE(3,1069)
1069  FORMAT(1X)
1097  FORMAT(30X,'OLD',66X,'NEW')
1079  CALL INV3(SW(1,1),SW(2,1),SW(3,1),SW(1,2),SW(2,2),SW(3,2),
     1 SW(1,3),SW(2,3),SW(3,3),CS)
      WRITE(3,1111)(CS(I,1),I=1,3),(CS(I,2),I=1,3),(CS(I,3),I=1,3)
1111  FORMAT(' X''= ',F6.3,' * X + ',F6.3,' * Y + ',F6.3,' * Z',/,
     1' Y''= ',F6.3,' * X + ',F6.3,' * Y + ',F6.3,' * Z',/,
     2' Z''= ',F6.3,' * X + ',F6.3,' * Y + ',F6.3,' * Z')
107   READ(1,102)CARD
      IF(CARD(1).NE.'COOR'.AND.CARD(1).NE.'ANIS')WRITE(3,112)CARD
      IF(CARD(1).EQ.'END ')GOTO 108
      IF(CARD(1).NE.'NO C')GOTO 1073
      WRITE(3,1070)
1070   FORMAT(' COORD CARDS WILL NOT BE TRANSFORMED.')
      NOCO=1
      GOTO 107
1073  IF(CARD(1).NE.'NO A')GOTO 108
      WRITE(3,1071)
1071  FORMAT(' ANISOS WILL NOT BE TRANSFORMED.')
      NOAN=1
      GOTO 107
108   IF(CARD(1).NE.'END ')THEN
      NFIL=1
      ELSE
      NFIL=19    
      OPEN(NAME=NFILE,UNIT=19,TYPE='OLD',FORM='FORMATTED',
     1 BLOCKSIZE=32768)
      READ(19,102)CARD
      ENDIF
      OPEN(NAME=NFILE2,UNIT=20,TYPE='NEW',FORM='FORMATTED',
     1 BLOCKSIZE=32768)
1080  IF(CARD(1).NE.'COOR')GOTO 113
      IF(ICOOR.EQ.0)THEN
        ICOOR=1
        WRITE(3,1069)
        WRITE(3,1069)
        WRITE(3,1097)
      ENDIF
      IF(NOCO.EQ.1)GOTO 120
      DECODE(80,110,CARD)TITLE,IDENT,FFL,X,Y,Z,C37
      DECODE(42,1122,CARD)CARD15,CARD27
110   FORMAT(A5,1X,A4,2X,A3,3F9.6,A37)
      DO 111 I=1,3
111   COORD(I)=CS(1,I)*X+CS(2,I)*Y+CS(3,I)*Z
      ENCODE(80,110,CARD)TITLE,IDENT,FFL,COORD,C37
      WRITE(3,1123)CARD15,CARD27,CARD15,COORD
1122  FORMAT(A15,A27)
1123  FORMAT(12X,A15,A27,25X,A15,3F11.6)
112   FORMAT(1X,20A4)
      GOTO 120
113   IF(CARD(1).NE.'ANIS')GOTO 120
      IF(NOAN.EQ.1)GOTO 120
      DECODE(80,1130,CARD)TITLE,IUCK,IDENT,(TEMP(I),I=1,6)
      DECODE(72,1132,CARD)CARD10,CARD60
1132  FORMAT(A10,A60)
1130  FORMAT(A5,A1,A4,2X,6F10.6)
      IF(IUCK.NE.'U')IUCK='B'
      if(ich.eq.0.and.iuck.eq.'U')ich=1
      IF(IUCK.EQ.'U')THEN
        DIVE=.5
        DIVE2=2.
      ELSE
        DIVE=1.
        DIVE2=1.
      ENDIF
      if(iin.eq.1.and.iuck.eq.'U')dive=dive*.5
      if(iin.ne.1.and.iuck.ne.'U')dive=dive*.5
      if(ich.eq.0)dive2=dive2*2.
      IF(IUCK.EQ.'U'.AND.ICELL.EQ.0)THEN
      WRITE(3,114)
114   FORMAT(' ***** CELL CARD NEEDED TO TRANSFORM U(I,J)S.  THE',
     1' FOLLOWING PARAMETERS ARE NOT TRANSFORMED: *****')
      WRITE(3,112)CARD
      GOTO 120
      ENDIF
      IF(IANIS.EQ.1)GOTO 118
      IANIS=1
      WRITE(3,1069)
      WRITE(3,1069)
      DO 1171 I=1,6
      J=I
      K=I
      IF(I.GT.3)J=1
      IF(I.EQ.6)J=2
      IF(I.GT.3)K=3
      IF(I.EQ.4)K=2
      AS(1,I)=CS(1,J)*CS(1,K)
      AS(2,I)=CS(2,J)*CS(2,K)
      AS(3,I)=CS(3,J)*CS(3,K)
      AS(4,I)=CS(1,J)*CS(2,K)+CS(2,J)*CS(1,K)
      AS(5,I)=CS(1,J)*CS(3,K)+CS(3,J)*CS(1,K)
      AS(6,I)=CS(2,J)*CS(3,K)+CS(3,J)*CS(2,K)
1171  CONTINUE
      IF(IIN.EQ.1)THEN
         IF(IUCK.EQ.'U')THEN
            WRITE(3,1153)
1153  FORMAT(' ANISOS ASSUMED ENTERED IN EQUATION FORM.')
         ELSE
            WRITE(3,1154)
1154  FORMAT(' ANISOS ASSUMED ENTERED IN MATRIX FORM.')
         ENDIF
      ELSE
         IF(IUCK.EQ.'U')THEN
            WRITE(3,1154)
         ELSE
            WRITE(3,1153)
         ENDIF
      ENDIF
      IF(ICH.EQ.1)THEN
      WRITE(3,1175)
1175  FORMAT(' ANISOS WRITTEN IN MATRIX FORM.')
      ELSE
      WRITE(3,1176)
1176  FORMAT(' ANISOS WRITTEN IN EQUATION FORM')
      ENDIF
      IF(IUCK.NE.'U')IUCK=' '
      IF(IUCK.NE.'U')GOTO 118
      DETA=4.0*(1.0-COSA**2-COSB**2-COSC**2+2.0*COSA*COSB*COSC)  
      SHH=(1.0-COSA**2)/(DETA*R**2)
      SKK=(1.0-COSB**2)/(DETA*S**2)
      SLL=(1.0-COSC**2)/(DETA*T**2)
      SKL=(COSB*COSC-COSA)*2.0/(S*T*DETA)
      SHK=(COSA*COSB-COSC)*2.0/(R*S*DETA)
      SHL=(COSA*COSC-COSB)*2.0/(R*T*DETA)
      CNV(1,1)=1./(78.9568*SHH)
      CNV(1,2)=1./(78.9568*SKK)
      CNV(1,3)=1./(78.9568*SLL)
      CNV(1,4)=1./(2.*78.9568*SQRT(SHH*SKK))
      CNV(1,5)=1./(2.*78.9568*SQRT(SHH*SLL))
      CNV(1,6)=1./(2.*78.9568*SQRT(SKK*SLL))
      COSA=COS(ANG(1)/57.2958)
      COSB=COS(ANG(2)/57.2958)  
      COSC=COS(ANG(3)/57.2958) 
      DETA=4.0*(1.0-COSA**2-COSB**2-COSC**2+2.0*COSA*COSB*COSC)  
      SHH=(1.0-COSA**2)/(DETA*ALEN(1)**2)
      SKK=(1.0-COSB**2)/(DETA*ALEN(2)**2)
      SLL=(1.0-COSC**2)/(DETA*ALEN(3)**2)
      SKL=(COSB*COSC-COSA)*2.0/(ALEN(2)*ALEN(3)*DETA)
      SHK=(COSA*COSB-COSC)*2.0/(ALEN(1)*ALEN(2)*DETA)
      SHL=(COSA*COSC-COSB)*2.0/(ALEN(1)*ALEN(3)*DETA)
      CNV(2,1)=1./(78.9568*SHH)
      CNV(2,2)=1./(78.9568*SKK)
      CNV(2,3)=1./(78.9568*SLL)
      CNV(2,4)=1./(2.*78.9568*SQRT(SHH*SKK))
      CNV(2,5)=1./(2.*78.9568*SQRT(SHH*SLL))
      CNV(2,6)=1./(2.*78.9568*SQRT(SKK*SLL))
      IIJ(1)=11
      IIJ(2)=22
      IIJ(3)=33
      IIJ(4)=12
      IIJ(5)=13
      IIJ(6)=23
      DO 1177 I=1,6
      DO 1177 J=1,6
        IF(IUCK.EQ.'U')THEN
          AE(J,I)=AS(J,I)/CNV(1,J)
          IF(J.GT.3)AE(J,I)=AE(J,I)*DIVE
          AE(J,I)=AE(J,I)*CNV(2,I)
          IF(I.GT.3)AE(J,I)=AE(J,I)*DIVE2
        ELSE
          AE(I,J)=AS(I,J)
        ENDIF
1177  CONTINUE
      DO 1774 I=1,6
1774  WRITE(3,1772)IUCK,IIJ(I),(AE(J,I),IUCK,J=1,6)
1772  FORMAT(1X,A1,I2,' = ',F6.3,' * ',A1,'11 + ',F6.3,' * ',A1,'22 + ',
     1F6.3,' * ',A1,'33 + ',F6.3,' * ',A1,'12 + ',F6.3,' * ',A1,'13 + ',
     1 F6.3,' * ',A1,'23')
118   DO 1180 I=1,6
1180  ANISO(I)=0.
      IF(IUCK.EQ.'U')THEN
      DO 117 I=1,6
117   TEMP(I)=TEMP(I)/CNV(1,I)
      ENDIF
      DO 1181 I=4,6
1181  TEMP(I)=TEMP(I)*DIVE
      DO 119 I=1,6
      DO 119 J=1,6
      ANISO(I)=ANISO(I)+AS(J,I)*TEMP(J)
119   CONTINUE
      IF(IUCK.EQ.'U')THEN
      DO 1191 I=1,6
1191  ANISO(I)=ANISO(I)*CNV(2,I)
      ENDIF
      DO 1195 I=4,6
1195  ANISO(I)=ANISO(I)*DIVE2
      IF(IAEQ.EQ.0)THEN
        IAEQ=1
        WRITE(3,1069)
        WRITE(3,1069)
        WRITE(3,1097)
      ENDIF
      ENCODE(80,1130,CARD)TITLE,IUCK,IDENT,ANISO
      WRITE(3,1196)CARD60,CARD10,ANISO
1196  FORMAT(A60,1X,A10,1X,6F10.6)
120   WRITE(20,102)CARD
      IF(CARD(1).NE.'END ')THEN
         READ(NFIL,102)CARD
         GOTO 1080
      ENDIF
      IF(NFIL.EQ.19)CLOSE(UNIT=19,DISP='SAVE')
      CLOSE(UNIT=20,DISP='SAVE')
      RETURN
      END
      SUBROUTINE INV3(AM11,AM12,AM13,AM21,AM22,AM23,AM31,AM32,AM33,
     1AI)
C
C  THIS ROUTINE CALCULATES THE INVERSE MATRIX FOR A 3x3 MATRIX
C
      DIMENSION AI(3,3)
      DOUBLE PRECISION DET
      DO 5 I=1,3
5     CONTINUE
      DET=DETERM3(AM11,AM12,AM13,AM21,AM22,AM23,AM31,AM32,AM33)
      AI(1,1)=DETERM2(AM22,AM23,AM32,AM33)/DET
      AI(1,2)=-(DETERM2(AM21,AM23,AM31,AM33)/DET)
      AI(1,3)=DETERM2(AM21,AM22,AM31,AM32)/DET
      AI(2,1)=-(DETERM2(AM12,AM13,AM32,AM33)/DET)
      AI(2,2)=DETERM2(AM11,AM13,AM31,AM33)/DET
      AI(2,3)=-(DETERM2(AM11,AM12,AM31,AM32)/DET)
      AI(3,1)=DETERM2(AM12,AM13,AM22,AM23)/DET
      AI(3,2)=-(DETERM2(AM11,AM13,AM21,AM23)/DET)
      AI(3,3)=DETERM2(AM11,AM12,AM21,AM22)/DET
      RETURN
      END
      FUNCTION DETERM2(AMM11,AMM12,AMM21,AMM22)
C
C  THIS ROUTINE CALCULATES THE DERIVATIVE OF A 2x2 MATRIX)
C
      DOUBLE PRECISION DETERM2
      DETERM2=AMM11*AMM22-AMM12*AMM21
      RETURN
      END
      FUNCTION DETERM3(AA11,AA12,AA13,AA21,AA22,AA23,AA31,AA32,AA33)
      DOUBLE PRECISION SUB1,SUB2,SUB3,DETERM3
C
C  THIS ROUTINE CALCULATES THE DERIVATIVE OF A 3x3 MATRIX
C
      SUB1=AA11*AA22*AA33-AA11*AA23*AA32
      SUB2=AA21*AA13*AA32-AA21*AA12*AA33
      SUB3=AA31*AA12*AA23-AA31*AA13*AA22
      DETERM3=SUB1+SUB2+SUB3
      RETURN
      END

