C           FILL TABLE WITH C(TH)   AS IN REEKE FOURIER
      SUBROUTINE TBFIL
      REAL*8 WORK FR4,EPS,FR0
      PARAMETER (EPS=6.28319/1024.)
      PARAMETER (FOURTH=0.25)
      PARAMETER (MSK1023=1023)
      COMMON /CSSN/SC,C
      DIMENSION SC(1024),C(1024),
     +          SCTB(2050)
       EQUIVALENCE (SC(1),SCTB(1)),
     +             (C(1),SCTB(1025)),
     +              (FR0,IFR0)
      WORK=EPS*.5
      C(1)=COS(WORK)        ! 1ST ENTRY IS COS(-E/2)
      C(2)=C(1)             ! 2ND ENTRY IS COS(+E/2)
      WORK=WORK+EPS         ! ARGUMENT FOR 3RD ENTRY
C   TRG1      OF REEKE VERSION
      DO I=1,1024
        K=I+2           ! +8
        J=I+1           ! +4
        C(K)=COS(WORK)          ! 3RD ENTRY=COS(3/2 E)
        FR0=(C(K)+C(J)+C(J)+C(I))*FOURTH    ! REEKE COMMENT SAYS
C                                            ! DIVIDE BY 4
        FR4=FR0*EPS          ! SIN(TH+PI/2)*EPS
        C(I)=FR0
        INDX=I+256       ! SIN INDEX TH+PI/2 AT I+256
        INDX=IAND(INDX,MSK1023)
        IF(INDX.EQ.0)INDX=1024
        SC(INDX)=FR4
        WORK=WORK+EPS      ! NEXT ARGUMENT
      ENDDO
      C(1025)=0.0
      C(1026)=0.0
       RETURN
       END
