      SUBROUTINE SPHFT (P,ICODE)
      DIMENSION P(1),ICODE(1)
      SQRT2=SQRT(2.0)
      I=ICODE(1)
      IW=I/1000
       IX=(I-IW*1000)/100
      IY=(I-IW*1000-IX*100)/10
      IZ=I-(IW*1000+IX*100+IY*10)
      IF(IW)2,1,10
   10 IF(IW.GT.2)GO TO 2
      GO TO(2,3),IW
    3 P(2)=0.0
      P(6)=0.0
      P(1)=SQRT2*P(1)
      P(5)=SQRT2*P(5)
    1 IF(IX)12,4,5
    5 IF(IX.GT.1)GO TO 12
      P(4) =0.0
    4 IF(IY)13,6,7
    7 IF(IY.GT.1)GO TO 13
      P(5)=0.0
    6 IF(IZ)14,8,9
    9 IF(IZ.GT.2)GO TO 14
      P(6)=0.0
    8 RETURN
    2 WRITE(3,11 )I
   11 FORMAT(' ERROR ON SPECIAL ANISO RESTRICTION CODE W, WXYZ =',I5)
      STOP
   12 WRITE(3,15)I
   15 FORMAT(' ERROR ON SPECIAL ANISO RESTRICTION CODE X, WXYZ =',I5)
      STOP
   13 WRITE(3,16)I
   16 FORMAT(' ERROR ON SPECIAL ANISO RESTRICTION CODE Y, WXYZ =',I5)
      STOP
   14 WRITE(3,17)I
   17 FORMAT(' ERROR ON SPECIAL ANISO RESTRICTION CODE Z, WXYZ =',I5)
      STOP
      END
      SUBROUTINE ORD
      COMMON /ORDR/IOE(8,8),IA,IB
      COMMON/GLUMP/PI(16),IN,SGN
      IN=IOE(IA,IB)
      IF(IN.EQ.0) GO TO 1
      SGN=1.
      IF(IN.LT.0)SGN=-1.
      IN=IABS(IN)
1      CONTINUE
      RETURN
      END
      SUBROUTINE XYZDER
C     THIS SUBROUTINE CALCULATES X Y AND Z DERIVATIVES FOR
C     TETRAGONAL LEAST SQUARES
      COMMON/COORDD/ PIH,PIK,PIL,X,Y,Z
      COMMON /GLUMP/ PI(16),IN,SGN
      GO TO (1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16),IN
1     EX=SGN*PI(4)
      X=X-PIH*EX
      Y=Y-PIK*EX
      Z=Z-PIL*SGN*PI(3)
      RETURN
2     EX=SGN*PI(3)
      X=X+PIH*EX
      Y=Y+PIK*EX
      Z=Z+PIL*SGN*PI(4)
      RETURN
 3    EX=SGN*PI(2)
      X=X-PIH*EX
      Y=Y-PIK*EX
      Z=Z+PIL*SGN*PI(1)
      RETURN
4     EX=SGN*PI(1)
      X=X+PIH*EX
      Y=Y+PIK*EX
      Z=Z-PIL*SGN*PI(2)
      RETURN
 5     EX=SGN*PI(8)
      X=X+PIK*EX
      Y=Y-PIH*EX
      Z=Z-PIL*SGN*PI(7)
      RETURN
 6    EX=SGN*PI(7)
      X=X-PIK*EX
      Y=Y+PIH*EX
      Z=Z+PIL*SGN*PI(8)
      RETURN
7     EX=SGN*PI(6)
      X=X+PIK*EX
      Y=Y-PIH*EX
      Z=Z+PIL*SGN*PI(5)
      RETURN
8     EX=SGN*PI(5)
      X=X-PIK*EX
      Y=Y+PIH*EX
      Z=Z-PIL*SGN*PI(6)
      RETURN
9     EX=SGN*PI(12)
      X=X-PIH*EX
      Y=Y+PIK*EX
      Z=Z-PIL*SGN*PI(11)
      RETURN
10    EX=SGN*PI(11)
      X=X+PIH*EX
      Y=Y-PIK*EX
      Z=Z+PIL*SGN*PI(12)
      RETURN
11    EX=SGN*PI(10)
      X=X-PIH*EX
      Y=Y+PIK*EX
      Z=Z+PIL*SGN*PI(9)
      RETURN
12    EX=SGN*PI(9)
      X=X+PIH*EX
      Y=Y-PIK*EX
      Z=Z-PIL*SGN*PI(10)
      RETURN
13    EX=SGN*PI(16)
      X=X-PIK*EX
      Y=Y-PIH*EX
      Z=Z-PIL*SGN*PI(15)
      RETURN
14    EX=SGN*PI(15)
      X=X+PIK*EX
      Y=Y+PIH*EX
      Z=Z+PIL*SGN*PI(16)
      RETURN
15    EX=SGN*PI(14)
      X=X-PIK*EX
      Y=Y-PIH*EX
      Z=Z+PIL*SGN*PI(13)
      RETURN
16    EX=SGN*PI(13)
      X=X+PIK*EX
      Y=Y+PIH*EX
      Z=Z-PIL*SGN*PI(14)
      RETURN
      END
      SUBROUTINE BANISO
      COMMON /BANI/H11,H22,H33,H12,H13,H23,A,B,C,D,E,F
      COMMON /GLUMP/PI(16),IN,SGN
C     THIS ROUTINE CALCULATES THE DERIVATIVES FOR ANISOTROPIC MOTION
      GO TO (1,1,1,1,2,2,2,2,3,3,3,3,4,4,4,4),IN
1     AA=H11
      BB=H22
      DD=H12
      GO TO 5
2     AA=H22
      BB=H11
      DD=-H12
      GO TO 5
3      AA=H11
      BB=H22
      DD=-H12
      GO TO 5
4     AA=H22
      BB=H11
      DD=H12
5      CONTINUE
      CC=H33
      GO TO (11,11,12,12,13,13,14,14,15,15,16,16,17,17,18,18),IN
  11  EE=-H13
      FF=-H23
      GO TO 20
12    EE=H13
      FF=H23
      GO TO 20
13    EE=H23
      FF=-H13
      GO TO 20
14    EE=-H23
      FF=H13
      GO TO 20
15    EE=-H13
C15   EE=IH13
      FF=H23
      GO TO 20
16    EE=H13
      FF=-H23
      GO TO 20
17    EE=-H23
      FF=-H13
      GO TO 20
18    EE=H23
      FF=H13
20    CONTINUE
      IA=(IN-(IN/2)*2)+1
      GO TO (21,22),IA
21    IA=IN-1
      GO TO 23
22    IA=IN+1
23    CONTINUE
      AA=AA*SGN
      BB=BB*SGN
      CC=CC*SGN
      DD=DD*SGN
      EE=EE*SGN
      FF=FF*SGN
      A=AA*PI(IN)+A
      B=BB*PI(IN)+B
      C=CC*PI(IN)+C
      D=DD*PI(IN)+D
      E=EE*PI(IA)+E
      F=FF*PI(IA)+F
      RETURN
      END
