      subroutine tlist
c  this program creates 2 texed tables of crystal and intensity
c  collection data from the inf file.
c  added to crym 9/88 by kms
      character*10 table
      character*20 c20
      character*80 card
      character*1 ckoct(8)
      character*17 c17
      character*4 word
      character*50 title
      character*1 ff(3,10)
      integer asig,bsig,csig,alsig,besig,gasig
      character*3 nf(10)
      character*16 itexfil,inffile
      data ckoct/'+','-','h','H','k','K','l','L'/
      common/fname/inffile,namlen
      i=namlen
      itexfil(1:i)=inffile(1:i)
      i=i+1
      itexfil(i:i+4)='I.tex'  ! table i tex file
      inffile(i:i+3)='.inf'
      open(unit=27,name=itexfil,form='formatted',type='new') !i tex file
C     NEW VERSION OF FIND DOES OPEN AND CLOSE OF INF FILE
C      open(unit=28,name=inffile,form='formatted',type='old') !inf file
      itexfil(i:i+5)='iv.tex'  ! table iv tex file
      open(unit=29,name=itexfil,form='formatted',type='new') !iv tex fil
51    format('&')
52    format('\cr')
53    format('\+')
      write(27,100)
      write(29,100)
100   format(' \input user1:[kms]tli',/,'\hsize=6truein')
      write(27,102)
102   format('{\centerline{\bf Table I.  Crystallographic Data for}}')
      write(29,103)
103   format('{\centerline{\bf Table IV.  Crystal and Intensity',
     1' Collection Data for}}')
      word='TITL'
      call find(card,word,i,28)  !find title card
      if(i.eq.1)then ! found
        decode(80,1031,card)title
1031    format(8x,a50)
        write(27,104)title
        write(29,104)title
104     format('{\centerline{\bf ',a50,'}}\bigno')
        write(3,105)title  ! to out file
105     format(' Title: ',a50) 
      else  ! no title card - tell them
        write(3,900)word
      endif
      write(27,107)
      write(29,107)
107   format('\settabs 2 \columns')
      word='FORM'
      assign 115 to igo
      call find(card,word,i,28)  ! is formula there?
      write(27,53)
      write(29,53)
      if(i.eq.1)then  ! found
        decode(80,108,card,err=901)(ff(1,j),ff(2,j),ff(3,j),nf(j),j=1,
     1  10)
108     format(10x,10(a1,a1,a1,a3,1x))
        j=0
        card(1:9)='Formula: '
        jj=10
109     j=j+1
        if(nf(j).eq.'   ')goto 112
        if(nf(j).eq.'  0')goto 112
        k=2
        if(ff(3,j).eq.' ')k=1
        if(ff(2,j).eq.' ')k=0  ! get rid of blanks in form factors
        if(ff(1,j).eq.'H'.and.ff(2,j).eq.'S')k=0  ! make HS - H
        do kk=1,k+1
          if(kk.gt.1)call small(ff(kk,j))
c  call subrout. small to make 2 and 3rd characters of form factors
c  (if any) into little letters
          card(jj:jj)=ff(kk,j)
          jj=jj+1
        enddo
        if(nf(j).ne.'  1')then  ! subscript if more than 1
          card(jj:jj+2)='$_{'
          card(jj+3:jj+5)=nf(j)
          card(jj+6:jj+7)='}$'
          jj=jj+8
        endif
        goto 109
112     write(27,114)card(1:jj-1)
        write(29,114)card(1:jj-1)
        write(3,113)(ff(1,kk),ff(2,kk),ff(3,kk),nf(kk),kk=1,j-1)
113     format(' Formula: ',<j-1>(a1,a1,a1,a3,','))
114     format(a<jj-1>)
      else  ! no formula
        write(3,900)word
      endif
115   write(27,51)
      write(29,51)
      word='WEIG'
      assign 120 to igo
      call find(card,word,i,28)
      if(i.eq.1)then
        decode(80,116,card,err=901)a
116     format(10x,f9.3)
        write(3,117)a
117     format('Formula weight: ',f10.3)
        write(27,117)a
        write(29,117)a
      else  ! no weight
        write(3,900)word
      endif
120   write(27,52)
      write(29,52)
      word='COLO'
      call find(card,word,i,28)
      write(29,53)
      if(i.eq.1)then
        decode(80,121,card)title
121     format(8x,a50)
        do ii=2,50
          call small(title(ii:ii))  ! make color into small letters
        enddo
        write(29,122)title
122     format('Crystal color: ',a50)
        write(3,122)title
      else
        write(3,900)word  ! no color
      endif
      write(29,51)
      word='HABI'
      call find(card,word,i,28)  ! is habit there?
      if(i.eq.1)then  ! yes
        decode(80,1031,card)title
        do ii=2,50
          call small(title(ii:ii))  ! make habit into small letters
        enddo
        write(29,125)title
125     format('Habit: ',a50)
        write(3,125)title
      else  ! not habit found
        write(3,900)word
      endif
      write(29,52)
      word='CRYS'
      assign 1259 to igo
      call find(card,word,i,28)
      if(i.eq.1)then  ! crystal size found
        decode(80,215,card,err=901)a,b,c
215     format(15x,f6.3,3x,f6.3,3x,f6.3)
        write(29,216)a,b,c
216     format('\+Crystal size: $',f6.2,'\times',f6.2,'\times',f6.2,
     1   '$ mm')
        write(3,217)card(1:55)
217     format(1x,a55)
        write(29,52)
      else
        write(3,900)word
      endif
1259  read(1,226)c20   ! space group
226   format(12x,a20)
      word='SPAC'
      assign 2270 to igo
      jsv=0
      call find(card,word,i,28)
      if(i.eq.1)then
        decode(80,2261,card,err=901)jsv
2261    format(14x,i3)
        write(29,2262)c20,jsv
2262    format('\+Space group: ${\rm ',a20,'}$ (\#$',i3,'$)')
2263    format('Space group: ${\rm ',a20,'}$ (\#$',i3,'$)')
        write(29,52)
      else
        write(29,227)c20
227     format('Space group: ${\rm ',a20,'}$')
        write(29,52)
      endif
2270  write(3,228)c20
228   format(' Space group: ',a20)
      word='CELL'
      assign 140 to igo
      call find(card,word,i,28)
      if(i.eq.1)then  ! found cell
        decode(80,126,card,err=901)a,asig,b,bsig,c,csig,al,alsig,be,
     1  besig,ga,gasig
126     format(5x,3(f9.3,1x,i2,1x),3(f8.2,1x,i2,1x))
        write(27,53)
        write(29,53)
        if(asig.ne.0)write(27,127)a,asig
        if(asig.ne.0)write(29,127)a,asig
c   for cell params, only write if sig is nonzero (=0 if nonrefineable)
127     format('$a=',f9.3,'(',i2,')$\AA')
        write(27,51)
        write(29,51)
        if(jsv.ne.0)then  ! space group to 27
          write(27,2263)c20,jsv
        else
          write(27,227)c20
        endif
        if(alsig.ne.0)write(29,128)al,alsig
128     format('$\alpha=',f8.2,'(',i2,')\deg$')
        write(27,52)
        write(29,52)
        write(27,53)
        write(29,53)
        if(bsig.ne.0)write(27,129)b,bsig  ! b
        if(bsig.ne.0)write(29,129)b,bsig
129     format('$b=',f9.3,'(',i2,')$\AA')
        write(27,51)
        write(29,51)
        word='T = '
        assign 1270 to igo
        call find(card,word,ii,28)
        jsv=0
        if(ii.eq.1)then
          Decode(80,173,card,err=901)jsv
173       format(4x,i4)
          write(27,1740)jsv
174       format('\+T $ =',i4,'\deg$K')
1740       format('T $ =',i4,'\deg$K')
          write(3,175)jsv
175       format(' T = ',i4,' degrees K')
        else
          write(3,900)word
        endif
1270    if(besig.ne.0)write(29,130)be,besig
130     format('$\beta=',f8.2,'(',i2,')\deg$')
1300     format('\+$\beta=',f8.2,'(',i2,')\deg$')
        write(27,52)
        write(29,52)
        write(27,53)
        write(29,53)
        if(csig.ne.0)write(27,131)c,csig ! c
        if(csig.ne.0)write(29,131)c,csig
131     format('$c=',f9.3,'(',i2,')$\AA')
        write(27,51)
        write(29,51)
        word='LAMB'  ! lambda to 27
        assign 1310 to igo
        call find(card,word,ii,28)  ! lambda there?
        asv=0.0
        if(ii.eq.1)then  ! yes
          Decode(80,161,card,err=901)asv
161       format(10x,f7.4)
          write(27,162)asv
162       format('$\lambda=',f7.4,'$\AA')
          write(3,163)asv
163       format(' lambda = ',f7.4,' angstroms.')
        else
          write(3,900)word  ! no lambda
        endif
1310    if(gasig.ne.0)write(29,132)ga,gasig
132     format('$\gamma=',f8.2,'(',i2,')\deg$')
        write(27,52)
        write(29,52)
        write(3,133)a,asig,b,bsig,c,csig,al,alsig,be,besig,ga,gasig
133     format(' CELL',3(f9.3,'(',i2,')'),3(f8.2,'(',i2,')'))
      else  ! no cell
        write(3,900)word
      endif
      write(27,53)
      if(alsig.ne.0)write(27,128)al,alsig  ! alpha to 27
      write(27,51)
      assign 134 to igo
      word='DENS'
      call find(card,word,i,28)
      asv2=0.0
      if(i.eq.1)then
        decode(80,1610,card,err=901)asv2
1610    format(11x,f6.3)
        write(27,1621)asv2
1620    format('\+$\rho_{\rm{calc}}=',f6.3,'$ g cm$^{-3}$')
1621    format('$\rho_{\rm{calc}}=',f6.3,'$ g cm$^{-3}$')
        write(3,1630)asv2
1630    format(' p(calc) = ',f6.3,' g cm**-3')
      else
        write(3,900)word
      endif
134   write(27,52)
      if(besig.ne.0)then
        write(27,1300)be,besig  ! beta to 27
        write(27,52)
      endif
      write(27,53)
      if(gasig.ne.0)write(27,132)ga,gasig  ! gamma to 27
      write(27,51)
      word='U = '
      assign 140 to igo
      call find(card,word,i,28)
      al=0.0
      if(i.eq.1)then  ! found mu
        decode(80,221,card,err=901)al,be
221     format(5x,f8.3,21x,f8.3)
        write(3,217)card(1:55)
222   format('\+$\mu=',f8.2,'$ cm$^{-1}\ (\mu$r$_{\rm{max}}=',f8.2,')$')
        write(27,2222)al
2222    format('$\mu=',f8.2,'$ cm$^{-1}$')
        write(27,52)
      else  ! no mu
        write(3,900)word
      endif
140   word='V = '
      assign 150 to igo
      call find(card,word,i,28)  ! volume there?
      write(27,53)
      write(29,53)
      if(i.eq.1)then  ! yes
        decode(80,141,card,err=901)a,j
141     format(5x,f9.1,1x,i2)
        write(27,142)a,j
        write(29,142)a,j
142     format('V $ =',f10.1,'(',i2,')$\AA$^3$')
        write(3,143)a,j
143     format(' Volume = ',f10.1,'(',i2,')')
      else
        write(3,900)word
      endif
150   write(27,51)
      assign 1508 to igo
      word='TRAN'  ! trans coef. range
      at1=0.0
      call find(card,word,i,28)
      if(i.eq.1)then
        decode(80,1502,card,err=901)at1,at2
1502    format(23x,f6.2,4x,f6.2)
        write(27,1503)at1,at2
        write(3,1505)at1,at2
1505    format(' Trans. Coeff. Range = ',f6.2,'-',f6.2)
1503    format('Transmission coeff. $ =',f6.2,'-',f6.2,'$')
      else
        write(3,900)word
      endif
1508  write(27,52)
      write(29,51)
      assign 160 to igo
      word='Z = '
      call find(card,word,i,28)
      jsv2=0
      if(i.eq.1)then  ! found z
        decode(80,151,card,err=901)jsv2
151     format(5x,i2)
        write(29,152)jsv2
152     format('$Z=',i2,'$')
        write(3,153)jsv2
153     format(' Z = ',i2)
      else  ! no z
        write(3,900)word
      endif
160   write(29,52)
      if(asv2.ne.0.0)then
        write(29,1620)asv2  ! density
        write(29,52)
      endif
      if(al.ne.0.0)write(29,222)al,be   ! mu
      write(29,51)
      if(at1.ne.0.0)write(29,1503)at1,at2  ! trans coef
      write(29,52)
      write(27,53)
      if(jsv2.ne.0)write(27,152)jsv2  ! z
      write(27,51)
      write(29,53)
      call find(card,word,i,28) ! cad-4 diffrac
      word='P21 '
      if(i.ne.1)call find(card,word,j,28)  ! p21 diffract
      word='P1BA'
      if(i.ne.1.and.j.ne.1)call find(card,word,k,28)  !p1bar diffract
      if(i.eq.1)then  ! yes, cad4
        write(29,181)
181     format('CAD-4 diffractometer')
        write(3,181)
      endif
      if(j.eq.1)then  ! yes, p21
        write(29,182)
182     format('P$2_1$ diffractometer')
        write(3,183)
183     format('P21 diffractometer')
      endif
      if(k.eq.1)then  ! yes, p1bar
        write(29,184)
184     format('P$\overline 1$ diffractometer')
        write(3,185)
185     format(' P1Bar diffractometer')
      endif
      word='DIFF'
      if(I+J+K.eq.0)write(3,900)word
      write(29,51)
      word='OMEG'
      call find(card,word,i,28)
      if(i.eq.1)then
        if(card(7:7).eq.' ')then  ! Omega scan
          write(29,186)
186       format('$\omega$ scan')
          write(3,187)
187       format(' Omega scan')
        else
          write(29,188)
188       format('$\theta$-$2\theta$ scan')
          write(3,189)
189       format(' Theta-2Theta scan')
        endif
      else
        word='SCAN'
        write(3,900)word
      endif
      write(29,52)
      write(29,53)
      if(asv.ne.0.0)write(29,162)asv  ! lambda
      write(29,51)
      word='GRAP'
      call find(card,word,i,28)  ! graphite monochromator
      if(i.eq.1)then
        write(29,171)
171     format('Graphite monochromator')
        write(3,171)
      else
        word='NO M'
        call find(card,word,j,28)  ! no monochromator card
        if(j.eq.1)then
          write(3,172)
172       format('No Monochromator')
          write(29,172)
        else
          word='MONO'
          write(3,900)word
        endif
      endif
      write(29,52)
      word='CAD-'
      i=0
      j=0
      k=0
      word='2THE'
      assign 200 to igo
      call find(card,word,i,28)
      write(29,53)
      if(i.eq.1)then
        decode(80,191,card,err=901)j,k  ! 2theta range
191     format(14x,i4,2x,i4)
        write(29,192)j,k
192     format('$2\theta$ range: $',i4,'\deg$--$',i4,'\deg$')
        write(3,193)j,k
193     format(' 2Theta range: ',i4,'-',i4)
      else
        write(3,900)word
      endif
200   write(29,51)
      word='OCTA'
      call find(card,word,i,28)  ! octants collected card
      if(i.eq.1)then
        decode(80,201,card)c17
201     format(20x,a17)
        write(3,217)card(1:55)
        kk=0
        jj=1
        do j=1,17
          do k=1,8
            if(c17(j:j).eq.ckoct(K))goto(203,204,205,205,205,205,205,
     1      205),k
            goto 210
203         kk=kk+1  ! + sign
            goto 210
204         kk=kk+2  ! - sign
            goto 210
205         if(kk.eq.1)card(jj:jj+3)='  + '
            if(kk.eq.2)card(jj:jj+3)=' -  '
            if(kk.eq.3)card(jj:jj+3)='\pm '
            if(kk.gt.0)jj=jj+4
            if(k.eq.3.or.k.eq.4)card(jj:jj)='h'
            if(k.eq.5.or.k.eq.6)card(jj:jj)='k'
            if(k.eq.7.or.k.eq.8)card(jj:jj)='l'
            jj=jj+1
            if(k.lt.7)then
              card(jj:jj)=','
              jj=jj+1
            endif
            kk=0
210       enddo
        enddo
        write(29,211)card(1:jj-1)
211     format('Octants collected: $',a<jj-1>,'$')
      else
        write(3,900)word
      endif
      write(29,52)
      if(jsv.ne.0)then
        write(29,174)jsv  ! temp
        write(29,52)
      endif
      word='REFL'
      assign 235 to igo
      call find(card,word,i,28)  ! number of reflections 
      if(i.eq.1)then  ! found
        decode(80,231,card,err=901)j
231     format(23x,i5)
        write(3,217)card(1:55)
        write(29,232)j
232     format('\+Number of reflections measured: $',i5,'$')
        write(29,52)
      else  ! no no. of reflects
        write(3,900)word
      endif
235   word='INDE'
      assign 240 to igo
      jir=0
      call find(card,word,i,28)  ! number of independent reflections
      if(i.eq.1)then  ! found
        decode(80,236,card,err=901)jir
236     format(26x,i6)
        write(3,217)card(1:55)
        write(29,237)jir
237     format('\+Number of independent reflections: $',i6,'$')
        write(29,52)
      else
        write(3,900)word
      endif
240   assign 245 to igo
      word='NUMB'
      call find(card,word,i,28)  ! number with f^2>0
      jg0=0
      if(i.eq.1)then  ! found
        decode(80,241,card,err=901)jg0
241     format(27x,i6)
        write(3,217)card(1:55)
        write(29,242)jg0
242     format('\+Number with F$_{\rm{o}}^2>0$: $',i6,'$')
        write(29,52)
      else
        write(3,900)word
      endif
245   word='NO. '
      assign 255 to igo
      call find(card,word,i,28) ! number with f^2>n sigma
      jg3=0
      if(i.eq.1)then
        decode(80,246,card,err=901)char1,a,jg3
246     format(19x,a1,f6.3,8x,i6)
        write(3,217)card(1:55)
        k=a
        if(k.eq.a)then  ! sigma an integer
          write(29,247)char1,k,jg3
247    format('\+Number with F$_{\rm{o}}^2',a1,i3,'\sigma($F$_{\rm{o}}',
     1   '^2)$: $',i6,'$')
          write(29,52)
        else
          write(29,248)char1,a,jg3
248    format('\+Number with F$_o^2',a1,f5.1,'\sigma($F$_o^2): ',i6,'$')
         write(29,52)
        endif
      else
        write(3,900)word
      endif
255   if(jir.ne.0)then  ! no. of ind. refs = no. in refinement
        write(29,2551)jir
2551    format('\+Number of reflections used in refinement: $',i6,'$')
        write(29,52)
      endif
250   assign 2552 to igo
      word='GOF '
      call find(card,word,i,28)
      if(i.eq.1)then  ! gof for merging data - found
        decode(80,251,card,err=901)a
251     format(23x,e10.3)
        write(3,217)card(1:55)
        write(29,252)a
252     format('\+Goodness of fit for merging data: $',f6.2,'$')
        write(29,52)
      else
        write(3,900)word
      endif
2552  word='R-IN'
      assign 260 to igo
      call find(card,word,i,28)  ! r-index
      if(i.eq.1)then  ! found
        decode(80,256,card,err=901)a
256     format(10x,f10.4)
        write(3,217)card(1:55)
        write(27,2571)a
2571    format('R(F$_{\rm{o}}$) $ =',f10.4,'$') 
        write(29,257)a,jg0
257     format('\+Final R-index: $',f10.4,'$ for $',i6,'$ reflections',
     1  ' with F$_{\rm{o}}^2>0$')
        write(29,52)
      else
        write(3,900)word
      endif
      write(27,52)
260   if(i.eq.1)then  ! look for special r if final r found
        word='R FO'
        assign 265 to igo
        call find(card,word,ii,28)
        if(ii.eq.1)then
          decode(80,261,card,err=901)char1,a,b
261       format(16x,a1,f6.3,8x,f10.4)
          write(3,217)card(1:55)
          k=a
          if(k.eq.a)then
            write(29,262)b,jg3,char1,k
262         format('\+Final R-index: $',f10.4,'$ for $',i6,'$ ',
     1     'reflections with F$^2_{\rm{o}}',a1,i4,'\sigma($F$^2',
     2      '_{\rm{o}})$')
            write(29,52)
          else
            write(29,263)b,jg3,char1,a
263         format('\+Final R-index: $',f10.4,'$ for $',i6,'$ ',
     1      'reflections with F$^2_{\rm{o}}',a1,f6.1,'\sigma($F$',
     2      '^2_\rm{o}))$')
            write(29,52)
          endif
        else
          write(3,900)word
        endif
265     continue
      endif
      word='FINA'
      assign 270 to igo
      call find(card,word,i,28)  ! final gof
      if(i.eq.1)then  ! found
        decode(80,266,card,err=901)a,j,jj
266     format(12x,e10.3,5x,i6,11x,i5)
        write(3,217)card(1:55)
        write(29,267)a,jj,j
267     format('\+Final goodness of fit: $',f8.2,'$ for $',i5,
     1  '$ parameters and $',i6,'$ reflections')
        write(29,52)
        write(27,268)a
268     format('\+ &GOF $ =',f8.2,'$')
        write(27,52)
      else
        write(3,900)word
      endif
270   write(27,271)
      write(29,271)
271   format('\par \vfill \end')
      return
900   format(' No ',a4,' card (1st 4 letters) in INF file.')
901   write(3,902)word
902   format(' Error on ',a4,' card (1st 4 letters) in INF file.')
      goto igo
      end
      subroutine small(char1)
      character*1 char1
      character*1 big(26),little(26)
      data big/'A','B','C','D','E','F','G','H','I','J','K','L','M',
     1'N','O','P','Q','R','S','T','U','V','W','X','Y','Z'/
      data little/'a','b','c','d','e','f','g','h','i','j','k','l',
     1'm','n','o','p','q','r','s','t','u','v','w','x','y','z'/
      do i=1,26
        if(char1.eq.big(i))goto 10
      enddo
      return
10    char1=little(i)
      return
      end
